package TagSample;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# タグ見本モジュール
# TagSample.pm ver1.0.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-10-04
######################################################################
# 実行
sub run ($) {
    my $this  = shift;
    my $myurl = $this->my_url;
    $myurl =~ s/start\.cgi$/counter.cgi/;

    unless ( ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }

    #JavaScript;
    my $js = <<SCRIPT;
cmonos.tool.tagSample = function (this_form) {
	var color_setting = cmonos.element.form(this_form).fieldname('color').list();
	var sample_image = document.getElementById('sample_image');

	// location
	var location_path = cmonos.form.item(this_form).fieldname('location').currentField.value;
	location_path = ((window.encodeURIComponent) ? encodeURIComponent(location_path) : escape(location_path));
	if (location_path != "" && (!cmonos.form.item(this_form).fieldname('nocount').currentField.checked)) {
		cmonos.form.item(this_form).fieldname('tagsample').currentField.value='<a href="$myurl?location='+location_path+'">リンク</a>';
		sample_image.src='$env::spacer';
		return;

	// invisible
	} else if (color_setting[3].checked) {
		cmonos.form.item(this_form).fieldname('tagsample').currentField.value='<img src="$myurl?invisible=true" />';
		sample_image.src='$env::spacer';
		return;

	}

	var num_gif = '';
	var num_image = new Array();
	num_image = cmonos.element.form(this_form).fieldname('image').list()

	for (var i=0; i<num_image.length; i++) {
		if (num_image[i].checked) {
			num_gif=num_image[i].value;
			break;
		}
	}

	var tag_sample='<img src="$myurl?image='+num_gif;
	var image_src='./counter.cgi?demo=true&image='+num_gif;

	// slide
	if (color_setting[1].checked) {
		var slide_color=cmonos.form.item(this_form).fieldname('slide_color').currentField.value;
		var slide_revcolor=cmonos.form.item(this_form).fieldname('slide_rev').currentField.value;
		tag_sample+='&amp;'+'color='+slide_color+'&amp;'+'revcolor='+slide_revcolor;
		image_src+='&'+'color='+slide_color+'&'+'revcolor='+slide_revcolor;

		// abs
		if (cmonos.form.item(this_form).fieldname('slide_abs').currentField.checked) {
			tag_sample+='&amp;'+'abs=true';
			image_src+='&'+'abs=true';
		}
		
	// change
	} else if (color_setting[2].checked) {
		var change_color=cmonos.form.item(this_form).fieldname('change_color').currentField.value;
		tag_sample+='&amp;'+'colortable='+change_color;
		image_src+='&'+'colortable='+change_color;
	}

	// nocount
	if (cmonos.form.item(this_form).fieldname('nocount').currentField.checked) {
		if (location_path != '') {
			tag_sample+='&amp;'+'location='+location_path;
		}
		tag_sample+='&amp;'+'nocount=true';
	}

	// this month
	if (cmonos.form.item(this_form).fieldname('no_total').currentField.checked) {
		tag_sample+='&amp;'+'total=false';
		image_src+='&'+'total=false';
	}

	// this month
	if (cmonos.form.item(this_form).fieldname('no_thismonth').currentField.checked) {
		tag_sample+='&amp;'+'thismonth=false';
		image_src+='&'+'thismonth=false';
	}

	// today
	if (cmonos.form.item(this_form).fieldname('no_today').currentField.checked) {
		tag_sample+='&amp;'+'today=false';
		image_src+='&'+'today=false';
	}

	// yesterday
	if (cmonos.form.item(this_form).fieldname('no_yesterday').currentField.checked) {
		tag_sample+='&amp;'+'yesterday=false';
		image_src+='&'+'yesterday=false';
	}

	// word
	if (cmonos.form.item(this_form).fieldname('no_word').currentField.checked) {
		tag_sample+='&amp;'+'word=false';
		image_src+='&'+'word=false';
	}

	// start
	if (cmonos.form.item(this_form).fieldname('no_start').currentField.checked) {
		tag_sample+='&amp;'+'start=false';
		image_src+='&'+'start=false';
	}

	// end
	if (cmonos.form.item(this_form).fieldname('no_end').currentField.checked) {
		tag_sample+='&amp;'+'end=false';
		image_src+='&'+'end=false';
	}

	// kirilevel
	if (cmonos.form.item(this_form).fieldname('kirilevel').currentField.selectedIndex == 3) {
		tag_sample+='&amp;'+'kirilevel=no';
		image_src+='&'+'kirilevel=no';
	} else if (cmonos.form.item(this_form).fieldname('kirilevel').currentField.selectedIndex >= 1) {
		tag_sample+='&amp;'+'kirilevel='+cmonos.form.item(this_form).fieldname('kirilevel').currentField.selectedIndex;
		image_src+='&'+'kirilevel='+cmonos.form.item(this_form).fieldname('kirilevel').currentField.selectedIndex;
	}

	// kiriban
	if (cmonos.form.item(this_form).fieldname('kiriban').currentField.value) {
		tag_sample+='&amp;'+'kiriban='+cmonos.form.item(this_form).fieldname('kiriban').currentField.value;
		image_src+='&'+'kiriban='+cmonos.form.item(this_form).fieldname('kiriban').currentField.value;
	}

	var image_id = (new Date()).getTime();
	tag_sample+='&amp;id='+image_id+'" />';
	image_src+='&id='+image_id;

	cmonos.form.item(this_form).fieldname('tagsample').currentField.value=tag_sample.replace(/#/g,'%23').replace(/\\+/g,'%2b').replace(/\\-/g,'%2d').replace(/,/g,'%2c');
	sample_image.src=image_src.replace(/#/g,'%23').replace(/\\+/g,'%2b').replace(/\\-/g,'%2d').replace(/,/g,'%2c');
}
cmonos.form.showColorTableSample = function () {
	if (this.currentField && this.currentField.value == '') {
		document.getElementById('colortable-sample').innerHTML = '';
		this.currentField.style.backgroundColor = '';
	} else {
		var sample = '';
		var fixed_color = '';
		var color = this.currentField.value.split(/\\s*,\\s*/);
		for (var i=0; i<color.length; i++) {
			if (color[i] != null && color[i].search(/^#[0-9a-fA-F]{6}\$/) != -1) {
				sample += '<div style="float: left; width: 15px; height: 15px; background-color: ' + color[i] + ';" title="' + color[i] + '"></div>';
				fixed_color += ((fixed_color != '') ? ',' : '') + color[i];
			} else if (color[i] != null && color[i].search(/^random\$/i) != -1) {
				fixed_color += ((fixed_color != '') ? ',' : '') + color[i];
			}
		}
		if (sample != '') sample += '<div style="clear:left"></div>';
		document.getElementById('colortable-sample').innerHTML = sample;
		this.currentField.value = fixed_color;
	}
}
SCRIPT
    $this->set_javascript($js);
    undef $js;

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print
        '<h1 title="条件を設定し「タグ見本書き出し」ボタンを押してください。">タグ見本</h1>';

    print '<form name="input" action="#" onsubmit="return false">';
    print '<fieldset><legend>アクセスカウンター設定</legend>';

    print '<fieldset><legend>画像選択</legend>';
    print $cgi::Deco->number_menu( 'image', 'number', '', 0, 1 );
    print '</fieldset>';

    print '<fieldset><legend>配色表変更</legend>';
    print '<table class="field-table"><tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label><input type="radio" name="color" value="" checked="checked" />同一配色表</label></td>';
    print '<td class="field">素材画像の配色に準じます。</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label><input type="radio" name="color" value="slide" />配色表調整</label></td>';
    print
        '<td class="field"><label><input type="text" name="slide_color" id="slide_color" size="8" maxlength="8" value="RANDOM" onclick="cmonos.tool.colorPalette.open(\'slide_color\',\'dom\')" onfocus="cmonos.form.item(this.form).fieldname(\'color\',1).select()" onchange="cmonos.validate.field(this).asColor(this.value,\'rgb\')" />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'slide_color\')" ondblclick="cmonos.tool.colorPalette.open(\'slide_color\',\'window\')" onclick="cmonos.form.item(document.input).fieldname(\'color\',1).select()"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'slide_color\')" ondblclick="cmonos.tool.colorSlider.open(\'slide_color\',\'window\')" onclick="cmonos.form.item(document.input).fieldname(\'color\',1).select()"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a>';
    print '（基準色）</label>';
    print
        ' <label><input type="text" name="slide_rev" id="slide_rev" size="8" maxlength="8" value="-#666666" onclick="cmonos.tool.colorPalette.open(\'slide_rev\',\'dom\')" onfocus="cmonos.form.item(this.form).fieldname(\'color\',1).select()" onchange="cmonos.validate.field(this).asColor(this.value,\'rgb\')" style="background-color: #666666" />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'slide_rev\')" ondblclick="cmonos.tool.colorPalette.open(\'slide_rev\',\'window\')" onclick="cmonos.form.item(document.input).fieldname(\'color\',1).select()"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'slide_rev\')" ondblclick="cmonos.tool.colorSlider.open(\'slide_rev\',\'window\')" onclick="cmonos.form.item(document.input).fieldname(\'color\',1).select()"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a>';
    print '（補正色）</label>';
    print
        ' <label><input type="checkbox" name="slide_abs" value="1" onclick="cmonos.form.item(this.form).fieldname(\'color\',1).select()" /> 値をループする</label>';
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label><input type="radio" name="color" value="change" />配色表置換</label></td>';
    print
        '<td class="field"><label><input type="text" name="change_color" id="change_color" size="46" onclick="cmonos.tool.colorPalette.open(\'change_color+\',\'dom\')" onfocus="cmonos.form.item(this.form).fieldname(\'color\',2).select();cmonos.form.field(this).showColorTableSample();" onchange="cmonos.form.field(this).showColorTableSample()" />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'change_color+\')" ondblclick="cmonos.tool.colorPalette.open(\'change_color+\',\'window\')" onclick="cmonos.form.item(document.input).fieldname(\'color\',2).select()"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print '（配色表）</label>';
    print '<div id="colortable-sample"></div>';
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    print '<fieldset><legend>カウンターを隠す</legend>';
    print
        '<label><input type="radio" name="color" id="color" value="invisible" /> カウンターを表示しません（アクセスはカウントされます）</label>';
    print '</fieldset>';

    print '<fieldset><legend>カウンターをモニターする</legend>';
    print
        '<label><input type="checkbox" name="nocount" id="nocount" value="1" /> アクセス数のみ表示しアクセスをカウントしません</label>';
    print '</fieldset>';

    print '<fieldset><legend>リンク先をカウントする</legend>';
    print
        '<label for="location">リンク先URL</label><input type="text" name="location" id="location" size="40" title="URLを記入してください。" />';
    print '</fieldset>';

    print '<fieldset><legend>表示の制御</legend>';
    print '<ol class="checkbox">';
    print
        '<li><label><input type="checkbox" name="no_total" id="no_total" value="1" /> 総アクセス数を表示しない</label></li>';
    print
        '<li><label><input type="checkbox" name="no_thismonth" value="1" /> 今月のアクセス数を表示しない</label></li>';
    print
        '<li><label><input type="checkbox" name="no_today" value="1" /> 今日のアクセス数を表示しない</label></li>';
    print
        '<li><label><input type="checkbox" name="no_yesterday" value="1" /> 昨日のアクセス数を表示しない</label></li>';
    print
        '<li><label><input type="checkbox" name="no_word" value="1" /> 数字のみ表示する</label></li>';
    print
        '<li><label><input type="checkbox" name="no_start" value="1" /> 開始画像を表示しない</label></li>';
    print
        '<li><label><input type="checkbox" name="no_end" value="1" /> 終了画像を表示しない</label></li>';
    print '</ol>';
    print '</fieldset>';

    print '<fieldset><legend>キリバン設定</legend>';
    print '<table class="field-table"><tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="kirilevel">キリバンレベル</label></td>';
    print '<td class="field">';
    print '<select id="kirilevel" name="kirilevel">';
    print '<option></option>';
    print
        '<option value="1">最高桁が 1 で、他は 0（1000 など）</option>';
    print '<option value="2">最高桁以外 0（3000 など）</option>';
    print '<option value="no">キリバン非検知</option>';
    print '</select>';
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="kiriban">オリジナルキリバン</label></td>';
    print
        '<td class="field"><input type="text" name="kiriban" id="kiriban" size="60" title="複数のキリバンを指定するときはカンマで区切ります。" />';
    print
        '<div class="hints">複数のキリバンを指定するときはカンマで区切ります。</div>';
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    print
        '<div class="submit"><input type="button" value="タグ見本書きだし" onclick="cmonos.tool.tagSample(this.form)" /></div>';
    print '</fieldset>';

    print
        '<fieldset id="tagsample-box"><legend><label for="tagsample">タグ見本</label></legend>';
    print
        '<textarea name="tagsample" id="tagsample" rows="4" cols="80" wrap="off"></textarea><br />';
    print
        '<div class="hints">id は、キャッシュを読み込ませないためにつけます。ファイルごとにユニークな id を割り当てて下さい。</div>';
    print '</fieldset>';

    print
        '<fieldset id="counter-image"><legend>画像見本（ここに画像が表示されます）</legend>';
    print
        '<img id="sample_image" name="sample_image" alt="カウンター画像見本" src="'
        . $env::spacer . '" />';
    print '</fieldset>';

    print '</form>';

    #ページフッタ
    $this->print_page_footer('tools');
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 'c210', 'TagSample' );

    #メニュー登録
    $setting::jump_menu{'c210'} = 'タグ見本';

}

1;
