package StatSetting;
require CMONOS::Accestat::Accestat;
@ISA = qw(Accestat);
use strict;
use utf8;
######################################################################
# アクセス解析環境設定モジュール
# StatSetting.pm ver1.1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2018-05-18
######################################################################
# 解析条件
sub stat_target ($) {
    my $this = shift;
    my ( $form, $target );
    $target
        = ( defined $setting::stat{'target'}{'path'}
            && !ref $setting::stat{'target'}{'path'} )
        ? $setting::stat{'target'}{'path'}
        : '';
    $target =~ s/\\(?!\\)//g
        if !defined $setting::stat{'target'}{'regexp'}
        || !$setting::stat{'target'}{'regexp'};
    $form = '<textarea name="setting:target_path" wrap="off"';
    $form
        .= ' title="パスの一部に設定された文字列を含むファイルのみ解析します。" cols="60" rows="4">';
    $form .= $this->escape($target);
    $form .= '</textarea>';

    $form .= '<div class="external-field">';
    $form .= '<select name="setting:target_regexp">';
    $form .= '<option value="">部分一致</option>';
    $form .= '<option value="2"'
        . (
        (          $setting::stat{'target'}{'regexp'}
                && $setting::stat{'target'}{'regexp'} == 2
        ) ? ' selected="selected"' : ''
        ) . '>完全一致</option>';
    $form .= '<option value="1"'
        . (
        (          $setting::stat{'target'}{'regexp'}
                && $setting::stat{'target'}{'regexp'} == 1
        ) ? ' selected="selected"' : ''
        ) . '>正規表現使用</option>';
    $form .= '</select></div>';

    if (@setting::recenttarget) {
        $form .= '<div class="external-field">';
        $form
            .= '<select onchange="cmonos.form.item(this.form).fieldname(\'setting:target_path\').textByMenu(this)">';
        $form
            .= '<option value="">↓最近使った絞り込み条件</option>';
        $form .= '<option value=""></option>';
        foreach my $t (@setting::recenttarget) {
            my $t2 = $t;
            $form
                .= '<option value="'
                . $this->escape_except_html_entity($t) . '">'
                . $this->jfold( $t2, 72, 'r', 1 )
                . '</option>';
        }
        $form .= '<option value=""></option>';
        $form .= '<option value="">条件をリセット</option>';
        $form .= '</select></div>';
        $form
            .= '<div class="external-field"><label><input type="checkbox" name="targetreset" value="1"> 最近使った絞り込み条件のメニューを消去</label></div>';
    }

    return $form;
}

sub stat_span ($) {
    my $this = shift;
    return '解析可能なログファイルが存在しません。'
        if defined $this->{'noLog'} && $this->{'noLog'};

    my ($form);
    $form = $this->span_setting('start');
    $form .= ' 〜 ';
    $form .= $this->span_setting( 'end', $this->{'noEnd'} );
    $form .= <<'FORM';
<script type="text/javascript" language="JavaScript">
<!--
cmonos.tool.dateControl = function (this_form,d) {
	d = eval(d);
	var y = 0;
	var m = 0;
	var md = 0;
	var dateObj;
	if (isNaN(d)) {
		d = 0;
	} else {
		dateObj = new Date();
		dateObj.setTime(86400000*d  + (new Date()).getTime());
		y = dateObj.getFullYear();
		m = dateObj.getMonth() + 1;
		md = dateObj.getDate();
	}

	for (var i=0; i < this_form.elements.length; i++) {
		if (this_form.elements[i].name.match(/^span:/)) {

			//年
			if (this_form.elements[i].name.match(/:year$/)) {
				for (var o=0; o < this_form.elements[i].options.length; o++) {
					if (d == 1) {
						if (this_form.elements[i].options[o].value == '') {
							this_form.elements[i].options[o].selected = true;
						} else {
							this_form.elements[i].options[o].selected = false;
						}
					} else {
						if (eval(this_form.elements[i].options[o].value) == y) {
							this_form.elements[i].options[o].selected = true;
						} else {
							this_form.elements[i].options[o].selected = false;
						}
					}
				}

			//月
			} else if (this_form.elements[i].name.match(/:mon$/)) {
				for (var o=0; o < this_form.elements[i].options.length; o++) {
					if (d == 1) {
						if (this_form.elements[i].options[o].value == '') {
							this_form.elements[i].options[o].selected = true;
						} else {
							this_form.elements[i].options[o].selected = false;
						}
					} else {
						if (eval(this_form.elements[i].options[o].value) == m) {
							this_form.elements[i].options[o].selected = true;
						} else {
							this_form.elements[i].options[o].selected = false;
						}
					}
				}

			//日
			} else if (this_form.elements[i].name.match(/:mday$/)) {
				for (var o=0; o < this_form.elements[i].options.length; o++) {
					if (d == 1) {
						if (this_form.elements[i].options[o].value == '') {
							this_form.elements[i].options[o].selected = true;
						} else {
							this_form.elements[i].options[o].selected = false;
						}
					} else {
						if (eval(this_form.elements[i].options[o].value) == md) {
							this_form.elements[i].options[o].selected = true;
						} else {
							this_form.elements[i].options[o].selected = false;
						}
					}
				}
			}
		}
	}
}
//-->
</script>
<select onchange="cmonos.tool.dateControl(this.form,this.options[this.selectedIndex].value);">
<option value="1">↓</option>
<option value="1">全範囲</option>
FORM
    $form .= "\x0A" . '<option value="0">きょう</option>'
        if defined $setting::general{'realtime'}
        && $setting::general{'realtime'};
    $form .= <<'FORM';
<option value="-1">きのう</option>
<option value="-2">おとつい</option>
<option value="-3">3日前</option>
<option value="-4">4日前</option>
<option value="-5">5日前</option>
<option value="-6">6日前</option>
<option value="-7">7日前</option>
</select>
FORM

    $form
        .= '<div class="note"><span class="datatitle">設定可能期間</span>';
    $form .= $this->date(
        $this->{'access_log_start'},
        $setting::page{'stat'}{'datelimit'},
        $setting::page{'stat'}{'datetype'}
        )
        . '〜'
        . $this->date(
        $this->{'access_log_end'},
        $setting::page{'stat'}{'datelimit'},
        $setting::page{'stat'}{'datetype'}
        );
    $form .= '</div>';
    return $form;
}

sub span_setting ($$;$) {
    my ( $this, $key, $option ) = @_;
    my ( $form, $year, $mon, $mday );
    ( $year, $mon, $mday )
        = (    !$option
            && defined $setting::stat{'span'}{$key}
            && $setting::stat{'span'}{$key}
            =~ /^([0-9]{4})([0-9]{2})([0-9]{2})/ )
        ? ( $1, $2, $3 )
        : ( 0, 0, 0 );
    $form = '<label><select name="span:' . $key . ':year">';
    $form .= '<option value=""></option>';
    foreach ( $this->{'year_start'} .. $this->{'year_end'} ) {
        $form
            .= '<option value="'
            . $_ . '"'
            . ( ( $_ == $year ) ? ' selected="selected"' : '' ) . '>'
            . $_
            . '</option>';
    }
    $form .= '</select>年</label> ';
    $form .= '<label><select name="span:' . $key . ':mon">';
    $form .= '<option value=""></option>';
    foreach ( 1 .. 12 ) {
        $form
            .= '<option value="'
            . $_ . '"'
            . ( ( $_ == $mon ) ? ' selected="selected"' : '' ) . '>'
            . $_
            . '</option>';
    }
    $form .= '</select>月</label> ';
    $form .= '<label><select name="span:' . $key . ':mday">';
    $form .= '<option value=""></option>';
    foreach ( 1 .. 31 ) {
        $form
            .= '<option value="'
            . $_ . '"'
            . ( ( $_ == $mday ) ? ' selected="selected"' : '' ) . '>'
            . $_
            . '</option>';
    }
    $form .= '</select>日</label>';
    return $form;
}

sub stat_title ($) {
    my $this = shift;
    return 'アクセス解析環境設定';
}

sub print_sub_stat_env ($) {
    my $this = shift;

    #アクセスログスペース
    my $limit
        = ( defined $setting::general{'limit'} )
        ? $setting::general{'limit'}
        : undef;
    $limit = $default::limit if !$limit;
    $limit = 100000          if !$limit;
    print $this->{'infoTable'}->tr;
    print $this->{'infoTable'}->th('ログスペース');
    print $this->{'infoTable'}
        ->td( '最大 ' . $this->digit($limit) . ' byte' );
    print $this->{'infoTable'}->_tr;

    #アクセスログスペース使用率
    print $this->{'infoTable'}->tr;
    print $this->{'infoTable'}->th('ログスペース使用率');
    print $this->{'infoTable'}->td( $this->{'BarGraph'}
            ->bargraph( $this->{'access_log_size'}, $limit, '%' ) );
    print $this->{'infoTable'}->_tr;

    #ダウンロード方式
    print $this->{'infoTable'}->tr;
    print $this->{'infoTable'}->th('表示方法');
    print $this->{'infoTable'}->td(
        '<select name="setting:download" onchange="cmonos.form.item(this.form).field(this).appendDownloadPathByValue({\'csv\':\'stat.csv\',\'tsv\':\'stat.tsv\'})">'
            . '<option value="">このウィンドウに表示する</option>'
            . '<option value="csv"'
            . (
            (   defined $setting::stat{'download'}
                    && $setting::stat{'download'} eq 'csv'
            ) ? ' selected="selected"' : ''
            )
            . '>csv形式（カンマ区切りテキスト）でダウンロードする</option>'
            . '<option value="tsv"'
            . (
            (   defined $setting::stat{'download'}
                    && $setting::stat{'download'} eq 'tsv'
            ) ? ' selected="selected"' : ''
            )
            . '>タブ区切りテキストでダウンロードする</option>'
            . '</select>'
            . '<div class="note">ダウンロードする場合、ファイル名は start.cgi になります。<br />ダウンロード後、ファイル名を data.csv などに変更してください。</div>'
    );
    print $this->{'infoTable'}->_tr;

    #全てをリセット
    print $this->{'infoTable'}->tr;
    print $this->{'infoTable'}->th('リセット');
    print $this->{'infoTable'}->td(
        '<input type="button" value="全ての解析条件をリセット" onclick="cmonos.form.item(this.form).resetAll()" />'
    );
    print $this->{'infoTable'}->_tr;

}

######################################################################
# ログ解析（何もしない）
sub access_stat ($) {
    my $this = shift;
    return;
}

######################################################################
# 本文
sub print_report ($) {
    my $this = shift;

    print '<dl id="stat-settings">';

    # アクセスの概要
    $this->print_stat_tools( 'general', 'GeneralReport',
        'アクセスの概要',
        '曜日別・時間別にアクセス数を集計します。' );

    # アクセス数の推移
    $this->print_stat_tools(
        'access',
        'AccessReport',
        'アクセス数の推移',
        '日/月単位でアクセス数の推移を表示します。',
        1, 0,
        ' <select name="setting:access_reverse">'
            . '<option value="">過去→現在</option>'
            . '<option value="1"'
            . (
            ( $setting::stat{'access'}{'reverse'} )
            ? ' selected="selected"'
            : ''
            )
            . '>現在→過去</option>'
            . '</select>'
            . ' <select name="setting:access_mon">'
            . '<option value="">日単位</option>'
            . '<option value="1"'
            . (
            ( $setting::stat{'access'}{'mon'} ) ? ' selected="selected"' : ''
            )
            . '>月単位</option>'
            . '</select>'
    );

    # ファイル別アクセス数ランキング
    $this->print_stat_tools(
        'request',
        'RequestReport',
        'ファイル別アクセス数ランキング',
        'ファイル別にアクセス数を集計します。',
        1, 1,
        ' <select name="setting:request_option">'
            . '<option value="">CGIの条件部分を含める</option>'
            . '<option value="1"'
            . (
            ( $setting::stat{'request'}{'option'} ) ? ' selected="selected"'
            : ''
            )
            . '>CGIの条件部分を無視する</option>'
            . '</select>'
            . ' <select name="setting:request_option2">'
            . '<option value="">アンカーを含める</option>'
            . '<option value="1"'
            . (
            ( $setting::stat{'request'}{'option2'} ) ? ' selected="selected"'
            : ''
            )
            . '>アンカーを無視する</option>'
            . '</select>'
            . ' <select name="setting:request_option3">'
            . '<option value="">同一IPからの再アクセスをカウントする</option>'
            . '<option value="1"'
            . (
            ( $setting::stat{'request'}{'option3'} ) ? ' selected="selected"'
            : ''
            )
            . '>同一IPからの再アクセスをカウントしない</option>'
            . '</select> '
    );

    # クリック率
    $this->print_stat_tools(
        'click',
        'ClickRatioReport',
        'ページ別クリック率ランキング',
        'ページ別にクリック率を割り出します。',
        1, 1,
        '</dd><dd><label for="setting:click_target" class="datatitle">対象ページ</label><input type="text" name="setting:click_target" size="30" value="'
            . $this->escape( $setting::stat{'click'}{'target'} ) . '" />'
            . ' <select name="setting:click_option">'
            . '<option value="">URL単位で集計する</option>'
            . '<option value="noquery"'
            . (
            (   defined $setting::stat{'click'}{'option'}
                    && $setting::stat{'click'}{'option'} eq 'noquery'
            ) ? ' selected="selected"' : ''
            )
            . '>CGIの条件部分を無視する</option>'
            . '<option value="noanchor"'
            . (
            (   defined $setting::stat{'click'}{'option'}
                    && $setting::stat{'click'}{'option'} eq 'noanchor'
            ) ? ' selected="selected"' : ''
            )
            . '>アンカーを無視する</option>'
            . '<option value="ignore"'
            . (
            (   defined $setting::stat{'click'}{'option'}
                    && $setting::stat{'click'}{'option'} eq 'ignore'
            ) ? ' selected="selected"' : ''
            )
            . '>CGIの条件部分とアンカーを無視する</option>'
            . '</select>'
    );

    # リンク元ランキング
    $this->print_stat_tools(
        'referer',
        'RefererReport',
        'リンク元ランキング',
        'リンク元を集計します。',
        1, 1,
        ' <select name="setting:referer_option">'
            . '<option value="">URL単位で集計する</option>'
            . '<option value="ignore"'
            . (
            (   defined $setting::stat{'referer'}{'option'}
                    && $setting::stat{'referer'}{'option'} eq 'ignore'
            ) ? ' selected="selected"' : ''
            )
            . '>CGIの条件部分とアンカーを無視する</option>'
            . '<option value="time_ignore"'
            . (
            (   defined $setting::stat{'referer'}{'option'}
                    && $setting::stat{'referer'}{'option'} eq 'time_ignore'
            ) ? ' selected="selected"' : ''
            )
            . '>CGIの条件部分とアンカーを無視する（新着順）</option>'
            . '<option value="nocgi"'
            . (
            (   defined $setting::stat{'referer'}{'option'}
                    && $setting::stat{'referer'}{'option'} eq 'nocgi'
            ) ? ' selected="selected"' : ''
            )
            . '>CGIからのリンクとアンカーを無視する</option>'
            . '<option value="time_nocgi"'
            . (
            (   defined $setting::stat{'referer'}{'option'}
                    && $setting::stat{'referer'}{'option'} eq 'time_nocgi'
            ) ? ' selected="selected"' : ''
            )
            . '>CGIからのリンクとアンカーを無視する（新着順）</option>'
            . '<option value="site"'
            . (
            (   defined $setting::stat{'referer'}{'option'}
                    && $setting::stat{'referer'}{'option'} eq 'site'
            ) ? ' selected="selected"' : ''
            )
            . '>サイト単位で集計する</option>'
            . '</select>'
            . '<select name="setting:referer_landing">'
            . '<option value="">再訪問時のリンク元もカウントする</option>'
            . '<option value="1"'
            . (
            ( $setting::stat{'referer'}{'landing'} )
            ? ' selected="selected"'
            : ''
            )
            . '>到着時のリンク元のみカウントする</option>'
            . '</select>'
    );

    # アクセス元ランキング
    my $client_target
        = ( defined $setting::stat{'client'}{'target'} )
        ? $setting::stat{'client'}{'target'}
        : '';
    $client_target =~ s/\\(?!\\)//g
        if !defined $setting::stat{'client'}{'regexp'}
        || !$setting::stat{'client'}{'regexp'};
    my $client_referer
        = ( defined $setting::stat{'client'}{'referer'} )
        ? $setting::stat{'client'}{'referer'}
        : '';
    $client_referer =~ s/\\(?!\\)//g
        if !defined $setting::stat{'client'}{'regexp'}
        || !$setting::stat{'client'}{'regexp'};
    my $client_url
        = ( defined $setting::stat{'client'}{'url'} )
        ? $setting::stat{'client'}{'url'}
        : '';
    $client_url =~ s/\\(?!\\)//g
        if !defined $setting::stat{'client'}{'regexp'}
        || !$setting::stat{'client'}{'regexp'};
    $this->print_stat_tools(
        'client', 'ClientReport', 'アクセス元ランキング',
        'アクセス元を集計します。', 1, 1,

        '</dd><dd><label for="setting:client_target" class="datatitle">ホスト名検索</label>'
            . '<input type="text" name="setting:client_target" size="30" value="'
            . $this->escape($client_target) . '" />'
            . '<select name="setting:client_regexp">'
            . '<option value="">部分一致</option>'
            . '<option value="2"'
            . (
            (          $setting::stat{'client'}{'regexp'}
                    && $setting::stat{'client'}{'regexp'} == 2
            ) ? ' selected="selected"' : ''
            )
            . '>完全一致</option>'
            . '<option value="1"'
            . (
            (          $setting::stat{'client'}{'regexp'}
                    && $setting::stat{'client'}{'regexp'} == 1
            ) ? ' selected="selected"' : ''
            )
            . '>正規表現使用</option>'
            . '</select>'
            . '<select name="setting:client_option">'
            . '<option value="">ホスト名で集計する</option>'
            . '<option value="1"'
            . (
            ( $setting::stat{'client'}{'option'} )
            ? ' selected="selected"'
            : ''
            )
            . '>ドメイン名で集計する</option>'
            . '</select>'

            . '</dd><dd><label for="setting:client_referer" class="datatitle">リンク元検索</label>'
            . '<input type="text" name="setting:client_referer" size="30" value="'
            . $this->escape($client_referer) . '" />'
            . '<select name="setting:client_refererRegexp">'
            . '<option value="">部分一致</option>'
            . '<option value="2"'
            . (
            (          $setting::stat{'client'}{'refererRegexp'}
                    && $setting::stat{'client'}{'refererRegexp'} == 2
            ) ? ' selected="selected"' : ''
            )
            . '>完全一致</option>'
            . '<option value="1"'
            . (
            (          $setting::stat{'client'}{'refererRegexp'}
                    && $setting::stat{'client'}{'refererRegexp'} == 1
            ) ? ' selected="selected"' : ''
            )
            . '>正規表現使用</option>'
            . '</select>'
            . '<select name="setting:client_refererLanding">'
            . '<option value="">再訪問時のリンク元を含む</option>'
            . '<option value="1"'
            . (
            ( $setting::stat{'client'}{'refererLanding'} )
            ? ' selected="selected"'
            : ''
            )
            . '>到着時のリンク元のみ</option>'
            . '</select>'

            . '</dd><dd><label for="setting:client_url" class="datatitle">アクセスURL検索</label>'
            . '<input type="text" name="setting:client_url" size="30" value="'
            . $this->escape($client_url) . '" />'
            . '<select name="setting:client_urlRegexp">'
            . '<option value="">部分一致</option>'
            . '<option value="2"'
            . (
            (          $setting::stat{'client'}{'urlRegexp'}
                    && $setting::stat{'client'}{'urlRegexp'} == 2
            ) ? ' selected="selected"' : ''
            )
            . '>完全一致</option>'
            . '<option value="1"'
            . (
            (          $setting::stat{'client'}{'urlRegexp'}
                    && $setting::stat{'client'}{'urlRegexp'} == 1
            ) ? ' selected="selected"' : ''
            )
            . '>正規表現使用</option>'
            . '</select>'
    );

    # 検索キーワードランキング
    $this->print_stat_tools(
        'keyword',
        'KeywordReport',
        '検索キーワードランキング',
        '検索キーワードを集計します。',
        1, 1,
        ' <select name="setting:keyword_option">'
            . '<option value="">単語ごとに集計する</option>'
            . '<option value="1"'
            . (
            ( $setting::stat{'keyword'}{'option'} )
            ? ' selected="selected"'
            : ''
            )
            . '>検索条件で集計する</option>'
            . '</select>'
    );

    # 訪問者の足跡再現
    $this->print_stat_tools(
        'tracer',
        'TracerReport',
        '訪問者の足跡再現',
        '特定IPの足跡を再現します。',
        1,
        0,
        '</dd><dd><label for="setting:tracer_target" class="datatitle">対象IP</label><input type="text" name="setting:tracer_target" size="50" value="'
            . $this->escape( $setting::stat{'tracer'}{'target'} ) . '" />'
    );

    # 訪問者の閲覧環境
    $this->print_stat_tools( 'agent', 'AgentReport',
        '訪問者の閲覧環境',
        '訪問者の閲覧環境を解析します。' );

    # 訪問者の言語環境
    $this->print_stat_tools( 'language', 'LanguageReport',
        '訪問者の言語環境',
        '訪問者の言語環境を解析します。' );

    # 訪問者のモニター環境
    $this->print_stat_tools(
        'monitor', 'MonitorReport',
        '訪問者のモニター環境',
        '訪問者のモニター環境を解析します。'
    );

    # メンテナンスツール
    if ( $this->is_secure('tools') ) {
        print '<dt>'
            . $this->submit_button( $env::image_dir . '/stat/tools.gif',
            20, 20, '管理モード', '', 'm', 'Tools', 'k', '0000' )
            . ' 管理モード</dt><dd>表示やアクセスログに関する設定を行います。</dd>';
    }

    print '</dl>';
    return;
}

sub print_stat_tools ($$$$;$$$$) {
    my ( $this, $key, $module, $name, $msg, $u, $sort, $form ) = @_;
    print '<dt>'
        . $this->submit_button( $env::image_dir . '/stat/' . $key . '.gif',
        20, 20, $name, '', 'm', $module, 'k', $key );
    print ' ' . $name . '</dt>';
    print '<dd>' . $msg . '</dd>' if defined $msg && $msg;
    print '<dd><label for="setting:'
        . $key
        . '_u" class="datatitle">表示件数</label><input type="text" name="setting:'
        . $key
        . '_u" size="3" value="'
        . $this->escape( $setting::stat{$key}{'u'} ) . '" />'
        if defined $u && $u;
    if ( defined $sort && $sort ) {
        print ' <select name="setting:' . $key . '_sort">';
        print '<option value="descend"'
            . (
            (   defined $setting::stat{$key}{'sort'}
                    && $setting::stat{$key}{'sort'} eq 'descend'
            ) ? ' selected="selected"' : ''
            ) . '>降順</option>';
        print '<option value="ascend"'
            . (
            (   defined $setting::stat{$key}{'sort'}
                    && $setting::stat{$key}{'sort'} eq 'ascend'
            ) ? ' selected="selected"' : ''
            ) . '>昇順</option>';
        print '</select>';
    }
    print $form if defined $form;
    print '</dd>'
        if ( defined $u && $u )
        || ( defined $sort && $sort )
        || ( defined $form && $form );
}

######################################################################
# クラス登録
#sub import {
BEGIN {

    # csvダウンロード対象外
    $setting::download = 'no';

    #デフォルトキー
    $main::k = 'setting' if !defined $main::k || !$main::k;

    #クラス登録
    Common::class_register( 'setting', 'StatSetting' );

}

1;

