package BbList;
require CMONOS::Baobab::BbTrunk;
@ISA = qw(BbTrunk);
use strict;
use utf8;
######################################################################
# バオバブ記事リスト表示モジュール
# BbList.pm ver1.0.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-08-13
######################################################################
# オブジェクト作成
sub new ($) {
    my $pkg  = shift;
    my $this = {};
    bless $this, $pkg;
    return $this;
}

sub is_list ($) {
    my $this = shift;
    return 1;
}

######################################################################
# 必要なフィールドのIDを返す
sub required_fields ($) {
    my $this = shift;
    $setting::page{$setting::key}{'listLimit'} = 30
        if $setting::page{$setting::key}{'listLimit'} <= 0;

    # 表示フィールド取得
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$_};
        next
            unless ref $field::obj{$id}
            && !$field::obj{$id}->{'Hidden'}
            && $field::obj{$id}->{'cellWidth'}
            && $field::obj{$id}->usual_format_enabled
            && ( $field::obj{$id}->{'Open'} || $this->is_secure('secret') );
        next if grep( $_ eq $id, @{ $this->{'required_fields'} } );
        push( @{ $this->{'required_fields'} }, $id );
        $this->{'tableWidth'} += $field::obj{$id}->{'cellWidth'};
        $this->{'cellWidth'} .= ',' if defined $this->{'cellWidth'};
        $this->{'cellWidth'}  .= $field::obj{$id}->{'cellWidth'};
        $this->{'cellAlign'}  .= ',' if defined $this->{'cellAlign'};
        $this->{'cellAlign'}  .= $field::obj{$id}->{'cellAlign'};
        $this->{'cellValign'} .= ',' if defined $this->{'cellValign'};
        $this->{'cellValign'} .= $field::obj{$id}->{'cellValign'};
        $field::obj{$id}->{'field_style_disabled'} = 2;
        $field::obj{$id}->{'field_tag_enabled'}    = 'no';
    }

    return @{ $this->{'required_fields'} };
}

######################################################################
#記事カウント
sub list_count ($$$$$$$) {
    my ( $this, $output, $database, $list, $p, $t, $n ) = @_;
    my ( $page, $e );
    $p = 0 if !defined $p || !$p;
    $this->{'count'} = $page = 0;
    foreach my $no (@$list) {
        if ( $t && !$output && !$e ) {
            $page++
                if $this->{'count'}
                && $setting::page{$setting::key}{'listLimit'}
                && $this->{'count'}
                % $setting::page{$setting::key}{'listLimit'} == 0;
            $e = 1 if $no eq $t;
        }
        $this->{'count'}++;
    }
    return ( !$output && $t ) ? $page : $p;
}

######################################################################
#記事ヘッダ
sub print_list_header ($$$$) {
    my ( $this, $handle, $output, $p ) = @_;

    #前後ページへのリンク
    $this->print_page_jump_form( $handle, $output, $p,
        $setting::page{$setting::key}{'listLimit'},
        $this->{'count'}, '', 1 );

    #テーブルフレーム
    print $handle $this->frame_start(
        $setting::page{$setting::key}{'listFrame'},
        '', '', 'baobab-table-frame', '', $output );

    #テーブル
    $this->{'Table'} = Table->new;
    if ( ref $table::obj{ $setting::page{$setting::key}{'listTable'} } ) {
        %{ $this->{'Table'} }
            = %{ $table::obj{ $setting::page{$setting::key}{'listTable'} } };
    }
    elsif (
        defined $setting::table{ $setting::page{$setting::key}{'listTable'} }
        {'setting'}
        && $setting::table{ $setting::page{$setting::key}{'listTable'} }
        {'setting'} )
    {
        $this->{'Table'}->set(
            $setting::table{ $setting::page{$setting::key}{'listTable'} }
                {'setting'} );
        $this->{'Table'}->{'name'}
            = $setting::table{ $setting::page{$setting::key}{'listTable'} }
            {'name'};
    }

    $this->{'Table'}->set(
        'tableid'    => 'baobab-article-list',
        'tablewidth' => $this->{'tableWidth'},
        'width'      => $this->{'cellWidth'},
        'align0'     => $this->{'cellAlign'},
        'alignH'     => 'center',
        'valign0'    => $this->{'cellValign'},
        'valignH'    => 'middle'
    );
    $this->{'cellspace'} = 0;
    $this->{'cellspace'} += $this->{'Table'}->{'cellpadding'} * 2
        if $this->{'Table'}->{'cellpadding'}
        && $this->{'Table'}->{'cellpadding'} !~ /[^0-9]/
        && $this->{'Table'}->{'cellpadding'} > 0;
    $this->{'cellspace'} += $this->{'Table'}->{'cellspacing'} * 2
        if $this->{'Table'}->{'cellspacing'}
        && $this->{'Table'}->{'cellspacing'} !~ /[^0-9]/
        && $this->{'Table'}->{'cellspacing'} > 0;
    $this->{'cellspace'} += $this->{'Table'}->{'border'}
        if $this->{'Table'}->{'border'}
        && $this->{'Table'}->{'border'} !~ /[^0-9]/
        && $this->{'Table'}->{'border'} > 0;

    #テーブル開始
    print $handle $this->{'Table'}->table;

    #フィールド名行
    print $handle $this->{'Table'}->tr;
    my ( $sort_enabled, $url, $s, $w );
    $sort_enabled = 0;
    if ( $output || !$setting::general{'postMethod'} ) {
        my @form;
        if ( defined $output && $output ) {
            push( @form, @setting::form0, 'v' );
        }
        else {
            push( @form, @setting::form, 'v', 't' );
        }
        @form = grep( $_ ne 'w' && $_ ne 's', @form );
        $url = $cgi::path . $this->set_query( 'url', \@form );
        $s
            = ( !$output && defined $main::s && $main::s ne '' ) ? $main::s
            : ( $field::for{'sort'} ) ? $field::for{'sort'}
            :                           'thread_mtime';
        $w
            = ( !$output && defined $main::w && $main::w ne '' ) ? $main::w
            : ($field::SORTORDER) ? $field::SORTORDER
            :                       'descend';
        $sort_enabled = 1;
    }
    foreach my $id ( @{ $this->{'required_fields'} } ) {
        next
            if !defined $id
            || !ref $field::obj{$id}
            || !$field::obj{$id}->usual_format_enabled;
        my $name = $field::obj{$id}->name;
        if (   $sort_enabled
            && $field::obj{$id}->sort_enabled
            && $field::obj{$id}->{'sortEnabled'} )
        {
            my $sorted = (
                $s eq $id
                    || ( ref $field::obj{$id}
                    && $field::obj{$id}->{'timetype'}
                    && $field::obj{$id}->{'timetype'} eq $s )
            ) ? 1 : 0;
            $name
                = '<a href="'
                . $url
                . $this->amp_escape(
                $this->add_query(
                    'url',
                    {   's' => $id,
                        'w' => (
                              ($sorted)
                            ? ( $w eq 'descend' )
                                    ? 'ascend'
                                    : 'descend'
                            : $w
                        )
                    }
                )
                )
                . '" title="この項目で'
                . ( ($sorted)
                ? ( $w eq 'descend' )
                        ? '昇順▲'
                        : '降順▼'
                : ( $w eq 'descend' ) ? '降順▼'
                :                       '昇順▲' )
                . 'にソートする">'
                . $name . '</a>'
                . ( ($sorted)
                ? ( $w eq 'descend' )
                        ? ' <span class="sort-mark">▼</span>'
                        : ' <span class="sort-mark">▲</span>'
                : '' );
            print $handle $this->{'Table'}
                ->th( $name, ( ($sorted) ? { 'class' => 'sorted' } : {} ) );
        }
        else {
            print $handle $this->{'Table'}->th($name);
        }
    }
    print $handle $this->{'Table'}->_tr;
}

######################################################################
#記事リスト
sub print_articles ($$$$$$) {
    my ( $this, $handle, $output, $database, $list, $p ) = @_;
    my ( $n, $count, $from, $to, $new, $query );
    $count = 0;
    $p     = 0 if !$p;
    $from  = $p * $setting::page{$setting::key}{'listLimit'};
    $to    = $from + $setting::page{$setting::key}{'listLimit'};
    $new   = ($output) ? 1 : 0;
    $query = $this->amp_escape(
        $this->set_query(
            'url',
            (     ($output)
                ? ($default::subdivided)
                        ? ['c']
                        : []
                : \@setting::form1
            )
        )
    );
    $query .= ($query) ? '&amp;' : '?';

    foreach $n (@$list) {
        next if $count < $from;
        last if $count >= $to;

        print $handle $this->{'Table'}->tr;
        my ($id);
        foreach $id ( @{ $this->{'required_fields'} } ) {
            $field::obj{$id}->{'maxwidth'} = $field::obj{$id}->{'cellWidth'}
                - ( $this->{'cellspace'} * 2 );
            if ( $id eq $field::for{'title'} ) {
                my $href
                    = '<a href="'
                    . $cgi::path
                    . $query . 'n='
                    . $n
                    . (
                    (          $setting::page{$setting::key}{'listLink'}
                            && $setting::page{$setting::key}{'listLink'} eq
                            'listarticle'
                    )
                    ? '&amp;v=listarticle'
                    : '&amp;t=' . $n . '&amp;v=listthread'
                    )
                    . '" name="n'
                    . $n
                    . '" id="n'
                    . $n . '">';
                if ($this->decode_utf8(
                        $database->{'tree'}->{ $this->encode_utf8($n) }
                    ) =~ /^d/
                    )
                {
                    print $handle $this->{'Table'}->td(
                        $href
                            . (
                            ( $setting::page{'deletedMsg'} )
                            ? $setting::page{'deletedMsg'}
                            : '<em>この記事は削除されました</em>'
                            )
                            . '</a>'
                    );
                }
                else {
                    my ( $db, $title );
                    $db = $field::obj{$id}->db;
                    $title
                        = $this->decode_utf8(
                        $database->{$db}->{ $this->encode_utf8($n) } )
                        if defined $db && $db;
                    if ( defined $title && $title ne '' ) {
                        print $handle $this->{'Table'}->td(
                            $href
                                . $field::obj{$id}->usual_format( $title,
                                $default::file . '/' . $n,
                                $main::c, $n, $database, $new )
                                . $this->new_item_icon( $database, $n, 1 )
                                . '</a>'
                        );
                    }
                    else {
                        print $handle $this->{'Table'}->td(
                            $href
                                . (
                                ( $setting::page{'defaultTitle'} )
                                ? $setting::page{'defaultTitle'}
                                : '(無題)'
                                )
                                . '</a>'
                        );
                    }
                }
            }
            else {
                my $db = $field::obj{$id}->db;
                print $handle $this->{'Table'}->td(
                    $field::obj{$id}->usual_format(
                        (   ($db)
                            ? $this->decode_utf8(
                                $database->{$db}->{ $this->encode_utf8($n) }
                                )
                            : ''
                        ),
                        $default::file . '/' . $n,
                        $main::c, $n,
                        $database,
                        $new
                    )
                );
            }
        }
        print $handle $this->{'Table'}->_tr;
    }
    continue {
        $count++;
    }
}

######################################################################
#記事フッタ
sub print_list_footer ($$$$) {
    my ( $this, $handle, $output, $p ) = @_;

    #テーブル終了
    print $handle $this->{'Table'}->_table;

    #テーブルフレーム終了
    print $handle $this->frame_end(
        $setting::page{$setting::key}{'listFrame'},
        '', '', 'baobab-table-frame', 1 );

    #前後ページへのリンク
    $this->print_page_jump_form( $handle, $output, $p,
        $setting::page{$setting::key}{'listLimit'},
        $this->{'count'}, '2', 1 );
}

1;
