package BbSearch;
require CMONOS::Baobab::Viewer;
@ISA = qw(Viewer);
use strict;
use utf8;
######################################################################
# バオバブ記事検索フォーム表示モジュール
# BbSearch.pm ver1.0.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-12-08
######################################################################
# オブジェクト作成
sub new ($) {
    my $pkg  = shift;
    my $this = {};
    bless $this, $pkg;
    return $this;
}

sub is_list ($) {
    my $this = shift;
    return 0;
}

######################################################################
# ページセッティング
sub css ($) {
    my $this = shift;
    return '';
}

######################################################################
# 必要なフィールドのIDを返す
sub required_fields ($) {
    my $this = shift;
    return;
}

######################################################################
#記事カウント
sub list_count ($$$$$$$) {
    my ( $this, $output, $db, $list, $p, $t, $n ) = @_;
    return $p;
}

######################################################################
#記事ヘッダ
sub print_list_header ($$$$) {
    my ( $this, $handle, $output, $p ) = @_;
    if ( defined $setting::page{$setting::key}{'searchFrameTitle'}
        && $setting::page{$setting::key}{'searchFrameTitle'} )
    {

        #検索フレーム
        print $handle $this->frame_start(
            $setting::page{$setting::key}{'searchFrame'},
            $setting::page{$setting::key}{'searchFrameWidth'},
            'box',
            'baobab-search-frame',
            '<h2>記事検索</h2>',
            $output
        );

    }
    else {

        #検索フレーム
        print $handle $this->frame_start(
            $setting::page{$setting::key}{'searchFrame'},
            $setting::page{$setting::key}{'searchFrameWidth'},
            'box',
            'baobab-search-frame',
            '',
            $output
        );
        print '<h2>記事検索</h2>';
    }
}

######################################################################
#記事リスト
sub print_articles ($$$$$$) {
    my ( $this, $handle, $output, $db, $list, $p ) = @_;

    #フォーム
    print $handle $this->form_start(
        'key'      => 'browse',
        'name'     => 'input',
        'required' => \@setting::form0
    );

    print $handle '<table class="field-table"><tbody>';

    my $search_count = 0;
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$_} }
            && ( $field::obj{ $field::ORDER{$_} }->{'Open'}
            || $this->is_secure('secret') )
            && $field::obj{ $field::ORDER{$_} }->{'searchEnabled'}
            && $field::obj{ $field::ORDER{$_} }->search_form_enabled;
        print $handle $field::obj{ $field::ORDER{$_} }->search_form;
        $search_count++;
    }

    print $handle
        '</tbody><tbody><tr class="tbody-start"><td class="reset-box"><input type="button" value="リセット" onclick="cmonos.form.item(this.form).resetAll(\'search:\')" /></td><td class="submit-box">';

    if (   $search_count > 1
        && $setting::page{$setting::key}{'defaultSearchOparator'}
        && $setting::page{$setting::key}{'defaultSearchOparatorFixed'} )
    {
        print $handle '<input type="hidden" name="and" value="'
            . (
            (   $setting::page{$setting::key}{'defaultSearchOparator'} eq 'OR'
            ) ? '0' : '1'
            ) . '" />';
    }
    print $handle '<ul class="tools">';
    if ($search_count > 1
        && (   !$setting::page{$setting::key}{'defaultSearchOparator'}
            || !$setting::page{$setting::key}{'defaultSearchOparatorFixed'} )
        )
    {
        print $handle '<li class="group-end"><select name="and">';
        print $handle '<option value="1">全ての条件に一致</option>';
        print $handle '<option value="0"'
            . (
            (   (   !defined $main::and
                        && $setting::page{$setting::key}
                        {'defaultSearchOparator'}
                        && $setting::page{$setting::key}
                        {'defaultSearchOparator'} eq 'OR'
                )
                    || (
                    (   defined $main::and
                        || !$setting::page{$setting::key}
                        {'defaultSearchOparator'}
                    )
                    && !$main::and
                    )
            ) ? ' selected="selected"' : ''
            ) . '>いずれかの条件に一致</option>';
        print $handle '</select></li>';
    }
    $this->print_sort_menu($handle);

    # テーブル表示
    $this->print_view_switch_submit_button( $handle, 'list',
        'テーブル表示' );

    if ( $this->tree_enabled ) {

        # ツリー表示
        $this->print_view_switch_submit_button( $handle, 'listtree',
            'ツリー表示' );

        # 記事スレッド表示
        $this->print_view_switch_submit_button( $handle, 'listthread',
            '記事スレッド表示' );
    }

    # 記事表示
    $this->print_view_switch_submit_button( $handle, 'listarticle',
        '記事表示' );

    print $handle '</ul></td></tr></tbody></table>';
    print $handle '</form>';
}

sub print_view_switch_submit_button ($$$$) {
    my ( $this, $handle, $view, $title ) = @_;
    print $handle '<li>';
    print $handle $cgi::icon->submit_button( $view, $setting::page{$view},
        $title, '', { 'v' => $view } );
    print $handle '</li>';
}

######################################################################
#入力欄
sub print_input_form ($$$$$$$$) {
    return;
}

######################################################################
#記事フッタ
sub print_list_footer ($$$$) {
    my ( $this, $handle, $output, $p ) = @_;

    #検索フレーム終了
    print $handle $this->frame_end(
        $setting::page{$setting::key}{'searchFrame'},
        $setting::page{$setting::key}{'searchFrameWidth'},
        'box', 'baobab-search-frame', 1
    );

}

1;
