package ThreadCategory;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールドモジュール（スレッドカテゴリー）
# ThreadCategory.pm 1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-01-15
######################################################################
sub set_my_type($;$) {
    my ( $v, $k ) = @_;
    $ThreadCategory::is_tree
        = ( ( defined $v && $v =~ /tree/ ) || ( defined $k && $k =~ /tree/ ) )
        ? 1
        : 0;
}

sub _set ($$) {
    my ( $this, $setting ) = @_;
    set_my_type( $main::v, $main::k );

    #スレッドカテゴリー情報
    $this->import_db( $default::preference_dir . '/thread_category',
        \%thread::category, 1 )
        unless %thread::category
        && ref $thread::category{'ORDER'}
        && %{ $thread::category{'ORDER'} };
    if (   %thread::category
        && ref $thread::category{'ORDER'}
        && %{ $thread::category{'ORDER'} } )
    {
        $this->{'field_for'}{'category'} = $this->{'id'};
        $this->use_icon( 'baobab', 'bb_icon' );
    }
    else {
        $this->{'disabled'} = 1;
    }
    return;
}

######################################################################
#	(0)-3 フィールドDB
sub db ($) {
    my $this = shift;
    return 'thread_category';
}

######################################################################
#	(0)-8 obj->align;
sub align ($) {
    my $this = shift;
    return 'center';
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    return 0 if $this->{'disabled'};
    return (
        (   defined $main::search{ $this->{'id'} }{'str'}
                && $main::search{ $this->{'id'} }{'str'} ne ''
        )
            || ( ref $main::search{ $this->{'id'} }{'str'}
            && @{ $main::search{ $this->{'id'} }{'str'} } )
    ) ? 1 : 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    return 1 if !$this->match_enabled;
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'str'} )
        if !ref $main::search{ $this->{'id'} }{'str'};
    foreach ( @{ $main::search{ $this->{'id'} }{'str'} } ) {
        next if !defined $_ || $_ eq '';
        return 1 if defined $$str && $$str eq $_;
    }
    return 0;
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
    my $this = shift;
    return ( $main::parent || $this->{'disabled'} ) ? 0 : 1;
}

sub form {
    my ( $this, $status, $original ) = @_;
    return '' if $main::parent || $this->{'disabled'};
    $main::data{ $this->{'id'} }{'str'} = $this->{'default'}
        if ( !defined $status || $status eq '' )
        && ( !defined $main::data{ $this->{'id'} }{'str'}
        || $main::data{ $this->{'id'} }{'str'} eq '' );
    my @data = ( $main::data{ $this->{'id'} }{'str'} );
    my $form = $this->field_header( '', 'data:' . $this->{'id'} . ':str' );
    $form .= $this->thread_category_menu( 'data:' . $this->{'id'} . ':str',
        0, \@data, $this->{'is_invalid_field'}{'str'} );
    $form .= $this->field_footer;
    return $form;
}

sub thread_category_menu ($$$$;$$) {
    my ( $this, $name, $is_multiple, $selected, $is_invalid_field,
        $is_setting )
        = @_;
    my ($form);
    if ( $this->{'radiobutton'} ) {
        $form .= '<ol class="checkbox">';
        $form
            .= '<li><label><input type="'
            . ( ($is_multiple) ? 'checkbox' : 'radio' )
            . '" name="'
            . $name
            . '" value="" /></label></li>'
            if $is_setting;
    }
    else {
        $form
            .= '<select name="'
            . $name
            . '" id="'
            . $name . '"'
            . ( ($is_multiple)      ? ' multiple="multiple"'   : '' )
            . ( ($is_invalid_field) ? $this->set_invalid_class : '' ) . '>';
        $form .= '<option value=""></option>' if !$is_multiple || $is_setting;
    }
    foreach ( sort { $a <=> $b } keys %{ $thread::category{'ORDER'} } ) {
        my $id = $thread::category{'ORDER'}{$_};
        if (   !defined $id
            || !ref $thread::category{$id}
            || !$thread::category{$id}{'closed'}
            || $this->is_secure('closed') )
        {
            my $is_selected
                = (    ref $selected eq 'ARRAY'
                    && @$selected
                    && grep( defined $_ && $_ ne '' && $id eq $_, @$selected )
                ) ? 1 : 0;
            if ( $this->{'radiobutton'} ) {
                $form
                    .= '<li><label><input type="'
                    . ( ($is_multiple) ? 'checkbox' : 'radio' )
                    . '" name="'
                    . $name
                    . '" value="'
                    . $id . '"'
                    . ( ($is_selected)      ? ' checked="checked"'     : '' )
                    . ( ($is_invalid_field) ? $this->set_invalid_class : '' )
                    . ' /> '
                    . $thread::category{$id}{'name'}
                    . '</label></li>';
            }
            else {
                $form
                    .= '<option value="'
                    . $id . '"'
                    . ( ($is_selected) ? ' selected="selected"' : '' ) . '>'
                    . $thread::category{$id}{'name'}
                    . '</option>';
            }
        }
    }
    if ( $this->{'radiobutton'} ) {
        $form .= '</ol>';
    }
    else {
        $form .= '</select>';
    }
    return $form;
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    if ( $main::parent || $this->{'disabled'} ) {
        delete $main::data{ $this->{'id'} }{'str'};
        return 1;
    }

    my $id = $main::data{ $this->{'id'} }{'str'};
    if ( !defined $id || !$id ) {
        if ( $this->{'required'} ) {
            push(
                @{ $cgi::action->{'dialog'} },
                ( ( $this->{'name'} ) ? $this->{'name'} : 'カテゴリー' )
                    . 'を選択してください'
            ) if ref $cgi::action;
            $main::data{ $this->{'id'} }{'str'} = '';
            $this->{'is_invalid_field'}{'str'} = 1;
            return 0;
        }
    }
    elsif ( !defined $thread::category{$id}{'name'}
        || $thread::category{$id}{'name'} eq '' )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '指定された'
                . (
                ( $this->{'name'} ) ? $this->{'name'} : 'カテゴリー' )
                . 'は存在しません。'
        ) if ref $cgi::action;
        $main::data{ $this->{'id'} }{'str'} = '';
        $this->{'is_invalid_field'}{'str'} = 1;
        return 0;
    }
    elsif ( $thread::category{$id}{'closed'} && !$this->is_secure('closed') )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '指定された'
                . (
                ( $this->{'name'} ) ? $this->{'name'} : 'カテゴリー' )
                . 'がみつかりませんでした。'
        ) if ref $cgi::action;
        $main::data{ $this->{'id'} }{'str'} = '';
        $this->{'is_invalid_field'}{'str'} = 1;
        return 0;
    }
    return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format_enabled ($) {
    my $this = shift;
    return ( $this->{'disabled'} ) ? 0 : 1;
}

sub usual_format {
    my ( $this, $str, $path, $c, $n, $db ) = @_;
    return '' if defined $this->{'disabled'} && $this->{'disabled'};
    $str = $$str{'str'} if ref $str eq 'HASH';
    my $id
        = ( defined $str && $str ne '' )
        ? $str
        : $this->get_thread_category_id( $n, $db );
    return '' if !defined $id || !$id;
    if (   ( !$ThreadCategory::is_tree || $this->{'icon'} )
        && $thread::category{$id}{'icon'}
        && $setting::icon{'threadcategory'}{ $thread::category{$id}{'icon'} }
        {'name'} )
    {
        return $this->field_tag(
            $cgi::Image->image_tag(
                (   ( $cgi::output || $cgi::output_option )
                    ? $this->base_change(
                        $cgi::icon->{'image_dir'}, $cgi::output,
                        $cgi::output_option
                        )
                    : $cgi::icon->{'image_dir'}
                )
                . '/threadcategory/'
                    . $setting::icon{'threadcategory'}
                    { $thread::category{$id}{'icon'} }{'name'},
                $setting::icon{'threadcategory'}
                    { $thread::category{$id}{'icon'} }{'width'},
                $setting::icon{'threadcategory'}
                    { $thread::category{$id}{'icon'} }{'height'},
                0,
                (   ( $thread::category{$id}{'name'} )
                    ? $thread::category{$id}{'name'}
                    : $id
                )
            )
        );
    }
    else {
        return $this->field_tag(
            $this->style(
                '&lt;'
                    . $this->escape( $thread::category{$id}{'name'} )
                    . '&gt;',
                $this->{'style'},     $this->{'fontsize'},
                $this->{'fontcolor'}, $this->{'fontface'}
            )
        );
    }
}

sub get_thread_category_id ($$$) {
    my ( $this, $n, $db ) = @_;
    my $category_id = $this->decode_utf8(
        $db->{'thread_category'}->{
            $this->encode_utf8(
                $cgi::action->get_top(
                    $n,
                    $this->decode_utf8(
                        $db->{'tree'}->{ $this->encode_utf8($n) }
                    )
                )
            )
        }
    );
    return ($category_id) ? $category_id : '';
}

sub has_content {
    my ( $this, $str, $type, $path, $c, $n, $db ) = @_;
    return 0 if defined $this->{'disabled'} && $this->{'disabled'};
    $str = $$str{'str'} if ref $str eq 'HASH';
    my $id
        = ( defined $str && $str ne '' )
        ? $str
        : $this->get_thread_category_id( $n, $db );
    return ($id) ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
    my $this = shift;
    return ( $this->{'disabled'} ) ? 0 : 1;
}

sub format_for_mail {
    my ( $this, $str, $path, $c, $n, $db ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if ( !defined $str || $str eq '' ) && !ref $db;
    my $id
        = ( defined $str && $str ne '' )
        ? $str
        : $this->get_thread_category_id( $n, $db );
    return '' if !defined $id || !$id;
    return
          '['
        . $this->{'name'} . "]\x0A"
        . $thread::category{$id}{'name'}
        . "\x0A\x0A";
}

#	(4)-3 obj->format_for_text(str);
sub format_for_text_enabled ($) {
    my $this = shift;
    return ( $this->{'disabled'} ) ? 0 : 1;
}

sub format_for_text {
    my ( $this, $str, $path, $c, $n, $db ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if ( !defined $str || $str eq '' ) && !ref $db;
    my $id
        = ( defined $str && $str ne '' )
        ? $str
        : $this->get_thread_category_id( $n, $db );
    return '' if !defined $id || !$id;
    return $thread::category{$id}{'name'};
}

sub format_for_detail_enabled ($) {
    my $this = shift;
    return ( $this->{'disabled'} ) ? 0 : 1;
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return ( $main::parent || $this->{'disabled'} ) ? 1 : 0;
}

sub confirmation ($$) {
    my ( $this, $str ) = @_;
    return '';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;

    #名前
    my $name = 'data:' . $this->{'id'};
    $this->print_field_info_form(
        $name,
        $this->{'disabled'},
        (   ( $this->{'disabled'} )
            ? '使用不可：スレッドカテゴリー設定がみつかりません。'
            : ''
        )
    );

    print '<fieldset>';
    print '<legend>カテゴリー選択肢の表示</legend>';
    print '<label><input type="checkbox" name="'
        . $name
        . '_radiobutton" id="'
        . $name
        . '_radiobutton" value="1"'
        . ( ( defined $this->{'radiobutton'} && $this->{'radiobutton'} )
        ? ' checked="checked"'
        : '' )
        . ' /> ラジオボタンで表示する。</label>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>表示設定</legend>';
    print '<label for="data:'
        . $this->{'id'}
        . '_icon"><input type="checkbox" name="'
        . $name
        . '_icon" id="'
        . $name
        . '_icon" value="1"'
        . ( ( $this->{'icon'} ) ? ' checked="checked"' : '' )
        . ' /> ツリー表示時も&lt;文字&gt;ではなくアイコンで表示する</label>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend><label for="data:'
        . $this->{'id'}
        . '_default">デフォルト</label></legend>';
    print $this->thread_category_menu(
        'data:' . $this->{'id'} . '_default',
        0, [ $this->{'default'} ],
        0, 1
    );
    print '</fieldset>';

    $this->print_font_setting_form($name);
    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_radiobutton' } = ''
        if !$main::data{ $this->{'id'} . '_radiobutton' };
    return $this->is_valid_font_setting;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
    my $this = shift;
    return '' if defined $this->{'disabled'} && $this->{'disabled'};
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'str'} );
    my $form
        = '<tr><td class="field-name"><label for="search:'
        . $this->{'id'}
        . ':str">'
        . $this->{'name'}
        . '</label></td><td class="field">';
    $form .= $this->thread_category_menu( 'search:' . $this->{'id'} . ':str',
        1, $main::search{ $this->{'id'} }{'str'} );
    $form .= '</td></tr>';
    return $form;
}

######################################################################
#	sample
sub sample ($$) {
    my ( $this, $str ) = @_;
    return
          ( defined $str )
        ? ( defined $thread::category{$str}{'ORDER'} )
            ? $thread::category{$str}{'ORDER'}
            : $str
        : '';
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return ( $main::k eq 'tools' ) ? 0 : 1;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'xbb_category', 'ThreadCategory',
        'スレッドカテゴリー' );
}

1;
