package BbExport;
require CMONOS::Baobab::BbCommon;
@ISA = qw(BbCommon);
use strict;
use utf8;
######################################################################
# 全記事書き出しモジュール
# BbExport.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
# 最終更新日：2017-01-31
######################################################################
# 実行
sub run ($) {
    my $this = shift;

    #フィールド設定読み込み
    $this->use_field( 'field', $default::field_pref_dir . '/inputfield',
        2, 2, 'no' );

    #書き出し
    if ( defined $main::a && $main::a eq 'w' ) {
        no warnings qw(untie);
        my ( $export, %db, %dbname );
        local $cgi::output_option = 'abs';

        #テキストをデータベースに変換
        require CMONOS::CGI_Lib::Table;
        $export = Table->new;
        use Fcntl qw(:DEFAULT);
        eval 'use ' . $env::dbm_file . ';';

        #データベースに接続
        tie(%{ $db{'thread_category'} },
            $env::dbm_file, "$default::db/thread_category",
            O_RDONLY, $env::dbm_mode
        ) if $field::for{'category'};
        tie( %{ $db{'thread_status'} },
            $env::dbm_file, "$default::db/thread_status", O_RDONLY,
            $env::dbm_mode )
            if $field::for{'status'};
        tie(%{ $db{'tree'} }, $env::dbm_file, "$default::db/tree",
            O_RDONLY,         $env::dbm_mode
        );
        while ( my ( $id, $field ) = each %field::obj ) {
            next unless $id ne '' && ref $field;
            $dbname{$id} = $field::obj{$id}->db;
            unless ( !$dbname{$id} || ref tied %{ $db{ $dbname{$id} } } ) {
                tie(%{ $db{ $dbname{$id} } },
                    $env::dbm_file, $default::db . '/' . $dbname{$id},
                    O_RDONLY, $env::dbm_mode
                );
            }
        }
        unless ( ref tied %{ $db{'mtime'} } ) {
            tie(%{ $db{'mtime'} },
                $env::dbm_file, $default::db . '/' . 'mtime',
                O_RDONLY, $env::dbm_mode
            );
        }

        #データベース書き出し
        $export->set_encoding();
        binmode STDOUT;
        if ($main::for_excel) {
            $this->print_http_header('application/vnd.ms-excel');
        }
        elsif ( $main::type eq 'tsv' ) {

            #$this->print_http_header('text/tab-separated-values');
            $this->print_http_header('application/tab-separated-values');
        }
        else {
            #$this->print_http_header('text/comma-separated-values');
            $this->print_http_header('application/csv');
        }
        my (@data);
        foreach my $o ( sort { $a <=> $b } keys %field::ORDER ) {
            push( @data, $field::obj{ $field::ORDER{$o} }->name );
        }
        print $export->array_to_sv( $main::type, @data );
        undef @data;
        while ( my ($n) = each %{ $db{'mtime'} } ) {
            utf8::decode($n) if !utf8::is_utf8($n);
            my (@data);
            foreach my $o ( sort { $a <=> $b } keys %field::ORDER ) {
                my $id     = $field::ORDER{$o};
                my $dbname = $dbname{$id};
                my $v      = '';
                if ( defined $dbname && $dbname ) {
                    $v = $this->decode_utf8(
                        $db{$dbname}{ $this->encode_utf8($n) } );
                    $v
                        = ( !$main::format )
                        ? ( defined $v )
                            ? $v
                            : ''
                        : (    $main::format eq 'html'
                            && $field::obj{$id}->format_for_detail_enabled )
                        ? $field::obj{$id}
                        ->format_for_detail( $v, "$default::file/$n",
                        $main::c, $n, \%db )
                        : ( $field::obj{$id}->format_for_text_enabled )
                        ? $field::obj{$id}
                        ->format_for_text( $v, "$default::file/$n", $main::c,
                        $n, \%db )
                        : '';
                }
                elsif ($main::format
                    && $main::format eq 'html'
                    && $field::obj{$id}->format_for_detail_enabled )
                {
                    $v
                        = $field::obj{$id}
                        ->format_for_detail( '', "$default::file/$n",
                        $main::c, $n, \%db );
                }
                elsif ($main::format
                    && $field::obj{$id}->format_for_text_enabled )
                {
                    $v
                        = $field::obj{$id}
                        ->format_for_text( '', "$default::file/$n", $main::c,
                        $n, \%db );
                }
                push( @data, $v );
            }
            print $export->array_to_sv( $main::type, @data );
            undef @data;
        }

        #データベースの接続を解除
        while ( my ( $k, $v ) = each %db ) {
            if ( ref tied %{$v} ) {
                untie %{$v};
            }
        }

        #終了
        exit;
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print '<h1>全記事の書き出し</h1>';
    my $filename = $default::id || 'exported';
    $filename =~ s/^_//;
    $filename .= '_data';
    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'path'     => '/.dl/' . $filename . '.csv',
        'required' => \@setting::form
    );
    print '<input type="hidden" name="a" value="w" />';

    print
        '<fieldset><table class="field-table"><tbody><tr><td class="field-name"><label for="type">ファイル形式</label></td><td class="field">';
    print
        '<select name="type" onchange="cmonos.form.item(this.form).field(this).appendDownloadPathByValue({\'csv\':\''
        . $filename
        . '.csv\',\'tsv\':\''
        . $filename
        . '.tsv\'})">';
    print
        '<option value="csv">カンマ区切りテキスト（Excel形式）</option>';
    print
        '<option value="tsv">タブ区切りテキスト（FileMaker形式）</option>';
    print '</select>';
    print $this->mk_select_menu(
        'format', '書き出しデータの書式を設定します。', '',
        $main::format,
        ''     => 'データ',
        'text' => 'テキスト',
        'html' => 'HTML'
    );
    print ' <label><input type="checkbox" name="for_excel" value="1"'
        . ( ($main::for_excel) ? ' checked="checked"' : '' )
        . ' /> Excel ファイルとして書き出す</label>';
    print ' <label><input type="checkbox" name="header" value="1"'
        . ( ($main::header) ? ' checked="checked"' : '' )
        . ' /> 一行目をフィールド名にする</label>';
    print '</td></tr>';

    print '</tbody></table></fieldset>';

    print
        '<fieldset class="submit"><input type="submit" value="書き出し" /></fieldset></form>';

    #ページフッタ
    $this->print_page_footer('tools');

}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);
    if ( !$default::subdivided
        || ( $default::subdivided && defined $main::c && $main::c ne '' ) )
    {

        #クラス登録
        Common::class_register( 'b300', 'BbExport' );

        #メニュー登録
        $setting::jump_menu{'b300'} = '全記事の書き出し';
    }
}

1;
