package ThanksMsg;
require CMONOS::CGI_Lib::Tools::Preference;
@ISA = qw(Preference);
use strict;
use utf8;
no warnings qw(once);
######################################################################
# 入力お礼設定モジュール
# ThanksMsg.pm ver1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定環境
sub set_preferences ($) {
    my $this = shift;
    $preference::db   = 'thanks';             # 記録用データベース名
    $preference::name = '入力お礼設定'; # 設定パネル名
    $preference::title
        = 'データ修正権限のないユーザーがデータ入力をしたときに表示する入力お礼の設定をします。';
}

######################################################################
# 設定パネル
sub print_preference_panel ($) {
    my $this = shift;

    #フィールド設定読み込み
    $this->use_field( 'field', $default::field_pref_dir . '/inputfield', 2 );

    print
        '<fieldset><legend>データ修正権限のないユーザーがデータ入力をしたときにのみ表示されます</legend>';
    print '<table class="field-table"><tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:thankstitle">入力お礼タイトル</label></td>';
    print
        '<td class="field"><input type="text" name="data:thankstitle" id="data:thankstitle" size="72" value="'
        . $this->escape( $main::data{'thankstitle'} )
        . '" title="データ修正権限のないユーザーがデータ入力をしたときにのみ表示されます。" /></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:thanks">入力お礼</label></td>';
    print
        '<td class="field"><textarea name="data:thanks" id="data:thanks" cols="72" rows="15" wrap="soft">'
        . $this->escape( $main::data{'thanks'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:thanks\').quotationByMenu(this)" title="これらのタグはお礼表示時に対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print '<option value="&lt;name&gt;">&lt;name&gt;[名前フィールド'
        . ( ( $field::for{'name'} && ref $field::obj{ $field::for{'name'} } )
        ? '（' . $field::obj{ $field::for{'name'} }->name . '）'
        : '' )
        . 'の値]</option>';
    print
        '<option value="&lt;title&gt;">&lt;title&gt;[タイトルフィールド'
        . (
        ( $field::for{'title'} && ref $field::obj{ $field::for{'title'} } )
        ? '（' . $field::obj{ $field::for{'title'} }->name . '）'
        : '' )
        . 'の値]</option>';
    print '</select>';
    print '</div>';
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>';
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ( !$default::subdivided
        || ( $default::subdivided && defined $main::c && $main::c ne '' ) )
    {

        #クラス登録
        Common::class_register( 'b210', 'ThanksMsg' );

        #ツール登録
        $setting::jump_menu{'b210'} = '入力お礼設定';
    }
}

1;
