package AddressJ;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（住所）
# AddressJ.pm 1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-03-01
######################################################################
#郵便局の郵便番号検索
$AddressJ::zipcode_url = 'http://www.post.japanpost.jp/zipcode/index.html';
######################################################################g
sub _set ($$) {
    my ( $this, $setting ) = @_;
    return;
}

sub elements ($$) {
    my ( $this, $str ) = @_;
    my (%data);
    if (   $str
        && $str
        =~ m!^<div itemprop="address" itemscope="itemscope" itemtype="http://data-vocabulary.org/Address"><div itemprop="region">(.*?)</div><div itemprop="locality">(.*?)</div><div itemprop="street-address"><div>(.*?)</div>(<div>.*?</div>|)</div>(<div>.*?</div>|)</div>$!is
        )
    {
        $data{'pref'}     = $1;
        $data{'city'}     = $2;
        $data{'street'}   = $3;
        $data{'building'} = $4;
        $data{'island'}   = ($5) ? '※離島' : '';
        $data{'building'} =~ s/^<div>//igs;
        $data{'building'} =~ s/<\/div>$//igs;
    }
    elsif ($str
        && $str =~ s/<(\w+)(?!\w)[<>]*itemprop="region"[<>]*>(.*?)<\/\1>//is )
    {
        $data{'pref'}   = $this->detag_addr($2);
        $data{'island'} = ( $str =~ s/※離島//s ) ? '※離島' : '';
        $data{'city'}   = $this->detag_addr($2)
            if $str
            =~ s/<(\w+)(?!\w)[<>]*itemprop="locality"[<>]*>(.*?)<\/\1>//is;
        my $street = $2
            if $str
            =~ s/<(\w+)(?!\w)[<>]*itemprop="street-address"[<>]*>(.*)<\/\1>//is;
        $data{'street'} = $2
            if $street =~ s/<(\w+)(?!\w)[<>]*>(.*?)<\/\1>//is;
        $data{'building'} = $2
            if $street =~ s/<(\w+)(?!\w)[<>]*>(.*?)<\/\1>//is;
        $data{'street'} = $this->detag_addr($street) if !$data{'street'};
    }
    else {
        if ($str) {
            $str =~ s/<br(?!\w)[^<>]*>/\x0A/igs;
            $str =~ s/<div(?!\w)[^<>]*>//igs;
            $str =~ s/\x0A+/\x0A/igs
                if $str =~ s/<\/div(?!\w)[^<>]*>/\x0A/igs;
            if ( $str !~ /\x0A/ ) {
                $str =~ s/^\d{3}\-?\d{4}\s*//s;
                $str
                    =~ s/^(.*?(?:都|道|府|県)(?!(?:都|道|府|県)))\s*/$1\x0A/s;
                $str =~ s/^(.*?(?:市|区|町|村))\s*/$1\x0A/s;
                $data{'island'} = ($4) ? '※離島' : '';
            }
        }
        (   $data{'pref'},     $data{'city'}, $data{'street'},
            $data{'building'}, $data{'island'}
        ) = ($str) ? split( /\x0A/, $str ) : ( '', '', '', '', '' );
    }
    return %data;
}

######################################################################
#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    return 1
        if !defined $main::search{ $this->{'id'} }{'str'}
        || $main::search{ $this->{'id'} }{'str'} eq '';
    @{ $this->{'pattern'} } = $this->make_patterns(
        \$main::search{ $this->{'id'} }{'str'},
        (   ( $this->{'ignoreCase'} || $main::search{ $this->{'id'} }{'i'} )
            ? 1
            : 0
        ),
        $main::search{ $this->{'id'} }{'mode'}
    ) if !ref $this->{'pattern'};

    my $addr = $$str;
    $addr =~ s/[\s\x{3000}]+//gs;
    $addr =~ s/<br(?![0-9a-zA-Z_])[^>]*>//gs;

    return $this->pattern_matched(
        \$addr,
        $this->{'pattern'},
        (   ( $this->{'ignoreCase'} || $main::search{ $this->{'id'} }{'i'} )
            ? 1
            : 0
        ),
        $main::search{ $this->{'id'} }{'mode'}
    );
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my ( $name, $form );

    #フィールドネーム+ヘッダ
    $form = $this->field_header('40');

    #デフォルト作成
    if ( defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'} ne '' )
    {
        %{ $main::data{ $this->{'id'} } }
            = $this->elements( $main::data{ $this->{'id'} }{'str'} );
    }
    elsif ( ( !defined $status || $status eq '' )
        && !defined $main::data{ $this->{'id'} }{'pref'} )
    {
        $main::data{ $this->{'id'} }{'pref'}     = $this->{'dpref'};
        $main::data{ $this->{'id'} }{'city'}     = $this->{'dcity'};
        $main::data{ $this->{'id'} }{'street'}   = $this->{'dstreet'};
        $main::data{ $this->{'id'} }{'building'} = $this->{'dbuilding'};
    }

    #都道府県
    $form .= '<div class="sub-field">';
    $form .= $this->prefecture_menu(
        $this->{'id'} . ':pref',
        $main::data{ $this->{'id'} }{'pref'},
        $this->{'is_invalid_field'}{'pref'},
        $this->{'required'}
    );

    #検索ボタンの付加
    if ( $env::zipcode ne '' && $this->{'zipcodesearch'} ) {
        $form
            .= ' <input type="button" value="〒→住所" onclick="openZipCodeSearchWindow(';
        $form
            .= $this->path_change( $env::zipcode_search, $ENV{'SCRIPT_NAME'},
            'abs' )
            . ',this.form,false,false,';
        $form
            .= '\'data:'
            . $this->{'id'}
            . ':pref\',\'data:'
            . $this->{'id'}
            . ':city\',\'data:'
            . $this->{'id'}
            . ':street\',\'data:'
            . $this->{'id'}
            . ':building\')" />';
    }
    $form
        .= ' <a class="tool" href="'
        . $AddressJ::zipcode_url
        . '" target="_blank" title="日本郵便ホームページの郵便番号住所検索ページにジャンプします。">〒検索</a>'
        if $AddressJ::zipcode_url && $this->{'yuseilink'};
    $form .= '</div>';

    #市町村
    $form
        .= '<div class="sub-field"><input type="text" name="data:'
        . $this->{'id'}
        . ':city" id="data:'
        . $this->{'id'}
        . ':city" size="36"';
    $form
        .= ' value="'
        . $this->escape( $main::data{ $this->{'id'} }{'city'} ) . '"'
        if defined $main::data{ $this->{'id'} }{'city'}
        && $main::data{ $this->{'id'} }{'city'};
    $form .= $this->set_invalid_class if $this->{'is_invalid_field'}{'city'};
    $form .= ' required="required"'   if $this->{'required'};
    $form
        .= ' /><label for="data:'
        . $this->{'id'}
        . ':city" class="note">（市区郡町村）</label></div>';

    #町域・番地
    $form
        .= '<div class="sub-field"><input type="text" name="data:'
        . $this->{'id'}
        . ':street" id="data:'
        . $this->{'id'}
        . ':street" size="36"';
    $form
        .= ' value="'
        . $this->escape( $main::data{ $this->{'id'} }{'street'} ) . '"'
        if defined $main::data{ $this->{'id'} }{'street'}
        && $main::data{ $this->{'id'} }{'street'};
    $form .= $this->set_invalid_class
        if $this->{'is_invalid_field'}{'street'};
    $form .= ' required="required"' if $this->{'required'};
    $form
        .= ' /><label for="data:'
        . $this->{'id'}
        . ':street" class="note">（町域・番地）</label></div>';

    #棟・番号
    $form
        .= '<div class="sub-field"><input type="text" name="data:'
        . $this->{'id'}
        . ':building" id="data:'
        . $this->{'id'}
        . ':building" size="36"';
    $form
        .= ' value="'
        . $this->escape( $main::data{ $this->{'id'} }{'building'} ) . '"'
        if defined $main::data{ $this->{'id'} }{'building'}
        && $main::data{ $this->{'id'} }{'building'};
    $form
        .= ' /><label for="data:'
        . $this->{'id'}
        . ':building" class="note">（棟・番号）</label></div>';

    #棟・番号
    if ( defined $this->{'islandcheck'} && $this->{'islandcheck'} ) {
        $form
            .= '<div class="sub-field"><input type="checkbox" name="data:'
            . $this->{'id'}
            . ':island" id="data:'
            . $this->{'id'}
            . ':island" value="※離島"';
        $form .= ' checked="checked"'
            if defined $main::data{ $this->{'id'} }{'island'}
            && $main::data{ $this->{'id'} }{'island'};
        $form
            .= ' /><label for="data:'
            . $this->{'id'}
            . ':island" class="note">離島</label></div>';
    }

    $form .= $this->field_footer;
    return $form;
}

sub prefecture_menu ($$;$$$) {
    my ( $this, $name, $pref, $is_invalid, $required ) = @_;
    my ($form);
    $pref = '' if !defined $pref;
    $form
        .= '<select name="data:'
        . $name
        . '" id="data:'
        . $name
        . '" title="都道府県を選択します。"'
        . ( ($is_invalid) ? $this->set_invalid_class : '' )
        . ( ($required)   ? ' required="required"'   : '' ) . '>';
    $form .= '<option value=""></option>';
    $form
        .= '<option value="北海道"'
        . ( ( $pref eq '北海道' ) ? ' selected="selected"' : '' )
        . '>北海道</option>';
    $form
        .= '<option value="青森県"'
        . ( ( $pref eq '青森県' ) ? ' selected="selected"' : '' )
        . '>青森県</option>';
    $form
        .= '<option value="岩手県"'
        . ( ( $pref eq '岩手県' ) ? ' selected="selected"' : '' )
        . '>岩手県</option>';
    $form
        .= '<option value="宮城県"'
        . ( ( $pref eq '宮城県' ) ? ' selected="selected"' : '' )
        . '>宮城県</option>';
    $form
        .= '<option value="秋田県"'
        . ( ( $pref eq '秋田県' ) ? ' selected="selected"' : '' )
        . '>秋田県</option>';
    $form
        .= '<option value="山形県"'
        . ( ( $pref eq '山形県' ) ? ' selected="selected"' : '' )
        . '>山形県</option>';
    $form
        .= '<option value="福島県"'
        . ( ( $pref eq '福島県' ) ? ' selected="selected"' : '' )
        . '>福島県</option>';
    $form
        .= '<option value="茨城県"'
        . ( ( $pref eq '茨城県' ) ? ' selected="selected"' : '' )
        . '>茨城県</option>';
    $form
        .= '<option value="栃木県"'
        . ( ( $pref eq '栃木県' ) ? ' selected="selected"' : '' )
        . '>栃木県</option>';
    $form
        .= '<option value="群馬県"'
        . ( ( $pref eq '群馬県' ) ? ' selected="selected"' : '' )
        . '>群馬県</option>';
    $form
        .= '<option value="埼玉県"'
        . ( ( $pref eq '埼玉県' ) ? ' selected="selected"' : '' )
        . '>埼玉県</option>';
    $form
        .= '<option value="千葉県"'
        . ( ( $pref eq '千葉県' ) ? ' selected="selected"' : '' )
        . '>千葉県</option>';
    $form
        .= '<option value="東京都"'
        . ( ( $pref eq '東京都' ) ? ' selected="selected"' : '' )
        . '>東京都</option>';
    $form
        .= '<option value="神奈川県"'
        . ( ( $pref eq '神奈川県' ) ? ' selected="selected"' : '' )
        . '>神奈川県</option>';
    $form
        .= '<option value="新潟県"'
        . ( ( $pref eq '新潟県' ) ? ' selected="selected"' : '' )
        . '>新潟県</option>';
    $form
        .= '<option value="富山県"'
        . ( ( $pref eq '富山県' ) ? ' selected="selected"' : '' )
        . '>富山県</option>';
    $form
        .= '<option value="石川県"'
        . ( ( $pref eq '石川県' ) ? ' selected="selected"' : '' )
        . '>石川県</option>';
    $form
        .= '<option value="福井県"'
        . ( ( $pref eq '福井県' ) ? ' selected="selected"' : '' )
        . '>福井県</option>';
    $form
        .= '<option value="山梨県"'
        . ( ( $pref eq '山梨県' ) ? ' selected="selected"' : '' )
        . '>山梨県</option>';
    $form
        .= '<option value="長野県"'
        . ( ( $pref eq '長野県' ) ? ' selected="selected"' : '' )
        . '>長野県</option>';
    $form
        .= '<option value="岐阜県"'
        . ( ( $pref eq '岐阜県' ) ? ' selected="selected"' : '' )
        . '>岐阜県</option>';
    $form
        .= '<option value="静岡県"'
        . ( ( $pref eq '静岡県' ) ? ' selected="selected"' : '' )
        . '>静岡県</option>';
    $form
        .= '<option value="愛知県"'
        . ( ( $pref eq '愛知県' ) ? ' selected="selected"' : '' )
        . '>愛知県</option>';
    $form
        .= '<option value="三重県"'
        . ( ( $pref eq '三重県' ) ? ' selected="selected"' : '' )
        . '>三重県</option>';
    $form
        .= '<option value="滋賀県"'
        . ( ( $pref eq '滋賀県' ) ? ' selected="selected"' : '' )
        . '>滋賀県</option>';
    $form
        .= '<option value="京都府"'
        . ( ( $pref eq '京都府' ) ? ' selected="selected"' : '' )
        . '>京都府</option>';
    $form
        .= '<option value="大阪府"'
        . ( ( $pref eq '大阪府' ) ? ' selected="selected"' : '' )
        . '>大阪府</option>';
    $form
        .= '<option value="兵庫県"'
        . ( ( $pref eq '兵庫県' ) ? ' selected="selected"' : '' )
        . '>兵庫県</option>';
    $form
        .= '<option value="奈良県"'
        . ( ( $pref eq '奈良県' ) ? ' selected="selected"' : '' )
        . '>奈良県</option>';
    $form
        .= '<option value="和歌山県"'
        . ( ( $pref eq '和歌山県' ) ? ' selected="selected"' : '' )
        . '>和歌山県</option>';
    $form
        .= '<option value="鳥取県"'
        . ( ( $pref eq '鳥取県' ) ? ' selected="selected"' : '' )
        . '>鳥取県</option>';
    $form
        .= '<option value="島根県"'
        . ( ( $pref eq '島根県' ) ? ' selected="selected"' : '' )
        . '>島根県</option>';
    $form
        .= '<option value="岡山県"'
        . ( ( $pref eq '岡山県' ) ? ' selected="selected"' : '' )
        . '>岡山県</option>';
    $form
        .= '<option value="広島県"'
        . ( ( $pref eq '広島県' ) ? ' selected="selected"' : '' )
        . '>広島県</option>';
    $form
        .= '<option value="山口県"'
        . ( ( $pref eq '山口県' ) ? ' selected="selected"' : '' )
        . '>山口県</option>';
    $form
        .= '<option value="徳島県"'
        . ( ( $pref eq '徳島県' ) ? ' selected="selected"' : '' )
        . '>徳島県</option>';
    $form
        .= '<option value="香川県"'
        . ( ( $pref eq '香川県' ) ? ' selected="selected"' : '' )
        . '>香川県</option>';
    $form
        .= '<option value="愛媛県"'
        . ( ( $pref eq '愛媛県' ) ? ' selected="selected"' : '' )
        . '>愛媛県</option>';
    $form
        .= '<option value="高知県"'
        . ( ( $pref eq '高知県' ) ? ' selected="selected"' : '' )
        . '>高知県</option>';
    $form
        .= '<option value="福岡県"'
        . ( ( $pref eq '福岡県' ) ? ' selected="selected"' : '' )
        . '>福岡県</option>';
    $form
        .= '<option value="佐賀県"'
        . ( ( $pref eq '佐賀県' ) ? ' selected="selected"' : '' )
        . '>佐賀県</option>';
    $form
        .= '<option value="長崎県"'
        . ( ( $pref eq '長崎県' ) ? ' selected="selected"' : '' )
        . '>長崎県</option>';
    $form
        .= '<option value="熊本県"'
        . ( ( $pref eq '熊本県' ) ? ' selected="selected"' : '' )
        . '>熊本県</option>';
    $form
        .= '<option value="大分県"'
        . ( ( $pref eq '大分県' ) ? ' selected="selected"' : '' )
        . '>大分県</option>';
    $form
        .= '<option value="宮崎県"'
        . ( ( $pref eq '宮崎県' ) ? ' selected="selected"' : '' )
        . '>宮崎県</option>';
    $form
        .= '<option value="鹿児島県"'
        . ( ( $pref eq '鹿児島県' ) ? ' selected="selected"' : '' )
        . '>鹿児島県</option>';
    $form
        .= '<option value="沖縄県"'
        . ( ( $pref eq '沖縄県' ) ? ' selected="selected"' : '' )
        . '>沖縄県</option>';
    $form .= '</select>';
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this     = shift;
    my $is_valid = 1;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    if ( defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'} ne '' )
    {
        (   $main::data{ $this->{'id'} }{'pref'},
            $main::data{ $this->{'id'} }{'city'},
            $main::data{ $this->{'id'} }{'street'},
            $main::data{ $this->{'id'} }{'building'},
            $main::data{ $this->{'id'} }{'island'}
        ) = split( /\x0A/, $main::data{ $this->{'id'} }{'str'} );
    }

    #半角変換
    $main::data{ $this->{'id'} }{'pref'} = $this->to_parenthesis(
        $this->z_to_h( $main::data{ $this->{'id'} }{'pref'} ) );
    $main::data{ $this->{'id'} }{'city'} = $this->to_parenthesis(
        $this->z_to_h( $main::data{ $this->{'id'} }{'city'} ) );
    $main::data{ $this->{'id'} }{'street'} = $this->to_parenthesis(
        $this->z_to_h( $main::data{ $this->{'id'} }{'street'} ) );
    $main::data{ $this->{'id'} }{'building'} = $this->to_parenthesis(
        $this->z_to_h( $main::data{ $this->{'id'} }{'building'} ) );

    #記入漏れ
    my ($error);
    if ( defined $main::data{ $this->{'id'} }{'building'}
        && $main::data{ $this->{'id'} }{'building'} ne '' )
    {
        $error .= $this->make_dialog('pref')
            if !defined $main::data{ $this->{'id'} }{'pref'}
            || $main::data{ $this->{'id'} }{'pref'} eq '';
        $error .= $this->make_dialog('city')
            if !defined $main::data{ $this->{'id'} }{'city'}
            || $main::data{ $this->{'id'} }{'city'} eq '';
        $error .= $this->make_dialog('street')
            if !defined $main::data{ $this->{'id'} }{'street'}
            || $main::data{ $this->{'id'} }{'street'} eq '';
    }
    elsif ( defined $main::data{ $this->{'id'} }{'street'}
        && $main::data{ $this->{'id'} }{'street'} ne '' )
    {
        $error .= $this->make_dialog('pref')
            if !defined $main::data{ $this->{'id'} }{'pref'}
            || $main::data{ $this->{'id'} }{'pref'} eq '';
        $error .= $this->make_dialog('city')
            if !defined $main::data{ $this->{'id'} }{'city'}
            || $main::data{ $this->{'id'} }{'city'} eq '';
    }
    elsif ( defined $main::data{ $this->{'id'} }{'city'}
        && $main::data{ $this->{'id'} }{'city'} ne '' )
    {
        $error .= $this->make_dialog('pref')
            if !defined $main::data{ $this->{'id'} }{'pref'}
            || $main::data{ $this->{'id'} }{'pref'} eq '';
        $error .= $this->make_dialog('street')
            if !defined $main::data{ $this->{'id'} }{'street'}
            || $main::data{ $this->{'id'} }{'street'} eq '';
    }
    elsif ( defined $main::data{ $this->{'id'} }{'pref'}
        && $main::data{ $this->{'id'} }{'pref'} ne '' )
    {
        $error .= $this->make_dialog('city')
            if !defined $main::data{ $this->{'id'} }{'city'}
            || $main::data{ $this->{'id'} }{'city'} eq '';
        $error .= $this->make_dialog('street')
            if !defined $main::data{ $this->{'id'} }{'street'}
            || $main::data{ $this->{'id'} }{'street'} eq '';
    }
    if ( defined $error && $error ne '' ) {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ) ? $this->{'name'} : '住所' )
                . 'に記入漏れがあります。'
                . $error
        ) if ref $cgi::action;
        $is_valid = 0;
        undef $error;
    }

    #必須項目
    if ($this->{'required'}
        && (   !defined $main::data{ $this->{'id'} }{'pref'}
            || $main::data{ $this->{'id'} }{'pref'} eq ''
            || !defined $main::data{ $this->{'id'} }{'city'}
            || $main::data{ $this->{'id'} }{'city'} eq ''
            || !defined $main::data{ $this->{'id'} }{'street'}
            || $main::data{ $this->{'id'} }{'street'} eq '' )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ) ? $this->{'name'} : '住所' )
                . 'が入力されていません。'
        ) if ref $cgi::action;
        $is_valid = 0;
        foreach ( 'pref', 'city', 'street' ) {
            $this->{'is_invalid_field'}{$_} = 1
                if !defined $main::data{ $this->{'id'} }{$_}
                || $main::data{ $this->{'id'} }{$_} eq '';
        }
    }

    #チェックボックス
    $main::data{ $this->{'id'} }{'island'}
        = ( $main::data{ $this->{'id'} }{'island'} ) ? '※離島' : '';

    #連結
    if (   $is_valid
        && $main::data{ $this->{'id'} }{'pref'} ne ''
        && $main::data{ $this->{'id'} }{'city'} ne ''
        && $main::data{ $this->{'id'} }{'street'} ne '' )
    {
        $main::data{ $this->{'id'} }{'str'}
            = $main::data{ $this->{'id'} }{'pref'} . "\x0A"
            . $main::data{ $this->{'id'} }{'city'} . "\x0A"
            . $main::data{ $this->{'id'} }{'street'} . "\x0A"
            . $main::data{ $this->{'id'} }{'building'} . "\x0A"
            . $main::data{ $this->{'id'} }{'island'};
    }
    else {
        $main::data{ $this->{'id'} }{'str'} = '';
    }

    $cookie::data{ 'data:' . $this->{'id'} . ':str' }
        = $main::data{ $this->{'id'} }{'str'}
        if $is_valid && $this->{'cookie'} && $main::set_cookie;
    return $is_valid;
}

sub make_dialog ($$) {
    my ( $this, $addr ) = @_;
    $this->{'is_invalid_field'}{$addr} = 1;
    if ( $addr eq 'pref' ) {
        return '\n都道府県を選択してください。';
    }
    elsif ( $addr eq 'city' ) {
        return '\n市町村を記入してください。';
    }
    elsif ( $addr eq 'street' ) {
        return '\n町域・番地を記入してください。';
    }
}

sub to_parenthesis ($$) {
    my ( $this, $str ) = @_;
    return '' if !defined $str;
    $str =~ s/</\(/g;
    $str =~ s/>/\)/g;
    return $str;
}

sub detag_addr ($$) {
    my ( $this, $html ) = @_;
    return '' if !defined $html;
    $html =~ s/<.*?>//igs;
    $html =~ s/[\x0D\x0A]+//gs;
    return $this->to_parenthesis($html);
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag($str) if !defined $str || $str eq '';
    if ( $str
        !~ /<div itemprop="address" itemscope="itemscope" itemtype="http:\/\/data-vocabulary.org\/Address">/
        && $str
        =~ /^([^\x0A]+)\x0A?([^\x0A]*)\x0A?([^\x0A]*)\x0A?([^\x0A]*)\x0A?([^\x0A]*)$/s
        )
    {
        $str
            = '<div itemprop="address" itemscope="itemscope" itemtype="http://data-vocabulary.org/Address">'
            . '<div itemprop="region">'
            . $1
            . '</div>'
            . ( ($2) ? '<div itemprop="locality">' . $2 . '</div>' : '' )
            . ( ( $3 || $4 )
            ? '<div itemprop="street-address">'
                . ( ($3) ? '<div>' . $3 . '</div>' : '' )
                . ( ($4) ? '<div>' . $4 . '</div>' : '' )
                . '</div>'
            : '' )
            . ( ($5) ? '<div>' . $5 . '</div>' : '' )
            . '</div>';
    }
    else {
        $str =~ s/[\x0A]+$//s;
        $str =~ s/[\x0A]+/<br \/>/g;
    }
    return $this->field_tag(
        $this->style(
            $this->data_tag( 'str', $str ), $this->{'style'},
            $this->{'fontsize'}, $this->{'fontcolor'},
            $this->{'fontface'}
        )
    );
}

sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';

    $str =~ s/[\x0A]+/\x0A/g;
    $str = '[' . $this->{'name'} . "]\x0A" . $str;
    $str =~ s/[\x0A]*\Z/\x0A\x0A/s;
    return $str;
}

sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';

    $str =~ s/[\x0A]+/\x0A/g;
    $str =~ s/[\x0A]+$//g;
    return $str;
}

sub has_content {
    my ( $this, $str ) = @_;
    if ( ref $str eq 'HASH' ) {
        return (
            ( $str->{'pref'} && $str->{'city'} && $str->{'street'} )
                || ( $str->{'str'}
                && $str->{'str'} =~ /[^\x09\x0A\x0C\x0D\x20]/s )
        ) ? 1 : 0;
    }
    elsif ( $str && $str =~ /[^\x09\x0A\x0C\x0D\x20]/s ) {
        return 1;
    }
    return 0;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my ($name);

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    #表示設定
    print '<fieldset>';
    print '<legend>入力欄設定</legend>';
    print '<ol class="checkbox">';
    if ( defined $env::zipcode && $env::zipcode ne '' ) {
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_zipcodesearch" value="1"'
            . ( ( $this->{'zipcodesearch'} ) ? ' checked="checked"' : '' )
            . ' /> 郵便番号住所検索ボタンを表示する</label></li>';
    }
    if ( defined $AddressJ::zipcode_url && $AddressJ::zipcode_url ) {
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_yuseilink" value="1"'
            . ( ( $this->{'yuseilink'} ) ? ' checked="checked"' : '' )
            . ' /> 日本郵便ホームページの郵便番号住所検索ページへのリンクを表示する</label></li>';
    }
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_islandcheck" value="1"'
        . ( ( $this->{'islandcheck'} ) ? ' checked="checked"' : '' )
        . ' /> 離島チェック欄を表示する</label></li>';
    print '</ol>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>デフォルト設定</legend>';

    #都道府県
    print '<div class="sub-field">';
    print $this->prefecture_menu( $this->{'id'} . '_dpref',
        $this->{'_dpref'} );

    #検索ボタンの付加
    if ( $env::zipcode ne '' && $this->{'zipcodesearch'} ) {
        print
            ' <input type="button" value="〒→住所" onclick="openZipCodeSearchWindow(';
        print '"'
            . $this->path_change( $env::zipcode_search, $ENV{'SCRIPT_NAME'},
            'abs' )
            . '",this.form,false,false,';
        print '\'data:'
            . $this->{'id'}
            . '_dpref\',\'data:'
            . $this->{'id'}
            . '_dcity\',\'data:'
            . $this->{'id'}
            . '_dstreet\',\'data:'
            . $this->{'id'}
            . '_dbuilding\')" />';
    }
    print ' <a class="tool" href="'
        . $AddressJ::zipcode_url
        . '" target="_blank" title="日本郵便ホームページの郵便番号住所検索ページにジャンプします。">〒検索</a>'
        if $AddressJ::zipcode_url && $this->{'yuseilink'};
    print '</div>';

    #市町村
    print '<div class="sub-field"><input type="text" name="data:'
        . $this->{'id'}
        . '_dcity" id="data:'
        . $this->{'id'}
        . '_dcity" size="40"';
    print ' value="' . $this->escape( $this->{'dcity'} ) . '"'
        if defined $this->{'dcity'} && $this->{'dcity'};
    print ' /><label for="data:'
        . $this->{'id'}
        . '_dcity" class="note">（市区郡町村）</label></div>';

    #町域・番地
    print '<div class="sub-field"><input type="text" name="data:'
        . $this->{'id'}
        . '_dstreet" id="data:'
        . $this->{'id'}
        . '_dstreet" size="40"';
    print ' value="' . $this->escape( $this->{'dstreet'} ) . '"'
        if defined $this->{'dstreet'} && $this->{'dstreet'};
    print ' /><label for="data:'
        . $this->{'id'}
        . '_dstreet" class="note">（町域・番地）</label></div>';

    #棟・番号
    print '<div class="sub-field"><input type="text" name="data:'
        . $this->{'id'}
        . '_dbuilding" id="data:'
        . $this->{'id'}
        . '_dbuilding" size="40"';
    print ' value="' . $this->escape( $this->{'dbuilding'} ) . '"'
        if defined $this->{'dbuilding'} && $this->{'dbuilding'};
    print ' /><label for="data:'
        . $this->{'id'}
        . '_dbuilding" class="note">（棟・番号）</label></div>';
    print '</fieldset>';

    if ( !defined $html_disabled || !$html_disabled ) {
        $this->print_ignorecase_setting_form($name);
        $this->print_font_setting_form($name);
    }
    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;

    #タグ修正
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };

    #チェックボックス
    $main::data{ $this->{'id'} . '_zipcodesearch' } = ''
        if !defined $main::data{ $this->{'id'} . '_zipcodesearch' }
        || $main::data{ $this->{'id'} . '_zipcodesearch' } eq '';
    $main::data{ $this->{'id'} . '_yuseilink' } = ''
        if !defined $main::data{ $this->{'id'} . '_yuseilink' }
        || $main::data{ $this->{'id'} . '_yuseilink' } eq '';
    $main::data{ $this->{'id'} . '_islandcheck' } = ''
        if !defined $main::data{ $this->{'id'} . '_islandcheck' }
        || $main::data{ $this->{'id'} . '_islandcheck' } eq '';
    $main::data{ $this->{'id'} . '_ignoreCase' } = ''
        if !$main::data{ $this->{'id'} . '_ignoreCase' };

    #文字色チェック
    return $this->is_valid_font_setting;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'addr_j', 'AddressJ', '住所' );
}

1;
