package CountDown;
require CMONOS::CGI_Lib::Field::Date;
@ISA = qw(Date);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（カウントダウン）
# Date.pm 1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'inputLimit'} = 2
        if !defined $this->{'inputLimit'} || $this->{'inputLimit'} eq '';
    return;
}

######################################################################
#	(0)-8 obj->align;
sub align ($) {
    my $this = shift;
    return 'left';
}

######################################################################
#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    my ( $p, $date );
    $this->get_search_patterns if !ref $this->{'pattern'};
    return 1 if @{ $this->{'pattern'} } == 0;
    $date = $1 if $$str =~ /^([0-9]+)/;
    foreach $p ( @{ $this->{'pattern'} } ) {
        next if !defined $p || $p eq '';
        if ( $p =~ /^(.*?)\-(.*)$/ ) {
            my ( $f, $t ) = ( $1, $2 );
            if (   ( !defined $f || $f eq '' || $f <= $date )
                && ( !defined $t || $t eq '' || $date <= $t ) )
            {
                return 1
                    if !defined $main::search{ $this->{'id'} }{'mode'}
                    || $main::search{ $this->{'id'} }{'mode'} ne 'and';
            }
            elsif ( defined $main::search{ $this->{'id'} }{'mode'}
                && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
            {
                return 0;
            }
        }
        elsif ( $this->is_nan($p) == 0 && $p == $date ) {
            return 1
                if !defined $main::search{ $this->{'id'} }{'mode'}
                || $main::search{ $this->{'id'} }{'mode'} ne 'and';
        }
        elsif ( defined $main::search{ $this->{'id'} }{'mode'}
            && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
        {
            return 0;
        }
    }
    if ( defined $main::search{ $this->{'id'} }{'mode'}
        && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
    {
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my ( $form, $date, $unit );
    (   $date,
        $main::data{ $this->{'id'} }{'name'},
        $main::data{ $this->{'id'} }{'span'},
        $main::data{ $this->{'id'} }{'skip'}
        )
        = split( /,/, $main::data{ $this->{'id'} }{'str'} )
        if defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'} =~ /,/;

    #フィールドネーム+ヘッダ
    $form = $this->field_header;

    #デフォルト作成
    if (   ( !defined $status || $status eq '' )
        && ( !defined $date || $date eq '' )
        && !$main::data{ $this->{'id'} }{'sec'}
        && !$main::data{ $this->{'id'} }{'min'}
        && !$main::data{ $this->{'id'} }{'h'}
        && !$main::data{ $this->{'id'} }{'d'}
        && !$main::data{ $this->{'id'} }{'mon'}
        && !$main::data{ $this->{'id'} }{'y'} )
    {
        if ( defined $this->{'presentTime'} && $this->{'presentTime'} ) {
            (   $main::data{ $this->{'id'} }{'sec'},
                $main::data{ $this->{'id'} }{'min'},
                $main::data{ $this->{'id'} }{'h'},
                $main::data{ $this->{'id'} }{'d'},
                $main::data{ $this->{'id'} }{'mon'},
                $main::data{ $this->{'id'} }{'y'}
            ) = localtime( $this->get_present_time );
            $main::data{ $this->{'id'} }{'mon'}++;
            $main::data{ $this->{'id'} }{'y'} += 1900;
        }
        else {
            $main::data{ $this->{'id'} }{'sec'} = $this->{'defaultsec'};
            $main::data{ $this->{'id'} }{'min'} = $this->{'defaultmin'};
            $main::data{ $this->{'id'} }{'h'}   = $this->{'defaulth'};
            $main::data{ $this->{'id'} }{'d'}   = $this->{'defaultd'};
            $main::data{ $this->{'id'} }{'mon'} = $this->{'defaultmon'};
            $main::data{ $this->{'id'} }{'y'}   = $this->{'defaulty'};
        }
    }
    elsif ($date) {
        $this->resolve_into_values( \$date );
    }

    $form .= $this->input_form( 'data', '', '', 1 );
    $form .= '<table class="sub-field-table"><tbody>';
    $form
        .= '<tr><td class="sub-field-name"><label for="data:'
        . $this->{'id'}
        . ':name">イベント名</label></td><td class="sub-field"><input type="text" size="16" name="data:'
        . $this->{'id'}
        . ':name" id="data:'
        . $this->{'id'}
        . ':name" value="'
        . $this->escape(
        $this->comma_unescape( $main::data{ $this->{'id'} }{'name'} ) )
        . '" /></td></tr>';
    if ( $this->{'inputLimit'} == -2 ) {
        $unit = '年';
        $main::data{ $this->{'id'} }{'span'}
            = int( $main::data{ $this->{'id'} }{'span'}
                / ( 365 * 24 * 60 * 60 * 1000 ) )
            if defined $main::data{ $this->{'id'} }{'span'}
            && $main::data{ $this->{'id'} }{'span'};
    }
    elsif ( $this->{'inputLimit'} == -1 ) {
        $unit = '月';
        $main::data{ $this->{'id'} }{'span'}
            = int( $main::data{ $this->{'id'} }{'span'}
                / ( 31 * 24 * 60 * 60 * 1000 ) )
            if defined $main::data{ $this->{'id'} }{'span'}
            && $main::data{ $this->{'id'} }{'span'};
    }
    elsif ( $this->{'inputLimit'} == 1 ) {
        $unit = '時間';
        $main::data{ $this->{'id'} }{'span'}
            = int( $main::data{ $this->{'id'} }{'span'} / ( 60 * 60 * 1000 ) )
            if defined $main::data{ $this->{'id'} }{'span'}
            && $main::data{ $this->{'id'} }{'span'};
    }
    elsif ( $this->{'inputLimit'} == 2 ) {
        $unit = '分';
        $main::data{ $this->{'id'} }{'span'}
            = int( $main::data{ $this->{'id'} }{'span'} / ( 60 * 1000 ) )
            if defined $main::data{ $this->{'id'} }{'span'}
            && $main::data{ $this->{'id'} }{'span'};
    }
    elsif ( $this->{'inputLimit'} == 3 ) {
        $unit = '秒';
        $main::data{ $this->{'id'} }{'span'}
            = int( $main::data{ $this->{'id'} }{'span'} / 1000 )
            if defined $main::data{ $this->{'id'} }{'span'}
            && $main::data{ $this->{'id'} }{'span'};
    }
    else {
        $unit = '日';
        $main::data{ $this->{'id'} }{'span'}
            = int(
            $main::data{ $this->{'id'} }{'span'} / ( 24 * 60 * 60 * 1000 ) )
            if defined $main::data{ $this->{'id'} }{'span'}
            && $main::data{ $this->{'id'} }{'span'};
    }
    $form
        .= '<tr><td class="sub-field-name"><label for="data:'
        . $this->{'id'}
        . ':span">イベント期間</label></td><td class="sub-field"><input type="number" size="4" name="data:'
        . $this->{'id'}
        . ':span" id="data:'
        . $this->{'id'}
        . ':span" value="'
        . $this->escape( $main::data{ $this->{'id'} }{'span'} ) . '"'
        . ( ( $this->{'is_invalid_field'}{'span'} )
        ? $this->set_invalid_class
        : '' )
        . ' /> '
        . $unit;
    $form
        .= '<div class="external-field"><label><input type="checkbox" name="data:'
        . $this->{'id'}
        . ':skip" id="data:'
        . $this->{'id'}
        . ':skip" value="1"'
        . (
        ( $main::data{ $this->{'id'} }{'skip'} ) ? 'checked="checked"' : '' )
        . ' /> イベント期間中は経過時間をカウントしない</label></div></td></tr>';
    $form .= '</tbody></table>';

    $form .= $this->field_footer;
    return $form;
}

sub comma_unescape ($$) {
    my ( $this, $str ) = @_;
    if ( !defined $str ) {
        $str = '';
    }
    else {
        $str =~ s/&#44;/,/g;
    }
    return $str;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    $this->resolve_into_values( \$main::data{ $this->{'id'} }{'str'} )
        if defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'};
    $main::data{ $this->{'id'} }{'name'} =~ s/,/&#44;/g
        if $main::data{ $this->{'id'} }{'name'};
    $main::data{ $this->{'id'} }{'skip'} = 0
        if !defined $main::data{ $this->{'id'} }{'skip'}
        || !$main::data{ $this->{'id'} }{'skip'};
    my ( $is_valid, $input ) = $this->is_valid_date;
    if (   !defined $main::data{ $this->{'id'} }{'span'}
        || !$main::data{ $this->{'id'} }{'span'} )
    {
        $main::data{ $this->{'id'} }{'span'} = '';
    }
    elsif ( $this->is_nan( $main::data{ $this->{'id'} }{'span'} ) ) {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                . 'のイベント期間を確認してください。半角数字にしてください。'
        ) if ref $cgi::action;
        $main::data{ $this->{'id'} }{'span'} = '';
        $this->{'is_invalid_field'}{'span'}  = 1;
        $is_valid                            = 0;
    }
    else {
        if ( $this->{'inputLimit'} == -2 ) {
            $main::data{ $this->{'id'} }{'span'}
                = $main::data{ $this->{'id'} }{'span'} * 365 * 24 * 60 * 60
                * 1000;
        }
        elsif ( $this->{'inputLimit'} == -1 ) {
            $main::data{ $this->{'id'} }{'span'}
                = $main::data{ $this->{'id'} }{'span'} * 31 * 24 * 60 * 60
                * 1000;
        }
        elsif ( $this->{'inputLimit'} == 1 ) {
            $main::data{ $this->{'id'} }{'span'}
                = $main::data{ $this->{'id'} }{'span'} * 60 * 60 * 1000;
        }
        elsif ( $this->{'inputLimit'} == 2 ) {
            $main::data{ $this->{'id'} }{'span'}
                = $main::data{ $this->{'id'} }{'span'} * 60 * 1000;
        }
        elsif ( $this->{'inputLimit'} == 3 ) {
            $main::data{ $this->{'id'} }{'span'}
                = $main::data{ $this->{'id'} }{'span'} * 1000;
        }
        else {
            $main::data{ $this->{'id'} }{'span'}
                = $main::data{ $this->{'id'} }{'span'} * 24 * 60 * 60 * 1000;
        }
    }
    if (   $is_valid
        && defined $main::data{ $this->{'id'} }{'y'}
        && $main::data{ $this->{'id'} }{'y'} ne ''
        && $main::data{ $this->{'id'} }{'y'} < 1970 )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                . 'を確認してください。1970年以降にしてください。'
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'y'} = 1;
        $is_valid = 0;
    }
    if ( $is_valid && $input ) {
        my $date = $this->date_cat(
            $main::data{ $this->{'id'} }{'sec'},
            $main::data{ $this->{'id'} }{'min'},
            $main::data{ $this->{'id'} }{'h'},
            $main::data{ $this->{'id'} }{'d'},
            $main::data{ $this->{'id'} }{'mon'},
            $main::data{ $this->{'id'} }{'y'}
        );
        $main::data{ $this->{'id'} }{'str'}
            = $date . ','
            . ( ( defined $main::data{ $this->{'id'} }{'name'} )
            ? $main::data{ $this->{'id'} }{'name'}
            : '' )
            . ','
            . ( ( defined $main::data{ $this->{'id'} }{'span'} )
            ? $main::data{ $this->{'id'} }{'span'}
            : '' )
            . ','
            . ( ( defined $main::data{ $this->{'id'} }{'skip'} )
            ? $main::data{ $this->{'id'} }{'skip'}
            : '' );
        $cookie::data{ 'data:' . $this->{'id'} . ':str' }
            = $main::data{ $this->{'id'} }{'str'}
            if $this->{'cookie'} && $main::set_cookie;
        return 1;

        #必須項目チェック
    }
    elsif ( $this->{'required'} && !$input ) {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( defined $this->{'name'} && $this->{'name'} )
                ? $this->{'name'} . 'が'
                : ''
                )
                . '入力されていません。'
        ) if ref $cgi::action;
        foreach ( 'sec', 'min', 'h', 'd', 'mon', 'y' ) {
            $this->{'is_invalid_field'}{$_} = 1
                if !defined $main::data{ $this->{'id'} }{$_}
                || $main::data{ $this->{'id'} }{$_} eq '';
        }
        return 0;
    }
    else {
        return 1;
    }
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag(
        ( $str && $str =~ /,/ )
        ? $this->data_tag_from_hash( 'str', $str )
            . $this->style(
            $this->print_count_down($str), $this->{'style'},
            $this->{'fontsize'},           $this->{'fontcolor'},
            $this->{'fontface'}
            )
        : ''
    );
}

sub has_content {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ( $str && $str =~ /,/ ) ? 1 : 0;
}

sub print_count_down ($$) {
    no warnings qw(numeric);
    my ( $this, $str ) = @_;
    my ( $id, $title, $title2 );
    my ( $date, $name, $span, $skip ) = split( /,/, $str );
    $date =~ /^([0-9]{4})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})/;
    my ( $year, $mon, $mday, $hour, $min, $sec )
        = ( $1, $2 + 0, $3 + 0, $4 + 0, $5 + 0, $6 + 0 );
    $span += 0;
    $id
        = 'countdown_'
        . $this->{'id'} . '_'
        . ( ++$this->{'countdown_id'} )
        . ( ($cgi::output) ? '_' . time : '' );
    $title = $title2
        = $this->escape(
        ( ( $name ne '' ) ? $this->comma_unescape($name) : $this->{'name'} ) )
        . ': '
        . $this->field_date($date);
    $title2 =~ s/<.*?>//g;
    return $this->javascript(
              'setInterval(\'cmonos.tool.writeCountDown(\\\''
            . $id
            . '\\\',\\\''
            . $this->escape(
            $this->quot_escape(
                (   ( $name ne '' )
                    ? $this->comma_unescape($name)
                    : $this->{'name'}
                )
            )
            )
            . '\\\','
            . $year . ','
            . $mon . ','
            . $mday . ','
            . $hour . ','
            . $min . ','
            . $sec . ','
            . $span . ','
            . ( ($skip) ? 'true' : 'false' )
            . ')\',1000);'
        )
        . '<span id="'
        . $id
        . '" title="'
        . $title2 . '">'
        . $title
        . '</span>';
}

sub quot_escape ($$) {
    my ( $this, $str ) = @_;

    #$str =~ s/\\/&yen;/g;
    #$str =~ s/'/&rsquo;/g;
    $str =~ s/\\/&#92;/g;
    $str =~ s/'/&#39;/g;
    return $str;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if $str !~ /,/;
    my ( $date, $name ) = split( /,/, $str );
    return
          '['
        . $this->name . "]\x0A"
        . $this->comma_unescape($name) . '('
        . $this->field_date( $date, 0 ) . ')'
        . "\x0A\x0A";
}

#	(4)-3 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if $str !~ /,/;
    my ( $date, $name ) = split( /,/, $str );
    return (
        ( $name ne '' ) ? $this->comma_unescape($name) : $this->{'name'} )
        . '('
        . $this->field_date( $date, 0 ) . ')';
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'time_countdown', 'CountDown',
        'カウントダウン' )
        if !$setting::field_for_mail;
}

1;
