package Date;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
use Time::Local;
######################################################################
# フィールド定義モジュール（日時）
# Date.pm 1.1.7
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-06-03
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'inputLimit'} = 0 if !defined $this->{'inputLimit'};
    $this->{'datetype'}
        = ( ( $setting::general{'datetype'} )
        ? $setting::general{'datetype'}
        : '' )
        if !$this->{'datetype'};
    return;
}

######################################################################
#	(0)-8 obj->align;
sub align ($) {
    my $this = shift;
    return 'right';
}

######################################################################
#	(1) obj->match(str);
sub match_enabled ($) {
    my $this = shift;
    if (( ref $this->{'pattern'} && @{ $this->{'pattern'} } > 0 )
        || ( defined $main::search{ $this->{'id'} }{'str'}
            && $main::search{ $this->{'id'} }{'str'} ne '' )
        || !$this->is_nan( $main::search{ $this->{'id'} }{'within'} )
        || !$this->is_nan( $main::search{ $this->{'id'} }{'fy'} )
        || ( defined $main::search{ $this->{'id'} }{'fmon'}
            && $main::search{ $this->{'id'} }{'fmon'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'fd'}
            && $main::search{ $this->{'id'} }{'fd'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'fh'}
            && $main::search{ $this->{'id'} }{'fh'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'fmin'}
            && $main::search{ $this->{'id'} }{'fmin'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'fsec'}
            && $main::search{ $this->{'id'} }{'fsec'} ne '' )
        || !$this->is_nan( $main::search{ $this->{'id'} }{'ty'} )
        || ( defined $main::search{ $this->{'id'} }{'tmon'}
            && $main::search{ $this->{'id'} }{'tmon'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'td'}
            && $main::search{ $this->{'id'} }{'td'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'th'}
            && $main::search{ $this->{'id'} }{'th'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'tmin'}
            && $main::search{ $this->{'id'} }{'tmin'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'tsec'}
            && $main::search{ $this->{'id'} }{'tsec'} ne '' )
        )
    {
        return 1;
    }
    else {
        return 0;
    }
}

sub match ($;$) {
    no warnings qw(numeric);
    my ( $this, $str ) = @_;
    my ($p);
    $this->get_search_patterns if !ref $this->{'pattern'};
    return 1 if @{ $this->{'pattern'} } == 0;

    foreach $p ( @{ $this->{'pattern'} } ) {
        next if !defined $p || $p eq '';
        if ( $p =~ /^(.*?)-(.*)$/ ) {
            my ( $f, $t ) = ( $1, $2 );
            if ((      !defined $f
                    || $f eq ''
                    || ( defined $$str && $$str ne '' && $f <= $$str )
                )
                && (   !defined $t
                    || $t eq ''
                    || ( defined $$str && $$str ne '' && $$str <= $t ) )
                )
            {
                return 1
                    if !defined $main::search{ $this->{'id'} }{'mode'}
                    || $main::search{ $this->{'id'} }{'mode'} ne 'and';
            }
            elsif ( defined $main::search{ $this->{'id'} }{'mode'}
                && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
            {
                return 0;
            }
        }
        elsif (!$this->is_nan($p)
            && defined $$str
            && $$str ne ''
            && $p == $$str )
        {
            return 1
                if !defined $main::search{ $this->{'id'} }{'mode'}
                || $main::search{ $this->{'id'} }{'mode'} ne 'and';
        }
        elsif ( defined $main::search{ $this->{'id'} }{'mode'}
            && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
        {
            return 0;
        }
    }
    if ( defined $main::search{ $this->{'id'} }{'mode'}
        && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
    {
        return 1;
    }
    else {
        return 0;
    }
}

sub get_search_patterns ($) {
    my $this = shift;
    @{ $this->{'pattern'} } = ();

    if (   defined $main::search{ $this->{'id'} }{'within'}
        && $main::search{ $this->{'id'} }{'within'} ne ''
        && !$this->is_nan( $main::search{ $this->{'id'} }{'within'} )
        && $main::search{ $this->{'id'} }{'within'} > 0 )
    {
        if ( $main::search{ $this->{'id'} }{'within'} < 1000 ) {
            my $y = $main::search{ $this->{'id'} }{'within'} * 10000000000;
            push(
                @{ $this->{'pattern'} },
                ( $this->time_id - $y ) . '-' . ( $this->time_id + $y )
            );
        }
        else {
            push(
                @{ $this->{'pattern'} },
                $this->time_id(
                    time - $main::search{ $this->{'id'} }{'within'}
                    )
                    . '-'
                    . $this->time_id(
                    time + $main::search{ $this->{'id'} }{'within'}
                    )
            );
        }
    }

    my ($pat);
    if ((   defined $main::search{ $this->{'id'} }{'fy'}
            && $main::search{ $this->{'id'} }{'fy'} ne ''
        )
        || ( defined $main::search{ $this->{'id'} }{'fmon'}
            && $main::search{ $this->{'id'} }{'fmon'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'fd'}
            && $main::search{ $this->{'id'} }{'fd'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'fh'}
            && $main::search{ $this->{'id'} }{'fh'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'fmin'}
            && $main::search{ $this->{'id'} }{'fmin'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'fsec'}
            && $main::search{ $this->{'id'} }{'fsec'} ne '' )
        )
    {

        my (@localtime);
        if ( !defined $main::search{ $this->{'id'} }{'fy'}
            || $main::search{ $this->{'id'} }{'fy'} eq '' )
        {
            @localtime = localtime(time);
            $localtime[5] += 1900;
            $localtime[4] += 1;
            shift @localtime;
        }

        $pat .= $this->date_cat(
            $main::search{ $this->{'id'} }{'fsec'},
            $main::search{ $this->{'id'} }{'fmin'},
            $main::search{ $this->{'id'} }{'fh'},
            $main::search{ $this->{'id'} }{'fd'},
            $main::search{ $this->{'id'} }{'fmon'},
            $main::search{ $this->{'id'} }{'fy'},
            @localtime
        );
    }

    $pat .= '-';

    if ((   defined $main::search{ $this->{'id'} }{'ty'}
            && $main::search{ $this->{'id'} }{'ty'} ne ''
        )
        || ( defined $main::search{ $this->{'id'} }{'tmon'}
            && $main::search{ $this->{'id'} }{'tmon'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'td'}
            && $main::search{ $this->{'id'} }{'td'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'th'}
            && $main::search{ $this->{'id'} }{'th'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'tmin'}
            && $main::search{ $this->{'id'} }{'tmin'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'tsec'}
            && $main::search{ $this->{'id'} }{'tsec'} ne '' )
        )
    {

        $pat .= $this->date_cat(
            $main::search{ $this->{'id'} }{'tsec'},
            $main::search{ $this->{'id'} }{'tmin'},
            $main::search{ $this->{'id'} }{'th'},
            $main::search{ $this->{'id'} }{'td'},
            $main::search{ $this->{'id'} }{'tmon'},
            $main::search{ $this->{'id'} }{'ty'},
            $main::search{ $this->{'id'} }{'fmin'},
            $main::search{ $this->{'id'} }{'fh'},
            $main::search{ $this->{'id'} }{'fd'},
            $main::search{ $this->{'id'} }{'fmon'},
            $main::search{ $this->{'id'} }{'fy'},
        );
    }

    push( @{ $this->{'pattern'} }, $pat ) if $pat ne '-';

    if ( defined $main::search{ $this->{'id'} }{'str'}
        && $main::search{ $this->{'id'} }{'str'} ne '' )
    {
        my (@temp);
        @temp = split( /[\x09\x0A\x0C\x0D\x20]+/,
            $this->z_to_h( $main::search{ $this->{'id'} }{'str'} ) );
        foreach (@temp) {
            my ( $to, $f, $t );
            $to = '-' if $_ =~ /\-|~|〜/;
            ( $f, $t ) = split(/\-|~|〜/);
            if ( $f
                =~ m!^([0-9]{0,4})/?([0-9]{0,2}|)/?([0-9]{0,2}|)/?([0-9]{0,2}|):?([0-9]{0,2}|):?([0-9]{0,2}|)!
                )
            {
                $f = $this->date_cat( $6, $5, $4, $3, $2, $1 );
            }
            else {
                $f = '';
            }
            if ( $t
                =~ m!^([0-9]{0,4})/?([0-9]{0,2}|)/?([0-9]{0,2}|)/?([0-9]{0,2}|):?([0-9]{0,2}|):?([0-9]{0,2}|)!
                )
            {
                $t = $this->date_cat( $6, $5, $4, $3, $2, $1 );
            }
            else {
                $t = '';
            }
            push( @{ $this->{'pattern'} }, $f . $to . $t );
        }
    }
}

sub date_cat ($$$$$$$;$$$$$) {
    my ($this, $sec,   $min,    $hour,   $mday,  $mon,
        $year, $d_min, $d_hour, $d_mday, $d_mon, $d_year
    ) = @_;
    my $pat = '';
    if ( !defined $year || $year eq '' ) {
        $pat .= sprintf( "%.4d", $d_year );
        if ( !defined $mon || $mon eq '' ) {
            $pat .= sprintf( "%.2d", $d_mon );
            if ( !defined $mday || $mday eq '' ) {
                $pat .= sprintf( "%.2d", $d_mday );
                if ( !defined $hour || $hour eq '' ) {
                    $pat .= sprintf( "%.2d", $d_hour );
                    if ( !defined $min || $min eq '' ) {
                        $pat .= sprintf( "%.2d", $d_min );
                    }
                    else {
                        $pat .= sprintf( "%.2d", ( ($min) ? $min : 0 ) );
                        $pat .= sprintf( "%.2d", ( ($sec) ? $sec : 0 ) );
                    }
                    $pat .= sprintf( "%.2d", ( ($sec) ? $sec : 0 ) );
                }
                else {
                    $pat .= sprintf( "%.2d", ( ($hour) ? $hour : 0 ) );
                    $pat .= sprintf( "%.2d", ( ($min)  ? $min  : 0 ) );
                    $pat .= sprintf( "%.2d", ( ($sec)  ? $sec  : 0 ) );
                }
            }
            else {
                $pat .= sprintf( "%.2d", ( ($mday) ? $mday : 0 ) );
                $pat .= sprintf( "%.2d", ( ($hour) ? $hour : 0 ) );
                $pat .= sprintf( "%.2d", ( ($min)  ? $min  : 0 ) );
                $pat .= sprintf( "%.2d", ( ($sec)  ? $sec  : 0 ) );
            }
        }
        else {
            $pat .= sprintf( "%.2d", ( ($mon)  ? $mon  : 0 ) );
            $pat .= sprintf( "%.2d", ( ($mday) ? $mday : 0 ) );
            $pat .= sprintf( "%.2d", ( ($hour) ? $hour : 0 ) );
            $pat .= sprintf( "%.2d", ( ($min)  ? $min  : 0 ) );
            $pat .= sprintf( "%.2d", ( ($sec)  ? $sec  : 0 ) );
        }
    }
    else {
        $pat .= sprintf( "%.4d", ( ($year) ? $year : 0 ) );
        $pat .= sprintf( "%.2d", ( ($mon)  ? $mon  : 0 ) );
        $pat .= sprintf( "%.2d", ( ($mday) ? $mday : 0 ) );
        $pat .= sprintf( "%.2d", ( ($hour) ? $hour : 0 ) );
        $pat .= sprintf( "%.2d", ( ($min)  ? $min  : 0 ) );
        $pat .= sprintf( "%.2d", ( ($sec)  ? $sec  : 0 ) );
    }
    return $pat;
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my ($form);

    #フィールドネーム+ヘッダ
    $form = $this->field_header;

    #デフォルト作成
    if (   ( !defined $status || $status eq '' )
        && !defined $main::data{ $this->{'id'} }{'str'}
        && !$main::data{ $this->{'id'} }{'sec'}
        && !$main::data{ $this->{'id'} }{'min'}
        && !$main::data{ $this->{'id'} }{'h'}
        && !$main::data{ $this->{'id'} }{'d'}
        && !$main::data{ $this->{'id'} }{'mon'}
        && !$main::data{ $this->{'id'} }{'y'} )
    {
        if ( defined $this->{'presentTime'} && $this->{'presentTime'} ) {
            (   $main::data{ $this->{'id'} }{'sec'},
                $main::data{ $this->{'id'} }{'min'},
                $main::data{ $this->{'id'} }{'h'},
                $main::data{ $this->{'id'} }{'d'},
                $main::data{ $this->{'id'} }{'mon'},
                $main::data{ $this->{'id'} }{'y'}
            ) = localtime( $this->get_present_time );
            $main::data{ $this->{'id'} }{'mon'}++;
            $main::data{ $this->{'id'} }{'y'} += 1900;
        }
        else {
            $main::data{ $this->{'id'} }{'sec'} = $this->{'defaultsec'};
            $main::data{ $this->{'id'} }{'min'} = $this->{'defaultmin'};
            $main::data{ $this->{'id'} }{'h'}   = $this->{'defaulth'};
            $main::data{ $this->{'id'} }{'d'}   = $this->{'defaultd'};
            $main::data{ $this->{'id'} }{'mon'} = $this->{'defaultmon'};
            $main::data{ $this->{'id'} }{'y'}   = $this->{'defaulty'};
        }
    }
    elsif ( $main::data{ $this->{'id'} }{'str'} ) {
        $this->resolve_into_values( \$main::data{ $this->{'id'} }{'str'} );
    }
    $form .= $this->input_form( 'data', '', '', 1 );
    $form .= $this->date_reset_tool( 'data:' . $this->{'id'} . ':' );
    $form .= $this->field_footer;
    return $form;
}

sub get_present_time ($) {
    my $this = shift;
    my ( $start, $end ) = $this->get_datetime_bounds;
    my $time = time;
    if ( $start && $start > $time ) {
        if (   $this->{'boundsStartType'}
            && $this->{'boundsStartType'} eq 'rel'
            && $this->{'hourStart'}
            && (   $this->{'boundsStartUnit'} eq 'week'
                || $this->{'boundsStartUnit'} eq 'day' )
            )
        {
            $start += $this->{'hourStart'} * 3600;
        }
        $time = $start;
    }
    if ( $end && $end < $time ) {
        if (   $this->{'boundsEndType'}
            && $this->{'boundsEndType'} eq 'rel'
            && $this->{'hourStart'}
            && (   $this->{'boundsEndUnit'} eq 'week'
                || $this->{'boundsEndUnit'} eq 'day' )
            )
        {
            $end = $end - 86400
                + ( ( $this->{'hourEnd'} ) ? $this->{'hourEnd'} * 3600 : 0 );
        }
        $time = $end;
    }
    return $time;
}

sub get_datetime_bounds ($) {
    my $this = shift;
    my ( $start, $end );
    my ( $sec, $min, $hour ) = localtime();
    my $sum = $hour * 3600 + $min * 60 + $sec;
    if ( $this->{'boundsStartType'} ) {
        if (   $this->{'boundsStartType'} eq 'rel'
            && defined $this->{'boundsStart'}
            && $this->{'boundsStart'} ne '' )
        {
            $start = $this->bounds_to_datetime(
                $this->{'boundsStart'},
                $this->{'boundsStartUnit'},
                $this->{'boundsStartDirection'}
            );
            if (   $this->{'boundsStartUnit'} eq 'week'
                || $this->{'boundsStartUnit'} eq 'day' )
            {
                $start -= $sum;
            }
        }
        elsif ($this->{'boundsStartType'} eq 'abs'
            && $this->{'boundsStarty'} )
        {
            $start = $this->data_to_datetime(
                $this->{'boundsStartsec'}, $this->{'boundsStartmin'},
                $this->{'boundsStarth'},   $this->{'boundsStartd'},
                $this->{'boundsStartmon'}, $this->{'boundsStarty'}
            );
        }
    }
    if ( $this->{'boundsEndType'} ) {
        if (   $this->{'boundsEndType'} eq 'rel'
            && defined $this->{'boundsEnd'}
            && $this->{'boundsEnd'} ne '' )
        {
            $end = $this->bounds_to_datetime(
                $this->{'boundsEnd'},
                $this->{'boundsEndUnit'},
                $this->{'boundsEndDirection'}
            );
            if (   $this->{'boundsEndUnit'} eq 'week'
                || $this->{'boundsEndUnit'} eq 'day' )
            {
                $end -= $sum;
            }
        }
        elsif ( $this->{'boundsEndType'} eq 'abs' && $this->{'boundsEndy'} ) {
            $end = $this->data_to_datetime(
                $this->{'boundsEndsec'}, $this->{'boundsEndmin'},
                $this->{'boundsEndh'},   $this->{'boundsEndd'},
                $this->{'boundsEndmon'}, $this->{'boundsEndy'}
            );
        }
    }
    return ( $start, $end );
}

sub date_reset_tool ($$;$$) {
    my ( $this, $name, $f, $t ) = @_;
    $f = '' if !$f;
    my $form
        = ' <input type="button" class="tool" onclick="cmonos.element.item(\''
        . $name
        . $f . 'y\'';
    $form .= ',\'' . $name . $f . 'mon\'' if $this->{'inputLimit'} >= -1;
    $form .= ',\'' . $name . $f . 'd\''   if $this->{'inputLimit'} >= 0;
    $form .= ',\'' . $name . $f . 'h\''   if $this->{'inputLimit'} >= 1;
    $form .= ',\'' . $name . $f . 'min\'' if $this->{'inputLimit'} >= 2;
    $form .= ',\'' . $name . $f . 'sec\'' if $this->{'inputLimit'} >= 3;
    if ($t) {
        $form .= ',\'' . $name . $t . 'y\'';
        $form .= ',\'' . $name . $t . 'mon\'' if $this->{'inputLimit'} >= -1;
        $form .= ',\'' . $name . $t . 'd\'' if $this->{'inputLimit'} >= 0;
        $form .= ',\'' . $name . $t . 'h\'' if $this->{'inputLimit'} >= 1;
        $form .= ',\'' . $name . $t . 'min\'' if $this->{'inputLimit'} >= 2;
        $form .= ',\'' . $name . $t . 'sec\'' if $this->{'inputLimit'} >= 3;
    }
    $form .= ').reset();" value="&lsaquo; リセット" />';
    return $form;
}

sub resolve_into_values ($$) {
    my ( $this, $str ) = @_;
    if (   $$str
        && $$str
        =~ m!^([0-9]{4})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})!
        )
    {
        $main::data{ $this->{'id'} }{'y'}   = $1;
        $main::data{ $this->{'id'} }{'mon'} = $2;
        $main::data{ $this->{'id'} }{'d'}   = $3;
        $main::data{ $this->{'id'} }{'h'}   = $4;
        $main::data{ $this->{'id'} }{'min'} = $5;
        $main::data{ $this->{'id'} }{'sec'} = $6;
    }
}

sub date_check_script ($$$) {
    my ( $this, $name, $type ) = @_;
    $name .= 'default' if $type =~ s/^default//;
    return ( !$type || $this->{'inputLimit'} < 0 )
        ? ''
        : 'cmonos.validate.datetime.fix(\''
        . $type . '\'' . ',\''
        . $name
        . 'fy\',\''
        . $name
        . 'fmon\',\''
        . $name . 'fd\''
        . ( ( $this->{'inputLimit'} > 0 ) ? ',\'' . $name . 'fh\'' : ',\'\'' )
        . (
        ( $this->{'inputLimit'} > 1 ) ? ',\'' . $name . 'fmin\'' : ',\'\'' )
        . ',\''
        . $name
        . 'ty\',\''
        . $name
        . 'tmon\',\''
        . $name . 'td\''
        . ( ( $this->{'inputLimit'} > 0 ) ? ',\'' . $name . 'th\'' : ',\'\'' )
        . (
        ( $this->{'inputLimit'} > 1 ) ? ',\'' . $name . 'tmin\'' : ',\'\'' )
        . ');';
}

sub input_form ($$;$$$) {
    my ( $this, $p, $op, $setting, $invalidcheck ) = @_;
    my ( $form, $sec, $min, $h, $d, $mon, $y );
    $op = '' if !defined $op;
    my $name = $p . ':' . $this->{'id'} . ( ($setting) ? '_' : ':' ) . $op;
    my $func = $this->date_check_script(
        $p . ':' . $this->{'id'} . ( ($setting) ? '_' : ':' ), $op );
    my $onchange = ($func) ? ' onchange="' . $func . '"' : '';

    if ( defined $setting && $setting ) {
        ( $sec, $min, $h, $d, $mon, $y ) = (
            $this->{ $op . 'sec' },
            $this->{ $op . 'min' },
            $this->{ $op . 'h' },
            $this->{ $op . 'd' },
            $this->{ $op . 'mon' },
            $this->{ $op . 'y' }
        );
    }
    else {
        no strict "refs";
        ( $sec, $min, $h, $d, $mon, $y ) = (
            ${ 'main::' . $p }{ $this->{'id'} }{ $op . 'sec' },
            ${ 'main::' . $p }{ $this->{'id'} }{ $op . 'min' },
            ${ 'main::' . $p }{ $this->{'id'} }{ $op . 'h' },
            ${ 'main::' . $p }{ $this->{'id'} }{ $op . 'd' },
            ${ 'main::' . $p }{ $this->{'id'} }{ $op . 'mon' },
            ${ 'main::' . $p }{ $this->{'id'} }{ $op . 'y' }
        );
    }
    $this->fill( \$sec, \$min, \$h, \$d, \$mon, \$y );

    #年
    $form .= '<span class="date-selector"><label>';
    $form .= ' Year ' if defined $default::english && $default::english;
    if (   !defined $this->{'yearStart'}
        || $this->{'yearStart'} eq ''
        || !defined $this->{'yearEnd'}
        || $this->{'yearEnd'} eq ''
        || $this->{'yearEnd'} - $this->{'yearStart'} > 50
        || $this->{'yearEnd'} < $this->{'yearStart'} )
    {
        $form
            .= '<input type="number" size="4" maxlength="4" name="'
            . $name
            . 'y" id="'
            . $name
            . 'y" value="'
            . $y . '"'
            . ( ( $invalidcheck && $this->{'is_invalid_field'}{ $op . 'y' } )
            ? ' class="invalid-field" onchange="'
                . $func
                . 'cmonos.validate.field(this).bailOut()"'
            : $onchange )
            . ' />';
    }
    else {
        $form
            .= '<select name="'
            . $name
            . 'y" id="'
            . $name . 'y"'
            . ( ( $invalidcheck && $this->{'is_invalid_field'}{ $op . 'y' } )
            ? ' class="invalid-field" onchange="'
                . $func
                . 'cmonos.validate.field(this).bailOut()"'
            : $onchange )
            . '>';
        $form .= '<option value=""></option>';
        foreach my $year ( $this->{'yearStart'} .. $this->{'yearEnd'} ) {
            $form
                .= '<option value="'
                . $year . '"'
                . ( ( $y && $year == $y ) ? ' selected="selected"' : '' )
                . '>'
                . $year
                . '</option>';
        }
        $form .= '</select>';
    }
    $form .= ($default::english) ? '</label>, ' : '年</label>';

    return $form if $this->{'inputLimit'} < -1;

    #月
    my (@mon);
    if ( defined $defaut::english && $defaut::english ) {
        @mon = (
            '',       'January',   'February', 'March',
            'April',  'May',       'June',     'July',
            'August', 'September', 'October',  'November',
            'December'
        );
    }
    else {
        @mon = (
            '',  '1', '2',  '3',  '4', '5', '6', '7',
            '8', '9', '10', '11', '12'
        );
    }
    $form
        .= '<label><select name="'
        . $name
        . 'mon" id="'
        . $name . 'mon"'
        . ( ( $invalidcheck && $this->{'is_invalid_field'}{ $op . 'mon' } )
        ? ' class="invalid-field" onchange="'
            . $func
            . 'cmonos.validate.field(this).bailOut()"'
        : $onchange )
        . '>';
    $form .= '<option value=""></option>';
    foreach my $month ( 1 .. 12 ) {
        $form
            .= '<option value="'
            . $month . '"'
            . ( ( $mon && $month == $mon ) ? ' selected="selected"' : '' )
            . '>'
            . $mon[$month]
            . '</option>';
    }
    $form .= '</select>';
    $form .= ($default::english) ? '</label> ' : '月</label>';

    return $form if $this->{'inputLimit'} < 0;

    #日
    $form
        .= '<label><select name="'
        . $name
        . 'd" id="'
        . $name . 'd"'
        . ( ( $invalidcheck && $this->{'is_invalid_field'}{ $op . 'd' } )
        ? ' class="invalid-field" onchange="'
            . $func
            . 'cmonos.validate.field(this).bailOut()"'
        : $onchange )
        . '>';
    $form .= '<option value=""></option>';
    foreach my $day ( 1 .. 31 ) {
        $form
            .= '<option value="'
            . $day . '"'
            . ( ( $d && $day == $d ) ? ' selected="selected"' : '' ) . '>'
            . $day
            . '</option>';
    }
    $form .= '</select>';
    $form .= ($default::english) ? 'th</label>, ' : '日</label>';
    $form
        .= '<a href="javascript:void(0)" onclick="cmonos.tool.calendarPalette.open(\''
        . $name
        . 'y\',\''
        . $name
        . 'mon\',\''
        . $name . 'd\''
        . ( ($func) ? ',function () {' . $func . '}' : '' )
        . ')" title="クリックするとカレンダーから日付を設定できます。"><img src="'
        . $env::image_dir
        . '/tool/calendar.gif" width="15" height="15" border="0" alt="カレンダーパネル" /></a></span>';

    return $form if $this->{'inputLimit'} < 1;

    #時
    $form
        .= '<span class="time-selector"><label><select name="'
        . $name
        . 'h" id="'
        . $name . 'h"'
        . ( ( $invalidcheck && $this->{'is_invalid_field'}{ $op . 'h' } )
        ? ' class="invalid-field" onchange="'
            . $func
            . 'cmonos.validate.field(this).bailOut()"'
        : $onchange )
        . '>';
    $form .= '<option value=""></option>';
    $h = $this->{'hourStart'}
        if $h ne '' && $this->{'hourStart'} && $this->{'hourStart'} > $h;
    $h = $this->{'hourEnd'}
        if $h ne '' && $this->{'hourEnd'} && $this->{'hourEnd'} < $h;
    foreach my $hour (
        ( $this->{'hourStart'} || 0 ) .. ( $this->{'hourEnd'} || 23 ) )
    {
        $form
            .= '<option value="'
            . $hour . '"'
            . ( ( $h ne '' && $hour == $h ) ? ' selected="selected"' : '' )
            . '>'
            . $hour
            . '</option>';
    }
    $form .= '</select>';
    $form .= '時' if !$default::english;
    $form .= '</label>';

    return $form if $this->{'inputLimit'} < 2;
    $form .= ':' if $default::english;

    #分
    $form
        .= '<label><select name="'
        . $name
        . 'min" id="'
        . $name . 'min"'
        . ( ( $invalidcheck && $this->{'is_invalid_field'}{ $op . 'min' } )
        ? ' class="invalid-field" onchange="'
            . $func
            . 'cmonos.validate.field(this).bailOut()"'
        : $onchange )
        . '>';
    $form .= '<option value=""></option>';
    foreach my $minutes ( 0 .. 59 ) {
        if ( !$this->{'minScale'} || $minutes % $this->{'minScale'} == 0 ) {
            $form
                .= '<option value="'
                . $minutes . '"'
                . ( ( $min ne '' && $minutes == $min )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $minutes
                . '</option>';
        }
    }
    $form .= '</select>';
    $form .= '分' if !$default::english;
    $form .= '</label>';

    return $form if $this->{'inputLimit'} < 3;
    $form .= ':' if $default::english;

    #秒
    $form
        .= '<label><select name="'
        . $name
        . 'sec" id="'
        . $name . 'sec"'
        . ( ( $invalidcheck && $this->{'is_invalid_field'}{ $op . 'sec' } )
        ? ' class="invalid-field" onchange="'
            . $func
            . 'cmonos.validate.field(this).bailOut()"'
        : $onchange )
        . '>';
    $form .= '<option value=""></option>';
    foreach my $second ( 0 .. 59 ) {
        if ( !$this->{'minScale'} || $second % $this->{'minScale'} == 0 ) {
            $form
                .= '<option value="'
                . $second . '"'
                . ( ( $sec ne '' && $second == $sec )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $second
                . '</option>';
        }
    }
    $form .= '</select>';
    $form .= '秒' if !$default::english;
    $form .= '</label></span>';

    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    $this->resolve_into_values( \$main::data{ $this->{'id'} }{'str'} )
        if defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'};

    my ( $is_valid, $input ) = $this->is_valid_date;
    if ( $is_valid && $input ) {
        $main::data{ $this->{'id'} }{'str'} = $this->date_cat(
            $main::data{ $this->{'id'} }{'sec'},
            $main::data{ $this->{'id'} }{'min'},
            $main::data{ $this->{'id'} }{'h'},
            $main::data{ $this->{'id'} }{'d'},
            $main::data{ $this->{'id'} }{'mon'},
            $main::data{ $this->{'id'} }{'y'}
        );

        #必須項目チェック
    }
    elsif ( $this->{'required'} && $input == 0 ) {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( defined $this->{'name'} && $this->{'name'} )
                ? $this->{'name'} . 'が'
                : ''
                )
                . '入力されていません。'
        ) if ref $cgi::action;
        foreach ( 'sec', 'min', 'h', 'd', 'mon', 'y' ) {
            $this->{'is_invalid_field'}{$_} = 1
                if !defined $main::data{ $this->{'id'} }{$_}
                || $main::data{ $this->{'id'} }{$_} eq '';
        }
        $is_valid = 0;
    }

    $cookie::data{ 'data:' . $this->{'id'} . ':str' }
        = $main::data{ $this->{'id'} }{'str'}
        if $is_valid && $this->{'cookie'} && $main::set_cookie;
    return $is_valid;
}

sub is_valid_date ($;$$) {
    my ( $this, $op, $name ) = @_;
    my ($is_valid);
    $name     = '' if !defined $name;
    $is_valid = 1;
    $op       = '' if !defined $op;

    #数字チェック
    if ((      defined $main::data{ $this->{'id'} }{ $op . 'y' }
            && $main::data{ $this->{'id'} }{ $op . 'y' } ne ''
            && $this->is_nan( $main::data{ $this->{'id'} }{ $op . 'y' } )
        )
        || (   defined $main::data{ $this->{'id'} }{ $op . 'mon' }
            && $main::data{ $this->{'id'} }{ $op . 'mon' } ne ''
            && $this->is_nan( $main::data{ $this->{'id'} }{ $op . 'mon' } ) )
        || (   defined $main::data{ $this->{'id'} }{ $op . 'd' }
            && $main::data{ $this->{'id'} }{ $op . 'd' } ne ''
            && $this->is_nan( $main::data{ $this->{'id'} }{ $op . 'd' } ) )
        || (   defined $main::data{ $this->{'id'} }{ $op . 'h' }
            && $main::data{ $this->{'id'} }{ $op . 'h' } ne ''
            && $this->is_nan( $main::data{ $this->{'id'} }{ $op . 'h' } ) )
        || (   defined $main::data{ $this->{'id'} }{ $op . 'min' }
            && $main::data{ $this->{'id'} }{ $op . 'min' } ne ''
            && $this->is_nan( $main::data{ $this->{'id'} }{ $op . 'min' } ) )
        || (   defined $main::data{ $this->{'id'} }{ $op . 'sec' }
            && $main::data{ $this->{'id'} }{ $op . 'sec' } ne ''
            && $this->is_nan( $main::data{ $this->{'id'} }{ $op . 'sec' } ) )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                . $name
                . 'を確認してください。半角数字にしてください。'
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{ $op . 'y' } = 1;
        $is_valid = 0;
    }
    else {
        if (   defined $main::data{ $this->{'id'} }{ $op . 'h' }
            && $main::data{ $this->{'id'} }{ $op . 'h' } ne ''
            && ( $main::data{ $this->{'id'} }{ $op . 'h' }
                < ( $this->{'hourStart'} || 0 )
                || $main::data{ $this->{'id'} }{ $op . 'h' }
                > ( $this->{'hourEnd'} || 23 ) )
            )
        {
            $this->{'is_invalid_field'}{ $op . 'h' } = 1;
            $is_valid = 0;
        }
        if (   defined $main::data{ $this->{'id'} }{ $op . 'min' }
            && $main::data{ $this->{'id'} }{ $op . 'min' } ne ''
            && (   $main::data{ $this->{'id'} }{ $op . 'min' } < 0
                || $main::data{ $this->{'id'} }{ $op . 'min' } > 59 )
            )
        {
            $this->{'is_invalid_field'}{ $op . 'min' } = 1;
            $is_valid = 0;
        }
        if (   defined $main::data{ $this->{'id'} }{ $op . 'sec' }
            && $main::data{ $this->{'id'} }{ $op . 'sec' } ne ''
            && (   $main::data{ $this->{'id'} }{ $op . 'sec' } < 0
                || $main::data{ $this->{'id'} }{ $op . 'sec' } > 59 )
            )
        {
            $this->{'is_invalid_field'}{ $op . 'sec' } = 1;
            $is_valid = 0;
        }
    }

    #日付チェック
    if (   defined $main::data{ $this->{'id'} }{ $op . 'y' }
        && $main::data{ $this->{'id'} }{ $op . 'y' } ne ''
        && defined $main::data{ $this->{'id'} }{ $op . 'mon' }
        && $main::data{ $this->{'id'} }{ $op . 'mon' } ne ''
        && defined $main::data{ $this->{'id'} }{ $op . 'd' }
        && $main::data{ $this->{'id'} }{ $op . 'd' } ne ''
        && $this->is_impossible_mday(
            $main::data{ $this->{'id'} }{ $op . 'y' },
            $main::data{ $this->{'id'} }{ $op . 'mon' },
            $main::data{ $this->{'id'} }{ $op . 'd' }
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( defined $this->{'name'} ) ? $this->{'name'} : '入力' )
                . $name
                . 'を確認してください。存在しない日付です。'
        ) if ref $cgi::action;
        $main::data{ $this->{'id'} }{ $op . 'd' }
            = ( $main::data{ $this->{'id'} }{ $op . 'mon' } == 2 )
            ? (
            $this->is_leap_year( $main::data{ $this->{'id'} }{ $op . 'y' } ) )
                ? 29
                : 28
            : 30;
        $this->{'is_invalid_field'}{ $op . 'd' } = 1;
        $is_valid = 0;
    }

    #項目チェック
    my ( $input, $error ) = ( 0, 0 );
    $input++
        if defined $main::data{ $this->{'id'} }{ $op . 'y' }
        && $main::data{ $this->{'id'} }{ $op . 'y' } ne '';
    if ( $this->{'inputLimit'} > -2 ) {
        $input++
            if defined $main::data{ $this->{'id'} }{ $op . 'mon' }
            && $main::data{ $this->{'id'} }{ $op . 'mon' } ne '';
        if ( $this->{'inputLimit'} < 0 ) {
            $error = 1 if $input == 1;
        }
        else {
            $input++
                if defined $main::data{ $this->{'id'} }{ $op . 'd' }
                && $main::data{ $this->{'id'} }{ $op . 'd' } ne '';
            if ( $this->{'inputLimit'} < 1 ) {
                $error = 1 if $input < 3;
            }
            else {
                $input++
                    if defined $main::data{ $this->{'id'} }{ $op . 'h' }
                    && $main::data{ $this->{'id'} }{ $op . 'h' } ne '';
                if ( $this->{'inputLimit'} < 2 ) {
                    $error = 1 if $input < 4;
                }
                else {
                    $input++
                        if defined $main::data{ $this->{'id'} }{ $op . 'min' }
                        && $main::data{ $this->{'id'} }{ $op . 'min' } ne '';
                    if ( $this->{'inputLimit'} < 3 ) {
                        $error = 1 if $input < 5;
                    }
                    else {
                        $input++
                            if defined $main::data{ $this->{'id'} }
                            { $op . 'sec' }
                            && $main::data{ $this->{'id'} }{ $op . 'sec' } ne
                            '';
                        $error = 1 if $input < 6;
                    }
                }
            }
        }
    }

    if ( $input && $error ) {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( defined $this->{'name'} ) ? $this->{'name'} : '入力' )
                . $name
                . 'を確認してください。入力が不足しています。'
        ) if ref $cgi::action;
        $is_valid = $input = 0;
        foreach my $i ( 'sec', 'min', 'h', 'd', 'mon', 'y' ) {
            $this->{'is_invalid_field'}{ $op . $i } = 1
                if !defined $main::data{ $this->{'id'} }{ $op . $i }
                || $main::data{ $this->{'id'} }{ $op . $i } eq '';
        }
    }
    elsif (
        $main::data{ $this->{'id'} }{ $op . 'y' }
        && $this->is_out_of_bounds(
            $this->data_to_datetime(
                $main::data{ $this->{'id'} }{ $op . 'sec' },
                $main::data{ $this->{'id'} }{ $op . 'min' },
                $main::data{ $this->{'id'} }{ $op . 'h' },
                $main::data{ $this->{'id'} }{ $op . 'd' },
                $main::data{ $this->{'id'} }{ $op . 'mon' },
                $main::data{ $this->{'id'} }{ $op . 'y' }
            )
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( defined $this->{'name'} ) ? $this->{'name'} : '入力' )
                . $name
                . 'を確認してください。現在設定可能な日時は'
                . $this->bounds_to_message
                . 'です。'
        ) if ref $cgi::action;
        $is_valid = 0;
        foreach my $i ( 'sec', 'min', 'h', 'd', 'mon', 'y' ) {
            $this->{'is_invalid_field'}{ $op . $i } = 1;
        }
    }

    return ( $is_valid, $input );
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag('') if !defined $str || $str eq '';
    return $this->field_tag(
        $this->data_tag_from_hash( 'str', $str )
            . $this->style(
            $this->nobr_date( $this->field_date($str) ),
            $this->{'style'},     $this->{'fontsize'},
            $this->{'fontcolor'}, $this->{'fontface'}
            )
    );
}

sub field_date ($$;$$) {
    my ( $this, $time, $limit, $itemprop ) = @_;
    $time = substr( $time, 0, 8 + ( $this->{'inputLimit'} * 2 ) );
    $limit = $this->{'datelimit'}
        if ( !defined $limit || $limit eq '' )
        && defined $this->{'field_tag_enabled'}
        && $this->{'field_tag_enabled'} eq 'no';
    my $date = $this->date( $time, $limit, $this->{'datetype'},
        $this->{'dateformat'} );
    if ($itemprop) {
        my $tz
            = ( $ENV{'TZ'} && $ENV{'TZ'} =~ /([+\-][0-9]+)$/ ) ? $1 * -1 : 0;
        $tz = ($tz) ? sprintf( "%+.2d", $tz ) . ':00' : 'Z';
        $date
            = '<time itemprop="'
            . $itemprop
            . '" datetime="'
            . $1 . '-'
            . sprintf( "%.2d", ( $2 || 0 ) ) . '-'
            . sprintf( "%.2d", ( $3 || 0 ) )
            . ( ( $this->{'inputLimit'} > 0 )
            ? 'T'
                . sprintf( "%.2d", ( $4 || 0 ) ) . ':'
                . sprintf( "%.2d", ( $5 || 0 ) ) . ':'
                . sprintf( "%.2d", ( $6 || 0 ) )
                . $tz
            : '' )
            . '">'
            . $date
            . '</time>'
            if $time
            =~ /^([0-9]{4})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})/;
    }
    return $date;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    return
          '['
        . $this->name . "]\x0A"
        . $this->field_date( $str, 0 )
        . "\x0A\x0A";
}

#	(4)-3 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    return $this->field_date( $str, 0 );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    $this->{'inputLimit'} = '0' if !$this->{'inputLimit'};
    print '<fieldset>';
    print '<legend>入力欄設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_inputLimit">入力範囲</label></td>';
    print '<td class="field">';
    print '<span class="unit">年〜</span>';
    print $this->mk_select_menu(
        $name . '_inputLimit', '', '', $this->{'inputLimit'},
        '-2' => '年',
        '-1' => '月',
        '0'  => '日',
        '1'  => '時',
        '2'  => '分',
        '3'  => '秒'
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_datetype">表示形式</label></td>';
    print '<td class="field">';
    $this->print_date_type_menu( $name . '_',
        $this->{'datetype'}, '', '', 1, $this->{'dateformat'} );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">「年」選択範囲</span></td>';
    print '<td class="field">';
    print '<label><input type="number" size="4" maxlength="4" name="'
        . $name
        . '_yearStart" value="'
        . $this->escape( $this->{'yearStart'} )
        . '" /><span class="unit">年〜</span></label>';
    print '<label><input type="number" size="4" maxlength="4" name="'
        . $name
        . '_yearEnd" value="'
        . $this->escape( $this->{'yearEnd'} )
        . '" /><span class="unit">年</span></label>';
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">「時」指定範囲</span></td>';
    print '<td class="field">';
    print '<label><select name="'
        . $name
        . '_hourStart" id="'
        . $name
        . '_hourStart">';
    print '<option value=""></option>';

    foreach my $hour ( 0 .. 23 ) {
        print '<option value="'
            . $hour . '"'
            . (
            (          defined $this->{'hourStart'}
                    && $this->{'hourStart'} ne ''
                    && $hour == $this->{'hourStart'}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $hour
            . '</option>';
    }
    print '</select>時</label>〜';
    print '<label><select name="'
        . $name
        . '_hourEnd" id="'
        . $name
        . '_hourEnd">';
    print '<option value=""></option>';
    foreach my $hour ( 0 .. 23 ) {
        print '<option value="'
            . $hour . '"'
            . (
            (          defined $this->{'hourEnd'}
                    && $this->{'hourEnd'} ne ''
                    && $hour == $this->{'hourEnd'}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $hour
            . '</option>';
    }
    print '</select>時</label>';
    print '</td>';
    print '</tr>';
    print '<td class="field-name"><label for="' . $name
        . '_minScale">「分/秒」指定</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_minScale', '', '', $this->{'minScale'},
        ''   => '1分/秒きざみ',
        '5'  => '5分/秒きざみ',
        '10' => '10分/秒きざみ',
        '15' => '15分/秒きざみ',
        '20' => '20分/秒きざみ',
        '30' => '30分/秒きざみ',
    );
    print '</td>';
    print '</tr>';

    if ( !defined $default::static || !$default::static ) {
        print '<tr>';
        print '<td class="field-name"><label for="' . $name
            . '_datelimit">日時の表示</label></td>';
        print
            '<td class="field"><input type="number" size="3" maxlength="3" name="'
            . $name
            . '_datelimit" id="'
            . $name
            . '_datelimit" value="'
            . $this->escape( $this->{'datelimit'} )
            . '" /> 日以内なら相対日時で表現する（きょう/きのう/○日前）</td>';
        print '</tr>';
    }

    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_default">デフォルト</label></td>';
    print '<td class="field">';
    print $this->input_form( 'data', 'default', 1 );
    print $this->date_reset_tool( 'data:' . $this->{'id'} . '_', 'default' );
    print '<div class="extra-field"><label><input type="checkbox" name="'
        . $name
        . '_presentTime" value="1"'
        . ( ( defined $this->{'presentTime'} && $this->{'presentTime'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 書き込み時間をデフォルトにする</label></div>';
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';
    $this->print_validate_settings($name);

    if ( !defined $html_disabled || !$html_disabled ) {

        #検索オプション
        $this->print_search_option_settings($name);

        #文字設定
        $this->print_font_setting_form($name);
    }
    $this->print_setting_save_button;
    return;
}

sub print_validate_settings ($$) {
    my ( $this, $name ) = @_;
    print '<fieldset><legend>設定範囲</legend>';
    print '<fieldset><legend>下記以降</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="'
        . $name
        . '_boundsStartType" value=""'
        . ( ( !$this->{'boundsStartType'} ) ? ' checked="checked"' : '' )
        . ' /> 指定しない</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_boundsStartType" value="rel"'
        . (
        ( $this->{'boundsStartType'} && $this->{'boundsStartType'} eq 'rel' )
        ? ' checked="checked"'
        : '' )
        . ' /></label> ';
    print '<input type="number" size="3" maxlength="3" name="'
        . $name
        . '_boundsStart" value="'
        . $this->escape( $this->{'boundsStart'} )
        . '" onfocus="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_boundsStartType\',1).select()" />';
    print $this->mk_select_menu(
        $name . '_boundsStartUnit', '', '',
        ( $this->{'boundsStartUnit'} || 'day' ),
        'min'   => '分',
        'hour'  => '時間',
        'day'   => '日',
        'week'  => '週',
        'month' => 'ヶ月',
        'year'  => '年',
    );
    print $this->mk_select_menu(
        $name . '_boundsStartDirection', '', '',
        $this->{'boundsStartDirection'},
        'before' => '前',
        'after'  => '後',
    );
    print '</li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_boundsStartType" value="abs"'
        . (
        ( $this->{'boundsStartType'} && $this->{'boundsStartType'} eq 'abs' )
        ? ' checked="checked"'
        : '' )
        . ' /></label> ';
    print $this->input_form( 'data', 'boundsStart', 1 );
    print '</li>';
    print '</ol>';
    print '</fieldset>';
    print '<fieldset><legend>下記まで</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="'
        . $name
        . '_boundsEndType" value=""'
        . ( ( !$this->{'boundsEndType'} ) ? ' checked="checked"' : '' )
        . ' /> 指定しない</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_boundsEndType" value="rel"'
        . ( ( $this->{'boundsEndType'} && $this->{'boundsEndType'} eq 'rel' )
        ? ' checked="checked"'
        : '' )
        . ' /></label> ';
    print '<input type="number" size="3" maxlength="3" name="'
        . $name
        . '_boundsEnd" value="'
        . $this->escape( $this->{'boundsEnd'} )
        . '" onfocus="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_boundsEndType\',1).select()" />';
    print $this->mk_select_menu(
        $name . '_boundsEndUnit', '', '',
        ( $this->{'boundsEndUnit'} || 'day' ),
        'min'   => '分',
        'hour'  => '時間',
        'day'   => '日',
        'week'  => '週',
        'month' => 'ヶ月',
        'year'  => '年',
    );
    print $this->mk_select_menu(
        $name . '_boundsEndDirection', '', '', $this->{'boundsEndDirection'},
        'before' => '前',
        'after'  => '後',
    );
    print '</li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_boundsEndType" value="abs"'
        . ( ( $this->{'boundsEndType'} && $this->{'boundsEndType'} eq 'abs' )
        ? ' checked="checked"'
        : '' )
        . ' /></label> ';
    print $this->input_form( 'data', 'boundsEnd', 1 );
    print '</li>';
    print '</ol>';
    print '</fieldset>';
    $this->_print_validate_settings($name);
    print '</fieldset>';
}

sub _print_validate_settings ($$) {
    my ( $this, $name ) = @_;
    return;
}

sub print_search_option_settings ($$) {
    my ( $this, $name ) = @_;
    if ( !$default::static ) {
        print '<fieldset>';
        print '<legend><label for="' . $name
            . '_searchOption">検索設定</label></legend>';
        print $this->mk_select_menu(
            $name . '_searchOption', '', '', $this->{'searchOption'},
            '' => '期間を指定',
            'text' =>
                '期間を指定+テキストエリアに複数の期間を指定',
            'menu' => 'メニューから選択',
        );
        print '</fieldset>';
    }
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = $this->is_valid_date_setting;

    if (   defined $main::data{ $this->{'id'} . '_defaulty' }
        && $main::data{ $this->{'id'} . '_defaulty' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_defaulty' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'デフォルト年を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_defaulty' };
        $is_valid = 0;
    }

    #日付チェック
    if (   defined $main::data{ $this->{'id'} . '_defaulty' }
        && $main::data{ $this->{'id'} . '_defaulty' } ne ''
        && defined $main::data{ $this->{'id'} . '_defaultmon' }
        && $main::data{ $this->{'id'} . '_defaultmon' } ne ''
        && defined $main::data{ $this->{'id'} . '_defaultd' }
        && $main::data{ $this->{'id'} . '_defaultd' } ne ''
        && $this->is_impossible_mday(
            $main::data{ $this->{'id'} . '_defaulty' },
            $main::data{ $this->{'id'} . '_defaultmon' },
            $main::data{ $this->{'id'} . '_defaultd' }
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'デフォルトを更新できませんでした。存在しない日付です。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_defaulty' };
        delete $main::data{ $this->{'id'} . '_defaultmon' };
        delete $main::data{ $this->{'id'} . '_defaultd' };
        $is_valid = 0;
    }

    return $is_valid;
}

sub is_valid_date_setting ($) {
    my $this     = shift;
    my $is_valid = 1;

    #チェックボックス
    $main::data{ $this->{'id'} . '_searchOption' } = ''
        if !$main::data{ $this->{'id'} . '_searchOption' };
    $main::data{ $this->{'id'} . '_presentTime' } = 0
        if !$main::data{ $this->{'id'} . '_presentTime' };

    #数字チェック
    if (   defined $main::data{ $this->{'id'} . '_datelimit' }
        && $main::data{ $this->{'id'} . '_datelimit' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_datelimit' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '日時の表示設定を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_datelimit' };
        $is_valid = 0;
    }
    if ((      defined $main::data{ $this->{'id'} . '_yearStart' }
            && $main::data{ $this->{'id'} . '_yearStart' } ne ''
            && $this->is_nan( $main::data{ $this->{'id'} . '_yearStart' } )
        )
        || (   defined $main::data{ $this->{'id'} . '_yearEnd' }
            && $main::data{ $this->{'id'} . '_yearEnd' } ne ''
            && $this->is_nan( $main::data{ $this->{'id'} . '_yearEnd' } ) )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '「年」選択範囲を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_yearStart' };
        delete $main::data{ $this->{'id'} . '_yearEnd' };
        $is_valid = 0;
    }

    #フォントチェック
    $is_valid = 0 if !$this->is_valid_font_setting;

    if (   defined $main::data{ $this->{'id'} . '_hourStart' }
        && $main::data{ $this->{'id'} . '_hourStart' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_hourStart' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '「時」指定範囲の開始時を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_hourStart' };
        $is_valid = 0;
    }
    elsif (
           defined $main::data{ $this->{'id'} . '_hourStart' }
        && $main::data{ $this->{'id'} . '_hourStart' } ne ''
        && (   $main::data{ $this->{'id'} . '_hourStart' } < 0
            || $main::data{ $this->{'id'} . '_hourStart' } > 23 )
        )
    {
        delete $main::data{ $this->{'id'} . '_hourStart' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_hourEnd' }
        && $main::data{ $this->{'id'} . '_hourEnd' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_hourEnd' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '「時」指定範囲の終了時を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_hourEnd' };
        $is_valid = 0;
    }
    elsif (
           defined $main::data{ $this->{'id'} . '_hourEnd' }
        && $main::data{ $this->{'id'} . '_hourEnd' } ne ''
        && (   $main::data{ $this->{'id'} . '_hourEnd' } < 0
            || $main::data{ $this->{'id'} . '_hourEnd' } > 23 )
        )
    {
        delete $main::data{ $this->{'id'} . '_hourEnd' };
        $is_valid = 0;
    }
    if (   $main::data{ $this->{'id'} . '_hourStart' }
        && $main::data{ $this->{'id'} . '_hourEnd' }
        && $main::data{ $this->{'id'} . '_hourStart' }
        > $main::data{ $this->{'id'} . '_hourEnd' } )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '「時」指定範囲を確認してください。開始時が終了時より後になっています。'
        ) if ref $cgi::action;
        my $tmp = $main::data{ $this->{'id'} . '_hourEnd' };
        $main::data{ $this->{'id'} . '_hourEnd' }
            = $main::data{ $this->{'id'} . '_hourStart' };
        $main::data{ $this->{'id'} . '_hourStart' } = $tmp;
    }
    if (   defined $main::data{ $this->{'id'} . '_boundsStart' }
        && $main::data{ $this->{'id'} . '_boundsStart' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_boundsStart' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '設定範囲の開始日時を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_boundsStart' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_boundsEnd' }
        && $main::data{ $this->{'id'} . '_boundsEnd' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_boundsEnd' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '設定範囲の終了日時を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_boundsEnd' };
        $is_valid = 0;
    }
    my ( $start, $end );
    if ( $main::data{ $this->{'id'} . '_boundsStartType' } ) {
        if (   $main::data{ $this->{'id'} . '_boundsStartType' } eq 'rel'
            && defined $main::data{ $this->{'id'} . '_boundsStart' }
            && $main::data{ $this->{'id'} . '_boundsStart' } ne '' )
        {
            $start = $this->bounds_to_datetime(
                $main::data{ $this->{'id'} . '_boundsStart' },
                $main::data{ $this->{'id'} . '_boundsStartUnit' },
                $main::data{ $this->{'id'} . '_boundsStartDirection' }
            );
        }
        elsif ($main::data{ $this->{'id'} . '_boundsStartType' } eq 'abs'
            && $main::data{ $this->{'id'} . '_boundsStarty' } )
        {
            $start = $this->data_to_datetime(
                $main::data{ $this->{'id'} . '_boundsStartsec' },
                $main::data{ $this->{'id'} . '_boundsStartmin' },
                $main::data{ $this->{'id'} . '_boundsStarth' },
                $main::data{ $this->{'id'} . '_boundsStartd' },
                $main::data{ $this->{'id'} . '_boundsStartmon' },
                $main::data{ $this->{'id'} . '_boundsStarty' }
            );
        }
        else {
            $main::data{ $this->{'id'} . '_boundsStartType' } = '';
        }
    }
    if ( $main::data{ $this->{'id'} . '_boundsEndType' } ) {
        if (   $main::data{ $this->{'id'} . '_boundsEndType' } eq 'rel'
            && defined $main::data{ $this->{'id'} . '_boundsEnd' }
            && $main::data{ $this->{'id'} . '_boundsEnd' } ne '' )
        {
            $end = $this->bounds_to_datetime(
                $main::data{ $this->{'id'} . '_boundsEnd' },
                $main::data{ $this->{'id'} . '_boundsEndUnit' },
                $main::data{ $this->{'id'} . '_boundsEndDirection' }
            );
        }
        elsif ($main::data{ $this->{'id'} . '_boundsEndType' } eq 'abs'
            && $main::data{ $this->{'id'} . '_boundsEndy' } )
        {
            $end = $this->data_to_datetime(
                $main::data{ $this->{'id'} . '_boundsEndsec' },
                $main::data{ $this->{'id'} . '_boundsEndmin' },
                $main::data{ $this->{'id'} . '_boundsEndh' },
                $main::data{ $this->{'id'} . '_boundsEndd' },
                $main::data{ $this->{'id'} . '_boundsEndmon' },
                $main::data{ $this->{'id'} . '_boundsEndy' }
            );
        }
        else {
            $main::data{ $this->{'id'} . '_boundsEndType' } = '';
        }
    }
    if ( $start && $end && $start > $end ) {
        push(
            @{ $cgi::action->{'dialog'} },
            '日付と時刻の設定範囲を確認してください。開始日時が終了日時より後になっています。'
        ) if ref $cgi::action;
        $main::data{ $this->{'id'} . '_boundsStartType' } = '';
        $main::data{ $this->{'id'} . '_boundsEndType' }   = '';
    }
    if ($main::data{ $this->{'id'} . '_minScale' }
        && !grep( $_ eq $main::data{ $this->{'id'} . '_minScale' },
            5, 10, 15, 20, 30 )
        )
    {
        $main::data{ $this->{'id'} . '_minScale' } = '';
    }

    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    return $is_valid;
}

sub is_out_of_bounds ($$) {
    my ( $this, $dt ) = @_;
    return 1 if !$dt;
    my ( $start, $end ) = $this->get_datetime_bounds;
    if ( ( $start && $start > $dt ) || ( $end && $end < $dt ) ) {
        return 1;
    }
    else {
        return 0;
    }
}

sub bounds_to_message ($) {
    my $this = shift;
    my $msg  = '';
    if ( $this->{'boundsStartType'} ) {
        if (   $this->{'boundsStartType'} eq 'rel'
            && defined $this->{'boundsStart'}
            && $this->{'boundsStart'} ne '' )
        {
            $msg .= ' '
                . $this->bounds_to_dialog(
                $this->{'boundsStart'},
                $this->{'boundsStartUnit'},
                $this->{'boundsStartDirection'}
                ) . '以降 ';
        }
        elsif ($this->{'boundsStartType'} eq 'abs'
            && $this->{'boundsStarty'} )
        {
            $msg .= ' '
                . $this->date(
                [   $this->{'boundsStarty'},   $this->{'boundsStartmon'},
                    $this->{'boundsStartd'},   $this->{'boundsStarth'},
                    $this->{'boundsStartmin'}, $this->{'boundsStartsec'}
                ],
                10,
                $this->{'datetype'}
                ) . '以降 ';
        }
    }
    if ( $this->{'boundsEndType'} ) {
        if (   $this->{'boundsEndType'} eq 'rel'
            && defined $this->{'boundsEnd'}
            && $this->{'boundsEnd'} ne '' )
        {
            $msg .= ' '
                . $this->bounds_to_dialog(
                $this->{'boundsEnd'},
                $this->{'boundsEndUnit'},
                $this->{'boundsEndDirection'}
                ) . 'まで ';
        }
        elsif ( $this->{'boundsEndType'} eq 'abs' && $this->{'boundsEndy'} ) {
            $msg .= ' '
                . $this->date(
                [   $this->{'boundsEndy'},   $this->{'boundsEndmon'},
                    $this->{'boundsEndd'},   $this->{'boundsEndh'},
                    $this->{'boundsEndmin'}, $this->{'boundsEndsec'}
                ],
                10,
                $this->{'datetype'}
                ) . 'まで ';
        }
    }
    return $msg;
}

sub bounds_to_dialog ($$$$$) {
    my ( $this, $bounds, $bounds_unit, $bounds_direction ) = @_;
    if ( defined $bounds && $bounds ne '' ) {
        $bounds_unit = 'day' if !$bounds_unit;
        return
            ( !$bounds ) ? '現在'
            : $bounds
            . $this->timeunit_to_japanese($bounds_unit)
            . ( ( $bounds_direction && $bounds_direction eq 'before' ) ? '前'
            : '後' );
    }
    return '';
}

sub timeunit_to_japanese ($$) {
    my ( $this, $unit ) = @_;
    if ( $unit eq 'min' ) {
        $unit = '分';
    }
    elsif ( $unit eq 'hour' ) {
        $unit = '時間';
    }
    elsif ( $unit eq 'month' ) {
        $unit = 'ヶ月';
    }
    elsif ( $unit eq 'year' ) {
        $unit = '年';
    }
    elsif ( $unit eq 'week' ) {
        $unit = '週';
    }
    else {
        $unit = '日';
    }
    return $unit;
}

sub data_to_datetime ($$$$$$$) {
    my ( $this, $sec, $min, $h, $d, $m, $y ) = @_;
    return timelocal(
        ( $sec || 0 ),
        ( $min || 0 ),
        ( $h   || 0 ),
        ( $d   || 1 ),
        ( ( $m || 1 ) - 1 ), $y,
    );
}

sub bounds_to_datetime ($$$$) {
    my ( $this, $bounds, $bounds_unit, $bounds_direction ) = @_;
    if ( defined $bounds && $bounds ne '' ) {
        $bounds = $this->timeunit_to_sec( $bounds, $bounds_unit );
        if ( $bounds_direction && $bounds_direction eq 'before' ) {
            return time - $bounds;
        }
        else {
            return time + $bounds;
        }
    }
    return 0;
}

sub timeunit_to_sec ($$$) {
    my ( $this, $t, $unit ) = @_;
    if ( defined $t && $t ne '' ) {
        $unit = 'day' if !$unit;
        if ( $unit eq 'min' ) {
            $t *= 60;
        }
        elsif ( $unit eq 'hour' ) {
            $t *= 3600;
        }
        elsif ( $unit eq 'month' ) {
            $t *= 2592000;
        }
        elsif ( $unit eq 'year' ) {
            $t *= 31536000;
        }
        elsif ( $unit eq 'week' ) {
            $t *= 604800;
        }
        else {
            $t *= 86400;
        }
        return $t;
    }
    return 0;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
    my $this = shift;

    my $form = '<tr><td class="field-name">';
    if ( defined $this->{'searchOption'} && $this->{'searchOption'} ) {
        $form
            .= '<label for="search:'
            . $this->{'id'}
            . ':str">'
            . $this->{'name'}
            . '</label>';
    }
    else {
        $form .= '<span class="datatitle">' . $this->{'name'} . '</span>';
    }
    $form .= '</td><td class="field">';
    if ( $this->{'searchOption'} && $this->{'searchOption'} eq 'menu' ) {
        $form
            .= '<select name="search:'
            . $this->{'id'}
            . ':within" id="search:'
            . $this->{'id'}
            . ':within">';
        $form .= '<option value=""></option>';
        if ( $this->{'inputLimit'} >= 1 ) {
            $form .= '<option value="86400"'
                . (
                (          $main::search{ $this->{'id'} }{'within'}
                        && $main::search{ $this->{'id'} }{'within'} eq '86400'
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . ( ( !$default::english )
                ? '24時間以内'
                : 'within 24 hours.' )
                . '</option>';
            $form .= '<option value="17280"'
                . (
                (          $main::search{ $this->{'id'} }{'within'}
                        && $main::search{ $this->{'id'} }{'within'} eq '17280'
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . ( ( !$default::english )
                ? '48時間以内'
                : 'within 48 hours.' )
                . '</option>';
        }
        if ( $this->{'inputLimit'} >= 0 ) {
            $form .= '<option value="259200"'
                . (
                (          $main::search{ $this->{'id'} }{'within'}
                        && $main::search{ $this->{'id'} }{'within'} eq
                        '259200'
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . ( ( !$default::english ) ? '3日以内' : 'within 3 days.' )
                . '</option>';
            $form .= '<option value="604800"'
                . (
                (          $main::search{ $this->{'id'} }{'within'}
                        && $main::search{ $this->{'id'} }{'within'} eq
                        '604800'
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . (
                ( !$default::english ) ? '1週間以内' : 'within 1 week.' )
                . '</option>';
            $form .= '<option value="1209600"'
                . (
                (          $main::search{ $this->{'id'} }{'within'}
                        && $main::search{ $this->{'id'} }{'within'} eq
                        '1209600'
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . (
                ( !$default::english ) ? '2週間以内' : 'within 2 weeks.' )
                . '</option>';
            $form .= '<option value="2592000"'
                . (
                (          $main::search{ $this->{'id'} }{'within'}
                        && $main::search{ $this->{'id'} }{'within'} eq
                        '2592000'
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . (
                ( !$default::english ) ? '1ヶ月以内' : 'within 1 month.' )
                . '</option>';
            $form .= '<option value="7862400"'
                . (
                (          $main::search{ $this->{'id'} }{'within'}
                        && $main::search{ $this->{'id'} }{'within'} eq
                        '7862400'
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . ( ( !$default::english )
                ? '3ヶ月以内'
                : 'within 3 months.' )
                . '</option>';
        }
        if ( $this->{'inputLimit'} >= -1 ) {
            $form .= '<option value="15768000"'
                . (
                (          $main::search{ $this->{'id'} }{'within'}
                        && $main::search{ $this->{'id'} }{'within'} eq
                        '15768000'
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . (
                ( !$default::english ) ? '半年以内' : 'within 6 months.' )
                . '</option>';
            $form .= '<option value="1"'
                . (
                (          $main::search{ $this->{'id'} }{'within'}
                        && $main::search{ $this->{'id'} }{'within'} eq '1'
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . ( ( !$default::english ) ? '1年以内' : 'within 1 year.' )
                . '</option>';
        }
        $form .= '<option value="3"'
            . (
            (          $main::search{ $this->{'id'} }{'within'}
                    && $main::search{ $this->{'id'} }{'within'} eq '3'
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . ( ( !$default::english ) ? '3年以内' : 'within 3 years.' )
            . '</option>';
        $form .= '<option value="5"'
            . (
            (          $main::search{ $this->{'id'} }{'within'}
                    && $main::search{ $this->{'id'} }{'within'} eq '5'
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . ( ( !$default::english ) ? '5年以内' : 'within 5 years.' )
            . '</option>';
        $form .= '<option value="10"'
            . (
            (          $main::search{ $this->{'id'} }{'within'}
                    && $main::search{ $this->{'id'} }{'within'} eq '10'
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . ( ( !$default::english ) ? '10年以内' : 'within 10 years.' )
            . '</option>';
        if ( $this->{'inputLimit'} <= -1 ) {
            $form .= '<option value="15"'
                . (
                (          $main::search{ $this->{'id'} }{'within'}
                        && $main::search{ $this->{'id'} }{'within'} eq '15'
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . (
                ( !$default::english ) ? '15年以内' : 'within 15 years.' )
                . '</option>';
            $form .= '<option value="20"'
                . (
                (          $main::search{ $this->{'id'} }{'within'}
                        && $main::search{ $this->{'id'} }{'within'} eq '20'
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . (
                ( !$default::english ) ? '20年以内' : 'within 20 years.' )
                . '</option>';
            $form .= '<option value="25"'
                . (
                (          $main::search{ $this->{'id'} }{'within'}
                        && $main::search{ $this->{'id'} }{'within'} eq '25'
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . (
                ( !$default::english ) ? '25年以内' : 'within 25 years.' )
                . '</option>';
            $form .= '<option value="30"'
                . (
                (          $main::search{ $this->{'id'} }{'within'}
                        && $main::search{ $this->{'id'} }{'within'} eq '30'
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . (
                ( !$default::english ) ? '30年以内' : 'within 30 years.' )
                . '</option>';
        }
        $form .= '</select>';
    }
    else {
        my $key = $this->escape( $main::search{ $this->{'id'} }{'str'} );
        $form .= '<div class="sub-field"><label>';
        $form .= '<span class="unit">From </span>'
            if defined $default::english && $default::english;
        $form .= $this->input_form( 'search', 'f' );
        $form .= '<span class="unit">から</span>'
            if !defined $default::english || !$default::english;
        $form .= '</label></div>';
        $form .= '<div class="sub-field"><label>';
        $form .= '<span class="unit">To </span>'
            if defined $default::english && $default::english;
        $form .= $this->input_form( 'search', 't' );
        $form .= '<span class="unit">まで</span>'
            if !defined $default::english || !$default::english;
        $form .= '</label>';
        $form .= $this->date_reset_tool( 'search:' . $this->{'id'} . ':',
            'f', 't' );
        $form .= '</div>';

        if ( $this->{'searchOption'} && $this->{'searchOption'} ne 'menu' ) {

            #英語表記
            if ( defined $default::english && $default::english ) {
                $form
                    .= '<div class="sub-field"><input type="text" size="30" name="search:'
                    . $this->{'id'}
                    . ':str" value="'
                    . $key . '" />';
                $form .= $this->mk_select_menu(
                    'search:' . $this->{'id'} . ':mode', '', '',
                    $main::search{ $this->{'id'} }{'mode'},
                    'and' => 'Matches on all',
                    'or'  => 'Matches on any'
                );
                $form .= '</div>';
                $form
                    .= '<div class="note">year[4]/month/day/hour:min:sec</div>';
                $form
                    .= '<div class="note">ex) 2001/1/1/0:00:00-2001/4/1/0:00:00</div>';

                #日本語
            }
            else {
                $form
                    .= '<div class="sub-field"><input type="text" size="30" name="search:'
                    . $this->{'id'}
                    . ':str" value="'
                    . $key . '" />';
                $form .= $this->mk_select_menu(
                    'search:' . $this->{'id'} . ':mode', '', '',
                    $main::search{ $this->{'id'} }{'mode'},
                    'and' => '全ての条件に一致',
                    'or'  => 'いずれかの条件に一致'
                );
                $form .= '</div>';
                $form
                    .= '<div class="note">年[4桁]/月/日/時:分:秒（複数の場合スペースで区切ります）</div>';
                $form
                    .= '<div class="note">"-"で期間を指定できます（2000/1/1/0:00:00-2001/1/1/0:00:00）。</div>';
            }
        }
    }
    $form .= $this->additional_search_form;
    $form .= '</td></tr>';

    return $form;
}

sub additional_search_form ($) {
    my $this = shift;
    return '';
}

######################################################################
#	sample
sub sample ($$) {
    my ( $this, $str ) = @_;
    return ( defined $str ) ? $str : '';
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'time_date', 'Date', '日時' );
}

1;
