package LinkToCalendar;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# フィールドモジュール（カレンダーリンク）
# LinkToCalendar.pm 1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-06-28
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'label'} = 'カレンダーを開く' if !$this->{'label'};
    return;
}

######################################################################
#	(2) obj->input_enabled;
sub form {
    my ( $this, $status, $original ) = @_;
    return '' if !$this->{'dir'};
    my ( $dir, $cat ) = split( /\//, $this->{'dir'} );
    my $cal = $this->cal_settings( $dir, $cat, 1 );
    if ( ref $cal && %$cal ) {
        my $form    = '';
        my @checked = ();
        if (   $main::data{ $this->{'id'} }{'str'}
            && !ref $main::data{ $this->{'id'} }{'str'}
            && $main::data{ $this->{'id'} }{'str'} =~ /,/ )
        {
            @checked = split( /,/, $main::data{ $this->{'id'} }{'str'} );
        }
        elsif ( defined $main::data{ $this->{'id'} }{'str'} ) {
            @checked
                = ( ref $main::data{ $this->{'id'} }{'str'} )
                ? @{ $main::data{ $this->{'id'} }{'str'} }
                : ( $main::data{ $this->{'id'} }{'str'} );
        }
        if ( ref $cal->{'eventcategory_order'}
            && @{ $cal->{'eventcategory_order'} } > 1 )
        {
            foreach my $e ( @{ $cal->{'eventcategory_order'} } ) {
                $form
                    .= '<li><label><input type="checkbox" name="data:'
                    . $this->{'id'}
                    . ':str" id="data:'
                    . $this->{'id'}
                    . ':str" value="'
                    . $e . '"'
                    . ( ( grep( $_ eq $e, @checked ) )
                    ? ' checked="checked"'
                    : '' )
                    . ' /> '
                    . $cal->{'eventcategory'}{$e}
                    . '</label></li>';
            }
        }
        else {
            $form
                .= '<li><label><input type="checkbox" name="data:'
                . $this->{'id'}
                . ':str" id="data:'
                . $this->{'id'}
                . ':str" value="all"'
                . ( ( grep( $_ eq 'all', @checked ) )
                ? ' checked="checked"'
                : '' )
                . ' /> '
                . $cal->{'name'}
                . '</label></li>';
        }
        return ($form)
            ? $this->field_header
            . '<ol class="checkbox">'
            . $form . '</ol>'
            . $this->field_footer
            : '';
    }
    return '';
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my ( $this, $path ) = @_;
    if ( defined $main::data{ $this->{'id'} }{'str'} ) {
        no warnings qw(numeric);
        my ( $dir, $cat ) = split( /\//, $this->{'dir'} );
        my $cal = $this->cal_settings( $dir, $cat, 1 );
        my @categories = ();
        if ( ref $cal && %$cal ) {
            my @e
                = ( ref $main::data{ $this->{'id'} }{'str'} )
                ? @{ $main::data{ $this->{'id'} }{'str'} }
                : ( $main::data{ $this->{'id'} }{'str'} =~ /,/ ) ?
                split( /,/, $main::data{ $this->{'id'} }{'str'} )
                : ( $main::data{ $this->{'id'} }{'str'} );
            foreach my $c (@e) {
                push( @categories, $c )
                    if $c eq 'all' || $cal->{'eventcategory'}{$c};
            }
        }
        $main::data{ $this->{'id'} }{'str'}
            = (@categories)
            ? join( ',', sort { $a <=> $b || $a cmp $b } @categories )
            : '';
    }
    if ( $this->{'cookie'} && $main::set_cookie ) {
        $cookie::data{ 'data:' . $this->{'id'} . ':str' }
            = $main::data{ $this->{'id'} }{'str'} || '';
    }
    return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    my $url = $this->calendar_link($str);
    if ( $this->{'button'} ) {
        $this->use_deco($cgi::output);
        return $this->field_tag(
            $this->data_tag_from_hash( 'str', $str )
                . $cgi::Deco->button(
                'jump',
                $this->{'button'},
                $url,
                $this->{'label'},
                ( ( $this->{'newWindow'} ) ? '_blank' : '' ),
                '',
                $cgi::output_option
                )
        );

    }
    else {
        $url = $this->base_change( $url, $cgi::output, $cgi::output_option )
            if $cgi::output || $cgi::output_option;
        return $this->field_tag(
            $this->data_tag_from_hash( 'str', $str )
                . $this->style(
                '<a href="'
                    . $this->escape_except_html_entity($url)
                    . '" title="'
                    . $this->detag_text( $this->{'label'} ) . '"'
                    . ( ( $this->{'newWindow'} ) ? ' target="_blank"' : '' )
                    . '>'
                    . $this->{'label'} . '</a>',
                $this->{'style'},     $this->{'fontsize'},
                $this->{'fontcolor'}, $this->{'fontface'}
                )
        );
    }
}

sub calendar_link ($$$) {
    my ( $this, $str ) = @_;
    my ( $dir, $cat ) = split( /\//, $this->{'dir'} );
    $str = join( ',', @$str ) if ref $str;
    if ( $str && $str eq 'all' ) {
        return
              '../'
            . $dir
            . '/start.cgi'
            . ( ( defined $cat && $cat ne '' ) ? '?c=' . $cat : '' );
    }
    else {
        return
              '../'
            . $dir
            . '/start.cgi'
            . ( ( defined $cat && $cat ne '' ) ? '?c=' . $cat . '&' : '?' )
            . ( ( defined $str ) ? 'event_category=' . $str : '' );
    }
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ( !defined $str || $str eq '' )
        ? ''
        : '['
        . $this->name . "]\x0A"
        . $this->id_to_name($str) . "\x0A"
        . $this->full_path( $this->calendar_link($str) )
        . "\x0A\x0A";
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ( !defined $str || $str eq '' )
        ? ''
        : $this->id_to_name($str) . ' - '
        . $this->full_path( $this->calendar_link($str) );
}

sub id_to_name ($$) {
    my ( $this, $str ) = @_;
    my @categories = split( /,/, $str );
    my ( $dir, $cat ) = split( /\//, $this->{'dir'} );
    my $cal = $this->cal_settings( $dir, $cat, 1 );
    return ( ref $cal && %$cal )
        ? join(
        ', ',
        grep( $_ ne '',
            ( map { $cal->{'eventcategory'}{$_} || '' } split( /,/, $str ) ) )
        )
        : '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return 1;
}

sub confirmation ($$) {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ( !defined $str || $str eq '' )
        ? ''
        : '<a href="'
        . $this->calendar_link($str)
        . '" target="_blank">'
        . ( $this->id_to_name($str) || $this->{'label'} ) . '</a>';
}

######################################################################
#	(5) obj->print_setting_form;
sub cal_settings ($$$;$) {
    my ( $this, $dir, $category, $eventcategory_required ) = @_;
    my $path = "../$dir/default.pl";
    my $data = $this->read_file($path);
    if ( $data =~ /\$lib\s*=\s*['"]Calendar['"]/s ) {
        my $preference_dir
            = ( $data =~ /\$preference_dir\s*=\s*(.*?);/s )
            ? $this->un_base_change( eval $1, $path, 'rel', 1 )
            : '';
        my $field_pref_dir
            = ( $data =~ /\$field_pref_dir\s*=\s*(.*?);/s )
            ? $this->un_base_change( eval $1, $path, 'rel', 1 )
            : '';
        my $subdivided = ( $data =~ /\$subdivided\s*=\s*1;/s ) ? 1 : 0;
        my @settings   = ();
        my $name       = '';
        if ($subdivided) {
            my (%db);
            tie( %db, $env::dbm_file, $preference_dir . '/general',
                O_RDONLY, $env::dbm_mode );
            if ( ref tied %db && defined $db{'cginame'} ) {
                $name = $this->decode_utf8( $db{'cginame'} );
            }
            untie %db;
            my @categories;
            if ($category) {
                @categories = ($category);
            }
            elsif ( opendir( DIR, $preference_dir ) ) {
                @categories = grep( $_ !~ /^\./ && -d "$preference_dir/$_",
                    readdir(DIR) );
            }
            foreach my $c (@categories) {
                my $c_preference_dir
                    = ( ( defined $preference_dir && $preference_dir ne '' )
                    ? $preference_dir
                    : '.' )
                    . '/'
                    . $c;
                if ( -d $c_preference_dir ) {
                    my $c_field_pref_dir = $field_pref_dir;
                    $c_field_pref_dir .= '/' . $c
                        unless $c_field_pref_dir
                        =~ s!^$preference_dir/!$c_preference_dir/!;
                    my $default
                        = $this->_cal_settings( $dir, $c, $c_preference_dir,
                        $c_field_pref_dir, $eventcategory_required, $name );
                    push( @settings, $default ) if ref $default && %$default;
                }
            }
            return (wantarray) ? @settings : $settings[0];
        }
        else {
            my $default = $this->_cal_settings( $dir, '', $preference_dir,
                $field_pref_dir, $eventcategory_required );
            return
                  (wantarray)
                ? ( ref $default && %$default )
                    ? ($default)
                    : ()
                : $default;
        }
    }
    return (wantarray) ? () : {};
}

sub _cal_settings ($$$$$;$$) {
    my ( $this, $dir, $c, $preference_dir, $field_pref_dir,
        $eventcategory_required, $name )
        = @_;
    my %default;
    $default{'name'} = $default{'dir'} = $dir . ( ($c) ? '/' . $c : '' );
    my ( %db, $eventcategory_id );
    tie( %db, $env::dbm_file, $preference_dir . '/general',
        O_RDONLY, $env::dbm_mode );
    if ( ref tied %db && defined $db{'cginame'} ) {
        $default{'name'} = ( ($name) ? $name . '/' : '' )
            . $this->decode_utf8( $db{'cginame'} );
    }
    untie %db;
    tie( %db, $env::dbm_file, $field_pref_dir . '/inputfield',
        O_RDONLY, $env::dbm_mode );
    if ( ref tied %db ) {

        #$default{'mailid'} = $this->decode_utf8($db{'for_mail'});
        while ( my ( $k, $v ) = each %db ) {
            if ( $v eq 'xcal_category' && $k =~ /^([0-9]+)_class$/ ) {
                $eventcategory_id = $1;
                last;
            }
        }
    }
    untie %db;
    if ( $eventcategory_id && $eventcategory_required ) {
        $default{'eventcategory'} = {};
        my %event_category;
        $this->import_db( $preference_dir . '/event_category',
            \%event_category, 1 );
        $default{'eventcategory_order'} = [];
        foreach
            my $i ( sort { $a <=> $b } keys %{ $event_category{'ORDER'} } )
        {
            my $id = $event_category{'ORDER'}{$i};
            push( @{ $default{'eventcategory_order'} }, $id );
            $default{'eventcategory'}{$id}
                = $event_category{$id}{'name'} || $id;
        }
    }
    return \%default;
}

sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my ( $name, @cal );
    local (*DIR);
    if ( opendir( DIR, "../" ) ) {
        my @dir = grep( $_ !~ /^\./ && -d "../$_" && -f "../$_/default.pl",
            readdir(DIR) );
        closedir(DIR);
        if (@dir) {
            use Fcntl qw(:DEFAULT);
            eval 'use ' . $env::dbm_file . ';';
            foreach my $d (@dir) {
                push( @cal, $this->cal_settings($d) );
            }
        }
    }

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);
    print '<fieldset>';
    print '<legend>対象カレンダー</legend>';
    if (@cal) {
        print '<select name="'
            . $name
            . '_dir" id="'
            . $name
            . '_dir"><option value=""></option>';
        foreach my $i (@cal) {
            print '<option value="'
                . $i->{'dir'} . '"'
                . ( ( $this->{'dir'} && $i->{'dir'} eq $this->{'dir'} )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $i->{'name'}
                . '</option>';
        }
        print '</select>';
    }
    else {
        print
            '<p class="note">カレンダーがみつかりません。</p>';
    }
    print '</fieldset>';

    if ( !defined $html_disabled || !$html_disabled ) {

        print '<fieldset>';
        print '<legend>リンク設定</legend>';

        print '<fieldset>';
        print '<legend><label for="' . $name
            . '_label">リンクラベル</label></legend>';
        print '<input type="text" name="'
            . $name
            . '_label" id="'
            . $name
            . '_label" value="'
            . $this->escape( $this->{'label'} )
            . '" size="50" />';
        print '</fieldset>';

        print '<fieldset>';
        print '<legend>ウィンドウ</legend>';
        print '<label><input type="checkbox" name="'
            . $name
            . '_newWindow" value="1"'
            . ( ( defined $this->{'newWindow'} && $this->{'newWindow'} )
            ? ' checked="checked"'
            : '' )
            . ' /> 新しいウィンドウで開く</label>';
        print '</fieldset>';

        #ボタンメニュー
        print
            '<fieldset><legend title="設定がない場合、URLが表示されます。">ボタン</legend>';
        $this->use_deco();
        print $cgi::Deco->button_menu( $name . '_button',
            'jump', 120, $this->{'button'} );
        print '</fieldset>';
        print '</fieldset>';

        #文字設定
        $this->print_font_setting_form($name);
    }
    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;
    if ( $main::data{ $this->{'id'} . '_dir' } ) {
        my $default = $this->cal_settings(
            split( /\//, $main::data{ $this->{'id'} . '_dir' } ) );
        delete $main::data{ $this->{'id'} . '_dir' }
            if !ref $default || !%$default;
    }
    $this->tag_fix( \$main::data{ $this->{'id'} . '_label' } )
        if defined $main::data{ $this->{'id'} . '_label' }
        && $main::data{ $this->{'id'} . '_label' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_newWindow' } = ''
        if !$main::data{ $this->{'id'} . '_newWindow' };
    $is_valid = 0 if !$this->is_valid_font_setting;
    return $is_valid;
}

######################################################################
#	(7) obj->search_form;
sub search_form_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'z_callink', 'LinkToCalendar',
        'カレンダーリンク' );
    $setting::deco_dir{'jump'}  = 'ジャンプボタン';
    $setting::deco_type{'jump'} = 'button';
}

1;
