package Number;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（番号）
# Num.pm 1.1.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-10-17
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'format'} = '4'
        if !defined $this->{'format'} || $this->{'format'} eq '';
    $this->scalar_to_array( \$this->{'placeholder'} )
        if defined $this->{'placeholder'} && !ref $this->{'placeholder'};
    $this->{'inputtype'} = ''
        if $this->{'inputtype'}
        && $this->{'inputtype'} ne 'number'
        && $this->{'inputtype'} ne 'tel';
    return;
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my ($form);

    #デフォルト作成
    $main::data{ $this->{'id'} }{'str'} = (
        ( !defined $status || $status eq '' )
            && ( !defined $main::data{ $this->{'id'} }{'str'}
            || $main::data{ $this->{'id'} }{'str'} eq '' )
            && defined $this->{'default'}
        ) ? $this->{'default'}
        : ( defined $main::data{ $this->{'id'} }{'str'} )
        ? $main::data{ $this->{'id'} }{'str'}
        : '';
    my (@numbers);
    push( @numbers, ( ( $1 eq "\x09" ) ? '' : $1 ) )
        while $main::data{ $this->{'id'} }{'str'} =~ /([\x090-9]+)/g;

    my $count  = 0;
    my $prefix = 'data:' . $this->{'id'} . ':';
    $form = $this->escape( $this->{'format'} );
    $form =~ s/([0-9]+)/$this->num_form($prefix,\@numbers,$1,\$count)/eg;

    return $this->field_header . $form . $this->field_footer;
}

sub num_form ($$$$$;$) {
    my ( $this, $prefix, $numbers, $size, $count, $not_form ) = @_;
    my $num = ( ref $numbers && @$numbers ) ? shift(@$numbers) : '';
    $size = 4 if !defined $size || !$size;
    my $form
        = '<input type="'
        . ( ( $this->{'inputtype'} ) ? $this->{'inputtype'} : 'text' )
        . '" name="'
        . $prefix
        . $$count
        . '" size="'
        . $size
        . '" value="'
        . $this->escape($num) . '"'
        . (
        (          !$not_form
                && defined $this->{'placeholder'}[$$count]
                && $this->{'placeholder'}[$$count] ne ''
        ) ? ' placeholder="'
            . $this->lf_to_space(
            $this->escape( $this->{'placeholder'}[$$count] )
            )
            . '"' : ''
        )
        . (
        (   !$not_form
                && ( $this->{'is_invalid_field'}{'str'}
                || $this->{'is_invalid_field'}{$$count} )
        ) ? $this->set_invalid_class : ''
        )
        . (
        (         !$not_form
                && $this->{'required'}
                && ( $this->{'requiredAll'} || $this->{'justsize'} )
        ) ? ' required="required"' : ''
        ) . ' />';
    $$count++;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this     = shift;
    my $is_valid = 1;
    my $count    = 0;
    my $exist    = 0;
    my @dialogs  = ();
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    $this->{'format'} =~ s/[\x09]//g;
    if (  !$main::data{ $this->{'id'} }{'0'}
        && $main::data{ $this->{'id'} }{'str'} )
    {
        my $c = 0;
        while ( $main::data{ $this->{'id'} }{'str'} =~ /([0-9]+)/g ) {
            $main::data{ $this->{'id'} }{$c} = $1;
            $c++;
        }
    }
    ( $main::data{ $this->{'id'} }{'str'} = $this->{'format'} )
        =~ s/([0-9]+)/$this->format_to_number($1,\$count,\$is_valid,\@dialogs,\$exist)/eg;
    if ($exist) {
        push( @{ $cgi::action->{'dialog'} }, @dialogs );
    }
    else {
        undef %{ $this->{'is_invalid_field'} };
        undef @dialogs;
        $is_valid = 1;
        $main::data{ $this->{'id'} }{'str'} = '';
    }
    $is_valid = 0 unless $this->is_not_empty('str');
    $cookie::data{ 'data:' . $this->{'id'} . ':str' }
        = $main::data{ $this->{'id'} }{'str'}
        if $is_valid && $this->{'cookie'} && $main::set_cookie;
    return $is_valid;
}

sub format_to_number ($$$$$$) {
    my ( $this, $size, $count, $is_valid, $dialogs, $exist ) = @_;
    my $num = '';
    $main::data{ $this->{'id'} }{$$count} = ''
        if !defined $main::data{ $this->{'id'} }{$$count};
    $main::data{ $this->{'id'} }{$$count} =~ s/[\x09\x0A\x0C\x0D\x20]+//g;
    $main::data{ $this->{'id'} }{$$count}
        = $this->z_to_h( $main::data{ $this->{'id'} }{$$count} )
        if $main::data{ $this->{'id'} }{$$count} =~ /[^0-9a-zA-Z_]/;

    #入力強制
    if (   $this->{'justsize'}
        && $main::data{ $this->{'id'} }{$$count} !~ /^[0-9]{$size}$/ )
    {
        push( @$dialogs,
                  ( ( $this->{'name'} ) ? $this->{'name'} : '入力' ) . '('
                . ( $$count + 1 )
                . ')を確認してください。'
                . $size
                . ' 文字の半角数字にしてください。' )
            if ref $cgi::action;
        $this->{'is_invalid_field'}{$$count} = 1;
        $$is_valid = 0;
    }
    elsif ($this->{'requiredAll'}
        && $main::data{ $this->{'id'} }{$$count} eq '' )
    {
        push( @$dialogs,
                  ( ( $this->{'name'} ) ? $this->{'name'} : '入力' ) . '('
                . ( $$count + 1 )
                . ')を入力してください。' )
            if ref $cgi::action;
        $this->{'is_invalid_field'}{$$count} = 1;
        $$is_valid = 0;
    }
    if ( $main::data{ $this->{'id'} }{$$count} =~ /[^0-9]/ ) {
        if ($default::english) {
            push(
                @$dialogs,
                '"'
                    . (
                    ( defined $this->{'name'} && $this->{'name'} )
                    ? $this->{'name'}
                    : ''
                    )
                    . '" ('
                    . ( $$count + 1 )
                    . ') field can only contain numeric values.'
            ) if ref $cgi::action;
        }
        else {
            push( @$dialogs,
                ( ( $this->{'name'} ) ? $this->{'name'} : '入力' ) . '('
                    . ( $$count + 1 )
                    . ')を確認してください。半角数字にしてください。'
            ) if ref $cgi::action;
        }
        $this->{'is_invalid_field'}{$$count} = 1;
        $$is_valid = 0;
    }
    if ( defined $main::data{ $this->{'id'} }{$$count}
        && $main::data{ $this->{'id'} }{$$count} ne '' )
    {
        $$exist = 1;
        $num    = $main::data{ $this->{'id'} }{$$count};
    }
    else {
        $num = "\x09";
    }

    delete $main::data{ $this->{'id'} }{$$count};
    $$count++;
    return $num;
}

######################################################################
#	(4)-1 obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag('') if !defined $str || $str eq '';
    return $this->field_tag(
        $this->style(
            $this->data_tag( 'str', $this->escape( $this->tag_to_lf($str) ) ),
            $this->{'style'},     $this->{'fontsize'},
            $this->{'fontcolor'}, $this->{'fontface'}
        )
    );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my ($name);

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>入力欄設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_format">入力フォーマット</label></td>';
    print '<td class="field">';
    print '<input type="text" name="'
        . $name
        . '_format" id="'
        . $name
        . '_format" value="'
        . $this->escape( $this->{'format'} )
        . '" size="56" title="入力フォーマットを設定します。" />';
    print
        '<div class="example">設定例）電話番号 = (4)4-4 / 郵便番号 = 3-4</div>';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_requiredAll" id="'
        . $name
        . '_requiredAll" value="1"'
        . ( ( defined $this->{'requiredAll'} && $this->{'requiredAll'} )
        ? ' checked="checked"'
        : '' )
        . ' /> すべての入力欄の入力を強制する</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_justsize" id="'
        . $name
        . '_justsize" value="1"'
        . ( ( defined $this->{'justsize'} && $this->{'justsize'} )
        ? ' checked="checked"'
        : '' )
        . ' /> フォーマット通りの入力を強制する</label></li>';
    print '</ol>';
    print '</td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_inputtype">入力タイプ</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_inputtype', '', '',
        ( ( defined $this->{'inputtype'} ) ? $this->{'inputtype'} : '' ),
        ''       => 'テキスト &lt;input type=&quot;text&quot;&gt;',
        'number' => '数字 &lt;input type=&quot;number&quot;&gt;',
        'tel'    => 'Tel &lt;input type=&quot;tel&quot;&gt;',
    );
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_default">デフォルト</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_default" id="'
        . $name
        . '_default" value="'
        . $this->escape( $this->{'default'} )
        . '" size="56" title="入力欄のデフォルトの値を設定します。" /></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">プレースホルダ</span></td>';
    print '<td class="field" colspan="3">';
    my $format           = $this->escape( $this->{'format'} );
    my $placeholder_name = $name . '_placeholder^';
    my $count            = 0;
    $format
        =~ s/([0-9]+)/$this->num_form($placeholder_name,$this->{'placeholder'},$1,\$count,1)/eg;
    print $format;
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    #文字設定
    $this->print_font_setting_form($name)
        if !defined $html_disabled || !$html_disabled;

    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;

    #空白の除去
    $main::data{ $this->{'id'} . '_default' } =~ s/[\x0A\x0D\x09]+/ /sg;
    $main::data{ $this->{'id'} . '_format' } =~ s/[\x0A\x0D\x09]+/ /sg;

    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_justsize' } = 0
        if !$main::data{ $this->{'id'} . '_justsize' };
    $main::data{ $this->{'id'} . '_requiredAll' } = 0
        if !$main::data{ $this->{'id'} . '_requiredAll' };

    #フォントチェック
    return $this->is_valid_font_setting;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
    my $this = shift;
    my ($form);
    $form
        = '<tr><td class="field-name"><label for="search:'
        . $this->{'id'}
        . ':str">'
        . $this->{'name'}
        . '</label></td><td class="field">';
    $form
        .= '<input type="text" size="30" name="search:'
        . $this->{'id'}
        . ':str" value="'
        . $this->escape( $main::search{ $this->{'id'} }{'str'} ) . '" /> ';

    #英語表記
    if ( defined $default::english && $default::english ) {
        $form .= $this->mk_select_menu(
            'search:' . $this->{'id'} . ':mode', '', '',
            $main::search{ $this->{'id'} }{'mode'},
            'and' => 'Matches on all numbers',
            'or'  => 'Matches on any number',
            'A'   => 'Begins with any number',
            'Z'   => 'Finishes with any number'
        );

        #日本語
    }
    else {
        $form .= $this->mk_select_menu(
            'search:' . $this->{'id'} . ':mode', '', '',
            $main::search{ $this->{'id'} }{'mode'},
            'and' => '全ての番号を含む',
            'or'  => 'いずれかの番号を含む',
            'A'   => 'いずれかの番号から始まる',
            'Z'   => 'いずれかの番号で終わる'
        );
    }

    $form .= '</td></tr>';
    return $form;
}

######################################################################
#	sample
sub sample ($$) {
    my ( $this, $str ) = @_;
    return ( defined $str ) ? $str : '';
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'num_number', 'Number', '番号' );
}

1;
