package RelatedPagesBase;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールドモジュール（関連ページ一覧）
# RelatedPagesBase.pm 1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-02-14
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    if ( !ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }
    $this->{'cacheLifetime'} = 3    if !$this->{'cacheLifetime'};
    $this->{'method'}        = 'OR' if !$this->{'method'};
    $this->{'count'}         = 10
        if !$this->{'count'} || $this->{'count'} < 1 || $this->{'count'} > 0;
    $this->{'linkTarget'} = 'self' if !$this->{'linkTarget'};
    $this->{'siteTab'} = 1
        if !$this->{'selfTab'}
        && !$this->{'parentTab'}
        && !$this->{'siteTab'}
        && !$this->{'webTab'};
    return;
}

######################################################################
#	(2) obj->input_enabled;
sub form {
    my ( $this, $status, $original ) = @_;
    my ($form);
    $form = $this->field_header( 40, 'data:' . $this->{'id'} . ':str' );
    $form
        .= '<textarea name="data:'
        . $this->{'id'}
        . ':str" id="data:'
        . $this->{'id'}
        . ':str" cols="40" rows="3">'
        . $this->escape(
        $this->unescape_data_tag( $main::data{ $this->{'id'} }{'str'} ) )
        . '</textarea>';
    $form
        .= '<div class="note">キーワードごとにカンマ(,)で区切ります。</div>';
    $form
        .= '<div class="extra-field"><label><input type="checkbox" name="data:'
        . $this->{'id'}
        . ':autoExtract" value="1" /> キーワードを自動取得する。</label></div>';
    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    if ( ( !$main::data{ $this->{'id'} }{'str'} && $this->{'autoExtract'} )
        || $main::data{ $this->{'id'} }{'autoExtract'} )
    {
        $main::data{ $this->{'id'} }{'str'}
            = $this->extract_keywords( $main::data{ $this->{'id'} }{'str'},
            \%main::data );
    }
    $main::data{ $this->{'id'} }{'str'} =~ s/["']//sg
        if $main::data{ $this->{'id'} }{'str'};
    if ( $this->{'cseEnabled'} ) {
        if ( !$env::google_api_key ) {
            push(
                @{ $cgi::action->{'dialog'} },
                'Google API キーが設定されていないので、「'
                    . ( $this->name || '関連ページフィールド' )
                    . '」は使用できません。Google API キーを取得し「セットアップアシスタント」の「管理情報変更」で設定してください。'
            ) if ref $cgi::action;
        }
        if ( !$env::google_custom_search_cx ) {
            push(
                @{ $cgi::action->{'dialog'} },
                'Google カスタム検索 cx が設定されていないので、「'
                    . ( $this->name || '関連ページフィールド' )
                    . '」は使用できません。Google カスタム検索 cx を取得し「セットアップアシスタント」の「管理情報変更」で設定してください。'
            ) if ref $cgi::action;
        }
    }
    return 1;
}

sub extract_keywords ($$;$$) {
    my ( $this, $keywords, $data, $path ) = @_;
    my $sentence = '';
    if ( $default::static && $this->need_whole_page ) {
        $sentence = $this->get_whole_page($path);
        return $this->{'temporary_keywords'} if $this->{'temporary_keywords'};
    }
    else {
        return $keywords if !ref $data;
        while ( my ( $id, $field ) = each %{ $this->{'field_obj'} } ) {
            if ( ref $field && $field->{'class'} =~ /^text/ ) {
                my $str = $data->{$id}{'str'};
                $field->text_color( \$str );
                $field->text_conv( \$str );
                $sentence .= $this->get_text_from_html($str);
            }
            elsif ( ref $field && $data->{$id}{'comment'} ) {
                my $str = $data->{$id}{'comment'};
                $field->text_color( \$str );
                $field->text_conv( \$str );
                $sentence .= $this->get_text_from_html($str);
            }
        }
    }
    return $keywords if !$sentence;
    my @reserved_words = ();
    push( @reserved_words,
        split( /[\x09\x0A\x0C\x0D\x20]*,[\x09\x0A\x0C\x0D\x20]*/, $keywords )
    ) if $keywords;
    push( @reserved_words, split( /\x0A+/, $this->{'reservedWords'} ) )
        if $this->{'reservedWords'};
    @reserved_words
        = grep( $_ =~ /[^\x09\x0A\x0C\x0D\x20]/, @reserved_words );
    my @stop_words
        = ( $this->{'stopWords'} )
        ? grep( $_ =~ /[^\x09\x0A\x0C\x0D\x20]/,
        split( /\x0A+/, $this->{'stopWords'} ) )
        : ();
    if ( $this->{'appid'} ) {

        if ( bytes::length $sentence > 90000 ) {
            use bytes;
            utf8::encode($sentence) if utf8::is_utf8($sentence);
            $sentence = bytes::substr( $sentence, 0, 90000 );
            utf8::decode($sentence) if !utf8::is_utf8($sentence);
        }
        require CMONOS::CGI_Lib::HTTP_Client;
        my $res = HTTP_Client->new->request(
            'POST' => 'http://jlp.yahooapis.jp/KeyphraseService/V1/extract',
            {},
            {   'appid'    => $this->{'appid'},
                'sentence' => $sentence,
            }
        );
        undef $sentence;
        if ( $res->is_success ) {
            my @reserved1 = ();
            my @reserved2 = ();
            my @reserved3 = ();
            my @results   = ();
            my $hash      = $res->hash('utf8');
            if ( ref $hash->{'ResultSet'}->{'Result'} ) {
                $this->scalar_to_array( \$hash->{'ResultSet'}->{'Result'} );
            RESULT:
                foreach my $result ( @{ $hash->{'ResultSet'}->{'Result'} } ) {
                    if ( $result->{'Keyphrase'} ) {

#push(@{$cgi::action->{'dialog'}},$result->{'Keyphrase'}) if ref $cgi::action;
                        if (@reserved_words) {
                            my ($k);
                            if (($k) = grep( $_ eq $result->{'Keyphrase'},
                                    @reserved_words )
                                )
                            {
                                push( @reserved1, $k );
                                next RESULT;
                            }
                            elsif (
                                ($k) = grep( $result->{'Keyphrase'} =~ /$_/,
                                    @reserved_words )
                                )
                            {
                                push( @reserved2, $k );
                                next RESULT;
                            }
                            elsif (
                                ($k) = grep( $_ =~ /$result->{'Keyphrase'}/,
                                    @reserved_words )
                                )
                            {
                                push( @reserved3, $k );
                                next RESULT;
                            }
                        }
                        if (grep( $result->{'Keyphrase'} eq $_, @stop_words )
                            )
                        {
                            next RESULT;
                        }
                        else {
                            push( @results, $result->{'Keyphrase'} );
                        }
                    }
                }
                push( @reserved1, @reserved2 ) if @reserved2;
                push( @reserved1, @reserved3 ) if @reserved3;
                push( @reserved1, @results )   if @results;
                @reserved1 = splice( @reserved1, 0, $this->{'quantity'} )
                    if @reserved1 > $this->{'quantity'};
                $keywords = join( ',', @reserved1 );
            }
            else {
                push(
                    @{ $cgi::action->{'dialog'} },
                    'キーワードの抽出に失敗しました。'
                ) if ref $cgi::action;
            }
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                'Yahoo! Webサービス API にアクセスできませんでした。'
            ) if ref $cgi::action;
        }
    }
    else {
        my @keywords = ();

        #優先語
        if (@reserved_words) {
            my ( $n, %reserved, %reserved_score );
            $n = 0;
            foreach my $k (@reserved_words) {
                $reserved{$k} = $n++;
            }
            foreach my $k ( sort { length $b <=> length $a } @reserved_words )
            {
                if ( $k =~ /^[0-9a-zA-Z_\x09\x0A\x0C\x0D\x20\-]+$/ ) {
                    $reserved_score{$k} += ( $sentence
                            =~ s/(^|[^0-9a-zA-Z_])$k(?![0-9a-zA-Z_])/ /isg );
                }
                else {
                    $reserved_score{$k} += ( $sentence =~ s/$k/ /isg );
                }
            }
            foreach my $k (
                sort {
                    $reserved_score{$b} <=> $reserved_score{$a}
                        || $reserved{$a} <=> $reserved{$b}
                } keys %reserved_score
                )
            {
                push( @keywords, $k ) if $reserved_score{$k};
                last if @keywords == $this->{'quantity'};
            }
        }
        if ( @keywords < $this->{'quantity'} ) {
            my (%score);

            #カタカナ語
            while ( $sentence =~ s/([\x{30A1}-\x{30FA}]+)/ /s ) {
                ++$score{$1}
                    if length $1 > 2 && !grep( $_ eq $1, @stop_words );
            }

            #ひらがな等除去
            $sentence =~ s/[\x{3040}-\x{3096}\x{30FC}]+/ /sg;

            #漢字
            while ( $sentence
                =~ s/([\x{2E80}-\x{2FFF}\x{3190}-\x{319F}\x{3400}-\x{9FFF}\x{F900}-\x{FAFF}\x{20000}-\x{DFFFF}]+)/ /s
                )
            {
                ++$score{$1}
                    if length $1 > 2 && !grep( $_ eq $1, @stop_words );
            }

            #英字
            while ( $sentence =~ s/([a-zA-Z][a-zA-Z\-0-9]*)/ /s ) {
                my $w = $1;
                ++$score{$w}
                    if ( $w =~ /^[A-Z]{2}/ || length $w > 4 )
                    && !grep( $_ eq $w, @stop_words );
            }

            undef $sentence;
            if (%score) {
                my $n = 0;
                while ( $n < 5 ) {
                    my $e = 1;
                    foreach my $k ( keys %score ) {
                        if (   $score{$k}
                            && $k
                            =~ /^[\x{2E80}-\x{2FFF}\x{3190}-\x{319F}\x{3400}-\x{9FFF}\x{F900}-\x{FAFF}\x{20000}-\x{DFFFF}]+$/
                            )
                        {
                            if ( my @group
                                = grep( $_ ne $k && $_ =~ /$k/, keys %score )
                                )
                            {
                                foreach my $key (@group) {
                                    my $count = $score{$key};
                                    $score{$k} += $count;
                                    delete $score{$key};
                                    foreach my $key2 ( split( /$k/, $key ) ) {
                                        $score{$key2} += $count
                                            if length $key2 >= 2
                                            && !
                                            grep( $_ eq $key2, @stop_words );
                                    }
                                    $e = 0;
                                }
                            }
                        }
                    }
                    last if $e;
                    $n++;
                }
            }

            foreach my $k (
                sort { $score{$b} <=> $score{$a} || length $b <=> length $a }
                keys %score )
            {
 #push(@{$cgi::action->{'dialog'}},$k . '=' . $score{$k}) if ref $cgi::action;
                push( @keywords, $k ) if $score{$k};
                last if @keywords == $this->{'quantity'};
            }
        }
        @keywords = splice( @keywords, 0, $this->{'quantity'} )
            if @keywords > $this->{'quantity'};
        $keywords = join( ',', @keywords );
    }
    $this->set_temporary_keywords($keywords);
    return $keywords;
}

sub need_whole_page ($) {
    my $this = shift;
    return $this->{'fromWholePage'};
}

sub get_whole_page ($$) {
    my ( $this, $path ) = @_;
    return $this->_get_whole_page( ($path) ? $path : $this->get_output_path );
}

sub set_temporary_keywords ($$) {
    my ( $this, $keywords ) = @_;
    return 1;
}

sub _get_whole_page ($$) {
    my ( $this, $path ) = @_;
    my $data = $this->read_file( $path, 1 );
    my $sentence = '';
    while ( $data
        =~ /<!--data(?![0-9a-zA-Z_])[^>]*name="(?:str|comment)"[^>]*-->(.*?)<!--\/data-->/sg
        )
    {
        $sentence .= $this->get_text_from_html($1);
    }
    return $sentence;
}

sub get_text_from_html($$) {
    my ( $this, $html ) = @_;
    $html = $this->delink($html);
    $html
        =~ s!(s?https?|s?ftps?)://([0-9a-zA-Z_~\-]+:[0-9a-zA-Z_~\-]+\@|)[0-9a-zA-Z_~\-]+\.[0-9a-zA-Z_~\-/\.#\?\&=\%]+! !isg;
    $html
        =~ s/[0-9a-zA-Z_][0-9a-zA-Z_~\-\+\.]*\@[0-9a-zA-Z_~\-]+?\.[0-9a-zA-Z_~\-\.]+/ /sg;
    $html =~ s/<.*?>/ /sg;
    $html =~ s/[\x09\x0A\x0C\x0D\x20]+/ /sg;
    return ' ' . $html;
}

sub get_relatedpage_template ($) {
    my $this = shift;
    if ( defined $this->{'template'} && $this->{'template'} ) {
        my $template = $this->{'template'};
        if ( $template =~ /<!--_tate(?![0-9a-zA-Z_])[^>]*-->/ ) {
            require CMONOS::CGI_Lib::Taketori;
            $template = Taketori->new( { 'css' => 1 } )
                ->tategaki_to_text($template);
        }
        if ( $template =~ /<!--frame(?![0-9a-zA-Z_])[^>]*-->/
            && ref $frame::obj{'frame'} )
        {
            require CMONOS::CGI_Lib::Frame;
            $template = Frame->new->text_to_frame( $template, 'no',
                $frame::obj{'frame'} );
        }
        return $template;
    }
    else {
        return <<'TEMPLATE';
<!--article-->
<div class="related-article">
<!--image--><!--/image-->
<!--title--><!--head--><h4 class="related-article-head"><!--/head--><!--foot--></h4><!--/foot--><!--/title-->
<!--description--><!--head--><div class="related-article-body"><!--/head--><!--foot--></div><!--/foot--><!--/description-->
<!--url--><!--head--><div class="related-article-url"><!--/head--><!--foot--></div><!--/foot--><!--/url-->
</div>
<!--/article-->
<!--more--><!--head--><div class="related-article-more"><!--/head--><!--foot--></div><!--/foot--><!--/more-->
TEMPLATE
    }
}

######################################################################
sub get_related_pages ($$$$$$;$$) {
    my ( $this, $q, $target, $p, $path, $c, $n, $for_default, $id ) = @_;
    return '' if !$q;
    $id = 'related-pages' . $this->_mk_user_generated_field_id( $c, $n )
        if !$id;
    $path = $this->get_file_directory if !$path;
    return ''
        if !$env::google_api_key
        || !$env::google_custom_search_cx
        || !$this->set_dir($path);
    my $default_target = $this->default_target;
    if (!$target
        || ( $target eq 'self'
            && ( !$this->{'selfTab'} || $default::lib eq 'HomePageMakerLite' )
        )
        || ($target eq 'parent'
            && (   !$this->{'selfTab'}
                || !$default::subdivided
                || !$default::master_preference_dir
                || $default::master_preference_dir eq
                $default::preference_dir )
        )
        || ( $target eq 'site' && !$this->{'selfTab'} )
        || ( $target eq 'web'  && !$this->{'webTab'} )
        )
    {
        $target = $default_target;
    }
    my $last = int( 100 / $this->{'count'} )
        + ( ( 100 % $this->{'count'} ) ? 1 : 0 );
    if ( !$p || $p < 0 ) {
        $p = 1;
    }
    elsif ( $p > $last ) {
        $p = $last;
    }
    if ( $target eq $default_target && $p == 1 ) {
        $for_default = 1;
    }
    elsif ($for_default) {
        $p      = 1;
        $target = $default_target;
    }
    my $default_ssi_path = $path . '/' . $this->{'id'} . '.ssi';
    my $default_js_path  = $path . '/' . $this->{'id'} . '.js';
    my $ssi_path
        = $path . '/'
        . $this->{'id'}
        . ( ( $target eq 'web' ) ? '.web'
        : ( $target eq 'site' )   ? '.site'
        : ( $target eq 'parent' ) ? '.parent'
        :                           '.self' )
        . '.ssi';
    if (   $p == 1
        && -f $ssi_path
        && -s $ssi_path
        && -M $ssi_path < $this->{'cacheLifetime'} )
    {
        my $content = $this->read_file( $ssi_path, 1 );
        if ( $for_default && -M $default_ssi_path > $this->{'cacheLifetime'} )
        {
            if ( $this->{'emptySSI'} ) {
                $this->write_file( $default_ssi_path, '', 1 );
                $this->write_file( $default_js_path,  '', 1 );
            }
            else {
                $this->write_file( $default_ssi_path, \$content, 1 );
                $this->mk_external_javascript( $default_ssi_path,
                    $default_js_path, $content );
            }
        }
        return $content;
    }
    if ( $for_default && !-f $default_ssi_path ) {
        $this->write_file( $default_ssi_path, '', 1 );
        $this->write_file( $default_js_path,  '', 1 );
    }
    return '' if $this->{'cse_error'};

    my @keywords
        = map( ( ( $_ =~ /[\x09\x0A\x0C\x0D\x20]/ ) ? '"' . $_ . '"' : $_ ),
        split( /[\x09\x0A\x0C\x0D\x20]*,[\x09\x0A\x0C\x0D\x20]*/, $q ) );
    $q
        = ( $this->{'method'} && $this->{'method'} eq 'AND' )
        ? join( ' ',   @keywords )
        : join( ' | ', @keywords );

    my $inurl
        = ( $target eq 'self' ) ? $this->get_parenturl($c)
        : ( $target eq 'parent' ) ? $this->get_topurl
        : ( $target eq 'site' )   ? $this->g_url( $this->full_path('../../') )
        :                           '';
    if ($inurl) {
        $inurl .= '/' if $inurl !~ m!/$!;
        $inurl = 'inurl:' . $inurl;
    }
    my $here = $this->get_selfurl( $c, $n );
    $inurl .= ( ($inurl) ? ' ' : '' ) . '-inurl:' . $here if $here;
    my $domain = $this->g_url( $this->http_my_domain );
    foreach my $u ( $this->get_exurl ) {
        $inurl .= ( ($inurl) ? ' ' : '' ) . '-inurl:' . $u if $u;
    }
    $inurl .= ' -filetype:xml -filetype:kml';

#    "template": "https://www.googleapis.com/customsearch/v1?q={searchTerms}&num={count?}&start={startIndex?}&lr={language?}&safe={safe?}&cx={cx?}&cref={cref?}&sort={sort?}&filter={filter?}&gl={gl?}&cr={cr?}&googlehost={googleHost?}&c2coff={disableCnTwTranslation?}&hq={hq?}&hl={hl?}&siteSearch={siteSearch?}&siteSearchFilter={siteSearchFilter?}&exactTerms={exactTerms?}&excludeTerms={excludeTerms?}&linkSite={linkSite?}&orTerms={orTerms?}&relatedSite={relatedSite?}&dateRestrict={dateRestrict?}&lowRange={lowRange?}&highRange={highRange?}&searchType={searchType}&fileType={fileType?}&rights={rights?}&imgSize={imgSize?}&imgType={imgType?}&imgColorType={imgColorType?}&imgDominantColor={imgDominantColor?}&alt=json"
    my $api
        = 'https://www.googleapis.com/customsearch/v1?key='
        . $this->url_encode($env::google_api_key) . '&cx='
        . $this->url_encode($env::google_custom_search_cx)
        . '&alt=atom&q='
        . $this->url_encode($q) . '&num='
        . $this->{'count'}
        . '&start='
        . ( ( $p - 1 ) * $this->{'count'} + 1 ) . '&hq='
        . $this->url_encode($inurl)
        . '&siteSearch='
        . $this->url_encode($domain);

    my $read     = 0;
    my $total    = 0;
    my $content  = '';
    my $template = $this->get_relatedpage_template;
    my ( $head, $foot ) = ( '', '' );
    ( $head, $template, $foot )
        = ( $1, $this->join_header_and_footer( $2, $3 ), $4 )
        if $template
        =~ /^(.*)<!--article(?![0-9a-zA-Z_])([^>]*)-->(.*)<!--\/article-->(.*)$/s;

    require CMONOS::CGI_Lib::HTTP_Client;
    my $res = HTTP_Client->new->request(
        'GET' => $api,
        { 'Referer' => $this->full_path($cgi::path) }
    );
    my $hash = $res->hash('utf8');
    if ( !$res->is_success || ref $hash->{'errors'} ) {
        push(
            @{ $cgi::action->{'dialog'} },
            '「'
                . ( $this->name || '関連ページ一覧フィールド' )
                . '」を更新できませんでした ('
                . ( $hash->{'errors'}->{'error'}->{'code'} || 'Error' )
                . ' : '
                . ( $hash->{'errors'}->{'error'}->{'internalReason'} || '' )
                . ')。'
            )
            if ref $cgi::action
            && ref $hash->{'errors'}
            && ref $hash->{'errors'}->{'error'};
        $this->{'cse_error'} = 1;
    }
    elsif ( ref $hash->{'feed'} ) {
        $total
            = ( ref $hash->{'feed'}->{'opensearch:totalResults'} )
            ? $hash->{'feed'}->{'opensearch:totalResults'}->{'value'}
            : $hash->{'feed'}->{'opensearch:totalResults'}
            if defined $hash->{'feed'}->{'opensearch:totalResults'};
        if ( ref $hash->{'feed'}->{'entry'} ) {
            $hash->{'feed'}->{'entry'} = [ $hash->{'feed'}->{'entry'} ]
                if ref $hash->{'feed'}->{'entry'} eq 'HASH';
        ITEM:
            foreach my $item ( @{ $hash->{'feed'}->{'entry'} } ) {
                my $mtime
                    = $this->date_to_gmt(
                      ( $item->{'updated'} )   ? $item->{'updated'}
                    : ( $item->{'modified'} )  ? $item->{'modified'}
                    : ( $item->{'published'} ) ? $item->{'published'}
                    : ( $item->{'issued'} )    ? $item->{'issued'}
                    :                            time );
                my $url
                    = $this->get_atom_value( $item->{'link'}, 'html', 'href' )
                    || $this->get_atom_value( $item->{'link'}, '', 'href' )
                    || '';
                my $title
                    = $this->detag( ( ref $item->{'title'} )
                    ? $item->{'title'}->{'value'}
                    : $item->{'title'} )
                    if defined $item->{'title'};
                my $description = $this->tag_fix(
                    $this->get_atom_value( $item->{'summary'}, 'html',
                        'value' )
                        || $this->get_atom_value( $item->{'summary'}, '',
                        'value' )
                        || $this->get_atom_value(
                        $item->{'content'}, 'html', 'value'
                        )
                ) || '';
                $description =~ s/<br(?!\w)[^>]*>//sgi;
                my $image
                    = (    $item->{'cse:PageMap'}
                        && $item->{'cse:PageMap'}->{'cse:DataObject'} )
                    ? $this->get_atom_value(
                    $item->{'cse:PageMap'}->{'cse:DataObject'},
                    'cse_image', 'src' )
                    : '';
                $content .= $this->replace_relatedpages( $template,
                    [ $url, $title, $description, $mtime, $image ] );
            }
        }
        $read = 1;
    }
    my $more_url
        = 'https://www.google.co.jp/search?q='
        . $this->url_encode($q)
        . '&ie=UTF-8&oe=UTF-8&hq='
        . $this->url_encode($inurl)
        . '&sitesearch='
        . $this->url_encode($domain);
    if ($content) {
        $content = $head . $content . $foot if $content;

#$content .= '<!--pager type="list" class="pager"--><!--/pager-->' if $content !~ /<!--pager(?!\w)[^>]*-->/si;
        my $max = int( $total / $this->{'count'} )
            + ( ( $total % $this->{'count'} ) ? 1 : 0 );
        $content
            =~ s/<\!--pager(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/pager(?![0-9a-zA-Z_])[^>]*-->/$this->_pager_replace($id,$target,$max,$last,$p,$more_url,$1,$2)/ges;
    }
    else {
        $content = $head . $foot;
        $content
            =~ s/<\!--pager(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/pager(?![0-9a-zA-Z_])[^>]*-->//gs;
    }
    $content
        =~ s/<\!--more(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/more(?![0-9a-zA-Z_])[^>]*-->/$this->_more_replace($more_url,$1,$2)/ges;
    if ( $read && $p == 1 ) {
        $this->write_file( $ssi_path, \$content, 1 );
        if ($for_default) {
            if ( $this->{'emptySSI'} ) {
                $this->write_file( $default_ssi_path, '', 1 );
                $this->write_file( $default_js_path,  '', 1 );
            }
            else {
                $this->write_file( $default_ssi_path, \$content, 1 );
                $this->mk_external_javascript( $default_ssi_path,
                    $default_js_path, $content );
            }
        }
    }
    return ( $read || !$for_default || !-s $default_ssi_path )
        ? $content
        : '';
}

sub default_target ($) {
    my $this = shift;
    return ( $default::lib ne 'HomePageMakerLite' && $this->{'selfTab'} )
        ? 'self'
        : (    $this->{'parentTab'}
            && $default::subdivided
            && $default::master_preference_dir
            && $default::master_preference_dir ne $default::preference_dir )
        ? 'parent'
        : ( $this->{'siteTab'} ) ? 'site'
        :                          'web';
}

sub _pager_replace ($$$$$$$$$) {
    my ($this, $id,       $target,     $max, $last,
        $p,    $more_url, $attributes, $content
    ) = @_;
    return '' if !$max || $max <= 1;
    my ( $header, $footer )
        = $this->get_header_and_footer( $attributes, $content );
    my $is_list = ( $attributes =~ / type="list"/i ) ? 1 : 0;
    my $class
        = ( $attributes =~ / class="([0-9a-zA-Z_\-\x20]+)"/i ) ? $1 : '';
    my $listid = ( $attributes =~ / id="([0-9a-zA-Z_\-]+)"/i ) ? $1 : '';
    my $text
        = ( $attributes =~ / text="(.+?)"/i )
        ? $1
        : '&raquo; Google で検索';
    my $a_target
        = ( $attributes =~ / target="([0-9a-zA-Z_\-]+)"/i ) ? $1 : '';
    my $list = '';
    $list
        = '<'
        . ( ($is_list) ? 'ul'                      : 'p' )
        . ( ($listid)  ? ' id="' . $listid . '"'   : '' )
        . ( ($class)   ? ' class="' . $class . '"' : '' ) . '>'
        if $is_list || $class || $listid;
    my $start = 1;
    my $end   = $last;
    $p = $last if $p > $last;

    if ( ( $end - $start ) >= 10 ) {
        $end   = $p + 4 if ( $p + 6 ) < $last;
        $start = $end - 5;
        $start = 1 if $start < 4;
    }
    foreach my $n (
        ( ( $start > 1 ) ? ( 1, '...' ) : () ),
        ( $start .. $end ),
        ( ( $end < $last ) ? ( '...', $last ) : () ),
        ( ( $last < $max ) ? ('m') : () )
        )
    {
        if ( $n eq 'm' ) {
            $list
                .= ( ($is_list) ? '<li class="next">' : '' )
                . '<a href="'
                . $this->escape($more_url) . '"'
                . ( ($a_target) ? ' target="' . $a_target . '"' : '' ) . '>'
                . $this->escape_except_html_entity($text) . '</a>';
        }
        elsif ( $n eq '...' ) {
            $list .= ( ($is_list) ? '<li class="omission">' : '' ) . $n;
        }
        elsif ( $n == $p ) {
            $list
                .= ( ($is_list) ? '<li class="here">' : '' )
                . '<strong>'
                . $n
                . '</strong>';
        }
        else {
            $list .= ($is_list) ? '<li>' : ' ';
            $list
                .= '<a href="javascript:void(0)" onclick="cmonos.tool.relatedpages.submit(\''
                . $id
                . '\',{\'target\' : \''
                . $target
                . '\',\'start\' : \''
                . $n
                . '\'})">'
                . $n . '</a>';
        }
        $list .= '</li>' if $is_list;
    }
    $list .= '</' . ( ($is_list) ? 'ul' : 'p' ) . '>'
        if $is_list || $class || $listid;
    return $header . $list . $footer;
}

sub _more_replace ($$;$$) {
    my ( $this, $url, $attributes, $content ) = @_;
    my ( $header, $footer )
        = $this->get_header_and_footer( $attributes, $content );
    my $class
        = ( $attributes =~ / class="([0-9a-zA-Z_\-\x20]+)"/i ) ? $1 : '';
    my $target = ( $attributes =~ / target="([0-9a-zA-Z_\-]+)"/i ) ? $1 : '';
    my $id     = ( $attributes =~ / id="([0-9a-zA-Z_\-]+)"/i )     ? $1 : '';
    my $text
        = ( $attributes =~ / text="(.+?)"/i ) ? $1
        : ($default::english) ? '&raquo; More...'
        :                       '&raquo; Google で検索する...';
    return
          $header
        . '<a href="'
        . $this->escape($url) . '"'
        . ( ($target) ? ' target="' . $target . '"' : '' )
        . ( ($id)     ? ' id="' . $id . '"'         : '' )
        . ( ($class)  ? ' class="' . $class . '"'   : '' ) . '>'
        . $this->escape_except_html_entity($text) . '</a>'
        . $footer;
}

sub get_atom_value ($$$$) {
    my ( $this, $element, $type, $name ) = @_;
    return '' if !defined $element;
    $element = [$element] if !ref $element || ref $element ne 'ARRAY';
    foreach my $this_element (@$element) {
        if ((   (   defined $this_element->{'type'}
                    && $this_element->{'type'} =~ /$type/
                )
                || !$type
            )
            && defined $this_element->{$name}
            )
        {
            return $this_element->{$name};
        }
    }
    return '';
}

sub replace_relatedpages ($$$$;$$) {
    my ( $this, $template, $data ) = @_;
    my ( $url, $title, $description, $mtime, $image ) = @$data;
    $title
        = '<a href="'
        . $this->escape($url) . '"'
        . ( ( $this->{'linkTarget'} && $this->{'linkTarget'} eq 'blank' )
        ? 'target="_blank"'
        : '' )
        . '>'
        . ( $title || $url ) . '</a>';
    $image
        = '<img src="' . $this->escape($image) . '" class="cse-thumbnail" />'
        if $image;
    $template
        =~ s/<\!--title(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/title(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('title',$1,$2,$title)/ges;
    $template
        =~ s/<\!--description(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/description(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('description',$1,$2,$description)/ges;
    $template
        =~ s/<\!--url(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/url(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('url',$1,$2,$url)/ges;
    $template
        =~ s/<\!--image(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/image(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('image',$1,$2,$image)/ges;
    $template
        =~ s/<\!--mtime(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/mtime(?![0-9a-zA-Z_])[^>]*-->/$this->datetime_tag_replace('mtime',$1,$2,$mtime,0,'gmt' . $this->{'datetype'},'')/ges;

    if ( $template =~ /<!--tate(?![0-9a-zA-Z_])[^>]*-->/ ) {
        require CMONOS::CGI_Lib::Taketori;
        $template
            = Taketori->new( { 'css' => 1 } )->text_to_tategaki($template);
    }
    return $template;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    $str = $this->extract_keywords( $str, '', $cgi::output )
        if $default::static
        && !$str
        && $this->{'autoExtract'}
        && $this->need_whole_page;
    return $this->field_tag('') if !$str || $str !~ /[^\x09\x0A\x0C\x0D\x20]/;
    my $id = 'related-pages' . $this->_mk_user_generated_field_id( $c, $n );
    if ( $this->{'cseEnabled'} ) {
        my $related_pages = '<ul id="' . $id . '-tabs" class="tabs">';
        if ( $this->{'selfTab'} ) {
            $related_pages
                .= '<li class="target-self selected-tab"><a href="javascript:void(0)" onclick="cmonos.tool.relatedpages.submit(\''
                . $id
                . '\',{\'target\' : \'self\'})">';
            $related_pages
                .= ( $setting::general{'cginame'} )
                ? $this->jfold( $setting::general{'cginame'}, 16, 'I', 1 )
                : ($default::subdivided) ? 'このカテゴリー'
                :                          'ここ';
            $related_pages .= '</a></li>';
        }
        if (   $this->{'parentTab'}
            && $default::subdivided
            && $default::master_preference_dir
            && $default::master_preference_dir ne $default::preference_dir )
        {
            $this->import_db( $default::master_preference_dir . '/general',
                \%master::general, 1 )
                if !%master::general;
            $related_pages
                .= '<li class="target-parent'
                . ( ( !$this->{'selfTab'} ) ? ' selected-tab' : '' )
                . '"><a href="javascript:void(0)" onclick="cmonos.tool.relatedpages.submit(\''
                . $id
                . '\',{\'target\' : \'parent\'})">';
            $related_pages
                .= ( $master::general{'cginame'} )
                ? $this->jfold( $master::general{'cginame'}, 16, 'I', 1 )
                : '総合';
            $related_pages .= '</a></li>';
        }
        if ( $this->{'siteTab'} ) {
            $related_pages
                .= '<li class="target-site'
                . ( ( !$this->{'selfTab'} && !$this->{'parentTab'} )
                ? ' selected-tab'
                : '' )
                . '"><a href="javascript:void(0)" onclick="cmonos.tool.relatedpages.submit(\''
                . $id
                . '\',{\'target\' : \'site\'})">';
            $related_pages
                .= ( $env::title && length $env::title < 16 )
                ? $env::title
                : 'このサイト';
            $related_pages .= '</a></li>';
        }
        if ( $this->{'webTab'} ) {
            $this->{'webLabel'} = '関連サイト' if !$this->{'webLabel'};
            $related_pages .= '<li class="target-web'
                . (
                (          !$this->{'selfTab'}
                        && !$this->{'parentTab'}
                        && !$this->{'siteTab'}
                ) ? ' selected-tab' : ''
                )
                . '"><a href="javascript:void(0)" onclick="cmonos.tool.relatedpages.submit(\''
                . $id
                . '\',{\'target\' : \'web\'})">';
            $related_pages .= $this->{'webLabel'};
            $related_pages .= '</a></li>';
        }
        $related_pages .= '</ul>';
        $this->get_related_pages( $str, '', 1, $path, $c, $n, 1, $id );
        $related_pages .= '<div id="' . $id . '">';
        $related_pages
            .= $this->include_external_file(
            $path . '/' . $this->{'id'} . '.ssi',
            1, $this->get_output_path, ( ($default::static) ? 0 : 1 ) );
        $related_pages .= '</div>';
        $related_pages .= $this->form_start(
            'id'       => $id . '-form',
            'name'     => $id . '-form',
            'method'   => 'post',
            'required' => $this->get_query_keys
        );
        $related_pages .= $this->add_query_for_form( $c, $n );
        $related_pages
            .= $this->add_query( 'post', { 'id' => $this->{'id'} } );
        $related_pages .= '</form>';
        $related_pages
            .= $this->javascript( 'cmonos.tool.relatedpages.submit(\''
                . $id
                . '\',{\'refresh\' : \'1\'})' );
        return $this->field_tag(
            ( ($str) ? $this->data_tag_from_hash( 'str', $str ) : '' )
            . $related_pages );
    }
    else {
        my @keywords
            = map(
            ( ( $_ =~ /[\x09\x0A\x0C\x0D\x20]/ ) ? '"' . $_ . '"' : $_ ),
            split( /[\x09\x0A\x0C\x0D\x20]*,[\x09\x0A\x0C\x0D\x20]*/, $str )
            );
        my $keyword
            = ( $this->{'method'} && $this->{'method'} eq 'AND' )
            ? join( ' ',   @keywords )
            : join( ' | ', @keywords );
        my $domain = $this->g_url( $this->http_my_domain );
        my $loader
            .= '<script src="http://www.google.com/jsapi" type="text/javascript"></script>'
            . "\x0A";
        $loader
            .= '<script language="Javascript" type="text/javascript" src="'
            . (
            ( $cgi::output || $cgi::output_option )
            ? $this->base_change( $env::javascript, $cgi::output,
                $cgi::output_option )
            : $env::javascript
            ) . '/grelatedpages.js" charset="UTF-8"></script>' . "\x0A";
        my $related_pages
            .= 'document.write(\'<div class="related-pages" id="'
            . $id
            . '">Loading...</div>\');' . "\x0A";
        $related_pages
            .= 'document.write(\'<div class="related-pages-y" id="'
            . $id
            . '-y"><a href="http://developer.yahoo.co.jp/about"><img src="http://i.yimg.jp/images/yjdn/yjdn_attbtn2_105_17.gif" width="105" height="17" title="Webサービス(キーフレーズ抽出) by Yahoo! JAPAN" alt="Webサービス(キーフレーズ抽出) by Yahoo! JAPAN" border="0" style="margin:15px 15px 15px 15px"></a></div>\');'
            . "\x0A"
            if $this->{'appid'};
        $related_pages
            .= 'writeGRelatedPages(\''
            . $id . '\',\''
            . $keyword . '\',\''
            . $this->get_selfurl( $c, $n ) . '\',\''
            . ( ( $this->{'linkTarget'} && $this->{'linkTarget'} eq 'blank' )
            ? 'blank'
            : 'self' )
            . '\',\''
            . ( ( $this->{'resultSet'} && $this->{'resultSet'} eq 'large' )
            ? 'large'
            : 'small' )
            . '\',[';
        my @exurl = $this->get_exurl;
        my $exurls
            = (@exurl)
            ? '\'exurl\' : [\'' . join( '\',\'', @exurl ) . '\'], '
            : '';

        if ( $this->{'selfTab'} ) {
            my $title
                = ( $setting::general{'cginame'} )
                ? $this->jfold( $setting::general{'cginame'}, 16, 'I', 1 )
                : ($default::subdivided) ? 'このカテゴリー'
                :                          'ここ';
            $related_pages .= '{';
            $related_pages .= '\'label\' : \'' . $title . '\', ';
            $related_pages .= '\'site\' : \'' . $domain . '\', ';
            $related_pages .= $exurls;
            $related_pages
                .= '\'inurl\' : \'' . $this->get_parenturl($c) . '\'';
            $related_pages .= '}, ';
        }
        if (   $this->{'parentTab'}
            && $default::subdivided
            && $default::master_preference_dir
            && $default::master_preference_dir ne $default::preference_dir )
        {
            $this->import_db( $default::master_preference_dir . '/general',
                \%master::general, 1 )
                if !%master::general;
            my $title
                = ( $master::general{'cginame'} )
                ? $this->jfold( $master::general{'cginame'}, 16, 'I', 1 )
                : '総合';
            $related_pages .= '{';
            $related_pages .= '\'label\' : \'' . $title . '\', ';
            $related_pages .= '\'site\' : \'' . $domain . '\', ';
            $related_pages .= $exurls;
            $related_pages .= '\'inurl\' : \'' . $this->get_topurl . '\'';
            $related_pages .= '}, ';

        }
        if ( $this->{'siteTab'} ) {
            my $title
                = ( $env::title && length $env::title < 16 )
                ? $env::title
                : 'このサイト';
            my $inurl = $this->g_url( $this->full_path('../../') );
            $inurl .= '/' if $inurl !~ m!/$!;
            $related_pages .= '{';
            $related_pages .= '\'label\' : \'' . $title . '\', ';
            $related_pages .= '\'site\' : \'' . $domain . '\', ';
            $related_pages .= $exurls;
            $related_pages .= '\'inurl\' : \'' . $inurl . '\'';
            $related_pages .= '}, ';
        }
        if ( $this->{'webTab'} ) {
            $this->{'webLabel'} = 'Web' if !$this->{'webLabel'};
            $related_pages .= '{';
            $related_pages .= $exurls;
            $related_pages .= '\'label\' : \'' . $this->{'webLabel'} . '\'';
            $related_pages .= '}, ';
        }
        $related_pages =~ s/,[\x09\x0A\x0C\x0D\x20]+$//s;
        $related_pages .= ']);';
        return $this->field_tag(
              ( ($str) ? $this->data_tag_from_hash( 'str', $str ) : '' )
            . $loader
                . $this->javascript($related_pages) );
    }
}

sub has_content {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ( defined $str && $str ne '' && $str =~ /[^\x09\x0A\x0C\x0D\x20]/ )
        ? 1
        : 0;
}

sub get_selfurl ($;$$) {
    my ( $this, $c, $n ) = @_;
    return $this->g_url( $this->get_viewer_url( $c, $n ) );
}

sub get_parenturl ($;$) {
    my ( $this, $c ) = @_;
    if ($default::static) {
        return $this->g_url( $this->get_viewer_url($c) );
    }
    else {
        return $this->g_url( $this->my_url
                . ( ( defined $c && $c ne '' ) ? '**c=' . $c : '' ) );
    }
}

sub get_topurl ($) {
    my $this = shift;
    return $this->g_url( $this->my_url );
}

sub get_exurl ($) {
    my $this = shift;
    return ();
}

sub g_url ($$) {
    my ( $this, $url ) = @_;
    $url =~ s/#.*$//i;
    $url =~ s!^https?://!!i;
    return ( $url =~ /\&/ ) ? '"' . $url . '"' : $url;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
    my $this = shift;
    return 0;
}

#	(4)-3 obj->format_for_text(str);
sub format_for_text_enabled ($) {
    my $this = shift;
    return 0;
}

sub format_for_text {
    my ( $this, $str ) = @_;
    return 0;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my ($name);

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);
    print '<fieldset>';
    print '<legend>キーワード抽出設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr><td class="field-name"><label for="' . $name
        . '_reservedWords">優先語</label></td>';
    print '<td class="field">';
    print '<textarea name="'
        . $name
        . '_reservedWords" id="'
        . $name
        . '_reservedWords" cols="56" rows="20" wrap="off" title="優先して抽出する語句を設定します。">'
        . $this->escape( $this->{'reservedWords'} )
        . '</textarea>';
    print '<div class="note">語句ごとに改行で区切ります。';
    print
        ' <label class="auto-fit" title="高さを内容に合わせる"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_reservedWords\').setAutoFit(this.checked);" />フィット</label>';
    print '</div></td></tr>';
    print '<tr><td class="field-name"><label for="' . $name
        . '_stopWords">除外語</label></td>';
    print '<td class="field">';
    print '<textarea name="'
        . $name
        . '_stopWords" id="'
        . $name
        . '_stopWords" cols="56" rows="20" wrap="off" title="抽出対象としない語句を設定します。">'
        . $this->escape( $this->{'stopWords'} )
        . '</textarea>';
    print '<div class="note">語句ごとに改行で区切ります。';
    print
        ' <label class="auto-fit" title="高さを内容に合わせる"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_stopWords\').setAutoFit(this.checked);" />フィット</label>';
    print '</div></td></tr>';
    print
        '<tr><td class="field-name"><span class="datatitle">自動抽出</span></td>';
    print '<td class="field">';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_autoExtract" value="1"'
        . (
        ( defined $this->{'autoExtract'} && $this->{'autoExtract'} eq '1' )
        ? ' checked="checked"'
        : '' )
        . ' /> キーワードが入力されなかったとき、常に自動的に抽出する</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_fromWholePage" value="1"'
        . (
        (   defined $this->{'fromWholePage'}
                && $this->{'fromWholePage'} eq '1'
        ) ? ' checked="checked"' : ''
        )
        . ' /> ページ全体を抽出対象とする</label></li>'
        if $default::static && $setting::field_db_name ne 'infofield';
    print '</ol>';
    print '</td></tr>';
    print '</tbody></table>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_appid"><a href="http://developer.yahoo.co.jp/webapi/jlp/keyphrase/v1/extract.html" target="_blank">Yahoo! キーフレーズ抽出 API</a> <a href="http://help.yahoo.co.jp/help/jp/developer/developer-06.html" target="_blank">アプリケーションID</a></label></legend>';
    print '<input type="text" name="'
        . $name
        . '_appid" id="'
        . $name
        . '_appid" value="'
        . $this->escape( $this->{'appid'} )
        . '" size="72" />';
    print '<div class="warning">';
    print
        'Yahoo! Webサービスによるキーワード抽出については、各ユーザーがそれぞれ個別に <a href="http://developer.yahoo.co.jp/search/" target="_blank">Yahoo! Web サービス</a> を利用するものとみなします。Yahoo! Web サービスによるキーフレーズ抽出は一切が無保証です。この機能は実験的に無償で追加されたものであり、あらゆるサポートの対象外です。将来のバージョンで削除されることがあります。';
    print '</div>';
    print '</fieldset>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>関連ページ検索設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print
        '<tr><td class="field-name"><span class="datatitle">関連ページ抽出</span></td>';
    print '<td class="field">';
    print '<label><input type="checkbox" name="'
        . $name
        . '_cseEnabled" value="1"'
        . ( ( defined $this->{'cseEnabled'} && $this->{'cseEnabled'} eq '1' )
        ? ' checked="checked"'
        : '' )
        . ' onclick="cmonos.element.tagClass(\'tr\',\'cse\',\'fieldset\',\'cse\').appear(this.checked);cmonos.element.tagClass(\'tr\',\'gsa\').disappear(this.checked);" /> Google カスタム検索 API を利用する。</label>';

    if ( !$env::google_api_key ) {
        print
            '<div class="warning">Google API キーがみつかりません。Google API キーを取得し「セットアップアシスタント」の「管理情報変更」で設定してください。</div>';
    }
    if ( !$env::google_custom_search_cx ) {
        print
            '<div class="warning">Google カスタム検索 cx がみつかりません。Google カスタム検索 cx を取得し「セットアップアシスタント」の「管理情報変更」で設定してください。</div>';
    }
    print '</td></tr>';
    print '<tr class="cse"><td class="field-name"><label for="' . $name
        . '_cacheLifetime">更新間隔</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_cacheLifetime', '', '', $this->{'cacheLifetime'},
        '1'  => '1',
        '2'  => '2',
        '3'  => '3',
        '4'  => '4',
        '5'  => '5',
        '6'  => '6',
        '7'  => '7',
        '8'  => '8',
        '9'  => '9',
        '10' => '10',
        '30' => '30',
        '90' => '90',
    );
    print '日</td></tr>';
    print '<tr class="gsa"><td class="field-name"><label for="' . $name
        . '_quantity">キーワード数</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_quantity', '', '', $this->{'quantity'},
        '1'  => '1',
        '2'  => '2',
        '3'  => '3',
        '4'  => '4',
        '5'  => '5',
        '6'  => '6',
        '7'  => '7',
        '8'  => '8',
        '9'  => '9',
        '10' => '10',
    );
    print '</td></tr>';
    print '<tr><td class="field-name"><label for="' . $name
        . '_method">検索方式</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_method', '', '', $this->{'method'},
        'OR'  => 'いずれかのキーワードに一致',
        'AND' => 'すべてのキーワードに一致',
    );
    print '</td></tr>';
    print '<tr><td class="field-name"><label for="' . $name
        . '_linkTarget">リンク</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_linkTarget', '', '', $this->{'linkTarget'},
        'self'  => '同じウィンドウで開く',
        'blank' => '新しいウィンドウで開く',
    );
    print '</td></tr>';
    print '<tr class="gsa"><td class="field-name"><label for="' . $name
        . '_resultSet">結果の数</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_resultSet', '', '', $this->{'resultSet'},
        'small' => '4件',
        'large' => '8件',
    );
    print '</td></tr>';
    print '<tr class="cse"><td class="field-name"><label for="' . $name
        . '_count">1ページあたりの表示数</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_count', '', '', $this->{'count'},
        '1'  => '1',
        '2'  => '2',
        '3'  => '3',
        '4'  => '4',
        '5'  => '5',
        '6'  => '6',
        '7'  => '7',
        '8'  => '8',
        '9'  => '9',
        '10' => '10',
    );
    print ' 件</td>';
    print '</td></tr>';
    print '<tr class="cse">';
    print '<td class="field-name"><label for="' . $name
        . '_datetype">日時表示形式</label></td>';
    print '<td class="field">';
    $this->print_date_type_menu( $name . '_', $this->{'datetype'} );
    print '</td>';
    print '</tr>';

    print
        '<tr><td class="field-name"><span class="datatitle">タブ表示</span></td>';
    print '<td class="field">';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_selfTab" value="1"'
        . ( ( defined $this->{'selfTab'} && $this->{'selfTab'} eq '1' )
        ? ' checked="checked"'
        : '' )
        . ' /> 「'
        . (
          ( $setting::general{'cginame'} ) ? $setting::general{'cginame'}
        : ( ($default::subdivided) ? 'このカテゴリー' : 'このCGI' )
        )
        . '」の関連ページ</label></li>'
        if $default::lib ne 'HomePageMakerLite';

    if (   $default::subdivided
        && $default::master_preference_dir
        && $default::master_preference_dir ne $default::preference_dir )
    {
        $this->import_db( $default::master_preference_dir . '/general',
            \%master::general, 1 )
            if !%master::general;
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_parentTab" value="1"'
            . (
            ( defined $this->{'parentTab'} && $this->{'parentTab'} eq '1' )
            ? ' checked="checked"'
            : '' )
            . ' /> 「'
            . ( ( $master::general{'cginame'} ) ? $master::general{'cginame'}
            : 'このCGI' )
            . '」の関連ページ</label></li>';
    }
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_siteTab" value="1"'
        . ( ( defined $this->{'siteTab'} && $this->{'siteTab'} eq '1' )
        ? ' checked="checked"'
        : '' )
        . ' /> 「このサイト」の関連ページ</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_webTab" value="1"'
        . ( ( defined $this->{'webTab'} && $this->{'webTab'} eq '1' )
        ? ' checked="checked"'
        : '' )
        . ' /> 「Web/関連サイト」上の関連ページ</label></li>';
    print '</ol>';
    print '</td></tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_webLabel">「Web/関連サイト」タブのラベル</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_webLabel" size="16" maxlength="16" value="'
        . $this->escape( $this->{'webLabel'} )
        . '" /></td>';
    print '</tr>';
    print '<tr class="cse tbody-end">';
    print
        '<td class="field-name"><span class="datatitle">初期状態</span></td>';
    print '<td class="field"><label><input type="checkbox" name="'
        . $name
        . '_emptySSI" value="1"'
        . ( ( defined $this->{'emptySSI'} && $this->{'emptySSI'} eq '1' )
        ? ' checked="checked"'
        : '' )
        . ' /> JavaScript が動作しない環境では関連ページを表示しない</label></td>';
    print '</tr>';

    print '</tbody></table>';

    print '<fieldset class="cse">';
    print '<legend><label for="' . $name
        . '_template">テンプレート</label></legend>';
    print '<textarea name="'
        . $name
        . '_template" id="'
        . $name
        . '_template" cols="72" rows="10" wrap="off" class="content-editor-area">'
        . $this->escape( $this->{'template'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<label class="auto-fit" title="高さを内容に合わせる"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'',
        $name,
        '_template\').setAutoFit(this.checked);" />フィット</label> ';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_template\').quotationByMenu(this)" title="これらのタグは、書き出し時に対応するトラックバックデータに変換されます。">';
    print '<option value="">▼関連記事タグを挿入する</option>';
    print
        '<option value="&lt;!--article--&gt;&lt;!--/article--&gt;">繰り返しの範囲 &lt;!--article--&gt;&lt;!--/article--&gt;</option>';
    print
        '<option value="&lt;!--title--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/title--&gt;">タイトル &lt;!--title--&gt;&lt;!--/title--&gt;</option>';
    print
        '<option value="&lt;!--description--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/description--&gt;">内容 &lt;!--description--&gt;&lt;!--/description--&gt;</option>';
    print
        '<option value="&lt;!--url--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/url--&gt;">URL &lt;!--url--&gt;&lt;!--/url--&gt;</option>';
    print
        '<option value="&lt;!--image--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/image--&gt;">サムネイル &lt;!--image--&gt;&lt;!--/image--&gt;</option>';
    print
        '<option value="&lt;!--mtime--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/mtime--&gt;">更新日時 &lt;!--mtime--&gt;&lt;!--/mtime--&gt;</option>';
    print '<option value=""></option>';
    print
        '<option value="&lt;!--pager--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/pager--&gt;">ページリスト(インライン) &lt;!--pager--&gt;&lt;!--/pager--&gt;</option>';
    print
        '<option value="&lt;!--pager type=&quot;list&quot; class=&quot;pager&quot;--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/pager--&gt;">ページリスト(リスト) &lt;!--pager type=&quot;list&quot;--&gt;&lt;!--/pager--&gt;</option>';
    print '<option value=""></option>';
    print
        '<option value="&lt;!--more--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/more--&gt;">もっとさがす &lt;!--more--&gt;&lt;!--/more--&gt;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot( '<!--article-->\n'
            . '<div class="related-article">\n'
            . '<!--image--><!--/image-->\n'
            . '<!--title--><!--head--><h4 class="related-article-head"><!--/head--><!--foot--></h4><!--/foot--><!--/title-->\n'
            . '<!--description--><!--head--><div class="related-article-body"><!--/head--><!--foot--></div><!--/foot--><!--/description-->\n'
            . '<!--url--><!--head--><div class="related-article-url"><!--/head--><!--foot--></div><!--/foot--><!--/url-->\n'
            . '</div>\n'
            . '<!--/article-->\n'
            . '<!--more--><!--head--><div class="related-article-more"><!--/head--><!--foot--></div><!--/foot--><!--/more-->\n'
        ) . '">テンプレート例</option>';
    print '<option value="'
        . $this->jsquot( '<dl class="log">\n'
            . '<!--article--><dt>\n'
            . '<!--image--><!--head--><span class="icon"><!--/head--><!--foot--></span><!--/foot--><!--/image--> \n'
            . '<!--title--><!--head--><span class="name"><!--/head--><!--foot--></span><!--/foot--><!--/title--> \n'
            . '<!--url--><!--head--><dd><!--/head--><!--foot--></dd><!--/foot--><!--/url-->\n'
            . '<dd>\n'
            . '<!--description--><!--/description-->\n'
            . '</dd>\n'
            . '<!--/article--></dl>\n'
            . '<!--more--><!--head--><div class="related-article-more"><!--/head--><!--foot--></div><!--/foot--><!--/more-->\n'
        ) . '">Vicuna CMS 互換テンプレート例</option>';
    print '</select>';
    require CMONOS::CGI_Lib::HTMLHelper;
    print HTMLHelper->new->html_helper_menu( $name . '_template' );

    if ( ref $frame::obj{'frame'} ) {
        my $sample = '';
        print
            ' <select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'',
            $name,
            '_template\').quotationByMenu(this)" title="これらのタグは、書き出し時に対応するフレームに変換されます。">';
        print
            '<option value="">▼フレームタグを挿入する</option>';
        foreach my $frid ( sort { $a <=> $b } keys %{ $frame::obj{'frame'} } )
        {
            $sample = $frid;
            print '<option value="&lt;!--frame id=&quot;', $frid,
                '&quot;--&gt;&lt;!--titlebar--&gt;&lt;!--/titlebar--&gt;&lt;!--contents--&gt;&lt;!--/contents--&gt;&lt;!--/frame--&gt;">ID : ',
                $frid, '</option>';
        }
        print '</select>';
        print
            '<div id="frame-tips"><label title="チェックするとフレームサンプルを表示します"><input type="checkbox" onclick="cmonos.element.item(\'framesample\').disappear(!this.checked);" /> フレームサンプルを表示する</label> <div id="framesample" style="display: none">';
        print $cgi::Deco->frame_menu( '', 'frame', '', '', 'ID' );
        print '</div>';
        print
            '<label title="チェックするとフレームタグの書き方を表示します"><input type="checkbox" onclick="cmonos.element.item(\'frametagsample\').disappear(!this.checked);" /> フレームタグの書き方を表示する</label> <table id="frametagsample" style="display: none"><tbody><tr><td id="sample-frame">';
        my ( $contents, $title ) = (
            '<strong>コンテンツ</strong>',
            '<strong>タイトル</strong>'
        );
        print $cgi::Deco->frame( 'frame', $sample, \$contents, \$title, 'no',
            '', 0, 'type', 'frame', 'titlenowrap', 1, 'contentsnowrap', 1 );
        print '</td><td id="sample-tag">';
        print
            '&lt;!--frame id=&quot;<strong>ID</strong>&quot;--&gt;<br />&lt;!--titlebar--&gt;<strong>タイトル</strong>&lt;!--/titlebar--&gt;<br />&lt;!--contents--&gt;<strong>コンテンツ</strong>&lt;!--/contents--&gt;<br />&lt;!--/frame--&gt;';
        print '</td></tr></tbody></table>';
        print '</div>';
    }

    print '</div></fieldset>';
    print $this->javascript( ( $this->{'cseEnabled'} )
        ? 'cmonos.element.tagClass(\'tr\',\'cse\',\'fieldset\',\'cse\').appear(true);cmonos.element.tagClass(\'tr\',\'gsa\').disappear(true);'
        : 'cmonos.element.tagClass(\'tr\',\'cse\',\'fieldset\',\'cse\').disappear(true);cmonos.element.tagClass(\'tr\',\'gsa\').appear(true);'
    );
    print '</fieldset>';
    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;
    if (   defined $main::data{ $this->{'id'} . '_quantity' }
        && $main::data{ $this->{'id'} . '_quantity' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_quantity' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'キーワード数を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_quantity' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_cacheLifetime' }
        && $main::data{ $this->{'id'} . '_cacheLifetime' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_cacheLifetime' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '更新間隔を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_cacheLifetime' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_count' }
        && $main::data{ $this->{'id'} . '_count' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_count' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '1ページあたりの表示数を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_count' };
        $is_valid = 0;
    }
    elsif ( !$main::data{ $this->{'id'} . '_count' }
        || $main::data{ $this->{'id'} . '_count' } < 0
        || $main::data{ $this->{'id'} . '_count' } > 10 )
    {
        $main::data{ $this->{'id'} . '_count' } = 10;
    }
    else {
        $main::data{ $this->{'id'} . '_count' }
            = int $main::data{ $this->{'id'} . '_count' };
    }
    $main::data{ $this->{'id'} . '_autoExtract' } = ''
        if !$main::data{ $this->{'id'} . '_autoExtract' };
    $main::data{ $this->{'id'} . '_fromWholePage' } = ''
        if !$main::data{ $this->{'id'} . '_fromWholePage' };
    $main::data{ $this->{'id'} . '_complement' } = ''
        if !$main::data{ $this->{'id'} . '_complement' };
    $main::data{ $this->{'id'} . '_cseEnabled' } = ''
        if !$main::data{ $this->{'id'} . '_cseEnabled' };
    $main::data{ $this->{'id'} . '_selfTab' } = ''
        if !$main::data{ $this->{'id'} . '_selfTab' };
    $main::data{ $this->{'id'} . '_parentTab' } = ''
        if !$main::data{ $this->{'id'} . '_parentTab' };
    $main::data{ $this->{'id'} . '_siteTab' } = ''
        if !$main::data{ $this->{'id'} . '_siteTab' };
    $main::data{ $this->{'id'} . '_webTab' } = ''
        if !$main::data{ $this->{'id'} . '_webTab' };
    $main::data{ $this->{'id'} . '_siteTab' } = 1
        if !$main::data{ $this->{'id'} . '_selfTab' }
        && !$main::data{ $this->{'id'} . '_parentTab' }
        && !$main::data{ $this->{'id'} . '_siteTab' }
        && !$main::data{ $this->{'id'} . '_webTab' };
    $main::data{ $this->{'id'} . '_autoExtract' } = ''
        if !$main::data{ $this->{'id'} . '_autoExtract' };
    $main::data{ $this->{'id'} . '_fromWholePage' } = ''
        if !$main::data{ $this->{'id'} . '_fromWholePage' };
    $main::data{ $this->{'id'} . '_emptySSI' } = ''
        if !$main::data{ $this->{'id'} . '_emptySSI' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $this->detag( \$main::data{ $this->{'id'} . '_webLabel' } )
        if defined $main::data{ $this->{'id'} . '_webLabel' }
        && $main::data{ $this->{'id'} . '_webLabel' };
    return $is_valid;
}

######################################################################
#	(7) obj->search_form;
sub search_form_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
sub update_enabled ($) {
    my $this = shift;
    return ( $this->{'cseEnabled'} ) ? 1 : 0;
}

sub is_secure_user_for_update ($) {
    my $this = shift;
    return 1;
}

######################################################################
#	(11) obj->update;
sub update ($;$) {
    my ( $this, $is_ajax ) = @_;
    if ( $this->{'cseEnabled'} && !$this->is_short_parameters ) {
        my $data_ref = $this->get_field_data;
        if (   ref $data_ref
            && defined $data_ref->{'str'}
            && $data_ref->{'str'} =~ /\S/ )
        {
            $main::target = $this->default_target if !$main::target;
            return {
                'status'  => 'success',
                'content' => $this->get_related_pages(
                    $data_ref->{'str'}, $main::target, $main::start,
                    '',                 $main::c,      $main::n,
                    $main::refresh
                ),
                'target' => $main::target,
            };
        }
    }
    return { 'status' => 'error' };
}

1;
