package Select;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールドモジュール（メニュー・選択ボタン共通）
# Select.pm 1.1.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
#　support@cmonos.jp
#　http://cmonos.jp/
# 最終更新日：2016-07-08
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    return;
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    return 1
        if ( defined $main::search{ $this->{'id'} }{'str'}
        && $main::search{ $this->{'id'} }{'str'} ne '' )
        || ( ref $main::search{ $this->{'id'} }{'str'}
        && @{ $main::search{ $this->{'id'} }{'str'} } > 0 );
    return 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    my ( $pat, @str );
    return 1
        unless ( defined $main::search{ $this->{'id'} }{'str'}
        && $main::search{ $this->{'id'} }{'str'} ne '' )
        || ( ref $main::search{ $this->{'id'} }{'str'}
        && @{ $main::search{ $this->{'id'} }{'str'} } > 0 );
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'str'} )
        if !ref $main::search{ $this->{'id'} }{'str'};
    @str = split( /\x0A/, $$str );
    foreach $pat ( @{ $main::search{ $this->{'id'} }{'str'} } ) {
        next if $pat eq '';
        if ( grep( $_ eq $pat, @str ) > 0 ) {
            return 1
                if !defined $main::search{ $this->{'id'} }{'mode'}
                || $main::search{ $this->{'id'} }{'mode'} ne 'and';
        }
        elsif ( defined $main::search{ $this->{'id'} }{'mode'}
            && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
        {
            return 0;
        }
    }
    if ( defined $main::search{ $this->{'id'} }{'mode'}
        && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
    {
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my ( $form, @temp );
    @temp = ();
    if (   defined $main::data{ $this->{'id'} }{'str'}
        && !ref $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'} =~ /\x0A/ )
    {
        @temp = split( /\x0A/, $main::data{ $this->{'id'} }{'str'} );
    }
    elsif ( ref $main::data{ $this->{'id'} }{'str'}
        && @{ $main::data{ $this->{'id'} }{'str'} } > 0 )
    {
        push( @temp, @{ $main::data{ $this->{'id'} }{'str'} } );
    }
    elsif ( defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'} ne '' )
    {
        push( @temp, $main::data{ $this->{'id'} }{'str'} );
    }
    $form = $this->field_header( 50,
        ( ( $this->is_one_to_one ) ? 'data:' . $this->{'id'} . ':str' : '' )
    );
    $form .= $this->select_menu( 'data', $this->{'multiple'}, \@temp,
        $this->{'is_invalid_field'}{'str'} );
    $form .= $this->field_footer;
    return $form;
}

sub is_one_to_one ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    if ( defined $main::data{ $this->{'id'} }{'str'}
        && !ref $main::data{ $this->{'id'} }{'str'} )
    {
        if ( $main::data{ $this->{'id'} }{'str'} =~ /\x0A/s ) {
            $main::data{ $this->{'id'} }{'str'}
                = [ split( /\x0A/s, $main::data{ $this->{'id'} }{'str'} ) ];
        }
        else {
            $this->scalar_to_array( \$main::data{ $this->{'id'} }{'str'} );
        }
    }
    my @temp = ();
    my @menu
        = ( $this->{'default'} ) ? split( /\x0A/, $this->{'default'} ) : ();
    foreach my $v ( @{ $main::data{ $this->{'id'} }{'str'} } ) {
        push( @temp, $v )
            if !grep( $_ eq $v, @temp ) && grep( $_ eq $v, @menu );
    }
    $main::data{ $this->{'id'} }{'str'}
        = (@temp)
        ? ( $this->{'multiple'} )
            ? join( "\x0A", @temp )
            : shift(@temp)
        : '';
    $this->escape_data_tag('str');
    if ( $this->is_not_empty('str') && $this->is_not_too_long('str') ) {
        $cookie::data{ 'data:' . $this->{'id'} . ':str' }
            = $main::data{ $this->{'id'} }{'str'}
            if defined $this->{'cookie'}
            && $this->{'cookie'}
            && defined $main::set_cookie
            && $main::set_cookie;
        return 1;
    }
    else {
        $this->{'is_invalid_field'}{'str'} = 1;
        return 0;
    }
}

sub is_not_empty ($$) {
    my ( $this, $name ) = @_;
    if (   defined $this->{'required'}
        && $this->{'required'}
        && ( !defined $main::data{ $this->{'id'} }{$name}
            || $main::data{ $this->{'id'} }{$name} eq '' )
        )
    {
        if ($default::english) {
            push(
                @{ $cgi::action->{'dialog'} },
                '"'
                    . (
                    ( defined $this->{'name'} && $this->{'name'} )
                    ? $this->{'name'}
                    : ''
                    )
                    . '" field is required.'
            ) if ref $cgi::action;
        }
        elsif ( $this->{'default'} !~ /\x0A/ ) {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( defined $this->{'name'} && $this->{'name'} )
                    ? $this->{'name'} . 'を'
                    : ''
                    )
                    . '確認してください。'
            ) if ref $cgi::action;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( defined $this->{'name'} && $this->{'name'} )
                    ? $this->{'name'} . 'が'
                    : ''
                    )
                    . '選択されていません。'
            ) if ref $cgi::action;
        }
        $this->{'is_invalid_field'}{$name} = 1;
        return 0;
    }
    return 1;
}

######################################################################
#	(4)-1 obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag($str) if !defined $str || $str eq '';
    $str = $this->fix_value($str);

    #単位を追加
    my @str = split( /\x0A/, $str );
    map( $_ .= '<span class="unit">' . $this->{'unit'} . '</span>', @str )
        if defined $this->{'unit'} && $this->{'unit'} ne '';

    my $data = '';
    if ( @str && @str > 1 ) {
        if ( !$this->{'listtype'} || $this->{'listtype'} eq 'csv' ) {
            $data = join( ', ', @str );
        }
        elsif ( $this->{'listtype'} eq 'ul' ) {
            $data = '<ul><li>' . join( '</li><li>', @str ) . '</li></ul>';
        }
        elsif ( $this->{'listtype'} eq 'ol' ) {
            $data = '<ol><li>' . join( '</li><li>', @str ) . '</li></ol>';
        }
    }
    else {
        $data = $str[0];
    }

    return $this->field_tag(
        $this->data_tag_from_hash( 'str', $str )
            . $this->style(
            $data,                $this->{'style'}, $this->{'fontsize'},
            $this->{'fontcolor'}, $this->{'fontface'}
            )
    );
}

#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';

    $str = $this->fix_value($str);
    my @str = split( /\x0A/, $str );
    map( $_ .= $this->{'unit'}, @str )
        if defined $this->{'unit'} && $this->{'unit'};
    if ( @str && @str > 1 ) {
        if ( !$this->{'listtype'} || $this->{'listtype'} eq 'csv' ) {
            $str = join( ', ', @str );
        }
        elsif ( $this->{'listtype'} eq 'ul' ) {
            $str = "\x0A・" . join( "\x0A・", @str ) . "\x0A";
        }
        elsif ( $this->{'listtype'} eq 'ol' ) {
            my $n = 1;
            my $s;
            $str = '';
            foreach $s (@str) { $str .= "\x0A" . ( $n++ ) . ') ' . $s; }
        }
    }
    else {
        $str = $str[0];
    }
    $str = '[' . $this->name . "]\x0A" . $str;
    $str =~ s/[\x0A]*\Z/\x0A\x0A/s;

    return $str;
}

#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    $str = $this->fix_value($str);
    my @str = split( /\x0A/, $str );
    map( $_ .= $this->{'unit'}, @str )
        if defined $this->{'unit'} && $this->{'unit'};
    return join( ', ', @str );
}

sub fix_value ($$) {
    my ( $this, $str ) = @_;
    return $this->escape($str);
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;
    $this->tag_fix( \$main::data{ $this->{'id'} . '_unit' }, 2 )
        if defined $main::data{ $this->{'id'} . '_unit' }
        && $main::data{ $this->{'id'} . '_unit' };

    #チェックボックス
    $main::data{ $this->{'id'} . '_multiple' } = ''
        if !defined $main::data{ $this->{'id'} . '_multiple' }
        || $main::data{ $this->{'id'} . '_multiple' } eq '';
    $main::data{ $this->{'id'} . '_listtype' } = 'csv'
        if !defined $main::data{ $this->{'id'} . '_listtype' }
        || $main::data{ $this->{'id'} . '_listtype' } eq '';
    $main::data{ $this->{'id'} . '_defaultSearchOparatorFixed' } = ''
        if !$setting::field_for_mail
        && (
        !defined $main::data{ $this->{'id'} . '_defaultSearchOparatorFixed' }
        || $main::data{ $this->{'id'} . '_defaultSearchOparatorFixed' } eq
        '' );

    #フォントチェック
    $is_valid = 0 if !$this->is_valid_font_setting;

    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    return $is_valid;
}

######################################################################
#	(5) obj->print_setting_form
sub _print_setting_form ($$) {
    my ( $this, $name ) = @_;
    print '<fieldset>';
    print '<legend>複数選択可能な場合の表示</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="'
        . $name
        . '_listtype" value="csv"'
        . (
        (   !$this->{'listtype'}
                || ( $this->{'listtype'} && $this->{'listtype'} eq 'csv' )
        ) ? ' checked="checked"' : ''
        ) . ' /> カンマ区切りテキスト</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_listtype" value="ul"'
        . ( ( $this->{'listtype'} && $this->{'listtype'} eq 'ul' )
        ? ' checked="checked"'
        : '' )
        . ' /> リスト(&lt;ul&gt;)</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_listtype" value="ol"'
        . ( ( $this->{'listtype'} && $this->{'listtype'} eq 'ol' )
        ? ' checked="checked"'
        : '' )
        . ' /> 番号付リスト(&lt;ol&gt;)</label></li>';
    print '</ol>';
    print '</fieldset>';

    if ( !$setting::field_for_mail ) {
        print '<fieldset>';
        print '<legend><label for="' . $name
            . '_defaultSearchOparator">検索オプションのデフォルト</label></legend>';
        print $this->mk_select_menu(
            $name . '_defaultSearchOparator',
            '', '',
            $this->{'defaultSearchOparator'},
            'and' => (
                ($default::english) ? 'Matches on all selection'
                : '全ての選択肢に一致'
            ),
            'or' => (
                ($default::english) ? 'Matches on any selection'
                : 'いずれかの選択肢に一致'
            )
        );
        print ' <label><input type="checkbox" name="'
            . $name
            . '_defaultSearchOparatorFixed" id="'
            . $name
            . '_defaultSearchOparatorFixed" value="1"'
            . ( ( $this->{'defaultSearchOparatorFixed'} )
            ? ' checked="checked"'
            : '' )
            . ' /> 固定する</label>';
        print '</fieldset>';
    }
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
    my $this = shift;
    my ($form);
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'str'} );
    $form
        = '<tr><td class="field-name">'
        . ( ( $this->is_one_to_one )
        ? '<label for="search:'
            . $this->{'id'}
            . ':str">'
            . $this->{'name'}
            . '</label>'
        : '<span class="datatitle">' . $this->{'name'} . '</span>' )
        . '</td><td class="field">';
    $form .= $this->select_menu( 'search', 1,
        $main::search{ $this->{'id'} }{'str'} );
    if ( defined $this->{'multiple'} && $this->{'multiple'} ) {
        if (   $this->{'defaultSearchOparator'}
            && $this->{'defaultSearchOparatorFixed'} )
        {
            $form
                .= '<input type="hidden" name="search:'
                . $this->{'id'}
                . ':mode" value="'
                . (
                ( $this->{'defaultSearchOparator'} eq 'or' ) ? 'or' : 'and' )
                . '" />';
        }
        else {
            $main::search{ $this->{'id'} }{'mode'}
                = $this->{'defaultSearchOparator'}
                if !$main::search{ $this->{'id'} }{'mode'}
                && $this->{'defaultSearchOparator'};
            $form .= $this->mk_select_menu(
                'search:' . $this->{'id'} . ':mode',
                '', '',
                $main::search{ $this->{'id'} }{'mode'},
                'and' => (
                    ($default::english) ? 'Matches on all selection'
                    : '全ての選択肢に一致'
                ),
                'or' => (
                    ($default::english) ? 'Matches on any selection'
                    : 'いずれかの選択肢に一致'
                )
            );
        }
    }
    $form .= '</td></tr>';
    return $form;
}

######################################################################
#	sample
sub sample ($$) {
    my ( $this, $str ) = @_;
    return ( defined $str ) ? $str : '';
}

1;
