package ShoppingCartForDB;
require CMONOS::CGI_Lib::Field::ShoppingCartBase;
@ISA = qw(ShoppingCartBase);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# フィールド定義モジュール（DBタイプCGI用ショッピングカート）
# ShoppingCartForDB.pm 1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-05-07
######################################################################
sub validity_period ($$$$) {
    my ( $this, $data, $c, $n ) = @_;
    if (   $this->{'periodfield'}
        && ref $this->{'field_obj'}->{ $this->{'periodfield'} }
        && $this->{'field_obj'}->{ $this->{'periodfield'} }->{'class'}
        && $this->{'field_obj'}->{ $this->{'periodfield'} }->{'class'} eq
        'time_span' )
    {
        my $db = $this->{'field_obj'}->{ $this->{'periodfield'} }->db;
        if ($db) {
            my $period = '';
            my $db_dir
                = ( $default::lib eq 'TableMaker' && $c )
                ? $default::db . '/' . $c
                : $default::db;
            if ( ref $cgi::action && ref $cgi::action->{'DB'} ) {
                if ( !ref tied %{ $cgi::action->{'DB'}{$c}{$db} } ) {
                    tie(%{ $cgi::action->{'DB'}{$c}{$db} },
                        $env::dbm_file, "$db_dir/$db",
                        O_RDONLY,       $env::dbm_mode
                    );
                }
                $period = $this->decode_utf8(
                    $cgi::action->{'DB'}{$c}{$db}{ $this->encode_utf8($n) } );
            }
            else {
                my %db;
                tie( %db, $env::dbm_file, $db_dir . '/' . $db,
                    O_RDONLY, $env::dbm_mode );
                if ( ref tied %db ) {
                    $period
                        = $this->decode_utf8( $db{ $this->encode_utf8($n) } );
                }
                untie %db;
            }
            return $period;
        }
    }
    return '';
}

sub _sc_period_is_ok ($$$$) {
    my ( $this, $data, $c, $n ) = @_;
    return 1;
}

######################################################################
#	(11) obj->update;
sub update_enabled ($) {
    my $this = shift;
    return ($defalut::static) ? 0 : 1;
}

sub is_short_parameters ($) {
    return 0;
}

sub is_secure_user_for_update ($) {
    my $this = shift;
    return (   $defalut::static
            || $this->is_short_parameters
            || !defined $this->{'formauthority'}
            || $this->{'formauthority'} eq ''
            || !$this->is_secure( $this->{'formauthority'} ) ) ? 0 : 1;
}

sub update ($;$) {
    my ( $this, $is_ajax ) = @_;
    return ($is_ajax)
        ? {
        'status' => 'error',
        'error_fields' =>
            $this->get_invalid_field_list( 'data:' . $this->{'id'} ),
        'message'          => $this->get_message_string,
        'authorized_level' => $this->get_authorized_level
        }
        : 0
        if !$this->is_valid_data;
    my ( %db, $db, $n, $done, $msg );
    $msg           = '';
    $db            = $this->get_db_directory;
    $n             = $main::n;
    $env::dbm_file = 'AnyDBM_File'
        if !defined $env::dbm_file || $env::dbm_file eq '';
    $env::dbm_mode = 0666 if !defined $env::dbm_mode || $env::dbm_mode eq '';
    tie(%db, $env::dbm_file,
        $db . '/showcase',
        O_RDWR | O_CREAT,
        $env::dbm_mode
    );

    if ( ref tied %db ) {
        my %data = $this->elements(
            $this->decode_utf8( $db{ $this->encode_utf8($n) } ) );
        if ($data{'digitalcontent'}
            || (   !$data{'digitalContentRequired'}
                && !$this->{'digitalContentRequired'} )
            )
        {
            foreach my $k (
                'weight',         'papersize',
                'thickness',      'condition',
                'availability',   'multiple',
                'option',         'foldertype',
                'digitalcontent', 'digitalContentRequired'
                )
            {
                if ( defined $data{$k} ) {
                    $data{$k} =~ s/\x0A/\&#10;/sg;
                    $main::data{ $this->{'id'} }{'str'}
                        .= $k . ':' . $data{$k} . "\x0A";
                }
            }
            $db{ $this->encode_utf8($n) }
                = $this->encode_utf8( $main::data{ $this->{'id'} }{'str'} );
            $done = 1;
        }
        else {
            $msg = 'デジタルコンテンツが存在しません。';
        }
        undef %{ $main::data{ $this->{'id'} } };
        undef %main::data;
    }
    else {
        $msg = 'データベースに接続できませんでした。';
    }
    untie %db;
    if ($done) {
        $this->post_update;
        return ($is_ajax)
            ? {
            'status'           => 'success',
            'reset_disabled'   => 1,
            'authorized_level' => $this->get_authorized_level
            }
            : 1;
    }
    else {
        return ($is_ajax)
            ? {
            'status'  => 'error',
            'message' => $this->name(1)
                . ' の更新に失敗しました。'
                . $msg,
            'authorized_level' => $this->get_authorized_level
            }
            : 0;
    }
}

sub editor_enabled ($) {
    my $this = shift;
    return 0;
}

sub is_secure_user_for_edit ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	CMONOS::CGI_Lib::UserGeneratedField からのコピー
sub get_db_directory ($) {
    my $this = shift;
    return '.';
}

sub get_invalid_field_list ($$) {
    my ( $this, $prefix ) = @_;
    my @invalid_fields
        = map { $prefix . ':' . $_ } keys %{ $this->{'is_invalid_field'} };
    delete $this->{'is_invalid_field'};
    return (@invalid_fields) ? join( ';', @invalid_fields ) : '';
}

sub get_message_string ($) {
    my $this = shift;
    if ( ref $cgi::action ) {
        my @message = $cgi::action->dialog;
        if (@message) {
            map {
                $_ =~ s/\\n//g;
                $_ =~ s/;//g;
            } @message;
            return join( ';', @message );
        }
    }
    return '';
}

sub get_viewer_url ($;$$) {
    my $this = shift;
    return $this->my_url;
}

sub get_authorized_level ($) {
    my $this = shift;
    if ( $this->is_master ) {
        return 5;
    }
    elsif ( $this->is_owner ) {
        return 4;
    }
    elsif ( $this->is_one_of_owners ) {
        return 3;
    }
    elsif ( $this->is_staff ) {
        return 2;
    }
    elsif ( $this->is_registered_user ) {
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
sub get_digital_content_directory_path ($) {
    my $this = shift;
    return $default::db . '/digital-content';
}

1;
