package Skype;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（Skype）
# Skype.pm 1.0.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-04-16
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    return;
}

######################################################################
#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    my ( $modifier, $p );
    return 1
        if !defined $main::search{ $this->{'id'} }{'str'}
        || $main::search{ $this->{'id'} }{'str'} eq '';
    if ( !ref $this->{'pattern'} ) {
        $main::search{ $this->{'id'} }{'str'}
            = $this->z_to_h( $main::search{ $this->{'id'} }{'str'} );
        @{ $this->{'pattern'} }
            = $this->make_patterns( \$main::search{ $this->{'id'} }{'str'},
            0, $main::search{ $this->{'id'} }{'mode'} );
    }
    return $this->pattern_matched( $str, $this->{'pattern'}, 1,
        $main::search{ $this->{'id'} }{'mode'} );
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my ( $name, $form );

    #名前にデータIDを埋め込む
    $name = 'data:' . $this->{'id'} . ':str';

    #フィールドネーム+ヘッダ
    $form = $this->field_header( '50', $name );

    #デフォルト作成
    $main::data{ $this->{'id'} }{'str'} = $this->{'default'}
        if ( !defined $status || $status eq '' )
        && ( !defined $main::data{ $this->{'id'} }{'str'}
        || $main::data{ $this->{'id'} }{'str'} eq '' );

    $form
        .= '<input type="text" id="'
        . $name
        . '" name="'
        . $name
        . '" size="40" maxlength="32"';
    $form
        .= ' value="'
        . $this->escape( $main::data{ $this->{'id'} }{'str'} ) . '"'
        if defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'};
    $form .= ' class="invalid-field"' if $this->{'is_invalid_field'}{'str'};
    $form .= ' placeholder="' . $this->escape( $this->{'placeholder'} ) . '"'
        if defined $this->{'placeholder'} && $this->{'placeholder'} ne '';
    $form .= ' required="required"' if $this->{'required'};
    $form .= ' />';

    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};

    $this->escape_data_tag('str');

    #半角変換
    $main::data{ $this->{'id'} }{'str'}
        = $this->z_to_h( $main::data{ $this->{'id'} }{'str'} );
    $main::data{ $this->{'id'} }{'str'} =~ s/\s+//gs;

    #必須項目
    my $is_valid = ( $this->is_not_empty('str') ) ? 1 : 0;

    #書式チェック
    if ( $main::data{ $this->{'id'} }{'str'} ne '' ) {
        if ( $main::data{ $this->{'id'} }{'str'}
            =~ /^[a-zA-Z][a-zA-Z0-9.,\-_]{5,31}$/ )
        {
            $main::data{ $this->{'id'} }{'str'}
                = lc $main::data{ $this->{'id'} }{'str'};
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( $this->{'name'} )
                    ? $this->{'name'}
                    : 'Skype アカウント'
                    )
                    . 'を確認してください。英字で始まる 6文字以上 32文字以内の英数字文字列にしてください。'
            ) if ref $cgi::action;
            $is_valid = 0;
        }

        #フィルターのチェック
        if ($this->{'filter'}
            && $this->is_taboo_string(
                $main::data{ $this->{'id'} }{'str'}, $this->{'filter'},
                $this->{'filterRegexp'}
            )
            )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( defined $this->{'name'} && $this->{'name'} )
                    ? $this->{'name'}
                    : 'Skype アカウント'
                    )
                    . 'を確認してください。禁止されたアカウントです。'
            ) if ref $cgi::action;
            $is_valid = 0;
        }
    }

    if ($is_valid) {
        $cookie::data{ 'data:' . $this->{'id'} . ':str' }
            = $main::data{ $this->{'id'} }{'str'}
            if $this->{'cookie'} && $main::set_cookie;
    }
    else {
        $this->{'is_invalid_field'}{'str'} = 1;
    }
    return $is_valid;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag($str) if !defined $str || $str eq '';

    my $id = $this->mk_user_generated_field_id( $c, $n, 'skype' );
    my $button = '';

    $button
        .= '<script type="text/javascript" src="//cdn.dev.skype.com/uri/skype-uri.js"></script>'
        if !$this->{'javascript_printed'}{ $cgi::output || 'STDOUT' }++;

    $button .= '<div id="' . $id . '">';
    $button .= '<script type="text/javascript">';
    $button .= 'Skype.ui({';
    $button .= '"name": "' . ( $this->{'buttonName'} || 'call' ) . '",';
    $button .= '"element": "' . $id . '",';
    $button .= '"participants": ["' . $str . '"]';
    $button .= ',"imageColor": "' . $this->{'buttonColor'} . '"'
        if $this->{'buttonColor'};
    $button .= ',"imageSize": ' . $this->{'buttonSize'}
        if $this->{'buttonSize'};
    $button .= '});';
    $button .= '</script>';
    $button .= '</div>';
    $button .= '</div>';

    return $this->field_tag(
        $this->style(
            $this->data_tag( 'str', $str ), $this->{'style'},
            $this->{'fontsize'}, $this->{'fontcolor'},
            $this->{'fontface'}
            )
            . $button
    );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->{'default'} =~ s/\x0A//sg if $this->{'default'};
    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>入力欄設定</legend>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_default">デフォルト</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_default" id="'
        . $name
        . '_default" value="'
        . $this->escape( $this->{'default'} )
        . '" size="40" maxlength="32" title="入力欄のデフォルトの値を設定します。" />';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_placeholder">プレースホルダ</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_placeholder" id="'
        . $name
        . '_placeholder" size="40" title="入力欄の placeholder 属性の値を設定します。" value="'
        . $this->escape( $this->{'placeholder'} ) . '" />';
    print '</fieldset>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_filter">禁止アカウント</label></legend>';
    print '<textarea name="'
        . $name
        . '_filterwords" id="'
        . $name
        . '_filter" cols="40" rows="4" wrap="off">'
        . $this->escape( $this->{'filterwords'} )
        . '</textarea>';
    print
        '<label class="auto-fit" title="高さを内容に合わせる"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_filterwords\').setAutoFit(this.checked);" />フィット</label>';
    print '<div class="note">禁止アカウントごとに改行</div>';
    print '<div class="extra-field"><label><input type="checkbox" name="'
        . $name
        . '_filterRegexp" value="1"'
        . ( ( defined $this->{'filterRegexp'} && $this->{'filterRegexp'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 正規表現を使用する</label></div>';
    print '</fieldset>';

    if ( !defined $html_disabled || !$html_disabled ) {
        print '<fieldset>';
        print '<legend>ボタン設定</legend>';
        print '<table class="field-table" id="import-settings">';
        print '<tbody>';
        print '<tr>';
        print '<td class="field-name"><label for="' . $name
            . '_buttonName">タイプ</label></td>';
        print '<td class="field">';
        print $this->mk_select_menu(
            $name . '_buttonName', '', '', $this->{'buttonName'},
            'call'     => '通話を開始',
            'chat'     => 'チャットを開始',
            'dropdown' => 'ドロップダウンメニューで選択',
        );
        print '</td>';
        print '</tr>';
        print '<tr>';
        print '<td class="field-name"><label for="' . $name
            . '_buttonColor">色</label></td>';
        print '<td class="field">';
        print $this->mk_select_menu(
            $name . '_buttonColor', '', '', $this->{'buttonColor'},
            ''      => '標準(青)',
            'white' => '白抜き',
        );
        print '</td>';
        print '</tr>';
        print '<tr>';
        print '<td class="field-name"><label for="' . $name
            . '_buttonSize">サイズ</label></td>';
        print '<td class="field">';
        print $this->mk_select_menu(
            $name . '_buttonSize', '', '', $this->{'buttonSize'},
            ''   => '標準(16px)',
            '10' => '10px',
            '12' => '12px',
            '14' => '14px',
            '16' => '16px',
            '24' => '24px',
            '32' => '32px',
        );
        print '</td>';
        print '</tr>';
        print '</tbody>';
        print '</table>';
        print '</fieldset>';

        #文字設定
        $this->print_font_setting_form($name);
    }
    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;

    #デフォルトチェック
    if ( defined $main::data{ $this->{'id'} . '_default' }
        && $main::data{ $this->{'id'} . '_default' } ne '' )
    {
        $main::data{ $this->{'id'} . '_default' }
            = $this->z_to_h( $main::data{ $this->{'id'} . '_default' } );
        $main::data{ $this->{'id'} . '_default' } =~ s/\s+//gs;
        $this->detag( \$main::data{ $this->{'id'} . '_default' } );
        if ( $main::data{ $this->{'id'} . '_default' }
            =~ /^[a-zA-Z][a-zA-Z0-9.,\-_]{5,31}$/ )
        {
            $main::data{ $this->{'id'} . '_default' }
                = lc $main::data{ $this->{'id'} . '_default' };
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                'デフォルトの値を確認してください。英字で始まる 6文字以上 32文字以内の英数字文字列にしてください。'
            ) if ref $cgi::action;
            $is_valid = 0;
        }
    }

    #タグの除去
    $main::data{ $this->{'id'} . '_placeholder' } =~ s/[\x0A\x0D]+//sg
        if defined $main::data{ $this->{'id'} . '_placeholder' };

    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_filter' }
        = $this->z_to_h( $main::data{ $this->{'id'} . '_filter' } )
        if $main::data{ $this->{'id'} . '_filter' };

    $main::data{ $this->{'id'} . '_buttonName' } = 'call'
        if !$main::data{ $this->{'id'} . '_buttonName' }
        || !grep( $_ eq $main::data{ $this->{'id'} . '_buttonName' },
        'call', 'chat', 'dropdown' );
    $main::data{ $this->{'id'} . '_buttonColor' } = ''
        if !$main::data{ $this->{'id'} . '_buttonColor' }
        || $main::data{ $this->{'id'} . '_buttonColor' } ne 'white';
    $main::data{ $this->{'id'} . '_buttonSize' } = ''
        if !$main::data{ $this->{'id'} . '_buttonSize' }
        || !grep( $_ eq $main::data{ $this->{'id'} . '_buttonSize' },
        '10', '12', '14', '16', '24', '32' );

    $is_valid = 0 if !$this->is_valid_font_setting;
    return $is_valid;
}

######################################################################
#	sample
sub sample ($$) {
    my ( $this, $str ) = @_;
    return ( defined $str ) ? $str : '';
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'text_skype', 'Skype', 'Skype' );
}

1;
