package SocialBookmarkBase;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（ソーシャルブックマーク共通）
# SocialBookmarkBase.pm 1.0.2
# Copyright (C) 2008-2017 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-12-10
######################################################################
sub get_sbm_template ($) {
my $this = shift;
return <<TMP;
<a href="//b.hatena.ne.jp/entry/<url>" class="hatena-bookmark-button" data-hatena-bookmark-title="<title>" data-hatena-bookmark-layout="standard" title="このエントリーをはてなブックマークに追加"><img src="//b.st-hatena.com/images/entry-button/button-only.gif" alt="このエントリーをはてなブックマークに追加" width="20" height="20" style="border: none;" /></a><script type="text/javascript" src="//b.st-hatena.com/js/bookmark_button.js" charset="utf-8" async="async"></script>

<a href="//twitter.com/share" class="twitter-share-button" data-count="horizontal" data-lang="ja">Tweet</a><script type="text/javascript" src="//platform.twitter.com/widgets.js"></script>

<iframe src="//www.facebook.com/plugins/like.php?href=<encoded_url>&amp;send=false&amp;layout=button_count&amp;width=130&amp;show_faces=true&amp;action=like&amp;colorscheme=light&amp;font&amp;height=21" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:130px; height:21px;" allowTransparency="true"></iframe>

<div class="g-plusone" data-size="standard" data-count="true"></div><script type="text/javascript" src="https://apis.google.com/js/plusone.js"></script>
TMP
}

sub print_sbm_selector ($) {
my $this = shift;
print '<option value="' . $this->escape('<a href="//b.hatena.ne.jp/entry/<url>" class="hatena-bookmark-button" data-hatena-bookmark-title="<title>" data-hatena-bookmark-layout="standard" title="このエントリーをはてなブックマークに追加"><img src="//b.st-hatena.com/images/entry-button/button-only.gif" alt="このエントリーをはてなブックマークに追加" width="20" height="20" style="border: none;" /></a><script type="text/javascript" src="//b.st-hatena.com/js/bookmark_button.js" charset="utf-8" async="async"></script>') . '">はてなブックマーク</option>';
print '<option value="' . $this->escape('<a href="//twitter.com/share" class="twitter-share-button" data-count="horizontal" data-lang="ja">Tweet</a><script type="text/javascript" src="//platform.twitter.com/widgets.js"></script>') . '">ツイートする</option>';
print '<option value="' . $this->escape('<div class="g-plusone" data-size="standard" data-count="true"></div><script type="text/javascript" src="https://apis.google.com/js/plusone.js"></script>') . '">Google +1 ボタン</option>';
print '<option value="' . $this->escape('<iframe src="//www.facebook.com/plugins/like.php?href=<encoded_url>&amp;send=false&amp;layout=button_count&amp;width=130&amp;show_faces=true&amp;action=like&amp;colorscheme=light&amp;font&amp;height=21" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:130px; height:21px;" allowTransparency="true"></iframe>') . '">Facebook いいね！ ボタン</option>';
}

#旧版はてブ対策
sub hateb_check ($) {
my $this = shift;
my $hateb = $env::icon_dir . '/b_entry.gif';
if (!-f $hateb) {
	my $original_img = 'http://d.hatena.ne.jp/images/b_entry.gif';
	require CMONOS::CGI_Lib::HTTP_Client;
	my $res = HTTP_Client->new->request('GET' => $original_img);
	if ($res->is_success) {
		$this->write_file($hateb,$res->content,1);
	} else {
		return $original_img;
	}
}
return $this->path_change($hateb,$ENV{'SCRIPT_NAME'},'abs');
}

######################################################################
sub _set ($$) {
my $this = shift;
$this->{'elements'} = 1;
return;
}

######################################################################
#	(1) obj->match(str);
sub match_enabled ($) {
my $this = shift;
return 0;
}

sub match ($;$) {
my($this,$str) = @_;
return 1
}

######################################################################
#	(2) obj->form;
sub form {
my($this,$status) = @_;
return '' if $this->{'enabled'} && $this->{'enabled'} == 2;
$main::data{$this->{'id'}}{'enabled'} = 1 if (!defined $status || $status eq '') && !defined $main::data{$this->{'id'}}{'enabled'} && $this->{'enabled'};

#フィールドネーム+ヘッダ
my $form = $this->field_header('50');
$form .= '<label><input type="checkbox" name="option:' . $this->{'id'} . ':enabled" value="1"' . (($main::data{$this->{'id'}}{'enabled'}) ? ' checked="checked"' : '') . ' /> 使用する</label>';
$form .= $this->field_footer;
return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
my $this = shift;
%{$main::data{$this->{'id'}}} = ();
$main::data{$this->{'id'}}{'title'} = $this->get_sbm_title;
$main::data{$this->{'id'}}{'enabled'} = ($this->{'enabled'} && $this->{'enabled'} == 2) ? 1 : ($main::option{$this->{'id'}}{'enabled'}) ? 1 : 0;

#データ整形
$this->data();
return 1;
}

sub get_sbm_title ($) {
my $this = shift;
my $title_id = $this->get_title_field_id;
my $title = '';
if (defined $title_id && $title_id ne '') {
	if (ref $this->{'input_hash'}) {
		$title = $this->{'input_hash'}{$title_id}{'str'} if ref $this->{'input_hash'}{$title_id} && defined $this->{'input_hash'}{$title_id}{'str'};
	} elsif (defined $main::data{$title_id}{'str'}) {
		$title = $main::data{$title_id}{'str'};
	}
}
if ($title ne '') {
	$this->text_color(\$title);
	$this->detag(\$title);
	$title =~ s/[\x09\x0A\x0C\x0D\x20]+/ /g;
} else {
	$title = $this->get_spare_title;
}
return $title;
}

sub get_title_field_id ($) {
my $this = shift;
return ($default::static) ? $this->{'field_for'}->{'title'} : (defined $this->{'field_for'}->{'title'} && $this->{'field_for'}->{'title'} ne '') ? $this->{'field_for'}->{'title'} : $this->{'field_for'}->{'key'};
}

sub get_spare_title ($) {
my $this = shift;
return '';
}

######################################################################
#	(4)-1 obj->usual_format(str);
sub usual_format {
my($this,$str,$path,$c,$n) = @_;
my %data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
if (!defined $data{'enabled'}) {
	delete $data{'str'};
	if ($default::static) {
		$data{'title'} = $this->get_sbm_title;
		$data{'enabled'} = ($this->{'enabled'}) ? 1 : 0;
	} else {
		return $this->field_tag('');
	}
}
my $html = '';
if ($data{'enabled'} || ($this->{'enabled'} && $this->{'enabled'} == 2)) {
	$data{'enabled'} = 1;
	$html = $this->sbm($data{'title'},$c,$n);
} else {
	$data{'enabled'} = 0;
}
return $this->field_tag($this->data_tag_from_hash('enabled' => $data{'enabled'},'title' => $data{'title'}) . $html,(($html) ? 0 : 1));
}

sub has_content {
my($this,$str) = @_;
return 0 if !defined $str || $str eq '';
my %data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
return ((%data && $data{'enabled'}) || ($this->{'enabled'} && $this->{'enabled'} == 2)) ? 1 : 0;
}

sub sbm ($$$$) {
my($this,$title,$c,$n) = @_;
$this->{'template'} = $this->get_sbm_template if !$this->{'template'};
my $url = $this->get_viewer_url($c,$n);
$url =~ s!/index\.s?html?(\#[^/]+|)$!/$1!is;
my $template = $this->{'template'};
my $encoded_url = $this->url_encode_for_sbm($url,1);
$url = $this->url_encode_for_sbm($url);
my $encoded_title = $this->url_encode_for_sbm($title,1);
$title = '' if !defined $title;
$template =~ s/(<div(?![0-9a-zA-Z_])[^>]*[\x09\x0A\x0C\x0D\x20]+class="topsy_widget_data"[^>]*>[\x09\x0A\x0C\x0D\x20]*<!--.*?)<title>(.*?-->[\x09\x0A\x0C\x0D\x20]*<\/div>)/$1<encoded_title>$2/sgi;
$template =~ s/((?:src|href)=["']?[^'"]*?)<title>/$1<encoded_title>/sgi;
$template =~ s/<title>/$title/sg;
$template =~ s/<encoded_title>/$encoded_title/sg;
$template =~ s/<url>/$url/sg;
$template =~ s/<encoded_url>/$encoded_url/sg;
$this->tag_fix(\$template,0,0,0,0,0,1,1);
return $template;
}

sub url_encode_for_sbm ($$) {
my($this,$str,$full) = @_;
return '' if !defined $str || $str eq '';
utf8::encode($str) if utf8::is_utf8($str);
if ($full) {
	$str =~ s/([\x00-\x1F\x21-\x29\x2B\x2C\x2F\x3A-\x3F\x5B-\x5E\x60\x7B-\xFF])/'%' . sprintf("%.2X", unpack("C", $1))/eg;
} else {
	$str =~ s/([\x00-\x1F\x21-\x29\x2B\x2C\x3B-\x3F\x5B-\x5E\x60\x7B-\xFF])/'%' . sprintf("%.2X", unpack("C", $1))/eg;
}
$str =~ s/\x20/+/g;
return $str;
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
my $this = shift;
return 0;
}

sub format_for_mail {
my($this,$str) = @_;
return '';
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text_enabled ($) {
my $this = shift;
return 0;
}

sub format_for_text {
my($this,$str) = @_;
return '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
my $this = shift;
return 1;
}

sub confirmation ($$;@) {
my($this,$str,@option) = @_;
return $this->optional_values . $this->usual_format($str,@option);
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my($this,$html_disabled,$tips) = @_;

#名前
my $name = 'data:' . $this->{'id'};

$this->print_field_info_form($name);

print '<fieldset>';
print '<legend>デフォルト</legend>';
print '<ol class="checkbox">';
#print '<li><label><input type="radio" name="' . $name . '_enabled" value="2"' . (($this->{'enabled'} && $this->{'enabled'} == 2) ? ' checked="checked"' : '') . ' /> 常に使用する。</label></li>';
print '<li><label><input type="radio" name="' . $name . '_enabled" value="1"' . (($this->{'enabled'} && $this->{'enabled'} == 1) ? ' checked="checked"' : '') . ' /> デフォルトで使用する。</label></li>';
print '<li><label><input type="radio" name="' . $name . '_enabled" value="0"' . ((!$this->{'enabled'}) ? ' checked="checked"' : '') . ' /> デフォルトで使用しない。</label></li>';
print '</ol>';
print '</fieldset>';

print '<fieldset>';
print '<legend><label for="' . $name . '_template">テンプレート</label></legend>';
print '<textarea name="' . $name . '_template" id="' . $name . '_template" cols="72" rows="10" wrap="off" class="content-editor-area">' . $this->escape($this->{'template'}) . '</textarea>';
print '<div class="toolbox">';
print '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'' . $name . '_template\').quotationByMenu(this)" title="これらのタグは、書き出し時に対応する値に変換されます。">';
print '<option value="">▼特殊タグを挿入する</option>';
print '<option value="&lt;title&gt;">記事のタイトル &lt;title&gt;</option>';
print '<option value="&lt;encoded_title&gt;">URL エンコードされた 記事のタイトル &lt;encoded_title&gt;</option>';
print '<option value="&lt;url&gt;">記事の URL &lt;url&gt;</option>';
print '<option value="&lt;encoded_url&gt;">URL エンコードされた 記事の URL &lt;encoded_url&gt;</option>';
print '</select>';
print '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'' . $name . '_template\').quotationByMenu(this)">';
print '<option value="">▼ソーシャルブックマークボタンを追加する</option>';
$this->print_sbm_selector;
print '</select>';

print '</div>';
print '</fieldset>';

$this->print_setting_save_button;
return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
$main::data{$this->{'id'} . '_enabled'} = 0 if !$main::data{$this->{'id'} . '_enabled'} || ($main::data{$this->{'id'} . '_enabled'} ne '1' && $main::data{$this->{'id'} . '_enabled'} ne '2');

return 1;
}

######################################################################
#	(7) obj->search_form;
sub search_form_enabled ($) {
my $this = shift;
return 0;
}

sub search_form ($) {
my $this = shift;
return '';
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
my $this = shift;
return 0;
}

1;
