package Tate;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（縦書き）
# Tate.pm 1.1.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-04-20
######################################################################
sub __set ($$) {
    my ( $this, $setting ) = @_;
    return;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag($str) if !defined $str || $str eq '';

    my ( $tate, $fontcolor, $taketori, $font_option );
    $fontcolor = $this->text_color( \$str );
    $this->text_conv( \$str );
    $this->text_fix( \$str, $this->{'csv'},
        ( ( !$this->{'rows'} || $this->{'rows'} <= 1 ) ? 1 : 0 ) )
        if defined $str && $str;
    $tate = $str;

    $tate =~ s/<\!--.*?-->//sg;
    $tate = '<font color="' . $fontcolor . '">' . $tate . '</font>'
        if defined $this->{'color'}
        && $this->{'color'}
        && defined $this->{'field_style_disabled'}
        && $this->{'field_style_disabled'} < 2
        && defined $fontcolor
        && $fontcolor;

    require CMONOS::CGI_Lib::TaketoriLegacy;
    $taketori = TaketoriLegacy->new;

    $font_option .= ' face="' . $this->{'fontface'} . '"'
        if defined $this->{'fontface'} && $this->{'fontface'};
    $font_option .= ' color="' . $this->{'fontcolor'} . '"'
        if defined $this->{'fontcolor'} && $this->{'fontcolor'};
    $font_option .= ' style="' . $this->{'style'} . '"'
        if defined $this->{'style'} && $this->{'style'};
    $font_option .= ' size="' . $this->{'fontsize'} . '"'
        if defined $this->{'fontsize'} && $this->{'fontsize'};

    $taketori->set(
        'Mac' => 'auto'
        , # "1"=マック版NNに最適化する/"auto"=クライアントに合わせる

        #	'type' => 'text',										# text=改行コードでも改行
        'name' => 'tategaki'
            . $this->_mk_user_generated_field_id( $c, $n )
            . '-1',    # 名前
        'jcode' => 'utf8',    # 漢字コード（utf8/euc/jis/sjis）
        'rows'          => $this->{'tateRows'},        # 一行字数
        'cols'          => $this->{'tateCols'},        # 一段行数
        'marginEnabled' => $this->{'marginEnabled'},   # 小書き調整方法
        'utf8Enabled'   => $this->{'utf8Enabled'}
        ,    # UTF8 HTML エンティティ
        'basefontsize' => $this->{'fontsize'}
        ,    # 標準フォントサイズ（1-7）
        'fontOption' => $font_option,    # 標準フォントオプション
        'separator' => $this->{'separator'},    # 段区切り
        'align'     => $this->{'align'},        # 位置揃え
        'numOption' => $this->{'numOption'}
        ,    # 数字は横書きにする（yes/no）
        'kinsokuLevel' => $this->{'kinsokuLevel'}
        , # 禁則処理設定（1=句読点のみ/2=句読点+ゃゅょ等）
        'upwardChar'   => $this->{'upwardChar'},     # 上段移動文字
        'downwardChar' => $this->{'downwardChar'}    # 下段移動文字
    );
    $taketori->tategaki( \$tate, '', 2 );
    undef $taketori;

    if ( defined $this->{'yoko'} && $this->{'yoko'} ) {
        my $yoko = $str;
        $yoko =~ s/<\!--.*?-->//sg;
        $yoko .= '<div style="text-align: center">'
            . $this->close_button(
            '',
            $setting::page{'closeButton'},
            $setting::page{'backButton'}
            ) . '</div>';
        $yoko =~ s/'/\\'/sg;
        $yoko =~ s/[\x0A\x0D]+/\\n/sg;
        $tate
            .= '<div style="text-align: center"><form action="#"><input type="button" value="横書き表示ウィンドウを開く" onclick="cmonos.window.openOriginalText(\''
            . $this->escape($yoko)
            . '\')" /></form></div>';
    }

    return $this->field_tag(
        (   ($fontcolor)
            ? $this->data_tag_from_hash( 'fontcolor', $fontcolor )
            : ''
        )
        . '<div style="display: none">'
            . $this->data_tag( 'str', $str )
            . '</div>'
            . $this->style(
            $tate, $this->{'style'}, $this->{'fontsize'},
            ( ($fontcolor) ? $fontcolor : $this->{'fontcolor'} ),
            $this->{'fontface'}, 1
            )
    );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_sub_setting_form ($$) {
    my ( $this, $name ) = @_;

    #デフォルト
    $this->{'separator'} = '<hr size="1" color="#000000" /><br /><br />'
        if !defined $this->{'separator'} && !defined $this->{'tateRows'};

    print '<fieldset>';
    print '<legend>縦書き設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><span class="datatitle">縦書きオプション</span></td>';
    print '<td class="field" colspan="3">';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="'
        . $name
        . '_kinsokuLevel" value=""'
        . ( ( !$this->{'kinsokuLevel'} ) ? ' checked="checked"' : '' )
        . ' /> 禁則処理をしない</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_kinsokuLevel" value="1"'
        . (
        ( defined $this->{'kinsokuLevel'} && $this->{'kinsokuLevel'} == 1 )
        ? ' checked="checked"'
        : '' )
        . ' /> 句読点のみ禁則する</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_kinsokuLevel" value="2"'
        . (
        ( defined $this->{'kinsokuLevel'} && $this->{'kinsokuLevel'} == 2 )
        ? ' checked="checked"'
        : '' )
        . ' /> 句読点とかっこ、「ぁ-ぉゃ-ょっ」等を禁則する</label></li>';
    print '</ol>';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_numOption" value="1" '
        . ( ( defined $this->{'numOption'} && $this->{'numOption'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 数字は横書きにする</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_yoko" value="1" '
        . ( ( defined $this->{'yoko'} && $this->{'yoko'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 横書き表示ウィンドウを開く ボタンを表示する</label></li>';
    print '</ol>';
    print
        '<div class="warning">下記オプションを設定すると古い Windows 版 IE で表示が崩れたり文字化けすることがあります。</div><ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_marginEnabled" value="1" '
        . ( ( defined $this->{'marginEnabled'} && $this->{'marginEnabled'} )
        ? ' checked="checked"'
        : '' )
        . ' /> margin を設定して小書き文字(ゃゅょっ等)の位置を調整する</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_utf8Enabled" value="1" '
        . ( ( defined $this->{'utf8Enabled'} && $this->{'utf8Enabled'} )
        ? ' checked="checked"'
        : '' )
        . ' /> UTF-8 HTMLエンティティで縦書用記号を表示する</label></li>';
    print '</ol>';
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr><td class="field-name"><label for="' . $name
        . '_tateRows">縦書き 一行字数</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_tateRows" id="'
        . $name
        . '_tateRows" value="'
        . $this->escape( $this->{'tateRows'} )
        . '" size="3" /> <span class="unit">文字</span></td>';
    print '<td class="field-name"><label for="' . $name
        . '_tateCols">縦書き 一段行数</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_tateCols" id="'
        . $name
        . '_tateCols" value="'
        . $this->escape( $this->{'tateCols'} )
        . '" size="3" /> <span class="unit">行</span></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_separator">段区切り</label></td>';
    print '<td class="field" colspan="3"><input type="text" name="'
        . $name
        . '_separator" id="'
        . $name
        . '_separator" value="'
        . $this->escape( $this->{'separator'} )
        . '" size="50" /></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_align">位置揃え</label></td>';
    print '<td class="field" colspan="3">';
    print $this->mk_select_menu(
        $name . '_align', '', '', $this->{'align'},
        ''       => '',
        'left'   => '左',
        'center' => '中央',
        'right'  => '右'
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_upwardChar">上段移動記号</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_upwardChar" id="'
        . $name
        . '_upwardChar" value="'
        . $this->escape( $this->{'upwardChar'} )
        . '" size="10" /></td>';
    print '<td class="field-name"><label for="' . $name
        . '_downwardChar">下段移動記号</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_downwardChar" id="'
        . $name
        . '_downwardChar" value="'
        . $this->escape( $this->{'downwardChar'} )
        . '" size="10" /></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';
}

sub html_editor_panel_type ($) {
    my $this = shift;
    return ( $this->{'nostyle'} ) ? 'nostylemini' : 'mini';
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_sub_setting ($) {
    my $this     = shift;
    my $is_valid = 1;

    #修正
    $this->tag_fix( \$main::data{ $this->{'id'} . '_separator' }, 2 )
        if defined $main::data{ $this->{'id'} . '_separator' }
        && $main::data{ $this->{'id'} . '_separator' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_upwardChar' }, 2 )
        if defined $main::data{ $this->{'id'} . '_upwardChar' }
        && $main::data{ $this->{'id'} . '_upwardChar' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_downwardChar' }, 2 )
        if defined $main::data{ $this->{'id'} . '_downwardChar' }
        && $main::data{ $this->{'id'} . '_downwardChar' };

    #チェックボックス
    $main::data{ $this->{'id'} . '_numOption' } = ''
        if !defined $main::data{ $this->{'id'} . '_numOption' }
        || !$main::data{ $this->{'id'} . '_numOption' };
    $main::data{ $this->{'id'} . '_yoko' } = ''
        if !defined $main::data{ $this->{'id'} . '_yoko' }
        || !$main::data{ $this->{'id'} . '_yoko' };
    $main::data{ $this->{'id'} . '_marginEnabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_marginEnabled' }
        || !$main::data{ $this->{'id'} . '_marginEnabled' };
    $main::data{ $this->{'id'} . '_utf8Enabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_utf8Enabled' }
        || !$main::data{ $this->{'id'} . '_utf8Enabled' };

    #数字
    if (   defined $main::data{ $this->{'id'} . '_tateCols' }
        && $main::data{ $this->{'id'} . '_tateCols' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_tateCols' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '縦書き一行字数を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_tateCols' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_tateRows' }
        && $main::data{ $this->{'id'} . '_tateRows' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_tateRows' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '縦書き一段行数を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_tateRows' };
        $is_valid = 0;
    }

    return $is_valid;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'text_0_tate', 'Tate', '縦書き(TABLE)' )
        if !$setting::field_for_mail;
    $setting::deco_dir{'return'}  = '戻る ボタン';
    $setting::deco_type{'return'} = 'button';
    $setting::deco_dir{'close'}   = '閉じる ボタン';
    $setting::deco_type{'close'}  = 'button';
}

1;
