package TogglerBase;
require CMONOS::CGI_Lib::Field::UserGeneratedField;
@ISA = qw(UserGeneratedField);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# フィールド定義モジュール（チェック）
# TogglerBase.pm 1.0
# Copyright (C) 2007-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-09-19
######################################################################
sub _set ($$) {
    my $this = shift;
    unless ( ref $cgi::Image ) {
        require CMONOS::CGI_Lib::Image;
        $cgi::Image = Image->new;
    }
    unless ( ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }

    #初期設定
    $this->{'aValue'} = '×'
        if !defined $this->{'aValue'} || $this->{'aValue'} eq '';
    $this->{'bValue'} = '△'
        if !defined $this->{'bValue'} || $this->{'bValue'} eq '';
    $this->{'bDisabled'} = 1 if !defined $this->{'bDisabled'};
    $this->{'cValue'} = '○'
        if !defined $this->{'cValue'} || $this->{'cValue'} eq '';
    $this->set_ownerpower if $default::static;
    $this->set_external_file_status;
    return;
}

# --------------------------------------------------------------------
#	(0)-5 データ要素の取得
sub elements ($;$) {
    my ( $this, $str ) = @_;
    my (%data);
    (   $data{'side'}, $data{'authority'}, $data{'atime'},
        $data{'ip'},   $data{'status'}
        )
        = split( /\x0A/, $str )
        if defined $str;
    $this->fill(
        \$data{'side'}, \$data{'authority'}, \$data{'atime'},
        \$data{'ip'},   \$data{'status'}
    );
    return %data;
}

sub update_toggler ($$;$) {
    my ( $this, $data ) = @_;
    $data->{'side'}
        = ( !$data->{'side'} || $data->{'side'} eq 'a' )
        ? ( $this->{'bDisabled'} )
            ? 'c'
            : 'b'
        : ( $data->{'side'} eq 'b' ) ? 'c'
        :                              'a';
    $data->{'authority'} = $main::email || '';
    if ( defined $cgi::client_host && $cgi::client_host ) {
        $data->{'ip'} = $cgi::client_host;
    }
    else {
        $data->{'ip'} = $this->to_ip( $ENV{'REMOTE_ADDR'} );
        $data->{'ip'} = $this->to_host( $data->{'latest_ip'} );
    }
    $data->{'atime'} = time;
    $data->{'status'} = 'enabled' if !$data->{'status'};
    return $this->get_toggler_data($data);
}

sub get_toggler_data ($$) {
    my ( $this, $data ) = @_;
    return
          ( ( defined $data->{'side'} ) ? $data->{'side'} : 'a' ) . "\x0A"
        . ( ( defined $data->{'authority'} ) ? $data->{'authority'} : '' )
        . "\x0A"
        . ( ( defined $data->{'atime'} )  ? $data->{'atime'}  : '' ) . "\x0A"
        . ( ( defined $data->{'ip'} )     ? $data->{'ip'}     : '' ) . "\x0A"
        . ( ( defined $data->{'status'} ) ? $data->{'status'} : 'enabled' );
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    return ( $main::search{ $this->{'id'} }{'side'} ) ? 1 : 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    return 1 if !$main::search{ $this->{'id'} }{'side'};
    return 0 if $$str && $$str =~ /disabled$/s;
    my $side = ( $$str && $$str =~ /^([a-zA-Z]+)/ ) ? $1 : 'a';
    return ( $main::search{ $this->{'id'} }{'side'} eq $side ) ? 1 : 0;
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
    my $this = shift;
    return ( defined $main::data{ $this->{'id'} }{'str'} ) ? 1 : 0;
}

#	(2) obj->form;
sub form {
    my ( $this, $status, $original, $path ) = @_;
    my ( $form, $field_disabled );
    $field_disabled = (
        $main::option{ $this->{'id'} }{'disabled'}
            || ( $main::data{ $this->{'id'} }{'status'}
            && $main::data{ $this->{'id'} }{'status'} eq 'disabled' )
    ) ? 1 : 0;

    #フィールドネーム+ヘッダ
    $form = $this->field_header;

    #トグルボタン表示
    if ( !$field_disabled ) {
        %{ $main::data{ $this->{'id'} } }
            = $this->elements(
            $this->read_file( $path . '/' . $this->{'id'} . '.dat', 1 ) )
            if $default::static;
        if (  !$main::data{ $this->{'id'} }{'status'}
            || $main::data{ $this->{'id'} }{'status'} ne 'disabled' )
        {
            if (  !$main::data{ $this->{'id'} }{'side'}
                || $main::data{ $this->{'id'} }{'side'} eq 'a' )
            {
                $form .= $cgi::Deco->set_output->toggler( 'toggler',
                    $this->{'toggler'}, 'a', $this->{'aValue'}, '', 1 );
            }
            elsif ( !$this->{'bDisabled'}
                && $main::data{ $this->{'id'} }{'side'} eq 'b' )
            {
                $form .= $cgi::Deco->set_output->toggler( 'toggler',
                    $this->{'toggler'}, 'b', $this->{'bValue'}, '', 1 );
            }
            elsif ( $main::data{ $this->{'id'} }{'side'} eq 'c' ) {
                $form .= $cgi::Deco->set_output->toggler( 'toggler',
                    $this->{'toggler'}, 'c', $this->{'cValue'}, '', 1 );
            }
        }
    }
    elsif (-f $path . '/' . $this->{'id'} . '.ssi'
        && -s $path . '/' . $this->{'id'} . '.ssi' )
    {
        $this->write_file( $path . '/' . $this->{'id'} . '.js',  '', 1 );
        $this->write_file( $path . '/' . $this->{'id'} . '.ssi', '', 1 );
    }

    $form
        .= ' <label><input type="checkbox" name="option:'
        . $this->{'id'}
        . ':disabled" value="1"'
        . ( ($field_disabled) ? ' checked="checked"' : '' )
        . ' /> 使用停止</label>';
    $form
        .= '<input type="hidden" name="option:'
        . $this->{'id'}
        . ':status" value="'
        . ( ($field_disabled) ? 'disabled' : 'enabled' ) . '" />';

    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    if ($default::static) {
        $main::data{ $this->{'id'} }{'status'}
            = ( $main::option{ $this->{'id'} }{'disabled'} )
            ? 'disabled'
            : 'enabled';
    }
    else {
        if ( defined $main::n && $main::n ne '' ) {
            undef $main::data{ $this->{'id'} }{'str'};
            if ((      $main::option{ $this->{'id'} }{'disabled'}
                    && $main::option{ $this->{'id'} }{'status'}
                    && $main::option{ $this->{'id'} }{'status'} eq 'enabled'
                )
                || (  !$main::option{ $this->{'id'} }{'disabled'}
                    && $main::option{ $this->{'id'} }{'status'}
                    && $main::option{ $this->{'id'} }{'status'} eq
                    'disabled' )
                )
            {
                my (%db);
                tie( %db, $env::dbm_file,
                    $this->get_db_directory . '/' . $this->db,
                    O_RDWR, $env::dbm_mode );
                if ( ref tied %db ) {
                    my %data = $this->elements(
                        $this->decode_utf8(
                            $db{ $this->encode_utf8($main::n) }
                        )
                    );
                    my $status
                        = ( $data{'status'} ) ? $data{'status'} : 'enabled';
                    if (   $main::option{ $this->{'id'} }{'disabled'}
                        && $status ne 'disabled' )
                    {
                        $data{'status'} = 'disabled';
                    }
                    elsif ( !$main::option{ $this->{'id'} }{'disabled'}
                        && $status eq 'disabled' )
                    {
                        $data{'status'} = 'enabled';
                    }
                    $db{ $this->encode_utf8($main::n) } = $this->encode_utf8(
                        $this->get_toggler_data( \%data ) );
                }
                untie %db;
            }
        }
        else {
            $main::data{ $this->{'id'} }{'status'}
                = ( $main::option{ $this->{'id'} }{'disabled'} )
                ? 'disabled'
                : 'enabled';
            $main::data{ $this->{'id'} }{'str'} = $this->get_toggler_data(
                {   'side'   => 'a',
                    'status' => $main::data{ $this->{'id'} }{'status'}
                }
            );
        }
    }
    return 1;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=表示するデータ/path=ファイル保存ディレクトリ
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    return $this->toggler_format( $str, $path, $c, $n,
        ( ( $this->has_detail_view && $this->{'detailViewOnly'} ) ? 0 : 1 ) );
}

sub format_for_detail {
    my ( $this, $str, $path, $c, $n ) = @_;
    return $this->toggler_format( $str, $path, $c, $n, 1 );
}

sub toggler_format {
    my ( $this, $str, $path, $c, $n, $votable ) = @_;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    my $id = $this->mk_user_generated_field_id( $c, $n );
    if ( $this->{'externalFileDisabled'}
        || ( $data{'status'} && $data{'status'} eq 'disabled' ) )
    {
        if (  !-f $path . '/' . $this->{'id'} . '.ssi'
            || -s $path . '/' . $this->{'id'} . '.ssi' )
        {
            $this->set_dir($path);
            $this->write_file( $path . '/' . $this->{'id'} . '.js',  '', 1 );
            $this->write_file( $path . '/' . $this->{'id'} . '.ssi', '', 1 );
        }
    }
    return $this->field_tag(
        $this->data_tag_from_hash( 'status' => 'disabled' ) )
        if $data{'status'} && $data{'status'} eq 'disabled';
    if (!$this->{'externalFileDisabled'}
        && (   $cgi::on_refreshing
            || !-f $path . '/' . $this->{'id'} . '.ssi'
            || !-s $path . '/' . $this->{'id'} . '.ssi' )
        )
    {
        if ($default::static    #静的書き出しで
            && ($cgi::on_refreshing #最新のテンプレートで書き出し中　か、
                || (  !$main::option{ $this->{'id'} }{'disabled'}
                    && $main::option{ $this->{'id'} }{'status'}
                    && $main::option{ $this->{'id'} }{'status'} eq
                    'disabled' )
            )                       #それまで使用停止だった場合
            )
        {
            %data = $this->elements(
                $this->read_file( $path . '/' . $this->{'id'} . '.dat', 1 ) );
        }
        my $data = $this->get_toggler( \%data, $id, $c, $n );
        $this->write_file( $path . '/' . $this->{'id'} . '.ssi', \$data );
        $this->mk_external_javascript( $path . '/' . $this->{'id'} . '.ssi',
            $path . '/' . $this->{'id'} . '.js', $data );
    }
    return $this->field_tag(
        $this->data_tag_from_hash( 'status' => 'enabled' )
            . (
            (   $this->{'externalFileDisabled'}
                    || ( !$default::static && $this->{'update_is_failed'} )
            )
            ? $this->get_toggler( \%data, $id, $c, $n,
                ( ($votable) ? 0 : 1 ), 1 )
            : $this->include_external_file(
                $path . '/' . $this->{'id'} . '.ssi', 1,
                $this->get_output_path,               1
            )
            )
    );
}

sub has_content {
    my ( $this, $str ) = @_;
    return 1 if !defined $str || $str eq '';
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return (   %data
            && defined $data{'status'}
            && $data{'status'} eq 'disabled' ) ? 0 : 1;
}

sub get_toggler ($$;$$) {
    my ( $this, $data, $id, $c, $n, $fixed, $external_file_disabled ) = @_;
    return '' if $data->{'status'} && $data->{'status'} eq 'disabled';
    my $form = '';
    if (!$fixed
        && (   !$external_file_disabled
            || !$this->{'generatableUser'}
            || $this->is_as_secure_as(
                $this->{'generatableUser'},
                [ $this->get_address( $this->{'authority'} ) ]
            )
        )
        )
    {
        $form .= $this->form_start(
            'key' => (
                ( $external_file_disabled && $setting::security_key )
                ? $setting::security_key
                : ''
            ),
            'id'       => $id . '-form',
            'name'     => $id . '-form',
            'method'   => 'post',
            'class'    => 'user-generated-toggler-form',
            'onsubmit' => 'return cmonos.form.item(this).submit(\''
                . $id . '\');',
            'required' => $this->get_query_keys
        );
        $form .= $this->add_query_for_form( $c, $n );
        $form .= $this->add_query( 'post', { 'id' => $this->{'id'} } );
        if ( !$data->{'side'} || $data->{'side'} eq 'a' ) {
            $form .= $cgi::Deco->toggler( 'toggler', $this->{'toggler'}, 'a',
                $this->{'aValue'}, $id . '-submit' );
        }
        elsif ( !$this->{'bDisabled'} && $data->{'side'} eq 'b' ) {
            $form .= $cgi::Deco->toggler( 'toggler', $this->{'toggler'}, 'b',
                $this->{'bValue'}, $id . '-submit' );
        }
        else {
            $form .= $cgi::Deco->toggler( 'toggler', $this->{'toggler'}, 'c',
                $this->{'cValue'}, $id . '-submit' );
        }
        $form .= '</form>';
    }
    else {
        if ( !$data->{'side'} || $data->{'side'} eq 'a' ) {
            $form .= $cgi::Deco->toggler( 'toggler', $this->{'toggler'}, 'a',
                $this->{'aValue'}, $id . '-value', 1 );
        }
        elsif ( !$this->{'bDisabled'} && $data->{'side'} eq 'b' ) {
            $form .= $cgi::Deco->toggler( 'toggler', $this->{'toggler'}, 'b',
                $this->{'bValue'}, $id . '-value', 1 );
        }
        else {
            $form .= $cgi::Deco->toggler( 'toggler', $this->{'toggler'}, 'c',
                $this->{'cValue'}, $id . '-value', 1 );
        }
    }
    return $form;
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str, $path, $c, $n ) = @_;
    return '' if !defined $str || $str eq '';
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return ( $data{'status'} && $data{'status'} eq 'disabled' )
        ? ''
        : '['
        . $this->name . "]\x0A"
        . $this->get_value_from_sidename( $data{'side'} )
        . "\x0A\x0A";
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    return '' if !defined $str || $str eq '';
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return ( $data{'status'} && $data{'status'} eq 'disabled' )
        ? ''
        : $this->get_value_from_sidename( $data{'side'} );
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation ($$) {
    my ( $this, $str ) = @_;
    return '' if !defined $str || $str eq '';
    my %data = $this->elements($str);
    return ( ( $data{'status'} && $data{'status'} eq 'disabled' )
        ? '使用停止'
        : '使用' );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>チェック責任者</legend>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_generatableUser">チェック権限のあるユーザー</label></legend>';
    print $this->mk_select_menu(
        $name . '_generatableUser', '', '', $this->{'generatableUser'},
        'master'  => 'マスター',
        'owner'   => '管理人',
        'owners'  => '共同オーナー',
        'staff'   => 'スタッフ',
        'member'  => '登録メンバー',
        'nocheck' => '全てのユーザー'
    );
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_authority">「登録メンバー」メールアドレス</label></legend>';
    print '<textarea name="'
        . $name
        . '_authority" id="'
        . $name
        . '_authority" cols="56" rows="5" wrap="off">'
        . $this->escape( $this->{'authority'} )
        . '</textarea>';
    print
        '<div class="note">登録メンバーが複数の時はカンマ（+改行）で区切ります。</div>';
    print '</fieldset>';
    print '</fieldset>';

    if ( !$default::static ) {
        print '<fieldset>';
        print '<legend>後処理</legend>';
        print '<ol class="checkbox">';
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_externalFileDisabled" id="'
            . $name
            . '_externalFileDisabled" value="1"'
            . (
            (   defined $this->{'externalFileDisabled'}
                    && $this->{'externalFileDisabled'}
            ) ? ' checked="checked"' : ''
            )
            . ' /> JavaScript による埋め込みではなく、その都度描画する (外部 JavaScript ファイルを作成しない)</label></li>';
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_mTime" id="'
            . $name
            . '_mTime" value="1"'
            . ( ( defined $this->{'mTime'} && $this->{'mTime'} )
            ? ' checked="checked"'
            : '' )
            . ' /> チェック時に更新時データベースを更新する</label></li>';
        print '</ol>';
        print '</fieldset>';
    }

    if ( $this->has_detail_view ) {
        print '<fieldset>';
        print '<legend>チェック可能な画面</legend>';
        print '<label><input type="checkbox" name="'
            . $name
            . '_detailViewOnly" id="'
            . $name
            . '_detailViewOnly" value="1"'
            . ( ( $this->{'detailViewOnly'} ) ? ' checked="checked"' : '' )
            . ' /> 詳細表示時のみチェック可能にする (JavaScript 埋め込みによる表示では常にチェック可能です)</label>';
        print '</fieldset>';
    }

    print '<fieldset>';
    print '<legend>ボタン設定</legend>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_aValue">状態A (初期状態) の名前</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_aValue" id="'
        . $name
        . '_aValue" value="'
        . $this->escape( $this->{'aValue'} )
        . '" size="50" />';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="'
        . $name
        . '_bValue">状態B の名前</label> (<label><input type="checkbox" name="'
        . $name
        . '_bDisabled" value="1"'
        . ( ( $this->{'bDisabled'} ) ? ' checked="checked"' : '' )
        . ' /> 使用しない</label>)</legend>';
    print '<input type="text" name="'
        . $name
        . '_bValue" id="'
        . $name
        . '_bValue" value="'
        . $this->escape( $this->{'bValue'} )
        . '" size="50" />';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_cValue">状態C の名前</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_cValue" id="'
        . $name
        . '_cValue" value="'
        . $this->escape( $this->{'cValue'} )
        . '" size="50" />';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>トグルボタン</legend>';
    print $cgi::Deco->toggler_menu( $name . '_toggler',
        'toggler', $this->{'toggler'} );
    print '</fieldset>';
    print '</fieldset>';

    $this->print_setting_save_button;
    return;
}

sub has_detail_view ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;

    #半角変換
    $main::data{ $this->{'id'} . '_authority' }
        = $this->z_to_h( $main::data{ $this->{'id'} . '_authority' }, 'utf8' )
        if defined $main::data{ $this->{'id'} . '_authority' }
        && $main::data{ $this->{'id'} . '_authority' };

    $main::data{ $this->{'id'} . '_externalFileDisabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_externalFileDisabled' }
        || !$main::data{ $this->{'id'} . '_externalFileDisabled' };
    $main::data{ $this->{'id'} . '_mTime' } = 0
        if !defined $main::data{ $this->{'id'} . '_mTime' }
        || !$main::data{ $this->{'id'} . '_mTime' };
    $main::data{ $this->{'id'} . '_detailViewOnly' } = 0
        if $this->has_detail_view
        && !$main::data{ $this->{'id'} . '_detailViewOnly' };
    $main::data{ $this->{'id'} . '_bDisabled' } = 0
        if !$main::data{ $this->{'id'} . '_bDisabled' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };

    return 1;
}

######################################################################
#	(6) obj->search_form;
sub search_form ($) {
    my $this = shift;
    return
          '<tr><td class="field-name"><label for="search:'
        . $this->{'id'}
        . ':side">'
        . $this->name
        . '</label></td><td class="field">'
        . $this->mk_select_menu(
        'search:' . $this->{'id'} . ':side',
        '', '',
        $main::search{ $this->{'id'} }{'side'},
        ''  => '',
        'a' => $this->escape_except_html_entity( $this->{'aValue'} ),
        (     ( $this->{'bDisabled'} )
            ? ()
            : ( 'b' => $this->escape_except_html_entity( $this->{'bValue'} ) )
        ),
        'c' => $this->escape_except_html_entity( $this->{'cValue'} ),
        ) . '</td></tr>';
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 1;
}

######################################################################
#	(11) obj->update;
sub is_secure_user_for_update ($) {
    my $this = shift;
    return (
        !$this->is_short_parameters
            && (
            !$this->{'generatableUser'}
            || $this->is_as_secure_as(
                $this->{'generatableUser'},
                [ $this->get_address( $this->{'authority'} ) ]
            )
            )
    ) ? 1 : 0;
}

sub update ($;$) {
    my ( $this, $is_ajax ) = @_;
    my ( $data_ref, $old_size, $new_size, $latest_ip );
    $data_ref = $this->get_field_data;
    if (   !ref $data_ref
        || ( $data_ref->{'status'} && $data_ref->{'status'} eq 'disabled' )
        || ( $default::static && ( !%$data_ref || !$data_ref->{'status'} ) ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ($default::english)
                ? 'Error!'
                : $this->name(1) . ' は現在利用できません。'
            )
        ) if ref $cgi::action;
        return ($is_ajax)
            ? {
            'status'  => 'error',
            'message' => $this->get_message_string,
            }
            : 0;
    }
    my $path = $this->get_file_directory;
    $data_ref = {
        $this->elements(
            $this->read_file( $path . '/' . $this->{'id'} . '.dat', 1 )
        )
        }
        if $default::static;
    my $data = $this->update_toggler($data_ref);
    if ($default::static) {
        $this->write_file( $path . '/' . $this->{'id'} . '.dat',
            \$data, 1, ( ($env::ownerpower) ? 0600 : $env::file_mode ) );
    }
    else {
        my (%db);
        tie(%db, $env::dbm_file,
            $this->get_db_directory . '/' . $this->db,
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %db ) {
            $db{ $this->encode_utf8($main::n) } = $this->encode_utf8($data);
        }
        untie %db;
    }
    my $id = $this->mk_user_generated_field_id( $main::c, $main::n );
    if ( $this->{'externalFileDisabled'} ) {
        $this->write_file( $path . '/' . $this->{'id'} . '.js',  '', 1 );
        $this->write_file( $path . '/' . $this->{'id'} . '.ssi', '', 1 );
    }
    else {
        my $data_html
            = $this->get_toggler( $data_ref, $id, $main::c, $main::n );
        $this->write_file( $path . '/' . $this->{'id'} . '.ssi',
            \$data_html, 1 );
        $this->mk_external_javascript( $path . '/' . $this->{'id'} . '.ssi',
            $path . '/' . $this->{'id'} . '.js', $data_html );
    }
    $this->post_update;
    return ($is_ajax)
        ? {
        'status' => 'success',
        (   ( $this->{'toggler'} )
            ? ( 'button_class' => 'toggler-'
                    . $this->{'toggler'} . '-'
                    . $data_ref->{'side'} )
            : ()
        ),
        'button_title' =>
            $this->get_value_from_sidename( $data_ref->{'side'} ),
        'button_value' =>
            $this->get_value_from_sidename( $data_ref->{'side'} ),
        'message' => $this->get_message_string,
        }
        : 1;
}

sub get_value_from_sidename ($$) {
    my ( $this, $side ) = @_;
    return
          ( !$side || $side eq 'a' ) ? $this->{'aValue'}
        : ( !$this->{'bDisabled'} && $side eq 'b' ) ? $this->{'bValue'}
        :                                             $this->{'cValue'};
}

sub editor_enabled ($) {
    my $this = shift;
    return 0;
}

sub is_secure_user_for_edit ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);
    $setting::deco_dir{'toggler'}  = 'トグルボタン';
    $setting::deco_type{'toggler'} = 'toggler';
}

1;
