package UserGeneratedComment;
require CMONOS::CGI_Lib::Field::UserGeneratedField;
@ISA = qw(UserGeneratedField);
use strict;
use utf8;
use Fcntl qw(:flock);
######################################################################
# フィールド定義モジュール（コメント）
# UserGeneratedComment.pm 1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-05-28
######################################################################
sub __set ($$) {
    my ( $this, $setting ) = @_;
    if ( !ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }
    $this->{'elements'} = 1;
    if ( !ref $cgi::Image ) {
        require CMONOS::CGI_Lib::Image;
        $cgi::Image = Image->new;
    }
    if ( !ref $cgi::UserAgent ) {
        require CMONOS::CGI_Lib::UserAgent;
        $cgi::UserAgent = UserAgent->new;
    }
    delete $this->{'syncedgrader'}
        if defined $this->{'syncedgrader'}
        && !ref $this->{'syncedgrader'}
        && $this->{'syncedgrader'} eq '';
    $this->scalar_to_array( \$this->{'syncedgrader'} )
        if defined $this->{'syncedgrader'} && !ref $this->{'syncedgrader'};
    if ( ref $this->{'syncedgrader'} && @{ $this->{'syncedgrader'} } ) {
        @{ $this->{'syncedgrader'} } = sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
            } grep( ref $this->{'field_obj'}{$_}
                && $this->{'field_obj'}{$_}->{'class'} eq 'ug_grader',
            @{ $this->{'syncedgrader'} } );
        unless ( ref $cgi::BarGraph ) {
            require CMONOS::CGI_Lib::BarGraph;
            $cgi::BarGraph = BarGraph->new;
        }
    }
    delete $this->{'requiredgrader'}
        if defined $this->{'requiredgrader'}
        && !ref $this->{'requiredgrader'}
        && $this->{'requiredgrader'} eq '';
    $this->scalar_to_array( \$this->{'requiredgrader'} )
        if defined $this->{'requiredgrader'}
        && !ref $this->{'requiredgrader'};
    if ( ref $this->{'requiredgrader'} && @{ $this->{'requiredgrader'} } ) {
        @{ $this->{'requiredgrader'} } = sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
            } grep( ref $this->{'field_obj'}{$_}
                && $this->{'field_obj'}{$_}->{'class'} eq 'ug_grader',
            @{ $this->{'requiredgrader'} } );
    }
    $this->{'nameFieldName'} = ( ($default::english) ? 'Name' : '名前' )
        if !defined $this->{'nameFieldName'}
        || $this->{'nameFieldName'} eq '';
    $this->{'commentFieldName'}
        = ( ($default::english) ? 'Comment' : 'コメント' )
        if !defined $this->{'commentFieldName'}
        || $this->{'commentFieldName'} eq '';
    $this->{'titleFieldName'}
        = ( ($default::english) ? 'Title' : 'タイトル' )
        if !defined $this->{'titleFieldName'}
        || $this->{'titleFieldName'} eq '';
    $this->{'emailFieldName'}
        = ( ($default::english) ? 'E-Mail' : 'メールアドレス' )
        if !defined $this->{'emailFieldName'}
        || $this->{'emailFieldName'} eq '';
    $this->{'urlFieldName'}
        = ( ($default::english) ? 'URL' : 'ホームページ' )
        if !defined $this->{'urlFieldName'} || $this->{'urlFieldName'} eq '';
    $this->{'iconSelectorName'}
        = ( ($default::english) ? 'Icon' : 'アイコン' )
        if !defined $this->{'iconSelectorName'}
        || $this->{'iconSelectorName'} eq '';
    $this->{'hiddenCheckboxName'}
        = ( ($default::english) ? 'Hide.' : '隠す' )
        if !defined $this->{'hiddenCheckboxName'}
        || $this->{'hiddenCheckboxName'} eq '';
    $this->{'submitButtonName'} = ( ($default::english) ? 'Send' : '送信' )
        if !defined $this->{'submitButtonName'}
        || $this->{'submitButtonName'} eq '';
    $this->{'rememberCheckboxName'}
        = ( ($default::english) ? 'Remember Me' : '情報を記憶する' )
        if !defined $this->{'rememberCheckboxName'}
        || $this->{'rememberCheckboxName'} eq '';
    $this->{'datetype'}
        = ( ( $setting::general{'datetype'} )
        ? $setting::general{'datetype'}
        : '' )
        if !$this->{'datetype'};
    $this->{'size'}            = 30        if !$this->{'size'};
    $this->{'cols'}            = 40        if !$this->{'cols'};
    $this->{'rows'}            = 3         if !$this->{'rows'};
    $this->{'generatableUser'} = 'nocheck' if !$this->{'generatableUser'};
    $this->{'fieldTable'}      = 'dl'      if !$this->{'fieldTable'};

    if ( $this->is_closed_door ) {
        $this->{'pendingEnabled'} = '';
        $this->{'rssEnabled'}     = '';
        $this->{'naviEnabled'}    = '';
        $this->{'deletable'}      = '';
    }
    $this->set_ownerpower;
    $this->set_external_file_status;
    return;
}

sub get_rss_name ($) {
    my $this = shift;
    return 'コメント';
}

sub get_comment_template ($;$) {
    my ( $this, $frame_flag ) = @_;
    if ( defined $this->{'template'} && $this->{'template'} ) {
        my $template = $this->{'template'};
        if ( $template =~ /<!--_tate(?![0-9a-zA-Z_])[^>]*-->/ ) {
            require CMONOS::CGI_Lib::Taketori;
            $template = Taketori->new( { 'css' => 1 } )
                ->tategaki_to_text($template);
        }
        if (   $frame_flag
            && $template =~ /<!--frame(?![0-9a-zA-Z_])[^>]*-->/
            && ref $frame::obj{'frame'} )
        {
            require CMONOS::CGI_Lib::Frame;
            $template = Frame->new->text_to_frame( $template, 'no',
                $frame::obj{'frame'} );
        }
        return $template;
    }
    else {
        return <<'TEMPLATE';
<div class="user-generated-comment">
<!--icon--><!--head--><div class="user-generated-comment-icon"><!--/head--><!--foot--></div><!--/foot--><!--/icon-->
<!--title--><!--head--><h4 class="user-generated-comment-head"><!--/head--><!--foot--></h4><!--/foot--><!--/title-->
<div class="user-generated-comment-body">
<!--comment--><!--head--><!--/head--><!--foot--><!--/foot--><!--/comment-->
</div>
<!--grade--><!--head--><div class="user-generated-comment-grade"><!--/head--><!--foot--></div><!--/foot--><!--/grade-->
<div class="user-generated-comment-info">
<strong><!--name--><!--/name--></strong>
<!--email--><!--head--> <!--/head--><!--foot--><!--/foot--><!--/email-->
<!--url--><!--head--> <!--/head--><!--foot--><!--/foot--><!--/url-->
<!--ctime--><!--head--> (<!--/head--><!--foot-->)<!--/foot--><!--/ctime-->
</div>
</div>
TEMPLATE
    }
}

######################################################################
sub get_user_generated_field_data ($$$$;$$$) {
    my ( $this, $memory, $data_ref, $path, $c, $n, $content_only ) = @_;
    my ( $dt, $_dt, $dd, $_dd, $submit_start, $submit_end );
    my $approval_required = ( $data_ref->{'approvalRequired'} ) ? 1 : 0;
    my $id              = $this->mk_user_generated_field_id( $c, $n );
    my $template        = $this->get_comment_template(1);
    my $comment_count   = 0;
    my $memory_count    = 0;
    my $comment_content = '';
    $memory = $this->{'masterMemory'}
        if $this->{'masterMemory'}
        && ( !defined $memory
        || $memory eq ''
        || $memory > $this->{'masterMemory'} );
    $this->use_deco( $this->get_output_path );
    local (*DAT);

    if ( open( DAT, $path . '/' . $this->{'id'} . '.dat' ) ) {
        binmode DAT, ":utf8";
        flock( DAT, LOCK_SH );
        my ( $head, $foot ) = ( '', '' );
        ( $head, $template, $foot )
            = ( $1, $this->join_header_and_footer( $2, $3 ), $4 )
            if $template
            =~ /^(.*)<!--article(?![0-9a-zA-Z_])([^>]*)-->(.*)<!--\/article-->(.*)$/s;
        while ( my $line = <DAT> ) {
            chomp $line;
            $memory_count++;
            $comment_content
                .= $this->replace_comment( $template, $approval_required,
                [ $this->svsplit( "\x09", $line ) ],
                0, \$comment_count );
            last if $memory && $comment_count >= $memory;
        }
        close(DAT);
        $comment_content = $head . $comment_content . $foot
            if $comment_content;
    }
    if ($content_only) {
        $cgi::Deco->restore_output;
        return $comment_content;
    }
    my $comment
        = '<div id="'
        . $id
        . '" class="user-generated-comments">'
        . $comment_content
        . '</div>';
    $comment
        .= '<p id="' . $id . '-info" class="user-generated-comments-info">';
    $comment
        .= '<a href="javascript:void(0)" onclick="cmonos.element.item(\''
        . $id . '\',\''
        . $id
        . '-form\').toggle()">'
        . $this->name(1)
        . '<span id="'
        . $id
        . '-count">('
        . $comment_count
        . ')</span>' . '</a>';
    $comment .= $this->field_editor_link(
        ( ($default::english) ? '[EDIT]' : '[編集]' ),
        $id . '-editor-link',
        'display: none',
        $c, $n
    ) if !$this->is_closed_door || $this->is_secure('tools');
    $comment .= '</p>';

    my $external_file_disabled
        = ( !$default::static && $this->{'update_is_failed'} )
        ? 1
        : $this->{'externalFileDisabled'};
    if ((     !$external_file_disabled
            || $this->is_as_secure_as( $this->{'generatableUser'} )
        )
        && ( !defined $memory || $memory eq '' || $memory_count < $memory )
        )
    {
        my $is_updated_record
            = ($external_file_disabled)
            ? $this->is_updated_record( $c, $n )
            : 0;
        my $name_enabled
            = (
            $template =~ /<!--name(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/name-->/s )
            ? 1
            : 0;
        my $title_enabled
            = ( $template
                =~ /<!--title(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/title-->/s )
            ? 1
            : 0;
        my $email_enabled
            = ( $template
                =~ /<!--email(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/email-->/s )
            ? 1
            : 0;
        my $url_enabled
            = (
            $template =~ /<!--url(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/url-->/s )
            ? 1
            : 0;
        my $icon_enabled
            = (    $this->{'dir'}
                && $template
                =~ /<!--icon(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/icon-->/s )
            ? 1
            : 0;
        my $grader_enabled
            = ( ref $this->{'syncedgrader'}
                && $template
                =~ /<!--grade(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/grade-->/s )
            ? 1
            : 0;
        $comment .= $this->form_start(
            'key' => (
                ( $external_file_disabled && $setting::security_key )
                ? $setting::security_key
                : ''
            ),
            'id'       => $id . '-form',
            'name'     => $id . '-form',
            'method'   => 'post',
            'class'    => 'user-generated-comment-form',
            'onsubmit' => 'return cmonos.form.item(this).submit(\''
                . $id
                . '\',[\'comment:name\''
                . (
                ($email_enabled) ? ',\'comment:email\',\'comment:hidden\''
                : ''
                )
                . ( ($url_enabled)  ? ',\'comment:url\''  : '' )
                . ( ($icon_enabled) ? ',\'comment:icon\'' : '' )
                . '],\'COMMENT\',\''
                . $env::server_name . '\',\''
                . (
                ($env::cookie_path) ? $env::cookie_path
                : $this->home_directory
                )
                . '\');',
            'required' => $this->get_query_keys
        );
        $comment .= $this->add_query_for_form( $c, $n );
        $comment .= $this->add_query( 'post', { 'id' => $this->{'id'} } );

        #ダミー入力欄
        $comment .= '<fieldset class="user-generated-content-input-form">';
        $comment
            .= 'Your Name : <input type="text" name="name" size="30" /><br />';
        $comment
            .= 'Your E-Mail : <input type="email" name="emailaddress" size="30" /><br />';
        $comment
            .= 'Your Url : <input type="url" name="url" size="30" /><br />';
        $comment
            .= 'Your Comment : <textarea name="comment" rows="3" cols="30"></textarea>';
        $comment .= '</fieldset>';

        if ($external_file_disabled
            && ( !defined $main::comment{'name'}
                || $main::comment{'name'} eq '' )
            )
        {
            $this->read_cookie('COMMENT');
            $main::comment{'name'}  = $this->get_user_name;
            $main::comment{'email'} = $main::email
                || ''
                if !defined $main::comment{'email'}
                || $main::comment{'email'} eq '';
        }
        if ( $this->{'fieldTable'} && $this->{'fieldTable'} eq 'dl' ) {
            $comment .= '<dl class="field-dl">';
            $dt  = '<dt>';
            $_dt = '</dt>';
            $dd  = '<dd>';
            $_dd = '</dd>';
            $submit_start
                = '</dl><div class="user-generated-comment-submit">';
            $submit_end = '</div>';
        }
        else {
            $comment .= '<table class="field-table"><tbody>';
            $dt  = '<tr><td class="field-name">';
            $_dt = '</td>';
            $dd  = '<td class="field">';
            $_dd = '</td></tr>';
            $submit_start
                = '</tbody><tbody><tr><td class="submit-box" colspan="2">';
            $submit_end = '</td></tr></tbody></table>';
        }
        if ($title_enabled) {
            $comment
                .= $dt
                . '<label for="'
                . $id
                . '-title">'
                . $this->{'titleFieldName'}
                . '</label>'
                . $_dt;
            $comment
                .= $dd
                . '<input type="text" size="'
                . $this->{'size'}
                . '" id="'
                . $id
                . '-title" name="comment:title" value="'
                . ( ($is_updated_record)
                ? $this->escape( $main::comment{'title'} )
                : '' )
                . '"'
                . (
                (   $is_updated_record && $this->{'is_invalid_field'}{'title'}
                ) ? ' class="invalid-field"' : ''
                )
                . ' onchange="cmonos.validate.field(this).bailOut()" />'
                . $_dd;
        }
        if ($name_enabled) {
            $comment
                .= $dt
                . '<strong><label for="'
                . $id
                . '-name">'
                . $this->{'nameFieldName'}
                . '</label></strong>'
                . $_dt;
            $comment
                .= $dd
                . '<input type="text" size="'
                . $this->{'size'}
                . '" id="'
                . $id
                . '-name" name="comment:name" value="'
                . ( ($external_file_disabled)
                ? $this->escape( $main::comment{'name'} )
                : '' )
                . '" maxlength="'
                . $this->{'size'} . '"'
                . (
                (          $external_file_disabled
                        && $this->{'is_invalid_field'}{'name'}
                ) ? ' class="invalid-field"' : ''
                )
                . ' onchange="cmonos.validate.field(this).asNotEmpty()" />'
                . $_dd;
        }
        if ($email_enabled) {
            $comment
                .= $dt
                . '<label for="'
                . $id
                . '-email">'
                . $this->{'emailFieldName'}
                . '</label>'
                . $_dt;
            $comment
                .= $dd
                . '<input type="email" size="'
                . $this->{'size'}
                . '" id="'
                . $id
                . '-email" name="comment:email" value="'
                . ( ($external_file_disabled)
                ? $this->escape( $main::comment{'email'} )
                : '' )
                . '" onchange="cmonos.validate.field(this).asEMailAddress()"'
                . (
                (          $external_file_disabled
                        && $this->{'is_invalid_field'}{'email'}
                ) ? ' class="invalid-field"' : ''
                ) . ' />';
            $comment
                .= ' <label><input type="checkbox" name="comment:hidden" value="1"'
                . ( ( $external_file_disabled && $main::comment{'hidden'} )
                ? ' checked="checked"'
                : '' )
                . ' />'
                . $this->{'hiddenCheckboxName'}
                . ' </label>'
                . $_dd;
        }
        if ($url_enabled) {
            $comment
                .= $dt
                . '<label for="'
                . $id
                . '-url">'
                . $this->{'urlFieldName'}
                . '</label>'
                . $_dt;
            $comment
                .= $dd
                . '<input type="url" size="'
                . $this->{'size'}
                . '" id="'
                . $id
                . '-url" name="comment:url" value="'
                . ( ($external_file_disabled)
                ? $this->escape( $main::comment{'url'} )
                : '' )
                . '" onchange="cmonos.validate.field(this).asUrl()"'
                . (
                (          $external_file_disabled
                        && $this->{'is_invalid_field'}{'url'}
                ) ? ' class="invalid-field"' : ''
                )
                . ' />'
                . $_dd;
        }
        if ($icon_enabled) {
            my $sample_id = $id . '-icon-sample';
            $comment
                .= $dt
                . '<label for="'
                . $id
                . '-icon">'
                . $this->{'iconSelectorName'}
                . '</label>'
                . $_dt;
            $comment .= $dd;
            $comment
                .= '<div class="user-generated-comment-icon-sample"><img id="'
                . $sample_id
                . '" name="'
                . $sample_id
                . '" src="'
                . (
                (          $external_file_disabled
                        && defined $main::comment{'icon'}
                        && $main::comment{'icon'} ne ''
                ) ? $main::comment{'icon'} : $this->path_change(
                    $env::spacer, $ENV{'SCRIPT_NAME'}, 'abs'
                )
                ) . '" alt="" /></div>';
            $comment .= $this->get_image_menu(
                'comment:icon',
                $id . '-icon',
                ( ($external_file_disabled) ? $main::comment{'icon'} : '' ),
                $sample_id,
                (   (          $external_file_disabled
                            && $this->{'is_invalid_field'}{'icon'}
                    ) ? 1 : 0
                )
            );
            $comment .= $_dd;
        }
        if ($grader_enabled) {
            foreach my $g ( @{ $this->{'syncedgrader'} } ) {
                my $gid   = $id . '-grader-' . $g;
                my $field = $this->{'field_obj'}{$g};
                my $required
                    = ( grep( $_ eq $g, @{ $this->{'requiredgrader'} } ) )
                    ? 1
                    : 0;
                my $v
                    = ($external_file_disabled)
                    ? $main::comment{ 'grader' . $g }
                    : '';
                $comment
                    .= $dt
                    . ( ($required) ? '<strong>' : '' )
                    . '<label for="'
                    . $gid . '">'
                    . $this->escape( $field->name )
                    . '</label>'
                    . ( ($required) ? '</strong>' : '' )
                    . $_dt;
                $comment .= $dd;
                $comment .= $cgi::BarGraph->bargraph(
                    $v,
                    $field->get_bar_max_value,
                    '', $gid,
                    $field->{'barColor'},
                    $field->{'bgColor'},
                    $field->{'barImage'},
                    $field->{'bgImage'},
                    $field->{'barWidth'},
                    $field->name . ':'
                        . (
                        $field->{'grade'}->[
                              scalar( @{ $field->{'grade'} } )
                            - ( $v || 0 )
                            - 1
                            ]
                            || $v
                            || 'クリック！'
                        )
                );
                $comment
                    .= '<div id="'
                    . $gid
                    . '-form">'
                    . $field->get_bargraph_form( 'comment:grader' . $g,
                    $v, 0, $gid )
                    . '</div>';
                $comment .= $field->get_graph_javascript($gid);
                $comment .= $_dd;
            }
        }
        $comment
            .= $dt
            . '<strong><label for="'
            . $id
            . '-comment">'
            . $this->{'commentFieldName'}
            . '</label></strong>'
            . $_dt;
        $comment
            .= $dd
            . '<textarea name="comment:comment" id="'
            . $id
            . '-comment" cols="'
            . $this->{'cols'}
            . '" rows="'
            . $this->{'rows'} . '"'
            . (
            ( $is_updated_record && $this->{'is_invalid_field'}{'comment'} )
            ? ' class="invalid-field"'
            : '' )
            . ' onchange="cmonos.validate.field(this).asNotEmpty()">'
            . (
            ($is_updated_record) ? $this->escape( $main::comment{'comment'} )
            : '' )
            . '</textarea>';
        $comment .= $this->textarea_tool( 'comment:comment', '',
            $id . '-comment' );
        $comment .= $_dd;
        $comment .= $submit_start;
        $comment
            .= '<label><input type="checkbox" name="set_cookie" value="1"'
            . (
            (   $external_file_disabled
                    && ( $cookie::read{'COMMENT'} || $main::set_cookie )
            ) ? ' checked="checked"' : ''
            )
            . ' />'
            . $this->{'rememberCheckboxName'}
            . '</label> ';
        $comment .= $cgi::Deco->submit_button(
            'comment', $this->{'button'},
            $this->{'submitButtonName'},
            { 'id' => $id . '-submit' },
            '', 'abs'
        );
        $comment .= $submit_end;
        $comment .= '</form>';
        $comment .= $this->javascript(
                  'cmonos.form.item("'
                . $id
                . '-form").setDefaultValue("COMMENT-UTF8","'
                . $id
                . '-editor-link");'
                . (
                ( $this->{'hiddenComment'} )
                ? 'cmonos.element.item(\''
                    . $id . '\',\''
                    . $id
                    . '-form\').toggle();'
                : ''
                )
        );
    }
    else {
        $comment .= '<form id="' . $id . '-form"></form>';
        $comment
            .= $this->javascript(
            'cmonos.element.item(\'' . $id . '\').toggle();' )
            if $this->{'hiddenComment'};
    }
    $cgi::Deco->restore_output;
    return (wantarray) ? ( $comment, $comment_content ) : $comment;
}

sub replace_comment ($$$$;$$) {
    my ( $this, $template, $approval_required, $data, $file_flag, $count )
        = @_;
    my ($id,         $ctime,       $approved, $comment, $name,
        $title,      $email,       $hidden,   $url,     $icon,
        $icon_width, $icon_height, $ip,       $agent,   $grades
    ) = @$data;
    return ''
        if !$file_flag
        && ( !defined $comment
        || ( $this->{'pendingEnabled'} && $approval_required && !$approved )
        );
    $$count++ if ref $count;
    $email = ( $hidden || !$email ) ? '' : $cgi::Deco->button(
        'email',
        $this->{'emailButton'},
        $this->address_protector( $email, $this->{'addressProtector'} ),
        (   ( $this->{'addressProtector'} )
            ? ( ( $default::english || !$this->{'emailButton'} )
                ? 'E-Mail'
                : 'メールソフトを開きます。' )
            : $this->address_camouflage($email)
        ),
        '', '', 'abs', 0, 1
    );
    $url
        = ( !$url )
        ? ''
        : $cgi::Deco->button( 'jump', $this->{'urlButton'}, $url, $url,
        '_blank', ( ( $this->{'nofollow'} ) ? { 'rel' => 'nofollow' } : '' ),
        'abs' );
    $icon = ( !$icon ) ? '' : $cgi::Image->image_tag(
        $this->path_change( $icon, $ENV{'SCRIPT_NAME'}, 'abs' ),
        $icon_width,
        $icon_height,
        $this->{'border'},
        $this->get_image_name($icon),
        '',
        $this->{'maxwidth'},
        $this->{'maxheight'}
    );
    my %grade = ();

    if ($grades) {
        foreach my $i ( split( /,/, $grades ) ) {
            $grade{$1} = $2 if $i =~ /([0-9]+)=([0-9]*)/;
        }
    }
    $agent = $this->get_user_agent_info($agent);
    $this->text_conv( \$title ) if $title;
    $this->text_conv( \$comment );
    $this->text_fix( \$comment, $this->{'csv'} );
    $template
        =~ s/<\!--name(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/name(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('name',$1,$2,$name,$file_flag)/ges;
    $template
        =~ s/<\!--email(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/email(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('email',$1,$2,$email,$file_flag)/ges;
    $template
        =~ s/<\!--title(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/title(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('title',$1,$2,$title,$file_flag)/ges;
    $template
        =~ s/<\!--url(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/url(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('url',$1,$2,$url,$file_flag)/ges;
    $template
        =~ s/<\!--icon(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/icon(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('icon',$1,$2,$icon,$file_flag)/ges;
    $template
        =~ s/<\!--grade(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/grade(?![0-9a-zA-Z_])[^>]*-->/$this->grade_tag_replace($1,$2,\%grade,$file_flag)/ges;
    $template
        =~ s/<\!--ip(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/ip(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('ip',$1,$2,$ip,$file_flag)/ges;
    $template
        =~ s/<\!--agent(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/agent(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('agent',$1,$2,$agent,$file_flag)/ges;
    $template
        =~ s/<\!--ctime(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/ctime(?![0-9a-zA-Z_])[^>]*-->/$this->datetime_tag_replace('ctime',$1,$2,$ctime,(($this->{'externalFileDisabled'}) ? $this->{'datelimit'} : 0),'gmt' . $this->{'datetype'},'',$file_flag)/ges;
    $template
        =~ s/<\!--comment(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/comment(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('comment',$1,$2,$comment,$file_flag)/ges;

    if ( $template =~ /<!--tate(?![0-9a-zA-Z_])[^>]*-->/ ) {
        require CMONOS::CGI_Lib::Taketori;
        $template = Taketori->new( { 'css' => 1 } )
            ->text_to_tategaki( $template, $file_flag );
    }
    return $template;
}

sub grade_tag_replace ($$$$$) {
    my ( $this, $attributes, $content, $grade, $file_flag ) = @_;
    my ( $header, $footer );
    ( $header, $footer, $attributes )
        = $this->get_header_and_footer( $attributes, $content );
    $attributes = '' if $attributes !~ /[^\x09\x0A\x0C\x0D\x20]/;
    my $temp = '';
    if (%$grade) {
        foreach my $id ( @{ $this->{'syncedgrader'} } ) {
            if ( $grade->{$id} ) {
                my $field = $this->{'field_obj'}{$id};
                my $h     = $header;
                my $f     = $footer;
                my $name  = $field->name;
                $h
                    =~ s/<\!--gradename(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/gradename(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('gradename',$1,$2,$name,$file_flag)/ges;
                $f
                    =~ s/<\!--gradename(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/gradename(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('gradename',$1,$2,$name,$file_flag)/ges;
                if ($file_flag) {
                    $temp
                        .= '<!--grade'
                        . $attributes . '-->'
                        . ( ( $h ne '' )
                        ? '<!--head-->' . $h . '<!--/head-->'
                        : '' );
                }
                else {
                    $temp .= $h;
                }
                $temp .= $cgi::BarGraph->bargraph(
                    $grade->{$id},
                    $field->get_bar_max_value,
                    '', $id,
                    $field->{'barColor'},
                    $field->{'bgColor'},
                    $field->{'barImage'},
                    $field->{'bgImage'},
                    $field->{'barWidth'},
                    $name . ':'
                        . (
                        $field->{'grade'}->[
                              scalar( @{ $field->{'grade'} } )
                            - ( $grade->{$id} || 0 )
                            - 1
                            ]
                            || $grade->{$id}
                            || '0'
                        )
                );
                if ($file_flag) {
                    $temp
                        .= ( ( $f ne '' )
                        ? '<!--foot-->' . $f . '<!--/foot-->'
                        : '' )
                        . '<!--/grade-->';
                }
                else {
                    $temp .= $f;
                }
            }
        }
    }
    if ($temp) {
        return $temp;
    }
    elsif ($file_flag) {
        return
              '<!--grade'
            . $attributes
            . ( ( $header ne '' )
            ? ' head="' . $this->lf_to_entity( $this->escape($header) ) . '"'
            : '' )
            . ( ( $footer ne '' )
            ? ' foot="' . $this->lf_to_entity( $this->escape($footer) ) . '"'
            : '' )
            . '--><!--/grade-->';
    }
    else {
        return '';
    }
}

sub get_image_name ($$) {
    my ( $this, $data ) = @_;
    $this->set_image_info_hash;
    my $img = ( $data =~ /([^\/]+)$/ ) ? $1 : '';
    return ( $this->{'image'}{$img}{'name'} )
        ? $this->{'image'}{$img}{'name'}
        : $img;
}

#画像選択フォーム
sub get_image_menu ($$$;$$$) {
    my ( $this, $name, $id, $default, $sample_id, $is_invalid_field ) = @_;
    return '' if !defined $this->{'dir'} || $this->{'dir'} eq '';
    my ( $form, $dir, $file, %image );
    local ( *DIR, *NAME );
    $dir = $env::image_dir . '/imagemenu/' . $this->{'dir'};
    return '' unless opendir( DIR, $dir );
    $dir .= '/';
    while ( $file = readdir(DIR) ) {

        if (   $file =~ /\.(gif|jpg|png)$/i
            && $file !~ /^\./
            && -f $dir . $file )
        {
            $image{$file} = 1;
        }
    }
    closedir(DIR);
    $form
        = '<select name="'
        . $name
        . '" id="'
        . ( ( $id ne '' )       ? $id                      : $name ) . '"'
        . ( ($is_invalid_field) ? ' class="invalid-field"' : '' )
        . ( ( !$sample_id )
        ? ' multiple="multiple" onchange="cmonos.validate.field(this).bailOut()"'
        : ' onchange="cmonos.element.item(\''
            . $sample_id
            . '\').setSrc(this.options[this.selectedIndex].value);cmonos.validate.field(this).bailOut()"'
        ) . '>';
    $form
        .= '<option value="'
        . $this->path_change( $env::spacer, $ENV{'SCRIPT_NAME'}, 'abs' )
        . '"></option>'
        if $sample_id;
    if ( open( NAME, $dir . 'name.txt' ) ) {
        binmode NAME, ":utf8";
        flock( NAME, LOCK_SH );
        my $line;
        while ( $line = <NAME> ) {
            chomp $line;
            next if $line !~ /:/;
            my ( $img, $name, $reserved ) = split( /:/, $line, 3 );
            next if !defined $image{$img} || !$image{$img};
            delete $image{$img};
            my $path = $this->path_change( $dir . $img, $ENV{'SCRIPT_NAME'},
                'abs' );
            if ($reserved) {
                if (   $this->{'externalFileDisabled'}
                    && $this->is_secure('tools') )
                {
                    $name = '*' . $name;
                }
                else {
                    next;
                }
            }
            $form
                .= '<option value="'
                . $path . '"'
                . (
                (   ( $default && !ref $default && $default eq $path )
                        || ( ref $default eq 'ARRAY'
                        && grep( $_ eq $path, @$default ) )
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . $name
                . '</option>';
        }
        close(NAME);
    }
    foreach my $img ( sort keys %image ) {
        my $path
            = $this->path_change( $dir . $img, $ENV{'SCRIPT_NAME'}, 'abs' );
        $form
            .= '<option value="'
            . $path . '"'
            . ( ( ref $default eq 'ARRAY' && grep( $_ eq $path, @$default ) )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $img
            . '</option>';
    }
    $form .= '</select>';
    return $form;
}

sub set_image_info_hash ($) {
    my $this = shift;
    return
           if ref $this->{'image'}
        || !defined $this->{'dir'}
        || $this->{'dir'} eq '';
    local (*NAME);
    if (open( NAME,
                  $env::image_dir
                . '/imagemenu/'
                . $this->{'dir'} . '/'
                . 'name.txt'
        )
        )
    {
        binmode NAME, ":utf8";
        flock( NAME, LOCK_SH );
        while ( my $line = <NAME> ) {
            next if $line !~ /:/;
            chomp $line;
            my ( $img, $name, $reserved ) = split( /:/, $line, 3 );
            if ( defined $img && $img ne '' ) {
                $this->{'image'}{$img}{'name'}     = $name;
                $this->{'image'}{$img}{'reserved'} = $reserved;
            }
        }
        close(NAME);
    }
}

sub get_user_agent_info ($;$$) {
    my ( $this, $user_agent, $rmtag ) = @_;
    my @info = $cgi::UserAgent->get_user_agent_info($user_agent);
    $info[2] .= $info[3];
    splice( @info, 3, 1 );
    shift @info;
    @info = grep( defined $_ && $_ ne '', @info );
    map( $_ = $this->escape($_), @info );
    return join( '/', @info );
}

sub get_user_generated_field_data_for_text ($$$$) {
    my ( $this, $memory, $data_ref, $path ) = @_;
    my $approval_required = ( $data_ref->{'approvalRequired'} ) ? 1 : 0;
    my $out               = '';
    my $template          = $this->get_comment_template(1);
    $memory = $this->{'masterMemory'}
        if $this->{'masterMemory'}
        && ( !defined $memory
        || $memory eq ''
        || $memory > $this->{'masterMemory'} );
    local (*DAT);
    if ( open( DAT, $path . '/' . $this->{'id'} . '.dat' ) ) {
        binmode DAT, ":utf8";
        flock( DAT, LOCK_SH );
        my $count;
        while ( my $line = <DAT> ) {
            chomp $line;
            my ($id,   $ctime, $approved,   $comment,
                $name, $title, $email,      $hidden,
                $url,  $icon,  $icon_width, $icon_height,
                $ip,   $agent
            ) = $this->svsplit( "\x09", $line );
            if (   !$this->{'pendingEnabled'}
                || !$approval_required
                || $approved )
            {
                $this->text_conv( \$title ) if $title;
                $this->text_conv( \$comment );
                $out
                    .= $this->detag( $this->{'titleFieldName'} ) . ' > '
                    . $title . "\x0A"
                    if defined $title && $title ne '';
                $out
                    .= $this->detag( $this->{'nameFieldName'} ) . ' > '
                    . $name . "\x0A"
                    if defined $name && $name ne '';
                $out
                    .= $this->detag( $this->{'emailFieldName'} ) . ' > '
                    . $email . "\x0A"
                    if !$hidden && defined $email && $email;
                $out
                    .= $this->detag( $this->{'urlFieldName'} ) . ' > '
                    . $url . "\x0A"
                    if defined $url && $url;
                $out .= $this->detag( $this->{'commentFieldName'} ) . ' >'
                    . "\x0A";
                $out
                    .= $this->detag($comment) . "\x0A("
                    . $this->date( $ctime, 0, 'gmt' . $this->{'datetype'} )
                    . ")\x0A\x0A";
                $count++;
            }
            last if $memory && $count >= $memory;
        }
        close(DAT);
    }
    return ($out) ? $out : '記事がありません。';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_template">テンプレート</label></legend>';
    print '<textarea name="'
        . $name
        . '_template" id="'
        . $name
        . '_template" cols="72" rows="10" wrap="off" class="content-editor-area">'
        . $this->escape( $this->{'template'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<label class="auto-fit" title="高さを内容に合わせる"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'',
        $name,
        '_template\').setAutoFit(this.checked);" />フィット</label> ';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_template\').quotationByMenu(this)" title="これらのタグは、書き出し時に対応する投稿データに変換されます。">';
    print '<option value="">▼投稿データタグを挿入する</option>';
    print
        '<option value="&lt;!--article--&gt;&lt;!--/article--&gt;">繰り返しの範囲 &lt;!--article--&gt;&lt;!--/article--&gt;</option>';
    print
        '<option value="&lt;!--name--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/name--&gt;">名前 &lt;!--name--&gt;&lt;!--/name--&gt;</option>';
    print
        '<option value="&lt;!--comment--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/comment--&gt;">コメント &lt;!--comment--&gt;&lt;!--/comment--&gt;</option>';
    print
        '<option value="&lt;!--title--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/title--&gt;">タイトル &lt;!--title--&gt;&lt;!--/title--&gt;</option>';
    print
        '<option value="&lt;!--email--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/email--&gt;">メールアドレスリンク &lt;!--email--&gt;&lt;!--/email--&gt;</option>';
    print
        '<option value="&lt;!--url--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/url--&gt;">URLリンク &lt;!--url--&gt;&lt;!--/url--&gt;</option>';
    print
        '<option value="&lt;!--icon--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/icon--&gt;">アイコン &lt;!--icon--&gt;&lt;!--/icon--&gt;</option>';
    print
        '<option value="&lt;!--grade--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/grade--&gt;">採点 &lt;!--grade--&gt;&lt;!--/grade--&gt;</option>';
    print
        '<option value="&lt;!--ip--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/ip--&gt;">投稿者 IP &lt;!--ip--&gt;&lt;!--/ip--&gt;</option>';
    print
        '<option value="&lt;!--agent--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/agent--&gt;">投稿者環境情報 &lt;!--agent--&gt;&lt;!--/agent--&gt;</option>';
    print
        '<option value="&lt;!--ctime--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/ctime--&gt;">投稿日時 &lt;!--ctime--&gt;&lt;!--/ctime--&gt;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot( '<div class="user-generated-comment">\n'
            . '<!--icon--><!--head--><div class="user-generated-comment-icon"><!--/head--><!--foot--></div><!--/foot--><!--/icon-->\n'
            . '<!--title--><!--head--><h4 class="user-generated-comment-head"><!--/head--><!--foot--></h4><!--/foot--><!--/title-->\n'
            . '<div class="user-generated-comment-body">\n'
            . '<!--comment--><!--/comment-->\n'
            . '</div>\n'
            . '<!--grade--><!--head--><div class="user-generated-comment-grade"><!--/head--><!--foot--></div><!--/foot--><!--/grade-->\n'
            . '<div class="user-generated-comment-info">\n'
            . '<strong><!--name--><!--/name--></strong>\n'
            . '<!--email--><!--head--> <!--/head--><!--foot--><!--/foot--><!--/email-->\n'
            . '<!--url--><!--head--> <!--/head--><!--foot--><!--/foot--><!--/url-->\n'
            . '<!--ctime--><!--head--> (<!--/head--><!--foot-->)<!--/foot--><!--/ctime-->\n'
            . '</div>\n'
            . '</div>\n' )
        . '">テンプレート例</option>';
    print '<option value="'
        . $this->jsquot( '<dl class="log">\n'
            . '<!--article--><dt>\n'
            . '<!--icon--><!--head--><span class="icon"><!--/head--><!--foot--></span><!--/foot--><!--/icon-->\n'
            . '<span class="name"><!--name--><!--/name--></span>\n'
            . '<span class="date"><!--ctime--><!--/ctime--></span>\n'
            . '<!--email--><!--head--><span class="email"><!--/head--><!--foot--></span><!--/foot--><!--/email-->\n'
            . '<!--url--><!--head--><span class="url"><!--/head--><!--foot--></span><!--/foot--><!--/url-->\n'
            . '</dt>\n'
            . '<dd>\n'
            . '<!--comment--><!--/comment-->\n'
            . '<!--grade--><!--/grade-->\n'
            . '</dd><!--/article-->\n'
            . '</dl>\n' )
        . '">Vicuna CMS 互換テンプレート例</option>';
    print '</select>';

    require CMONOS::CGI_Lib::HTMLHelper;
    print HTMLHelper->new->html_helper_menu( $name . '_template' );

    if ( ref $frame::obj{'frame'} ) {
        my $sample = '';
        print
            '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'',
            $name,
            '_template\').quotationByMenu(this)" title="これらのタグは、書き出し時に対応するフレームに変換されます。">';
        print
            '<option value="">▼フレームタグを挿入する</option>';
        foreach my $frid ( sort { $a <=> $b } keys %{ $frame::obj{'frame'} } )
        {
            $sample = $frid;
            print '<option value="&lt;!--frame id=&quot;', $frid,
                '&quot;--&gt;&lt;!--titlebar--&gt;&lt;!--/titlebar--&gt;&lt;!--contents--&gt;&lt;!--/contents--&gt;&lt;!--/frame--&gt;">ID : ',
                $frid, '</option>';
        }
        print '</select>';
        print
            '<div id="frame-tips"><label title="チェックするとフレームサンプルを表示します"><input type="checkbox" onclick="cmonos.element.item(\'framesample\').disappear(!this.checked);" /> フレームサンプルを表示する</label> <div id="framesample" style="display: none">';
        print $cgi::Deco->frame_menu( '', 'frame', '', '', 'ID' );
        print '</div>';
        print
            '<label title="チェックするとフレームタグの書き方を表示します"><input type="checkbox" onclick="cmonos.element.item(\'frametagsample\').disappear(!this.checked);" /> フレームタグの書き方を表示する</label> <table id="frametagsample" style="display: none"><tbody><tr><td id="sample-frame">';
        my ( $contents, $title ) = (
            '<strong>コンテンツ</strong>',
            '<strong>タイトル</strong>'
        );
        print $cgi::Deco->frame( 'frame', $sample, \$contents, \$title, 'no',
            '', 0, 'type', 'frame', 'titlenowrap', 1, 'contentsnowrap', 1 );
        print '</td><td id="sample-tag">';
        print
            '&lt;!--frame id=&quot;<strong>ID</strong>&quot;--&gt;<br />&lt;!--titlebar--&gt;<strong>タイトル</strong>&lt;!--/titlebar--&gt;<br />&lt;!--contents--&gt;<strong>コンテンツ</strong>&lt;!--/contents--&gt;<br />&lt;!--/frame--&gt;';
        print '</td></tr></tbody></table>';
        print '</div>';
    }

    print '</div>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>入力欄名/ボタン</legend>';
    my $table = Table->new;
    $table->set(
        'tableclass' => 'tooltable',
        'thenabled'  => 'true',
        'trclass'    => 'odd,even',
        'class0'     => 'odd,even',
        'classF'     => 'name',
        'style0'     => 'text-align: center'
    );
    print $table->table;
    print $table->tr;
    print $table->td('入力欄');
    print $table->td('入力欄名');
    print $table->td('入力欄/ボタン設定');
    print $table->_tr;
    print $table->tr;
    print $table->td('名前');
    print $table->td( '<input type="text" size="24" name="'
            . $name
            . '_nameFieldName" value="'
            . $this->escape( $this->{'nameFieldName'} )
            . '" />' );
    print $table->td( '<input type="number" size="3" name="'
            . $name
            . '_size" value="'
            . $this->escape( $this->{'size'} )
            . '" /> 文字(共通)' );
    print $table->_tr;
    print $table->tr;
    print $table->td('タイトル');
    print $table->td( '<input type="text" size="24" name="'
            . $name
            . '_titleFieldName" value="'
            . $this->escape( $this->{'titleFieldName'} )
            . '" />' );
    print $table->td();
    print $table->_tr;
    print $table->tr;
    print $table->td('メールアドレス');
    print $table->td( '<input type="text" size="24" name="'
            . $name
            . '_emailFieldName" value="'
            . $this->escape( $this->{'emailFieldName'} )
            . '" />' );
    print $table->td(
        $cgi::Deco->button_menu(
            $name . '_emailButton',
            'email', 120, $this->{'emailButton'}
        )
    );
    print $table->_tr;
    print $table->tr;
    print $table->td('ホームページ');
    print $table->td( '<input type="text" size="24" name="'
            . $name
            . '_urlFieldName" value="'
            . $this->escape( $this->{'urlFieldName'} )
            . '" />' );
    print $table->td(
        $cgi::Deco->button_menu(
            $name . '_urlButton',
            'jump', 120, $this->{'urlButton'}
        )
    );
    print $table->_tr;
    print $table->tr;
    print $table->td('アイコン');
    print $table->td( '<input type="text" size="24" name="'
            . $name
            . '_iconSelectorName" value="'
            . $this->escape( $this->{'iconSelectorName'} )
            . '" />' );
    print $table->td( $this->icon_setting($name) );
    print $table->_tr;
    print $table->tr;
    print $table->td('採点フィールド連動');
    print $table->td();
    print $table->td( $this->synced_grader_setting($name) );
    print $table->_tr;
    print $table->tr;
    print $table->td('コメント');
    print $table->td( '<input type="text" size="24" name="'
            . $name
            . '_commentFieldName" value="'
            . $this->escape( $this->{'commentFieldName'} )
            . '" />' );
    print $table->td( '幅 <input type="number" size="3" name="'
            . $name
            . '_cols" value="'
            . $this->escape( $this->{'cols'} )
            . '" /> 文字 × 高さ <input type="number" size="3" name="'
            . $name
            . '_rows" value="'
            . $this->escape( $this->{'rows'} )
            . '" /> 文字' );
    print $table->_tr;
    print $table->tr;
    print $table->td('メールアドレス非表示');
    print $table->td( '<input type="text" size="24" name="'
            . $name
            . '_hiddenCheckboxName" value="'
            . $this->escape( $this->{'hiddenCheckboxName'} )
            . '" />' );
    print $table->td();
    print $table->_tr;
    print $table->tr;
    print $table->td('送信ボタン');
    print $table->td( '<input type="text" size="24" name="'
            . $name
            . '_submitButtonName" value="'
            . $this->escape( $this->{'submitButtonName'} )
            . '" />' );
    print $table->td(
        $cgi::Deco->button_menu(
            $name . '_button',
            'comment', 120, $this->{'button'}
        )
    );
    print $table->_tr;
    print $table->tr;
    print $table->td('情報を記憶する');
    print $table->td( '<input type="text" size="24" name="'
            . $name
            . '_rememberCheckboxName" value="'
            . $this->escape( $this->{'rememberCheckboxName'} )
            . '" />' );
    print $table->td();
    print $table->_tr;
    print $table->_table;
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>投稿設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_fieldTable">入力欄表示形式</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_fieldTable', '入力欄表示形式', '',
        $this->{'fieldTable'},
        'table' => 'テーブル',
        'dl'    => '定義リスト'
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_masterMemory">コメント最大保存数</label></td>';
    print '<td class="field"><input type="number" name="'
        . $name
        . '_masterMemory" id="'
        . $name
        . '_masterMemory" value="'
        . $this->escape( $this->{'masterMemory'} )
        . '" size="3" title="各記事の設定に優先する最大保存数を設定します。" /> <span class="unit">件</span></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_maxlength">コメント最大文字数</label></td>';
    print '<td class="field"><input type="number" name="'
        . $name
        . '_maxlength" id="'
        . $name
        . '_maxlength" value="'
        . $this->escape( $this->{'maxlength'} )
        . '" size="3" title="コメントの文字数を制限します。" /> <span class="unit">文字（半角）</span></td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><span class="datatitle">コメント入力チェック</span></td>';
    print '<td class="field"><label><input type="checkbox" name="'
        . $name
        . '_type" id="'
        . $name
        . '_type" value="j"'
        . ( ( $this->{'type'} && $this->{'type'} eq 'j' )
        ? ' checked="checked"'
        : '' )
        . ' /> 日本語文字列必須</label></td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_rule">連続投稿制限</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_rule', '連続投稿制限', '', $this->{'rule'},
        '0' => '制限なし',
        '1' => '同一 IP からの連続投稿を制限',
        '2' => '類似 IP からの連続投稿を制限'
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_cancelLimit">制限期限</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_cancelLimit', '制限期限', '', $this->{'cancelLimit'},
        '0'       => '無期限',
        '86400'   => '1日後',
        '259200'  => '3日後',
        '604800'  => '7日後',
        '1209600' => '14日後',
        '2592000' => '30日後',
        '5184000' => '60日後',
        '7776000' => '90日後'
    );
    print '</td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_generatableUser">パスワード制限</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_generatableUser', '', '', $this->{'generatableUser'},
        'master'  => 'マスター',
        'owner'   => '管理人',
        'owners'  => '共同オーナー',
        'staff'   => 'スタッフ',
        'member'  => '登録メンバー',
        'nocheck' => 'チェックなし'
    );
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';

    if ( !$this->is_closed_door ) {
        print '<tr>';
        print
            '<td class="field-name"><span class="datatitle">表示のタイミング</span></td>';
        print '<td class="field"><label><input type="checkbox" name="'
            . $name
            . '_pendingEnabled" id="'
            . $name
            . '_pendingEnabled" value="1"'
            . (
            (   defined $this->{'pendingEnabled'} && $this->{'pendingEnabled'}
            ) ? ' checked="checked"' : ''
            )
            . ' /> 承認されるまで表示しないことを可能にする</label></td>';
        print '</tr>';
    }
    print '<tr>';
    print '<td class="field-name"><span class="datatitle">隠す</span></td>';
    print '<td class="field"><label><input type="checkbox" name="'
        . $name
        . '_hiddenComment" id="'
        . $name
        . '_hiddenComment" value="1"'
        . ( ( defined $this->{'hiddenComment'} && $this->{'hiddenComment'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 初期状態でコメント数のみ表示する(コメント数クリックでコメントを表示)</label></td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><span class="datatitle">後処理</span></td>';
    print '<td class="field"><ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_externalFileDisabled" id="'
        . $name
        . '_externalFileDisabled" value="1"'
        . (
        (   defined $this->{'externalFileDisabled'}
                && $this->{'externalFileDisabled'}
        ) ? ' checked="checked"' : ''
        )
        . ' /> JavaScript による埋め込みではなく、その都度描画する (外部 JavaScript ファイルを作成しない)</label></li>'
        if !$default::static && !$this->is_closed_door;
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_mTime" id="'
        . $name
        . '_mTime" value="1"'
        . ( ( defined $this->{'mTime'} && $this->{'mTime'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 投稿時に更新時データベースを更新する</label></li>'
        if !$default::static;
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_nameCheck" id="'
        . $name
        . '_nameCheck" value="1"'
        . ( ( defined $this->{'nameCheck'} && $this->{'nameCheck'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 名前を重複チェックデータベースに登録する（登録済みの名前と重複していないかチェックする）</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_nameRegister" id="'
        . $name
        . '_nameRegister" value="1"'
        . ( ( defined $this->{'nameRegister'} && $this->{'nameRegister'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 名前をユーザー名データベースに登録する（他の CGI で利用）</label></li>';

    if ( !$this->is_closed_door ) {
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_rssEnabled" id="'
            . $name
            . '_rssEnabled" value="1"'
            . ( ( defined $this->{'rssEnabled'} && $this->{'rssEnabled'} )
            ? ' checked="checked"'
            : '' )
            . ' /> コメント RSS を更新する</label></li>';
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_naviEnabled" id="'
            . $name
            . '_naviEnabled" value="1"'
            . ( ( defined $this->{'naviEnabled'} && $this->{'naviEnabled'} )
            ? ' checked="checked"'
            : '' )
            . ' /> 最新コメント一覧を更新する</label></li>';
    }
    print '</ol>';
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    if ( !$default::static ) {
        print '<tr>';
        print
            '<td class="field-name"><span class="datatitle">投稿日時の表示</span></td>';
        print '<td class="field"><label for="'
            . $name
            . '_datelimit"><input type="number" size="3" maxlength="3" name="'
            . $name
            . '_datelimit" id="'
            . $name
            . '_datelimit" value="'
            . $this->escape( $this->{'datelimit'} )
            . '" /> 日以内なら相対日時で表現する（きょう/きのう/○日前）</label></td>';
        print '</tr>';
    }
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_datetype">日時表示形式</label></td>';
    print '<td class="field">';
    $this->print_date_type_menu( $name . '_', $this->{'datetype'} );
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_mailtoMaster">投稿通知送信先</label></td>';
    print '<td class="field">';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_mailtoMaster" id="'
        . $name
        . '_mailtoMaster" value="1"'
        . ( ( defined $this->{'mailtoMaster'} && $this->{'mailtoMaster'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 管理人アドレス</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_mailtoOwners" value="1"'
        . ( ( defined $this->{'mailtoOwners'} && $this->{'mailtoOwners'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 共同オーナーアドレス</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_mailtoStaff" value="1"'
        . ( ( defined $this->{'mailtoStaff'} && $this->{'mailtoStaff'} )
        ? ' checked="checked"'
        : '' )
        . ' /> スタッフアドレス</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_mailtoAllEMailAddresses" value="1"'
        . (
        (   defined $this->{'mailtoAllEMailAddresses'}
                && $this->{'mailtoAllEMailAddresses'}
        ) ? ' checked="checked"' : ''
        )
        . ' /> すべてのメールアドレスフィールド</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_mailToUser" value="1"'
        . ( ( defined $this->{'mailToUser'} && $this->{'mailToUser'} )
        ? ' checked="checked"'
        : '' )
        . ' /> ユーザー指定アドレス</label></li>';
    print '</ol>';
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>コメント制御</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_taboowords">禁止文字列</label></td>';
    print '<td class="field"><textarea name="'
        . $name
        . '_taboowords" id="'
        . $name
        . '_taboowords" cols="56" rows="4" wrap="off">'
        . $this->escape( $this->{'taboowords'} )
        . '</textarea>';
    print '<div class="extra-field"><label><input type="checkbox" name="'
        . $name
        . '_tabooregexp" value="1"'
        . ( ( defined $this->{'tabooregexp'} && $this->{'tabooregexp'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 正規表現を使用する</label></div>';
    print '<div class="note">禁止文字列ごとに改行</div>';
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_convtable">文字変換表</label></td>';
    print '<td class="field"><textarea name="'
        . $name
        . '_convtable" id="'
        . $name
        . '_convtable" cols="56" rows="4" wrap="off" title="下記書式に従って文字変換表を設定します。">'
        . $this->escape( $this->{'convtable'} )
        . '</textarea>';
    print '<div class="extra-field"><label><input type="checkbox" name="'
        . $name
        . '_convregexp" value="1"'
        . ( ( defined $this->{'convregexp'} && $this->{'convregexp'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 正規表現を使用する</label></div>';
    print
        '<div class="note">書式：変換対象文字列=&gt;変換後文字列[改行]</div>';
    print
        '<div class="example">例）、=>，（句読点の統一例）/SPAM=>spam（語句の統一例）</div>';
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    $this->print_html_tag_setting_form( $name, '(コメント欄)' );
    $this->print_table_setting_form( $name, '(コメント内テーブル)' );

    if ( !$this->is_closed_door ) {
        print '<fieldset>';
        print '<legend>登録ユーザーによる削除</legend>';
        print '<label><input type="checkbox" name="'
            . $name
            . '_deletable" value="1"'
            . ( ( defined $this->{'deletable'} && $this->{'deletable'} )
            ? ' checked="checked"'
            : '' )
            . ' /> 登録ユーザーによるコメントの削除を許可する</label>';
        print '</fieldset>';
    }
    $this->print_setting_save_button;
}

sub icon_setting ($$) {
    my ( $this, $name ) = @_;
    my $form
        = '<select name="'
        . $name
        . '_dir" id="'
        . $name
        . '_dir" title="画像ディレクトリを選択してください。">';
    local ( *DIR, *NAME );
    if ( opendir( DIR, $env::image_dir . '/imagemenu' ) ) {
        my @dir
            = grep( $_ !~ /^\./ && -d $env::image_dir . '/imagemenu/' . $_,
            readdir(DIR) );
        closedir(DIR);
        my ($dir_name);
        foreach $dir_name (@dir) {
            my ($name);
            if (open( NAME,
                          $env::image_dir
                        . '/imagemenu/'
                        . $dir_name . '/'
                        . 'name.txt'
                )
                )
            {
                binmode NAME, ":utf8";
                flock( NAME, LOCK_SH );
                $name = <NAME>;
                close(NAME);
                chomp $name;
            }
            $name = $dir_name
                if !defined $name || $name eq '' || $name =~ /:/;
            $form
                .= '<option value="'
                . $dir_name . '"'
                . ( ( defined $this->{'dir'} && $dir_name eq $this->{'dir'} )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $name
                . '</option>';
        }
    }
    $form .= '</select>';
    return $form;
}

sub synced_grader_setting ($$) {
    my ( $this, $name ) = @_;
    my $form .= '<ol class="checkbox">';
    foreach my $field_id (
        sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
        } keys %{ $this->{'field_obj'} }
        )
    {
        if ( ref $this->{'field_obj'}->{$field_id}
            && $this->{'field_obj'}->{$field_id}->{'class'} eq 'ug_grader' )
        {
            $form
                .= '<li><label><input type="checkbox" name="'
                . $name
                . '_syncedgrader" id="'
                . $name
                . '_syncedgrader" value="'
                . $field_id . '"'
                . (
                (   ref $this->{'syncedgrader'}
                        && grep( $_ eq $field_id,
                        @{ $this->{'syncedgrader'} } )
                ) ? ' checked="checked"' : ''
                )
                . '> '
                . $this->escape( $this->{'field_obj'}{$field_id}->name )
                . '</label> (<label><input type="checkbox" name="'
                . $name
                . '_requiredgrader" id="'
                . $name
                . '_requiredgrader" value="'
                . $field_id . '"'
                . (
                (   ref $this->{'requiredgrader'} && grep( $_ eq $field_id,
                        @{ $this->{'requiredgrader'} } )
                ) ? ' checked="checked"' : ''
                ) . '>必須</label>)</li>';
        }
    }
    $form .= '</ol>';
    return $form;
}

######################################################################
#	(6) obj->is_valid_setting;
sub _is_valid_sub_setting ($) {
    my $this     = shift;
    my $is_valid = 1;
    $this->tag_fix( \$main::data{ $this->{'id'} . '_nameFieldName' } )
        if defined $main::data{ $this->{'id'} . '_nameFieldName' }
        && $main::data{ $this->{'id'} . '_nameFieldName' };
    if (   defined $main::data{ $this->{'id'} . '_size' }
        && $main::data{ $this->{'id'} . '_size' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_size' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '入力欄サイズを更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_size' };
        $is_valid = 0;
    }
    $this->tag_fix( \$main::data{ $this->{'id'} . '_titleFieldName' } )
        if defined $main::data{ $this->{'id'} . '_titleFieldName' }
        && $main::data{ $this->{'id'} . '_titleFieldName' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_emailFieldName' } )
        if defined $main::data{ $this->{'id'} . '_emailFieldName' }
        && $main::data{ $this->{'id'} . '_emailFieldName' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_urlFieldName' } )
        if defined $main::data{ $this->{'id'} . '_urlFieldName' }
        && $main::data{ $this->{'id'} . '_urlFieldName' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_iconSelectorName' } )
        if defined $main::data{ $this->{'id'} . '_iconSelectorName' }
        && $main::data{ $this->{'id'} . '_iconSelectorName' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_hiddenCheckboxName' } )
        if defined $main::data{ $this->{'id'} . '_hiddenCheckboxName' }
        && $main::data{ $this->{'id'} . '_hiddenCheckboxName' };
    $this->escape( \$main::data{ $this->{'id'} . '_submitButtonName' } )
        if defined $main::data{ $this->{'id'} . '_submitButtonName' }
        && $main::data{ $this->{'id'} . '_submitButtonName' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_rememberCheckboxName' } )
        if defined $main::data{ $this->{'id'} . '_rememberCheckboxName' }
        && $main::data{ $this->{'id'} . '_rememberCheckboxName' };

    #チェックボックス
    $main::data{ $this->{'id'} . '_hiddenComment' } = ''
        if !defined $main::data{ $this->{'id'} . '_hiddenComment' }
        || !$main::data{ $this->{'id'} . '_hiddenComment' };
    $main::data{ $this->{'id'} . '_nameCheck' } = ''
        if !defined $main::data{ $this->{'id'} . '_nameCheck' }
        || $main::data{ $this->{'id'} . '_nameCheck' } eq '';
    $main::data{ $this->{'id'} . '_nameRegister' } = ''
        if !defined $main::data{ $this->{'id'} . '_nameRegister' }
        || $main::data{ $this->{'id'} . '_nameRegister' } eq '';
    $main::data{ $this->{'id'} . '_rssEnabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_rssEnabled' }
        || $main::data{ $this->{'id'} . '_rssEnabled' } eq '';
    $main::data{ $this->{'id'} . '_naviEnabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_naviEnabled' }
        || $main::data{ $this->{'id'} . '_naviEnabled' } eq '';
    $main::data{ $this->{'id'} . '_deletable' } = ''
        if !defined $main::data{ $this->{'id'} . '_deletable' }
        || $main::data{ $this->{'id'} . '_deletable' } eq '';
    $main::data{ $this->{'id'} . '_syncedgrader' } = ''
        if !defined $main::data{ $this->{'id'} . '_syncedgrader' };
    $main::data{ $this->{'id'} . '_requiredgrader' } = ''
        if !defined $main::data{ $this->{'id'} . '_requiredgrader' };

    return $is_valid;
}

######################################################################
#	(11) obj->update;
sub update ($;$) {
    my ( $this, $is_ajax ) = @_;
    my ($input_is_valid);
    $this->save_update_target;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};

    #入力のチェック
    $input_is_valid = 1;
    $this->detag( \$main::comment{'name'}, \$main::comment{'title'} );

    #半角変換
    $main::comment{'email'} = $this->z_to_h( $main::comment{'email'} );
    $main::comment{'url'}   = $this->z_to_h( $main::comment{'url'} );

    if ($main::name
        || ((   !defined $main::comment{'name'}
                || $main::comment{'name'} eq ''
            )
            && $this->get_comment_template(1)
            =~ /<!--name(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/name-->/s
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ($default::english)
                ? 'Error! Please input your name.'
                : $this->{'nameFieldName'}
                    . ' が入力されていません。'
            )
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'name'} = 1;
        $input_is_valid = 0;
    }
    elsif ( $this->{'nameCheck'} && $this->use_register ) {
        if ($cgi::Register->is_available_name(
                $main::pswd,            $main::email,
                $main::comment{'name'}, $security::registered,
                $is_ajax
            )
            )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                $cgi::Register->success_dialog
            ) if ref $cgi::action;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                $cgi::Register->error_dialog
            ) if ref $cgi::action;
            $this->{'is_invalid_field'}{'name'} = 1;
            $input_is_valid = 0;
        }
    }
    if ($main::emailaddress
        || (   defined $main::comment{'email'}
            && $main::comment{'email'} ne ''
            && ($this->is_invalid_email_address( $main::comment{'email'} )
                || $this->is_taboo_string(
                    $main::comment{'email'}, $this->{'taboowords'},
                    $this->{'tabooregexp'}
                )
            )
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ($default::english)
                ? 'Error! Please input your e-mail address correctly.'
                : $this->{'emailFieldName'}
                    . ' が正しくありません。'
            )
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'email'} = 1;
        $input_is_valid = 0;
    }
    elsif ( $this->{'emailCheck'} && !$main::comment{'email'} ) {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ($default::english)
                ? 'Error! Please input your e-mail address.'
                : $this->{'emailFieldName'}
                    . ' が入力されていません。'
            )
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'email'} = 1;
        $input_is_valid = 0;
    }
    if ($main::url
        || (   defined $main::comment{'url'}
            && $main::comment{'url'} ne ''
            && ($this->is_invalid_url( $main::comment{'url'} )
                || $this->is_taboo_string(
                    $main::comment{'url'}, $this->{'taboowords'},
                    $this->{'tabooregexp'}
                )
            )
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ($default::english)
                ? 'Error! Please input your home page url correctly.'
                : $this->{'urlFieldName'} . ' が正しくありません。'
            )
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'url'} = 1;
        $input_is_valid = 0;
    }
    if (   $main::comment
        || !defined $main::comment{'comment'}
        || $main::comment{'comment'} eq '' )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ($default::english)
                ? 'Error! Please input your comment.'
                : $this->{'commentFieldName'}
                    . ' が入力されていません。'
            )
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'comment'} = 1;
        $input_is_valid = 0;
    }
    elsif ($this->{'type'}
        && $this->{'type'} eq 'j'
        && $this->is_not_japanese( $main::comment{'comment'} ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ($default::english)
                ? 'Error! Please input your comment.'
                : $this->{'commentFieldName'}
                    . ' が日本語ではない可能性があります。日本語の文章を増やしてください。'
            )
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'comment'} = 1;
        $input_is_valid = 0;
    }
    elsif (
        $this->is_taboo_string(
            $main::comment{'comment'}, $this->{'taboowords'},
            $this->{'tabooregexp'}
        )
        || $this->is_taboo_string(
            $main::comment{'title'}, $this->{'taboowords'},
            $this->{'tabooregexp'}
        )
        || $this->is_taboo_string(
            $main::comment{'name'}, $this->{'taboowords'},
            $this->{'tabooregexp'}
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ($default::english)
                ? 'Error! Please input your comment.'
                : $this->{'commentFieldName'}
                    . ' に禁止された語句が存在します。'
            )
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'comment'} = 1;
        $input_is_valid = 0;
    }
    elsif (
        $this->{'maxlength'}
        && $this->{'maxlength'} < (
            $this->str_length( $main::comment{'comment'} ) + (
                ( $main::comment{'title'} )
                ? $this->str_length( $main::comment{'title'} )
                : 0
                ) + (
                ( $main::comment{'name'} )
                ? $this->str_length( $main::comment{'name'} )
                : 0
                )
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ($default::english)
                ? 'Your comment is too long.'
                : $this->{'commentFieldName'} . ' が長過ぎます。'
            )
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'comment'} = 1;
        $input_is_valid = 0;
    }
    if ( ref $this->{'syncedgrader'} ) {
        foreach my $g ( @{ $this->{'syncedgrader'} } ) {
            if ( !$main::comment{ 'grader' . $g }
                && grep( $_ eq $g, @{ $this->{'requiredgrader'} } ) )
            {
                push(
                    @{ $cgi::action->{'dialog'} },
                    $this->{'field_obj'}{$g}->name
                        . 'が入力されていません。'
                ) if ref $cgi::action;
                $input_is_valid = 0;
            }
        }
    }

    #入力エラー
    if ( !$input_is_valid ) {
        $this->{'update_is_failed'} = 1 if !$default::static && !$is_ajax;
        return ($is_ajax)
            ? {
            'status'           => 'error',
            'error_fields'     => $this->get_invalid_field_list('comment'),
            'message'          => $this->get_message_string,
            'authorized_level' => $this->get_authorized_level
            }
            : 0;
    }

    #掲示板設定読み込み
    my $setting = $this->get_field_data;

    #掲示板閉鎖
    if (   !ref $setting
        || ( defined $setting->{'memory'}  && $setting->{'memory'} eq '0' )
        || ( !defined $setting->{'memory'} && $this->{'protected'} ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ($default::english)
                ? 'Error! This bbs was closed.'
                : $this->name(1) . ' は現在利用できません。'
            )
        ) if ref $cgi::action;
        return ($is_ajax)
            ? {
            'status'           => 'error',
            'message'          => $this->get_message_string,
            'authorized_level' => $this->get_authorized_level
            }
            : 0;
    }

    my $file_dir = $this->get_file_directory;
    my $dat_path = $file_dir . '/' . $this->{'id'} . '.dat';

    #アイコンサイズ取得
    my $icon_width  = '';
    my $icon_height = '';
    my $icon_ext    = '';
    my $icon_size   = '';
    if ( $main::comment{'icon'} ) {
        my $icon_path = $this->path_change( $main::comment{'icon'},
            $ENV{'SCRIPT_NAME'}, 'rel' );
        if ( $icon_path ne $env::spacer && -f $icon_path ) {
            $icon_size = -s $icon_path;
            ( $icon_width, $icon_height, $icon_ext )
                = $cgi::Image->info($icon_path);
        }
        delete $main::comment{'icon'} if !$icon_width || !$icon_height;
    }

    #記事数のカウント
    my $memory_count       = 0;
    my $last_comment_ip    = '';
    my $last_comment_ctime = 0;
    my $last_id            = 0;
    my $approval_required
        = ( $this->{'pendingEnabled'} && $setting->{'approvalRequired'} )
        ? 1
        : 0;
    local (*DAT);
    if ( open( DAT, $dat_path ) ) {
        binmode DAT, ":utf8";
        flock( DAT, LOCK_SH );
        my $last_comment = '';
        while ( my $line = <DAT> ) {
            chomp $line;
            if ($line) {
                $memory_count++;
                $last_comment = $line;
            }
        }
        close(DAT);
        if ($last_comment) {
            my @comment = $this->svsplit( "\x09", $last_comment );
            $last_comment_ip    = $comment[12] if $comment[12];
            $last_comment_ctime = $comment[1]  if $comment[1];
            $last_id            = $comment[0]  if $comment[0];
        }
    }

    #投稿処理
    $last_comment_ip =~ s/[0-9]+/[0-9]+/g
        if $last_comment_ip
        && $last_comment_ip =~ /[0-9]/
        && $last_comment_ip =~ /[^\.0-9]/
        && $this->{'rule'}
        && $this->{'rule'} == 2;
    if (   $this->{'rule'} == 0
        || $last_comment_ip eq ''
        || $this->client_ip_is_matched($last_comment_ip) == 0
        || ( $this->{'cancelLimit'} > 0
            && time - $last_comment_ctime > $this->{'cancelLimit'} )
        )
    {
        my $memory = (
            $this->{'masterMemory'}
                && ( !defined $setting->{'memory'}
                || $setting->{'memory'} eq ''
                || $setting->{'memory'} > $this->{'masterMemory'} )
        ) ? $this->{'masterMemory'} : $setting->{'memory'};
        $memory_count++;

        #掲示板閉鎖
        if ( defined $memory && $memory ne '' && $memory_count > $memory ) {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ($default::english)
                    ? 'This bbs was closed.'
                    : '記事数が最大保存数に達したので、これ以上書き込むことが出来ません。'
                )
            ) if ref $cgi::action;
            return ($is_ajax)
                ? {
                'status'           => 'error',
                'hide_form'        => '1',
                'message'          => $this->get_message_string,
                'authorized_level' => $this->get_authorized_level
                }
                : 0;
        }

        #名前の登録
        $cgi::Register->user_name_register( $main::pswd, $main::email,
            $main::comment{'name'}, $security::registered )
            if $this->{'nameRegister'} && $this->use_register;

        #クッキー設定
        if ($main::set_cookie) {
            $cookie::name = 'COMMENT';
            %cookie::data = (
                'comment:email' => (
                    ( defined $main::comment{'email'} )
                    ? $main::comment{'email'}
                    : ''
                ),
                'comment:name' => (
                    ( defined $main::comment{'name'} )
                    ? $main::comment{'name'}
                    : ''
                ),
                'comment:url' => (
                    ( defined $main::comment{'url'} ) ? $main::comment{'url'}
                    : ''
                ),
                'comment:icon' => (
                    ( defined $main::comment{'icon'} )
                    ? $main::comment{'icon'}
                    : ''
                ),
            );
        }

        my $grade_data = '';
        if ( ref $this->{'syncedgrader'} ) {
            foreach my $g ( @{ $this->{'syncedgrader'} } ) {
                if ( $main::comment{ 'grader' . $g } ) {
                    local $main::point  = $main::comment{ 'grader' . $g };
                    local $main::access = 1;
                    $grade_data
                        .= ( ($grade_data) ? ',' : '' )
                        . $g . '='
                        . $main::comment{ 'grader' . $g };
                    $this->{'field_obj'}{$g}->update( 0, 1 )
                        if !$approval_required;
                }
            }
        }

        my $viewer_url  = $this->get_viewer_url( $main::c, $main::n );
        my $editor_url  = $this->get_user_generated_field_editor_url(1);
        my @new_comment = ();
        my $content     = '';
        local (*DAT);
        if ( open( DAT, ">>$dat_path" ) ) {
            binmode DAT, ":utf8";
            flock( DAT, LOCK_EX );
            @new_comment = (
                ( $last_id + 1 ),
                time,
                ( ($approval_required) ? 0 : 1 ),
                $main::comment{'comment'},
                (   ( defined $main::comment{'name'} )
                    ? $main::comment{'name'}
                    : ''
                ),
                (   ( defined $main::comment{'title'} )
                    ? $main::comment{'title'}
                    : ''
                ),
                (   ( defined $main::comment{'email'} )
                    ? $main::comment{'email'}
                    : ''
                ),
                ( ( $main::comment{'hidden'} ) ? 1 : 0 ),
                (   ( defined $main::comment{'url'} ) ? $main::comment{'url'}
                    : ''
                ),
                (   ( defined $main::comment{'icon'} )
                    ? $main::comment{'icon'}
                    : ''
                ),
                $icon_width,
                $icon_height,
                (          $ENV{'REMOTE_HOST'}
                        || $this->to_host( $ENV{'REMOTE_ADDR'} )
                ),
                $ENV{'HTTP_USER_AGENT'},
                $grade_data
            );
            print DAT $this->svjoin( "\x09", @new_comment ), "\x0A";
            close(DAT);
            chmod(
                ( ($env::ownerpower) ? 0600 : $env::file_mode ),
                $dat_path
            );
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                '新しいコメントの保存に失敗しました。'
            ) if ref $cgi::action;
            $this->{'update_is_failed'} = 1 if !$default::static && !$is_ajax;
            return ($is_ajax)
                ? {
                'status'           => 'error',
                'message'          => $this->get_message_string,
                'authorized_level' => $this->get_authorized_level
                }
                : 0;
        }

        #通知メール
        if (   $this->{'mailtoMaster'}
            || $this->{'mailtoOwners'}
            || $this->{'mailtoStaff'}
            || $this->{'mailtoAllEMailAddresses'}
            || (   $this->{'mailToUser'}
                && $setting->{'mailto'}
                && $setting->{'mailto'} ne '' )
            )
        {
            my @bcc = ();
            if ( $this->{'mailtoAllEMailAddresses'} ) {
                push( @bcc, $this->get_all_mail_field_data_list );
            }
            elsif ($this->{'mailToUser'}
                && $setting->{'mailto'}
                && $setting->{'mailto'} ne '' )
            {
                push( @bcc,
                    $this->get_mail_field_data( $setting->{'mailto'} ) );
            }
            push( @bcc, $setting::general{'master'} )
                if defined $this->{'mailtoMaster'}
                && $this->{'mailtoMaster'}
                && $setting::general{'master'};
            push( @bcc, $setting::general{'owners'} )
                if defined $this->{'mailtoOwners'}
                && $this->{'mailtoOwners'}
                && $setting::general{'owners'};
            push( @bcc, $setting::general{'staff'} )
                if defined $this->{'mailtoStaff'}
                && $this->{'mailtoStaff'}
                && $setting::general{'staff'};
            if (@bcc) {
                unless ( ref $cgi::SendMail ) {
                    require CMONOS::CGI_Lib::SendMail;
                    $cgi::SendMail = SendMail->new(
                        ( ( defined $env::sendmail ) ? $env::sendmail : '' ),
                        (   ( defined $env::master_email )
                            ? $env::master_email
                            : ''
                        ),
                        '',
                        ( ( ref $cgi::input ) ? $cgi::input : '' ),
                        1
                    );
                }
                my $msg = $this->name
                    . 'に新しい投稿があります。' . "\x0A";
                $msg .= '新しい投稿があるページ : '
                    . $viewer_url . "\x0A";
                $msg
                    .= 'コメント編集ツール : '
                    . $editor_url . "\x0A"
                    if $approval_required;
                $msg .= "\x0A";
                $msg
                    .= $this->detag( $this->{'titleFieldName'} ) . ' : '
                    . $main::comment{'title'} . "\x0A"
                    if defined $main::comment{'title'}
                    && $main::comment{'title'} ne '';
                $msg
                    .= $this->detag( $this->{'nameFieldName'} ) . ' : '
                    . $main::comment{'name'} . "\x0A"
                    if defined $main::comment{'name'}
                    && $main::comment{'name'} ne '';
                $msg
                    .= $this->detag( $this->{'emailFieldName'} ) . ' : '
                    . $main::comment{'email'} . "\x0A"
                    if !$main::comment{'hidden'}
                    && defined $main::comment{'email'}
                    && $main::comment{'email'} ne '';
                $msg
                    .= $this->detag( $this->{'urlFieldName'} ) . ' : '
                    . $main::comment{'url'} . "\x0A"
                    if defined $main::comment{'url'}
                    && $main::comment{'url'} ne '';
                $msg
                    .= $this->detag( $this->{'commentFieldName'} ) . ' : '
                    . "\x0A"
                    . $main::comment{'comment'}
                    . "\x0A\x0A"
                    if defined $main::comment{'comment'}
                    && $main::comment{'comment'} ne '';
                $cgi::SendMail->send_mail(
                    'Bcc'     => join( ',', $this->get_address(@bcc) ),
                    'From'    => $env::master_email,
                    'Subject' => $this->{'name'}
                        . 'に新しい投稿があります！',
                    'message' => $msg,
                    'info'    => 1
                );
                push( @{ $this->{'dialog'} }, $cgi::SendMail->dialog );
            }
        }
        if ($approval_required) {
            $this->save_pending_db( $editor_url,
                $this->get_title_field_data );
            push(
                @{ $cgi::action->{'dialog'} },
                (   ($default::english)
                    ? 'Thank you for your comment.'
                    : $this->name(1)
                        . ' ありがとうございます。この '
                        . $this->name(1)
                        . ' は内容が確認された後、表示されます。'
                )
            ) if ref $cgi::action;
            $memory_count = '';
        }
        else {
            $content = $this->set_embed_files( $memory, $setting, $file_dir,
                $main::c, $main::n, 1 );
            my $comment = $main::comment{'comment'};
            my $title   = $main::comment{'title'};
            $this->text_conv( \$title ) if $title;
            $this->text_conv( \$comment );
            $this->text_fix( \$comment );
            $this->feed_field_rss(
                'comment',
                {   'title' => ( ( defined $title ) ? $title : '' ),
                    'link' => $viewer_url,
                    'content:encoded' => $comment,
                    (     ( defined $main::comment{'name'} )
                        ? ( 'dc:creator' => $main::comment{'name'} )
                        : ()
                    ),
                    'category' => (
                        (          $default::subdivided
                                && defined $main::c
                                && $main::c ne ''
                                && $setting::general{'cginame'}
                        ) ? $setting::general{'cginame'} : ''
                    ),
                    'enclosure' => (
                        ( $main::comment{'icon'} )
                        ? { 'url' =>
                                $this->full_path( $main::comment{'icon'} ),
                            'length' => $icon_size,
                            'type'   => (
                                ( $Common::mime_type{$icon_ext} )
                                ? $Common::mime_type{$icon_ext}
                                : 'application/octet-stream'
                            )
                            }
                        : ''
                    ),
                }
            ) if $this->{'rssEnabled'};
            $this->navi_update( \@new_comment, $viewer_url )
                if $this->{'naviEnabled'};
            $this->post_update;
            $main::comment{'comment'} = $main::comment{'title'} = '';

            if ( ref $this->{'syncedgrader'} ) {
                foreach my $g ( @{ $this->{'syncedgrader'} } ) {
                    delete $main::comment{ 'grader' . $g };
                }
            }
            push(
                @{ $cgi::action->{'dialog'} },
                (   ($default::english)
                    ? 'Thank you for your comment.'
                    : $this->name(1) . ' ありがとうございます。'
                )
            ) if ref $cgi::action;
        }
        return ($is_ajax)
            ? {
            'status'  => 'success',
            'content' => ( ($approval_required) ? '' : $content ),

#'new_content'		=>	(($approval_required) ? '' : $this->replace_comment($this->get_comment_template(1),$setting->{'approvalRequired'},\@new_comment)),
            'new_count' => $memory_count,
            'hide_form' => (
                ( $memory && $memory_count && $memory_count >= $memory )
                ? '1'
                : ''
            ),
            'message'          => $this->get_message_string,
            'authorized_level' => $this->get_authorized_level
            }
            : 1;

    }
    else {
        push(
            @{ $cgi::action->{'dialog'} },
            '連続投稿はご遠慮ください。'
        ) if ref $cgi::action;
        $this->{'update_is_failed'} = 1 if !$default::static && !$is_ajax;
        return ($is_ajax)
            ? {
            'status'           => 'error',
            'message'          => $this->get_message_string,
            'authorized_level' => $this->get_authorized_level
            }
            : 0;
    }
}

sub get_navi_info ($) {
    my $this = shift;
    return ( 'recentcomments', 'recentcomments.ssi',
        'recentCommentsTemplate' );
}

sub mk_recent_items_article ($$$;$) {
    my ( $this, $comment_array, $template, $url ) = @_;
    if ($url) {
        $url = $this->escape($url);
        my @comment_data = @$comment_array;
        my $title        = $this->get_title_field_data;
        $title
            = $this->escape( $setting::general{'cginame'}
                . ( ( $setting::general{'cginame'} && $title ) ? ' > ' : '' )
                . $title );
        $title = ' title="' . $title . '"' if $title;
        if ( $template
            =~ /<!--title(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/title-->/s )
        {
            if ( defined $comment_data[5] && $comment_data[5] ne '' ) {
                $comment_data[5]
                    = '<a href="'
                    . $url . '"'
                    . $title . '>'
                    . $this->detag_text( $comment_data[5] ) . '</a>';
            }
            elsif ( $template
                =~ /<!--comment(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/comment-->/ )
            {
                $comment_data[3]
                    = '<a href="'
                    . $url . '"'
                    . $title . '>'
                    . $this->detag_text( $comment_data[3] ) . '</a>';
            }
            else {
                $comment_data[5]
                    = '<a href="'
                    . $url . '"'
                    . $title . '>'
                    . $this->detag_text( $comment_data[3] ) . '</a>';
            }
        }
        else {
            $comment_data[3]
                = '<a href="'
                . $url . '"'
                . $title . '>'
                . $this->detag_text( $comment_data[3] ) . '</a>';
        }
        return $this->replace_comment( $template, 0, \@comment_data, 1 );
    }
    else {
        return $this->replace_comment( $template, 0, $comment_array, 1 );
    }
}

sub get_array_from_template ($$) {
    my ( $this, $template ) = @_;
    my $comment = $this->get_hash_from_template($template);
    if (   $comment->{'icon'}
        && $comment->{'icon'} =~ /<img(?![0-9a-zA-Z_])([^>]+)>/ )
    {
        my $icon_info = $1;
        $comment->{'icon'}
            = ( $icon_info =~ /[\x09\x0A\x0C\x0D\x20]+src="(.*?)"/ )
            ? $1
            : '';
        $comment->{'icon_width'}
            = ( $icon_info =~ /[\x09\x0A\x0C\x0D\x20]+width="(.*?)"/ )
            ? $1
            : '';
        $comment->{'icon_height'}
            = ( $icon_info =~ /[\x09\x0A\x0C\x0D\x20]+height="(.*?)"/ )
            ? $1
            : '';
    }
    return [
        '',
        (   ( defined $comment->{'ctime'} && !ref $comment->{'ctime'} )
            ? $comment->{'ctime'}
            : ''
        ),
        1,
        (   ( defined $comment->{'comment'} && !ref $comment->{'comment'} )
            ? $comment->{'comment'}
            : ''
        ),
        (   ( defined $comment->{'name'} && !ref $comment->{'name'} )
            ? $comment->{'name'}
            : ''
        ),
        (   ( defined $comment->{'title'} && !ref $comment->{'title'} )
            ? $comment->{'title'}
            : ''
        ),
        (   ( defined $comment->{'email'} && !ref $comment->{'email'} )
            ? $comment->{'email'}
            : ''
        ),
        '',
        (   ( defined $comment->{'url'} && !ref $comment->{'url'} )
            ? $comment->{'url'}
            : ''
        ),
        (   ( defined $comment->{'icon'} && !ref $comment->{'icon'} )
            ? $comment->{'icon'}
            : ''
        ),
        (   (   defined $comment->{'icon_width'}
                    && !ref $comment->{'icon_width'}
            ) ? $comment->{'icon_width'} : ''
        ),
        (   (   defined $comment->{'icon_height'}
                    && !ref $comment->{'icon_height'}
            ) ? $comment->{'icon_height'} : ''
        ),
        (   ( defined $comment->{'ip'} && !ref $comment->{'ip'} )
            ? $comment->{'ip'}
            : ''
        ),
        (   ( defined $comment->{'agent'} && !ref $comment->{'agent'} )
            ? $comment->{'agent'}
            : ''
        )
    ];
}

######################################################################
sub set_user_generated_field_editor_page_settings ($) {
    my $this = shift;
    $setting::page{'ugfieldeditor'}{'title'}
        = $this->detag( $this->get_title_field_data );

    #	$setting::page{'ugfieldeditor'}{'text'} = '#000000';
    #	$setting::page{'ugfieldeditor'}{'link'} = '#0000ff';
    #	$setting::page{'ugfieldeditor'}{'alink'} = '#99ffff';
    #	$setting::page{'ugfieldeditor'}{'vlink'} = '#000099';
    #	$setting::page{'ugfieldeditor'}{'hover'} = '#00ffff';
    #	$setting::page{'ugfieldeditor'}{'nodeco'} = 'no';
    #	$setting::page{'ugfieldeditor'}{'bgcolor'} = '#ffffff';
    $setting::page{'ugfieldeditor'}{'bodyId'}      = 'comment-editor';
    $setting::page{'ugfieldeditor'}{'cssFileName'} = 'comment-editor.css';

# 	$setting::page{'ugfieldeditor'}{'CSS'} = 'h1 { font-size: large; font-weight: bold; text-indent: 1em; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'ugfieldeditor'}{'CSS'} .= 'h2 { font-size: medium; font-weight: bold; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'ugfieldeditor'}{'CSS'} .= 'hr { border-width: 1 0 0 0; }';
# 	$setting::page{'ugfieldeditor'}{'background'} = '';
# 	$setting::page{'ugfieldeditor'}{'bgproperties'} = '';
# 	$setting::page{'ugfieldeditor'}{'topmargin'} = '';
# 	$setting::page{'ugfieldeditor'}{'leftmargin'} = '';
# 	$setting::page{'ugfieldeditor'}{'javascript'} = '';
# 	$setting::page{'ugfieldeditor'}{'header'} = '';
# 	$setting::page{'ugfieldeditor'}{'headerFileName'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleImageAlign'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleImage'} = '';
# 	$setting::page{'ugfieldeditor'}{'align'} = '';
# 	$setting::page{'ugfieldeditor'}{'width'} = '';
# 	$setting::page{'ugfieldeditor'}{'deco'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleText'} = '';
    return 1;
}

sub user_generated_field_edit ($) {
    my $this = shift;
    return 0 if !$this->is_editable;
    local ( *DAT, *TEMP );
    my $done            = 0;
    my $last_deleted_id = '';
    my $last_id         = '';
    my @last_approved_comment;
    my $delete_list = '';
    my $temp_path
        = $this->{'file_directory'} . '/' . $this->{'id'} . '.temp.dat';
    my @deleted_grader  = ();
    my @appended_grader = ();

    if ( open( TEMP, ">>$temp_path" ) ) {
        binmode TEMP, ":utf8";
        flock( TEMP, LOCK_EX );
        truncate( TEMP, 0 );
        seek( TEMP, 0, 0 );
        if ( open( DAT, $this->{'dat_path'} ) ) {
            binmode DAT, ":utf8";
            flock( DAT, LOCK_SH );
            my $line;
            while ( $line = <DAT> ) {
                chomp $line;
                my @data = $this->svsplit( "\x09", $line );
                $last_id = $data[0]
                    if !$this->{'pendingEnabled'}
                    || !$this->{'field_data'}->{'approvalRequired'}
                    || $data[2];
                if ($main::data{ $data[0] }
                    && (!$this->{'delete_only'}
                        || (   $main::data{ $data[0] } eq 'delete'
                            && $data[6]
                            && $main::email
                            && $data[6] eq $main::email )
                    )
                    )
                {
                    if ( $main::data{ $data[0] } eq 'delete' ) {
                        $last_deleted_id = $data[0];
                        push( @deleted_grader, $data[14] )
                            if $data[2] && $data[14];
                        next;
                    }
                    elsif ($this->{'pendingEnabled'}
                        && $this->{'field_data'}->{'approvalRequired'} )
                    {
                        if ( $main::data{ $data[0] } eq 'approve' ) {
                            if ( !$data[2] ) {
                                @last_approved_comment = @data;
                                push( @appended_grader, $data[14] )
                                    if $data[14];
                            }
                            $data[2] = 1;
                        }
                        else {
                            if ( $data[2] ) {
                                push( @deleted_grader, $data[14] )
                                    if $data[14];
                                $last_deleted_id = $data[0];
                            }
                            $data[2] = 0;
                        }
                    }
                    else {
                        $data[2] = 1;
                    }
                    print TEMP $this->svjoin( "\x09", @data ), "\x0A";
                }
                else {
                    print TEMP $line, "\x0A";
                }
            }
            close(DAT);
            $done = 1;
        }
        close(TEMP);
    }
    if ($done) {
        rename( $temp_path, $this->{'dat_path'} );
        chmod(
            ( ($env::ownerpower) ? 0600 : $env::file_mode ),
            $this->{'dat_path'}
        );
    }
    if ( ref $this->{'syncedgrader'}
        && ( @deleted_grader || @appended_grader ) )
    {
        my ( %grade, %count );
        foreach my $grades (@appended_grader) {
            foreach my $g ( split( /,/, $grades ) ) {
                if ( $g =~ /^([0-9]+)=([0-9]+)$/ && $2 ) {
                    $grade{$1} += $2;
                    $count{$1}++;
                }
            }
        }
        foreach my $grades (@deleted_grader) {
            foreach my $g ( split( /,/, $grades ) ) {
                if ( $g =~ /^([0-9]+)=([0-9]+)$/ && $2 ) {
                    $grade{$1} -= $2;
                    $count{$1}--;
                }
            }
        }
        foreach my $g ( @{ $this->{'syncedgrader'} } ) {
            if ( $grade{$g} ) {
                local $main::point  = $grade{$g};
                local $main::access = $count{$g};
                $this->{'field_obj'}{$g}->update( 0, 1 )
                    if $grade{$g} || $count{$g};
            }
        }
    }
    if ( @last_approved_comment || $last_deleted_id ) {
        my $viewer_url = $this->get_viewer_url( $main::c, $main::n );
        $this->set_embed_files(
            $this->{'field_data'}->{'memory'},
            $this->{'field_data'}, $this->{'file_directory'},
            $main::c, $main::n
        );
        if (@last_approved_comment) {
            my $icon_ext  = '';
            my $icon_size = '';
            if ( $last_approved_comment[9] ) {
                my $icon_path = $this->path_change( $last_approved_comment[9],
                    $ENV{'SCRIPT_NAME'}, 'rel' );
                $icon_size = -s $icon_path
                    if $icon_path ne $env::spacer && -f $icon_path;
                $icon_ext = $1
                    if $last_approved_comment[9] =~ /\.([0-9a-zA-Z_]+)$/;
            }
            my $comment = $last_approved_comment[3];
            my $title   = $last_approved_comment[5];
            $this->text_conv( \$title ) if $title;
            $this->text_conv( \$comment );
            $this->text_fix( \$comment );
            $this->feed_field_rss(
                'comment',
                {   'title' => ( ( $title ne '' ) ? $title : '' ),
                    'link' => $viewer_url,
                    'content:encoded' => $comment,
                    'category'        => (
                        (          $default::subdivided
                                && defined $main::c
                                && $main::c ne ''
                                && $setting::general{'cginame'}
                        ) ? $setting::general{'cginame'} : ''
                    ),
                    'enclosure' => (
                        ( $last_approved_comment[9] )
                        ? { 'url' =>
                                $this->full_path( $last_approved_comment[9] ),
                            'length' => $icon_size,
                            'type'   => (
                                ( $Common::mime_type{$icon_ext} )
                                ? $Common::mime_type{$icon_ext}
                                : 'application/octet-stream'
                            )
                            }
                        : ''
                    )
                }
            ) if $this->{'rssEnabled'};
            $this->navi_update( \@last_approved_comment, $viewer_url )
                if $this->{'naviEnabled'};
            $this->post_update;
        }
        elsif ( $last_id eq $last_deleted_id ) {
            $this->navi_update( '', '', 1 ) if $this->{'naviEnabled'};
            $this->delete_field_rss_item( 'comment', $viewer_url );
            $this->post_update(1);
        }
        else {
            $this->post_update(1);
        }
    }
    return 1;
}

sub print_user_generated_field_editor ($) {
    my $this = shift;
    $this->mk_settings_for_editor;
    $this->print_error_dialog(
        $this->name(1) . ' は現在利用できません。' )
        if !ref $this->{'field_data'};
    my $javascript = <<'SCRIPT';
function classChange (target_id,class_name,flag) {
	if (flag) document.getElementById(target_id).className = class_name;
}
SCRIPT
    $cgi::action->set_javascript($javascript);
    undef $javascript;
    $cgi::action->print_page_header( 'ugfieldeditor', '', '', 0, '',
        $this->name . '編集' );
    print $this->form_start(
        'key'      => 'ugfieldeditor',
        'name'     => 'input',
        'method'   => 'post',
        'onsubmit' => 'return cmonos.form.item(this).isNotSubmitted()'
    );
    print $this->get_query_for_user_generated_field_editor(1);
    print '<input type="hidden" name="action" value="edit" />';
    local (*DAT);
    my $count = 0;

    if ( open( DAT, $this->{'dat_path'} ) ) {
        binmode DAT, ":utf8";
        flock( DAT, LOCK_SH );
        while ( my $line = <DAT> ) {
            chomp $line;
            my ($id,   $ctime, $approved,   $comment,
                $name, $title, $email,      $hidden,
                $url,  $icon,  $icon_width, $icon_height,
                $ip,   $agent, $grades
            ) = $this->svsplit( "\x09", $line );
            my %grade = ();
            if ($grades) {
                foreach my $i ( split( /,/, $grades ) ) {
                    $grade{$1} = $2 if $i =~ /([0-9]+)=([0-9]*)/;
                }
            }
            if ( !$this->{'delete_only'}
                || ( $email && $main::email && $email eq $main::email ) )
            {
                print '<div class="'
                    . (
                    (          $this->{'pendingEnabled'}
                            && $this->{'field_data'}->{'approvalRequired'}
                            && !$approved
                    ) ? 'pending-comment' : 'approved-comment'
                    )
                    . '" id="comment-'
                    . $id . '">';
                print '<div class="controller">';
                print '<label><input type="radio" name="data:'
                    . $id
                    . '" value="'
                    . ( ($approved) ? '' : 'approve' ) . '"'
                    . (
                    (          !$this->{'pendingEnabled'}
                            || !$this->{'field_data'}->{'approvalRequired'}
                            || $approved
                    ) ? ' checked="checked"' : ''
                    )
                    . ' onclick="cmonos.element.item(\'comment-'
                    . $id
                    . '\').changeClassName(\'approved-comment\',this.checked);" />承認</label>'
                    if !$this->{'delete_only'}
                    || !$this->{'pendingEnabled'}
                    || !$this->{'field_data'}->{'approvalRequired'}
                    || $approved;
                print ' <label><input type="radio" name="data:'
                    . $id
                    . '" value="'
                    . ( ( !$approved ) ? '' : 'pending' ) . '"'
                    . ( ( !$approved ) ? ' checked="checked"' : '' )
                    . ' onclick="cmonos.element.item(\'comment-'
                    . $id
                    . '\').changeClassName(\'pending-comment\',this.checked);" />保留</label>'
                    if $this->{'pendingEnabled'}
                    && $this->{'field_data'}->{'approvalRequired'}
                    && ( !$this->{'delete_only'} || !$approved );
                print ' <label><input type="radio" name="data:'
                    . $id
                    . '" value="delete" onclick="cmonos.element.item(\'comment-'
                    . $id
                    . '\').changeClassName(\'delete-comment\',this.checked);" />削除</label>';
                print '</div>';
                $icon = ( !$icon ) ? '' : $cgi::Image->image_tag(
                    $icon,                        $icon_width,
                    $icon_height,                 $this->{'border'},
                    $this->get_image_name($icon), '',
                    $this->{'maxwidth'},          $this->{'maxheight'}
                );
                $this->text_conv( \$title ) if $title;
                $this->text_conv( \$comment );
                $this->text_fix( \$comment, $this->{'csv'} );
                print '<div class="comment">';
                print '<div class="comment-icon">' . $icon . '</div>'
                    if $icon ne '';
                print '<h1>' . $title . '(' . $id . ')</h1>';
                print '<div class="comment-author">'
                    . $name
                    . ( ($email)
                    ? ' &lt;'
                        . $email . '&gt;'
                        . ( ($hidden) ? '[非表示]' : '' )
                    : '' )
                    . ( ($url) ? ' (' . $url . ')' : '' )
                    . '</div>';
                print '<div class="comment-agent">'
                    . $this->get_user_agent_info($agent) . '/'
                    . $ip
                    . '</div>'
                    if $agent && $ip;
                print $comment;
                print $this->grade_tag_replace( '', '', \%grade );
                print '<div class="comment-ctime">'
                    . $this->date( $ctime, $this->{'datelimit'},
                    'gmt' . $this->{'datetype'} )
                    . '</div>';
                print '</div>';
                print '</div>';
                $count++;
            }
        }
        close(DAT);
    }
    print( ($count)
        ? '<input type="submit" value="更新する" class="submit" />'
        : '<p>コメントが存在しません。</p>' );
    print '</form>';
    $cgi::action->print_page_footer('ugfieldeditor');
    $this->rm_settings_for_editor;
    return 1;
}

######################################################################
#sub import {
BEGIN {
    if ( !$setting::field_for_mail
        && ( !defined $default::type || $default::type eq '' ) )
    {
        $setting::deco_dir{'comment'}  = 'コメントする ボタン';
        $setting::deco_type{'comment'} = 'button';
        $setting::deco_dir{'jump'}     = 'ジャンプボタン';
        $setting::deco_type{'jump'}    = 'button';
        $setting::deco_dir{'email'}    = 'Eメールボタン';
        $setting::deco_type{'email'}   = 'button';
    }
}

1;
