package HTMLHelper;
require CMONOS::CGI_Lib::Common;
@ISA = qw(Common);
use strict;
use utf8;
######################################################################
# HTML入力補助モジュール
# HTMLHelper.pm 1.0.2
# Copyright (C) 2007-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-12-30
######################################################################
sub new ($;@) {
    my $pkg  = shift;
    my $this = {};
    bless $this;
    $this;
}

######################################################################
# HTML入力補助メニュー
sub html_helper_menu ($$;$$$$) {
    my ( $this, $name, $optional_menu, $tag_disabled, $csv_enabled, $id )
        = @_;
    my $form
        = '<select id="'
        . ( ($id) ? $id : $name )
        . '-helper" class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '\').quotationByMenu(this)"'
        . ( ($csv_enabled)
        ? ' title="カンマ区切り文字列(CSV)を、&lt;!--csv--&gt;&lt;!--/csv--&gt; で囲むと、自動的に表に変換されます。"'
        : '' )
        . '>';
    $form .= '<option value="">▼挿入・置換</option>';

    if ( defined $optional_menu && $optional_menu ne '' ) {
        $form .= $optional_menu;
        $form .= '<option value=""></option>';
    }

    $form .= '<option value="&amp;hearts;">&hearts;[記号]</option>';
    $form .= '<option value="&amp;laquo;">&laquo;[記号]</option>';
    $form .= '<option value="&amp;raquo;">&raquo;[記号]</option>';
    $form .= '<option value="&amp;yen;">&yen;[記号]</option>';

    if ($csv_enabled) {
        $form .= '<option value=""></option>';
        $form
            .= '<option value="&lt;!--csv--&gt;&lt;!--/csv--&gt;">CSVタグ</option>';
        $form
            .= '<option value="&lt;!--tate--&gt;&lt;!--/tate--&gt;">縦書きタグ</option>';
    }

    $form .= '<option value=""></option>';
    $form
        .= '<option value="[[&lt;=&amp;lt;,&gt;=&amp;gt;]]">エスケープ(&lt;&gt;)[変換]</option>';
    $form
        .= '<option value="[[&amp;=&amp;amp;,&lt;=&amp;lt;,&quot;=&amp;quot;,&gt;=&amp;gt;]]">エスケープ(&lt;&gt;&quot;&amp;)[変換]</option>';
    $form
        .= '<option value="[[&amp;lt;=&lt;,&amp;gt;=&gt;]]">エスケープ解除(&lt;&gt;)[変換]</option>';
    $form
        .= '<option value="[[&amp;lt;=&lt;,&amp;gt;=&gt;,&amp;quot;=&quot;,&amp;amp;=&amp;]]">エスケープ解除(&lt;&gt;&quot;&amp;)[変換]</option>';
    $form .= '<option value="[[REPLACE]]">[置換]</option>';

    if ( !$tag_disabled ) {
        $form .= '<option value=""></option>';
        $form
            .= '<option value="&lt;a href=&quot;&quot; target=&quot;_blank&quot;&gt;&lt;/a&gt;">&lt;a&gt;[リンク]</option>';
        $form
            .= '<option value="&lt;strong&gt;&lt;/strong&gt;">&lt;strong&gt;[強調]</option>';
        $form
            .= '<option value="&lt;em&gt;&lt;/em&gt;">&lt;em&gt;[強調]</option>';
        $form
            .= '<option value="&lt;del&gt;&lt;/del&gt;">&lt;del&gt;[削除]</option>';
        $form
            .= '<option value="&lt;ins&gt;&lt;/ins&gt;">&lt;ins&gt;[挿入]</option>';
        $form
            .= '<option value="&lt;blockquote&gt;&lt;/blockquote&gt;">&lt;blockquote&gt;[引用]</option>';
        $form
            .= '<option value="&lt;q cite=&quot;&quot;&gt;&lt;/q&gt;">&lt;q&gt;[引用]</option>';
        $form
            .= '<option value="&lt;cite&gt;&lt;/cite&gt;">&lt;cite&gt;[出典]</option>';
        $form
            .= '<option value="'
            . $this->jsquot('&lt;ul&gt;\n&lt;li&gt;&lt;/li&gt;\n&lt;/ul&gt;')
            . '">&lt;ul&gt;[リスト]</option>';
        $form
            .= '<option value="'
            . $this->jsquot('&lt;ol&gt;\n&lt;li&gt;&lt;/li&gt;\n&lt;/ol&gt;')
            . '">&lt;ol&gt;[番号リスト]</option>';
        $form
            .= '<option value="&lt;li&gt;&lt;/li&gt;">&lt;li&gt;[リスト]</option>';
        $form
            .= '<option value="'
            . $this->jsquot(
            '&lt;dl&gt;\n&lt;dt&gt;&lt;/dt&gt;\n&lt;dd&gt;&lt;/dd&gt;\n&lt;/dl&gt;'
            ) . '">&lt;dl&gt;[定義リスト]</option>';
        $form
            .= '<option value="&lt;pre&gt;&lt;/pre&gt;">&lt;pre&gt;[整形済]</option>';
        $form
            .= '<option value="&lt;code&gt;&lt;/code&gt;">&lt;code&gt;[コード]</option>';
        $form
            .= '<option value="&lt;code class=&quot;html-source-code&quot;&gt;&lt;/code&gt;">&lt;code&gt;[HTMLソース]</option>';
        $form
            .= '<option value="&lt;abbr title=&quot;&quot;&gt;&lt;/abbr&gt;">&lt;abbr&gt;[略語]</option>';
        $form
            .= '<option value="&lt;acronym title=&quot;&quot;&gt;&lt;/acronym&gt;">&lt;acronym&gt;[頭文字略語]</option>';
        $form
            .= '<option value="&lt;dfn&gt;&lt;/dfn&gt;">&lt;dfn&gt;[定義用語]</option>';
        $form
            .= '<option value="&lt;ruby&gt;&lt;rb&gt;&lt;/rb&gt;&lt;rp&gt;(&lt;/rp&gt;&lt;rt&gt;&lt;/rt&gt;&lt;rp&gt;)&lt;/rp&gt;&lt;/ruby&gt;">&lt;ruby&gt;[ルビ]</option>';
        $form
            .= '<option value="&lt;h1&gt;&lt;/h1&gt;">&lt;h1&gt;[見出し1]</option>';
        $form
            .= '<option value="&lt;h2&gt;&lt;/h2&gt;">&lt;h2&gt;[見出し2]</option>';
        $form
            .= '<option value="&lt;h3&gt;&lt;/h3&gt;">&lt;h3&gt;[見出し3]</option>';
        $form
            .= '<option value="&lt;h4&gt;&lt;/h4&gt;">&lt;h4&gt;[見出し4]</option>';
        $form
            .= '<option value="&lt;h5&gt;&lt;/h5&gt;">&lt;h5&gt;[見出し5]</option>';
        $form
            .= '<option value="&lt;h6&gt;&lt;/h6&gt;">&lt;h6&gt;[見出し6]</option>';
    }

    $form .= '<option value=""></option>';
    $form .= '<option value="&amp;reg;">&reg;[記号]</option>';
    $form .= '<option value="&amp;copy;">&copy;[記号]</option>';
    $form .= '<option value="&amp;plusmn;">&plusmn;[記号]</option>';
    $form .= '<option value="&amp;sect;">&sect;[記号]</option>';
    $form .= '<option value="&amp;cent;">&cent;[記号]</option>';
    $form .= '<option value="&amp;pound;">&pound;[記号]</option>';
    $form .= '<option value="&amp;micro;">&micro;[記号]</option>';
    $form .= '<option value="&amp;lt;">&lt;[記号]</option>';
    $form .= '<option value="&amp;gt;">&gt;[記号]</option>';
    $form .= '<option value="&amp;times;">&times;[記号]</option>';
    $form .= '<option value="&amp;divide;">&divide;[記号]</option>';
    $form .= '<option value="&amp;sup1;">&sup1;[記号]</option>';
    $form .= '<option value="&amp;sup2;">&sup2;[記号]</option>';
    $form .= '<option value="&amp;sup3;">&sup3;[記号]</option>';
    $form .= '<option value="&amp;para;">&para;[記号]</option>';
    $form .= '<option value="&amp;deg;">&deg;[記号]</option>';
    $form .= '<option value="&amp;spades;">&spades;[記号]</option>';
    $form .= '<option value="&amp;clubs;">&clubs;[記号]</option>';
    $form .= '<option value="&amp;diams;">&diams;[記号]</option>';
    $form .= '</select>';
    return $form;
}

1;
