package BackgroundLib;
require CMONOS::CGI_Lib::Tools::ImageLib;
@ISA = qw(ImageLib);
use strict;
use utf8;
######################################################################
# 背景画像ライブラリ編集モジュール
# BackgroundLib.pm ver1.0.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-03-01
######################################################################
# 設定フォーム
sub print_setting_form ($$$) {
    my $this = shift;
    return;
}

######################################################################
# メニュー
sub menu ($$;$$$) {
    my ( $this, $name, $lib_dir, $id, $list ) = @_;
    return $this->{'deco_obj'}
        ->background_menu( $name, $main::dir, 100, $id, 1, $list, $lib_dir );
}

######################################################################
# 画像設定登録
sub set_image ($) {
    my $this = shift;
    $this->update_css_files;
}

######################################################################
# CSS修正
sub update_css_files ($) {
    my $this = shift;
    my $img
        = ( -f "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.gif" )
        ? "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.gif"
        : ( -f "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.jpg" )
        ? "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.jpg"
        : ( -f "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.png" )
        ? "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.png"
        : '';
    return if !$img;
    $img = $this->base_change( $img, $env::css . '/default.css' );
    my $pat = quotemeta $img;
    $pat =~ s/\.(gif|jpg|png)$/.(gif|jpg|png)/;
    local (*DIR);
    return unless opendir( DIR, $env::css );
    my @css_files
        = grep( $_ =~ /^[0-9a-zA-Z_]+\.css$/
            && $_ ne 'common.css'
            && $_ ne 'tools.css'
            && $_ ne 'image.css',
        readdir(DIR) );
    closedir(DIR);
    push( @css_files, 'site-navi.css' );

    foreach my $file (@css_files) {
        my $path = $env::css . '/' . $file;
        my $data = $this->read_file( $path, 1 );
        if ( $data =~ s/$pat/$img/sg ) {
            $this->write_file( $path, \$data, 1 );
        }
    }
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    $ImageLib::modules{'background'} = 'BackgroundLib'
        if !defined $ImageLib::modules{'background'};
}

1;
