package NumberLib;
require CMONOS::CGI_Lib::Tools::ButtonLib;
@ISA = qw(ButtonLib);
use strict;
use utf8;
######################################################################
# 数字画像ライブラリ編集モジュール
# NumberLib.pm ver1.0.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 削除
sub erace_image_css ($) {
    my $this = shift;
    return;
}

######################################################################
# メニュー
sub menu ($$;$$$) {
    my ( $this, $name, $lib_dir, $id, $list ) = @_;
    return $this->{'deco_obj'}
        ->number_menu( $name, $main::dir, $id, 1, $list, $lib_dir );
}

######################################################################
# 素材ライブラリCSSチェック
sub image_css_is_ready ($$$$) {
    my ( $this, $image_lib, $dir, $setting ) = @_;
    return 0;
}

######################################################################
# 画像設定登録
sub set_image ($) {
    my $this = shift;
    return;
}

######################################################################
# 設定フォーム
sub print_setting_form ($) {
    my $this = shift;
    return;
}

######################################################################
# 画像の保存
sub save_images ($) {
    my $this = shift;
    return 0
        if !ref $cgi::input
        || $cgi::Image->is_not_web_image( $cgi::input, '', '', 'gif' );
    my $is_valid = 1;
    foreach my $image ( '0', '1', '2', '3', '4', '5', '6', '7', '8', '9' ) {
        if ( !defined $main::image{$image} || $main::image{$image} eq '' ) {
            push(
                @{ $cgi::action->{'dialog'} },
                '数字画像【' . $image . '】がありません。'
            );
            $is_valid = 0;
        }
    }
    return 0 if !$is_valid;

    #古い画像の削除
    $this->unlink_my_files;

    #保存
    foreach my $image (
        '0',       '1',           '2',         '3',
        '4',       '5',           '6',         '7',
        '8',       '9',           'total',     'total_end',
        'monthly', 'monthly_end', 'yesterday', 'yesterday_end',
        'today',   'today_end',   'kiriban',   'start',
        'end',     'spacer'
        )
    {
        if ( defined $main::image{$image} && $main::image{$image} ne '' ) {
            $cgi::input->save_file(
                'image:' . $image,
                1000000,
                "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id",
                '!' . $image,
                ['image/gif:gif']
            );
        }
    }
    push( @{ $cgi::action->{'dialog'} }, $cgi::input->dialog )
        if ref $cgi::action;
    if ($main::tate) {
        local (*FILE);
        use Fcntl qw(:flock);
        my $v
            = "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id/v.gif";
        if ( open( FILE, ">>$v" ) ) {
            binmode FILE;
            flock( FILE, LOCK_EX );
            truncate( FILE, 0 );
            seek( FILE, 0, 0 );
            print FILE
                "GIF89a\x01\x00\x01\x00\x80\x00\x00\xFF\xFF\xFF\x00\x00\x00\x21\xF9\x04\x05\x14\x00\x00\x00\x2C\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02\x02D\x01\x00\x3B";
            close(FILE);
        }
        chmod( $env::file_mode, $v );
    }
    return 1;
}

sub unlink_my_files ($) {
    my $this = shift;
    $this->unlink_image_files(
        '0',       '1',           '2',         '3',
        '4',       '5',           '6',         '7',
        '8',       '9',           'total',     'total_end',
        'monthly', 'monthly_end', 'yesterday', 'yesterday_end',
        'today',   'today_end',   'kiriban',   'start',
        'end',     'spacer',      'v'
    );
}

######################################################################
# アップロードフォーム
sub print_upload_form ($$) {
    my ( $this, $save_button ) = @_;
    print <<FORM;
<fieldset>
<legend>オリジナル画像</legend>
<fieldset>
<legend>数字</legend>
<table class="field-table">
<tbody>
<tr>
<td class="field-name"><label for="image:1">1</label></td>
<td class="q-field"><input type="file" id="image:1" name="image:1" /></td>
<td class="field-name"><label for="image:2">2</label></td>
<td class="q-field"><input type="file" id="image:2" name="image:2" /></td>
</tr>
<tr>
<td class="field-name"><label for="image:3">3</label></td>
<td class="q-field"><input type="file" id="image:3" name="image:3" /></td>
<td class="field-name"><label for="image:4">4</label></td>
<td class="q-field"><input type="file" id="image:4" name="image:4" /></td>
</tr>
<tr>
<td class="field-name"><label for="image:5">5</label></td>
<td class="q-field"><input type="file" id="image:5" name="image:5" /></td>
<td class="field-name"><label for="image:6">6</label></td>
<td class="q-field"><input type="file" id="image:6" name="image:6" /></td>
</tr>
<tr>
<td class="field-name"><label for="image:7">7</label></td>
<td class="q-field"><input type="file" id="image:7" name="image:7" /></td>
<td class="field-name"><label for="image:8">8</label></td>
<td class="q-field"><input type="file" id="image:8" name="image:8" /></td>
</tr>
<tr>
<td class="field-name"><label for="image:9">9</label></td>
<td class="q-field"><input type="file" id="image:9" name="image:9" /></td>
<td class="field-name"><label for="image:0">0</label></td>
<td class="q-field"><input type="file" id="image:0" name="image:0" /></td>
</tr>
</tbody>
</table>
</fieldset>
<fieldset>
<legend>説明/単位</legend>
<table class="field-table">
<tbody>
<tr>
<td class="field-name"><label for="image:total">総カウントスタート</label></td>
<td class="q-field"><input type="file" id="image:total" name="image:total" /></td>
<td class="field-name"><label for="image:total_end">総カウントエンド</label></td>
<td class="q-field"><input type="file" id="image:total_end" name="image:total_end" /></td>
</tr>
<tr>
<td class="field-name"><label for="image:thismonth">今月のアクセス数スタート</label></td>
<td class="q-field"><input type="file" id="image:thismonth" name="image:thismonth" /></td>
<td class="field-name"><label for="image:thismonth_end">今月のアクセス数エンド</label></td>
<td class="q-field"><input type="file" id="image:thismonth_end" name="image:thismonth_end" /></td>
</tr>
<tr>
<td class="field-name"><label for="image:today">今日のアクセス数スタート</label></td>
<td class="q-field"><input type="file" id="image:today" name="image:today" /></td>
<td class="field-name"><label for="image:today_end">今日のアクセス数エンド</label></td>
<td class="q-field"><input type="file" id="image:today_end" name="image:today_end" /></td>
</tr>
<tr>
<td class="field-name"><label for="image:yesterday">昨日のアクセス数スタート</label></td>
<td class="q-field"><input type="file" id="image:yesterday" name="image:yesterday" /></td>
<td class="field-name"><label for="image:yesterday_end">昨日のアクセス数エンド</label></td>
<td class="q-field"><input type="file" id="image:yesterday_end" name="image:yesterday_end" /></td>
</tr>
<tr>
<td class="field-name"><label for="image:start">カウンタースタート</label></td>
<td class="q-field"><input type="file" id="image:start" name="image:start" /></td>
<td class="field-name"><label for="image:end">カウンターエンド</label></td>
<td class="q-field"><input type="file" id="image:end" name="image:end" /></td>
</tr>
<tr>
<td class="field-name"><label for="image:kiriban">キリバンエンブレム</label></td>
<td class="q-field"><input type="file" id="image:kiriban" name="image:kiriban" /></td>
<td class="field-name"><label for="image:spacer">スペーサー</label></td>
<td class="q-field"><input type="file" id="image:spacer" name="image:spacer" /></td>
</tr>
</tbody>
</table>
</fieldset>
<label><input type="checkbox" name="tate" value="1" /> 縦書き</label>
<div class="submit"><input type="submit" value="$save_button" /></div>
</fieldset>
FORM
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    $ImageLib::modules{'number'} = 'NumberLib'
        if !defined $ImageLib::modules{'number'};
}

1;
