package PreferenceMap;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# 環境設定マップモジュール
# PreferenceMap.pm ver1.0
# Copyright (C) 2008-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 実行
sub run ($) {
    my $this = shift;

    #ページヘッダ
    $this->jump_menu('tools');

    $this->print_page_header('tools');

    print '<h1>環境設定マップ</h1>';

    my ( @required, $code, %sub_jump_menu_key );
    push( @required, 'm' );
    push( @required, 'c' ) if defined $main::c && $main::c ne '';
    if (%setting::sub_jump_menu) {
        while ( my ( $key, $hash ) = each %setting::sub_jump_menu ) {
            foreach my $id ( keys %{ $setting::sub_jump_menu{$key} } ) {
                $sub_jump_menu_key{$id} = $key;
            }
        }
    }

    #設定選択メニュー
    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'map',
        'required' => \@required
    );
    $code = '';
    print '<ul>';
    foreach my $k ( sort keys %setting::jump_menu ) {
        next if $setting::master_check_option{$k} && !$this->is_master;
        if ( $k =~ /^([\.\-0-9a-zA-Z_]{2})/ && $code ne $1 ) {
            print '</ul><ul>' if defined $code && $code ne '';
            $code = $1;
        }
        print '<li><input type="submit" name="k='
            . $k
            . '" value="'
            . $setting::jump_menu{$k} . '" />';
        if ( $sub_jump_menu_key{$k} ) {
            print '<ul>';
            my $code2 = '';
            foreach my $k2 (
                sort
                keys %{ $setting::sub_jump_menu{ $sub_jump_menu_key{$k} } } )
            {
                next
                    if $setting::master_check_option{$k2}
                    && $this->is_master == 0;
                if ( $k2 =~ /^([\.\-0-9a-zA-Z_]{3})/ && $code2 ne $1 ) {
                    print '</ul><ul>' if defined $code2 && $code2 ne '';
                    $code2 = $1;
                }
                print '<li><input type="submit" name="k='
                    . $k2
                    . '" value="'
                    . $setting::sub_jump_menu{ $sub_jump_menu_key{$k} }{$k2}
                    . '" /></li>';
            }
            print '</ul>';
        }
        print '</li>';
    }
    print '</ul>';
    print '</form>';

    #ページフッタ
    $this->print_page_footer('tools');

}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( '---1', 'PreferenceMap' );

    #メニュー登録
    $setting::jump_menu{'---1'} = '環境設定マップ';
}

1;
