package PreferenceShare;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
use Fcntl qw(:DEFAULT :flock);
######################################################################
# 設定の共有モジュール
# PreferenceShare.pm ver1.1.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-07-20
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    my (%shareable_db);
    push( @main::shareable_db, $main::shareable_db )
        if defined $main::shareable_db && $main::shareable_db ne '';
    @main::shareable_db = grep( defined $_ && $_ ne '', @main::shareable_db );
    undef $main::shareable_db;
    $main::a = '' if !defined $main::a;
    $this->get_shareable_db_info( \%shareable_db );

    if ( @main::shareable_db && $main::a ) {
        my ( @preference_id, $is_invalid );
        $main::prefid = $this->z_to_h( $main::prefid, 'utf8' )
            if $main::prefid;
        if ( !defined $main::prefid && $main::prefid eq '' ) {
            push(
                @{ $this->{'dialog'} },
                '設定 ID を入力してください。'
            );
            $is_invalid = 1;
        }
        elsif ( $main::prefid !~ /^[0-9a-zA-Z]{1,16}$/ ) {
            push(
                @{ $this->{'dialog'} },
                '設定 ID は16文字以内の半角英数字にしてください。'
            );
            $is_invalid = 1;
        }
        elsif ( grep( $_ eq $main::prefid, $this->get_existing_pref_id ) ) {
            push(
                @{ $this->{'dialog'} },
                'この設定 ID は既に使用されています。別の ID に変更してください。'
            );
            $is_invalid = 1;
        }
        $main::prefname =~ s/[<>]//sg;
        $main::prefname =~ s/[\x09\x0A\x0C\x0D\x20]+/ /sg;
        $main::prefname =~ s/[\x09\x0A\x0C\x0D\x20]+$//s;
        if ( !defined $main::prefname && $main::prefname eq '' ) {
            push(
                @{ $this->{'dialog'} },
                '設定名を入力してください。'
            );
            $is_invalid = 1;
        }
        if ( !$is_invalid ) {
            eval 'use ' . $env::dbm_file . ';';
            my @pref_type = ();
            foreach my $db (@main::shareable_db) {
                if ( $shareable_db{$db}{'pref_path'} ) {
                    if ($this->mk_default_bak(
                            $shareable_db{$db}{'pref_path'},
                            $shareable_db{$db}{'bak_path'},
                            $main::prefid,
                            $main::prefname,
                            $main::noaddr
                        )
                        )
                    {
                        push( @pref_type, $shareable_db{$db}{'pref_type'} );
                    }
                    else {
                        push(
                            @{ $this->{'dialog'} },
                            $shareable_db{$db}{'pref_type'}
                                . 'の共有に失敗しました。'
                        );
                    }
                }
            }
            $this->share_relational_files( \@main::shareable_db,
                $main::prefid );
            push(
                @{ $this->{'dialog'} },
                '「'
                    . join( '」「', @pref_type )
                    . '」を設定名「'
                    . $main::prefname . '('
                    . $main::prefid
                    . ')」として共有しました。'
            ) if @pref_type;
            undef $main::prefid;
            undef $main::prefname;
            undef $main::noaddr;
            undef @main::shareable_db;
        }

    }
    elsif ($main::a) {
        push(
            @{ $this->{'dialog'} },
            '共有する設定が指定されていません。'
        );

    }

    #ページヘッダ
    $this->jump_menu( 'tools', 'share' );
    $this->print_page_header('tools');

    print '<h1>設定の共有</h1>';

    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'onsubmit' => 'return cmonos.form.item(this).isNotSubmitted();',
        'required' => \@setting::form
    );
    print '<input type="hidden" name="a" value="share" />';

    print '<fieldset>';
    print
        '<div class="hints">共有された設定は「データベース・設定 の復元」で利用することが出来ます。</div>';
    print '<table class="field-table"><tbody>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">共有する設定</span></td>';
    print '<td class="field"><ol class="checkbox">';

    if (%shareable_db) {
        foreach my $db (
            sort {
                $shareable_db{$a}{'pref_id'} cmp $shareable_db{$b}{'pref_id'}
                    || $a cmp $b
            } keys %shareable_db
            )
        {
            print
                '<li><label><input type="checkbox" name="shareable_db" value="'
                . $db . '"'
                . ( ( grep( $db eq $_, @main::shareable_db ) )
                ? ' checked="checked"'
                : '' )
                . ' />'
                . $shareable_db{$db}{'pref_type'}
                . '</label></li>';
        }
    }
    print '</ol></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="prefid">設定 ID</label></td>';
    print
        '<td><input type="text" name="prefid" id="prefid" size="16" maxlength="16" value="'
        . $this->escape($main::prefid)
        . '" />（16文字以内の半角英数字）</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="prefname">設定名</label></td>';
    print
        '<td class="field"><input type="text" name="prefname" id="prefname" size="40" value="'
        . $this->escape($main::prefname)
        . '" /></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">設定共有オプション</span></td>';
    print
        '<td class="field"><label><input type="checkbox" name="noaddr" id="noaddr"'
        . ( ($main::noaddr) ? ' checked="checked"' : '' )
        . ' /> メールアドレスおよび管理人名を削除してから共有する。</label></td>';
    print '</tr>';
    print '</tbody></table></fieldset>';

    print
        '<fieldset class="submit"><input type="submit" value="実行" class="save" /></fieldset></form>';

    #ページフッタ
    $this->print_page_footer('tools');

}

sub get_existing_pref_id ($) {
    my $this = shift;
    my (%pref_id);
    local (*DIR);
    foreach my $type ( $backup::default{'pref'}, $backup::default{'field'} ) {
        next if !$type;
        my $path
            = ( $env::user_default_dir || $env::default_dir ) . '/' . $type;
        if ( opendir( DIR, $path ) ) {
            my $file;
            while ( $file = readdir(DIR) ) {
                next if $file =~ /^\./;
                $pref_id{$1} = 1
                    if $file =~ /^[0-9a-zA-Z_]+\.([a-zA-Z0-9]+)\.default$/;
            }
            closedir(DIR);
        }
    }
    return keys %pref_id;
}

sub get_shareable_db_info ($$) {
    my ( $this, $shareable_db ) = @_;
    return;
}

sub share_relational_files ($$$) {
    my ( $this, $target, $prefid ) = @_;
    return 1;
}

######################################################################
# DBをバックアップ
sub mk_default_bak ($$$$$;$) {
    my ( $this, $pref_path, $bak_path, $ext, $name, $noaddr ) = @_;
    my ( %db_hash, $done );
    my $home_dir_id      = ($env::home_dir_id) ? $env::home_dir_id : '';
    my $user_directory   = $this->home_directory(1);
    my $home_url         = $this->full_path( '../../', 1 );
    my $home_url_encoded = $this->url_encode($home_url);
    $done = 0;
    tie( %db_hash, $env::dbm_file, $pref_path, O_RDONLY, $env::dbm_mode );

    if ( ref tied %db_hash ) {
        $bak_path .= '.' . $ext . '.default';
        local (*BAK);
        if ( open( BAK, ">>$bak_path" ) ) {
            binmode BAK, ":utf8";
            flock( BAK, LOCK_EX );
            truncate( BAK, 0 );
            seek( BAK, 0, 0 );
            print BAK $name . "\x0A";
            while ( my ( $k, $v ) = each %db_hash ) {
                utf8::decode($k) if !utf8::is_utf8($k);
                utf8::decode($v) if !utf8::is_utf8($v);
                next if grep( $k eq $_, 'latest', 'count', 'mastercginame' );
                $k =~ s/\x09/&#09;/gs;
                $k =~ s/(\x0D\x0A|\x0D|\x0A)/\x0B/gs;
                if ($noaddr) {
                    if (   $k eq 'mastername'
                        || $k eq 'master'
                        || $k eq 'owners'
                        || $k eq 'staff' )
                    {
                        next;
                    }
                    else {
                        $v
                            =~ s!<?[0-9a-zA-Z_\-\+\.]+\@[0-9a-zA-Z_\-]+\.[0-9a-zA-Z_\-\.]+>?!!g;
                    }
                }
                $v
                    =~ s!($user_directory|\.)(/lib/(?:xfiles|javascript|css)/)!(($1 && $1 eq '.') ? $1 . $2 : '<user-directory>' . $2)!ge;
                if ($home_dir_id) {
                    $v =~ s!\Q$user_directory\E(?=["'/])!<user-directory>!gs;
                    $v =~ s/#document_$home_dir_id/#document_<home-dir-id>/g;
                }
                else {
                    $v
                        =~ s/([\x09\x0A\x0C\x0D\x20]+(?:src|href|background|virtual|action)=(?:&quot;|["'])(?!\/\/))\Q$user_directory\E(?=(?:[\/"']|&quot;))/$1<user-directory>/gi;
                    $v =~ s/#document_(?!_)/#document_<home-dir-id>/g;
                }
                $v =~ s!$home_url!<home-url>!g;
                $v =~ s/$home_url_encoded/<home-url-encoded>/g;
                $v =~ s/\x09/&#09;/gs;
                $v =~ s/(\x0D\x0A|\x0D|\x0A)/\x0B/gs;
                print BAK $k;
                print BAK "\x09";
                print BAK $v;
                print BAK "\x0A";
            }
            close(BAK);
            chmod( $env::file_mode, $bak_path );
            $done = 1;
        }
    }
    untie %db_hash;
    return $done;
}

1;
