package TrackbackReceiverBase;
require CMONOS::CGI_Lib::Base;
@ISA = qw(Base);
use strict;
use utf8;
######################################################################
# トラックバック受信モジュール
# TrackbackReceiverBase.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    my ( $error, $message );
    if (   !defined $main::id
        || $main::id eq ''
        || !ref $field::obj{$main::id}
        || $field::obj{$main::id}->{'class'} ne 'ug_trackback' )
    {
        ( $error, $message ) = (
            1,
            'この記事に Trackback することはできません。(Denied.)'
        );
    }
    elsif ( $field::obj{$main::id}->update ) {
        ( $error, $message ) = ( 0, join( ' ', $this->dialog ) );
    }
    else {
        ( $error, $message ) = ( 1, join( ' ', $this->dialog ) );
    }
    binmode STDOUT, ":utf8";
    $this->print_http_header('text/xml; charset=utf-8');
    print '<?xml version="1.0" encoding="utf-8"?>', "\x0A";
    print '<response>',                             "\x0A";
    print '<error>', $error, '</error>', "\x0A";
    print '<message>', $message, '</message>', "\x0A" if $message;
    print '</response>', "\x0A";
}

######################################################################
# モジュール読み込み
#sub import {
BEGIN {
    #クッキー
    $cookie::id_enabled = 1;    #ID情報クッキー読み込み

    $setting::security_key                    = 'tb';
    $setting::key                             = 'tb';
    $setting::security{'tb'}{'passwordCheck'} = 'nocheck';
    $main::k                                  = 'tb';

    $setting::general  = 1;     #一般設定読み込み
    $setting::deco     = 1;     #テキスト装飾設定読み込み
    $setting::security = 1;     #アクセス権設定読み込み
    $setting::table    = 1;     #テーブル設定読み込み
    $setting::page     = 0;     #ページ設定読み込み

    #フィールド読み込み設定
    $setting::field_db_name = 'inputfield'
        if !$setting::field_db_name;    #フィールド設定DB
    $setting::field = 2
        ; #フィールド設定読み込み（2=オリジナルも読み込む）
    $setting::field_style_disabled = 0
        ; #2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
    $setting::field_tag_enabled
        = 'no'; #tag=タグのみ/all=全ての設定/no=タグをつけない
}

1;
