package CalDailyView;
require CMONOS::Calendar::CalDayView;
@ISA = qw(CalDayView);
use strict;
use utf8;
######################################################################
# カレンダー日表示モジュール
# CalDailyView.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# オブジェクト作成
sub new ($) {
    my $pkg  = shift;
    my $this = {};
    bless $this, $pkg;
    return $this;
}

sub get_target_dates ($$) {
    my ( $this, $date ) = @_;
    return ($date);
}

sub prev_calendar_date ($$) {
    my ( $this, $date ) = @_;
    return $this->get_prev_date( $date, 1 );
}

sub next_calendar_date ($$) {
    my ( $this, $date ) = @_;
    return $this->get_next_date( $date, 1 );
}

sub page_title ($$) {
    my ( $this, $date ) = @_;
    if ( $date =~ /^([0-9]{4})([0-9]{2})([0-9]{2})$/ ) {
        my ( $y, $m, $d ) = ( $1, $2 + 0, $3 + 0 );
        return
              $y . '年'
            . $m . '月'
            . $d . '日('
            . $this->get_wday_name( $y, $m, $d ) . ')';
    }
    return '';
}

sub calendar_type ($) {
    my $this = shift;
    return 'daily';
}

sub day_limit ($) {
    my $this = shift;
    return 1;
}

sub have_timetable ($) {
    my $this = shift;
    return 1;
}

1;
