package Tools;
use strict;
use utf8;
######################################################################
# メンテナンスモジュール
# Tools.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定DB読み込み設定
    $setting::general  = 1;    #一般設定読み込み
    $setting::deco     = 1;    #テキスト装飾設定読み込み
    $setting::security = 1;    #アクセス権設定読み込み
    $setting::table    = 1;    #テーブル設定読み込み
    $setting::page     = 0;    #ページ設定読み込み

    #クッキー
    $cookie::id_enabled = 1;    #ID情報クッキー読み込み

    #フィールド読み込み設定
    $setting::field = 0
        ; #フィールド設定読み込み（2=オリジナルも読み込む）
    $setting::field_style_disabled = 2
        ; #2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
    $setting::field_tag_enabled
        = 'no'; #tag=タグのみ/all=全ての設定/no=タグをつけない

    #必須フォーム
    @setting::form = ( 'm', 'k' );

    #バックアップデフォルトディレクトリ
    if (   $default::subdivided
        && ( !defined $main::c || $main::c eq '' )
        && $main::k ne '00c0' )
    {
        $backup::default{'pref'} = 'calendar/masterdefault';
    }
    else {
        $backup::default{'pref'}  = 'calendar/default';
        $backup::default{'field'} = 'calendar/default/field';
    }

    if ( $default::subdivided && ( !defined $main::c || $main::c eq '' ) ) {

        #アクセス権設定名
        $setting::security_name{'index'} = '総合インデックス';

        #バックアップ対象DB
        $backup::db_name{'categorymtime'}
            = 'カテゴリー更新時データベース';    #名前
        $backup::db_path{'categorymtime'}
            = $default::db . '/category_mtime';   #データベースの位置

    }
    else {
        $cgi::input->error404
            if $default::subdivided
            && defined $main::c
            && $main::c ne ''
            && !-d "$default::preference_dir/$main::c";

        push( @setting::form, 'c' ) if defined $main::c && $main::c ne '';

        #アクセス権設定名
        $setting::security_name{'browse'} = 'イベント閲覧';
        $setting::security_name{'secret'} = '非公開フィールド閲覧';
        $setting::security_name{'detail'} = 'イベント詳細閲覧';
        $setting::security_name{'input'}  = 'イベント入力';
        $setting::security_name{'revise'} = 'イベント修正';
        $setting::security_name{'closed'} = '非公開イベント閲覧';
        $setting::security_name{'setClosedEvent'}
            = '非公開イベント指定';
        $setting::security_name{'delete'} = 'イベント削除';
        $setting::security_name{'inputProtectedFields'}
            = '保護フィールド入力';
        $setting::security_name{'reviseProtectedFields'}
            = '保護フィールド修正';

        #バックアップ対象DB
        $backup::db_name{'db'} = 'イベントデータベース';    #名前
        $backup::db_path{'db'} = $default::db;    #データベースの位置
        $backup::find{'db'} = 1;    #1=ディレクトリの階層を下る

        #復元対象関連ファイル
        $backup::relational_file{'event_category'}{'path'}
            = 'calendar/default/css/event-category';
        $backup::relational_file{'event_category'}{'ext'} = 'css';
        $backup::relational_file{'event_category'}{'target'}
            = $default::file
            . ( ( $default::subdivided && defined $main::c && $main::c ne '' )
            ? '/' . $main::c
            : '' )
            . '/event-category.css';
    }

    #各種キー設定
    $setting::security_key = 'tools'; #デフォルトセキュリティキー
    $setting::key          = 'tools'; #ページ設定キー

    #	$setting::subkey = '';									#ページ詳細設定キー

    #アクセス権設定名
    $setting::security_name{'tools'} = '環境設定';

    #デフォルトキー
    $main::k = '0000' if !defined $main::k || $main::k eq '';

    #ツールページ設定
    $setting::page{'tools'}{'title'} = '環境設定';

    #	$setting::page{'tools'}{'text'} = '#000000';
    #	$setting::page{'tools'}{'link'} = '#0000ff';
    #	$setting::page{'tools'}{'alink'} = '#99ffff';
    #	$setting::page{'tools'}{'vlink'} = '#000099';
    #	$setting::page{'tools'}{'hover'} = '#00ffff';
    #	$setting::page{'tools'}{'nodeco'} = 'no';
    #	$setting::page{'tools'}{'bgcolor'} = '#ffffff';
    $setting::page{'tools'}{'bodyId'}                   = 'tools';
    $setting::page{'tools'}{'commonHtmlHeaderDisabled'} = 1;
    $setting::page{'tools'}{'cssFileName'}              = 'tools.css';

# 	$setting::page{'tools'}{'CSS'} = 'h1 { font-size: large; font-weight: bold; text-indent: 1em; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'tools'}{'CSS'} .= 'h2 { font-size: medium; font-weight: bold; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'tools'}{'CSS'} .= 'hr { border-width: 1 0 0 0; }';
# 	$setting::page{'tools'}{'background'} = '';
# 	$setting::page{'tools'}{'bgproperties'} = '';
# 	$setting::page{'tools'}{'topmargin'} = '';
# 	$setting::page{'tools'}{'leftmargin'} = '';
# 	$setting::page{'tools'}{'javascript'} = '';
# 	$setting::page{'tools'}{'header'} = '';
# 	$setting::page{'tools'}{'headerFileName'} = '';
# 	$setting::page{'tools'}{'titleImageAlign'} = '';
# 	$setting::page{'tools'}{'titleImage'} = '';
# 	$setting::page{'tools'}{'align'} = '';
# 	$setting::page{'tools'}{'width'} = '';
# 	$setting::page{'tools'}{'deco'} = '';
# 	$setting::page{'tools'}{'titleText'} = '';

    $cgi::input->query_filter( $cgi::input->secure_query_for_tools_ref )
        if ref $cgi::input;

    #メンテナンスモジュール読み込み
    Common::use_modules('CGI_Lib/Tools');
    Common::use_modules( $default::lib . '/Tools' );

    #イメージCSS
    $setting::image_css = 'calendar-image.css';

}

1;
