package EventSweeper;
require CMONOS::Calendar::CalCommon;
@ISA = qw(CalCommon);
use strict;
use utf8;
######################################################################
# イベント整理モジュール
# EventSweeper.pm ver1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-01-27
######################################################################
# 実行
sub run ($) {
    my $this = shift;

    use Fcntl qw(:DEFAULT);
    eval 'use ' . $env::dbm_file . ';';
    use File::Path;

    #一括削除
    $this->use_field( 'field', $default::field_pref_dir . '/inputfield',
        2, 2, 'no' );
    if (%main::search) {
        if (   $this->is_valid_date( $main::search{'f'} )
            && $this->is_valid_date( $main::search{'t'} ) )
        {
            my ( $limit, @delete_events, %dt, $delete_count, @search_fields,
                $from, $to );
            $limit = time - $main::search{'within'}
                if $main::search{'within'};
            $from
                = $main::search{'f'}{'year'}
                . sprintf( "%.2d", $main::search{'f'}{'mon'} )
                . sprintf( "%.2d", $main::search{'f'}{'mday'} )
                if $main::search{'f'}{'year'};
            $to
                = $main::search{'t'}{'year'}
                . sprintf( "%.2d", $main::search{'t'}{'mon'} )
                . sprintf( "%.2d", $main::search{'t'}{'mday'} )
                if $main::search{'t'}{'year'};
            if (%main::search) {
                while ( my ( $id, $hash ) = each %main::search ) {
                    if (   $id !~ /\D/
                        && ref $field::obj{$id}
                        && $field::obj{$id}->match_enabled )
                    {
                        my $count = 0;
                        while ( my ( $k, $v ) = each %$hash ) {
                            if (defined $v
                                && (   ( ref $v && @$v )
                                    || ( !ref $v && $v ne '' ) )
                                )
                            {
                                $count++;
                            }
                        }
                        if (   $count
                            && $count == 1
                            && $main::search{$id}{'mode'} )
                        {
                            $count = 0;
                        }
                        push( @search_fields, $id ) if $count;
                    }
                }
            }
            if (   @search_fields
                || $from
                || $to
                || $limit
                || $main::search{'freq'} )
            {
                $delete_count = 0;
                tie( %dt, $env::dbm_file, $default::db . '/dt',
                    O_RDWR, $env::dbm_mode );
                if ( ref tied %dt ) {
                    my ( %date, %db, @db );
                    tie( %date, $env::dbm_file, $default::db . '/date',
                        O_RDWR, $env::dbm_mode );
                    tie(%{ $db{'ctime'} },
                        $env::dbm_file, $default::db . '/ctime',
                        O_RDWR, $env::dbm_mode
                    );
                    tie(%{ $db{'mtime'} },
                        $env::dbm_file, $default::db . '/mtime',
                        O_RDWR, $env::dbm_mode
                    );
                    tie(%{ $db{'agent'} },
                        $env::dbm_file, $default::db . '/agent',
                        O_RDWR, $env::dbm_mode
                    );
                    tie(%{ $db{'ip'} },
                        $env::dbm_file, $default::db . '/ip',
                        O_RDWR, $env::dbm_mode
                    );
                    tie(%{ $db{'category'} },
                        $env::dbm_file, $default::db . '/category',
                        O_RDWR, $env::dbm_mode
                    );
                    while ( my ( $id, $field ) = each %field::obj ) {
                        $field::obj{$id}->{'searchOption'} = 1
                            if !$field::obj{$id}->{'searchOption'};
                        my $db_name = $field->db;
                        if ( $db_name && !ref $db{$db_name} ) {
                            tie(%{ $db{$db_name} },
                                $env::dbm_file,
                                $default::db . '/' . $db_name,
                                O_RDWR,
                                $env::dbm_mode
                            );
                        }
                    }
                    @db = values %db;
                EVENT:
                    while ( my ( $n, $dt ) = each %dt ) {
                        my $is_matched = 0;
                        utf8::decode($n)  if !utf8::is_utf8($n);
                        utf8::decode($dt) if !utf8::is_utf8($dt);
                        if ( $from || $to ) {
                            if (   $dt
                                && $dt
                                =~ /^([0-9]{8})T?(?:[0-9]{6}|)-([0-9]{8})T?(?:[0-9]{6}|)\x09([^\x09\x0A\x0C\x0D\x20]*)/
                                )
                            {
                                my ( $start_date, $end_date, $rrule )
                                    = ( $1, $2, $3 );
                                $end_date = $1
                                    if $rrule =~ /FREQ=\w+/
                                    && $rrule =~ /UNTIL=([0-9]{8})/;
                                if (   ( !$from || $from <= $start_date )
                                    && ( !$to || $end_date < $to ) )
                                {
                                    $is_matched = 1;
                                }
                                elsif ($main::and) {
                                    next EVENT;
                                }
                            }
                        }
                        if ($limit) {
                            if (   $db{'ctime'}{$n}
                                && $db{'ctime'}{$n} > $limit )
                            {
                                $is_matched = 1;
                            }
                            elsif ($main::and) {
                                next EVENT;
                            }
                        }
                        if ( $main::search{'freq'} ) {
                            my $freq = ( $dt =~ /FREQ=\w+/ ) ? 1 : 0;
                            if (   ( $main::search{'freq'} eq '1' && $freq )
                                || ( $main::search{'freq'} eq '-1' && !$freq )
                                )
                            {
                                $is_matched = 1;
                            }
                            elsif ($main::and) {
                                next EVENT;
                            }
                        }
                    SEARCH:
                        foreach my $id (@search_fields) {
                            my $dat
                                = $this->decode_utf8(
                                $db{ $field::obj{$id}->db }
                                    ->{ $this->encode_utf8($n) } );
                            if ( $field::obj{$id}->match( \$dat ) ) {
                                $is_matched = 1;
                            }
                            elsif ($main::and) {
                                next EVENT;
                            }
                        }
                        if ( !$dt || $is_matched ) {
                            push( @delete_events, $n );
                            if (   $n
                                && $dt{$n}
                                && $dt{$n} =~ /\x09([^\x09]+)$/s )
                            {
                                my @dates = $this->get_event_ids(
                                    [ split( /,/, $1 ) ] );
                                rmtree "$default::file/$n"
                                    if defined $default::file
                                    && $default::file ne '';
                                foreach my $db (@db) {
                                    delete $db->{$n};
                                }
                                $delete_count++;
                                foreach my $d (@dates) {
                                    if ( $date{$d} ) {
                                        my @events = split( /,/, $date{$d} );
                                        if (grep( $_
                                                    && $_
                                                    =~ /^(?:[0-9]+<|)$n(?:>[0-9]+|)$/,
                                                @events )
                                            )
                                        {
                                            @events
                                                = grep( $_
                                                    && $_
                                                    !~ /^(?:[0-9]+<|)$n(?:>[0-9]+|)$/,
                                                @events );
                                            if (@events) {
                                                $date{$d}
                                                    = join( ',', @events );
                                            }
                                            else {
                                                delete $date{$d};
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    foreach my $n (@delete_events) {
                        utf8::encode($n) if utf8::is_utf8($n);
                        delete $dt{$n};
                    }
                    foreach my $db (@db) {
                        untie(%$db);
                    }
                    undef %db;
                    untie(%date);
                }
                untie(%dt);
                $this->index_sweeper( \@delete_events );
                push(
                    @{ $this->{'dialog'} },
                    $delete_count . 'の予定を削除しました。'
                );
            }
            else {
                push(
                    @{ $this->{'dialog'} },
                    '一括削除に失敗しました。条件が設定されていません。'
                );
            }
        }
        else {
            push(
                @{ $this->{'dialog'} },
                '一括削除に失敗しました。日付の指定を確認してください。'
            );
        }
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print
        '<h1 title="予定の一括削除を行います。">予定の一括削除</h1>';

    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'onsubmit' => 'return cmonos.form.item(this).isNotSubmitted()',
        'required' => \@setting::form
    );

    print '<fieldset><legend>一括削除条件</legend>';
    print '<table class="field-table"><tbody>';
    print '<tr>';
    print '<td class="field-name"><span class="datatitle">日付</span></td>';
    print '<td class="field">';
    $this->print_date_form( 'search:f:', $main::search{'f'} );
    print ' から<br />';
    $this->print_date_form( 'search:t:', $main::search{'t'} );
    print 'まで</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="search:freq">繰り返し</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        'search:freq', '', '', $main::search{'freq'},
        ''   => '',
        '1'  => '繰り返す予定のみ',
        '-1' => '繰り返す予定を除外',
    );
    print '</td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><label for="search:within">作成時</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        'search:within', '', '', $main::search{'within'},
        ''      => '',
        300     => '5分',
        600     => '10分',
        1800    => '30分',
        3600    => '1時間',
        10800   => '3時間',
        21600   => '6時間',
        43200   => '12時間',
        86400   => '1日',
        259200  => '3日',
        604800  => '1週間',
        2592000 => '30日',
    );
    print '</td>';
    print '</tr>';

    print '</tbody><tbody>';
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        if ( ref $field::obj{ $field::ORDER{$_} }
            && $field::obj{ $field::ORDER{$_} }->search_form_enabled )
        {
            $field::obj{ $field::ORDER{$_} }->{'searchOption'} = 1
                if !$field::obj{ $field::ORDER{$_} }->{'searchOption'};
            print $field::obj{ $field::ORDER{$_} }->search_form;
        }
    }
    print
        '</tbody><tbody><tr class="tbody-start"><td class="reset-box"><input type="button" value="リセット" onclick="cmonos.form.item(this.form).resetAll(\'search:\')" /></td><td class="submit-box">';
    print '<select name="and">';
    print '<option value="1">全ての条件に一致</option>';
    print '<option value="0"'
        . (
        ( defined $main::and && !$main::and ) ? ' selected="selected"' : '' )
        . '>いずれかの条件に一致</option>';
    print '</select></td></tr></tbody></table>';

    print '</fieldset>';
    print '<fieldset class="delete">';
    print
        '<input type="submit" name="delete=1" value="上条件に一致する予定を一括削除する" onclick="return confirm(\'この操作は取り消せません。本当に削除しますか？\');" />';
    print '</fieldset></form>';

    #ページフッタ
    $this->print_page_footer('tools');
}

sub print_date_form ($$$) {
    my ( $this, $prefix, $selected ) = @_;
    my @localtime = localtime(time);
    my $year      = $localtime[5] + 1900;
    print '<label><select name="' . $prefix
        . 'year"><option value=""></option>';
    for ( my $y = $year - 20; $y < $year + 20; $y++ ) {
        print '<option value="', $y, '"';
        print(
            (          ref $selected
                    && $selected->{'year'}
                    && $selected->{'year'} == $y
            ) ? ' selected="selected"' : ''
        );
        print '>', $y, '</option>';
    }
    print '</select>年</label> ';
    print '<label><select name="' . $prefix
        . 'mon"><option value=""></option>';
    foreach my $i ( 1 .. 12 ) {
        print '<option value="', $i, '"';
        print(
            (          ref $selected
                    && $selected->{'mon'}
                    && $selected->{'mon'} == $i
            ) ? ' selected="selected"' : ''
        );
        print '>', $i, '</option>';
    }
    print '</select>月</label> ';
    print '<label><select name="' . $prefix
        . 'mday"><option value=""></option>';
    foreach my $i ( 1 .. 31 ) {
        print '<option value="', $i, '"';
        print(
            (          ref $selected
                    && $selected->{'mday'}
                    && $selected->{'mday'} == $i
            ) ? ' selected="selected"' : ''
        );
        print '>', $i, '</option>';
    }
    print '</select>日</label>';
}

sub is_valid_date ($$) {
    my ( $this, $date ) = @_;
    return (
        (   !ref $date
                || ( !$date->{'year'} && !$date->{'mon'} && !$date->{'mday'} )
        )
            || (
               !$this->is_nan( $date->{'mday'} )
            && !$this->is_nan( $date->{'mon'} )
            && !$this->is_nan( $date->{'year'} )
            && $date->{'year'} > 1900
            && !$this->is_impossible_mday(
                $date->{'year'}, $date->{'mon'}, $date->{'mday'}
            )
            )
    ) ? 1 : 0;
}

sub get_event_ids ($$) {
    my ( $this, $events ) = @_;
    my (%event);
    foreach my $n (@$events) {
        $n =~ s/^[0-9]+<//;
        $n =~ s/>[0-9]+$//;
        $event{$n}++;
    }
    return keys %event;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);
    if ( !$default::subdivided
        || ( $default::subdivided && defined $main::c && $main::c ne '' ) )
    {

        #クラス登録
        Common::class_register( 'xxas', 'EventSweeper' );

        #メニュー登録
        $setting::jump_menu{'xxas'} = '予定の一括削除';

    }
}

1;
