package MasterGeneralSetting;
require CMONOS::CGI_Lib::Tools::General;
@ISA = qw(General);
use strict;
use utf8;
no warnings qw(once);
######################################################################
# 一般設定モジュール
# MasterGeneralSetting.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定チェック項目取得
sub get_sub_setting_items ($) {
    my $this = shift;

    #チェックボックス
    push( @check::checkbox, 'subicon' );

    #タグを除去する
    push( @check::notag, 'description' );

    #数字チェック
    $check::num{'dateLimit'} = '日時の表示設定';

    #数字チェック
    $check::num{'iconMaxSize'}
        = 'カテゴリーアイコンファイルサイズ制限';
    $check::num{'iconWidthLimit'} = 'カテゴリーアイコン横幅制限';
    $check::num{'iconHeightLimit'}
        = 'カテゴリーアイコン高さ制限';

    $check::imagefile{'og'} = 'og:image';
    $check::ogimage{'og'}   = 1;
}

######################################################################
# 設定環境2
sub is_database_cgi ($) {
    my $this = shift;
    return 1;
}

sub sub_set_preferences ($) {
    my $this = shift;
    $cgi::enctype_multipart = 1;
    $default::file = '.' if !defined $default::file || $default::file eq '';
    $preference::filedir{'og'}
        = $default::file;    #画像保存ディレクトリ
}

######################################################################
# サブ設定パネル
sub print_sub_preference_panel ($$) {
    my ( $this, $master ) = @_;
    print '<fieldset><legend>メタデータ</legend>';
    print '<fieldset><legend>og:image</legend>';
    $this->print_image_upload_form( 'og', 'og', \%main::data );
    print '</fieldset>';
    print
        '<fieldset><legend><label for="data:description">説明</label></legend>';
    print
        '<textarea name="data:description" id="data:description" cols="56" rows="6" wrap="soft" title="メタデータに埋め込む掲示板の説明を設定します。">'
        . ( ( defined $main::data{'description'} )
        ? $main::data{'description'}
        : '' )
        . '</textarea>';
    print
        '<div class="note">メタデータに埋め込む掲示板の説明を設定します。</div></fieldset>';
    print '</fieldset>';

    print '<fieldset><legend>日付の書式設定</legend>';
    print '<table class="field-table"><tbody>';

    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">標準日付書式</span></td>';
    print '<td class="field">';
    $this->print_date_type_menu( 'data:', $main::data{'datetype'},
        '日付の標準書式を設定します。' );
    print '</td>';
    print '</tr>';

    print '<tr>';
    print
        '<td class="field-name"><label for="data:dateLimit">日時の表示</label></td>';
    print
        '<td class="field"><input type="number" size="3" maxlength="3" name="data:dateLimit" id="data:dateLimit" value="'
        . $this->escape( $main::data{'dateLimit'} )
        . '" /> 日以内なら相対日時で表現する（きょう/きのう/○日前）';
    print '</td>';
    print '</tr>';

    print '</tbody></table>';
    print '</fieldset>';

    print '<fieldset><legend>カテゴリーアイコン設定</legend>';
    print '<table class="field-table"><tbody>';

    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">カテゴリーアイコン</span></td>';
    print
        '<td class="field"><label><input type="checkbox" name="data:subicon" id="data:subicon" value="1"'
        . ( ( $main::data{'subicon'} ) ? ' checked="checked"' : '' )
        . ' /> カテゴリーごとにアイコンを作成できるようにする</label></td>';
    print '</tr>';

    print '<tr>';
    print '<td class="field-name">';
    print
        '<label for="data:iconMaxSize">カテゴリーアイコンファイルサイズ制限</label></td>';
    print
        '<td class="field"><input type="number" name="data:iconMaxSize" id="data:iconMaxSize" value="'
        . $this->escape( $main::data{'iconMaxSize'} )
        . '" size="15" /> <span class="unit">byte</span>';
    print
        '<div class="hints">設定が無い場合、30,000byte（30kB）に設定されます。</div>';
    print '</td>';
    print '</tr>';

    print '<tr>';
    print
        '<td class="field-name"><label for="data:iconWidthLimit">カテゴリーアイコン横幅制限</label></td>';
    print
        '<td class="field"><input type="number" name="data:iconWidthLimit" id="data:iconWidthLimit" value="'
        . $this->escape( $main::data{'iconWidthLimit'} )
        . '" size="4" /> <span class="unit">ピクセル</span></td>';
    print '</tr>';

    print '<tr>';
    print
        '<td class="field-name"><label for="data:iconHeightLimit">カテゴリーアイコン高さ制限</label></td>';
    print
        '<td class="field"><input type="number" name="data:iconHeightLimit" id="data:iconHeightLimit" value="'
        . $this->escape( $main::data{'iconHeightLimit'} )
        . '" size="4" /> <span class="unit">ピクセル</span></td>';
    print '</tr>';

    print '</tbody></table>';
    print '</fieldset>';
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ( $default::subdivided && ( !defined $main::c || $main::c eq '' ) ) {

        #クラス登録
        Common::class_register( '0000', 'MasterGeneralSetting' );

        #ツール登録
        $setting::jump_menu{'0000'} = '一般設定';
    }
}

1;
