package NoticeMsg;
require CMONOS::CGI_Lib::Tools::Preference;
@ISA = qw(Preference);
use strict;
use utf8;
######################################################################
# 入力通知設定モジュール
# NoticeMsg.pm ver1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定環境
sub set_preferences ($) {
    my $this = shift;
    $preference::db = 'mail';    # 記録用データベース名
    $preference::name = '入力通知メール設定';    # 設定パネル名
    $preference::title
        = '新規入力を管理人に通知するメールを設定をします。';
}

######################################################################
# 設定パネル
sub print_preference_panel ($) {
    my $this         = shift;
    my $setting_flag = 0;

    #フィールド設定読み込み
    $this->use_field( 'field', $default::field_pref_dir . '/inputfield', 2 );

    print
        '<fieldset><legend>新規予定通知メール設定 <span class="note">(新規予定の入力があったとき管理人・共同オーナー・スタッフに自動的に送信されます)</span></legend>';
    if ( defined $setting::general{'notice'} && $setting::general{'notice'} )
    {
        print '<table class="field-table"><tbody>';
        print '<tr>';
        print
            '<td class="field-name"><label for="data:subject">メールの表題</label></td>';
        print
            '<td class="field"><input type="text" name="data:subject" id="data:subject" size="72" value="'
            . $this->escape( $main::data{'subject'} )
            . '" /></td>';
        print '</tr>';

        print '<tr>';
        print
            '<td class="field-name"><label for="data:msg">通知内容</label></td>';
        print
            '<td class="field"><textarea name="data:msg" id="data:msg" cols="72" rows="15" wrap="soft">'
            . $this->escape( $main::data{'msg'} )
            . '</textarea>';
        print '<div class="toolbox">';
        print
            '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:msg\').quotationByMenu(this)" title="これらのタグは通知メール送信時に対応する値に変換されます。">';
        print '<option value="">▼挿入する</option>';
        print
            '<option value="&lt;dt&gt;">&lt;dt&gt;[予定の日時]</option>';
        print
            '<option value="&lt;name&gt;">&lt;name&gt;[名前フィールド'
            . (
            ( $field::for{'name'} && ref $field::obj{ $field::for{'name'} } )
            ? '（' . $field::obj{ $field::for{'name'} }->name . '）'
            : '' )
            . 'の値]</option>';
        print
            '<option value="&lt;title&gt;">&lt;title&gt;[タイトルフィールド'
            . (
            (   $field::for{'title'}
                    && ref $field::obj{ $field::for{'title'} }
            )
            ? '（' . $field::obj{ $field::for{'title'} }->name . '）'
            : ''
            ) . 'の値]</option>';
        print
            '<option value="&lt;url&gt;">&lt;url&gt;[新規予定のURL]</option>';
        print
            '<option value="&lt;data&gt;">&lt;data&gt;[予定内容の一覧]</option>'
            if $setting::general{'notice'} eq 'data';
        print '</select>';
        print '</div>';
        print '</td>';
        print '</tr>';

        print '</tbody></table>';

        $setting_flag = 1;
    }
    else {

        print
            '新規予定通知機能停止中（「一般設定」で変更できます。）';
    }
    print '</fieldset>';

    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>'
        if $setting_flag;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ( !$default::subdivided
        || ( $default::subdivided && defined $main::c && $main::c ne '' ) )
    {

        #クラス登録
        Common::class_register( 'c200', 'NoticeMsg' );

        #ツール登録
        $setting::jump_menu{'c200'} = '入力通知メール設定';
    }
}

1;
