package RelatedPages;
require CMONOS::HomePageMaker::Field::HMUserGeneratedField;
require CMONOS::CGI_Lib::Field::RelatedPagesBase;
@ISA = qw(HMUserGeneratedField RelatedPagesBase);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（関連ページ一覧）
# RelatedPages.pm 1.0.1
# Copyright (C) 2007-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2012-07-15
######################################################################
sub get_whole_page ($$) {
    my $this = shift;
    my $path = $this->get_article_dir;
    return ''
        if $path
        && $this->{'target_path'}
        && $path eq $this->{'target_path'}
        && $this->{'temporary_keywords'};
    delete $this->{'temporary_keywords'};
    $this->{'target_path'} = $path;
    my $sentence = '';
    local (*DIR);
    if ( opendir( DIR, $path ) ) {
        my @page = grep( -f "$path/$_" && $_ =~ /^[0-9]+\.s?html?$/i,
            readdir(DIR) );
        closedir(DIR);
        foreach my $p (@page) {
            $sentence .= $this->_get_whole_page( $path . '/' . $p );
        }
    }
    return $sentence;
}

sub need_whole_page ($) {
    my $this = shift;
    return ( $main::p && $main::p eq 'i' ) ? 1 : $this->{'fromWholePage'};
}

sub set_temporary_keywords ($$) {
    my ( $this, $keywords ) = @_;
    $this->{'temporary_keywords'} = $keywords;
}

sub get_selfurl ($;$$) {
    my ( $this, $c, $n ) = @_;
    if ( $main::p && $main::p eq 'i' ) {
        return $this->g_url(
            $this->full_path( $this->get_article_dir(1) . '/' ) );
    }
    else {
        return $this->g_url( $this->full_path( $this->get_output_path(1) ) );
    }
}

sub get_parenturl ($;$) {
    my ( $this, $c ) = @_;
    return $this->g_url( $this->full_path( $default::home . '/' ) );

#return $this->g_url($this->full_path($default::home . '/*.' . (($env::ssi && $env::ssi_ext) ? $env::ssi_ext : 'html')));
}

sub get_topurl ($;$) {
    my $this = shift;
    return $this->g_url( $this->full_path( $master::home . '/' ) );

#return $this->g_url($this->full_path($master::home . '/*.' . $default::ext));
}

sub get_exurl ($) {
    my $this  = shift;
    my @exurl = (
        $this->g_url(
                  $this->full_path($default::home)
                . '/index.'
                . ( ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html' )
        )
    );
    push( @exurl,
        $this->g_url( $this->full_path($default::home) . '/history/' ) )
        if $default::date;
    if (   $default::subdivided
        && $master::home
        && $default::home ne $master::home )
    {
        push(
            @exurl,
            $this->g_url(
                      $this->full_path($default::home)
                    . '/index.'
                    . (
                    ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html'
                    )
            )
        );
    }
    return @exurl;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'webapi_rel', 'RelatedPages',
        '関連ページ一覧' );
}

1;
