package TrackbackPing;
require CMONOS::HomePageMaker::Field::HMUserGeneratedField;
require CMONOS::CGI_Lib::Field::TrackbackPingBase;
@ISA = qw(HMUserGeneratedField TrackbackPingBase);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（トラックバック/Ping）
# TrackbackPing.pm 1.0
# Copyright (C) 2007-2018 CMONOS Co. Ltd.
#
#　support@cmonos.jp
#　http://cmonos.jp/
#
######################################################################
sub search_links_from_files ($$) {
    my ( $this, $link_array ) = @_;
    return if $main::p && $main::p ne 'i';
    my $dir
        = ( !$master::home || $master::home eq $default::home )
        ? $default::home
        . ( ( $default::subdivided && defined $main::c && $main::c ne '' )
        ? '/' . $main::c
        : '' )
        . '/'
        . $main::n
        : $default::home . '/' . $main::n;
    local (*DIR);
    if ( opendir( DIR, $dir ) ) {
        my @pages = grep( -f "$dir/$_" && $_ =~ /^[0-9]+\./, readdir(DIR) );
        closedir(DIR);
        foreach my $file (@pages) {
            my $data = $this->read_file( $dir . '/' . $file, 1 );
            while ( $data
                =~ /<!--field(?=[\x09\x0A\x0C\x0D\x20\-])[^>]*-->(.*?)<!--\/field-->/gs
                )
            {
                my $field = $1;
                while ( $field
                    =~ /<!--data(?=[\x09\x0A\x0C\x0D\x20\-])[^>]*-->(.*?)<!--\/data-->/gs
                    )
                {
                    my $value = $1;
                    $this->search_links( \$value, $link_array );
                }
            }
        }
    }
}

sub get_trackback_url ($;$$) {
    my ( $this, $c, $n ) = @_;
    return
          $this->my_url
        . '?m=TrackbackReceiver&id='
        . $this->{'id'}
        . (
        ( $default::subdivided && defined $c && $c ne '' ) ? '&c=' . $c : '' )
        . ( ( defined $n && $n ne '' ) ? '&n=' . $n : '' )
        . (
        ( defined $main::p && $main::p ne '' )
        ? '&p='
            . $main::p
            . (
            ( $main::p ne 'i' )
            ? ( ( defined $main::chap && $main::chap ne '' )
                ? '&chap=' . $main::chap
                : '' )
                . (
                ( defined $main::sect && $main::sect ne '' )
                ? '&sect=' . $main::sect
                : ''
                )
            : ''
            )
        : ''
        );
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'ug_trackback', 'TrackbackPing',
        'トラックバック/Ping' );
}

1;
