package KMLTool;
require CMONOS::CGI_Lib::Common;
@ISA = qw(Common);
use strict;
use utf8;
use Fcntl qw(:flock);
######################################################################
# 簡易KMLツール
# CMONOS::HomePageMaker::KMLTool.pm ver1.0.4
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-02-05
######################################################################
# オブジェクトを作る。
sub new ($$) {
    my ( $pkg, $this_template ) = @_;
    my $this = { 'template' => $this_template };
    bless $this;
    $env::file_mode = 0644 if !$env::file_mode;
    return $this;
}

sub mk_coordinates_from_template ($$) {
    my ( $this, $this_data ) = @_;
    if (   ref $this->{'template'}->{'field_obj'}
        && ref $this->{'template'}->{'field_for'}
        && $this->{'template'}->{'field_for'}{'coordinates'}
        && ref $this->{'template'}
        ->{'field_obj'}{ $this->{'template'}->{'field_for'}{'coordinates'} } )
    {
        if (defined
            $this_data->{ $this->{'template'}->{'field_for'}{'coordinates'} }
            {'m'}
            && $this_data->{ $this->{'template'}->{'field_for'}{'coordinates'}
            }{'m'} ne ''
            && $this_data->{ $this->{'template'}->{'field_for'}{'coordinates'}
            }{'c'} )
        {
            return (
                $this_data->{ $this->{'template'}
                        ->{'field_for'}{'coordinates'} }{'c'}
                    =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ ) ? $2 . ',' . $1 : '';
        }
        elsif (
            $this_data->{ $this->{'template'}->{'field_for'}{'coordinates'} }
            {'kml'}
            && $this_data->{ $this->{'template'}->{'field_for'}{'coordinates'}
            }{'p'} )
        {
            return (
                $this_data->{ $this->{'template'}
                        ->{'field_for'}{'coordinates'} }{'p'}
                    =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ ) ? $2 . ',' . $1 : '';
        }
        elsif (
            $this_data->{ $this->{'template'}->{'field_for'}{'coordinates'} }
            {'c'} )
        {
            return (
                $this_data->{ $this->{'template'}
                        ->{'field_for'}{'coordinates'} }{'c'}
                    =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ ) ? $2 . ',' . $1 : '';
        }
        elsif (
            $this_data->{ $this->{'template'}->{'field_for'}{'coordinates'} }
            {'str'} )
        {
            my %data
                = $this->{'template'}->{'field_obj'}
                { $this->{'template'}->{'field_for'}{'coordinates'} }
                ->elements(
                $this_data->{ $this->{'template'}
                        ->{'field_for'}{'coordinates'} }{'str'} );
            if ( defined $data{'m'} && $data{'m'} ne '' && $data{'c'} ) {
                return ( $data{'c'} =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ )
                    ? $2 . ',' . $1
                    : '';
            }
            elsif ( $data{'kml'} && $data{'p'} ) {
                return ( $data{'p'} =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ )
                    ? $2 . ',' . $1
                    : '';
            }
            elsif ( $data{'c'} ) {
                return ( $data{'c'} =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ )
                    ? $2 . ',' . $1
                    : '';
            }
        }
    }
    return '';
}

sub mk_icon_from_template ($$) {
    my ( $this, $this_data ) = @_;
    if (   ref $this->{'template'}->{'field_obj'}
        && ref $this->{'template'}->{'field_for'}
        && $this->{'template'}->{'field_for'}{'coordinates'}
        && ref $this->{'template'}
        ->{'field_obj'}{ $this->{'template'}->{'field_for'}{'coordinates'} } )
    {
        my $gmap = $this->{'template'}->{'field_for'}{'coordinates'};
        if (   defined $this_data->{$gmap}{'mk'}
            && $this_data->{$gmap}{'mk'} ne ''
            && $this_data->{$gmap}{'width'}
            && $this_data->{$gmap}{'height'} )
        {
            return {
                'href'    => $this_data->{$gmap}{'mk'},
                'width'   => $this_data->{$gmap}{'width'},
                'height'  => $this_data->{$gmap}{'height'},
                'anchorx' => $this_data->{$gmap}{'anchorx'},
                'anchory' => $this_data->{$gmap}{'anchory'},
            };
        }
        elsif (
            $this_data->{ $this->{'template'}->{'field_for'}{'coordinates'} }
            {'str'} )
        {
            my %data
                = $this->{'template'}->{'field_obj'}
                { $this->{'template'}->{'field_for'}{'coordinates'} }
                ->elements(
                $this_data->{ $this->{'template'}
                        ->{'field_for'}{'coordinates'} }{'str'} );
            if (   defined $data{'mk'}
                && $data{'mk'} ne ''
                && $data{'width'}
                && $data{'height'} )
            {
                return {
                    'href'    => $data{'mk'},
                    'width'   => $data{'width'},
                    'height'  => $data{'height'},
                    'anchorx' => $data{'anchorx'},
                    'anchory' => $data{'anchory'},
                };
            }
        }
    }
    return {};
}

sub mk_kmlurl_from_template ($$) {
    my ( $this, $this_data ) = @_;
    if (   ref $this->{'template'}->{'field_obj'}
        && ref $this->{'template'}->{'field_for'}
        && $this->{'template'}->{'field_for'}{'coordinates'}
        && ref $this->{'template'}
        ->{'field_obj'}{ $this->{'template'}->{'field_for'}{'coordinates'} } )
    {
        my $gmap = $this->{'template'}->{'field_for'}{'coordinates'};
        if (   $this->{'template'}->{'field_obj'}{$gmap}->{'showKml'}
            && $this_data->{$gmap}{'kml'} )
        {
            if ( $this_data->{$gmap}{'url'} ) {
                return $this_data->{$gmap}{'url'};
            }
            else {
                my $kml_path
                    = $default::home . '/'
                    . $main::n
                    . ( ( $main::p eq 'i' ) ? '/i'
                    : '/' . $main::p . '/' . $main::chap . '/' . $main::sect )
                    . '/'
                    . $gmap
                    . ( ( $this_data->{$gmap}{'kml'} eq 'kmz' ) ? '.kmz'
                    : '.kml' );
                return ( -f $kml_path ) ? $this->full_path($kml_path) : '';
            }
        }
    }
    return '';
}

sub mk_name_from_template ($$;$) {
    my ( $this, $this_data, $title ) = @_;
    if (   ref $this->{'template'}->{'field_obj'}
        && ref $this->{'template'}->{'field_for'}
        && $this->{'template'}->{'field_for'}{'title'}
        && ref $this->{'template'}
        ->{'field_obj'}{ $this->{'template'}->{'field_for'}{'title'} }
        && defined $this_data->{ $this->{'template'}->{'field_for'}{'title'} }
        {'str'}
        && $this_data->{ $this->{'template'}->{'field_for'}{'title'} }{'str'}
        ne '' )
    {
        return $this->detag_text(
            $this->{'template'}
                ->{'field_obj'}{ $this->{'template'}->{'field_for'}{'title'} }
                ->usual_format(
                $this_data->{ $this->{'template'}->{'field_for'}{'title'} }
                    {'str'}
                )
        );
    }
    elsif ( defined $title && $title ne '' ) {
        return $title;
    }
    else {
        return '';
    }
}

sub mk_description_from_template ($$$$;$$) {
    my ( $this, $url, $this_data, $description_template, $title ) = @_;
    $url = $this->escape($url);
    if (   ref $this->{'template'}->{'field_obj'}
        && ref $this->{'template'}->{'field_for'}
        && $this->{'template'}->{'field_for'}{'title'}
        && ref $this->{'template'}
        ->{'field_obj'}{ $this->{'template'}->{'field_for'}{'title'} }
        && defined $this_data->{ $this->{'template'}->{'field_for'}{'title'} }
        {'str'}
        && $this_data->{ $this->{'template'}->{'field_for'}{'title'} }{'str'}
        ne ''
        && $this_data->{ $this->{'template'}->{'field_for'}{'title'} }{'str'}
        !~ /^<>[#0-9a-zA-Z]+$/ )
    {
        $title = $this_data->{ $this->{'template'}->{'field_for'}{'title'} }
            {'str'};
    }
    my $name = $this->mk_name_from_template( $this_data, $title );
    if ( defined $description_template
        && $description_template
        =~ /<!--$this->{'template'}->{'field_tag_name'}(?![0-9a-zA-Z_])[^>]*-->/
        )
    {
        local $cgi::output_option = 'abs';
        local $this_data->{
            (   (          ref $this->{'template'}->{'field_obj'}
                        && ref $this->{'template'}->{'field_for'}
                        && $this->{'template'}->{'field_for'}{'title'}
                ) ? $this->{'template'}->{'field_for'}{'title'} : ''
            )
        }{'str'} = ($title) ? $title : '';
        my $description
            = $this->{'template'}
            ->replace( $description_template, $this_data, 'usual',
            $this->{'template'}->current_field_format_options );
        my $linked = 0;
        if (   ref $this->{'template'}->{'field_obj'}
            && ref $this->{'template'}->{'field_for'}
            && $this->{'template'}->{'field_for'}{'title'}
            && ref $this->{'template'}
            ->{'field_obj'}{ $this->{'template'}->{'field_for'}{'title'} }
            && defined
            $this_data->{ $this->{'template'}->{'field_for'}{'title'} }{'str'}
            && $this_data->{ $this->{'template'}->{'field_for'}{'title'} }
            {'str'} ne '' )
        {
            my $title_id = $this->{'template'}->{'field_for'}{'title'};
            $linked = 1
                if $description
                =~ s/(<!--$this->{'template'}->{'field_tag_name'}(?![0-9a-zA-Z_])[^>]*?id="$title_id"[^>]*-->.*?<!--\/$this->{'template'}->{'field_tag_name'}(?![0-9a-zA-Z_])[^>]*-->)/$this->add_link_to_titlefield($1,$url)/es;
        }
        if (   ref $this->{'template'}->{'field_obj'}
            && ref $this->{'template'}->{'field_for'} )
        {
            my ( $icon_id, %data );
            if ( $this->{'template'}->{'field_for'}{'icon'}
                && ref $this->{'template'}
                ->{'field_obj'}{ $this->{'template'}->{'field_for'}{'icon'} }
                && defined
                $this_data->{ $this->{'template'}->{'field_for'}{'icon'} }
                {'str'}
                && $this_data->{ $this->{'template'}->{'field_for'}{'icon'} }
                {'str'} ne '' )
            {
                $icon_id = $this->{'template'}->{'field_for'}{'icon'};
                %data    = $this->{'template'}->{'field_obj'}{$icon_id}
                    ->elements( $this_data->{$icon_id}{'str'} );
            }
            if (   ( !%data || !$data{'type'} )
                && $this->{'template'}->{'field_for'}{'icon2'}
                && ref $this->{'template'}
                ->{'field_obj'}{ $this->{'template'}->{'field_for'}{'icon2'} }
                && defined
                $this_data->{ $this->{'template'}->{'field_for'}{'icon2'} }
                {'str'}
                && $this_data->{ $this->{'template'}->{'field_for'}{'icon2'} }
                {'str'} ne '' )
            {
                $icon_id = $this->{'template'}->{'field_for'}{'icon2'};
                %data    = $this->{'template'}->{'field_obj'}{$icon_id}
                    ->elements( $this_data->{$icon_id}{'str'} );
            }
            if (   ( !%data || !$data{'type'} )
                && $this->{'template'}->{'field_for'}{'icon3'}
                && ref $this->{'template'}
                ->{'field_obj'}{ $this->{'template'}->{'field_for'}{'icon3'} }
                && defined
                $this_data->{ $this->{'template'}->{'field_for'}{'icon3'} }
                {'str'}
                && $this_data->{ $this->{'template'}->{'field_for'}{'icon3'} }
                {'str'} ne '' )
            {
                $icon_id = $this->{'template'}->{'field_for'}{'icon3'};
                %data    = $this->{'template'}->{'field_obj'}{$icon_id}
                    ->elements( $this_data->{$icon_id}{'str'} );
            }
            if ( $data{'type'} ) {
                $linked = 1
                    if $description
                    =~ s/(<!--$this->{'template'}->{'field_tag_name'}(?![0-9a-zA-Z_])[^>]*?id="$icon_id"[^>]*-->.*?<!--\/$this->{'template'}->{'field_tag_name'}(?![0-9a-zA-Z_])[^>]*-->)/$this->add_link_to_iconfield($1,$url,$name)/es;
            }
        }
        return ($linked)
            ? $description
            : '<p><a href="'
            . $url . '">'
            . $name
            . '</a></p>'
            . $description;
    }
    else {
        return '<a href="' . $url . '">' . $name . '</a>';
    }
}

sub add_link_to_titlefield ($$$) {
    my ( $this, $field, $url ) = @_;
    $field = '<a href="' . $url . '">' . $field . '</a>'
        unless $field
        =~ s/(<!--data-->.*?<!--\/data-->)/<a href="$url">$1<\/a>/s;
    return $field;
}

sub add_link_to_iconfield ($$$$) {
    my ( $this, $field, $url, $name ) = @_;
    $field = '<a href="' . $url . '">' . $field . '</a>'
        unless $field
        =~ s/<a(?!\w)[^>]*?>\s*(<img(?!\w)[^>]*?>)\s*<\/a>/'<a href="' . $url . '">' . $this->replace_alt_text($1,$name) . '<\/a>'/eis
        || $field
        =~ s/(<img(?!\w)[^>]*?>)/'<a href="' . $url . '">' . $this->replace_alt_text($1,$name) . '<\/a>'/eis;
    return $field;
}

sub replace_alt_text ($$$) {
    my ( $this, $img, $name ) = @_;
    $name = $this->escape($name);
    $img =~ s/\s(alt|title)="(.*?)"/ $1="$name"/sgi;
    return $img;
}

sub update ($$$$;$$) {
    my ( $this, $path, $this_kml, $this_place, $sort, $limit ) = @_;
    return 0 if !$this_place->{'link'};
    my $is_updated = 0;
    my $new_place  = '';
    my $kml        = '';
    my $gmap_field
        = (    ref $this->{'template'}->{'field_obj'}
            && ref $this->{'template'}->{'field_for'}
            && $this->{'template'}->{'field_for'}{'coordinates'}
            && ref $this->{'template'}->{'field_obj'}
            { $this->{'template'}->{'field_for'}{'coordinates'} } )
        ? $this->{'template'}
        ->{'field_obj'}{ $this->{'template'}->{'field_for'}{'coordinates'} }
        : undef;
    my $style_id
        = ( ref $gmap_field && $gmap_field->{'defaultMarker'} )
        ? 'defaultIcon'
        : 'temporaryIcon';
    local (*KML);

    if ( -f $path ) {
        if ( open( KML, $path ) ) {
            binmode KML, ":utf8";
            flock( KML, LOCK_SH );
            $kml = join( '', <KML> );
            close(KML);
        }
        else {
            return 0;
        }
    }
    if ( $this_place->{'coordinates'} && !$this_place->{'delete'} ) {
        $this_place->{'timestamp'}
            = $this->timestamp(
            ( $this_place->{'mtime'} ) ? $this_place->{'mtime'} : time )
            if !$this_place->{'timestamp'};
        my $info = '';
        $info
            .= '    <name>'
            . $this->clean_up( $this_place->{'name'}, 1 )
            . "</name>\x0A"
            if defined $this_place->{'name'} && $this_place->{'name'} ne '';
        $info
            .= '    <description><![CDATA['
            . $this->clean_up( $this_place->{'description'} )
            . "]]></description>\x0A"
            if defined $this_place->{'description'}
            && $this_place->{'description'} ne '';
        $info .= '    <atom:link href="'
            . $this->escape( $this_place->{'link'} ) . '" />' . "\x0A";
        if ( $this_place->{'url'} ) {
            $new_place .= '  <NetworkLink>' . "\x0A";
            $new_place .= $info;
            $new_place .= '    <Link>' . "\x0A";
            $new_place
                .= '      <href>'
                . $this->escape( $this_place->{'url'} )
                . '</href>' . "\x0A";
            $new_place .= '    </Link>' . "\x0A";
            $new_place .= '  </NetworkLink>' . "\x0A";
        }
        $new_place .= '  <Placemark>' . "\x0A";
        $new_place .= $info;
        if ( ref $this_place->{'icon'} && $this_place->{'icon'}{'href'} ) {
            $new_place .= '    <Style>' . "\x0A";
            $new_place .= '      <IconStyle>' . "\x0A";
            $new_place .= '        <Icon>' . "\x0A";
            $new_place
                .= '          <href>'
                . $this_place->{'icon'}->{'href'}
                . '</href>' . "\x0A";
            $new_place
                .= '          <width>'
                . $this_place->{'icon'}->{'width'}
                . '</width>' . "\x0A";
            $new_place
                .= '          <height>'
                . $this_place->{'icon'}->{'height'}
                . '</height>' . "\x0A";
            $new_place
                .= '          <anchorx>'
                . $this_place->{'icon'}->{'anchorx'}
                . '</anchorx>' . "\x0A";
            $new_place
                .= '          <anchory>'
                . $this_place->{'icon'}->{'anchory'}
                . '</anchory>' . "\x0A";
            $new_place .= '        </Icon>' . "\x0A";
            $new_place .= '      </IconStyle>' . "\x0A";
            $new_place .= '    </Style>' . "\x0A";
        }
        else {
            $new_place
                .= '    <styleUrl>#' . $style_id . '</styleUrl>' . "\x0A";
        }
        $new_place .= '    <Point>' . "\x0A";
        $new_place
            .= '      <coordinates>'
            . $this_place->{'coordinates'}
            . '</coordinates>' . "\x0A";
        $new_place .= '    </Point>' . "\x0A";
        $new_place .= '    <TimeStamp>' . "\x0A";
        $new_place
            .= '      <when>'
            . $this_place->{'timestamp'}
            . '</when>' . "\x0A";
        $new_place .= '    </TimeStamp>' . "\x0A";
        $new_place .= '  </Placemark>' . "\x0A";
    }
    if ($kml) {
        my %place_marks   = ();
        my %network_links = ();
        my %sort          = ();
        my $new_kml       = '';
        my $done          = 0;
        my $by_mtime      = ( $sort && $sort =~ s/^mtime//i ) ? 1 : 0;
        my $target_link
            = ( $this_place->{'delete'} )
            ? quotemeta( $this_place->{'link'} )
            : '';
        while ( $kml
            =~ /([\t\x20]*<(Placemark|NetworkLink)>.*?<\/\2>[\x0A\x0D]*)/sg )
        {
            my $place_mark = $1;
            my $tag        = $2;
            my $link
                = ( $place_mark
                    =~ /<atom:link(?![0-9a-zA-Z_])[^>]*[\x09\x0A\x0C\x0D\x20]+href="([^"]*?)"[^>]*\/>/
                ) ? $this->unescape($1) : 0;
            next if $this_place->{'delete'} && $link =~ /^$target_link/;
            if ( $tag eq 'NetworkLink' ) {
                if ( $sort && $limit ) {
                    $network_links{$link} = $place_mark;
                }
                elsif ( $link ne $this_place->{'link'} ) {
                    $new_kml .= $place_mark;
                }
            }
            else {
                if ( $sort && $limit ) {
                    my $sort_value;
                    if ($by_mtime) {
                        $sort_value
                            = ( $place_mark
                                =~ /<TimeStamp>[\x09\x0A\x0C\x0D\x20]*<when>[\x09\x0A\x0C\x0D\x20]*(.*?)[\x09\x0A\x0C\x0D\x20]*<\/when>[\x09\x0A\x0C\x0D\x20]*<\/TimeStamp>/
                            ) ? $1 : 0;
                    }
                    else {
                        $sort_value
                            = ( $link =~ m!([^/]+/[^/]+)$! ) ? $1 : $link;
                    }
                    $sort{$link}        = $sort_value;
                    $place_marks{$link} = $place_mark;
                }
                elsif ( $link eq $this_place->{'link'} ) {
                    $new_kml .= $new_place if !$done++;
                }
                else {
                    $new_kml .= $place_mark;
                }
            }
        }
        if ( $sort && $limit ) {
            if ( $this_place->{'coordinates'} && !$this_place->{'delete'} ) {
                $sort{ $this_place->{'link'} }
                    = ($by_mtime) ? $this_place->{'timestamp'}
                    : ( $this_place->{'link'} =~ m!([^/]+/[^/]+)$! ) ? $1
                    :   $this_place->{'link'};
                $network_links{ $this_place->{'link'} } = '';
                $place_marks{ $this_place->{'link'} }   = $new_place;
            }
            my $count   = 0;
            my %counted = ();
            $kml = '';
            foreach my $link (
                sort { $this->sort_by( \$sort{$a}, \$sort{$b}, $sort ) }
                keys %sort )
            {
                my $count_key = $link;
                $count_key =~ s![^/]+$!!;
                if ( $counted{$count_key} || $count < $limit ) {
                    $kml .= $network_links{$link} if $network_links{$link};
                    $kml .= $place_marks{$link};
                }
                $count++ if !$counted{$count_key}++;
            }
        }
        else {
            $new_kml .= $new_place
                if $this_place->{'coordinates'}
                && !$this_place->{'delete'}
                && !$done;
            $kml = $new_kml;
        }
    }
    else {
        $kml = $new_place;
    }
    if ( open( KML, ">>$path" ) ) {
        binmode KML, ":utf8";
        flock( KML, LOCK_EX );
        truncate( KML, 0 );
        seek( KML, 0, 0 );
        print KML '<?xml version="1.0" encoding="UTF-8"?>', "\x0A";
        print KML
            '<kml xmlns="http://earth.google.com/kml/2.2" xmlns:atom="http://www.w3.org/2005/Atom">',
            "\x0A";
        print KML '<Document>', "\x0A";
        print KML '  <name>'
            . $this->clean_up( $this_kml->{'name'}, 1 )
            . "</name>\x0A"
            if defined $this_kml->{'name'} && $this_kml->{'name'} ne '';
        print KML '  <description>'
            . $this->clean_up( $this_kml->{'description'}, 1 )
            . "</description>\x0A"
            if defined $this_kml->{'description'}
            && $this_kml->{'description'} ne '';

        if ($env::copyright) {
            print KML '  <atom:author>', "\x0A";
            print KML '    <atom:name>'
                . $this->clean_up( $env::copyright, 1 )
                . '</atom:name>', "\x0A";
            print KML '  </atom:author>', "\x0A";
        }
        print KML '  <atom:link href="'
            . $this->full_path($default::home)
            . '" />', "\x0A"
            if $default::home;
        if ( $style_id eq 'defaultIcon' ) {
            print KML '  <Style id="defaultIcon">', "\x0A";
            print KML '    <IconStyle>',            "\x0A";
            print KML '      <Icon>',               "\x0A";
            print KML '        <href>'
                . $gmap_field->{'defaultMarker'}
                . '</href>', "\x0A";
            print KML '        <width>'
                . $gmap_field->{'defaultMarkerWidth'}
                . '</width>', "\x0A";
            print KML '        <height>'
                . $gmap_field->{'defaultMarkerHeight'}
                . '</height>', "\x0A";
            print KML '        <anchorx>'
                . $gmap_field->{'defaultMarkerAnchorX'}
                . '</anchorx>', "\x0A";
            print KML '        <anchory>'
                . $gmap_field->{'defaultMarkerAnchorY'}
                . '</anchory>', "\x0A";
            print KML '      </Icon>',    "\x0A";
            print KML '    </IconStyle>', "\x0A";
            print KML '  </Style>',       "\x0A";
        }
        else {
            print KML '  <Style id="temporaryIcon">', "\x0A";
            print KML '    <IconStyle>',              "\x0A";
            print KML '      <Icon>',                 "\x0A";
            print KML
                '        <href>http://maps.google.com/mapfiles/ms/micons/red-dot.png</href>',
                "\x0A";
            print KML '        <width>32</width>',     "\x0A";
            print KML '        <height>32</height>',   "\x0A";
            print KML '        <anchorx>16</anchorx>', "\x0A";
            print KML '        <anchory>32</anchory>', "\x0A";
            print KML
                '        <shadow>http://maps.google.com/mapfiles/ms/micons/msmarker.shadow.png</shadow>',
                "\x0A";
            print KML '        <swidth>59</swidth>',   "\x0A";
            print KML '        <sheight>32</sheight>', "\x0A";
            print KML '      </Icon>',                 "\x0A";
            print KML '    </IconStyle>',              "\x0A";
            print KML '  </Style>',                    "\x0A";
        }
        print KML $kml;
        print KML '</Document>', "\x0A";
        print KML '</kml>',      "\x0A";
        close(KML);
        return 1;
    }
    return 0;
}

sub timestamp ($$) {
    my ( $this, $time ) = @_;
    if ( $time
        =~ /^([0-9]{4})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})$/ )
    {
        return $1 . '-' . $2 . '-' . $3 . 'T' . $4 . ':' . $5 . ':' . $6
            . 'Z';
    }
    else {
        my ( $sec, $min, $hour, $mday, $mon, $year ) = gmtime(time);
        return
              ( ( $year < 1900 ) ? $year + 1900 : $year ) . '-'
            . sprintf( "%.2d", $mon ) . '-'
            . sprintf( "%.2d", $mday ) . 'T'
            . sprintf( "%.2d", $hour ) . ':'
            . sprintf( "%.2d", $min ) . ':'
            . sprintf( "%.2d", $sec ) . 'Z';
    }
}

sub clean_up ($$;$) {
    my ( $this, $str, $detag ) = @_;
    $str =~ s/<!--[^>]*?-->//gs;
    $str
        =~ s/\&(?!(?:#[0-9]{2,6}|#x[a-fA-F0-9]+|[a-zA-Z0-9]{2,10});)/\&amp;/g;
    if ($detag) {
        $str =~ s/<(.*?)>/(($1 =~ m! alt="(.*?)"!i) ? $1 : '')/egs;
        $str =~ s/"/&quot;/g;
        $str =~ s/</&lt;/g;
        $str =~ s/>/&gt;/g;
    }
    else {
        $str
            =~ s/(<[^<>]*[\x09\x0A\x0C\x0D\x20]+(?:href|src|background|action)=["']?)(?![0-9a-zA-Z_]+:)([^"\x09\x0A\x0C\x0D\x20]+)([^<>]*>)/$1 . $this->full_path($2) . $3/seig;
        $str
            =~ s/(<param[\x09\x0A\x0C\x0D\x20]+name=["']?(?:src|movie)["']?[\x09\x0A\x0C\x0D\x20]+value=["']?)(?![0-9a-zA-Z_]+:)([^"\x09\x0A\x0C\x0D\x20]+)([^<>]*>)/$1 . $this->full_path($2) . $3/seig;
        $str
            =~ s/(<video(?![0-9a-zA-Z_])[^<>]*[\x09\x0A\x0C\x0D\x20]+preview=["']?)(?![0-9a-zA-Z_]+:)([^"\x09\x0A\x0C\x0D\x20]+)([^<>]*>)/$1 . $this->full_path($2) . $3/seig;
        $str =~ s/<script(?![0-9a-zA-Z_])[^>]*>.*?<\/script>//sig;
    }
    $str =~ s/[\x0D\x0A]+//gs;
    return $str;
}

1;
