package ArticlePage;
require CMONOS::HomePageMaker::Tools::HomePage;
@ISA = qw(HomePage);
use strict;
use utf8;
######################################################################
# 記事ページ設定モジュール
# ArticlePage.pm ver1.0.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-10-10
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    my $this = shift;

    #数字項目
    $check::num{'ChapterLimit'} = 'chapter数/1ページ'
        if !defined $check::num{'ChapterLimit'};
    $check::num{'SectionLimit'} = 'section数/1ページ'
        if !defined $check::num{'SectionLimit'};

    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'article'
        if !defined $preference::id
        || $preference::id ne 'article';    # データキー
    $preference::name = '記事ページレイアウト'
        if !defined $preference::name;      # 設定パネル名
    $preference::title
        = '記事ページのレイアウトについて設定します。'
        if !defined $preference::title;
    $preference::ssi = 1 if !$preference::ssi;    #SSIを利用可能
    $preference::static_page = 1
        if !$preference::static_page;             #HTMLファイル
}

######################################################################
# フィールド入力支援
sub field_support ($$) {
    my ( $this, $id ) = @_;
    my ($tool);
    $this->use_field( 'info',  $default::field_pref_dir . '/infofield',  2 );
    $this->use_field( 'field', $default::field_pref_dir . '/inputfield', 2 );
    if (%info::obj) {
        $tool
            = '<select class="tool" size="1" onchange="cmonos.form.item(this.form).fieldname(\''
            . $id
            . '\').quotationByMenu(this)" title="これらのタグは、対応するページ情報データに変換されます。">';
        $tool
            .= '<option value="">▼ページ情報フィールドタグを挿入する</option>';
        foreach my $n ( sort { $a <=> $b } keys %info::ORDER ) {
            my $id = $info::ORDER{$n};
            next if !ref $info::obj{$id};
            $tool
                .= '<option value="&lt;!--info id=&quot;'
                . $id
                . '&quot;--&gt;&lt;!--/info--&gt;">'
                . $id . ' : '
                . $info::obj{$id}->{'name'}
                . '</option>';
        }
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--head--&gt;&lt;!--/head--&gt;">フィールドヘッダ</option>';
        $tool
            .= '<option value="&lt;!--foot--&gt;&lt;!--/foot--&gt;">フィールドフッタ</option>';
        $tool
            .= '<option value="&lt;!--name--&gt;&lt;!--/name--&gt;">フィールド名</option>';
        $tool
            .= '<option value="&lt;!--groupname--&gt;&lt;!--/groupname--&gt;">フィールドグループ名</option>';
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--counter id=&quot;&quot;--&gt;&lt;!--/counter--&gt;">カウンター</option>';
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--if:info id=&quot;&quot;--&gt;&lt;!--else--&gt;&lt;!--/if--&gt;">id に値があるとき〜</option>';
        $tool
            .= '<option value="&lt;!--unless:info id=&quot;&quot;--&gt;&lt;!--else--&gt;&lt;!--/unless--&gt;">id に値がないとき〜</option>';
        $tool .= '</select>';
    }
    if (%field::obj) {
        $tool
            .= '<select class="tool" size="1" onchange="cmonos.form.item(this.form).fieldname(\''
            . $id
            . '\').quotationByMenu(this)" title="これらのタグは、対応するフィールドデータに変換されます。">';
        $tool
            .= '<option value="">▼入力フィールドタグを挿入する</option>';
        $tool
            .= '<option value="&lt;!--chaptertitle--&gt;&lt;!--/chaptertitle--&gt;">chapter タイトル</option>';
        $tool .= '<option value=""></option>';
        foreach my $n ( sort { $a <=> $b } keys %field::ORDER ) {
            my $id = $field::ORDER{$n};
            next if !ref $field::obj{$id};
            $tool
                .= '<option value="&lt;!--field id=&quot;'
                . $id
                . '&quot;--&gt;&lt;!--/field--&gt;">'
                . $id . ' : '
                . $field::obj{$id}->{'name'}
                . '</option>';
        }
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--head--&gt;&lt;!--/head--&gt;">フィールドヘッダ</option>';
        $tool
            .= '<option value="&lt;!--foot--&gt;&lt;!--/foot--&gt;">フィールドフッタ</option>';
        $tool
            .= '<option value="&lt;!--name--&gt;&lt;!--/name--&gt;">フィールド名</option>';
        $tool
            .= '<option value="&lt;!--groupname--&gt;&lt;!--/groupname--&gt;">フィールドグループ名</option>';
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--counter id=&quot;&quot;--&gt;&lt;!--/counter--&gt;">カウンター</option>';
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--if id=&quot;&quot;--&gt;&lt;!--else--&gt;&lt;!--/if--&gt;">id に値があるとき〜</option>';
        $tool
            .= '<option value="&lt;!--unless id=&quot;&quot;--&gt;&lt;!--else--&gt;&lt;!--/unless--&gt;">id に値がないとき〜</option>';
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--chapterindex--&gt;&lt;!--/chapterindex--&gt;">chapter インデックス</option>';
        $tool
            .= '<option value="&lt;!--chapterarticle--&gt;&lt;!--/chapterarticle--&gt;">chapter 項目</option>';
        $tool
            .= '<option value="&lt;!--chaptertitle--&gt;&lt;!--/chaptertitle--&gt;">chapter タイトル</option>';
        $tool
            .= '<option value="&lt;!--sectionindex--&gt;&lt;!--/sectionindex--&gt;">section インデックス</option>';
        $tool
            .= '<option value="&lt;!--sectionarticle--&gt;&lt;!--/sectionarticle--&gt;">section 項目</option>';
        $tool
            .= '<option value="&lt;!--sectiontitle--&gt;&lt;!--/sectiontitle--&gt;">section タイトル</option>';
        $tool
            .= '<option value="&lt;!--sectiondescription--&gt;&lt;!--/sectiondescription--&gt;">section 説明</option>';
        $tool
            .= '<option value="&lt;!--sectionmedia--&gt;&lt;!--/sectionmedia--&gt;">section メディア</option>';
        $tool
            .= '<option value="'
            . $this->jsquot( '&lt;!--chapterindex--&gt;\n'
                . '&lt;!--head--&gt;&lt;ul class=&quot;chapterindex&quot;&gt;&lt;!--/head--&gt;\n'
                . '&lt;!--chapterarticle--&gt;\n'
                . '&lt;!--head--&gt;&lt;li&gt;&lt;!--/head--&gt;\n'
                . '&lt;!--chaptertitle--&gt;&lt;!--/chaptertitle--&gt;\n'
                . '&lt;!--sectionindex--&gt;\n'
                . '&lt;!--head--&gt;&lt;ul&gt;&lt;!--/head--&gt;\n'
                . '&lt;!--sectionarticle--&gt;\n'
                . '&lt;!--head--&gt;&lt;li&gt;&lt;!--/head--&gt;\n'
                . '&lt;!--sectiontitle--&gt;&lt;!--/sectiontitle--&gt;\n'
                . '&lt;!--sectiondescription--&gt;&lt;!--/sectiondescription--&gt;\n'
                . '&lt;!--foot--&gt;&lt;/li&gt;&lt;!--/foot--&gt;\n'
                . '&lt;!--/sectionarticle--&gt;\n'
                . '&lt;!--foot--&gt;&lt;/ul&gt;&lt;!--/foot--&gt;\n'
                . '&lt;!--/sectionindex--&gt;\n'
                . '&lt;!--foot--&gt;&lt;/li&gt;&lt;!--/foot--&gt;\n'
                . '&lt;!--/chapterarticle--&gt;\n'
                . '&lt;!--foot--&gt;&lt;/ul&gt;&lt;!--/foot--&gt;\n'
                . '&lt;!--/chapterindex--&gt;\n' );
        $tool .= '">chapter インデックス例</option>';
        $tool .= '</select>';
    }
    return $tool;
}

######################################################################
# 設定追加
sub _print_sub_preference_panel ($) {
    my $this = shift;
    print
        '<fieldset><legend>chapter/section</legend><table class="field-table"><tbody><tr>';
    print
        '<td class="field-name"><label for="data:article_ChapterLimit"><span title="記事 section のセット">chapter</span> 数/1ページ</label></td>';
    print
        '<td class="q-field"><input type="number" size="3" name="data:article_ChapterLimit" id="data:article_ChapterLimit" value="'
        . ( ( defined $main::data{'article_ChapterLimit'} )
        ? $main::data{'article_ChapterLimit'}
        : '' )
        . '" title="1ページあたりの chapter 数を設定してください。" />';
    print '</td>';
    print
        '<td class="field-name"><label for="data:article_ChapterDir"><span title="記事 section のセット">chapter</span> 増設方向</label></td>';
    print '<td class="q-field">';
    print $this->mk_select_menu(
        'data:article_ChapterDir',
        'chapter の増設方向を設定してください。', '',
        $main::data{'article_ChapterDir'},
        'below' => '下方向↓',
        'above' => '上方向↑'
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:article_SectionLimit"><span title="全フィールドを含む記事要素の最小単位">section</span> 数/1 chapter</label></td>';
    print
        '<td class="q-field"><input type="number" size="3" name="data:article_SectionLimit" id="data:article_SectionLimit" value="'
        . ( ( defined $main::data{'article_SectionLimit'} )
        ? $main::data{'article_SectionLimit'}
        : '' )
        . '" title="1chapter あたりの section 数を設定してください。" />';
    print '</td>';
    print
        '<td class="field-name"><label for="data:article_SectionDir"><span title="全フィールドを含む記事要素の最小単位">section</span> 増設方向</label></td>';
    print '<td class="q-field">';
    print $this->mk_select_menu(
        'data:article_SectionDir',
        'section の増設方向を設定してください。', '',
        $main::data{'article_SectionDir'},
        'below' => '下方向↓',
        'above' => '上方向↑'
    );
    print '</td>';
    print '</tr></tbody></table></fieldset>';
}

sub set_template ($$) {
    my ( $this, $this_template ) = @_;
    $this_template->set(
        'chapter' => 'chapter',    # chapterタグ <!--chapter-->
        'section' => 'section'     # sectionタグ <!--section-->
    );
    return;
}

######################################################################
#sub import {
BEGIN {
    if ( !$default::subdivided
        || ( $default::subdivided && defined $main::c && $main::c ne '' ) )
    {
        #クラス登録
        Common::class_register( 'H010', 'ArticlePage' );

        #ツール登録
        $setting::jump_menu{'H010'} = 'ページレイアウト'
            if !defined $setting::jump_menu{'H010'}; #これがデフォルト
        $setting::sub_jump_menu{'page'}{'H010'} = '記事ページ'
            if !defined $setting::sub_jump_menu{'page'}{'H010'};
        $setting::selected_jump_menu{'H010'} = 'H010'
            if !defined $setting::selected_jump_menu{'H010'}
            ; #サブメニューがあるときメインメニューのデフォルトキー

        $preference::page{'H010'} = 'article'
            if !defined $preference::page{'H010'};
    }
}

1;
