package CategoryEditor;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# カテゴリー編集モジュール
# CategoryEditor.pm ver1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-12-12
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    my ( $newname, $newid, @folder, %subindex_order );

    use Fcntl qw(:DEFAULT);
    eval 'use ' . $env::dbm_file . ';';

    #データ削除
    if ( defined $main::a && $main::a eq 'e' ) {
        push( @main::delete, $main::delete )
            if defined $main::delete && $main::delete;
        @main::delete = grep( defined $_ && $_ ne '', @main::delete );
        if (@main::delete) {
            $this->delete_category( \@main::delete );
            foreach (@main::delete) {
                delete $main::order{$_} if defined $main::order{$_};
            }
        }
    }

    #フォルダリスト取得
    @folder = $this->get_folder;

    #書き込み
    if ( defined $main::a && $main::a eq 'e' ) {

        #新規作成
        if ( defined $main::new{'id'} && $main::new{'id'} ne '' ) {
            $main::new{'id'} = $this->z_to_h( $main::new{'id'} );
            if ($this->mk_category(
                    $main::new{'id'},   \@folder,
                    $main::new{'name'}, $main::new{'mastername'},
                    $main::new{'master'}
                )
                )
            {

                #増設通知
                if ( defined $main::notification && $main::notification ) {
                    my %installmsg;
                    $this->import_db(
                        $default::preference_dir . '/installmsg',
                        \%installmsg );
                    $installmsg{'subject'}
                        = '【お知らせ】ページを増設しました。'
                        if !defined $installmsg{'subject'}
                        || !$installmsg{'subject'};
                    $installmsg{'msg'}
                        = '○URL' . "\x0A" . '<uri>'
                        . "\x0A\x0A"
                        . '○環境設定ツールのURL' . "\x0A"
                        . '<tool>' . "\x0A"
                        if !defined $installmsg{'msg'} || !$installmsg{'msg'};
                    my $tool
                        = $this->my_url . '?m=Tools&c=' . $main::new{'id'};
                    my $uri = $this->http_my_domain
                        . $this->path_change( $default::home,
                        $ENV{'SCRIPT_NAME'}, 'abs' )
                        . '/'
                        . $main::new{'id'};
                    $installmsg{'msg'} =~ s/<(uri|url)>/$uri/igs;
                    $installmsg{'msg'} =~ s/<tool>/$tool/igs;

                    unless ( ref $cgi::SendMail ) {
                        require CMONOS::CGI_Lib::SendMail;
                        $cgi::SendMail = SendMail->new( $env::sendmail,
                            $env::master_email, '', $cgi::input, 1 );
                    }
                    $cgi::SendMail->send_mail(
                        'To' => (
                            ( $main::new{'master'} )
                            ? ( ( $main::new{'mastername'} )
                                ? $main::new{'mastername'} . ' <'
                                    . $main::new{'master'} . '>'
                                : $main::new{'master'} )
                            : $env::master_email
                        ),
                        'From' => (
                            ( $setting::general{'master'} )
                            ? ( ( $setting::general{'mastername'} )
                                ? $setting::general{'mastername'} . ' <'
                                    . $setting::general{'master'} . '>'
                                : $setting::general{'master'} )
                            : $env::master_email
                        ),
                        'Subject' => $installmsg{'subject'},
                        'message' => $installmsg{'msg'} . "\x0A\x0A"
                    );
                }
                undef %main::new;
            }
        }
        elsif (
            ( defined $main::new{'name'} && $main::new{'name'} ne '' )
            || ( defined $main::new{'mastername'}
                && $main::new{'mastername'} ne '' )
            || ( defined $main::new{'master'} && $main::new{'master'} ne '' )
            )
        {
            push(
                @{ $this->{'dialog'} },
                '新規フォルダ名を記入してください。'
            );
        }
    }

    #インデックス表示順取得
    if ( @folder && %main::order ) {
        no warnings qw(numeric uninitialized);
        my $no = 1;
        foreach (
            sort {
                       $main::order{$a} <=> $main::order{$b}
                    || $main::oldorder{$b} <=> $main::oldorder{$a}
                    || $a <=> $b
                    || $a cmp $b
            } @folder
            )
        {
            $main::order{$_} = $no++;
        }
        delete $main::order{''};
    }

    %subindex_order = $this->index_sort(
        \@folder,
        $default::home
            . '/index.'
            . ( ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html' ),
        '総合インデックス'
    );
    $this->index_sort(
        \@folder,
        $default::home . '/navi.ssi',
        '埋め込みインデックス'
    );
    $this->index_sort(
        \@folder,
        $default::external_index,
        $this->path_change(
            $default::external_index, $ENV{'SCRIPT_NAME'}, 'abs'
        )
        )
        if $default::external_index
        && !$setting::general{'externalIndexDisabled'}
        && -f $default::external_index;
    $this->index_sort(
        \@folder,
        $default::external_navi,
        $this->path_change(
            $default::external_navi, $ENV{'SCRIPT_NAME'}, 'abs'
        )
        )
        if $default::external_navi
        && !$setting::general{'externalNaviDisabled'}
        && -f $default::external_navi;
    $this->index_sort(
        \@folder,
        $default::external_navi2,
        $this->path_change(
            $default::external_navi2, $ENV{'SCRIPT_NAME'}, 'abs'
        )
        )
        if $default::external_navi2
        && !$setting::general{'externalNavi2Disabled'}
        && -f $default::external_navi2;

    #ナビゲーション更新
    if ( defined $main::a && $main::a eq 'e' ) {
        require CMONOS::CGI_Lib::NavUpdate;
        NavUpdate->new->scan->update;
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print
        '<h1 title="カテゴリーの増設や削除を行います。">カテゴリー編集</h1>';

    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'required' => \@setting::form
    );
    print '<input type="hidden" name="a" value="e" />';
    print '<fieldset><legend>カテゴリー一覧</legend>';

    #テーブル設定
    require CMONOS::CGI_Lib::Table;
    my $table = Table->new;
    $table->set(
        'tableclass' => 'tooltable',
        'trclass'    => 'odd,even',
        'class0'     => 'odd,even',
        'classF'     => 'caution',
        'style0'     => 'white-space: nowrap;text-align: center;',
        'thenabled'  => 'true'
    );

    print $table->table;

    #ヘッダ
    print $table->tr;
    print $table->td('削除');
    print $table->td('表示順');
    print $table->td('フォルダ名');
    print $table->td('カテゴリー名');
    print $table->td('管理人名');
    print $table->td('管理人アドレス');
    print $table->td('環境設定');
    print $table->_tr;

    if ( @folder && @folder > 1 ) {
        no warnings qw(numeric);
        @folder = sort {
            (          %main::order
                    && defined $main::order{$a}
                    && defined $main::order{$b}
                    && $main::order{$a} <=> $main::order{$b} )
                || $a <=> $b
                || $a cmp $b
        } @folder;
    }

    #設定項目
    my (%name);
    my $order = 0;
    foreach my $folder_name (@folder) {
        my (%setting);
        $order++;
        print $table->tr;
        tie(%setting,
            $env::dbm_file,
            $default::master_preference_dir . '/' . $folder_name . '/general',
            O_RDONLY,
            $env::dbm_mode
        );
        $name{$folder_name}
            = ( ref tied %setting && $setting{'cginame'} ne '' )
            ? $this->escape( $this->decode_utf8( $setting{'cginame'} ) )
            : $folder_name;
        print $table->td( '<input type="checkbox" name="delete" value="'
                . $folder_name
                . '" onclick="cmonos.form.field(this).checkboxConfirm(\''
                . $name{$folder_name}
                . ' に関連する全てのデータが削除されます。本当に削除しますか？\')" />'
        );
        print $table->td(
                  '<input type="hidden" name="oldorder:'
                . $folder_name
                . '" value="'
                . $order
                . '" /><input type="number" name="order:'
                . $folder_name
                . '" value="'
                . ( ( $subindex_order{$folder_name} ) ? $order : '' ) . '"'
                . (
                ( $subindex_order{$folder_name} )
                ? ''
                : ' disabled="disabled"'
                )
                . ' size="3" />'
        );
        print $table->td($folder_name);
        print $table->td( $name{$folder_name} );
        print $table->td(
            ( ref tied %setting && $setting{'mastername'} ne '' )
            ? $this->escape( $this->decode_utf8( $setting{'mastername'} ) )
            : '' );
        print $table->td( ( ref tied %setting && $setting{'master'} ne '' )
            ? $this->escape( $this->decode_utf8( $setting{'master'} ) )
            : '' );
        untie %setting;
        print $table->td( '<a href="./start.cgi?m=Tools&amp;c='
                . $folder_name
                . '" target="_blank">環境設定</a>' );
        print $table->_tr;
    }

    #新規作成
    print $table->tr;
    print $table->td('新規');
    print $table->td('');
    print $table->td( '<input type="text" name="new:id" size="10" value="'
            . $this->escape( $main::new{'id'} )
            . '" maxlength="16" />' );
    print $table->td( '<input type="text" name="new:name" size="20" value="'
            . $this->escape( $main::new{'name'} )
            . '" maxlength="30" />' );
    print $table->td(
              '<input type="text" name="new:mastername" size="20" value="'
            . $this->escape( $main::new{'mastername'} )
            . '" maxlength="20" />' );
    print $table->td(
              '<input type="email" name="new:master" size="30" value="'
            . $this->escape( $main::new{'master'} )
            . '" />' );
    print $table->td('');
    print $table->_tr;

    print $table->_table;

    print
        '<div class="hints">カテゴリーを追加するには新規フォルダ名を記入します。</div>';
    print '</fieldset>';

    #デフォルト設定選択
    print '<fieldset><legend>初期設定</legend>';
    print '<table class="field-table"><tbody>';
    if (@folder) {
        print
            '<tr><td class="field-name"><label for="import">設定のインポート</label></td>';
        print
            '<td class="field"><select name="import" id="import" title="既に存在するカテゴリーから設定を読み込みます。"><option value=""></option>';
        foreach my $f (@folder) {
            print '<option value="'
                . $f . '"'
                . ( ( $main::import && $main::import eq $f )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $name{$f}
                . '</option>';
        }
        print '</select>';
        print '</td></tr>';
    }
    print
        '<tr><td class="field-name"><label for="restore:pref">初期設定のデフォルト</label></td><td class="field">';
    $this->print_backup_menu('pref');
    print
        '</td></tr><tr><td class="field-name"><label for="restore:field">フィールド設定のデフォルト</label></td><td class="field">';
    $this->print_backup_menu('field');
    print '</td></tr></tbody></table></fieldset>';

    print
        '<fieldset class="submit"><label><input type="checkbox" name="notification" value="1" /> 新規カテゴリーの管理人にカテゴリー増設通知を送る</label> <input type="submit" value="保存" class="save" /></fieldset>';
    print '</form>';

    #ページフッタ
    $this->print_page_footer('tools');
}

sub get_folder ($) {
    my $this   = shift;
    my @folder = ();
    local (*DIR);
    if ( opendir( DIR, $default::master_preference_dir ) ) {
        no warnings qw(numeric);
        @folder
            = sort { $a <=> $b || $a cmp $b }
            grep( $_ =~ /^[0-9a-zA-Z_]+$/
                && -d "$default::master_preference_dir/$_",
            readdir(DIR) );
        closedir(DIR);
    }
    else {
        push(
            @{ $this->{'dialog'} },
            'ホームディレクトリの設定を確認してください。'
        );
    }
    return @folder;
}

sub index_sort ($$$$) {
    my ( $this, $folder, $index_path, $index_name ) = @_;
    my %subindex_order = ();
    if ( -f $index_path ) {
        my ( $separator, $separator_interval ) = ( '', '' );
        my $index_html = $this->read_file( $index_path, 1 );
        my $my_index_id
            = ( defined $default::id && $default::id ne '' )
            ? $default::id
            : 'homepage';
        my %subindex_temp;
        my $subindex_changed = 0;
        if ( $index_html
            =~ /(<!--index(?![0-9a-zA-Z_])[^>]*? id="$my_index_id"[^>]*-->.*?<!--\/index-->)/s
            )
        {
            my $my_index_html = $1;
            my $no            = 0;
            if ( $my_index_html
                =~ /<\!--separator(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/separator(?![0-9a-zA-Z_])[^>]*-->/s
                )
            {
                my $separator_option = '';
                ( $separator_option, $separator ) = ( $1, $2 );
                $separator_interval
                    = ( $separator_option
                        =~ /[\x09\x0A\x0C\x0D\x20]+interval="([0-9]+)"/si )
                    ? $1
                    : 1;
                $separator = $this->unescape($1)
                    if $separator_option
                    =~ /[\x09\x0A\x0C\x0D\x20]+value="([^"]+)"/si;
                $my_index_html
                    =~ s/<\!--separator(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/separator(?![0-9a-zA-Z_])[^>]*-->//sg;
            }
            while ( $my_index_html
                =~ /(<!--subindex(?![0-9a-zA-Z_])([^>]*)-->.*?<!--\/subindex-->)/gs
                )
            {
                my ( $subindex_setting, $subindex_id, $subindex );
                ( $subindex, $subindex_setting ) = ( $1, $2 );
                $subindex_id
                    = ( $subindex_setting
                        =~ /[\x09\x0A\x0C\x0D\x20]*id[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)"/s
                    ) ? $1 : '';
                $subindex_temp{$subindex_id}  = $subindex;
                $subindex_order{$subindex_id} = ++$no;
            }
            if (%subindex_order) {
                no warnings qw(numeric uninitialized);
                if (%main::order) {
                    my $prev_id = '';
                    foreach (
                        sort {
                            $main::order{$a} <=> $main::order{$b}
                                || $a <=> $b
                                || $a cmp $b
                        } @$folder
                        )
                    {
                        if (   $prev_id ne ''
                            && $subindex_order{$prev_id}
                            > $subindex_order{$_} )
                        {
                            $subindex_changed = 1;
                            last;
                        }
                        $prev_id = $_;
                    }
                }
                else {
                    my $no = 1;
                    foreach (
                        sort {
                            (          defined $subindex_order{$a}
                                    && defined $subindex_order{$b}
                                    && $subindex_order{$a}
                                    <=> $subindex_order{$b} )
                                || $a <=> $b
                                || $a cmp $b
                        } @$folder
                        )
                    {
                        $main::order{$_} = $no++;
                    }
                }
            }
            if ($subindex_changed) {
                my $my_subindex    = '';
                my $count          = 0;
                my $separator_done = 0;
                foreach (
                    sort {
                               $main::order{$a} <=> $main::order{$b}
                            || $a cmp $b
                    } keys %subindex_temp
                    )
                {
                    $my_subindex .= $subindex_temp{$_};
                    $count++;
                    if (   $separator_interval
                        && $count % $separator_interval == 0 )
                    {
                        $my_subindex
                            .= '<!--separator interval="'
                            . $separator_interval . '"-->'
                            . $separator
                            . '<!--/separator-->';
                        $separator_done = 1;
                    }
                }
                $my_subindex
                    .= '<!--separator interval="'
                    . $separator_interval
                    . '" value="'
                    . $this->escape($separator)
                    . '"--><!--/separator-->'
                    if !$separator_done;
                $my_index_html
                    =~ s/<!--subindex(?![0-9a-zA-Z_])[^>]*?-->.*<!--\/subindex-->/$my_subindex/gs;
                $index_html
                    =~ s/<!--index(?![0-9a-zA-Z_])[^>]*? id="$my_index_id"[^>]*-->.*?<!--\/index-->/$my_index_html/s;
                $this->write_file( $index_path, $index_html, 1 );
                push(
                    @{ $this->{'dialog'} },
                    $index_name . 'を更新しました。'
                );
            }
        }
    }
    return %subindex_order;
}

######################################################################
# カテゴリー削除
sub delete_category ($$) {
    my ( $this, $delete_ids ) = @_;
    return if !@$delete_ids;
    my ( @urls, @index_files, $index, $home_url );
    $home_url = $this->full_path($default::home);
    use File::Path;
    foreach my $cid (@$delete_ids) {
        next if !defined $cid || $cid eq '';
        if ( defined $default::home && -d "$default::home/$cid" ) {
            rmtree "$default::home/$cid";
        }
        if ( defined $default::master_preference_dir
            && -d "$default::master_preference_dir/$cid" )
        {
            rmtree "$default::master_preference_dir/$cid";
        }
        if ( defined $default::master_field_pref_dir
            && -d "$default::master_field_pref_dir/$cid" )
        {
            rmtree "$default::master_field_pref_dir/$cid";
        }
        push( @urls, $home_url . '/' . $cid );
    }
    @index_files = (
        $env::externalfiles . '/metaindex.ssi',
        $env::externalfiles . '/recentcomments.ssi',
        $env::externalfiles . '/recenttrackbacks.ssi',
        $default::home . '/navi.ssi',
        $default::home . '/recentcomments.ssi',
        $default::home . '/recenttrackbacks.ssi',
    );
    $index = $this->fileglob( $default::home,
        '^index\.(html|htm|shtml|shtm|stm)$', 'f' );
    push( @index_files, $index ) if defined $index && $index;
    push( @index_files, $default::external_index )
        if defined $default::external_index
        && $default::external_index
        && !grep( $_ eq $default::external_index, @index_files );
    push( @index_files, $default::external_navi )
        if defined $default::external_navi
        && $default::external_navi
        && !grep( $_ eq $default::external_navi, @index_files );
    push( @index_files, $default::external_navi2 )
        if defined $default::external_navi2
        && $default::external_navi2
        && !grep( $_ eq $default::external_navi2, @index_files );
    require CMONOS::CGI_Lib::IndexSweeper;
    IndexSweeper->new(
        'index_files' => \@index_files,
        'rss_files'   => [
            '../../index.xml',
            '../../comment.xml',
            '../../trackback.xml',
            '../../podcast.xml',
            $default::home . '/index.xml',
            $default::home . '/comment.xml',
            $default::home . '/trackback.xml',
            $default::home . '/podcast.xml',
        ],
        'kml_files' => [ $default::home . '/index.kml', ],
    )->sweep( \@urls, { $default::id => $delete_ids } );
    return;
}

######################################################################
# カテゴリー作成
sub mk_category ($$$$) {
    my ( $this, $id, $folder, $name, $mastername, $master ) = @_;
    return 0 if !defined $id || $id eq '';
    my ($error);
    if (   defined $master
        && $master ne ''
        && $this->is_invalid_email_address($master) )
    {
        push(
            @{ $this->{'dialog'} },
            '新しいカテゴリーの増設に失敗しました。管理人アドレスを確認してください。'
        );
        $error = 1;
    }
    if ( $id =~ /[^0-9a-zA-Z_]/ ) {
        push(
            @{ $this->{'dialog'} },
            '新しいカテゴリーの増設に失敗しました。フォルダ名は半角英数字にしてください。'
        );
        $error = 1;
    }
    if ( length $id > 32 ) {
        push(
            @{ $this->{'dialog'} },
            '新しいカテゴリーの増設に失敗しました。フォルダ名が長すぎます。'
        );
        $error = 1;
    }
    if ( grep( $_ eq $id, @$folder ) ) {
        push(
            @{ $this->{'dialog'} },
            '新しいカテゴリーの増設に失敗しました。このフォルダ名は既に使われています。'
        );
        $error = 1;
    }
    return 0 if defined $error && $error;

    #必要なディレクトリを作成
    my ( $import, $import_field, $pref, $field );
    $pref = $default::master_preference_dir . '/' . $id;
    ( $field = $default::master_field_pref_dir )
        =~ s!^$default::master_preference_dir/!$pref/!;

    $this->set_dir("$default::home/$id");
    $this->write_file( "$default::home/$id/navi.ssi", '', 1 );
    $this->set_dir($pref);
    $this->set_dir($field);
    push( @$folder, $id );

    #設定のインポートorバックアップ読み込み
    if (   defined $main::import
        && $main::import ne ''
        && $main::import !~ /[^0-9a-zA-Z_]/
        && -d $default::master_preference_dir . '/' . $main::import )
    {
        my ( $import, $import_field, $icon );
        $import = $default::master_preference_dir . '/' . $main::import;
        ( $import_field = $default::master_field_pref_dir )
            =~ s!^$default::master_preference_dir/!$import/!;
        $this->directory_copy( $import, $pref, 0,
            [ '^[\.\-]', '\.(html|htm|txt|cgi)$' ] );
        $this->directory_copy( $import_field, $field, 0,
            [ '^[\.\-]', '\.(html|htm|txt|cgi)$' ] );
        $icon = $this->fileglob( $default::home . '/' . $main::import,
            '^icon\.(gif|jpg|png)$' );
        if ( defined $icon && $icon ) {
            my ($icon_name);
            $icon_name = $1 if $icon =~ /(icon\.(gif|jpg|png)$)$/;
            $this->file_copy( $icon,
                $default::home . '/' . $id . '/' . $icon_name );
        }

    }
    else {
        $this->restore( $backup::default{'pref'},  $pref,  'bak' );
        $this->restore( $backup::default{'field'}, $field, 'bak' );
    }

    #デフォルトの設定を作成
    $this->restore( $backup::default{'pref'}, $pref, $main::restore{'pref'} );
    $this->restore( $backup::default{'field'},
        $field, $main::restore{'field'} );

    if (   ( defined $name && $name ne '' )
        || ( defined $mastername && $mastername ne '' )
        || ( defined $master && $master ne '' ) )
    {
        my (%db);
        tie(%db, $env::dbm_file,
            $pref . '/general',
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %db ) {
            $db{'cginame'}
                = ( defined $name ) ? $this->encode_utf8($name) : '';
            $db{'mastername'}
                = ( defined $mastername )
                ? $this->encode_utf8($mastername)
                : '';
            $db{'master'}
                = ( defined $master ) ? $this->encode_utf8($master) : '';
        }
        untie %db;
    }
    return 1;
}

######################################################################
# 復元メニュー
sub print_backup_menu ($$) {
    my ( $this, $key ) = @_;
    my (%bak);
    %bak = ();
    $this->get_backup_list_hash( $backup::default{$key}, \%bak )
        if defined $backup::default{$key} && $backup::default{$key};
    if ( !%bak ) {
        print '設定ファイルがありません。';
        return;
    }

    print '<select name="restore:'
        . $key
        . '" id="restore:'
        . $key
        . '" title="新規作成するカテゴリーに必要な設定を自動作成します。">';
    print '<option value=""></option>';
    print '<option value="bak"'
        . ( ( $main::restore{$key} && $main::restore{$key} eq 'bak' )
        ? ' selected="selected"'
        : '' )
        . '>'
        . $bak{'bak'}
        . '</option>'
        if $bak{'bak'};
    foreach my $ext ( sort keys %bak ) {
        next if $ext eq 'bak';
        print '<option value="', $ext, '"',
            ( ( $main::restore{$key} && $main::restore{$key} eq $ext )
            ? ' selected="selected"'
            : '' ), '>';
        print $bak{$ext};
        print '</option>';
    }

    print '</select>';
}

sub get_backup_list_hash ($$$) {
    my ( $this, $dir, $bak ) = @_;
    $this->_get_backup_list_hash( $env::default_dir . '/' . $dir, $bak )
        if $env::default_dir;
    $this->_get_backup_list_hash( $env::user_default_dir . '/' . $dir,
        $bak, 1 )
        if $env::user_default_dir;
}

sub _get_backup_list_hash ($$$;$) {
    my ( $this, $path, $bak, $user_dir ) = @_;
    my ( $db, @files );
    if ( -d $path ) {
        $db = '.*?';
    }
    else {
        ( $path, $db ) = ( $1, $2 ) if $path =~ m!^(.*)/([^/]+)$!;
        $db =~ s/\.([^\/\.]+)$//;
    }
    $path =~ s!/$!!;
    if ( opendir( DIR, $path ) ) {
        @files = grep( -f "$path/$_" && $_ !~ /^\./, readdir(DIR) );
        closedir(DIR);
        foreach my $file_name (@files) {
            if ( $file_name =~ /^$db\.bak$/ ) {
                next if defined $$bak{'bak'} && $$bak{'bak'} ne '';
                $$bak{'bak'} = '標準設定';
            }
            elsif ( $file_name =~ /^$db\.([0-9a-zA-Z_]+\.default)$/ ) {
                my $ext = ( ($user_dir) ? '~' : '' ) . $1;
                next if defined $$bak{$ext} && $$bak{$ext} ne '';
                if ( open( FILE, "$path/$file_name" ) ) {
                    binmode FILE, ":utf8";
                    $$bak{$ext} = <FILE>;
                    close(FILE);
                    chomp $$bak{$ext};
                    $$bak{$ext} .= '&lt;共有&gt;'
                        if $env::user_default_dir && !$user_dir;
                }
            }
        }
    }
}

######################################################################
# デフォルトを復元
sub restore ($$$$;@) {
    my ( $this, $bakpath, $dbpath, $ext, @db ) = @_;
    if ( $ext && $ext =~ s/^~// ) {
        $bakpath = ( $env::user_default_dir || $env::default_dir ) . '/'
            . $bakpath;
    }
    elsif ($bakpath) {
        $bakpath = $env::default_dir . '/' . $bakpath;
    }
    return
           if !defined $ext
        || ( $ext ne 'bak' && $ext !~ /^[0-9a-zA-Z_]+\.default$/ )
        || !defined $bakpath
        || !defined $dbpath
        || $ext eq ''
        || $bakpath eq ''
        || $dbpath eq '';
    if ( !@db ) {
        local (*DIR);
        return unless opendir( DIR, $bakpath );
        @db = grep( -f "$bakpath/$_" && $_ !~ /^[\.\-]/, readdir(DIR) );
        closedir(DIR);
    }
    my $user_directory   = $this->home_directory(1);
    my $home_dir_id      = ($env::home_dir_id) ? $env::home_dir_id : '';
    my $home_url         = $this->full_path( '../../', 1 );
    my $home_url_encoded = $this->url_encode($home_url);
    my $error            = 0;
    foreach (@db) {
        my ( %db, $file, $db );
        $file = $bakpath . '/' . $_;
        $db   = $dbpath . '/' . $_;
        next unless -f $file && $db =~ s/\.$ext$//;
        tie( %db, $env::dbm_file, $db, O_RDWR | O_CREAT, $env::dbm_mode );
        if ( ref tied %db ) {
            my $data = $this->read_file($file);
            if ($data) {
                while ( $data
                    =~ /([^\x09\x0A\x0D]+)\x09([^\x0A\x0D]*)[\x0A\x0D]*/sg )
                {
                    my ( $k, $v ) = ( $1, $2 );
                    $k =~ s/\&#09;/\x09/gs;
                    $k =~ s/\x0B/\x0A/gs;
                    $v =~ s/\&#09;/\x09/gs;
                    $v =~ s/\x0B/\x0A/gs;
                    $v =~ s!<home-dir-id>!$home_dir_id!gs;
                    $v =~ s/<home-url>/$home_url/gs;
                    $v =~ s/<home-url-encoded>/$home_url_encoded/gs;
                    $v =~ s!<user-directory>!$user_directory!gs;
                    utf8::encode($k) if utf8::is_utf8($k);
                    utf8::encode($v) if utf8::is_utf8($v);
                    eval '$db{$k} = $v;';
                    $error++ if defined $@ && $@;
                }
            }
        }
        untie %db;
    }
    push(
        @{ $this->{'dialog'} },
        '容量が大き過ぎる'
            . $error
            . '件の設定復元に失敗しました。'
    ) if $error;
    return;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);
    if ( $default::subdivided && ( !defined $main::c || $main::c eq '' ) ) {

        #クラス登録
        Common::class_register( '00H0', 'CategoryEditor' );

        #メニュー登録
        $setting::jump_menu{'00H0'} = 'カテゴリー編集'
            if !defined $setting::jump_menu{'00H0'};

    }
}

1;
