package EditorPage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# 記事編集ページ設定モジュール
# EditorPage.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-03-29
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    my $this = shift;
    push( @check::notag, 'infoLabel', 'mainLabel' );
    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'edit';    # データキー
    $preference::name
        = '記事編集ページレイアウト';    # 設定パネル名
    $preference::title
        = '記事編集ページのレイアウトについて設定します。';
}

######################################################################
# 設定パネル
sub print_sub_preference_panel ($;$$) {
    my ( $this, $id, $key ) = @_;
    print '<fieldset><legend>ラベル</legend>';
    print '<fieldset><legend><label for="data:' . $id
        . 'infoLabel">「ページ情報」ラベル</label></legend>';
    print '<input type="text" name="data:'
        . $id
        . 'infoLabel" id="data:'
        . $id
        . 'infoLabel" value="'
        . $this->escape( $main::data{ $key . 'infoLabel' } )
        . '" size="56" title="空欄で「ページ情報」と表示されます。" />';
    print '</fieldset>';
    print '<fieldset><legend><label for="data:' . $id
        . 'mainLabel">「本文」ラベル</label></legend>';
    print '<input type="text" name="data:'
        . $id
        . 'mainLabel" id="data:'
        . $id
        . 'mainLabel" value="'
        . $this->escape( $main::data{ $key . 'mainLabel' } )
        . '" size="56" title="空欄でページ数のみ表示されます。" />';
    print '</fieldset>';
    print '</fieldset>';
}

######################################################################
#sub import {
BEGIN {
    if ( !$default::subdivided
        || ( $default::subdivided && defined $main::c && $main::c ne '' ) )
    {

        #クラス登録
        Common::class_register( 'H020', 'EditorPage' );

        #ツール登録
        $setting::sub_jump_menu{'page'}{'H020'} = '記事編集ページ';
        $setting::selected_jump_menu{'H020'} = 'H010'
            ; #サブメニューがあるときメインメニューのデフォルトキー

        $preference::page{'H020'} = 'edit';
    }
}

1;
