package InstallMsg;
require CMONOS::CGI_Lib::Tools::Preference;
@ISA = qw(Preference);
use strict;
use utf8;
######################################################################
# カテゴリー増設通知設定モジュール
# InstallMsg.pm ver1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定環境
sub set_preferences ($) {
    my $this = shift;
    $preference::db = 'installmsg';    # 記録用データベース名
    $preference::name
        = 'カテゴリー増設通知設定';    # 設定パネル名
    $preference::title
        = 'カテゴリーを増設した際、管理人に通知するメールの設定をします。';
}

######################################################################
# 設定パネル
sub print_preference_panel ($) {
    my $this = shift;

    print
        '<fieldset><legend>カテゴリー増設通知メール設定 <span class="note">(カテゴリーを増設した際、管理人に通知するメールの内容を設定します)</span></legend>';
    print '<table class="field-table"><tbody>';
    print
        '<tr><td class="field-name"><label for="data:subject">メールタイトル</label></td>';
    print
        '<td class="field"><input type="text" name="data:subject" id="data:subject" size="72" value="'
        . $this->escape( $main::data{'subject'} )
        . '" title="カテゴリーを増設した際、管理人に通知するメールの表題を設定します。" />';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:msg">通知内容</label></td>';
    print
        '<td class="field"><textarea name="data:msg" id="data:msg" cols="72" rows="15" wrap="soft">'
        . $this->escape( $main::data{'msg'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:msg\').quotationByMenu(this)" title="これらのタグは通知メール送信時に対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print
        '<option value="&lt;uri&gt;">&lt;uri&gt;[増設したページの URL]</option>';
    print
        '<option value="&lt;tool&gt;">&lt;tool&gt;[増設したページの環境設定ツールの URL]</option>';
    print '</select>';
    print '</div>';
    print '</td></tr>';
    print '</tbody></table>';
    print '</fieldset>';

    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>';
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ( $default::subdivided && ( !defined $main::c || $main::c eq '' ) ) {

        #クラス登録
        Common::class_register( '00H1', 'InstallMsg' );

        #ツール登録
        $setting::jump_menu{'00H1'} = 'カテゴリー増設通知設定';
    }
}

1;
