package GeneralSetting;
require CMONOS::CGI_Lib::Tools::General;
@ISA = qw(General);
use strict;
use utf8;
######################################################################
# 一般設定モジュール
# GeneralSetting.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-02-09
######################################################################
# 設定チェック項目取得
sub get_sub_setting_items ($) {
    my $this = shift;
    $check::num{'rewindable'} = '更新の保存数';
    push( @check::checkbox, 'siteRSSEnabled', 'rssChecked' );
    push( @check::notag, 'description' );
    $check::imagefile{'og'} = 'og:image';
    $check::ogimage{'og'}   = 1;
    return;
}

######################################################################
# 設定環境2
sub is_database_cgi ($) {
    my $this = shift;
    return 1;
}

sub sub_set_preferences ($) {
    my $this = shift;
    $cgi::enctype_multipart = 1;
    $default::file = '.' if !defined $default::file || $default::file eq '';
    $preference::filedir{'og'}
        = $default::file;    #画像保存ディレクトリ
}

######################################################################
# サブ設定パネル
sub print_sub_preference_panel ($$) {
    my ( $this, $master ) = @_;
    print '<fieldset><legend>メタデータ</legend>';
    print '<fieldset><legend>og:image</legend>';
    $this->print_image_upload_form( 'og', 'og', \%main::data );
    print '</fieldset>';
    print
        '<fieldset><legend><label for="data:description">説明</label></legend>';
    print
        '<textarea name="data:description" id="data:description" cols="56" rows="6" wrap="soft" title="メタデータに埋め込む説明を設定します。">'
        . ( ( defined $main::data{'description'} )
        ? $main::data{'description'}
        : '' )
        . '</textarea>';
    print
        '<div class="note">メタデータに埋め込む説明を設定します。</div></fieldset>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>標準日付書式</legend>';
    $this->print_date_type_menu( 'data:', $main::data{'datetype'},
        '日付の標準書式を設定します。' );
    print '</fieldset>';

    print '<fieldset><legend>最初に表示する chapter</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="data:getNewChapter" value="1"'
        . ( ( $main::data{'getNewChapter'} ) ? ' checked="checked"' : '' )
        . ' /> 新規 chapter を最初に表示する</label></li>';
    print '<li><label><input type="radio" name="data:getNewChapter" value="0"'
        . ( ( !$main::data{'getNewChapter'} ) ? ' checked="checked"' : '' )
        . ' /> 最後の chapter を最初に表示する</label></li>';
    print '</ol>';
    print '</fieldset>';
    print '<fieldset><legend>最初に表示する section</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="data:getNewSection" value="1"'
        . ( ( $main::data{'getNewSection'} ) ? ' checked="checked"' : '' )
        . ' /> 新規 section を最初に表示する</label></li>';
    print '<li><label><input type="radio" name="data:getNewSection" value="0"'
        . ( ( !$main::data{'getNewSection'} ) ? ' checked="checked"' : '' )
        . ' /> 最後の section を最初に表示する</label></li>';
    print '</ol>';
    print '</fieldset>';

    print '<fieldset><legend>更新の保存</legend>';
    print
        '<label>過去の更新を<input type="number" size="3" maxlength="3" name="data:rewindable" value="'
        . $this->escape( $main::data{'rewindable'} )
        . '" /> 件まで自動保存する。</label>';
    print '</fieldset>';

    #RSS更新設定
    print '<fieldset><legend>RSS更新設定</legend>';
    print '<fieldset><legend>更新するRSS</legend>';
    print '<label><input type="checkbox" name="data:siteRSSEnabled" value="1"'
        . ( ( $main::data{'siteRSSEnabled'} ) ? ' checked="checked"' : '' )
        . ' /> '
        . ( ( -f '../../index.xml' )
        ? '<a href="../../index.xml" target="_blank">サイト全体の新着情報(RSS)</a>'
        : 'サイト全体の新着情報(RSS)' )
        . 'を更新する</label>';
    print '</fieldset>';
    print '<fieldset><legend>デフォルトの状態</legend>';
    print '<label><input type="checkbox" name="data:rssChecked" value="1"'
        . ( ( $main::data{'rssChecked'} ) ? ' checked="checked"' : '' )
        . ' /> デフォルトで RSS を更新する(RSS 更新チェックボックスがチェック済み)</label>';
    print '</fieldset>';
    print '</fieldset>';
    return;
}

######################################################################
# サブ設定チェック
sub _is_valid_setting ($) {
    my $this = shift;
    if ( $setting::general{'siteRSSEnabled'}
        && !$main::data{'siteRSSEnabled'} )
    {
        require CMONOS::CGI_Lib::IndexSweeper;
        IndexSweeper->new( 'rss_files' => ['../../index.xml'], )
            ->sweep( [ $this->full_path($default::home) ] );
    }
    return;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( '0000', 'GeneralSetting' );

    #ツール登録
    $setting::jump_menu{'0000'} = '一般設定';
}

1;
