package SiteMapPage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# サイトマップページ設定モジュール
# SiteMapPage.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-12-20
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    my $this = shift;
    push( @check::checkbox, 'descriptionEnabled' );
    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    no warnings qw(once);
    my $this = shift;
    $preference::id = 'sitemap';    # データキー
    $preference::name
        = 'サイトマップページレイアウト';   # 設定パネル名
    $preference::title
        = 'サイトマップページのレイアウトについて設定します。';
    $preference::ssi = 1;
}

######################################################################
# 設定パネル
sub print_sub_preference_panel ($;$$) {
    my ( $this, $id, $key ) = @_;
    require CMONOS::CGI_Lib::Template;
    my $this_template = Template->new;

    #入力支援ツール
    my $tool
        = '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:sitemap_template\').quotationByMenu(this)" title="これらのタグは、書き出し時に適切な表示に変換されます。">';
    $tool .= '<option value="">▼特殊タグを挿入する</option>';
    $tool
        .= '<option value="&lt;!--sitemap--&gt;&lt;!--/sitemap--&gt;">サイトマップ &lt;!--sitemap--&gt;&lt;!--/sitemap--&gt;</option>';
    $tool .= '</select>';
    $this_template->print_template_form( 'data:sitemap_template',
        'テンプレート', \$main::data{'sitemap_template'}, \$tool );

    print '<fieldset><legend>説明</legend>';
    print
        '<label><input type="checkbox" name="data:sitemap_descriptionEnabled" value="1"'
        . ( ( $main::data{'sitemap_descriptionEnabled'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 説明を付記する。</label>';
    print '</textarea>';
    print '</fieldset>';
}

#他の設定のインポート
sub print_import_menu ($) {
    my $this = shift;
    my $xfile_path
        = $this->path_change( $env::externalfiles, $ENV{'SCRIPT_NAME'},
        'abs' );
    print '</form><form action="#">';
    print '<fieldset><legend>サイトマップ URL</legend>';
    print '<textarea id="sitemap-url" rows="2" cols="96" wrap="off">';
    print $this->http_my_domain
        . $this->path_change( $default::sitemap_path
            || '../../sitemap.'
            . ( ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html' ) );
    print '</textarea>';
    print '</fieldset>';
    print
        '<fieldset><legend>サイトマップ埋め込みタグ (SSI)</legend>';
    print '<textarea id="tag-sample" rows="2" cols="96" wrap="off">';
    print '&lt;!--#include virtual=&quot;'
        . $this->escape($xfile_path)
        . '/site-map.ssi&quot;--&gt;';
    print '</textarea>';
    print '</fieldset>';
    print
        '<fieldset><legend>サイトマップ埋め込みタグ (JavaScript)</legend>';
    print '<textarea id="tag-sample-js" rows="2" cols="96" wrap="off">';
    print
        '&lt;script type=&quot;text/javascript&quot; language=&quot;JavaScript&quot; src=&quot;'
        . $this->http_my_domain
        . $xfile_path
        . '/site-map.js&quot;&gt;&lt;/script&gt;';
    print '</textarea>';
    print '</fieldset>';
    print '</form>';
}

######################################################################
# 後処理
sub update_settings ($) {
    my $this = shift;

    #ナビメーカーに CGI の名前を登録する
    my $navi_db = $default::preference_dir;
    if ( $navi_db =~ s![0-9a-zA-Z_]+$!navimaker/navi_db! ) {
        my ( %navi, $update );
        use Fcntl qw(:DEFAULT);
        eval 'use ' . $env::dbm_file . ';';
        tie( %navi, $env::dbm_file, $navi_db, O_RDWR, $env::dbm_mode );
        if ( ref tied %navi ) {
            my $k = 'navimakerSiteMap_title';
            utf8::encode($k) if utf8::is_utf8($k);
            if ( defined $navi{$k} ) {
                my $title
                    = $main::data{'sitemap_title'} || 'サイトマップ';
                if ( $this->decode_utf8( $navi{$k} ) ne $title ) {
                    $navi{$k} = $this->encode_utf8($title);
                    $update = 1;
                }
            }
        }
        untie %navi;
        require CMONOS::CGI_Lib::NavUpdate;
        NavUpdate->new->update;
    }

}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 'n002', 'SiteMapPage' );

    #ツール登録
    $setting::jump_menu{'n000'}
        = 'ページレイアウト';    #これがデフォルト
    $setting::sub_jump_menu{'page'}{'n002'} = 'サイトマップページ';
    $setting::selected_jump_menu{'n002'} = 'n000'
        ; #サブメニューがあるときメインメニューのデフォルトキー

}

1;
