package TabLib;
require CMONOS::CGI_Lib::Tools::ButtonLib;
@ISA = qw(ButtonLib);
use strict;
use utf8;
######################################################################
# タブ画像ライブラリ編集モジュール
# TabLib.pm ver1.0.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-10-04
######################################################################
# メニュー
sub menu ($$;$$$) {
    my ( $this, $name, $lib_dir, $id, $list ) = @_;
    return $this->{'deco_obj'}
        ->tab_menu( $name, $main::dir, $id, 1, $list, $lib_dir );
}

######################################################################
# 素材ライブラリCSSチェック
sub image_css_is_ready ($$$$) {
    my ( $this, $image_lib, $dir, $setting ) = @_;
    return 1;
}

sub make_image_css ($$$;$$) {
    my ( $this, $image_dir, $dir, $is_image_lib, $setting ) = @_;
    return '';
}

######################################################################
# 画像設定登録
sub set_image ($) {
    my $this = shift;
    if (   defined $main::setting{'color'}
        && $main::setting{'color'} ne ''
        && $this->is_invalid_color( $main::setting{'color'} ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '文字色設定を確認してください。'
        ) if ref $cgi::action;
        delete $main::setting{'color'};
    }
    elsif ( defined $main::setting{'color'} ) {
        $setting::deco{$main::dir}{$main::id}{'color'}
            = $main::setting{'color'};
    }
    (   $setting::deco{$main::dir}{$main::id}{'left'},
        $setting::deco{$main::dir}{$main::id}{'right'},
        $setting::deco{$main::dir}{$main::id}{'padding'}
    ) = $this->{'deco_obj'}->tab_info( $main::dir, $main::id );
    $setting::deco{$main::dir}{$main::id}{'left'} = ''
        if !defined $setting::deco{$main::dir}{$main::id}{'left'};
    $setting::deco{$main::dir}{$main::id}{'right'} = ''
        if !defined $setting::deco{$main::dir}{$main::id}{'right'};
    $setting::deco{$main::dir}{$main::id}{'padding'} = ''
        if !defined $setting::deco{$main::dir}{$main::id}{'padding'};
    $setting::deco{$main::dir}{$main::id}{'color'} = ''
        if !defined $setting::deco{$main::dir}{$main::id}{'color'};
    $this->set_deco( $main::dir, $main::id,
        $setting::deco{$main::dir}{$main::id} );
    return;
}

######################################################################
# 設定フォーム
sub print_setting_form ($) {
    my $this = shift;
    print
        '<fieldset><legend><label for="setting:color">文字色</label></legend>';
    print
        '<input name="setting:color" id="setting:color" type="text" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'setting:color\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" value="'
        . $this->escape(
        $this->{'deco_obj'}{'setting'}{$main::dir}{$main::id}{'color'} )
        . '" style="background-color: '
        . $this->escape(
        $this->{'deco_obj'}{'setting'}{$main::dir}{$main::id}{'color'} )
        . '" />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'setting:color\')" ondblclick="cmonos.tool.colorPalette.open(\'setting:color\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'setting:color\')" ondblclick="cmonos.tool.colorSlider.open(\'setting:color\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a>';
    print ' <input type="submit" value="設定を保存" />'
        if defined $main::id && $main::id ne '';
    print '</fieldset>';
    return;
}

######################################################################
# 画像の保存
sub save_images ($) {
    my $this = shift;
    return 0
        if !ref $cgi::input
        || $cgi::Image->is_not_web_image( $cgi::input, '', '', '', 1 );
    if ( !defined $main::image{'left'} || $main::image{'left'} eq '' ) {
        push(
            @{ $cgi::action->{'dialog'} },
            'タブ左辺画像がありません。'
        ) if ref $cgi::action;
        return 0;
    }
    if ( !defined $main::image{'right'} || $main::image{'right'} eq '' ) {
        push(
            @{ $cgi::action->{'dialog'} },
            'タブ右辺画像がありません。'
        ) if ref $cgi::action;
        return 0;
    }

    #古い画像の削除
    $this->unlink_my_files;

    #保存
    my $image;
    foreach $image ( 'left', 'right' ) {
        $cgi::input->save_file(
            'image:' . $image,
            '!' . $image,
            [   'image/gif:gif',   'image/jpeg:jpg',
                'image/pjpeg:jpg', 'image/x-png:png',
                'image/png:png'
            ],
            1000000,
            "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id",
        );
    }
    $cgi::input->clear_clipboard;
    push( @{ $cgi::action->{'dialog'} }, $cgi::input->dialog )
        if ref $cgi::action;
    return 1;
}

sub unlink_my_files ($) {
    my $this = shift;
    $this->unlink_image_files( 'left', 'right' );
}

######################################################################
# アップロードフォーム
sub print_upload_form ($$) {
    my ( $this, $save_button ) = @_;
    print <<FORM;
<fieldset>
<legend>オリジナル画像</legend>
<table class="field-table">
<tbody>
<tr>
<td class="field-name"><label for="image:left">タブ左辺</label></td>
<td class="field"><input type="file" id="image:left" name="image:left" /></td>
</tr>
<tr>
<td class="field-name"><label for="image:right">タブ右辺</label></td>
<td class="field"><input type="file" id="image:right" name="image:right" /></td>
</tr>
</tbody>
</table>
<div class="submit"><input type="submit" value="$save_button" /></div>
</fieldset>
FORM
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    no warnings qw(once);
    $ImageLib::modules{'tab'} = 'TabLib';
}

1;
