package ThanksPage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# 送信お礼ページ設定モジュール
# ThanksPage.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-04-17
######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'thanks';    # データキー
    $preference::name
        = '送信お礼ページレイアウト';    # 設定パネル名
    $preference::title
        = '送信お礼ページのレイアウトについて設定します。';
}

######################################################################
# 設定パネル
sub print_sub_preference_panel ($$$) {
    my ( $this, $id, $key ) = @_;
    $this->use_field( 'field', $default::field_pref_dir . '/inquiryfield',
        2 );
    print
        '<fieldset><legend><label for="data:thanks_thanks">送信お礼本文</label></legend>';
    print
        '<textarea name="data:thanks_thanks" id="data:thanks_thanks" cols="72" rows="15">'
        . $this->escape( $main::data{'thanks_thanks'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:thanks_thanks\').quotationByMenu(this)" title="これらのタグはお礼表示時に対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print
        '<option value="&lt;name&gt;">&lt;name&gt;[差出人名フィールド'
        . ( ( $field::for{'name'} && ref $field::obj{ $field::for{'name'} } )
        ? '（' . $field::obj{ $field::for{'name'} }->name . '）'
        : '' )
        . 'の値]</option>';
    print
        '<option value="&lt;data&gt;">&lt;data&gt;[入力されたデータの一覧]</option>';
    print
        '<option value="&lt;number&gt;">&lt;number&gt;[通し番号]</option>';
    print '</select>';
    print '</div>';
    print
        '<div class="additional-field"><label for="data:thanks_defaultname">&lt;name&gt; のデフォルト</label><input type="text" name="data:thanks_defaultname" id="data:thanks_defaultname" size="20" value="'
        . $this->escape( $main::data{'thanks_defaultname'} )
        . '" /></div>';
    print '</fieldset>';
}

######################################################################
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( 'q002', 'ThanksPage' );

    #ツール登録
    $setting::sub_jump_menu{'page'}{'q002'} = '送信お礼ページ';
    $setting::selected_jump_menu{'q002'} = 'q000'
        ; #サブメニューがあるときメインメニューのデフォルトキー

    $preference::page{'q002'} = 'thanks';
}

1;
