package RegisterExport;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# 登録情報書き出しモジュール
# RegisterExport.pm ver1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-05-17
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    $this->print_dialog( 'pswd',
        '設定エラー！ : パスワード管理データベースディレクトリのパスが設定されていません。'
    ) if !$this->use_register;
    push( @main::delete, $main::delete )
        if defined $main::delete && $main::delete;

    #書き出し
    if ( defined $main::a && $main::a eq 'w' ) {
        my ( $db_path, $r, $title, %db, $k );
        if ( $main::target eq 'baduser' ) {
            $title   = 'BAD ADDRESS';
            $db_path = $env::register_db . '/baduser';
        }
        else {
            $title   = 'REGISTER';
            $db_path = $env::register_db . '/users';
        }
        binmode STDOUT;
        if ($main::for_excel) {
            $this->print_http_header('application/vnd.ms-excel');
        }
        else {
            #$this->print_http_header('text/comma-separated-values');
            $this->print_http_header('application/csv');
        }

        $r = $ENV{'HTTP_USER_AGENT'};
        if ( $r =~ /win/i ) {
            $r = "\x0D\x0A";
        }
        elsif ( $r =~ /mac/i ) {
            $r = "\x0D";
        }
        else {
            $r = "\x0A";
        }

        print $this->jcode_convert( $title, 'sjis', 'utf8' ) . $r . $r;

        use Fcntl qw(:DEFAULT);
        eval 'use ' . $env::dbm_file . ';';
        tie( %db, $env::dbm_file, $db_path, O_RDONLY, $env::dbm_mode );
        while ( ($k) = each %db ) {
            print $this->jcode_convert( $k, 'sjis', 'utf8' );
            print ',';
            print $r;
        }
        untie %db;
        return;
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    my $filename = $default::id || 'exported';
    $filename =~ s/_pswd$/_register/;
    $filename =~ s/^_//;

    print '<h1>登録情報書き出し</h1>';
    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'path'     => '/.dl/' . $filename . '_user.csv',
        'required' => \@setting::form
    );
    print '<input type="hidden" name="a" value="w" />';

    print '<fieldset class="submit">';
    print '<label for="target" class="datatitle">書き出し対象</label>';
    print
        '<select name="target" onchange="cmonos.form.item(this.form).field(this).appendDownloadPathByValue({\'pswd\':\''
        . $filename
        . '_user.csv\',\'baduser\':\''
        . $filename
        . '_baduser.csv\'})">';
    print '<option value="pswd">登録者</option>';
    print '<option value="baduser">登録制限対象者</option>';
    print '</select>';
    print ' <input type="submit" value="書き出し" />';
    print ' <label><input type="checkbox" name="for_excel" value="1"'
        . ( ($main::for_excel) ? ' checked="checked"' : '' )
        . ' /> Excel ファイルとして書き出す</label>';
    print '</fieldset></form>';

    #ページフッタ
    $this->print_page_footer('tools');

}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 'r212', 'RegisterExport' );

    #メニュー登録
    $setting::jump_menu{'r212'} = '登録情報書き出し';
}

1;
