package RegisterImport;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
no warnings qw(once);
######################################################################
# 登録情報読み込みモジュール
# RegisterImport.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-12-10
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    $this->print_dialog( 'pswd',
        '設定エラー！ : パスワード管理データベースディレクトリのパスが設定されていません。'
    ) if !$this->use_register;

    use Fcntl qw(:DEFAULT);
    my ( %setting, %pref );
    tie( %pref, $env::dbm_file, $cgi::Register->{'dbm_path'} . '/preference',
        O_RDONLY, $env::dbm_mode );
    if ( ref tied %pref ) {
        $setting{'mail'}{'subject'}
            = $cgi::Register->decode_utf8( $pref{'mail_subject'} )
            if $pref{'mail_subject'};
        $setting{'mail'}{'message'}
            = $cgi::Register->decode_utf8( $pref{'mail_msg'} )
            if $pref{'mail_msg'};
        $setting{'batchmail'}{'subject'}
            = $cgi::Register->decode_utf8( $pref{'batchmail_subject'} )
            if $pref{'batchmail_subject'};
        $setting{'batchmail'}{'message'}
            = $cgi::Register->decode_utf8( $pref{'batchmail_msg'} )
            if $pref{'batchmail_msg'};
        $setting{'batchmail2'}{'subject'}
            = $cgi::Register->decode_utf8( $pref{'batchmail2_subject'} )
            if $pref{'batchmail2_subject'};
        $setting{'batchmail2'}{'message'}
            = $cgi::Register->decode_utf8( $pref{'batchmail2_msg'} )
            if $pref{'batchmail2_msg'};
    }
    untie %pref;
    $main::mailtype
        = ( ref $setting{'batchmail'} ) ? 'batchmail'
        : ( ref $setting{'batchmail2'} ) ? 'batchmail2'
        : 'mail'
        if !$main::mailtype
        || !grep( $main::mailtype eq $_, 'mail', 'batchmail', 'batchmail2' );

    #書き出し
    if ( defined $main::a && $main::a eq 'pswd' ) {
        my ($pcount,  $allcount, $skip, $subject,
            $message, @bad_addr, @address
        );
        ( $subject, $message ) = (
            $setting{$main::mailtype}{'subject'},
            $setting{$main::mailtype}{'message'}
        ) if ref $setting{$main::mailtype};
        @address = $this->get_address( $main::addr,
            $cgi::input->get_posted_file_data('file') );
        $main::addr = '';
        $pcount = $allcount = $skip = 0;
        $cgi::Register->gc( $setting::general{'pswdExpired'}, 1 );
        foreach my $addr (@address) {
            $allcount++;
            if ( $main::skip && $cgi::Register->exist($addr) ) {
                $skip++;
            }
            elsif ( $cgi::Register->register( $addr, $subject, $message ) ) {
                $pcount++;
            }
            else {
                $main::addr .= ',' . "\x0A"
                    if defined $main::addr && $main::addr;
                $main::addr .= $addr;
            }
        }
        push(
            @{ $this->{'dialog'} },
            $allcount
                . ' 件中 '
                . $pcount
                . ' 件のメールアドレスを一括登録しました。'
                . (
                ($skip)
                ? $skip . ' 件は既に登録されています。'
                : ''
                )
        );
        $cgi::input->clear_clipboard;
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print '<h1>メールアドレス一括登録</h1>';
    print
        '<div class="hints">読み込みファイルと書き込まれたメールアドレスの両方を一括登録します。</div>';

    print $this->form_start(
        'key'    => 'tools',
        'name'   => 'input',
        'method' => 'post',
        'multi'  => 1,
        'onsubmit' =>
            'return confirm(\'この操作は取り消せません。本当に一括登録しますか？\') &amp;&amp; cmonos.form.item(this).isNotSubmitted()',
        'required' => \@setting::form
    );
    print '<input type="hidden" name="a" value="pswd" />';

    print
        '<fieldset><legend><label for="file">ファイル読み込み</label></legend>';
    print '<input type="file" name="file" id="file" />';
    print '</fieldset>';

    print
        '<fieldset><legend><label for="addr">メールアドレス</label></legend>';
    print '<textarea name="addr" id="addr" cols="50" rows="20">'
        . $this->escape($main::addr)
        . '</textarea>';
    print
        ' <label class="auto-fit" title="高さを内容に合わせる"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'addr\').setAutoFit(this.checked);" />フィット</label>';
    print
        '<div class="hints">メールアドレスごとに改行します。</div>';
    print '</fieldset>';

    if ( keys %setting > 1 ) {
        print
            '<fieldset><legend><label for="mailtype">メールテンプレート</label></legend>';
        print $this->mk_select_menu(
            'mailtype',
            '', '',
            $main::mailtype,
            (   ( ref $setting{'mail'} )
                ? ( 'mail' => 'デフォルト'
                        . (
                        ( $setting{'mail'}{'subject'} )
                        ? ':' . $setting{'mail'}{'subject'}
                        : ''
                        )
                    )
                : ()
            ),
            (   ( ref $setting{'batchmail'} )
                ? ( 'batchmail' => '一括登録用'
                        . (
                        ( $setting{'batchmail'}{'subject'} )
                        ? ':' . $setting{'batchmail'}{'subject'}
                        : ''
                        )
                    )
                : ()
            ),
            (   ( ref $setting{'batchmail2'} )
                ? ( 'batchmail2' => '予備の一括登録用'
                        . (
                        ( $setting{'batchmail2'}{'subject'} )
                        ? ':' . $setting{'batchmail2'}{'subject'}
                        : ''
                        )
                    )
                : ()
            ),
        );
        print '</fieldset>';
    }

    print
        '<fieldset class="submit"><label><input type="checkbox" name="skip" value="1" checked="checked" /> 登録済みメールアドレスをスキップする</label> ';
    print '<input type="submit" value="一括登録" />';
    print '</fieldset></form>';

    #ページフッタ
    $this->print_page_footer('tools');

}

######################################################################
# クラス登録
#sub import {
BEGIN {

    #クラス登録
    Common::class_register( 'r211', 'RegisterImport' );

    #メニュー登録
    $setting::jump_menu{'r211'} = 'メールアドレス一括登録';
}

1;
