package DetailViewer;
require CMONOS::TableMaker::TMCommon;
@ISA = qw(TMCommon);
use strict;
use utf8;
######################################################################
# 詳細ビューワモジュール
# DetailViewer.pm ver1.2.7
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-06-27
######################################################################
# メイン
sub run ($) {
    my $this = shift;
    use Fcntl qw(:DEFAULT);
    eval 'use ' . $env::dbm_file . ';';

    #---------------------------------------------------------------------
    #ダイレクト
    if ((      !defined $main::c
            || $main::c eq ''
            || !defined $main::n
            || $main::n eq ''
        )
        && $main::email
        && $setting::general{'oneEmailToOneRecord'}
        && $field::for{'mail'}
        )
    {
        ( $main::c, $main::n )
            = $this->get_category_and_number_from_permanent_id(
            $this->email_to_id($main::email) );
    }
    elsif ( defined $main::record_id && $main::record_id ) {
        ( $main::c, $main::n )
            = $this->get_category_and_number_from_permanent_id(
            $main::record_id);
    }
    else {
        my ( $c, $n )
            = $this->get_category_and_number_from_permanent_id($main::n);
        ( $main::c, $main::n ) = ( $c, $n ) if $c && $n;
    }

    #特殊フィールド用の条件から元の条件を復元
    if ( !$main::c ) {
        $main::c = (@main::c) ? $main::c[0] : (@main::ct) ? $main::ct[0] : '';
        undef @main::c;
    }
    if ( !@main::ct && $main::ct ) {
        @main::ct = ($main::ct);
        undef $main::ct;
    }
    push( @main::ct, $main::c ) if !@main::ct && defined $main::c;

    #---------------------------------------------------------------------
    #要求チェック
    if (   $this->is_nan($main::c)
        || $this->is_nan($main::n)
        || !-d "$default::db/$main::c" )
    {
        $this->print_dialog( $setting::key,
            '<form action="./start.cgi"><input type="hidden" name="m" value="DetailViewer" /><input type="text" size="8" name="record_id" value="'
                . $this->escape($main::record_id)
                . '" /><input type="submit" value="接続" /></form>' );
    }
    my ( %mtime, $mtime );
    tie( %mtime, $env::dbm_file, "$default::db/$main::c/mtime",
        O_RDWR | O_CREAT,
        $env::dbm_mode );
    if ( ref tied %mtime ) {
        $mtime = $this->decode_utf8( $mtime{ $this->encode_utf8($main::n) } )
            if defined $mtime{ $this->encode_utf8($main::n) }
            && $mtime{ $this->encode_utf8($main::n) };
    }
    untie %mtime;
    if ( !$mtime ) {
        $this->print_dialog( $setting::key,
            '<form action="./start.cgi"><input type="hidden" name="m" value="DetailViewer" /><input type="text" size="8" name="record_id" value="'
                . $this->escape($main::record_id)
                . '" /><input type="submit" value="接続" /></form>' );
    }
    undef %mtime;

    #ファイル格納ディレクトリ
    my $path = "$default::file/$main::c/$main::n";

    #---------------------------------------------------------------------
    #以前の状態を復元するための準備
    my ($archives_dir);
    if ($main::ver) {
        $main::ver =~ s/[^0-9]//g;
        if (   !$main::ver
            || !
            -d "$default::file/$main::c/$main::n/archives.pending/$main::ver"
            )
        {
            undef $main::ver;
        }
        else {
            $archives_dir
                = "$default::file/$main::c/$main::n/archives.pending/$main::ver";
            my $ip = $ENV{'REMOTE_HOST'}
                || $this->to_host( $ENV{'REMOTE_ADDR'} );
            $this->write_file(
                $archives_dir . '/.htaccess',
                'Satisfy all' . "\x0A"
                    . 'order deny,allow' . "\x0A"
                    . 'deny from all' . "\x0A"
                    . 'allow from '
                    . $ip . "\x0A",
                1
            );
        }
    }

    #---------------------------------------------------------------------
    #アクセス権チェック
    if ($main::ver) {
        if ( !$this->is_secure('rewind') ) {
            $this->print_password_check_form($setting::key);
            return;
        }
    }
    elsif (defined $setting::security{'detail'}{'passwordCheck'}
        && $setting::security{'detail'}{'passwordCheck'} eq 'member'
        && !$this->is_staff )
    {
        my (@mail);
        if ( ref $field::for{'mail_address'}
            && @{ $field::for{'mail_address'} } )
        {
            foreach my $id ( @{ $field::for{'mail_address'} } ) {
                my (%db);
                tie(%db,
                    $env::dbm_file,
                    $default::db . '/'
                        . $main::c . '/'
                        . $field::obj{$id}->db,
                    O_RDONLY,
                    $env::dbm_mode
                );
                if ( ref tied %db ) {
                    push(
                        @mail,
                        $this->decode_utf8(
                            $db{ $this->encode_utf8($main::n) }
                        )
                    );
                }
                untie(%db);
            }
        }
        @mail = $this->get_address(@mail);
        if ( !$this->is_authorized(@mail) ) {
            $this->print_password_check_form($setting::key);
            return;
        }
    }
    return
        if $this->is_pending_record_detail( $main::c, $main::n, $main::ver );

    #---------------------------------------------------------------------
    #リンク元
    $this->query_optimize;
    my $referer_url = $this->referer_url;

    #---------------------------------------------------------------------
    #特殊フィールド処理
    if (   !$main::ver
        && defined $main::id
        && $main::id ne ''
        && ref $field::obj{$main::id}
        && $field::obj{$main::id}->update_enabled
        && $field::obj{$main::id}->is_secure_user_for_update
        && $field::obj{$main::id}->update )
    {
        $this->set_onload( 'cmonos.window.refreshOpener(\''
                . ( ($main::mod) ? $this->escape($referer_url) : '' )
                . '\',false)' );
    }

    #---------------------------------------------------------------------
    #アクセスカウント
    $this->reset_access_counter( $setting::general{'counterReset'} );
    my ( %access_ip, $is_not_countable );
    tie(%access_ip, $env::dbm_file,
        "$default::db/$main::c/access_ip",
        O_RDWR | O_CREAT,
        $env::dbm_mode
    );
    if ( ref tied %access_ip ) {
        my $ip = $ENV{'REMOTE_HOST'} || $this->to_host( $ENV{'REMOTE_ADDR'} );
        my @access_ips = ( $access_ip{$main::n} )
            ? split( /\x09/,
            substr( $access_ip{$main::n}, 0, ( $env::db_maxlength || 900 ) ) )
            : ();
        if ( @access_ips && grep( $ip eq $_, @access_ips ) ) {
            @access_ips = ( $ip, grep( $ip ne $_, @access_ips ) );
            $is_not_countable = 1;
        }
        else {
            unshift( @access_ips, $ip );
        }
        my $kept_ip
            = ( $setting::page{$setting::key}{'keptIP'} )
            ? $setting::page{$setting::key}{'keptIP'}
            : 64;
        if ( @access_ips > $kept_ip ) {
            splice( @access_ips, $kept_ip );
        }
        $access_ip{$main::n} = substr( join( "\x09", @access_ips ),
            0, ( $env::db_maxlength || 900 ) );
    }
    untie %access_ip;
    if ( !$is_not_countable ) {
        my ( %total, %monthly, %weekly, %daily );
        tie(%total, $env::dbm_file,
            "$default::db/$main::c/access_total",
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %total ) {
            $total{$main::n}++;
        }
        untie %total;
        tie(%monthly, $env::dbm_file,
            "$default::db/$main::c/access_monthly",
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %monthly ) {
            $monthly{$main::n}++;
        }
        untie %monthly;
        tie(%weekly, $env::dbm_file,
            "$default::db/$main::c/access_weekly",
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %weekly ) {
            $weekly{$main::n}++;
        }
        untie %weekly;
        tie(%daily, $env::dbm_file,
            "$default::db/$main::c/access_daily",
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %daily ) {
            $daily{$main::n}++;
        }
        untie %daily;
    }

    #---------------------------------------------------------------------
    #前後レコード判定
    my ( $header_neighbor_link, $footer_neighbor_link ) = ( '', '' );
    if (   $setting::page{$setting::key}{'headerNeighborLink'}
        || $setting::page{$setting::key}{'footerNeighborLink'} )
    {
        my ( $prev_record, $next_record ) = $this->get_neighbor_record;
        if ( $prev_record || $next_record ) {
            $header_neighbor_link
                = $this->get_neighbor_link( $prev_record, $next_record )
                if defined $setting::page{$setting::key}{'headerNeighborLink'}
                && $setting::page{$setting::key}{'headerNeighborLink'};
            $footer_neighbor_link
                = $this->get_neighbor_link( $prev_record, $next_record,
                $referer_url )
                if defined $setting::page{$setting::key}{'footerNeighborLink'}
                && $setting::page{$setting::key}{'footerNeighborLink'};
        }
    }

    #---------------------------------------------------------------------
    #書き出し
    my ( $have_template, $this_template, %temp );

    #新着アイコン
    my $delegate_field
        = ( $field::for{'key'} ) ? $field::for{'key'}
        : ( $field::for{'title'} ) ? $field::for{'title'}
        :                            '';
    my $new_item_icon = '';
    if ( !$main::ver ) {
        unless ( ref $cgi::Image ) {
            require CMONOS::CGI_Lib::Image;
            $cgi::Image = Image->new;
        }
        if ( $setting::page{'newIconLimit'} ) {
            my ( %ctime, $ctime );
            tie( %ctime, $env::dbm_file, "$default::db/$main::c/ctime",
                O_RDWR | O_CREAT,
                $env::dbm_mode );
            if ( ref tied %ctime ) {
                $ctime
                    = $this->decode_utf8(
                    $ctime{ $this->encode_utf8($main::n) } )
                    if defined $ctime{ $this->encode_utf8($main::n) }
                    && $ctime{ $this->encode_utf8($main::n) };
            }
            untie %ctime;
            if ( $ctime
                && time - $ctime < 86400 * $setting::page{'newIconLimit'} )
            {
                my $title
                    = ( $setting::page{'newIconAlt'} )
                    ? $setting::page{'newIconAlt'}
                    : (
                    $setting::deco{'new'}{ $setting::page{'newIcon'} }{'alt'}
                    )
                    ? $setting::deco{'new'}{ $setting::page{'newIcon'} }
                    {'alt'}
                    : 'NEW!';
                if (   $setting::page{'newIcon'}
                    && $setting::deco{'new'}{ $setting::page{'newIcon'} }
                    {'width'} )
                {
                    $new_item_icon = ' '
                        . $cgi::Image->image_tag(
                        $env::image_dir . '/new/'
                            . $setting::deco{'new'}
                            { $setting::page{'newIcon'} }{'name'},
                        $setting::deco{'new'}{ $setting::page{'newIcon'} }
                            {'width'},
                        $setting::deco{'new'}{ $setting::page{'newIcon'} }
                            {'height'},
                        0,
                        $title,
                        'class="new-item-icon"',
                        );
                }
                else {
                    $new_item_icon
                        = ' <span class="new-item-icon">'
                        . $title
                        . '</span>';
                }
            }
        }
        if ( !$new_item_icon && $setting::page{'upIconLimit'} ) {
            if ( $mtime
                && time - $mtime < 86400 * $setting::page{'upIconLimit'} )
            {
                my $title
                    = ( $setting::page{'upIconAlt'} )
                    ? $setting::page{'upIconAlt'}
                    : (
                    $setting::deco{'new'}{ $setting::page{'upIcon'} }{'alt'} )
                    ? $setting::deco{'new'}{ $setting::page{'upIcon'} }{'alt'}
                    : 'UP!';
                if (   $setting::page{'upIcon'}
                    && $setting::deco{'new'}{ $setting::page{'upIcon'} }
                    {'width'} )
                {
                    $new_item_icon = ' '
                        . $cgi::Image->image_tag(
                        $env::image_dir . '/new/'
                            . $setting::deco{'new'}
                            { $setting::page{'upIcon'} }{'name'},
                        $setting::deco{'new'}{ $setting::page{'upIcon'} }
                            {'width'},
                        $setting::deco{'new'}{ $setting::page{'upIcon'} }
                            {'height'},
                        0,
                        $title,
                        'class="up-item-icon"',
                        );
                }
                else {
                    $new_item_icon
                        = ' <span class="up-item-icon">' . $title . '</span>';
                }
            }
        }
    }

    #テンプレート
    if ( defined $setting::page{$setting::key}{'template'}
        && $setting::page{$setting::key}{'template'} ne '' )
    {
        require CMONOS::CGI_Lib::Template;
        $this_template = Template->new;
        $this_template->set(
            'field_style_disabled' => $setting::field_style_disabled,
            'field_tag_enabled'    => $setting::field_tag_enabled
        );
        $have_template = 1;
        $have_template++
            if $setting::page{$setting::key}{'template'}
            =~ /<body(?![0-9a-zA-Z_])[^>]*>/i;
        $setting::page{$setting::key}{'template'}
            =~ s/(<!--field(?=\s)[^>]*\s+id="$delegate_field"[^>]*-->.*?<!--\/field(?!\w)[^>]*-->)/$this->add_field_footer($1,$new_item_icon)/seig
            if $delegate_field;
        $this_template->template_parser(
            \$setting::page{$setting::key}{'template'} );
    }

    #タイトル抽出
    my $title_id
        = ( $field::for{'title'} ) ? $field::for{'title'}
        : ( $field::for{'key'} )  ? $field::for{'key'}
        : ( $field::for{'name'} ) ? $field::for{'name'}
        :                           '';
    if ( ref $field::obj{$title_id} ) {
        my $title = $this->detag_text(
            $field::obj{$title_id}->usual_format(
                $this->get_content( $title_id, $path, $archives_dir, 1 )
            )
        );
        $this->push_window_title($title) if defined $title && $title ne '';
        $this->set_page_title( $title . $new_item_icon );
    }
    if ( $field::for{'content'} && ref $field::obj{ $field::for{'content'} } )
    {
        $this->set_description(
            $field::obj{ $field::for{'content'} }->usual_format(
                $this->get_content(
                    $field::for{'content'}, $path, $archives_dir, 1
                )
            )
        );
    }
    my $image_url;
    if ( $field::for{'media'} && ref $field::obj{ $field::for{'media'} } ) {
        $image_url = $field::obj{ $field::for{'media'} }->image_file_url(
            $this->get_content(
                $field::for{'media'}, $path, $archives_dir, 1
            ),
            $path, $main::c, $main::n
        );
    }
    if (  !$image_url
        && $field::for{'media2'}
        && ref $field::obj{ $field::for{'media2'} } )
    {
        $image_url = $field::obj{ $field::for{'media2'} }->image_file_url(
            $this->get_content(
                $field::for{'media2'}, $path, $archives_dir, 1
            ),
            $path, $main::c, $main::n
        );
    }
    if (  !$image_url
        && $field::for{'media3'}
        && ref $field::obj{ $field::for{'media3'} } )
    {
        $image_url = $field::obj{ $field::for{'media3'} }->image_file_url(
            $this->get_content(
                $field::for{'media3'}, $path, $archives_dir, 1
            ),
            $path, $main::c, $main::n
        );
    }
    $this->set_og_image($image_url) if $image_url;
    if ( $field::for{'coordinates'}
        && ref $field::obj{ $field::for{'coordinates'} } )
    {
        $this->set_og_latlng(
            $field::obj{ $field::for{'coordinates'} }->get_latlng(
                $this->get_content(
                    $field::for{'coordinates'},
                    $path, $archives_dir, 1
                ),
                $path, $main::c, $main::n
            )
        );
    }

    #ページヘッダ
    my $info = '';
    if ($main::ver) {
        my ( $ip, $ua, $email, $name )
            = split( /\x0A/,
            $this->read_file( $archives_dir . '/data/author', 1 ) );
        $name = $cgi::Register->get_name_from_email($email) || $name || ''
            if $email;
        my $datetime = $this->date( $main::ver, 3, 'c24' );
        $info = '<div id="cms-rollback-information">';
        $info .= '<strong>【' . $datetime . '版】</strong>';
        if ( $this->is_secure('tools') ) {
            $info .= ' by';
            $info .= ' ' . $this->escape($name) if $name;
            $info
                .= ' &lt;<a href="mailto:'
                . $email
                . '" title="'
                . $email . '">'
                . $email
                . '</a>&gt;'
                if $email;
            $info .= ' [' . $ip . ']' if $ip;
        }
        $info .= '</div>';
    }
    $this->set_last_modified($mtime)
        if $setting::general{'lastModifiedHeaderEnabled'};
    $this->set_favorites_control_js;
    if ( !$have_template || $have_template < 2 ) {
        $this->set_canonical(
            $this->permalink_of_detailview( $main::c, $main::n )
                . ( ($main::dn) ? '&dn=' . $main::dn : '' ) );
        $this->print_page_header($setting::key);
        if ($info) {
            print $info;
        }
        elsif ( $this->is_secure('revise') ) {
            print $this->get_rev_buttons( $main::c, $main::n, 'detailedit',
                'detaildelete', $setting::key );
        }
    }
    else {
        $this->print_http_header;
        if ( $this->{'JavaScript'} ) {
            my $js = $this->javascript( $this->{'JavaScript'},
                ( ( $env::doctype && $env::doctype =~ /XHTML/ ) ? 1 : 0 ) );
            $setting::page{$setting::key}{'template'}
                =~ s/(<\/head>)/$js$1/si;
        }
        if ( $this->is_secure('revise') ) {
            if ($info) {
                $setting::page{$setting::key}{'template'}
                    =~ s/(<body(?![0-9a-zA-Z_])[^>]*>)/$1$info/si;
            }
            else {
                my $buttons = $this->get_rev_buttons( $main::c, $main::n,
                    'detailedit', 'detaildelete', $setting::key );
                $setting::page{$setting::key}{'template'}
                    =~ s/(<body(?![0-9a-zA-Z_])[^>]*>)/$1$buttons/si;
            }
        }
    }
    print $header_neighbor_link;
    my ( $table_field, $top_field ) = ( '', '' );
    if ( !$have_template ) {

        #装飾調整

        #項目フレーム調整
        if ( $setting::page{$setting::key}{'fieldFrame'}
            && ref $frame::obj{'frame'}
            { $setting::page{$setting::key}{'fieldFrame'} } )
        {
            my @frame_setting = (
                'framewidth' => $setting::page{$setting::key}{'fieldWidth'},
                'fixed'      => 'no',
                'frameclass' => 'item-body'
            );
            push( @frame_setting,
                'contentsalign', $setting::page{$setting::key}{'boxAlign'} )
                if defined $setting::page{$setting::key}{'boxAlign'}
                && $setting::page{$setting::key}{'boxAlign'};
            push( @frame_setting,
                'contentsvalign', $setting::page{$setting::key}{'boxValign'} )
                if defined $setting::page{$setting::key}{'boxValign'}
                && $setting::page{$setting::key}{'boxValign'};
            $frame::obj{'frame'}
                { $setting::page{$setting::key}{'fieldFrame'} }
                ->set_direct(@frame_setting);
        }

        #項目名フレーム調整
        if ( defined $setting::page{$setting::key}{'fieldTitleOption'}
            && $setting::page{$setting::key}{'fieldTitleOption'} )
        {
            if ( $setting::page{$setting::key}{'fieldFrame'}
                && ref $frame::obj{'frame'}
                { $setting::page{$setting::key}{'fieldFrame'} } )
            {
                $frame::obj{'frame'}
                    { $setting::page{$setting::key}{'fieldFrame'} }->{'type'}
                    = 'frame';
            }
        }
        elsif ( $setting::page{$setting::key}{'fieldTitleFrame'}
            && ref $frame::obj{'frame'}
            { $setting::page{$setting::key}{'fieldTitleFrame'} } )
        {
            $frame::obj{'frame'}
                { $setting::page{$setting::key}{'fieldTitleFrame'} }
                ->set_direct( 'framewidth',
                $setting::page{$setting::key}{'fieldTitleWidth'},
                'frameclass', 'item-titlebar' );
        }

        #トップ項目
        if (   defined $field::for{'top'}
            && $field::for{'top'} ne ''
            && ref $field::obj{ $field::for{'top'} }
            && $field::obj{ $field::for{'top'} }->format_for_detail_enabled
            && !$field::obj{ $field::for{'top'} }->{'Hidden'}
            && (   $field::obj{ $field::for{'top'} }->{'Open'}
                || $this->is_secure('secret') )
            )
        {
            my $contents
                = $this->get_content( $field::for{'top'}, $path,
                $archives_dir )
                . (
                (          $new_item_icon
                        && $delegate_field
                        && $field::for{'top'} eq $delegate_field
                ) ? $new_item_icon : ''
                );
            $top_field
                .= ( $field::for{'top'} eq $title_id )
                ? '<h1 id="top-item">' . $contents . '</h1>'
                : '<div id="top-item" class="section"><div class="body">'
                . $contents
                . '</div></div>'
                if defined $contents && $contents ne '';
        }

        # 一覧表示項目
        my ( $table, $table_check, $name );
        if (   defined $setting::page{$setting::key}{'table'}
            && $setting::page{$setting::key}{'table'} ne ''
            && ref $table::obj{ $setting::page{$setting::key}{'table'} } )
        {
            $table = $table::obj{ $setting::page{$setting::key}{'table'} };
            $table_field = $table->table;
        }
        else {
            $table_field = '<table class="field-table"><tbody>';
        }
        foreach ( sort { $a <=> $b } keys %field::ORDER ) {
            my ( $id, $title, $contents );
            $id = $field::ORDER{$_};

            #トップ項目をスキップ
            next if $id eq $field::for{'top'};

       #テーブル項目以外をスキップ/不正な項目をスキップ
            next
                unless ref $field::obj{$id}
                && $field::obj{$id}->{'detailTable'}
                && !$field::obj{$id}->{'Hidden'}
                && ( $field::obj{$id}->{'Open'}
                || $this->is_secure('secret') )
                && $field::obj{$id}->format_for_detail_enabled;

            $contents = $this->get_content( $id, $path, $archives_dir )
                . (
                (          $new_item_icon
                        && $delegate_field
                        && $id eq $delegate_field
                ) ? $new_item_icon : ''
                );
            next if !defined $contents || $contents eq '';

            #タイトルバー
            if (   $setting::page{$setting::key}{'fieldTitleOption'}
                && ( !defined $name || $name eq '' )
                && (   $id eq $field::for{'title'}
                    || $id eq $field::for{'key'}
                    || $id eq $field::for{'name'} )
                && $contents =~ /[^\x09\x0A\x0C\x0D\x20]/
                && $contents ne '&nbsp;'
                )
            {
                $name = '<h2 class="item-title">' . $contents . '</h2>';
                next;
            }

            #一覧表示項目
            $title = $field::obj{$id}->name;
            if ( ref $table ) {
                $table_field .= $table->tr;
                $table_field .= $table->td($title);
                $table_field .= $table->td($contents);
                $table_field .= $table->_tr;
            }
            else {
                $table_field
                    .= '<tr><td class="field-name"><span class="datatitle">'
                    . $title
                    . '</span></td>';
                $table_field
                    .= '<td class="field">' . $contents . '</td></tr>';
            }
            $table_check = 1;
        }
        if ($table_check) {
            $table_field
                .= ( ref $table ) ? $table->_table : '</tbody></table>';
        }
        else {
            $table_field = '';
        }
        $table_field
            = ( $setting::page{$setting::key}{'fieldFrame'} )
            ? $this->get_frame( $setting::page{$setting::key}{'fieldFrame'},
            $table_field, $name, 'no', 'section', 'item-table' )
            : '<div id="item-table" class="section">'
            . ( ( defined $name ) ? $name : '' )
            . '<div class="body">'
            . $table_field
            . '</div></div>'
            if defined $table_field && $table_field ne '';
        $table_field = $top_field . $table_field;

        #一覧表示
        print $table_field
            if !defined $setting::page{$setting::key}{'tableValign'}
            || $setting::page{$setting::key}{'tableValign'} ne 'bottom';
    }

    #書き出し
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        if ( ref $field::obj{$id} ) {
            if (   $field::obj{$id}->format_for_detail_enabled
                && !$field::obj{$id}->{'Hidden'}
                && (   $field::obj{$id}->{'Open'}
                    || $this->is_secure('secret') ) )
            {

                #テンプレート用データ取得
                if ($have_template) {
                    $temp{$id}
                        = $this->get_content( $id, $path, $archives_dir, 1 );

#トップ項目をスキップ/テーブル項目をスキップ/不正な項目をスキップ
                }
                elsif ( $id ne $field::for{'top'}
                    && !$field::obj{$id}->{'detailTable'} )
                {
                    my ( $name, $title, $contents );

                    #空コンテンツをスキップ
                    $contents
                        = $this->get_content( $id, $path, $archives_dir )
                        . (
                        (          $new_item_icon
                                && $delegate_field
                                && $id eq $delegate_field
                        ) ? $new_item_icon : ''
                        );
                    next
                        if $contents !~ /[^\x09\x0A\x0C\x0D\x20]/
                        || $contents eq '&nbsp;';
                    print '<div class="section" id="item-' . $id . '">';

                    #項目名
                    $name = $field::obj{$id}->name;
                    if (   defined $name
                        && $name ne ''
                        && $name ne '&nbsp;'
                        && $name =~ /[^\x09\x0A\x0C\x0D\x20]/ )
                    {
                        $name = '<h2 class="item-title">' . $name . '</h2>';
                        if (defined $setting::page{$setting::key}
                            {'fieldTitleOption'}
                            && $setting::page{$setting::key}
                            {'fieldTitleOption'} )
                        {
                            $title = $name;
                        }
                        else {
                            print(
                                (   $setting::page{$setting::key}
                                        {'fieldTitleFrame'}
                                )
                                ? $this->get_frame(
                                    $setting::page{$setting::key}
                                        {'fieldTitleFrame'},
                                    $name,
                                    '',
                                    'no',
                                    'item-titlebar'
                                    )
                                : $name
                            );
                        }
                    }

                    #項目欄
                    print(
                        ( $setting::page{$setting::key}{'fieldFrame'} )
                        ? $this->get_frame(
                            $setting::page{$setting::key}{'fieldFrame'},
                            $contents, $title, 'no', 'item-body' )
                        : ( ( defined $title ) ? $title : '' )
                            . '<div class="body">'
                            . $contents
                            . '</div>'
                    );
                    print '</div>';
                }
            }
            else {
                $field::obj{$id}->disabled;
            }
        }
    }

    #テンプレートにしたがって出力
    if ($have_template) {
        my $article = $this_template->deco(
            $setting::page{$setting::key}{'template'} );

        if (   $default::type
            && $default::type eq 'order'
            && $field::for{'order_info'}
            && ref $field::obj{ $field::for{'order_info'} } )
        {
            my $data = $this->get_data( $field::for{'order_info'}, $path );
            my $ptime
                = ( $data && $data =~ /^(.*?)\x0A/ )
                ? ( split( /\x09/, $1 ) )[6]
                : '';
            local $setting::fixed_data = 1;
            my $info = $field::obj{ $field::for{'order_info'} }
                ->format_for_detail( $data, $path, $main::c, $main::n );
            undef $data;
            my $ctime = $ptime;
            if ( !$ctime ) {
                my (%db);
                tie( %db, $env::dbm_file, "$default::db/$main::c/ctime",
                    O_RDONLY, $env::dbm_mode );
                $ctime
                    = $this->decode_utf8(
                    $db{ $this->encode_utf8($main::n) } )
                    if ref tied %db && $db{ $this->encode_utf8($main::n) };
                untie(%db);
            }

            my $name
                = ( $field::for{'name'}
                    && ref $field::obj{ $field::for{'name'} } )
                ? $this->get_content( $field::for{'name'}, $path,
                $archives_dir )
                : '';
            my $email
                = ( $field::for{'mail'}
                    && ref $field::obj{ $field::for{'mail'} } )
                ? $this->get_content( $field::for{'mail'}, $path,
                $archives_dir )
                : '';
            my $address
                = ( $field::for{'shippingaddress'}
                    && ref $field::obj{ $field::for{'shippingaddress'} } )
                ? $this->get_content( $field::for{'shippingaddress'},
                $path, $archives_dir )
                : '';
            my $zipcode
                = ( $field::for{'shippingzipcode'}
                    && ref $field::obj{ $field::for{'shippingzipcode'} } )
                ? $this->get_content( $field::for{'shippingzipcode'},
                $path, $archives_dir )
                : '';
            my $seller
                = $setting::general{'mastername'} || $env::copyright || '';
            my $seller_email
                = $setting::general{'master'} || $env::master_email || '';
            my $url = $this->full_path('../../');
            my $sitename = $env::title || '';
            my $company
                = ( $env::copyright && $env::copyright ne $seller )
                ? $env::copyright
                : '';

            $article
                =~ s/<\!--(sheet)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/sheet-->/$this->item_tag_replace($1,$2,$3,$info)/iges;
            $article
                =~ s/<\!--(buyer)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/buyer-->/$this->item_tag_replace($1,$2,$3,$name)/iges;
            $article
                =~ s/<\!--(buyer_email)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/buyer_email-->/$this->item_tag_replace($1,$2,$3,$email)/iges;
            $article
                =~ s/<\!--(buyer_address)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/buyer_address-->/$this->item_tag_replace($1,$2,$3,$address)/iges;
            $article
                =~ s/<\!--(buyer_zipcode)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/buyer_zipcode-->/$this->item_tag_replace($1,$2,$3,$zipcode)/iges;
            $article
                =~ s/<\!--date(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/date-->/$this->paid_date_replace($ctime,$1,$2)/sge;
            $article
                =~ s/<\!--(seller)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/seller-->/$this->item_tag_replace($1,$2,$3,$seller)/iges;
            $article
                =~ s/<\!--(seller_email)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/seller_email-->/$this->item_tag_replace($1,$2,$3,$seller_email)/iges;
            $article
                =~ s/<\!--(seller_company)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/seller_company-->/$this->item_tag_replace($1,$2,$3,$company)/iges;
            $article
                =~ s/<\!--(seller_sitename)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/seller_sitename-->/$this->item_tag_replace($1,$2,$3,$sitename)/iges;
            $article
                =~ s/<\!--(seller_url)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/seller_url-->/$this->item_tag_replace($1,$2,$3,$url)/iges;

            if ($ptime) {
                $article
                    =~ s/<\!--invoice(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/invoice-->//igs;
            }
            else {
                $article
                    =~ s/<\!--receipt(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/receipt-->//igs;
            }
        }

        print $this_template->replace(
            $this->page_item_replace(
                $article, 0, '', $setting::page{$setting::key}{'title'}
            ),
            \%temp,
            'detail',
            ( ($main::ver) ? $archives_dir : $path ),
            $main::c, $main::n
        );

        #一覧表示
    }
    elsif ( defined $setting::page{$setting::key}{'tableValign'}
        && $setting::page{$setting::key}{'tableValign'} eq 'bottom' )
    {
        print $table_field;
    }

    print(
        ($footer_neighbor_link) ? $footer_neighbor_link : $this->back_button(
            $referer_url, '<div id="close-button" class="panel">',
            '</div>'
        )
    );

    #ページフッタ
    $this->print_page_footer($setting::key)
        if !defined $have_template || $have_template < 2;

}

sub has_opener ($) {
    my $this = shift;
    return 1;
}

sub push_optional_title ($$) {
    my ( $this, $title_path ) = @_;
    $this->import_db( $default::preference_dir . '/category',
        \%setting::category, 1 )
        if !%setting::category;
    if (   ref $setting::category{'ORDER'}
        && keys %{ $setting::category{'ORDER'} } > 1
        && ref $setting::category{$main::c}
        && defined $setting::category{$main::c}{'name'}
        && $setting::category{$main::c}{'name'} ne '' )
    {
        push( @$title_path, $setting::category{$main::c}{'name'} );
    }
    return 1;
}

sub push_optional_topicpath ($$) {
    my ( $this, $topicpath_pair ) = @_;
    $this->import_db( $default::preference_dir . '/category',
        \%setting::category, 1 )
        if !%setting::category;
    if (   ref $setting::category{'ORDER'}
        && keys %{ $setting::category{'ORDER'} } > 1
        && ref $setting::category{$main::c}
        && defined $setting::category{$main::c}{'name'}
        && $setting::category{$main::c}{'name'} ne '' )
    {
        push( @$topicpath_pair,
                  './start.cgi?'
                . ( ($main::mod) ? 'm=' . $main::mod . '&' : '' ) . 'c='
                . $main::c => $setting::category{$main::c}{'name'} );
    }
    return 1;
}

sub paid_date_replace ($$$$) {
    my ( $this, $ptime, $attributes, $content ) = @_;
    my ( $type, $format, $date_only );
    if ( $content
        =~ s/[\x09\x0A\x0C\x0D\x20]*<\!--format(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/format(?![0-9a-zA-Z_])[^>]*-->//si
        )
    {
        $format = $1;
    }
    elsif ( $attributes
        =~ /[\x09\x0A\x0C\x0D\x20]+format[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)"/si
        )
    {
        $format = $this->unescape( $this->entity_to_lf($1) );
    }
    my ( $header, $footer )
        = $this->get_header_and_footer( $attributes, $content );
    $date_only = $1
        if $attributes
        && $attributes =~ /[\x09\x0A\x0C\x0D\x20]+dateonly="([12])"/s;
    $type
        = (    $attributes
            && $attributes =~ /[\x09\x0A\x0C\x0D\x20]+type="([^"]+)"/s )
        ? $1
        : ( $setting::general{'datetype'} || '' );
    $type .= ( $date_only && $date_only == 2 ) ? '>dnw' : '>d';
    return
          $header
        . $this->date( $ptime, 0, 'gmt' . $type, $format )
        . $footer;
}

sub has_to_satisfy_queries ($) {
    my $this = shift;
    if (   $field::for{'coordinates'}
        && ref $main::search{ $field::for{'coordinates'} }
        && $main::search{ $field::for{'coordinates'} }{'sw'}
        && $main::search{ $field::for{'coordinates'} }{'ne'} )
    {
        return ( $field::for{'coordinates'} );
    }
    else {
        return ();
    }
}

sub get_data ($$$) {
    my ( $this, $id, $path ) = @_;
    my $db   = $field::obj{$id}->db;
    my $data = '';
    if ($main::ver) {
        $data = $this->read_file( $path . '/data/' . $db, 1 );
    }
    else {
        my (%db);
        tie( %db, $env::dbm_file, "$default::db/$main::c/$db", O_RDONLY,
            $env::dbm_mode )
            if defined $db && $db ne '';
        $data = $this->decode_utf8( $db{ $this->encode_utf8($main::n) } );
        untie(%db) if defined $db && $db ne '';
    }
    return $data;
}

sub get_content ($$$;$$) {
    my ( $this, $id, $path, $archives_dir, $raw ) = @_;
    my $db   = $field::obj{$id}->db;
    my $data = '';
    if ( $main::ver && -f $archives_dir . '/data/' . $db ) {
        $data = $this->read_file( $archives_dir . '/data/' . $db, 1 );
        return $field::obj{$id}
            ->format_for_detail( $data, $archives_dir, $main::c, $main::n )
            if !$raw;
    }
    else {
        my (%db);
        tie( %db, $env::dbm_file, "$default::db/$main::c/$db", O_RDONLY,
            $env::dbm_mode )
            if defined $db && $db ne '';
        $data = $this->decode_utf8( $db{ $this->encode_utf8($main::n) } );
        untie(%db) if defined $db && $db ne '';
        return $field::obj{$id}
            ->format_for_detail( $data, $path, $main::c, $main::n )
            if !$raw;
    }
    return $data;
}

sub set_rss_link ($;$) {
    my ( $this, $output ) = @_;
    if ( defined $main::c ) {
        $this->import_db( $default::preference_dir . '/category',
            \%setting::category, 1 )
            if !%setting::category;
        $this->_set_rss_link(
            $default::file . '/' . $main::c,
            (   (          ref $setting::category{$main::c}
                        && defined $setting::category{$main::c}{'name'}
                        && $setting::category{$main::c}{'name'} ne ''
                ) ? $setting::category{$main::c}{'name'} : ''
            )
        );
    }
    $this->_set_rss_link(
        $default::file,
        (   (   defined $setting::general{'cginame'}
                    && $setting::general{'cginame'} ne ''
            ) ? $setting::general{'cginame'} : ''
        ),
        $output
    );
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定DB読み込み設定
    $setting::general  = 1;    #一般設定読み込み
    $setting::deco     = 1;    #テキスト装飾設定読み込み
    $setting::security = 1;    #アクセス権設定読み込み
    $setting::table    = 1;    #テーブル設定読み込み
    $setting::page     = 1;    #ページ設定読み込み

    $setting::field_db_name = 'inputfield';    #フィールド設定DB
    $setting::field         = 2
        ; #フィールド設定読み込み（2=オリジナルも読み込む）
    $setting::field_style_disabled = 0
        ; #2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
    $setting::field_tag_enabled
        = 'no'; #tag=タグのみ/all=全ての設定/no=タグをつけない

    $setting::pending_check = 1;    #非公開レコードチェック

    #設定種キー設定
    $setting::security_key
        = 'detail';                 #デフォルトセキュリティキー
    $setting::key = 'detail';       #ページ設定キー
    if (   $main::dn
        && $main::dn >= 2
        && $main::dn <= $default::detail_variation )
    {
        $main::dn = int($main::dn);
        $setting::key .= $main::dn;
    }
    else {
        undef $main::dn;
    }

    #クッキー
    $cookie::id_enabled = 1;    #ID情報クッキー読み込み

    #デフォルトキー
    $main::k = 'detail' if !defined $main::k || !$main::k;

    #必須フォーム
    @setting::form = (
        'm',  'c', 'n',   'dn',     's',   'w',   'f', 'u',
        'fv', 'q', 'and', 'search', 'mod', 'uni', 'ct'
    );

    #クラス登録
    Common::class_register( 'detail', 'DetailViewer' );

    #イメージCSS
    $setting::image_css  = 'tablemaker-image.css';
    $setting::image_css2 = 'order-image.css'
        if $default::type && $default::type eq 'order';
}

1;
