package EstimateSheet;
require CMONOS::TableMaker::CheckOut;
@ISA = qw(CheckOut);
use strict;
use utf8;
use Fcntl qw(:DEFAULT :flock);
######################################################################
# お見積もり印刷モジュール
# EstimateSheet.pm ver1.0.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-11-25
######################################################################
# メイン
sub run ($) {
    my $this = shift;
    $this->import_db( $default::preference_dir . '/terms',
        \%setting::payment, 1 )
        if !%setting::payment;
    $main::a = '' if !defined $main::a;
    $main::c = '' if !defined $main::c || $main::c =~ /[^0-9]/;
    $main::n = '';
    my $estimate_sheet = $this->estimate_sheet;
    $field::obj{ $field::for{'mail'} }->{'required'} = 1
        if $default::type
        && $default::type eq 'order'
        && $field::for{'mail'}
        && ref $field::obj{ $field::for{'mail'} };
    my $form = '<input type="hidden" name="m" value="CheckOut" />';
    $form .= '<input type="hidden" name="k" value="checkout" />';
    $form .= '<input type="hidden" name="a" value="w" />';

    foreach my $o ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$o};
        $field::obj{$id}->is_valid_data;
        if ( ref $main::option{$id} ) {
            while ( my ( $k, $v ) = each %{ $main::option{$id} } ) {
                next if $k eq 'str';
                if ( ref $v eq 'ARRAY' ) {
                    my $n = 0;
                    foreach my $value (@$v) {
                        $form
                            .= '<input type="hidden" name="option:'
                            . $id . ':'
                            . $k . '^'
                            . ( $n++ )
                            . '" value="'
                            . $this->escape($value) . '" />';
                    }
                }
                else {
                    $form
                        .= '<input type="hidden" name="option:'
                        . $id . ':'
                        . $k
                        . '" value="'
                        . $this->escape($v) . '" />';
                }
            }
        }
        if ( ref $main::data{$id} ) {
            $form .= $field::obj{$id}->hidden_confirmation_data;
        }
        $field::obj{$id}->{'is_temporary_data'} = 1;
    }
    $this->dialog;    #エラーメッセージを消去

    $form = '<div id="cms-estimatesheet-bar">'
        . $this->form_start(
        'key'      => $setting::key,
        'name'     => 'input',
        'method'   => 'post',
        'onsubmit' => 'return cmonos.form.item(this).isNotSubmitted()',
        'required' => \@setting::form
        )
        . $form
        . '<input type="submit" name="cancel=1" value="戻る" /> <input type="submit" value="続行する" /> <input type="button" value="このページを印刷する" onclick="window.print();" /></form></div>';

    if ( !$setting::page{$setting::key}{'template'} ) {
        $setting::page{$setting::key}{'cssFileName'} = 'estimate.css'
            if !$setting::page{$setting::key}{'cssFileName'};
        $setting::page{$setting::key}{'title'} = 'お見積もりの印刷'
            if !$setting::page{$setting::key}{'title'};
        $setting::page{$setting::key}{'template'} = <<TEMP;
<div id="main">
<h1>お見積もり</h1>
<dl id="date">
<dt>見積書発行日</dt><dd><!--date--><!--/date--></dd>
<dt>見積書有効期間</dt><dd>一ヶ月</dd>
</dl>
<div id="requestor">
<!--requestor_address--><!--head--><div class="address"><!--/head--><!--foot--></div><!--/foot--><!--/requestor_address-->
<!--requestor_email--><!--head--><div class="email"><!--/head--><!--foot--></div><!--/foot--><!--/requestor_email-->
<div class="name"><span class="name"><!--requestor--><!--/requestor--></span><span class="suffix">様</span></div>
</div>
<div id="estimator">
<!--estimator_company--><!--head--><div class="company"><!--/head--><!--foot--></div><!--/foot--><!--/estimator_company-->
<!--estimator--><!--head--><div class="name"><!--/head--><!--foot--></div><!--/foot--><!--/estimator-->
<!--estimator_email--><!--head--><div class="email"><!--/head--><!--foot--></div><!--/foot--><!--/estimator_email-->
<div class="address">



</div>
<!--estimator_sitename--><!--head--><div class="sitename"><!--/head--><!--foot--></div><!--/foot--><!--/estimator_sitename-->
<!--estimator_url--><!--head--><div class="url"><!--/head--><!--foot--></div><!--/foot--><!--/estimator_url-->
</div>
<!--estimate--><!--head--><div id="estimate"><!--/head--><!--foot--></div><!--/foot--><!--/estimate-->
<div id="note"><p>※このお見積もりは概算です。実際にご注文いただいた時点で、条件により多少変動する場合がございます。</p></div>
</div>
TEMP
    }
    my $article = $setting::page{$setting::key}{'template'};

    my $print_css = <<'CSS';
<style type="text/css" media="print"> 
html body div#cms-estimatesheet-bar, div#cgi-dialog-box {
  display: none !important;
}
</style> 
CSS
    $this->set_html_header($print_css);

    my $name
        = ( $field::for{'name'} && ref $field::obj{ $field::for{'name'} } )
        ? $field::obj{ $field::for{'name'} }
        ->usual_format( $main::data{ $field::for{'name'} },
        '', $main::c, $main::n )
        : '';
    my $email
        = ( $field::for{'mail'} && ref $field::obj{ $field::for{'mail'} } )
        ? $field::obj{ $field::for{'mail'} }
        ->usual_format( $main::data{ $field::for{'mail'} },
        '', $main::c, $main::n )
        : '';
    my $address
        = ( $field::for{'shippingaddress'}
            && ref $field::obj{ $field::for{'shippingaddress'} } )
        ? $field::obj{ $field::for{'shippingaddress'} }
        ->usual_format( $main::data{ $field::for{'shippingaddress'} },
        '', $main::c, $main::n )
        : '';
    my $zipcode
        = ( $field::for{'shippingzipcode'}
            && ref $field::obj{ $field::for{'shippingzipcode'} } )
        ? $field::obj{ $field::for{'shippingzipcode'} }
        ->usual_format( $main::data{ $field::for{'shippingzipcode'} },
        '', $main::c, $main::n )
        : '';
    my $seller = $setting::general{'mastername'} || $env::copyright || '';
    my $seller_email
        = $setting::general{'master'} || $env::master_email || '';
    my $url = $this->full_path('../../');
    my $sitename = $env::title || '';
    my $company
        = ( $env::copyright && $env::copyright ne $seller )
        ? $env::copyright
        : '';

    $article
        =~ s/<\!--(requestor)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/requestor-->/$this->item_tag_replace($1,$2,$3,$name)/iges;
    $article
        =~ s/<\!--(requestor_email)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/requestor_email-->/$this->item_tag_replace($1,$2,$3,$email)/iges;
    $article
        =~ s/<\!--(requestor_address)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/requestor_address-->/$this->item_tag_replace($1,$2,$3,$address)/iges;
    $article
        =~ s/<\!--(requestor_zipcode)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/requestor_zipcode-->/$this->item_tag_replace($1,$2,$3,$zipcode)/iges;
    $article
        =~ s/<\!--date(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/date-->/$this->date_replace($1,$2)/sge;
    $article
        =~ s/<\!--(seller)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/seller-->/$this->item_tag_replace($1,$2,$3,$seller)/iges;
    $article
        =~ s/<\!--(seller_email)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/seller_email-->/$this->item_tag_replace($1,$2,$3,$seller_email)/iges;
    $article
        =~ s/<\!--(seller_company)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/seller_company-->/$this->item_tag_replace($1,$2,$3,$company)/iges;
    $article
        =~ s/<\!--(seller_sitename)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/seller_sitename-->/$this->item_tag_replace($1,$2,$3,$sitename)/iges;
    $article
        =~ s/<\!--(seller_url)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/seller_url-->/$this->item_tag_replace($1,$2,$3,$url)/iges;

    require CMONOS::CGI_Lib::Template;
    my $this_template = Template->new->set( 'field_tag_enabled' => 'no' );
    $article = $this_template->replace( $article, \%main::data, 'detail', '',
        $main::c ),

        my $footer_required;
    if (   $article =~ /<html(?!\w)[^>]*>/is
        && $article =~ /<body(?!\w)[^>]*>/is )
    {
        $article =~ s/(<body(?!\w)[^>]*>)/$1$form/is;
    }
    else {
        $this->print_page_header($setting::key);
        print $form;
        $footer_required = 1;
    }

    $article
        =~ s/<\!--(estimate)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/estimate-->/$this->item_tag_replace($1,$2,$3,$estimate_sheet)/iges;
    print $article;

    $this->print_page_footer($setting::key) if $footer_required;
}

sub date_replace ($$$) {
    my ( $this, $attributes, $content ) = @_;
    my ( $type, $format, $date_only );
    if ( $content
        =~ s/[\x09\x0A\x0C\x0D\x20]*<\!--format(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/format(?![0-9a-zA-Z_])[^>]*-->//si
        )
    {
        $format = $1;
    }
    elsif ( $attributes
        =~ /[\x09\x0A\x0C\x0D\x20]+format[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)"/si
        )
    {
        $format = $this->unescape( $this->entity_to_lf($1) );
    }
    my ( $header, $footer )
        = $this->get_header_and_footer( $attributes, $content );
    $date_only = $1
        if $attributes
        && $attributes =~ /[\x09\x0A\x0C\x0D\x20]+dateonly="([12])"/s;
    $type
        = (    $attributes
            && $attributes =~ /[\x09\x0A\x0C\x0D\x20]+type="([^"]+)"/s )
        ? $1
        : ( $setting::general{'datetype'} || '' );
    $type .= ( $date_only && $date_only == 2 ) ? '>dnw' : '>d';
    return $header . $this->date( '', 0, 'gmt' . $type, $format ) . $footer;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ( $default::type && $default::type eq 'order' ) {
        no warnings qw(once);

        #設定種キー設定
        $setting::security_key
            = 'checkout';    #デフォルトセキュリティキー
        $setting::key = 'estimate';    #ページ設定キー

        #クッキー
        $cookie::id_enabled = 1;       #ID情報クッキー読み込み

        #デフォルトキー
        $main::k = 'estimate' if !defined $main::k || !$main::k;

        #必須フォーム
        @setting::form = ('c');

        $setting::page{'estimate'}{'title'} = 'お見積もり印刷';

        #クラス登録
        Common::class_register( 'estimate', 'EstimateSheet' );
    }
}

1;
