package DetailButton;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# フィールド定義モジュール（サムネイル+詳細を見るボタン）
# DetailButton.pm 1.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2012-01-27
######################################################################
sub _set ($$) {
    no warnings qw(once);
    my ( $this, $setting ) = @_;
    unless ( ref $cgi::Image ) {
        require CMONOS::CGI_Lib::Image;
        $cgi::Image = Image->new;
    }
    unless ( ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }
    $this->{'border'} = '0'
        if !defined $this->{'border'} || $this->{'border'} eq '';
    $this->{'alwaysCopy'} = 1 if !defined $this->{'alwaysCopy'};

    #複数の要素を登録
    $this->{'elements'} = 1;

    #ファイルアップロード
    if ( !$this->{'noThumbnail'} ) {
        $cgi::enctype_multipart = 1;
    }
    return;
}

#	(0)-8 obj->align;
sub align ($) {
    my $this = shift;
    return 'center';
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    return 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    return 1;
}

######################################################################
#	(2) obj->form;
sub input_enabled ($) {
    my $this = shift;
    return ( $this->{'noThumbnail'} ) ? 0 : 1;
}

sub form {
    my ( $this, $status, $original, $path ) = @_;
    return '' if $this->{'noThumbnail'} || $this->{'userThumbnailDisabled'};
    my ( $name, $form );

    #名前にデータIDを埋め込む
    $name = 'data:' . $this->{'id'};

    #フィールドネーム+ヘッダ
    $form = $this->field_header( '', $name . ':file' );

    #ファイルの存在をチェック
    (   $main::data{ $this->{'id'} }{'type'},
        $main::data{ $this->{'id'} }{'width'},
        $main::data{ $this->{'id'} }{'height'}
        )
        = ()
        unless defined $main::data{ $this->{'id'} }{'type'}
        && -f ( ( !$cgi::input->{'clipboard_expired'}
                && $this->{'is_posted_file'} )
        ? $cgi::input->get_public_clipboard
        : $path )
        . '/'
        . $this->{'id'} . '.'
        . $main::data{ $this->{'id'} }{'type'};

    #アップロードフォーム
    $form
        .= '<span id="'
        . $name
        . ':file-wrapper"><input type="file" name="'
        . $name
        . ':file" id="'
        . $name
        . ':file" value="'
        . $this->escape( $main::data{ $this->{'id'} }{'file'} ) . '"'
        . ( ( $this->{'is_invalid_field'}{'file'} )
        ? $this->set_invalid_class
        : '' )
        . ' /></span><input type="button" value="&#139; リセット" onclick="cmonos.form.item(this.form).fieldname(\''
        . $name
        . ':file\').reset()">';
    $form
        .= '<div class="note">(&lt; '
        . $this->escape( $this->{'maxsize'} )
        . ' byte) </div>'
        if defined $this->{'maxsize'}
        && $this->{'maxsize'} ne ''
        && $this->{'maxsize'} > 0;
    $form
        .= '<div class="note">(&lt; '
        . ( ( $this->{'widthlimit'} ) ? $this->{'widthlimit'} : '&infin;' )
        . ' × '
        . ( ( $this->{'heightlimit'} ) ? $this->{'heightlimit'} : '&infin;' )
        . ' <span class="unit">ピクセル</span>) </div>'
        if $this->{'widthlimit'} || $this->{'heightlimit'};
    $form
        .= '<input type="hidden" name="'
        . $name
        . ':width" value="'
        . $this->escape( $main::data{ $this->{'id'} }{'width'} ) . '" />';
    $form
        .= '<input type="hidden" name="'
        . $name
        . ':height" value="'
        . $this->escape( $main::data{ $this->{'id'} }{'height'} ) . '" />';

    #既存ファイルの表示
    if ((   defined $status && $status ne ''
            || (  !$cgi::input->{'clipboard_expired'}
                && $this->{'is_posted_file'} )
        )
        && defined $main::data{ $this->{'id'} }{'type'}
        && $main::data{ $this->{'id'} }{'type'} ne ''
        )
    {
        $form .= '<div class="sample-image">';
        $form .= $cgi::Image->image_tag(
            (   (         !$cgi::input->{'clipboard_expired'}
                        && $this->{'is_posted_file'}
                ) ? $cgi::input->get_public_clipboard : $path
            )
            . "/$this->{'id'}.$main::data{$this->{'id'}}{'type'}",
            $main::data{ $this->{'id'} }{'width'},
            $main::data{ $this->{'id'} }{'height'},
            $this->{'border'},
            $this->{'name'},
            '', 300, 300,
        );
        if (  !$cgi::input->{'clipboard_expired'}
            && $this->{'is_posted_file'} )
        {
            $form
                .= '<div class="extra-field"><label><input type="checkbox" name="option:'
                . $this->{'id'}
                . ':cancel" value="1" /> この<strong>未確定</strong>ファイルを削除する</label></div>'
                if !defined $this->{'required'} || !$this->{'required'};
        }
        else {
            $form
                .= '<div class="extra-field"><label><input type="checkbox" name="'
                . $name
                . ':delete" value="1"'
                . (
                (         !$cgi::input->{'clipboard_expired'}
                        && $main::data{ $this->{'id'} }{'delete'}
                ) ? ' checked="checked"' : ''
                )
                . ' /> このファイルを削除する</label></div>'
                if !defined $this->{'required'} || !$this->{'required'};
        }
        $form
            .= '<input type="hidden" name="'
            . $name
            . ':type" value="'
            . $main::data{ $this->{'id'} }{'type'}
            . '" /></div>';
    }

    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my ( $this, $path ) = @_;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    return 1 if defined $this->{'noThumbnail'} && $this->{'noThumbnail'};

    my ( $is_valid, @stat, $name, $width, $height, $type );
    $is_valid = 1;

    #シンボリックネーム
    $name = 'data:' . $this->{'id'} . ':file';

    #既存ファイルの情報
    if ( $path && -d $path ) {
        (   $main::data{ $this->{'id'} }{'width'},
            $main::data{ $this->{'id'} }{'height'},
            $main::data{ $this->{'id'} }{'type'}
            )
            = $this->get_field_file_info(
            $path,
            $main::data{ $this->{'id'} }{'width'},
            $main::data{ $this->{'id'} }{'height'},
            $main::data{ $this->{'id'} }{'type'},
            '',
            '',
            1
            );
    }
    else {
        delete $main::data{ $this->{'id'} }{'width'};
        delete $main::data{ $this->{'id'} }{'height'};
        delete $main::data{ $this->{'id'} }{'type'};
        undef $path;
    }

    #ファイルアップロードフィールドからコピー
    if (   $main::clipboard_id
        && !$main::data{ $this->{'id'} }{'file'}
        && !$main::option{ $this->{'id'} }{'cancel'} )
    {
        $cgi::input->inherit_posted_file_properties($name);
    }
    my %properties
        = $cgi::input->get_posted_file_properties_from_param($name);
    if ( $properties{'delete'} ) {
        delete $properties{'delete'};
        $cgi::input->set_posted_file_properties_from_param( $name, 0,
            \%properties );
    }
    if (   $this->{'copyfrom'}
        && $env::clipboard
        && $cgi::Image->image_magick_enabled
        && ((   !$properties{'filename'}
                && (  !$main::data{ $this->{'id'} }{'type'}
                    || $main::data{ $this->{'id'} }{'delete'}
                    || $this->{'alwaysCopy'} )
            )
            || $this->{'userThumbnailDisabled'}
        )
        && ref $this->{'field_obj'}{ $this->{'copyfrom'} }
        && ( $this->{'field_obj'}{ $this->{'copyfrom'} }->{'class'} eq 'file'
            || $this->{'field_obj'}{ $this->{'copyfrom'} }->{'class'} eq
            'file_shipainter' )
        )
    {
        if ($cgi::input->get_posted_file_size_from_param(
                'data:' . $this->{'copyfrom'} . ':file'
            ) > 0
            )
        {
            my @info = $cgi::Image->input_info( $cgi::input,
                'data:' . $this->{'copyfrom'} . ':file', 0 );
            %properties
                = $cgi::input->clone_posted_file(
                'data:' . $this->{'copyfrom'} . ':file', $name )
                if $info[2];
        }
        elsif ( $this->{'field_obj'}{ $this->{'copyfrom'} }->{'class'} eq
               'file_shipainter'
            && $main::data{ $this->{'copyfrom'} }{'key'}
            && $main::data{ $this->{'copyfrom'} }{'key'}
            !~ /[^0-9a-zA-Z_\@\-]/s )
        {
            use Fcntl qw(:flock);
            my $is_valid_header = 1;
            local (*SPD);
            if (open( SPD,
                          $env::clipboard . '/'
                        . $main::data{ $this->{'copyfrom'} }{'key'}
                )
                )
            {
                binmode SPD;
                flock( SPD, LOCK_EX );
                my $pos = 9;
                my $buf = int( $this->{'field_obj'}{ $this->{'copyfrom'} }
                        ->read_image( \*SPD, 1, 8 ) );
                if ($buf) {
                    my %header
                        = $this->url_decode(
                        $this->{'field_obj'}{ $this->{'copyfrom'} }
                            ->read_image( \*SPD, 9, $buf ) );
                    $pos += $buf;
                    if ($header{'pch'}
                        && (  !$path
                            || $header{'pch'} ne $path . '/'
                            . $this->{'copyfrom'}
                            . '.spch' )
                        )
                    {
                        $is_valid_header = 0;
                    }
                }
                if ($is_valid_header) {
                    $buf = int( $this->{'field_obj'}{ $this->{'copyfrom'} }
                            ->read_image( \*SPD, $pos, 8 ) );
                    $pos += 10;    #8バイト+CRLF
                    if ($buf) {
                        my $image
                            = $this->{'field_obj'}{ $this->{'copyfrom'} }
                            ->read_image( \*SPD, $pos, $buf );
                        my ( $width, $height, $ext, $type )
                            = $cgi::Image->info( \$image );
                        $properties{'filename'}
                            = $main::data{ $this->{'id'} }{'file'}
                            = 'image.' . $ext;
                        $properties{'name'} = $name;
                        $properties{'type'} = $type;
                        $cgi::input->post_clipboard( $name, 0, $image,
                            \%properties );
                    }
                }
                close(SPD);
            }
        }
    }

    if ( $properties{'filename'} ) {

        #添付ファイルが画像ファイルかどうかチェック
        @stat
            = $cgi::Image->input_info( $cgi::input, $name, 0,
            $this->{'widthlimit'}, $this->{'heightlimit'},
            1, \%properties, 1 );
        ( $width, $height, $type ) = @stat if @stat > 2;

        #MIME-TYPEチェック
        if ( !defined $type || $type eq '' ) {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( $this->{'name'} )
                    ? $this->{'name'}
                    : 'サムネイル画像'
                    )
                    . 'のファイルタイプを確認してください。'
            ) if ref $cgi::action;
            $this->{'is_invalid_field'}{'file'} = 1;
            $is_valid = 0;
        }

        #ファイルサイズチェック
        if (   defined $this->{'maxsize'}
            && $this->{'maxsize'} > 0
            && $cgi::input->get_posted_file_size_from_param($name)
            > $this->{'maxsize'} )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( $this->{'name'} )
                    ? $this->{'name'}
                    : 'サムネイル画像'
                    )
                    . 'のファイルサイズを確認してください。'
                    . $this->{'maxsize'}
                    . 'バイト以内にしてください。'
            ) if ref $cgi::action;
            $this->{'is_invalid_field'}{'file'} = 1;
            $is_valid = 0;
        }

        #ファイル削除予約
    }
    elsif ( !$this->{'required'} && $main::data{ $this->{'id'} }{'delete'} ) {
        $properties{'delete'} = $this->{'id'};
        $cgi::input->set_posted_file_properties_from_param( $name, 0,
            \%properties );
        $cgi::input->parameters_trash(
            \$main::data{ $this->{'id'} }{'width'},
            \$main::data{ $this->{'id'} }{'height'},
            \$main::data{ $this->{'id'} }{'type'}
        );
        delete $main::data{ $this->{'id'} }{'file'};
        $this->data( 'file', 'delete', 'width', 'height', 'type' );
        return 1;

    }
    else {
        ( $width, $height, $type ) = (
            $main::data{ $this->{'id'} }{'width'},
            $main::data{ $this->{'id'} }{'height'},
            $main::data{ $this->{'id'} }{'type'}
        );
    }
    delete $main::data{ $this->{'id'} }{'file'};

    #画像サイズチェック
    if ( $this->{'widthlimit'} && $width && $width > $this->{'widthlimit'} ) {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( $this->{'name'} )
                ? $this->{'name'}
                : 'サムネイル画像'
                )
                . 'の横幅を確認してください。'
                . $this->{'widthlimit'}
                . 'ピクセル以内にしてください。'
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'file'} = 1;
        $is_valid = 0;
    }
    if (   $this->{'heightlimit'}
        && $height
        && $height > $this->{'heightlimit'} )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( $this->{'name'} )
                ? $this->{'name'}
                : 'サムネイル画像'
                )
                . 'の高さを確認してください。'
                . $this->{'heightlimit'}
                . 'ピクセル以内にしてください。'
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'file'} = 1;
        $is_valid = 0;
    }
    return 0 if !$is_valid;

    #データ整形
    my ( $w, $h, $t );
    ( $w, $h, $t ) = (
        $main::data{ $this->{'id'} }{'width'},
        $main::data{ $this->{'id'} }{'height'},
        $main::data{ $this->{'id'} }{'type'}
    );
    (   $main::data{ $this->{'id'} }{'width'},
        $main::data{ $this->{'id'} }{'height'},
        $main::data{ $this->{'id'} }{'type'}
    ) = ( $width, $height, $type );
    $this->data('delete');

    #入力のチェック
    if ( !$this->is_not_empty('type') ) {
        (   $main::data{ $this->{'id'} }{'width'},
            $main::data{ $this->{'id'} }{'height'},
            $main::data{ $this->{'id'} }{'type'}
        ) = ( $w, $h, $t );
        $this->{'is_invalid_field'}{'file'} = 1;
        return 0;
    }

    #画像の保存を予約
    if ( $properties{'filename'} ) {
        $mail::file .= '<' . $name . '>,'
            if defined $this->{'mail'}
            && $this->{'mail'};    #メール添付予約
        $cgi::input->save_file( $name,
                  '!'
                . $this->{'id'} . '.'
                . $main::data{ $this->{'id'} }{'type'} );
        $this->{'is_posted_file'} = 1;
    }

    return 1;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=表示するデータ/path=ファイル保存ディレクトリ/category=カテゴリー/no=レコードNo
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    my ( %data, $image, $thumbnail, $option, $target, $ct );
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    if ( !defined $cgi::path || $cgi::path eq '' ) {
        $cgi::path = $ENV{'SCRIPT_NAME'};
        $cgi::path = $env::cgi_server . $cgi::path
            if defined $env::cgi_server && $env::cgi_server;
    }
    if ( @main::c && ( @main::c > 1 || $main::c[0] =~ /,/ ) ) {
        foreach (@main::c) {
            $ct .= '&ct=' . $_;
        }
    }
    $thumbnail
        = $cgi::path
        . '?m=DetailViewer'
        . ( ( $this->{'dn'} ) ? '&dn=' . $this->{'dn'} : '' )
        . ( ( defined $c )    ? '&c=' . $c             : '' )
        . ( ( defined $n )    ? '&n=' . $n             : '' )
        . ( ($ct)             ? $ct                    : '' )
        . $this->set_query(
        'url+',
        [   grep( $_ ne 'm'
                    && $_ ne 'k'
                    && $_ ne 'c'
                    && $_ ne 'n'
                    && $_ ne 'ct'
                    && $_ ne 'dn'
                    && $_ ne 'uni',
                @setting::form )
        ]
        );
    if ( !defined $this->{'sameWindow'} || !$this->{'sameWindow'} ) {
        $option
            = 'onclick="if(typeof cmonos == \'object\'){cmonos.window.open(\'detailViewer'
            . ( ( $this->{'dn'} && $this->{'dn'} > 1 ) ? '-' . $this->{'dn'}
            : '' )
            . '\','
            . ( ( $this->{'windowWidth'} ) ? $this->{'windowWidth'} : '640' )
            . ','
            . (
            ( $this->{'windowHeight'} ) ? $this->{'windowHeight'} : '480' )
            . ')}else{window.open(\'\',\'detailViewer'
            . ( ( $this->{'dn'} && $this->{'dn'} > 1 ) ? '-' . $this->{'dn'}
            : '' )
            . '\',\'width='
            . ( ( $this->{'windowWidth'} ) ? $this->{'windowWidth'} : '640' )
            . ',height='
            . (
            ( $this->{'windowHeight'} ) ? $this->{'windowHeight'} : '480' )
            . ',scrollbars=yes,resizable=yes\')} return true"';
        $target
            = 'detailViewer'
            . ( ( $this->{'dn'} && $this->{'dn'} > 1 )
            ? '-' . $this->{'dn'}
            : '' );
    }

    #画像タグ
    if (   !$this->{'noThumbnail'}
        && defined $data{'type'}
        && $data{'type'} ne '' )
    {
        $thumbnail
            = $this->thumbnail( \%data, $path, $c, $n, $thumbnail, $target,
            $option );

    }
    elsif ( $this->{'button'} && $main::m ne 'KMLViewer' ) {
        $thumbnail
            = $cgi::Deco->button( 'detail', $this->{'button'}, $thumbnail,
            $this->name(1), $target, $option, $cgi::output_option );

    }
    else {
        $thumbnail
            = '<a href="'
            . $this->escape($thumbnail) . '"'
            . (
            ($target)
            ? ' target="detailViewer'
                . (
                ( $this->{'dn'} && $this->{'dn'} > 1 )
                ? '-' . $this->{'dn'}
                : ''
                )
                . '"'
            : ''
            ) . ( ( defined $option ) ? ' ' . $option : '' );
        $thumbnail .= '>' . $this->escape( $this->name(1) ) . '</a>';
    }
    return $this->field_tag(
        $this->data_tag_from_ref( \%data ) . $thumbnail );
}

sub thumbnail ($$$$$;$$$) {
    my ( $this, $data, $path, $c, $n, $url, $target, $option ) = @_;
    my $thumbnail = (
        ($url)
        ? '<a href="'
            . $this->escape($url) . '"'
            . (
            ($target)
            ? ' target="detailViewer'
                . (
                ( $this->{'dn'} && $this->{'dn'} > 1 )
                ? '-' . $this->{'dn'}
                : ''
                )
                . '"'
            : ''
            )
            . ( ($option) ? ' ' . $option : '' )
        : '<span'
        )
        . ' title="'
        . $this->escape( $this->name(1) ) . '"';
    my ( $badge_path, $badge_w, $badge_h, $badge_title );
    if (   $this->{'badgeField'}
        && ref $this->{'field_obj'}{ $this->{'badgeField'} }
        && ( $this->{'field_obj'}{ $this->{'badgeField'} }->{'class'} eq
            'select_image'
            || $this->{'field_obj'}{ $this->{'badgeField'} }->{'class'} eq
            'select_imagemenu' )
        )
    {
        my $db = $field::obj{ $this->{'badgeField'} }->db;
        if ($db) {
            my $badge_str;
            if ( ref $cgi::action && ref $cgi::action->{'DB'} ) {
                if ( !ref tied %{ $cgi::action->{'DB'}{$c}{$db} } ) {
                    tie( %{ $cgi::action->{'DB'}{$c}{$db} },
                        $env::dbm_file, "$default::db/$c/$db", O_RDONLY,
                        $env::dbm_mode );
                }
                $badge_str = $this->decode_utf8(
                    $cgi::action->{'DB'}{$c}{$db}{ $this->encode_utf8($n) } );
            }
            else {
                my %db;
                tie( %db, $env::dbm_file, $default::db . '/' . $c . '/' . $db,
                    O_RDONLY, $env::dbm_mode );
                if ( ref tied %db ) {
                    $badge_str
                        = $this->decode_utf8( $db{ $this->encode_utf8($n) } );
                }
                untie %db;
            }
            if ($badge_str) {
                if ( $this->{'field_obj'}{ $this->{'badgeField'} }->{'class'}
                    eq 'select_image' )
                {
                    my $img = ( split( /,/, $badge_str ) )[0];
                    ( $badge_path, $badge_w, $badge_h, $badge_title ) = (
                        $env::image_dir
                            . '/misc/'
                            . $setting::deco{'misc'}{$img}{'name'},
                        $setting::deco{'misc'}{$img}{'width'},
                        $setting::deco{'misc'}{$img}{'height'},
                        $setting::deco{'misc'}{$img}{'alt'}
                    ) if $img;
                }
                elsif (
                    $this->{'field_obj'}{ $this->{'badgeField'} }->{'class'}
                    eq 'select_imagemenu' )
                {
                    my %badge_data
                        = $this->{'field_obj'}{ $this->{'badgeField'} }
                        ->elements($badge_str);
                    ( $badge_path, $badge_w, $badge_h, $badge_title ) = (
                        $badge_data{'images'}[0],
                        $badge_data{'width'}[0],
                        $badge_data{'height'}[0],
                        $this->{'field_obj'}{ $this->{'badgeField'} }
                            ->get_image_name( $badge_data{'images'}[0] )
                        )
                        if ref $badge_data{'images'}
                        && $badge_data{'images'}[0];
                }
            }
        }
    }
    if ($badge_w) {
        ( $badge_w, $badge_h )
            = $cgi::Image->image_fit( $badge_w, $badge_h, $data->{'width'},
            $data->{'height'} );
        $thumbnail .= ' style="';
        $thumbnail .= 'position: relative;';
        $thumbnail .= 'display: -moz-inline-box;';
        $thumbnail .= 'display: inline-block;';
        $thumbnail .= 'vertical-align: middle;';
        $thumbnail .= 'text-align: center;';
        $thumbnail .= '/display: inline;';
        $thumbnail .= '/zoom: 1;';
        $thumbnail .= '_display: inline;';
        $thumbnail .= '_zoom: 1;';
        $thumbnail .= 'width: ' . $data->{'width'} . 'px;';
        $thumbnail .= 'height: ' . $data->{'height'} . 'px;';
        $thumbnail .= '">';
    }
    else {
        $thumbnail .= '>';
    }
    $thumbnail .= $cgi::Image->image_tag(
        "$path/$this->{'id'}.$data->{'type'}", $data->{'width'},
        $data->{'height'},                     $this->{'border'},
        $this->name(1),                        '',
        '',                                    '',
        $cgi::output,                          $cgi::output_option,
    );
    if ($badge_w) {
        my $badge_style = 'position: absolute;';
        $badge_style .= 'top: '
            . (
            ( $this->{'badgeValign'} && $this->{'badgeValign'} eq 'top' )
            ? '-8px'
            : ( $this->{'badgeValign'} && $this->{'badgeValign'} eq 'bottom' )
            ? ( $data->{'height'} - $badge_h + 8 ) . 'px'
            : ( int( ( $data->{'height'} - $badge_h ) / 2 ) ) . 'px'
            ) . ';';
        $badge_style
            .= 'left: '
            . ( ( $this->{'badgeAlign'} && $this->{'badgeAlign'} eq 'left' )
            ? '-8px'
            : ( $this->{'badgeAlign'} && $this->{'badgeAlign'} eq 'right' )
            ? ( $data->{'width'} - $badge_w + 8 ) . 'px'
            : ( int( ( $data->{'width'} - $badge_w ) / 2 ) ) . 'px' )
            . ';';
        if ( $this->{'badgeOpacity'} ) {
            my $o = $this->{'badgeOpacity'} / 100;
            $badge_style .= 'opacity: ' . $o . ';';
            $badge_style .= '-moz-opacity: ' . $o . ';';
            $badge_style .= '-webkit-opacity: ' . $o . ';';
            $badge_style .= '-o-opacity: ' . $o . ';';
            $badge_style .= '-ms-filter: \'alpha(opacity='
                . $this->{'badgeOpacity'} . ')\';';
            $badge_style
                .= 'filter: alpha(opacity=' . $this->{'badgeOpacity'} . ');';
        }
        $thumbnail
            .= $cgi::Image->image_tag( $badge_path, $badge_w, $badge_h, 0,
            $badge_title, ' style="' . $badge_style . '"',
            '', '', $cgi::output, $cgi::output_option, );
    }
    $thumbnail .= ($url) ? '</a>' : '</span>';
}

sub has_content {
    my ( $this, $str, $type ) = @_;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return (
              !$type
            || $type ne 'detail'
            || ( !$this->{'noThumbnail'}
            && defined $data{'type'}
            && $data{'type'} ne '' )
    ) ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
    my $this = shift;
    return 0;
}

sub format_for_mail {
    my ( $this, $str ) = @_;
    return '';
}

#---------------------------------------------------------------------
#	(4)-3 obj->format_for_detail(str);
sub format_for_detail_enabled ($) {
    my $this = shift;
    return ( $this->{'noThumbnail'} || $this->{'hideThumbnail'} ) ? 0 : 1;
}

sub format_for_detail {
    my ( $this, $str, $path, $c, $n ) = @_;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    if (   !$this->{'noThumbnail'}
        && defined $data{'type'}
        && $data{'type'} ne '' )
    {
        return $this->thumbnail( \%data, $path, $c, $n );
    }
    else {
        return '';
    }
}

#	(4)-4 obj->format_for_text(str);
sub format_for_text_enabled ($) {
    my $this = shift;
    return 0;
}

sub format_for_text {
    my ( $this, $str ) = @_;
    return '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return 1;
}

sub confirmation ($$;$) {
    my ( $this, $str, $path ) = @_;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    my $out = '';
    if ( defined $data{'type'} && $data{'type'} ne '' ) {
        $out .= $cgi::Image->image_tag(
            (   (         !$cgi::input->{'clipboard_expired'}
                        && $this->{'is_posted_file'}
                ) ? $cgi::input->get_public_clipboard : $path
            )
            . "/$this->{'id'}.$data{'type'}",
            $data{'width'},
            $data{'height'},
            $this->{'border'},
            $this->{'name'},
            '', 300, 300,
        );
        if (   $main::data{ $this->{'id'} }{'delete'}
            && !$this->{'required'}
            && !$this->{'is_posted_file'} )
        {
            $out
                .= '<div class="note">このファイルを削除する</div>';
        }
    }
    return $out;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->{'maxsize'} = '30000'
        if !defined $this->{'maxsize'} || !$this->{'maxsize'};
    $this->print_field_info_form($name);

    print '<fieldset>';
    if ( $default::detail_variation >= 2 ) {
        print '<legend><label for="' . $name
            . '_dn">詳細表示ウィンドウ・ページレイアウト</label></legend>';
        print '<select name="' . $name . '_dn" id="' . $name . '_dn">';
        print '<option value="">詳細表示ページ</option>';
        foreach ( 2 .. $default::detail_variation ) {
            print '<option value="'
                . $_ . '"'
                . ( ( defined $this->{'dn'} && $this->{'dn'} eq $_ )
                ? ' selected="selected"'
                : '' )
                . '>詳細表示ページ'
                . $_
                . '</option>';
        }
        print '</select>';
    }
    else {
        print '<legend>詳細表示ウィンドウ設定</legend>';
    }
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_sameWindow" id="'
        . $name
        . '_sameWindow" value="1"'
        . ( ( defined $this->{'sameWindow'} && $this->{'sameWindow'} )
        ? ' checked="checked"'
        : '' )
        . ' onclick="cmonos.element.item(\'windowsize\').disappear(this.checked)" /> 別ウィンドウを開かず同じウィンドウに表示する</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_hideThumbnail" id="'
        . $name
        . '_hideThumbnail" value="1"'
        . ( ( defined $this->{'hideThumbnail'} && $this->{'hideThumbnail'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 詳細画面ではサムネイルを表示しない</label></li>';
    print '</ol>';
    print '<fieldset id="windowsize">';
    print
        '<legend>ウィンドウサイズ(同じウィンドウに表示する場合無効)</legend>';
    print '<label>幅 <input type="text" name="'
        . $name
        . '_windowWidth" id="'
        . $name
        . '_windowWidth" value="'
        . $this->escape( $this->{'windowWidth'} )
        . '" size="7" maxlength="7" /> <span class="unit">ピクセル</span></label> ';
    print '&times; <label>高さ <input type="text" name="'
        . $name
        . '_windowHeight" id="'
        . $name
        . '_windowHeight" value="'
        . $this->escape( $this->{'windowHeight'} )
        . '" size="7" maxlength="7" /> <span class="unit">ピクセル</span></label> ';
    print '</fieldset>';
    print $this->javascript(
        'cmonos.element.item(\'windowsize\').disappear(true)')
        if $this->{'sameWindow'};
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>詳細表示ボタン設定</legend>';
    print '<fieldset>';
    print '<legend>サムネイル画像</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_noThumbnail">サムネイル非表示</label></td>';
    print '<td class="field" colspan="3"><input type="checkbox" name="'
        . $name
        . '_noThumbnail" id="'
        . $name
        . '_noThumbnail" value="1" '
        . ( ( defined $this->{'noThumbnail'} && $this->{'noThumbnail'} )
        ? ' checked="checked"'
        : '' )
        . ' />';
    print
        '<span class="hints">チェックするとサムネイル画像設定が無効になります。</span>';
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_maxsize">ファイルサイズ制限</label></td>';
    print '<td class="field" colspan="3"><input type="text" name="'
        . $name
        . '_maxsize" id="'
        . $name
        . '_maxsize" value="'
        . $this->escape( $this->{'maxsize'} )
        . '" size="16" /> <span class="unit">byte</span>';
    print
        '<div class="hints">設定が無い場合、30,000byte（30kB）に設定されます。</div>';
    print
        '<div class="hints">画像サイズが制限値を超える場合、画像添付を拒絶します。</div>';
    print '</td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_widthlimit">画像横幅制限</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_widthlimit" id="'
        . $name
        . '_widthlimit" value="'
        . $this->escape( $this->{'widthlimit'} )
        . '" size="4" /> <span class="unit">ピクセル</span></td>';
    print '<td class="field-name"><label for="' . $name
        . '_heightlimit">画像高さ制限</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_heightlimit" id="'
        . $name
        . '_heightlimit" value="'
        . $this->escape( $this->{'heightlimit'} )
        . '" size="4" /> <span class="unit">ピクセル</span>';
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">通知メール</span></td>';
    print '<td class="field" colspan="3"><label><input type="checkbox" name="'
        . $name
        . '_mail" id="'
        . $name
        . '_mail" value="1" '
        . ( ( defined $this->{'mail'} && $this->{'mail'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 通知メールにサムネイル画像ファイルを添付する</label></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    if ( $cgi::Image->image_magick_enabled ) {
        print '<fieldset>';
        print '<legend><label for="' . $name
            . '_copyfrom">サムネイル画像がないとき、このフィールドからサムネイル画像を作成する</label></legend>';
        print '<select name="'
            . $name
            . '_copyfrom" id="'
            . $name
            . '_copyfrom">';
        print '<option value=""></option>';
        foreach my $id (
            sort {
                $this->{'field_obj'}->{$a}->{'ORDER'}
                    <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                    || $a <=> $b
            } keys %{ $this->{'field_obj'} }
            )
        {
            if (ref $this->{'field_obj'}{$id}
                && (   $this->{'field_obj'}{$id}->{'class'} eq 'file'
                    || $this->{'field_obj'}{$id}->{'class'} eq
                    'file_shipainter' )
                )
            {
                print '<option value="'
                    . $id . '"'
                    . (
                    (   defined $this->{'copyfrom'}
                            && $this->{'copyfrom'} eq $id
                    ) ? ' selected="selected"' : ''
                    )
                    . '>'
                    . $this->jfold( $this->{'field_obj'}{$id}->name,
                    32, 'I', 1 )
                    . '</option>';
            }
        }
        print '</select>';
        print '<ol class="checkbox"><li><label><input type="checkbox" name="'
            . $name
            . '_alwaysCopy" value="1"'
            . ( ( $this->{'alwaysCopy'} ) ? ' checked="checked"' : '' )
            . ' /> 可能ならば常にこのフィールドの画像で現在のサムネイル画像を上書きする。</label></li>';
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_userThumbnailDisabled" value="1"'
            . (
            ( $this->{'userThumbnailDisabled'} ) ? ' checked="checked"' : '' )
            . ' /> 常にこのフィールドをサムネイル画像にする。</label></li></ol>';
        print '</fieldset>';
    }

    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_button">デフォルトボタン</label></legend>';

    #ボタンメニュー
    print $cgi::Deco->button_menu( $name . '_button',
        'detail', 120, $this->{'button'} );
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>バッジ画像</legend>';
    print
        '<div class="hints">「画像選択」フィールドタイプまたは「画像メニュー」フィールドタイプで選択した画像(最初の一つ)をサムネイル画像に重ねて表示できます。</div>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_badgeField">バッジ画像フィールド</label></td>';
    print '<td class="field">';
    print '<select name="'
        . $name
        . '_badgeField" id="'
        . $name
        . '_badgeField">';
    print '<option value=""></option>';

    foreach my $id (
        sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
        } keys %{ $this->{'field_obj'} }
        )
    {
        if (ref $this->{'field_obj'}{$id}
            && (   $this->{'field_obj'}{$id}->{'class'} eq 'select_image'
                || $this->{'field_obj'}{$id}->{'class'} eq
                'select_imagemenu' )
            )
        {
            print '<option value="'
                . $id . '"'
                . (
                (   defined $this->{'badgeField'}
                        && $this->{'badgeField'} eq $id
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . $this->jfold( $this->{'field_obj'}{$id}->name, 32, 'I', 1 )
                . '</option>';
        }
    }
    print '</select>';
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_badgeAlign">位置</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_badgeAlign', '', '', $this->{'badgeAlign'},
        ''       => '',
        'left'   => '左',
        'center' => '中央',
        'right'  => '右'
    );
    print $this->mk_select_menu(
        $name . '_badgeValign', '', '', $this->{'badgeValign'},
        ''       => '',
        'top'    => '上',
        'center' => '中央',
        'bottom' => '下'
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_badgeOpacity">透明度</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_badgeOpacity" id="'
        . $name
        . '_badgeOpacity" value="'
        . $this->escape( $this->{'badgeOpacity'} )
        . '" size="4" /> <span class="unit">%</span></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';
    print '</fieldset>';
    $this->print_setting_save_button;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = $this->is_valid_file_setting;
    if (   defined $main::data{ $this->{'id'} . '_windowWidth' }
        && $main::data{ $this->{'id'} . '_windowWidth' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_windowWidth' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '詳細表示ウィンドウ幅を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_windowWidth' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_windowHeight' }
        && $main::data{ $this->{'id'} . '_windowHeight' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_windowHeight' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '詳細表示ウィンドウ高さを更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_windowHeight' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_badgeOpacity' }
        && $main::data{ $this->{'id'} . '_badgeOpacity' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_badgeOpacity' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'バッジ画像透明度を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_badgeOpacity' };
        $is_valid = 0;
    }
    elsif ($main::data{ $this->{'id'} . '_badgeOpacity' }
        && $main::data{ $this->{'id'} . '_badgeOpacity' } )
    {
        $main::data{ $this->{'id'} . '_badgeOpacity' }
            = int $main::data{ $this->{'id'} . '_badgeOpacity' };
        $main::data{ $this->{'id'} . '_badgeOpacity' } = ''
            if $main::data{ $this->{'id'} . '_badgeOpacity' } >= 100
            || $main::data{ $this->{'id'} . '_badgeOpacity' } <= 0;
    }

    #チェックボックス
    $main::data{ $this->{'id'} . '_noThumbnail' } = ''
        if !defined $main::data{ $this->{'id'} . '_noThumbnail' }
        || $main::data{ $this->{'id'} . '_noThumbnail' } eq '';
    $main::data{ $this->{'id'} . '_sameWindow' } = ''
        if !defined $main::data{ $this->{'id'} . '_sameWindow' }
        || $main::data{ $this->{'id'} . '_sameWindow' } eq '';
    $main::data{ $this->{'id'} . '_hideThumbnail' } = ''
        if !defined $main::data{ $this->{'id'} . '_hideThumbnail' }
        || $main::data{ $this->{'id'} . '_hideThumbnail' } eq '';
    $main::data{ $this->{'id'} . '_userThumbnailDisabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_userThumbnailDisabled' }
        || !$main::data{ $this->{'id'} . '_userThumbnailDisabled' };
    $main::data{ $this->{'id'} . '_alwaysCopy' } = '0'
        if !$main::data{ $this->{'id'} . '_alwaysCopy' };
    $cgi::enctype_multipart = 1
        if !defined $this->{'noThumbnail'} || !$this->{'noThumbnail'};

    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    return $is_valid;
}

######################################################################
#	(6) obj->search_form;
sub search_form_enabled ($) {
    my $this = shift;
    return 0;
}

sub search_form ($) {
    my $this = shift;
    return;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    if ( !$setting::field_for_mail ) {
        no warnings qw(once);
        Field::class_register( 'xtm_detail', 'DetailButton',
            '詳細/サムネイル画像' );
        $setting::deco_dir{'detail'}  = '詳細ボタン';
        $setting::deco_type{'detail'} = 'button';
    }
}

1;
