package FavoritesNotice;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（お気に入り）
# FavoritesNotice.pm 1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-06-14
######################################################################
#	(0)-3 対応するDB
sub db ($) {
    my $this = shift;
    return '';
}

sub _set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'msg'} = 'お気に入りリストを送信する'
        if !$this->{'msg'};
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    return 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    return 1;
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status, $original, $path ) = @_;
    my @favorites = grep( $_ ne '' && $_ !~ /[^0-9]/,
        split( /,/, $this->read_cookie_direct('favorites') ) );
    return ( !@favorites )
        ? ''
        : $this->field_header
        . '<label><input type="checkbox" name="data:'
        . $this->{'id'}
        . ':str" value="1"'
        . (
        ( $main::data{ $this->{'id'} }{'str'} ) ? 'checked="checked"' : '' )
        . ' />'
        . $this->{'msg'}
        . ' <a href="'
        . $this->escape(
        $this->full_path($cgi::path) . '?m=TableViewer&fv=1' )
        . '" target="_blank">[確認]</a>'
        . '</label>'
        . $this->field_footer;
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
    my $this = shift;
    return 1;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=表示するデータ/path=ファイル保存ディレクトリ
sub usual_format_enabled ($) {
    my $this = shift;
    return 0;
}

sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    return '';
}

sub has_content {
    my $this = shift;
    return 1;
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
    my $this = shift;
    return 1;
}

sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !$str;
    my @favorites = grep( $_ ne '' && $_ !~ /[^0-9]/,
        split( /,/, $this->read_cookie_direct('favorites') ) );
    return ( !@favorites )
        ? ''
        : '['
        . $this->name . "]\x0A"
        . $this->{'msg'}
        . "\x0A  >> "
        . $this->full_path($cgi::path)
        . '?m=TableViewer&fv=1&fav='
        . join( '%2C', @favorites )
        . "\x0A\x0A";
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text_enabled ($) {
    my $this = shift;
    return 0;
}

sub format_for_text {
    my ( $this, $str ) = @_;
    return '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return 1;
}

sub confirmation ($$) {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !$str;
    my @favorites = grep( $_ ne '' && $_ !~ /[^0-9]/,
        split( /,/, $this->read_cookie_direct('favorites') ) );
    return ( !@favorites )
        ? ''
        : $this->{'msg'}
        . ' <a href="'
        . $this->escape(
        $this->full_path($cgi::path) . '?m=TableViewer&fv=1' )
        . '" target="_blank">[確認]</a>';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;
    $this->print_field_info_form( 'data:' . $this->{'id'} );
    print '<fieldset><legend>メッセージ</legend><textarea name="data:'
        . $this->{'id'}
        . '_msg" cols="72" rows="3" wrap="soft">'
        . $this->escape( $this->{'msg'} )
        . '</textarea></fieldset>';
    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_msg' } )
        if defined $main::data{ $this->{'id'} . '_msg' }
        && $main::data{ $this->{'id'} . '_msg' };
    return 1;
}

######################################################################
#	(6) obj->search_form;
sub search_form_enabled ($) {
    my $this = shift;
    return 0;
}

sub search_form ($) {
    my $this = shift;
    return '';
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);
    if ( $setting::field_for_mail && !$default::type ) {
        Field::class_register( 'xtm_favnotice', 'FavoritesNotice',
            'お気に入りリスト' );
    }
}

1;
