package InquiryButton;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
eval 'use ' . $env::dbm_file . ';';
use Fcntl qw(:DEFAULT);
######################################################################
# フィールド定義モジュール（問い合せボタン）
# InquiryButton.pm 1.1.5
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-08-17
######################################################################
sub _set ($$) {
    my $this = shift;
    unless ( ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }

    #複数の要素を登録
    $this->{'elements'} = 1;

    return;
}

#	(0)-8 obj->align;
sub align ($) {
    my $this = shift;
    return 'center';
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    return 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    return 1;
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status, $original, $path ) = @_;
    my ( $form, $quotmenu_flag );

    #フィールドネーム+ヘッダ
    $form = $this->field_header;

    #メール送信機能の設定
    $main::data{ $this->{'id'} }{'mailto'} = $this->{'mailtoDefault'}
        if !ref $main::data{ $this->{'id'} }
        && defined $this->{'mailtoDefault'};
    $form
        .= '<dl><dt><label for="data:'
        . $this->{'id'}
        . ':mailto">送信先 </label></dt>';
    $form
        .= '<dd><select name="data:'
        . $this->{'id'}
        . ':mailto" id="data:'
        . $this->{'id'}
        . ':mailto"'
        . ( ( $this->{'is_invalid_field'}{'mailto'} )
        ? $this->set_invalid_class
        : '' )
        . '>';
    if ( defined $this->{'mailtoUser'} && $this->{'mailtoUser'} ) {
        foreach my $id (
            sort {
                $this->{'field_obj'}->{$a}->{'ORDER'}
                    <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                    || $a <=> $b
            } keys %{ $this->{'field_obj'} }
            )
        {
            $form
                .= '<option value="'
                . $id . '"'
                . (
                (   defined $main::data{ $this->{'id'} }{'mailto'}
                        && $main::data{ $this->{'id'} }{'mailto'} eq $id
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . $this->{'field_obj'}{$id}->{'name'}
                . ' に送信</option>'
                if ref $this->{'field_obj'}{$id}
                && $this->{'field_obj'}{$id}->{'e-mail'};
        }
        $form .= '<option value="master"'
            . (
            (   defined $main::data{ $this->{'id'} }{'mailto'}
                    && $main::data{ $this->{'id'} }{'mailto'} eq 'master'
            ) ? ' selected="selected"' : ''
            )
            . '>管理人アドレス に送信</option>'
            if $this->{'mailtoMaster'}
            || $this->{'mailtoOwners'}
            || $this->{'mailtoStaff'};
    }
    else {
        $form .= '<option value="master"'
            . (
            (   defined $main::data{ $this->{'id'} }{'mailto'}
                    && $main::data{ $this->{'id'} }{'mailto'} eq 'master'
            ) ? ' selected="selected"' : ''
            ) . '>管理人アドレス に送信</option>';
    }
    $form .= '<option value=""'
        . (
        (   !defined $main::data{ $this->{'id'} }{'mailto'}
                || $main::data{ $this->{'id'} }{'mailto'} eq ''
        ) ? ' selected="selected"' : ''
        ) . '>使用停止</option>';
    $form .= '</select></dd>';

    if ( defined $this->{'autores'} && $this->{'autores'} ) {
        $form
            .= '<dt><label for="data:'
            . $this->{'id'}
            . ':ressubject">自動返信メールの表題</label></dt>';
        $form
            .= '<dd><input type="text" name="data:'
            . $this->{'id'}
            . ':ressubject" id="data:'
            . $this->{'id'}
            . ':ressubject" value="'
            . $this->escape( $main::data{ $this->{'id'} }{'ressubject'} )
            . '" size="40" title="自動返信メールの表題を設定します。" /></dd>';
        $form
            .= '<dt><label for="data:'
            . $this->{'id'}
            . ':resmsg">自動返信メールの本文</label></dt>';
        $form
            .= '<dd><textarea name="data:'
            . $this->{'id'}
            . ':resmsg" id="data:'
            . $this->{'id'}
            . ':resmsg" rows="5" cols="40" title="自動返信メールの本文を設定します。" wrap="soft">'
            . $this->escape( $main::data{ $this->{'id'} }{'resmsg'} )
            . '</textarea>';
        $form .= '<div class="toolbox">';
        $form
            .= '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:'
            . $this->{'id'}
            . ':resmsg\').quotationByMenu(this)" title="これらのタグは自動返信メール送信時に対応する値に変換されます。">';
        $form .= '<option value="">▼挿入する</option>';
        $form
            .= '<option value="&lt;name&gt;">&lt;name&gt;[送信者の名前]</option>';
        $form
            .= '<option value="&lt;msg&gt;">&lt;msg&gt;[送信された本文]</option>';
        $form
            .= '<option value="&lt;url&gt;">&lt;url&gt;[問い合わせ発信元レコードのURL]</option>';
        $form .= '</select>';
        $form .= '</div>';
        $form
            .= '<div class="hints">文章が長すぎると設定が保存されない場合があります。</div></dd>';
        $quotmenu_flag = 1;
    }
    if ( defined $this->{'usrthanks'} && $this->{'usrthanks'} ) {
        $form
            .= '<dt><label for="data:'
            . $this->{'id'}
            . ':thankstitle">送信お礼のタイトル</label></dt>';
        $form
            .= '<dd><input type="text" name="data:'
            . $this->{'id'}
            . ':thankstitle" id="data:'
            . $this->{'id'}
            . ':thankstitle" value="'
            . $this->escape( $main::data{ $this->{'id'} }{'thankstitle'} )
            . '" size="40" title="送信お礼のタイトルを設定します。" /></dd>';
        $form
            .= '<dt><label for="data:'
            . $this->{'id'}
            . ':thanks">送信お礼文</label></dt>';
        $form
            .= '<dd><textarea name="data:'
            . $this->{'id'}
            . ':thanks" id="data:'
            . $this->{'id'}
            . ':thanks" rows="5" cols="40" title="この送信お礼はメールの送信後に表示されます。" wrap="soft">'
            . $this->escape( $main::data{ $this->{'id'} }{'thanks'} )
            . '</textarea>';
        $form .= '<div class="toolbox">';
        $form
            .= '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:'
            . $this->{'id'}
            . ':thanks\').quotationByMenu(this)" title="これらのタグは送信お礼表示時に対応する値に変換されます。">';
        $form .= '<option value="">▼挿入する</option>';
        $form
            .= '<option value="&lt;name&gt;">&lt;name&gt;[送信者の名前]</option>';
        $form
            .= '<option value="&lt;msg&gt;">&lt;msg&gt;[送信された本文]</option>';
        $form
            .= '<option value="&lt;url&gt;">&lt;url&gt;[問い合わせ発信元レコードのURL]</option>';
        $form .= '</select>';
        $form .= '</div>';
        $form
            .= '<div class="hints">文章が長すぎると設定が保存されない場合があります。</div></dd>';
        $quotmenu_flag = 1;
    }
    $form .= '</dl>';

    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    if (   $main::data{ $this->{'id'} }{'mailto'}
        && $main::data{ $this->{'id'} }{'mailto'} ne 'master' )
    {
        if ( !ref $this->{'field_obj'}
            { $main::data{ $this->{'id'} }{'mailto'} }
            || !$this->{'field_obj'}{ $main::data{ $this->{'id'} }{'mailto'} }
            ->{'e-mail'}
            || !$main::data{ $main::data{ $this->{'id'} }{'mailto'} }{'str'} )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( $this->{'name'} )
                    ? $this->{'name'}
                    : '問い合わせボタン'
                    )
                    . 'の送信先がみつかりません。'
            ) if ref $cgi::action;
            $this->{'is_invalid_field'}{'mailto'} = 1;
            return 0;
        }
    }

    #データ整形
    $this->data;
    return 1;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=表示するデータ/path=ファイル保存ディレクトリ/category=カテゴリー/no=レコードNo
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    if (   $this->{'period'}
        && ref $this->{'field_obj'}->{ $this->{'period'} }
        && $this->{'field_obj'}->{ $this->{'period'} }->{'class'}
        && $this->{'field_obj'}->{ $this->{'period'} }->{'class'} eq
        'time_span' )
    {
        my $db = $this->{'field_obj'}->{ $this->{'period'} }->db;
        if ($db) {
            my $period;
            if ( ref $cgi::action && ref $cgi::action->{'DB'} ) {
                if ( !ref tied %{ $cgi::action->{'DB'}{$c}{$db} } ) {
                    tie( %{ $cgi::action->{'DB'}{$c}{$db} },
                        $env::dbm_file, "$default::db/$c/$db", O_RDONLY,
                        $env::dbm_mode );
                }
                $period = $this->decode_utf8(
                    $cgi::action->{'DB'}{$c}{$db}{ $this->encode_utf8($n) } );
            }
            else {
                my %db;
                tie( %db, $env::dbm_file, $default::db . '/' . $c . '/' . $db,
                    O_RDONLY, $env::dbm_mode );
                if ( ref tied %db ) {
                    $period
                        = $this->decode_utf8( $db{ $this->encode_utf8($n) } );
                }
                untie %db;
            }
            use Time::Local;
            if (   $period
                && $period
                =~ m!^([0-9]{0,4})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2}) \- ([0-9]{0,4})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})!
                )
            {
                my $start = ($1)
                    ? timelocal(
                    ( $6 || 0 ),
                    ( $5 || 0 ),
                    ( $4 || 0 ),
                    ( $3 || 1 ),
                    ( ($2) ? $2 - 1 : 0 ), $1
                    )
                    : 0;
                my $end = ($7)
                    ? timelocal(
                    ( $12 || 0 ),
                    ( $11 || 0 ),
                    ( $10 || 0 ),
                    ( $9  || 1 ),
                    ( ($8) ? $8 - 1 : 0 ), $7
                    )
                    : 0;
                my $now = time;
                if ( $start > $now || ( $end && $end < $now ) ) {
                    return $this->{'unavailableMessage'} || '';
                }
            }
        }
    }

    my (%data);
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return $this->field_tag('')
        if !defined $data{'mailto'} || $data{'mailto'} eq '';
    my ( $image, $href, $option, $target );
    if ( !defined $cgi::path || $cgi::path eq '' ) {
        $cgi::path = $ENV{'SCRIPT_NAME'};
        $cgi::path = $env::cgi_server . $cgi::path
            if defined $env::cgi_server && $env::cgi_server;
    }
    $href
        = $cgi::path
        . '?m=Inquiry&c='
        . $c . '&n='
        . $n . '&mf='
        . $this->{'id'} . '&mod='
        . $main::m
        . $this->set_query(
        'url+',
        [   grep( $_ ne 'm'
                    && $_ ne 'k'
                    && $_ ne 'c'
                    && $_ ne 'n'
                    && $_ ne 'mod'
                    && $_ ne 'ct'
                    && $_ ne 'dn'
                    && $_ ne 'uni',
                @setting::form )
        ]
        );
    if ( !defined $this->{'sameWindow'} || !$this->{'sameWindow'} ) {
        $option
            = 'onclick="if(typeof cmonos == \'object\'){cmonos.window.open(\'inquiryWindow\','
            . ( ( $this->{'windowWidth'} ) ? $this->{'windowWidth'} : '640' )
            . ','
            . (
            ( $this->{'windowHeight'} ) ? $this->{'windowHeight'} : '480' )
            . ')}else{window.open(\'\',\'inquiryWindow\',\'width='
            . ( ( $this->{'windowWidth'} ) ? $this->{'windowWidth'} : '640' )
            . ',height='
            . (
            ( $this->{'windowHeight'} ) ? $this->{'windowHeight'} : '480' )
            . ',scrollbars=yes,resizable=yes\')} return true"';
        $target = 'inquiryWindow';
    }

    #画像タグ
    if ( $this->{'button'} && $main::m ne 'KMLViewer' ) {
        $href = $cgi::Deco->button( 'email', $this->{'button'}, $href,
            $this->name(1), $target, $option, $cgi::output_option );

    }
    else {
        $href
            = '<a href="'
            . $href . '"'
            . ( ($target) ? ' target="detailViewer"' : '' )
            . ' title="" '
            . $option;
        $href .= '>' . $this->name(1) . '</a>';
    }

    return $this->field_tag( $this->data_tag_from_ref( \%data ) . $href );
}

sub has_content {
    my ( $this, $str ) = @_;
    return 0 if !defined $str || $str eq '';
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return ( %data && $data{'mailto'} ) ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
    my $this = shift;
    return 0;
}

sub format_for_mail {
    my ( $this, $str ) = @_;
    return;
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text_enabled ($) {
    my $this = shift;
    return 0;
}

sub format_for_text {
    my ( $this, $str ) = @_;
    return;
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return 1;
}

sub confirmation ($$) {
    my ( $this, $str ) = @_;
    return '' if !defined $str || $str eq '';
    my ( %data, $form );
    %data = $this->elements($str);
    $form = '<dl class="confirmation">';
    if ( defined $this->{'mailtoUser'} && $this->{'mailtoUser'} ) {
        $form .= '<dt>送信先</dt><dd>'
            . (
            ( $data{'mailto'} eq '' ) ? '使用停止'
            : ( ( $data{'mailto'} eq 'master' )
                ? '管理人アドレス に送信'
                : ( ( ref $this->{'field_obj'}{ $data{'mailto'} } )
                    ? $this->{'field_obj'}{ $data{'mailto'} }->{'name'}
                        . ' に送信'
                    : '使用停止' )
            )
            ) . '</dd>';
    }
    else {
        $form
            .= '<dt>送信先</dt><dd>'
            . ( ( $data{'mailto'} eq 'master' )
            ? '管理人アドレス に送信'
            : '使用停止' )
            . '</dd>';
    }
    if ( defined $this->{'autores'} && $this->{'autores'} ) {
        $form .= '<dt>自動返信メールの表題</dt><dd>'
            . $this->escape( $data{'ressubject'} ) . '</dd>';
        $form .= '<dt>自動返信メールの本文</dt><dd>'
            . $this->escape( $data{'resmsg'} ) . '</dd>';
    }
    if ( defined $this->{'usrthanks'} && $this->{'usrthanks'} ) {
        $form .= '<dt>送信お礼のタイトル</dt><dd>'
            . $this->escape( $data{'thankstitle'} ) . '</dd>';
        $form .= '<dt>送信お礼文</dt><dd>'
            . $this->escape( $data{'thanks'} ) . '</dd>';
    }
    $form .= '</dl>';
    return $form;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    #ボタンメニュー
    print '<fieldset>';
    print '<legend>表示設定</legend>';
    print '<fieldset>';
    print '<legend><label for="${name}_button">ボタン</label></legend>';

    print $cgi::Deco->button_menu( $name . '_button',
        'email', 120, $this->{'button'} );

    print '</fieldset>';
    print '<fieldset>';
    print '<legend>問い合わせウィンドウ</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_sameWindow" id="'
        . $name
        . '_sameWindow" value="1"'
        . ( ( defined $this->{'sameWindow'} && $this->{'sameWindow'} )
        ? ' checked="checked"'
        : '' )
        . ' onclick="cmonos.element.item(\'windowsize\').disappear(this.checked)" /> 別ウィンドウを開かず同じウィンドウに表示する</label></li>';
    print '</ol>';
    print '<fieldset id="windowsize">';
    print
        '<legend>ウィンドウサイズ(同じウィンドウに表示する場合無効)</legend>';
    print '<label>幅 <input type="text" name="'
        . $name
        . '_windowWidth" id="'
        . $name
        . '_windowWidth" value="'
        . $this->escape( $this->{'windowWidth'} )
        . '" size="7" maxlength="7" /> <span class="unit">ピクセル</span></label> ';
    print '&times; <label>高さ <input type="text" name="'
        . $name
        . '_windowHeight" id="'
        . $name
        . '_windowHeight" value="'
        . $this->escape( $this->{'windowHeight'} )
        . '" size="7" maxlength="7" /> <span class="unit">ピクセル</span></label> ';
    print '</fieldset>';
    print $this->javascript(
        'cmonos.element.item(\'windowsize\').disappear(true)')
        if $this->{'sameWindow'};
    print '</fieldset>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>問い合わせメール設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_mailtoMaster">送信先</label></td>';
    print '<td class="field"><ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_mailtoMaster" value="1"'
        . ( ( defined $this->{'mailtoMaster'} && $this->{'mailtoMaster'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 管理人アドレス</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_mailtoOwners" value="1"'
        . ( ( defined $this->{'mailtoOwners'} && $this->{'mailtoOwners'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 共同オーナーアドレス</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_mailtoStaff" value="1"'
        . ( ( defined $this->{'mailtoStaff'} && $this->{'mailtoStaff'} )
        ? ' checked="checked"'
        : '' )
        . ' /> スタッフアドレス</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_mailtoUser" value="1"'
        . ( ( defined $this->{'mailtoUser'} && $this->{'mailtoUser'} )
        ? ' checked="checked"'
        : '' )
        . ' /> ユーザー指定アドレス</label></li>';
    print '</ol></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_mailtoDefault">送信先のデフォルト</label></td>';
    print '<td class="field">';
    print '<select name="'
        . $name
        . '_mailtoDefault" id="'
        . $name
        . '_mailtoDefault">';

    if ( defined $this->{'mailtoUser'} && $this->{'mailtoUser'} ) {
        foreach my $id (
            sort {
                $this->{'field_obj'}->{$a}->{'ORDER'}
                    <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                    || $a <=> $b
            } keys %{ $this->{'field_obj'} }
            )
        {
            print '<option value="'
                . $id . '"'
                . (
                (   defined $this->{'mailtoDefault'}
                        && $this->{'mailtoDefault'} eq $id
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . $this->{'field_obj'}{$id}->{'name'}
                . ' に送信</option>'
                if ref $this->{'field_obj'}{$id}
                && $this->{'field_obj'}{$id}->{'e-mail'};
        }
        print '<option value="master"'
            . (
            (   defined $this->{'mailtoDefault'}
                    && $this->{'mailtoDefault'} eq 'master'
            ) ? ' selected="selected"' : ''
            )
            . '>管理人アドレス に送信</option>'
            if $this->{'mailtoMaster'}
            || $this->{'mailtoOwners'}
            || $this->{'mailtoStaff'};
    }
    else {
        print '<option value="master"'
            . (
            (   defined $this->{'mailtoDefault'}
                    && $this->{'mailtoDefault'} eq 'master'
            ) ? ' selected="selected"' : ''
            ) . '>管理人アドレス に送信</option>';
    }
    print '<option value=""'
        . (
        (   !defined $this->{'mailtoDefault'}
                || $this->{'mailtoDefault'} eq ''
        ) ? ' selected="selected"' : ''
        ) . '>使用停止</option>';
    print '</select>';
    print '</td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_subject">メールの表題</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_subject" id="'
        . $name
        . '_subject" value="'
        . $this->escape( $this->{'subject'} )
        . '" size="50" title="デフォルトの表題を設定します。" />';
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">連続送信の制限</span></td>';
    print
        '<td class="field"><label><input type="number" size="3" maxlength="3" name="'
        . $name
        . '_ipStopper" id="'
        . $name
        . '_ipStopper" value="'
        . $this->escape( $this->{'ipStopper'} )
        . '" /> 秒間、同一IPからの送信を禁止する</label></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>問い合わせ受付期間</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_period">期間参照フィールド</label></td>';
    print '<td class="field">';
    my $period_menu = '';

    foreach my $id (
        sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
        } keys %{ $this->{'field_obj'} }
        )
    {
        $period_menu
            .= '<option value="'
            . $id . '"'
            . ( ( defined $this->{'period'} && $this->{'period'} eq $id )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $this->{'field_obj'}{$id}->{'name'}
            . '</option>'
            if ref $this->{'field_obj'}{$id}
            && $this->{'field_obj'}{$id}->{'class'}
            && $this->{'field_obj'}{$id}->{'class'} eq 'time_span';
    }
    if ($period_menu) {
        print '<select name="'
            . $name
            . '_period" id="'
            . $name
            . '_period">';
        print '<option value=""'
            . ( ( !defined $this->{'period'} || $this->{'period'} eq '' )
            ? ' selected="selected"'
            : '' )
            . '>&lt;指定しない&gt;</option>';
        print $period_menu;
        print '</select>';
    }
    else {
        print '「期間」フィールドがみつかりません。';
    }
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_unavailableMessage">受付期間外メッセージ</label></td>';
    print '<td class="field"><textarea name="'
        . $name
        . '_unavailableMessage" id="'
        . $name
        . '_unavailableMessage" rows="4" cols="56" title="受付期間外のとき表示するメッセージを設定します。" wrap="soft">'
        . $this->escape( $this->{'unavailableMessage'} )
        . '</textarea>';
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>自動返信メール設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">個別設定の許可</span></td>';
    print '<td class="field"><label><input type="checkbox" name="'
        . $name
        . '_autores" id="'
        . $name
        . '_autores" value="1" size="50"'
        . ( ( defined $this->{'autores'} && $this->{'autores'} )
        ? ' checked="checked"'
        : '' )
        . ' /> レコードごとに自動返信メールを設定する</label></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_ressubject">自動返信メールの表題</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_ressubject" id="'
        . $name
        . '_ressubject" value="'
        . $this->escape( $this->{'ressubject'} )
        . '" size="56" title="自動返信メールの表題を設定します。" /></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_resmsg">自動返信メールの本文</label></td>';
    print '<td class="field"><textarea name="'
        . $name
        . '_resmsg" id="'
        . $name
        . '_resmsg" rows="10" cols="56" title="自動返信メールの本文を設定します。" wrap="soft">'
        . $this->escape( $this->{'resmsg'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_resmsg\').quotationByMenu(this)" title="これらのタグは自動返信メール送信時に対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print
        '<option value="&lt;name&gt;">&lt;name&gt;[差出人フィールドの値]</option>';
    print
        '<option value="&lt;msg&gt;">&lt;msg&gt;[送信された本文]</option>';
    print
        '<option value="&lt;url&gt;">&lt;url&gt;[問い合わせ発信元レコードのURL]</option>';
    print '</select>';
    print '</div>';
    print
        '<div class="hints">文章が長すぎると設定が保存されない場合があります。</div>';
    print '</td></tr>';
    print '</tbody></table>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>送信お礼設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print
        '<tr><td class="field-name"><span class="datatitle">個別設定の許可</span></td>';
    print '<td class="field"><label><input type="checkbox" name="'
        . $name
        . '_usrthanks" id="'
        . $name
        . '_usrthanks" value="1" size="50"'
        . ( ( defined $this->{'usrthanks'} && $this->{'usrthanks'} )
        ? ' checked="checked"'
        : '' )
        . ' /> レコードごとに送信お礼を設定する</label></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_thankstitle">送信お礼タイトル</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_thankstitle" id="'
        . $name
        . '_thankstitle" value="'
        . $this->escape( $this->{'thankstitle'} )
        . '" size="56" title="送信お礼のタイトルを設定します。" /></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_thanks">送信お礼文</label></td>';
    print '<td class="field"><textarea name="'
        . $name
        . '_thanks" id="'
        . $name
        . '_thanks" rows="10" cols="56" title="この送信お礼はメールの送信後に表示されます。" wrap="soft">'
        . $this->escape( $this->{'thanks'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_thanks\').quotationByMenu(this)" title="以下のタグは送信お礼表示時に対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print
        '<option value="&lt;name&gt;">&lt;name&gt;[差出人フィールドの値]</option>';
    print
        '<option value="&lt;msg&gt;">&lt;msg&gt;[送信された本文]</option>';
    print '</select>';
    print '</div>';
    print
        '<div class="hints">文章が長すぎると設定が保存されない場合があります。</div>';
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';
    $this->print_setting_save_button;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;
    $main::data{ $this->{'id'} . '_mailtoMaster' } = ''
        if !defined $main::data{ $this->{'id'} . '_mailtoMaster' }
        || $main::data{ $this->{'id'} . '_mailtoMaster' } eq '';
    $main::data{ $this->{'id'} . '_mailtoOwners' } = ''
        if !defined $main::data{ $this->{'id'} . '_mailtoOwners' }
        || $main::data{ $this->{'id'} . '_mailtoOwners' } eq '';
    $main::data{ $this->{'id'} . '_mailtoStaff' } = ''
        if !defined $main::data{ $this->{'id'} . '_mailtoStaff' }
        || $main::data{ $this->{'id'} . '_mailtoStaff' } eq '';
    $main::data{ $this->{'id'} . '_mailtoUser' } = ''
        if !defined $main::data{ $this->{'id'} . '_mailtoUser' }
        || $main::data{ $this->{'id'} . '_mailtoUser' } eq '';
    $main::data{ $this->{'id'} . '_autores' } = ''
        if !defined $main::data{ $this->{'id'} . '_autores' }
        || $main::data{ $this->{'id'} . '_autores' } eq '';
    $main::data{ $this->{'id'} . '_usrthanks' } = ''
        if !defined $main::data{ $this->{'id'} . '_usrthanks' }
        || $main::data{ $this->{'id'} . '_usrthanks' } eq '';
    $main::data{ $this->{'id'} . '_sameWindow' } = ''
        if !defined $main::data{ $this->{'id'} . '_sameWindow' }
        || $main::data{ $this->{'id'} . '_sameWindow' } eq '';
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_unavailableMessage' } )
        if defined $main::data{ $this->{'id'} . '_unavailableMessage' }
        && $main::data{ $this->{'id'} . '_unavailableMessage' };

    if (   defined $main::data{ $this->{'id'} . '_windowWidth' }
        && $main::data{ $this->{'id'} . '_windowWidth' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_windowWidth' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '問い合わせウィンドウ幅を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_windowWidth' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_windowHeight' }
        && $main::data{ $this->{'id'} . '_windowHeight' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_windowHeight' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '問い合わせウィンドウ高さを更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_windowHeight' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_ipStopper' }
        && $main::data{ $this->{'id'} . '_ipStopper' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_ipStopper' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '連続送信制限秒数を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_ipStopper' };
        $is_valid = 0;
    }
    return 1;
}

######################################################################
#	(6) obj->search_form;
sub search_form_enabled ($) {
    my $this = shift;
    return 0;
}

sub search_form ($) {
    my $this = shift;
    return;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);
    if ( !$setting::field_for_mail ) {
        Field::class_register( 'xtm_inq', 'InquiryButton',
            '問い合わせボタン' );
        $setting::deco_dir{'email'} = 'Eメールボタン'
            if !defined $setting::deco_dir{'email'};
        $setting::deco_type{'email'} = 'button'
            if !defined $setting::deco_type{'email'};
    }
}

1;
