package SCNumericalData;
require CMONOS::CGI_Lib::Field::Num;
@ISA = qw(Num);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（ユーザー情報）
# SCNumericalData.pm 1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    $this->__set($setting);
    return;
}

sub __set ($$) {
    my ( $this, $setting ) = @_;
    return;
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
    my $this = shift;
    return 0;
}

sub form {
    my $this = shift;
    return '';
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    return 1;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form( $name, 1 );

    print '<fieldset>';
    print '<legend>表示設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_unit">単位</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_unit" id="'
        . $name
        . '_unit" value="'
        . $this->escape( $this->{'unit'} )
        . '" size="8" title="入力する内容に適した単位を設定します。" />';
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><input type="checkbox" name="'
        . $name
        . '_comma" id="'
        . $name
        . '_comma" value="1"'
        . ( ( defined $this->{'comma'} && $this->{'comma'} )
        ? ' checked="checked"'
        : '' )
        . ' /></td>';
    print '<td class="field"><label for="' . $name
        . '_comma">三桁ごとに位取りする</label></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    $this->print_sub_setting_form($name);

    print '<fieldset>';
    print '<legend>検索設定</legend>';
    print '<label><input type="checkbox" name="'
        . $name
        . '_searchOption" value="1"'
        . ( ( defined $this->{'searchOption'} && $this->{'searchOption'} )
        ? ' checked="checked"'
        : '' )
        . ' /> より詳しい検索</label>';
    print '</fieldset>';

    #文字設定
    $this->print_font_setting_form($name);
    $this->print_setting_save_button;
    return;
}

sub print_sub_setting_form ($$) {
    my ( $this, $name ) = @_;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = $this->is_valid_font_setting;
    $is_valid = 0 if !$this->is_valid_sub_setting;
    $this->tag_fix( \$main::data{ $this->{'id'} . '_unit' }, 2 )
        if ref $this && $main::data{ $this->{'id'} . '_unit' };
    $main::data{ $this->{'id'} . '_searchOption' } = ''
        if !defined $main::data{ $this->{'id'} . '_searchOption' };
    $main::data{ $this->{'id'} . '_comma' } = ''
        if !defined $main::data{ $this->{'id'} . '_comma' };
    return $is_valid;
}

sub is_valid_sub_setting ($) {
    my $this = shift;
    return 1;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return 0;
}

1;
