package SCOrderManager;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# フィールドモジュール（購入商品担当者）
# SCOrderManager.pm 1.0.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-04-14
######################################################################
#	(0)-3 フィールドDB
sub db ($) {
    my $this = shift;
    return 'manager';
}

sub _set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'e-mail'} = 1;
    $this->{'field_for'}{'mail_address'} = []
        if !ref $this->{'field_for'}{'mail_address'};
    push( @{ $this->{'field_for'}{'mail_address'} }, $this->{'id'} );
    return;
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
    my $this = shift;
    return 0;
}

sub form {
    my ( $this, $status, $original, $path ) = @_;
    return '';
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
    my $this = shift;
    return 1;
}

######################################################################
# 後処理
sub settle_up ($;$) {
    my ( $this, $path ) = @_;
    return ( $this->save_manager_info( $main::c, $main::n ) ) ? 1 : 0;
}

sub save_manager_info ($$$) {
    my ( $this, $c, $n ) = @_;
    my ( %db, $data );
    tie( %db, $env::dbm_file, "$default::db/$c/order", O_RDONLY,
        $env::dbm_mode );
    if ( ref tied %db ) {
        $data = $this->decode_utf8( $db{$n} );
    }
    untie %db;
    my $managers = '';
    if ($data) {
        $data =~ s/^(.*?)\x0A//;
        while ( $data =~ /^(.*)$/mg ) {
            next if !$1;
            my %item_data = ();
            $cgi::Session->read_data( \%item_data, $1 );
            if (   $item_data{'path'}
                && $item_data{'path'}
                =~ m!^\.\./([^/]+)/start\.cgi\?(?:pickup=1&|)m=[a-zA-Z]+(&c=([a-zA-Z0-9_]+)|)&n=([a-zA-Z0-9_]+)!
                )
            {
                my $email = $this->get_mailaddress_from_item( $1, $3, $4 );
                if ($email) {
                    my $name = $cgi::Register->get_name_from_email($email);
                    my $item = $item_data{'name'}
                        . (
                        (          $item_data{'key'}
                                && $item_data{'key'} ne $item_data{'name'}
                        ) ? ' [' . $item_data{'key'} . ']' : ''
                        )
                        . ( ( $item_data{'digitalcontent'} )
                        ? ' (' . $item_data{'digitalcontent'} . ')'
                        : '' );
                    my $path = $item_data{'path'};
                    $managers
                        .= $email . "\x09"
                        . $name . "\x09"
                        . $item . "\x09"
                        . $path . "\x0A";
                }
            }
        }
    }
    tie( %db, $env::dbm_file, "$default::db/$c/manager", O_RDWR | O_CREAT,
        $env::dbm_mode );
    if ( ref tied %db ) {
        $db{ $this->encode_utf8($n) }
            = $this->encode_utf8( $managers || 'NODATA' );
    }
    untie %db;
    return $managers;
}

sub get_mailaddress_from_item ($$$) {
    my ( $this, $dir, $c, $n ) = @_;
    my $path = "../$dir/default.pl";
    my $data = $this->read_file($path);
    if ( $data =~ /\$lib\s*=\s*['"]Calendar['"]/s ) {
        my $preference_dir
            = ( $data =~ /\$preference_dir\s*=\s*(.*?);/s )
            ? $this->un_base_change( eval $1, $path, 'rel', 1 )
            : '';
        my $field_pref_dir
            = ( $data =~ /\$field_pref_dir\s*=\s*(.*?);/s )
            ? $this->un_base_change( eval $1, $path, 'rel', 1 )
            : '';
        my $db
            = ( $data =~ /\$db\s*=\s*(.*?);/s )
            ? $this->un_base_change( eval $1, $path, 'rel', 1 )
            : '';
        my $subdivided = ( $data =~ /\$subdivided\s*=\s*1;/s ) ? 1 : 0;
        return '' if !$preference_dir || !$field_pref_dir || !$db;
        if ($subdivided) {
            return '' if !$c;
            $db .= '/' . $c;
            my $c_preference_dir = $preference_dir . '/' . $c;
            if ( -d $c_preference_dir ) {
                $field_pref_dir .= '/' . $c
                    unless $field_pref_dir
                    =~ s!^$preference_dir/!$c_preference_dir/!;
                $preference_dir = $c_preference_dir;
            }
            else {
                return '';
            }
        }
        my ( %db, $mailid, @email );
        tie( %db, $env::dbm_file, $field_pref_dir . '/inputfield',
            O_RDONLY, $env::dbm_mode );
        if ( ref tied %db ) {
            $mailid = $this->decode_utf8( $db{'for_mail'} );
        }
        untie %db;
        return '' if !$mailid;
        tie( %db, $env::dbm_file, $db . '/' . $mailid,
            O_RDONLY, $env::dbm_mode );
        if ( ref tied %db && $db{$n} ) {
            @email = $this->get_address( $this->decode_utf8( $db{$n} ) );
        }
        untie %db;
        return ( @email && $email[0] ) ? $email[0] : '';
    }
    return '';
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    $str = $this->save_manager_info( $c, $n ) if !$str;
    return ( $str && $str ne 'NODATA' )
        ? $this->style(
        $this->manager_info($str), $this->{'style'},
        $this->{'fontsize'},       $this->{'fontcolor'},
        $this->{'fontface'}
        )
        : '';
}

sub manager_info ($$$) {
    my ( $this, $data, $is_text ) = @_;
    return '' if $data eq 'NODATA';
    my $info = ($is_text) ? '' : '<ul>';
    while ( $data =~ /^(.*)$/mg ) {
        my $line = $1;
        chomp $line;
        my ( $email, $name, $item, $path ) = split( /\x09/, $line );
        if ($is_text) {
            $info
                .= ( ( $name ne '' ) ? $name . ' <' . $email . '>' : $email )
                . "\x0A" . '('
                . $item . ')' . "\x0A"
                . $this->full_path($path)
                . "\x0A\x0A";
        }
        else {
            $info
                .= '<li>'
                . ( ( $name ne '' )
                ? $name
                    . ' &lt;<a href="mailto:'
                    . $email . '">'
                    . $email
                    . '</a>&gt;'
                : '<a href="mailto:' . $email . '">' . $email . '</a>' )
                . ' (<a href="'
                . $this->escape($path) . '">'
                . $this->escape($item)
                . '</a>)</li>';
        }
    }
    $info =~ s/\s+$//s;
    $info .= '</ul>' if !$is_text;
    return $info;
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ( !defined $str || $str eq '' || $str eq 'NODATA' )
        ? ''
        : '['
        . $this->name . "]\x0A"
        . $this->manager_info( $str, 1 )
        . "\x0A\x0A";
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ( !defined $str || $str eq '' || $str eq 'NODATA' )
        ? ''
        : $this->manager_info( $str, 1 );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my $name = 'data:' . $this->{'id'};
    $this->print_field_info_form($name);
    $this->print_ignorecase_setting_form($name);
    $this->print_font_setting_form($name);
    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_ignoreCase' } = ''
        if !$main::data{ $this->{'id'} . '_ignoreCase' };
    return $this->is_valid_font_setting;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);
    if (   defined $default::type
        && $default::type eq 'order'
        && defined $env::checkout
        && $env::checkout
        && !$setting::field_for_mail )
    {
        Field::class_register( 'yorder_manager', 'SCOrderManager',
            '購入商品担当者' );
        push( @field::redundancy_forbidden, 'yorder_manager' );
    }
}

1;
