package SCOrderShippingInfo;
require CMONOS::TableMaker::Field::TMUserGeneratedField;
require CMONOS::CGI_Lib::Field;
@ISA = qw(TMUserGeneratedField Field);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# 配送情報モジュール
# SCOrderShippingInfo.pm 1.0.6
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-08-12
######################################################################
%SCOrderShippingInfo::url = (
    'クロネコヤマト' =>
        'http://toi.kuronekoyamato.co.jp/cgi-bin/tneko?init',
    'クロネコヤマト・メール便' =>
        'http://toi.kuronekoyamato.co.jp/cgi-bin/tneko?init',
    'クロネコヤマト・メール便(速達)' =>
        'http://toi.kuronekoyamato.co.jp/cgi-bin/tneko?init',
    '佐川急便' =>
        'http://k2k.sagawa-exp.co.jp/p/sagawa/web/okurijoinput.jsp',
    '福山通運' => 'http://corp.fukutsu.co.jp/situation/tracking_no',
    'ゆうパック' =>
        'https://trackings.post.japanpost.jp/services/srv/search/input',
    'ゆうメール' =>
        'https://trackings.post.japanpost.jp/services/srv/search/input'
);
######################################################################
#	(0)-3 フィールドDB
sub db ($) {
    my $this = shift;
    return 'shipping';
}

# --------------------------------------------------------------------
sub _set ($$) {
    my $this = shift;
    unless ( ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }
    @{ $this->{'authorities'} } = $this->get_address( $this->{'authority'} );
    $this->scalar_to_array( \$this->{'order'} );
    $this->import_db( $default::preference_dir . '/terms',
        \%setting::payment, 1 )
        if !%setting::payment;
    $this->{'field_for'}{'shipping_info'} = $this->{'id'};
    $this->scalar_to_array( \$this->{'mailto'} );
    $this->{'datetype'}
        = ( ( $setting::general{'datetype'} )
        ? $setting::general{'datetype'}
        : '' )
        if !$this->{'datetype'};
    $setting::general{'itemname'} = '商品'
        if !$setting::general{'itemname'};
    return;
}

sub mk_table_object ($$) {
    my ( $this, $id ) = @_;
    my $table;
    if ($id) {
        if ( ref $table::obj{$id} ) {
            $table = $table::obj{$id};
        }
        elsif ( ref $setting::table{$id} ) {
            $this->use_table;
            $table = $table::obj{$id};
        }
    }
    if ( !ref $table ) {
        $table = Table->new;
        $table->set(
            'tableclass' => 'datatable',
            'trclass'    => 'odd,even',
            'class0'     => 'odd,even',
        );
    }
    return $table;
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'service'} );
    return (
        (   ref $main::search{ $this->{'id'} }{'service'}
                && @{ $main::search{ $this->{'id'} }{'service'} }
        )
            || $main::search{ $this->{'id'} }{'shipped'}
            || $main::search{ $this->{'id'} }{'number'}
    ) ? 1 : 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    return 1 if !$this->match_enabled;
    $this->data_update($str);
    if ( $main::search{ $this->{'id'} }{'number'} ) {
        @{ $this->{'pattern'} }
            = split( /\s+/, $main::search{ $this->{'id'} }{'number'} )
            if !ref $this->{'pattern'};
        return ( $$str
                && grep( $$str =~ /\t$_\t/s, @{ $this->{'pattern'} } ) )
            ? 1
            : 0;
    }
    else {
        return (
            (   !$main::search{ $this->{'id'} }{'shipped'}
                    || ( $main::search{ $this->{'id'} }{'shipped'} eq 'true'
                    && $$str =~ /^[^\x09\x0A\x0D]*?\x09\S+/ )
                    || ( $main::search{ $this->{'id'} }{'shipped'} eq 'false'
                    && $$str !~ /^[^\x09\x0A\x0D]*?\x09\S+/ )
            )
                && (
                !@{ $main::search{ $this->{'id'} }{'service'} }
                || grep( $$str =~ /\t$_\t/si,
                    @{ $main::search{ $this->{'id'} }{'service'} } )
                )
        ) ? 1 : 0;
    }
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status, $original, $path ) = @_;
    my $service
        = ( $main::data{ $this->{'id'} }{'service'} )
        ? $main::data{ $this->{'id'} }{'service'}
        : (    $main::data{ $this->{'id'} }{'str'}
            && $main::data{ $this->{'id'} }{'str'} =~ /^([^\x09\x0A\x0D]*)/s )
        ? $1
        : '';
    my $shipped
        = (    $main::data{ $this->{'id'} }{'str'}
            && $main::data{ $this->{'id'} }{'str'}
            =~ /^[^\x09\x0A\x0D]*\x09(\S*)/s ) ? $1 : '';
    my $form = $this->field_header;
    if ( ref $cgi::action && $cgi::action->{'noshipping_only'} ) {
        $form
            .= ( $cgi::action->{'noshipping_only'} == 2 )
            ? ($default::english)
                ? 'Download Only.'
                : 'ダウンロード'
            : ($default::english) ? 'No Shipping Only.'
            :                       '配送不要';
    }
    elsif ($shipped) {
        $form .= $this->shipping_info( $main::c, $main::n,
            \$main::data{ $this->{'id'} }{'str'} );
    }
    else {
        $form .= $this->delivery_service_menu(
            'data:' . $this->{'id'} . ':service',
            [$service], $this->{'is_invalid_field'},
            0, $cgi::action
        );
    }
    $form .= $this->field_footer;
    return $form;
}

sub delivery_service_menu ($$$$;$$$) {
    my ( $this, $name, $data, $is_invalid, $is_multiple, $cgi_action ) = @_;
    my $form = '';
    if (   !ref $this->{'order'}
        || !@{ $this->{'order'} }
        || @{ $this->{'order'} } == 1 )
    {
        $form
            .= ($is_multiple)
            ? ''
            : ( defined $this->{'order'}[0] )
            ? ( $this->{'service'}{ $this->{'order'}[0] }{'name'} )
                ? $this->{'service'}{ $this->{'order'}[0] }{'name'}
                : $this->{'service'}{ $this->{'order'}[0] }{'service'}
            : '';
    }
    else {
        $form
            = '<select name="'
            . $name . '"'
            . ( ($is_multiple) ? ' multiple="multiple"'
            : ( $this->{'required'} ) ? ' required="required"'
            :                           '' )
            . ( ($is_invalid) ? $this->set_invalid_class : '' ) . '>';
        foreach my $id ( @{ $this->{'order'} } ) {
            my $service
                = ( $this->{'service'}{$id}{'name'} )
                ? $this->{'service'}{$id}{'name'}
                : $this->{'service'}{$id}{'service'};
            if (!ref $cgi_action
                || ((      !$cgi_action->{'weight_lacked'}
                        || !$setting::payment{'yuumail'}
                        || $service !~ /ゆうメール/
                    )
                    && (   !$cgi_action->{'papersize_lacked'}
                        || !$setting::payment{'mailbin'}
                        || $service !~ /メール便/ )
                )
                )
            {
                $form
                    .= '<option value="'
                    . $this->escape($service) . '"'
                    . (
                    (   ref $data
                            && grep( defined $_ && $_ eq $service, @$data )
                    ) ? ' selected="selected"' : ''
                    )
                    . '>'
                    . $this->escape($service)
                    . '</option>';
            }
        }
        $form .= '</select>';
    }
    if (   $setting::payment{'carriage'}
        && $setting::payment{'carriage'} eq 'weight'
        && $cgi_action->{'weight_lacked'} )
    {
        $form
            .= '<p class="warning">重量が設定されていない商品があるため、送料を計算できません。</p>';
    }
    if (   $setting::payment{'carriage'}
        && $setting::payment{'carriage'} eq 'papersize'
        && $cgi_action->{'papersize_lacked'} )
    {
        $form
            .= '<p class="warning">サイズが設定されていない商品があるため、送料を計算できません。</p>';
    }
    return $form;
}

sub shipping_info ($$$;$$) {
    my ( $this, $c, $n, $data_ref, $for_text, $order_info ) = @_;
    my ( $ajax, $service, $shipped, %shipped_item );
    $this->data_update($data_ref);
    return '' if !defined $c || !defined $n || !ref $data_ref || !$$data_ref;
    if ($order_info) {
        $ajax = 1;
    }
    else {
        $order_info = '';
        if ( ref $cgi::action && ref $cgi::action->{'DB'} ) {
            if ( !ref tied %{ $cgi::action->{'DB'}{$c}{'order'} } ) {
                tie( %{ $cgi::action->{'DB'}{$c}{'order'} },
                    $env::dbm_file, "$default::db/$c/order", O_RDONLY,
                    $env::dbm_mode );
            }
            $order_info = $this->decode_utf8(
                $cgi::action->{'DB'}{$c}{'order'}{ $this->encode_utf8($n) } );
        }
        else {
            my %db;
            tie( %db, $env::dbm_file, $default::db . '/' . $c . '/order',
                O_RDONLY, $env::dbm_mode );
            if ( ref tied %db ) {
                $order_info
                    = $this->decode_utf8( $db{ $this->encode_utf8($n) } );
            }
            untie %db;
        }
    }
    while ( $$data_ref =~ /^(.*)$/gm ) {
        my $data = $1;
        $data =~ s/\x0A$//;
        if ( !defined $service ) {
            $service = ( $data =~ /^([^\x09\x0A\x0D]*)/s )        ? $1 : '';
            $shipped = ( $data =~ /^[^\x09\x0A\x0D]*\x09(\S*)/s ) ? $1 : '';
        }
        else {
            my ( $t, $s, $num, $comment ) = split( /\x09/, $data, 4 );
            $shipped_item{$t} = {
                'service' => $s,
                'number'  => $num,
                'comment' => $comment,
            };
        }
    }
    return $service if !$order_info;
    my $is_manager
        = ( $this->is_secure_user && defined $n && $n ne '' ) ? 1 : 0;
    my $user_is_manager   = $is_manager;
    my $too_early         = 0;
    my $id                = $this->mk_user_generated_field_id( $c, $n );
    my $table             = $this->mk_table_object( $this->{'table'} );
    my $is_updated_record = $this->is_updated_record( $c, $n );
    my $content           = '';
    my $form              = '';

    if ( !$for_text && !$shipped && $is_manager ) {
        $form .= $this->form_start(
            'id'   => ( ($id) ? $id . '-form' : '' ),
            'name' => ( ($id) ? $id . '-form' : '' ),
            'method'   => 'post',
            'onsubmit' => 'return cmonos.form.item(this).submit(\''
                . $id . '\');',
            'required' => \@setting::form
        ) if !$ajax;
        $form .= '<input type="hidden" name="id" value="'
            . $this->{'id'} . '" />';
        $form .= '<input type="hidden" name="c" value="' . $c . '" />'
            if !grep( $_ eq 'c', @setting::form );
        $form .= '<input type="hidden" name="n" value="' . $n . '" />'
            if !grep( $_ eq 'n', @setting::form );
        $form .= $table->table;
        $form .= $table->tr;
        $form
            .= $table->th(
            '<input type="checkbox" onclick="cmonos.element.form(this.form).fieldname(\'ship:ship\').select(this.checked)" />配送'
            );
        $form .= $table->th( $setting::general{'itemname'} );
        $form .= $table->th('オプション');
        $form .= $table->th('数量');
        $form .= $table->_tr;
    }
    my $count      = 0;
    my $item_id    = 0;
    my $is_pending = 0;
    while ( $order_info =~ /^(.*)$/mg ) {
        next if !$1;
        my $i = $1;
        if ( !$item_id++ ) {
            if ( $this->{'waitForPayment'} && !( split( /\x09/, $i ) )[6] ) {
                $too_early  = 1;
                $is_manager = 0;
            }
            next;
        }
        next if $i =~ /^cancel\x09/;
        my %item_data = ();
        $cgi::Session->read_data( \%item_data, $i );
        my $quantity = $item_data{'quantity'};
        if (   defined $item_data{'newquantity'}
            && $item_data{'newquantity'} =~ /^[0-9]+$/
            && $item_data{'newquantity'} < $quantity )
        {
            $quantity   = $item_data{'newquantity'};
            $is_pending = 1;
        }
        next
            if $item_data{'digitalcontent'}
            || $item_data{'noshipping'}
            || !$quantity
            || $quantity < 0;
        if ($for_text) {
            my $data = $item_data{'name'}
                . (
                (          $item_data{'key'}
                        && $item_data{'key'} ne $item_data{'name'}
                ) ? ' [' . $this->escape( $item_data{'key'} ) . ']' : ''
                )
                . ( ( $item_data{'digitalcontent'} )
                ? ' (' . $this->escape( $item_data{'digitalcontent'} ) . ')'
                : '' );
            $data .= ' - ' . $item_data{'option'} if $item_data{'option'};
            $data .= ' × ' . $quantity . "\x0A";
            $shipped_item{ ( $item_data{'shipped'} || '0' ) }{'data'}
                .= $data;
        }
        else {
            my $name
                = '<a href="'
                . $this->escape( $item_data{'path'}
                    . ( ( $item_data{'anchor'} ) ? $item_data{'anchor'} : '' )
                )
                . '" target="_blank">'
                . $this->escape( $item_data{'name'} )
                . (
                (          $item_data{'key'}
                        && $item_data{'key'} ne $item_data{'name'}
                ) ? ' [' . $this->escape( $item_data{'key'} ) . ']' : ''
                )
                . '</a>'
                . ( ( $item_data{'digitalcontent'} )
                ? ' (' . $this->escape( $item_data{'digitalcontent'} ) . ')'
                : '' );
            my $option = $this->escape( $item_data{'option'} );
            if ( $item_data{'shipped'} || ( !$shipped && !$is_manager ) ) {
                my $sid = $item_data{'shipped'} || '0';
                $shipped_item{$sid} = {} if !ref $shipped_item{$sid};
                $shipped_item{$sid}{'data'} = []
                    if !ref $shipped_item{$sid}{'data'};
                push(
                    @{ $shipped_item{$sid}{'data'} },
                    {   'name'     => $name,
                        'option'   => $option,
                        'quantity' => $quantity,
                    }
                );
            }
            elsif ( !$shipped && $is_manager ) {
                $form .= $table->tr;
                $form .= $table->td(
                          '<input type="checkbox" name="ship:ship" value="'
                        . $item_id . '"'
                        . (
                        (          $main::ship{'ship'}
                                && ref $main::ship{'ship'}
                                && grep( $_ eq $item_id,
                                @{ $main::ship{'ship'} } )
                        ) ? ' checked="checked"' : ''
                        )
                        . ' />'
                ) if $is_manager;
                $form .= $table->td($name);
                $form .= $table->td($option);
                $form .= $table->td($quantity);
                $form .= $table->_tr;
            }
        }
        $count++;
    }
    if ( !$for_text ) {
        if ($is_pending) {
            $form
                = ($user_is_manager)
                ? '<p class="warning">キャンセルが申請されています。確認後、<a href="javascript:window.location.reload()">再読み込み</a>してください。</p>'
                : '';
        }
        elsif ( !$count ) {
            $form
                = ($user_is_manager)
                ? '<p class="warning">この注文はキャンセルされました。</p>'
                : '';
        }
        elsif ($too_early) {
            $form
                = ($user_is_manager)
                ? '<p class="warning">決済承認前のため配送できません。</p>'
                : '';
        }
        elsif ( !$shipped && $is_manager ) {
            $form .= $table->_table;
            $form .= '<table class="sub-field-table"><tbody>';
            $form
                .= '<tr><td class="field-name"><label for="ship:service">配送業者</label></td><td class="field">'
                . (
                ($service) ? $service : $this->delivery_service_menu(
                    'ship:service',
                    [   (   ( $is_updated_record && $main::ship{'service'} )
                            ? $main::ship{'service'}
                            : ()
                        )
                    ]
                )
                ) . '</td></tr>';
            $form
                .= '<tr><td class="field-name"><label for="ship:number">伝票番号</label></td><td class="field"><input type="text" name="ship:number" id="ship:number" size="20" value="'
                . $this->escape(
                ( $is_updated_record && $main::ship{'number'} )
                ? $main::ship{'number'}
                : '' )
                . '"'
                . (
                (          $is_updated_record
                        && $this->{'is_invalid_field'}{'number'}
                ) ? ' class="invalid-field"' : ''
                )
                . ' onchange="cmonos.validate.field(this).bailOut()" /></td></tr>';
            $form
                .= '<tr class="tbody-end"><td class="field-name"><label for="ship:comment">コメント</label></td><td class="field"><textarea name="ship:comment" id="ship:comment" cols="20" rows="3"'
                . (
                (          $is_updated_record
                        && $this->{'is_invalid_field'}{'comment'}
                ) ? ' class="invalid-field"' : ''
                )
                . ' onchange="cmonos.validate.field(this).bailOut()">'
                . $this->escape(
                ( $is_updated_record && $main::ship{'comment'} )
                ? $main::ship{'comment'}
                : '' )
                . '</textarea></td></tr>';
            $form .= '</tbody><tbody>';
            $form .= '<tr><td class="submit-box" colspan="2">';
            $form .= $cgi::Deco->submit_button(
                'submit',
                $this->{'button'},
                ( ($default::english) ? 'Submit' : '配送完了' ),
                { 'id'           => $id . '-submit' },
                { 'ship:shipped' => 1 }
            );
            $form .= '</td></tr></tbody></table>';
            $form .= '</form>' if !$ajax;
        }
    }
    $content = ($ajax) ? '' : '<div id="' . $id . '">' if !$for_text;
    if (%shipped_item) {
        $content .= '<dl class="sc-shipping-info">' if !$for_text;
        foreach my $t ( sort { $a <=> $b } keys %shipped_item ) {
            if ($for_text) {
                $content .= (
                    ( !$t ) ? '▽未配送'
                    : '▼'
                        . $this->date( $t, 0, $this->{'datetype'} . 'gmt>d' )
                        . '配送 : '
                        . (
                        ( $shipped_item{$t}{'service'} )
                        ? $shipped_item{$t}{'service'}
                        : ''
                        )
                        . (
                        ( $shipped_item{$t}{'number'} )
                        ? ' [伝票番号:'
                            . $shipped_item{$t}{'number'} . ']' . "\x0A"
                            . $this->service_url(
                            $shipped_item{$t}{'service'},
                            $shipped_item{$t}{'number'}
                            )
                        : ''
                        )
                    )
                    . "\x0A"
                    . $shipped_item{$t}{'data'} . "\x0A"
                    if ref $shipped_item{$t} && $shipped_item{$t}{'data'};
            }
            elsif (ref $shipped_item{$t}
                && ref $shipped_item{$t}{'data'}
                && @{ $shipped_item{$t}{'data'} } )
            {
                $content .= '<dt>'
                    . (
                    ( !$t ) ? '未配送' : '<a href="'
                        . $this->service_url(
                        $shipped_item{$t}{'service'},
                        $shipped_item{$t}{'number'}
                        )
                        . '" target="_blank">'
                        . $this->date( $t, 3, $this->{'datetype'} . 'gmt>d' )
                        . '配送' . '</a>'
                        . (
                        ( $shipped_item{$t}{'service'} )
                        ? ' : ' . $shipped_item{$t}{'service'}
                        : ''
                        )
                        . (
                        ( $shipped_item{$t}{'number'} )
                        ? ' [伝票番号:'
                            . $shipped_item{$t}{'number'} . ']'
                        : ''
                        )
                    ) . '</dt>';
                $content .= '<dd class="sc-shipping-list">' . $table->table;
                $content .= $table->tr;
                $content .= $table->th( $setting::general{'itemname'} );
                $content .= $table->th('オプション');
                $content .= $table->th('数量');
                $content .= $table->_tr;
                foreach my $dat ( @{ $shipped_item{$t}{'data'} } ) {
                    $content .= $table->tr;
                    $content .= $table->td( $dat->{'name'} );
                    $content .= $table->td( $dat->{'option'} );
                    $content .= $table->td( $dat->{'quantity'} );
                    $content .= $table->_tr;
                }
                $content .= $table->_table . '</dd>';
                $content .= '<dd class="sc-shipping-comment"><p>'
                    . $this->autolink(
                    $this->escape_except_html_entity(
                        $shipped_item{$t}{'comment'}
                    ),
                    1
                    )
                    . '</p></dd>'
                    if $shipped_item{$t}{'comment'};
            }
        }
        $content .= '</dl>' if !$for_text;
    }
    else {
        $content .= $service;
    }
    $content .= ($ajax) ? '' : '</div>' if !$for_text;
    return ($ajax) ? ( $form, $content ) : ( $form . $content || $service );
}

sub service_url ($$$) {
    my ( $this, $service, $number ) = @_;
    my $url = '#';
    $number = '' if $number eq 'shipped';
    if ( $SCOrderShippingInfo::url{$service} ) {
        $url = $SCOrderShippingInfo::url{$service};
    }
    else {
        my ($id);
        foreach $id ( @{ $this->{'order'} } ) {
            if ( $service eq $this->{'service'}{$id}{'name'} ) {
                if ($SCOrderShippingInfo::url{ $this->{'service'}{$id}
                            {'service'} } )
                {
                    $url = $SCOrderShippingInfo::url{ $this->{'service'}{$id}
                            {'service'} };
                }
                elsif ( $this->{'service'}{$id}{'url'} ) {
                    $url = $this->{'service'}{$id}{'url'};
                }
                last;
            }
        }
    }
    $url =~ s/_number_/$number/sg;
    return $url;
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
    my $this = shift;
    if ( ref $cgi::action && $cgi::action->{'noshipping_only'} ) {
        $main::data{ $this->{'id'} }{'str'} = '';
        return 1;
    }
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    my $is_valid = 1;
    my $data     = '';
    if ( !$cgi::action->{'new_data'} ) {
        my %db;
        tie( %db, $env::dbm_file, "$default::db/$main::c/shipping",
            O_RDONLY, $env::dbm_mode );
        if ( ref tied %db && defined $db{ $this->encode_utf8($main::n) } ) {
            $data = $this->decode_utf8( $db{ $this->encode_utf8($main::n) } );
        }
        untie %db;
        $this->data_update( \$data );
    }
    elsif ( $main::data{ $this->{'id'} }{'str'} ) {
        $data = $main::data{ $this->{'id'} }{'str'};
    }
    my $service = ( $data && $data =~ /^([^\x09\x0A\x0D]*)/s ) ? $1 : '';
    my $shipped
        = ( $data && $data =~ /^[^\x09\x0A\x0D]*\x09(\S*)/s ) ? $1 : '';
    $service = $main::data{ $this->{'id'} }{'service'}
        if !$shipped && $main::data{ $this->{'id'} }{'service'};
    if ( !$shipped ) {
        if ($service
            && ($SCOrderShippingInfo::url{$service}
                || grep( $service eq $this->{'service'}{$_}{'name'},
                    @{ $this->{'order'} } )
            )
            )
        {
        }
        elsif (!$service
            && @{ $this->{'order'} }
            && @{ $this->{'order'} } == 1
            && defined $this->{'order'}[0]
            && $this->{'order'}[0] ne '' )
        {
            $service
                = ( $this->{'service'}{ $this->{'order'}[0] }{'name'} )
                ? $this->{'service'}{ $this->{'order'}[0] }{'name'}
                : $this->{'service'}{ $this->{'order'}[0] }{'service'};
        }
        elsif ( $this->{'required'} && !$service ) {
            $is_valid = 0;
            push(
                @{ $cgi::action->{'dialog'} },
                $this->name . 'を指定してください。'
            ) if ref $cgi::action;
            $service = '';
        }
        elsif ($service) {
            $is_valid = 0;
            push(
                @{ $cgi::action->{'dialog'} },
                $this->name
                    . 'を確認してください。'
                    . $this->escape($service)
                    . ' はご利用になれません。'
            ) if ref $cgi::action;
            $service = '';
        }
    }
    else {
        $main::data{ $this->{'id'} }{'str'} = $data;
    }
    if ( $is_valid && $service ) {
        if ( $this->cod_is_unavailable($service) ) {
            $is_valid = 0;
            if ((      !ref $this->{'order'}
                    || !@{ $this->{'order'} }
                    || @{ $this->{'order'} } == 1
                )
                && defined $this->{'field_for'}{'payment_method'}
                && ref $this->{'field_obj'}
                { $this->{'field_for'}{'payment_method'} }
                )
            {
                push(
                    @{ $cgi::action->{'dialog'} },
                    $this->{'field_obj'}
                        { $this->{'field_for'}{'payment_method'} }->name
                        . 'を確認してください。'
                        . $this->escape($service)
                        . ' は代引きに対応していません。'
                ) if ref $cgi::action;
            }
            else {
                push(
                    @{ $cgi::action->{'dialog'} },
                    $this->name
                        . 'を確認してください。'
                        . $this->escape($service)
                        . ' は代引きに対応していません。'
                ) if ref $cgi::action;
            }
        }
        if ((      $cgi::action->{'weight_lacked'}
                && $setting::payment{'yuumail'}
                && $service =~ /ゆうメール/
            )
            || (   $cgi::action->{'papersize_lacked'}
                && $setting::payment{'mailbin'}
                && $service =~ /メール便/ )
            )
        {
            $is_valid = 0;
            push(
                @{ $cgi::action->{'dialog'} },
                $this->name
                    . 'を確認してください。'
                    . $this->escape($service)
                    . ' で配送できない'
                    . $setting::general{'itemname'}
                    . 'が含まれています。'
            ) if ref $cgi::action;
        }
    }
    if ($is_valid) {
        $data =~ s/^([^\x09\x0A\x0D]*)/$service/;
        $main::data{ $this->{'id'} }{'str'} = $data;
        $cookie::data{ 'data:' . $this->{'id'} . ':service' } = $service
            if $this->{'cookie'} && $main::set_cookie && defined $service;
    }
    else {
        $this->{'is_invalid_field'} = 1;
    }
    return $is_valid;
}

sub data_update ($$) {
    my ( $this, $data_ref ) = @_;
    if (   ref $data_ref
        && $$data_ref
        && $$data_ref !~ /\x0A/s
        && $$data_ref =~ /\x09/s )
    {
        my ( $service, $number, $time, $comment )
            = split( /\t/, $$data_ref, 4 );
        $$data_ref
            = $service
            . ( ($time)
            ? "\x09"
                . $time . "\x0A"
                . $time . "\x09"
                . ( $service || '' ) . "\x09"
                . ( $number  || '' ) . "\x09"
                . ( $comment || '' ) . "\x0A"
            : '' );
    }
}

sub cod_is_unavailable ($$) {
    my ( $this, $service ) = @_;
    return 1
        if !$setting::payment{'codenabled'}
        && defined $this->{'field_for'}{'payment_method'}
        && $main::data{ $this->{'field_for'}{'payment_method'} }{'str'}
        && $main::data{ $this->{'field_for'}{'payment_method'} }{'str'} eq
        'cod';
    my ($id);
    foreach $id ( @{ $this->{'order'} } ) {
        if (   $service eq $this->{'service'}{$id}{'name'}
            || $service eq $this->{'service'}{$id}{'service'} )
        {
            if (   !$this->{'service'}{$id}{'cod'}
                && defined $this->{'field_for'}{'payment_method'}
                && $main::data{ $this->{'field_for'}{'payment_method'} }
                {'str'}
                && $main::data{ $this->{'field_for'}{'payment_method'} }
                {'str'} eq 'cod' )
            {
                return 1;
            }
            else {
                return 0;
            }
        }
    }
    return 0;
}

######################################################################
#	obj->is_secure;
sub is_secure_user ($) {
    my $this = shift;

    #管理パスワードチェック
    if (   !defined $this->{'checkerLevel'}
        || $this->{'checkerLevel'} eq ''
        || $this->{'checkerLevel'} eq 'master' )
    {
        if ( $this->is_master ) {
            return 1;
        }
        else {
            return 0;
        }

        #オーナーパスワードチェック
    }
    elsif ( $this->{'checkerLevel'} eq 'owner' ) {
        if ( $this->is_owner ) {
            return 1;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                $cgi::Register->error_dialog
            ) if ref $cgi::Register;
            return 0;
        }

        #共同オーナーパスワードチェック
    }
    elsif ( $this->{'checkerLevel'} eq 'owners' ) {
        if ( $this->is_one_of_owners ) {
            return 1;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                $cgi::Register->error_dialog
            ) if ref $cgi::Register;
            return 0;
        }

        #スタッフパスワードチェック
    }
    elsif ( $this->{'checkerLevel'} eq 'staff' ) {
        if ( $this->is_staff ) {
            return 1;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                $cgi::Register->error_dialog
            ) if ref $cgi::Register;
            return 0;
        }

        #登録パスワードチェック
    }
    elsif ( $this->{'checkerLevel'} eq 'member' ) {
        if ( $this->is_authorized( @{ $this->{'authorities'} } ) ) {
            return 1;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                $cgi::Register->error_dialog
            ) if ref $cgi::Register;
            return 0;
        }
    }

    return 0;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=表示するデータ/path=ファイル保存ディレクトリ
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->shipping_info( $c, $n, \$str );
}

sub has_content {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ( ( $str && $str =~ /^[^\x09\x0A\x0C\x0D\x20]/ )
            || $this->is_secure_user ) ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str, $path, $c, $n ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    $str
        = '['
        . $this->name . "]\x0A"
        . $this->shipping_info( $c, $n, \$str, 1 );
    $str =~ s/[\x0A]*\Z/\x0A\x0A/s;
    return $str;
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str, $path, $c, $n ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    return $this->shipping_info( $c, $n, \$str, 1 );
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return 1;
}

sub confirmation ($$) {
    my ( $this, $str ) = @_;
    my ($service);
    if ( ref $cgi::action && $cgi::action->{'noshipping_only'} ) {
        return
              ( $cgi::action->{'noshipping_only'} == 2 )
            ? ($default::english)
                ? 'Download Only.'
                : 'ダウンロード'
            : ($default::english) ? 'No Shipping Only.'
            :                       '配送不要';
    }
    else {
        $str = $$str{'str'} if ref $str eq 'HASH';
        return ( $str =~ /^([^\x09\x0A\x0D]+)/s ) ? $this->escape($1) : '';
    }
}

sub hidden_confirmation_data ($) {
    my $this = shift;
    return
          '<input type="hidden" name="data:'
        . $this->{'id'}
        . ':service" value="'
        . (
        (          $main::data{ $this->{'id'} }{'str'}
                && $main::data{ $this->{'id'} }{'str'}
                =~ /^([^\x0A\x0D\x09]+)/s
        ) ? $this->escape($1) : ''
        ) . '" />';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    require CMONOS::CGI_Lib::Table;
    my $table = Table->new;
    $table->set(
        'tableclass' => 'tooltable',
        'trclass'    => 'odd,even',
        'class0'     => 'odd,even',
        'classF'     => 'caution',
        'thenabled'  => 'true',
        'style0'     => 'text-align:center'
    );
    print '<fieldset>';
    print '<legend>配送サービスリスト</legend>';
    print $table->table;

    #ヘッダ
    print $table->tr;
    print $table->td('削除');
    print $table->td('表示順');
    print $table->td('配送サービス');
    print $table->td('サービス名');
    print $table->td('URL');
    print $table->td('代引き') if $setting::payment{'codenabled'};
    print $table->_tr;

    #設定項目
    my ( $id, $n );
    foreach $id ( @{ $this->{'order'} } ) {
        $this->print_delivery_service_setting( $name, $table, $id, ++$n,
            $this->{'service'}{$id} );
    }
    $id = 1;
    $id++ while ref $this->{'service'}{$id};
    $this->print_delivery_service_setting( $name, $table, $id, ++$n );

    print $table->_table;
    undef %$table;
    undef $table;

    print
        '<div class="hints">サービスが「その他」以外の場合、サービス名と URL を設定する必要はありません。</div>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>配送情報書き込み</legend>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_checkerLevel">書き込み権限のあるユーザー</label></legend>';
    print $this->mk_select_menu(
        $name . '_checkerLevel', '', '', $this->{'checkerLevel'},
        'master' => 'マスター',
        'owner'  => '管理人',
        'owners' => '共同オーナー',
        'staff'  => 'スタッフ',
        'member' => '登録メンバー'
    );
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_authority">「登録メンバー」メールアドレス</label></legend>';
    print '<textarea name="'
        . $name
        . '_authority" id="'
        . $name
        . '_authority" cols="56" rows="5" wrap="off">'
        . $this->escape( $this->{'authority'} )
        . '</textarea>';
    print
        '<div class="note">登録メンバーが複数の時はカンマ（+改行）で区切ります。</div>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_datetype">配送時表示書式</label></legend>';
    $this->print_date_type_menu( $name . '_', $this->{'datetype'} );
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>配送開始時</legend>';
    print '<label><input type="checkbox" name="'
        . $name
        . '_waitForPayment" id="'
        . $name
        . '_waitForPayment" value="1" '
        . ( ( defined $this->{'waitForPayment'} && $this->{'waitForPayment'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 「決済承認」まで配送を許可しない。</label>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>更新時の記録</legend>';
    print '<label><input type="checkbox" name="'
        . $name
        . '_mTime" id="'
        . $name
        . '_mTime" value="1" '
        . ( ( defined $this->{'mTime'} && $this->{'mTime'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 配送完了時に更新時データベースを更新する。</label>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>送信ボタン</legend>';
    print $cgi::Deco->button_menu( $name . '_button',
        'submit', 120, $this->{'button'} );
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>配送通知メール</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_mailto">通知メール送信先</label></td>';
    print '<td class="field"><select name="'
        . $name
        . '_mailto" id="'
        . $name
        . '_mailto" multiple="multiple">';

    foreach my $id (
        sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
        } keys %{ $this->{'field_obj'} }
        )
    {
        if ( defined $this->{'field_obj'}{$id}->{'e-mail'}
            && $this->{'field_obj'}{$id}->{'e-mail'} )
        {
            print '<option value="'
                . $id . '"'
                . (
                (   ref $this->{'mailto'}
                        && grep( $_ eq $id, @{ $this->{'mailto'} } )
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . $this->{'field_obj'}{$id}->name
                . '</option>';
        }
    }
    print '</select>';
    print
        '<div class="note">無選択の場合、通知機能は動作しません。</div></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_subject">表題</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_subject" id="'
        . $name
        . '_subject" size="70" value="'
        . $this->escape( $this->{'subject'} )
        . '" /></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_msg">内容</label></td>';
    print '<td class="field"><textarea name="'
        . $name
        . '_msg" id="'
        . $name
        . '_msg" cols="70" rows="10">'
        . $this->escape( $this->{'msg'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_msg\').quotationByMenu(this)" title="これらのタグはメール送信時に対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print '<option value="&lt;name&gt;">&lt;name&gt;[名前フィールド'
        . (
        (   $this->{'field_for'}{'name'}
                && ref $this->{'field_obj'}{ $this->{'field_for'}{'name'} }
        )
        ? '（'
            . $this->{'field_obj'}{ $this->{'field_for'}{'name'} }->name
            . '）'
        : ''
        ) . 'の値]</option>';
    print '<option value="&lt;key&gt;">&lt;key&gt;[キーフィールド'
        . (
        (   $this->{'field_for'}{'key'}
                && ref $this->{'field_obj'}{ $this->{'field_for'}{'key'} }
        )
        ? '（'
            . $this->{'field_obj'}{ $this->{'field_for'}{'key'} }->name
            . '）'
        : ''
        ) . 'の値]</option>';
    print
        '<option value="&lt;title&gt;">&lt;title&gt;[タイトルフィールド'
        . (
        (   $this->{'field_for'}{'title'}
                && ref $this->{'field_obj'}{ $this->{'field_for'}{'title'} }
        )
        ? '（'
            . $this->{'field_obj'}{ $this->{'field_for'}{'title'} }->name
            . '）'
        : ''
        ) . 'の値]</option>';
    print
        '<option value="&lt;service&gt;">&lt;service&gt;[配送業者]</option>';
    print
        '<option value="&lt;deliurl&gt;">&lt;deliurl&gt;[配送業者のURL]</option>';
    print
        '<option value="&lt;number&gt;">&lt;number&gt;[荷物番号]</option>';
    print
        '<option value="&lt;comment&gt;">&lt;comment&gt;[配送コメント]</option>';
    print '<option value="&lt;date&gt;">&lt;date&gt;[発送日]</option>';
    print
        '<option value="&lt;data&gt;">&lt;data&gt;[データの一覧]</option>';
    print
        '<option value="&lt;url&gt;">&lt;url&gt;[データ一覧のURL]</option>';
    print
        '<option value="&lt;input&gt;">&lt;input&gt;[データ編集のURL]</option>';
    print
        '<option value="&lt;register&gt;">&lt;register&gt;[アドレス登録のURL]</option>';
    print '</select>';
    print '</div></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>デフォルト</legend>';
    print $this->delivery_service_menu( $name . '_default',
        [ $this->{'default'} ] );
    print '</fieldset>';

    if (   $this->{'field_for'}{'checker'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'checker'} }
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'checker'} }
        {'phase'} )
    {
        my $checker = $this->{'field_obj'}{ $this->{'field_for'}{'checker'} };
        print '<fieldset>';
        print '<legend>「' . $checker->name . '」連動</legend>';
        print '全商品の発送が完了したとき「'
            . $checker->name
            . '」の状況を、<select name="'
            . $name
            . '_phase" id="'
            . $name
            . '_phase"><option value=""></option>';
        foreach my $id ( @{ $checker->{'order'} } ) {
            print '<option value="'
                . $id . '"'
                . ( ( $this->{'phase'} && $this->{'phase'} eq $id )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $checker->{'phase'}{$id}{'name'}
                . '</option>'
                if ref $checker->{'phase'}{$id};
        }
        print '</select>に変更する';
        print '</fieldset>';
    }

    $this->print_table_setting_form( $name, '', 'none' );

    #$this->print_font_setting_form($name);
    $this->print_setting_save_button;
    return;
}

sub print_delivery_service_setting ($$$$$;$) {
    my ( $this, $name, $table, $id, $n, $data ) = @_;
    $name .= '_service_' . $id . '_';
    print $table->tr;
    print $table->td( ( ref $data )
        ? '<input type="checkbox" name="delete:' . $id . '" value="1" />'
        : '新規' );
    print $table->td( '<input type="hidden" name="oldorder:'
            . $id
            . '" value="'
            . $n
            . '" /><input type="number" name="order:'
            . $id
            . '" value="'
            . $n
            . '" size="2" maxlength="2" />' );
    print $table->td(
        $this->default_delivery_service_menu(
            $name . 'service',
            ( ( ref $data ) ? $data->{'service'} : undef )
        )
    );
    print $table->td( '<input type="text" name="'
            . $name
            . 'name" value="'
            . ( ( ref $data ) ? $this->escape( $data->{'name'} ) : '' )
            . '" size="20" />' );
    print $table->td( '<input type="text" name="'
            . $name
            . 'url" value="'
            . ( ( ref $data ) ? $this->escape( $data->{'url'} ) : '' )
            . '" size="30" />' );
    print $table->td( '<input type="checkbox" name="'
            . $name
            . 'cod" value="1"'
            . ( ( ref $data && $data->{'cod'} ) ? ' checked="checked"' : '' )
            . ' />' )
        if $setting::payment{'codenabled'};
    print $table->_tr;
}

sub default_delivery_service_menu ($$$$;$$) {
    my ( $this, $name, $service ) = @_;
    my ( $s, $form );
    $form .= '<select name="' . $name . '">';
    $form .= '<option value=""></option>';
    foreach $s ( sort keys %SCOrderShippingInfo::url ) {
        $form
            .= '<option value="'
            . $this->escape($s) . '"'
            . ( ( $service && $service eq $s ) ? ' selected="selected"' : '' )
            . '>'
            . $this->escape($s)
            . '</option>';
    }
    $form
        .= '<option value=""'
        . (
        ( defined $service && $service eq '' ) ? ' selected="selected"' : '' )
        . '>その他</option>';
    $form .= '</select>';
    return $form;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;
    my ( $id, @services, %name_check );
    foreach $id ( sort { $a <=> $b } keys %main::order ) {
        if ( !$id ) {
            $id = '0';
            delete $main::data{ $this->{'id'}
                    . '_service_'
                    . $id
                    . '_service' };
            delete $main::data{ $this->{'id'} . '_service_' . $id . '_name' };
            delete $main::data{ $this->{'id'} . '_service_' . $id . '_url' };
            delete $main::data{ $this->{'id'} . '_service_' . $id . '_cod' };
        }
        elsif (
            $main::delete{$id}
            || (!$main::data{ $this->{'id'} . '_service_' . $id . '_service' }
                && (!defined $main::data{ $this->{'id'}
                            . '_service_'
                            . $id
                            . '_name' }
                    || $main::data{ $this->{'id'}
                            . '_service_'
                            . $id
                            . '_name' } eq '' )
            )
            )
        {
            $main::data{ $this->{'id'} . '_service_' . $id . '_service' }
                = "\x7F";
            $main::data{ $this->{'id'} . '_service_' . $id . '_name' }
                = "\x7F";
            $main::data{ $this->{'id'} . '_service_' . $id . '_url' }
                = "\x7F";
            $main::data{ $this->{'id'} . '_service_' . $id . '_cod' }
                = "\x7F";
        }
        else {
            push( @services, $id );
            $main::data{ $this->{'id'} . '_service_' . $id . '_service' }
                =~ s/\s+/ /sg;
            $main::data{ $this->{'id'} . '_service_' . $id . '_name' }
                =~ s/\s+/ /sg;
            $main::data{ $this->{'id'} . '_service_' . $id . '_url' }
                =~ s/\s+/ /sg;
            $main::data{ $this->{'id'} . '_service_' . $id . '_cod' }
                =~ s/\s+/ /sg
                if $main::data{ $this->{'id'} . '_service_' . $id . '_cod' };
            $this->tag_fix(
                \$main::data{ $this->{'id'} . '_service_' . $id . '_name' } );
            if ( $main::data{ $this->{'id'} . '_service_' . $id . '_name' } eq
                '' )
            {
                $name_check{ $main::data{ $this->{'id'}
                            . '_service_'
                            . $id
                            . '_service' } }++
                    if $main::data{ $this->{'id'}
                        . '_service_'
                        . $id
                        . '_service' };
            }
            elsif (
                $main::data{ $this->{'id'} . '_service_' . $id . '_name' } ne
                ''
                && $name_check{
                    $main::data{ $this->{'id'} . '_service_' . $id . '_name' }
                }++
                )
            {
                push(
                    @{ $cgi::action->{'dialog'} },
                    $main::data{ $this->{'id'} . '_service_' . $id . '_name' }
                        . 'というサービス名は既に使われています。'
                ) if ref $cgi::action;
                $main::data{ $this->{'id'} . '_service_' . $id . '_name' }
                    .= '\'';
                $is_valid = 0;
            }
            $main::data{ $this->{'id'} . '_service_' . $id . '_cod' } = 0
                if !$main::data{ $this->{'id'} . '_service_' . $id . '_cod' }
                || !$setting::payment{'codenabled'};
            if (defined $main::data{ $this->{'id'}
                        . '_service_'
                        . $id
                        . '_url' }
                && $main::data{ $this->{'id'} . '_service_' . $id . '_url' }
                ne ''
                && $this->is_invalid_url(
                    $main::data{ $this->{'id'} . '_service_' . $id . '_url' }
                )
                )
            {
                push(
                    @{ $cgi::action->{'dialog'} },
                    'URLに不正があります。'
                ) if ref $cgi::action;
                delete $main::data{ $this->{'id'}
                        . '_service_'
                        . $id
                        . '_url' };
                $is_valid = 0;
            }
        }
    }
    $main::data{ $this->{'id'} . '_order' } = [
        (   sort {
                       $main::order{$a} <=> $main::order{$b}
                    || $main::oldorder{$b} <=> $main::oldorder{$a}
                    || $main::order{$a} cmp $main::order{$b}
                    || $a <=> $b
            } @services
        )
    ];
    $main::data{ $this->{'id'} . '_subject' } =~ s/[\x0A\x0D]+//g
        if defined $main::data{ $this->{'id'} . '_subject' };
    $main::data{ $this->{'id'} . '_mTime' } = 0
        if !defined $main::data{ $this->{'id'} . '_mTime' }
        || !$main::data{ $this->{'id'} . '_mTime' };
    $main::data{ $this->{'id'} . '_waitForPayment' } = 0
        if !defined $main::data{ $this->{'id'} . '_waitForPayment' }
        || !$main::data{ $this->{'id'} . '_waitForPayment' };
    $main::data{ $this->{'id'} . '_authority' }
        = $this->z_to_h( $main::data{ $this->{'id'} . '_authority' }, 'utf8' )
        if defined $main::data{ $this->{'id'} . '_authority' }
        && $main::data{ $this->{'id'} . '_authority' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };

    #$is_valid = 0 if !$this->is_valid_font_setting;
    return $is_valid;
}

######################################################################
#	(6) obj->search_form;
sub search_form ($) {
    my $this = shift;
    my ($form);
    $form
        = '<tr class="tbody-end"><td class="field-name"><span class="datatitle">'
        . $this->{'name'}
        . '</span></td><td class="field">';
    $form .= $this->delivery_service_menu(
        'search:' . $this->{'id'} . ':service',
        [ $main::search{ $this->{'id'} }{'service'} ],
        0, 1
    );
    $form .= $this->mk_select_menu(
        'search:' . $this->{'id'} . ':shipped', '', '',
        $main::search{ $this->{'id'} }{'shipped'},
        ''      => '',
        'false' => '未配送',
        'true'  => '配送済'
    );
    $form
        .= '<input type="text" name="search:'
        . $this->{'id'}
        . ':number" id="search:'
        . $this->{'id'}
        . ':number" size="16" value="'
        . $this->escape( $main::search{ $this->{'id'} }{'number'} )
        . '" title="荷物番号" />';
    $form .= '</td></tr>';
    return $form;
}

######################################################################
#	(11) obj->update;
sub update_enabled ($) {
    my $this = shift;
    return 1;
}

sub is_secure_user_for_update ($) {
    my $this = shift;
    return 1;
}

sub is_secure_user_for_edit ($) {
    my $this = shift;
    return 0;
}

sub _update_error ($$) {
    my ( $this, $is_ajax ) = @_;
    return ($is_ajax)
        ? {
        'status'           => 'error',
        'error_fields'     => $this->get_invalid_field_list('ship'),
        'message'          => $this->get_message_string,
        'authorized_level' => $this->get_authorized_level
        }
        : 0;
}

sub update ($;$) {
    my ( $this, $is_ajax ) = @_;
    my (%db,      $time,      $c,       $n,
        $db,      $form,      $content, $error,
        $invalid, $too_early, $is_pending
    );
    if ( @main::c && !defined $main::c ) {
        $main::c = $main::c[0];
    }
    undef @main::c;
    $this->save_update_target;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    if ( !$this->is_secure_user ) {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ne '' ) ? $this->{'name'} : '配送情報' )
                . 'を更新できませんでした。更新権限がありません。'
        );
        return $this->_update_error($is_ajax);
    }
    if ( !$main::ship{'shipped'} ) {
        push(
            @{ $cgi::action->{'dialog'} },
            '「配送完了」ボタンを押してください。'
        ) if ref $cgi::action;
        return $this->_update_error($is_ajax);
    }
    if ( !$main::ship{'ship'}
        || ( ref $main::ship{'ship'} && !@{ $main::ship{'ship'} } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '配送'
                . $setting::general{'itemname'}
                . 'を選択してください。'
        ) if ref $cgi::action;
        return $this->_update_error($is_ajax);
    }
    if ( $main::ship{'number'} =~ /[^0-9a-zA-Z_]/ ) {
        $this->{'is_invalid_field'}{'number'} = 1;
        push(
            @{ $cgi::action->{'dialog'} },
            '伝票番号に英数字以外の文字列が含まれています。'
        ) if ref $cgi::action;
        return $this->_update_error($is_ajax);
    }
    $db = $default::db . '/' . $main::c;
    $n  = $main::n;
    $c  = $main::c;
    $this->detag( \$main::ship{'comment'} );
    $main::ship{'comment'} =~ s/[\x09\x0A\x0C\x0D\x20]+\Z//s;
    $main::ship{'service'}
        = (    @{ $this->{'order'} }
            && @{ $this->{'order'} } == 1
            && defined $this->{'order'}[0]
            && $this->{'order'}[0] ne '' )
        ? ( $this->{'service'}{ $this->{'order'}[0] }{'name'} )
            ? $this->{'service'}{ $this->{'order'}[0] }{'name'}
            : $this->{'service'}{ $this->{'order'}[0] }{'service'}
        : ''
        if !$main::ship{'service'}
        || (
        !$SCOrderShippingInfo::url{ $main::ship{'service'} }
        && !grep( $main::ship{'service'} eq $this->{'service'}{$_}{'name'},
            @{ $this->{'order'} } )
        );
    $this->scalar_to_array( \$main::ship{'ship'} );
    $time          = time;
    $env::dbm_file = 'AnyDBM_File'
        if !defined $env::dbm_file || $env::dbm_file eq '';
    $env::dbm_mode = 0666 if !defined $env::dbm_mode || $env::dbm_mode eq '';
    tie(%db, $env::dbm_file,
        $db . '/shipping',
        O_RDWR | O_CREAT,
        $env::dbm_mode
    );

    if ( ref tied %db ) {
        my $data = $this->decode_utf8( $db{ $this->encode_utf8($n) } );
        $this->data_update( \$data );
        $data .= "\x0A" if $data !~ /\x0A$/s;
        $main::ship{'service'} = $1 if $data =~ /^([^\x09\x0A\x0D]+)/s;
        $main::ship{'number'}  = '' if !defined $main::ship{'number'};
        $main::ship{'comment'} = '' if !defined $main::ship{'comment'};
        my $time = time;
        if ( $main::ship{'service'} ) {
            $data .= join( "\x09",
                $time, $main::ship{'service'}, $main::ship{'number'},
                $main::ship{'comment'} )
                . "\x0A";
            my %order;
            tie( %order, $env::dbm_file, $default::db . '/' . $c . '/order',
                O_RDWR, $env::dbm_mode );
            if ( ref tied %order ) {
                my $order_info
                    = $this->decode_utf8( $order{ $this->encode_utf8($n) } );
                my $completed = 1;
                my $count     = 0;
                my $new_info;
                while ( $order_info =~ /^(.*)$/mg ) {
                    my $i = $1;
                    next if !$i;
                    $i =~ s/\x0A*$/\x0A/;
                    if ( !defined $new_info ) {
                        if ( $this->{'waitForPayment'}
                            && !( split( /\x09/, $i ) )[6] )
                        {
                            $too_early = 1;
                            last;
                        }
                        $new_info = $i;
                    }
                    next if !$count++;
                    my %item_data = ();
                    $cgi::Session->read_data( \%item_data, $i );
                    my $quantity = $item_data{'quantity'};
                    if (   defined $item_data{'newquantity'}
                        && $item_data{'newquantity'} =~ /^[0-9]+$/
                        && $item_data{'newquantity'} < $quantity )
                    {
                        $quantity   = $item_data{'newquantity'};
                        $is_pending = 1;
                    }
                    my $noshipping
                        = (    $item_data{'digitalcontent'}
                            || $item_data{'noshipping'}
                            || !$quantity
                            || $quantity < 0 ) ? 1 : 0;
                    if ( !grep( $_ eq $count, @{ $main::ship{'ship'} } ) ) {
                        $new_info .= $i;
                        $completed = 0
                            if !$noshipping && !$item_data{'shipped'};
                    }
                    else {
                        if ($noshipping) {
                            $new_info .= $i;
                            $invalid = 1;
                        }
                        else {
                            $item_data{'shipped'} = $time;
                            $new_info
                                .= $cgi::Session->data( '', '', \%item_data,
                                1 );
                        }
                    }
                }
                if ( !$too_early && !$is_pending ) {
                    $order{ $this->encode_utf8($n) }
                        = $this->encode_utf8($new_info)
                        if !$invalid;
                    $data =~ s/^([^\x09\x0A\x0D]*).*?\x0A/$1\x09$time\x0A/s
                        if $completed;
                    $db{ $this->encode_utf8($n) } = $this->encode_utf8($data);
                    ( $form, $content )
                        = $this->shipping_info( $c, $n, \$data, 0, $new_info )
                        if $is_ajax;
                }
            }
            else {
                $error = 1;
            }
            untie %order;
        }
    }
    else {
        $error = 1;
    }
    untie %db;
    if ($error) {
        push(
            @{ $cgi::action->{'dialog'} },
            'エラー！\nデータベースにアクセスできませんでした。'
        ) if ref $cgi::action;
        return $this->_update_error($is_ajax);
    }
    elsif ($is_pending) {
        push(
            @{ $cgi::action->{'dialog'} },
            'キャンセルが申請されている'
                . $setting::general{'itemname'}
                . 'があります。再読み込みして確認してください。'
        ) if ref $cgi::action;
        return $this->_update_error($is_ajax);
    }
    elsif ($too_early) {
        push(
            @{ $cgi::action->{'dialog'} },
            '決済承認前のため配送できません。'
        ) if ref $cgi::action;
        return $this->_update_error($is_ajax);
    }
    elsif ($invalid) {
        push(
            @{ $cgi::action->{'dialog'} },
            '数量が0になっている'
                . $setting::general{'itemname'}
                . 'があります。再読み込みして確認してください。'
        ) if ref $cgi::action;
        return $this->_update_error($is_ajax);
    }
    elsif ( !$main::ship{'service'} ) {
        $this->{'is_invalid_field'}{'service'} = 1;
        push(
            @{ $cgi::action->{'dialog'} },
            '配送業者が設定されていません。'
        ) if ref $cgi::action;
        return $this->_update_error($is_ajax);
    }

    #通知メール
    if ( ref $this->{'mailto'} && @{ $this->{'mailto'} } ) {
        my (@mailto);
        foreach ( @{ $this->{'mailto'} } ) {
            my (%mail);
            tie( %mail, $env::dbm_file, $db . '/' . $_,
                O_RDONLY, $env::dbm_mode );
            push( @mailto,
                $this->get_address( $mail{ $this->encode_utf8($n) } ) )
                if defined $mail{ $this->encode_utf8($n) }
                && $mail{ $this->encode_utf8($n) };
            untie(%mail);
        }
        if (@mailto) {
            my ($subject,      $msg,         $name,    $bcc,
                $register_url, $script_name, $deliurl, $url,
                $input,        $date
            );
            $subject
                = ( $this->{'subject'} )
                ? $this->{'subject'}
                : 'ご注文の品を発送しました。';
            $msg
                = ( $this->{'msg'} )
                ? $this->{'msg'}
                : 'ご注文の品を発送しました。' . "\x0A"
                . '<url>';
            $subject =~ s/<service>/$main::ship{'service'}/igs;
            $msg =~ s/<service>/$main::ship{'service'}/igs;
            $subject =~ s/<comment>/$main::ship{'comment'}/igs;
            $msg =~ s/<comment>/$main::ship{'comment'}/igs;
            $subject =~ s/<number>/$main::ship{'number'}/igs;
            $msg =~ s/<number>/$main::ship{'number'}/igs;
            $deliurl = $this->service_url( $main::ship{'service'},
                $main::ship{'number'} );
            $msg =~ s/<deliurl>/$deliurl/igs;
            $date = $this->date( $time, 3, $this->{'datetype'} . 'gmt>d' );
            $msg =~ s/<date>/$date/igs;

            if ( $subject =~ /<name>/i || $msg =~ /<name>/i ) {
                $name = ($default::english) ? 'you' : 'あなた';
                if ( defined $this->{'field_for'}{'name'}
                    && $this->{'field_for'}{'name'} )
                {
                    my (%name);
                    tie(%name,
                        $env::dbm_file,
                        $db . '/'
                            . $this->{'field_obj'}
                            { $this->{'field_for'}{'name'} }->db,
                        O_RDONLY,
                        $env::dbm_mode
                    );
                    $name
                        = $this->decode_utf8(
                        $name{ $this->encode_utf8($n) } )
                        if defined $name{ $this->encode_utf8($n) }
                        && $name{ $this->encode_utf8($n) } ne '';
                    untie(%name);
                }
                $subject =~ s/<name>/$name/igs;
                $msg =~ s/<name>/$name/igs;
            }
            if ( $subject =~ /<key>/i || $msg =~ /<key>/i ) {
                my $key = ($default::english) ? 'this' : 'これ';
                if ( defined $this->{'field_for'}{'key'}
                    && $this->{'field_for'}{'key'} )
                {
                    my (%key);
                    tie(%key,
                        $env::dbm_file,
                        $db . '/'
                            . $this->{'field_obj'}
                            { $this->{'field_for'}{'key'} }->db,
                        O_RDONLY,
                        $env::dbm_mode
                    );
                    $key
                        = $this->decode_utf8( $key{ $this->encode_utf8($n) } )
                        if defined $key{ $this->encode_utf8($n) }
                        && $key{ $this->encode_utf8($n) } ne '';
                    untie(%key);
                }
                $subject =~ s/<key>/$key/igs;
                $msg =~ s/<key>/$key/igs;
            }
            if ( $subject =~ /<title>/i || $msg =~ /<title>/i ) {
                my $title = ($default::english) ? 'this' : 'これ';
                if ( defined $this->{'field_for'}{'title'}
                    && $this->{'field_for'}{'title'} )
                {
                    my (%title);
                    tie(%title,
                        $env::dbm_file,
                        $db . '/'
                            . $this->{'field_obj'}
                            { $this->{'field_for'}{'title'} }->db,
                        O_RDONLY,
                        $env::dbm_mode
                    );
                    $title
                        = $this->decode_utf8(
                        $title{ $this->encode_utf8($n) } )
                        if defined $title{ $this->encode_utf8($n) }
                        && $title{ $this->encode_utf8($n) } ne '';
                    untie(%title);
                }
                $subject =~ s/<title>/$title/igs;
                $msg =~ s/<title>/$title/igs;
            }
            if ( $msg =~ /<data>/i ) {
                my ( $list, $file_dir );
                $file_dir = "$default::file/$c/$n";
                foreach my $id (
                    sort {
                        $this->{'field_obj'}->{$a}->{'ORDER'}
                            <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                            || $a <=> $b
                    } keys %{ $this->{'field_obj'} }
                    )
                {
                    next
                        if !$this->{'field_obj'}{$id}
                        ->format_for_mail_enabled;
                    my (%data);
                    tie( %data, $env::dbm_file,
                        $db . '/' . $this->{'field_obj'}{$id}->db,
                        O_RDONLY, $env::dbm_mode );
                    $list
                        .= $this->{'field_obj'}{$id}->format_for_mail(
                        $this->decode_utf8( $data{ $this->encode_utf8($n) } ),
                        $file_dir, $c, $n );
                    untie(%data);
                }
                $msg =~ s/<data>/$list/igs;
            }
            $script_name = $this->my_url;
            $url = $this->permalink_of_detailview( $main::c, $main::n );
            $msg =~ s/<url>/$url/igs;
            $input
                = $script_name . '?m=Input&c=' . $main::c . '&n=' . $main::n;
            $msg =~ s/<input>/$input/igs;
            $register_url = $this->http_my_domain
                . $this->path_change( $env::register_cgi,
                $ENV{'SCRIPT_NAME'}, 'abs' );
            $msg =~ s/<register>/$register_url/igs;

            unless ( ref $cgi::SendMail ) {
                require CMONOS::CGI_Lib::SendMail;
                $cgi::SendMail
                    = SendMail->new( $env::sendmail, $env::master_email, '',
                    $cgi::input, 1 );
            }
            foreach (@mailto) {
                $bcc .= ',' if defined $bcc && $bcc ne '';
                $bcc
                    .= ( $name && $name ne 'you' && $name ne 'あなた' )
                    ? $name . ' <' . $_ . '>'
                    : $_;
            }
            $cgi::SendMail->send_mail(
                'Bcc'  => $bcc,
                'From' => (
                    ( $setting::general{'master'} )
                    ? ( ( $setting::general{'mastername'} )
                        ? $setting::general{'mastername'} . ' <'
                            . $setting::general{'master'} . '>'
                        : $setting::general{'master'} )
                    : $env::master_email
                ),
                'Subject' => $subject,
                'message' => $msg . "\x0A\x0A",
                'info'    => 0
            );
        }
    }
    undef %main::ship;
    if (  !$form
        && $this->{'phase'}
        && $this->{'field_for'}{'checker'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'checker'} }
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'checker'} }
        {'phase'} )
    {
        local $main::phase   = $this->{'phase'};
        local $main::comment = '';
        $this->{'field_obj'}{ $this->{'field_for'}{'checker'} }->update;
    }
    $this->post_update;
    if ($is_ajax) {
        return {
            'status' => 'success',
            'form'   => (
                ($form)
                ? $form
                : '<p>すべての'
                    . $setting::general{'itemname'}
                    . 'を配送しました。</p>'
            ),
            'content' => ( ($content) ? $content : '' ),
            'message'          => $this->get_message_string,
            'authorized_level' => $this->get_authorized_level
        };
    }
    else {
        return 0;
    }
}

sub editor_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	CMONOS::CGI_Lib::UserGeneratedField からのコピー
sub get_invalid_field_list ($$) {
    my ( $this, $prefix ) = @_;
    return ''
        if !defined $this->{'is_invalid_field'}
        || !ref $this->{'is_invalid_field'};
    my @invalid_fields
        = map { $prefix . ':' . $_ } keys %{ $this->{'is_invalid_field'} };
    delete $this->{'is_invalid_field'};
    return (@invalid_fields) ? join( ';', @invalid_fields ) : '';
}

sub get_message_string ($) {
    my $this = shift;
    if ( ref $cgi::action ) {
        my @message = $cgi::action->dialog;
        if (@message) {
            map {
                $_ =~ s/\\n//g;
                $_ =~ s/;//g;
            } @message;
            return join( ';', @message );
        }
    }
    return '';
}

sub get_authorized_level ($) {
    my $this = shift;
    if ( $this->is_master ) {
        return 5;
    }
    elsif ( $this->is_owner ) {
        return 4;
    }
    elsif ( $this->is_one_of_owners ) {
        return 3;
    }
    elsif ( $this->is_staff ) {
        return 2;
    }
    elsif ( $this->is_registered_user ) {
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);
    if (   defined $default::type
        && $default::type eq 'order'
        && defined $env::checkout
        && $env::checkout
        && !$setting::field_for_mail )
    {
        Field::class_register( 'yorder_shipping', 'SCOrderShippingInfo',
            '配送情報' );
        push( @field::redundancy_forbidden, 'yorder_shipping' );
    }
}

1;
