package Sticky;
require CMONOS::TableMaker::Field::TMUserGeneratedField;
require CMONOS::CGI_Lib::Field;
@ISA = qw(TMUserGeneratedField Field);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# フィールド定義モジュール（付箋）
# Sticky.pm 1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-01-22
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'checked'} = {} if !ref $this->{'checked'};
    $this->{'sticky_enabled'}
        = (    ref $cgi::action
            && $cgi::action->is_registered_user
            && $main::email ) ? 1 : 0;
}

sub record_is_checked ($$) {
    my ( $this, $c, $n ) = @_;
    if ( !ref $this->{'checked'}{$c} ) {
        my %db;
        $this->{'checked'}{$c} = {} if !ref $this->{'checked'}{$c};
        tie( %db, $env::dbm_file,
            $default::db . '/' . $c . '/' . $this->{'id'},
            O_RDONLY, $env::dbm_mode );
        my $data = '';
        if ( ref tied %db ) {
            $data = $this->decode_utf8( $db{ $this->user_key } );
        }
        untie %db;
        if ( defined $data && $data ne '' ) {
            foreach my $no ( split( /,/, $data ) ) {
                $this->{'checked'}{$c}{$no} = 1;
            }
        }
    }
    return ( $this->{'checked'}{$c}{$n} ) ? 1 : 0;
}

sub user_key ($) {
    my $this    = shift;
    my $user_id = $main::email;
    $user_id
        =~ s/([^\.\/0-9A-Za-z])/'\/' . sprintf("%.2X", unpack("C", $1))/eg;
    return $this->encrypt( $user_id, 'sT', 1 );
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    return (   $this->{'sticky_enabled'}
            && defined $main::search{ $this->{'id'} }{'checked'}
            && $main::search{ $this->{'id'} }{'checked'} ne '' ) ? 1 : 0;
}

#	(1) obj->match(str);
sub match ($;$$$) {
    my ( $this, $str, $c, $n ) = @_;
    my $checked = $this->record_is_checked( $c, $n );
    return (   ( $main::search{ $this->{'id'} }{'checked'} && $checked )
            || ( !$main::search{ $this->{'id'} }{'checked'} && !$checked ) )
        ? 1
        : 0;
}

######################################################################
#	(2) obj->form;
sub input_enabled ($) {
    my $this = shift;
    return 0;
}

sub form {
    my ( $this, $status, $original, $path ) = @_;
    return '';
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
    my $this = shift;
    return 1;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=表示するデータ/path=ファイル保存ディレクトリ
sub usual_format_enabled ($) {
    my $this = shift;
    return ( $this->{'sticky_enabled'} || $main::m eq 'Tools' ) ? 1 : 0;
}

sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    return '' if !$this->{'sticky_enabled'};
    my $checked = $this->record_is_checked( $c, $n );
    my $id = $this->mk_user_generated_field_id( $c, $n );
    my @required
        = grep( $_ ne 'n' && $_ ne 'c' && $_ ne 'id', @setting::form );
    push( @required, 'ct' ) if !grep( $_ eq 'ct', @required );
    @main::ct = @main::c if !@main::ct && @main::c;
    my $form = $this->form_start(
        'key'  => ( ($setting::security_key) ? $setting::security_key : '' ),
        'id'   => ( ($id)                    ? $id . '-form'          : '' ),
        'name' => ( ($id)                    ? $id . '-form'          : '' ),
        'method'   => 'post',
        'onsubmit' => 'return cmonos.form.item(this).submit();',
        'required' => \@required
    );
    $form
        .= '<input type="hidden" name="id" value="' . $this->{'id'} . '" />';
    $form .= '<input type="hidden" name="n" value="' . $n . '" />';
    $form .= '<input type="hidden" name="c" value="' . $c . '" />';
    $form
        .= '<input type="checkbox" name="checked" value="1" title="'
        . $this->name . '"'
        . ( ($checked) ? ' checked="checked"' : '' )
        . ' onclick="cmonos.form.item(this.form).submit();" />';
    $form .= '<noscript><input type="submit" /></noscript></form>';
    return $this->field_tag($form);
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
    my $this = shift;
    return 0;
}

sub format_for_mail {
    my ( $this, $str ) = @_;
    return '';
}

#---------------------------------------------------------------------
#	(4)-3 obj->format_for_detail(str);
sub format_for_detail_enabled ($) {
    my $this = shift;
    return ( $this->{'sticky_enabled'} || $main::m eq 'Tools' ) ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text_enabled ($) {
    my $this = shift;
    return ( $this->{'sticky_enabled'} || $main::m eq 'Tools' ) ? 1 : 0;
}

sub format_for_text {
    my ( $this, $str, $path, $c, $n ) = @_;
    return ( $this->{'sticky_enabled'} && $this->record_is_checked( $c, $n ) )
        ? $this->name
        : '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return 1;
}

sub confirmation ($$) {
    my ( $this, $str ) = @_;
    return '';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;
    my ( $name, $id, $n );

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>検索欄設定</legend>';

    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_truelabel">チェック済みのラベル</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_truelabel" id="'
        . $name
        . '_truelabel" value="'
        . $this->escape( $this->{'truelabel'} )
        . '" size="40" />';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_falselabel">チェックされていない場合のラベル</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_falselabel" id="'
        . $name
        . '_falselabel" value="'
        . $this->escape( $this->{'falselabel'} )
        . '" size="40" />';
    print '</fieldset>';

    print '</fieldset>';

    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;
    return 1;
}

######################################################################
#	(6) obj->search_form;
sub search_form_enabled ($) {
    my $this = shift;
    return ( $this->{'sticky_enabled'} || $main::m eq 'Tools' ) ? 1 : 0;
}

sub search_form ($) {
    my $this = shift;
    my ($form);
    $form
        = '<tr><td class="field-name"><label for="search:'
        . $this->{'id'}
        . ':checked">'
        . $this->{'name'}
        . '</label></td><td class="field">';
    $form .= $this->mk_select_menu(
        'search:' . $this->{'id'} . ':checked',
        '', '',
        $main::search{ $this->{'id'} }{'checked'},
        ''  => '',
        '1' => (
            ( $this->{'truelabel'} ) ? $this->escape( $this->{'truelabel'} )
            : '該当する'
        ),
        '0' => (
            ( $this->{'falselabel'} ) ? $this->escape( $this->{'falselabel'} )
            : '該当しない'
        ),
    );
    $form .= '</td></tr>';
    return $form;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return ( $this->{'sticky_enabled'} || $main::m eq 'Tools' ) ? 1 : 0;
}

sub sample ($$;$$) {
    my ( $this, $str, $c, $n ) = @_;
    return $this->record_is_checked( $c, $n );
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(11) obj->update;
sub update_enabled ($) {
    my $this = shift;
    return 1;
}

sub is_secure_user_for_update ($) {
    my $this = shift;
    $this->read_security_settings;
    return (
        (   $this->is_secure( 'browse', 1 ) || $this->is_secure( 'detail', 1 )
        )
            && !$this->{'Hidden'}
            && ( $this->{'Open'} || $this->is_secure( 'secret', 1 ) )
    ) ? 1 : 0;
}

sub update ($;$) {
    no warnings qw(untie);
    my ( $this, $is_ajax ) = @_;
    my %db;
    tie(%db, $env::dbm_file,
        $default::db . '/' . $main::c . '/' . $this->{'id'},
        O_RDWR | O_CREAT,
        $env::dbm_mode
    );
    if ( ref tied %db ) {
        my $key  = $this->user_key;
        my $data = $this->decode_utf8( $db{$key} );
        my %checked;
        if ( defined $data ) {
            foreach my $no ( split( /,/, $data ) ) {
                $checked{$no} = 1;
            }
        }
        if ($main::checked) {
            $checked{$main::n} = 1;
        }
        elsif ( defined $checked{$main::n} ) {
            delete $checked{$main::n};
        }
        if (%checked) {
            $db{$key} = $this->encode_utf8( join( ',', keys %checked ) );
        }
        else {
            delete $db{$key};
        }
    }
    else {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ne '' ) ? $this->{'name'} : '付箋' )
                . 'を更新できませんでした。データベース接続に失敗しました。'
        );
        return ($is_ajax)
            ? {
            'status'  => 'error',
            'message' => $this->get_message_string,
            }
            : 0;
    }
    untie %db;
    if ($is_ajax) {
        return { 'status' => 'success', };
    }
    else {
        return 1;
    }
}

sub get_message_string ($) {
    my $this = shift;
    if ( ref $cgi::action ) {
        my @message = $cgi::action->dialog;
        if (@message) {
            map {
                $_ =~ s/\\n//g;
                $_ =~ s/;//g;
            } @message;
            return join( ';', @message );
        }
    }
    return '';
}

######################################################################
#sub import {
BEGIN {
    if ( !$setting::field_for_mail ) {
        Field::class_register( 'xtm_sticky', 'Sticky', '付箋' );
    }
}

1;
