package Sum;
require CMONOS::CGI_Lib::Field::Num;
@ISA = qw(Num);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（数[合計]）
# Sum.pm 1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
#	(0)-4 フィールドの名前
sub name ($) {
    my $this = shift;
    if ( $main::m eq 'TableViewer' ) {
        return ( ( defined $this->{'name'} ) ? $this->{'name'}
            : '[' . $this->{'id'} . ']' )
            . ( ( $this->{'br'} ) ? '<br />' : ' ' )
            . ( ( defined $default::english && $default::english )
            ? '([ ] is the sum)'
            : '([ ]内は合計)' );
    }
    else {
        return ( ( defined $this->{'name'} )
            ? $this->{'name'}
            : '[' . $this->{'id'} . ']' );
    }
}

######################################################################
#	(4)-1 obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag($str) if !defined $str || $str eq '';
    my ($sum);
    if ( $main::m eq 'TableViewer' ) {
        $this->{'sum'} += $str;
        $sum = $this->{'sum'};
        if ( defined $this->{'comma'} && $this->{'comma'} ) {
            $sum
                =~ s/(\.[0-9]{4,})/{my $d = $1;$d =~ s\/([0-9]{3})\/$1,\/g;$d}/ge;
            $sum
                =~ s/([0-9]{4,}(?=([^0-9]|$)))/{my $d = $1;1 while $d =~ s\/([0-9])([0-9]{3}(?=([^0-9]|$)))\/$1,$2\/g;$d}/ge;
        }
        $sum = '0' if !defined $sum || !$sum;
        $sum .= ' ' . $this->{'unit'}
            if defined $this->{'unit'} && $this->{'unit'} ne '';
        $sum
            = ( ( $this->{'br'} ) ? '<div class="sum-info">' : ' ' ) . '['
            . $sum . ']'
            . ( ( $this->{'br'} ) ? '</div>' : '' );
    }
    else {
        $sum = '';
    }
    if ( defined $this->{'comma'} && $this->{'comma'} ) {
        $str
            =~ s/(\.[0-9]{4,})/{my $d = $1;$d =~ s\/([0-9]{3})\/$1,\/g;$d}/ge;
        $str
            =~ s/([0-9]{4,}(?=([^0-9]|$)))/{my $d = $1;1 while $d =~ s\/([0-9])([0-9]{3}(?=([^0-9]|$)))\/$1,$2\/g;$d}/ge;
    }
    return $this->field_tag(
        $this->style(
            $this->data_tag( 'str', $str ) . $sum, $this->{'style'},
            $this->{'fontsize'}, $this->{'fontcolor'},
            $this->{'fontface'}
        )
    );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my ($name);

    #名前
    $name = 'data:' . $this->{'id'};

    $this->{'default'} =~ s/\x0A//sg if defined $this->{'default'};

    $this->print_field_info_form( $name, 0,
        'テーブル表示時のみ合計値を併記します' );
    print '<fieldset>';
    print '<legend>入力欄設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_cols">入力欄幅</label></td>';
    print '<td class="field"><input type="number" name="'
        . $name
        . '_cols" id="'
        . $name
        . '_cols" value="'
        . $this->escape( $this->{'cols'} )
        . '" size="3" title="入力欄の横幅を設定します。" /> <span class="unit">文字(半角)</span></td>';
    print '<td class="field-name"><label for="' . $name
        . '_maxlength">最大文字数</label></td>';
    print '<td class="field"><input type="number" name="'
        . $name
        . '_maxlength" id="'
        . $name
        . '_maxlength" value="'
        . $this->escape( $this->{'maxlength'} )
        . '" size="3" title="入力欄の文字数を制限します。" /> <span class="unit">文字(半角)</span></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_unit">単位</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_unit" id="'
        . $name
        . '_unit" value="'
        . $this->escape( $this->{'unit'} )
        . '" size="8" title="入力する内容に適した単位を設定します。" /> <label><input type="checkbox" name="'
        . $name
        . '_int" value="1"'
        . ( ( defined $this->{'int'} && $this->{'int'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 整数</label></td>';
    print '<td class="field-name"><label for="' . $name
        . '_default">デフォルト</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_default" id="'
        . $name
        . '_default" value="'
        . $this->escape( $this->{'default'} )
        . '" size="8" title="入力欄のデフォルトの値を設定します。" />'
        . ( ( defined $this->{'unit'} && $this->{'unit'} ne '' )
        ? ' <span class="unit">' . $this->{'unit'} . '</span>'
        : '' )
        . '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><input type="checkbox" name="'
        . $name
        . '_comma" id="'
        . $name
        . '_comma" value="1"'
        . ( ( defined $this->{'comma'} && $this->{'comma'} )
        ? ' checked="checked"'
        : '' )
        . ' /></td>';
    print '<td class="field"><label for="' . $name
        . '_comma">三桁ごとに位取りする</label></td>';
    print '<td class="field-name"><input type="checkbox" name="'
        . $name
        . '_br" id="'
        . $name
        . '_br" value="1"'
        . ( ( defined $this->{'br'} && $this->{'br'} )
        ? ' checked="checked"'
        : '' )
        . ' /></td>';
    print '<td class="field"><label for="' . $name
        . '_br">合計表示の前に改行を入れる</label></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    if ( !defined $html_disabled || !$html_disabled ) {
        if ( !defined $default::static || !$default::static ) {
            print '<fieldset>';
            print '<legend>検索設定</legend>';
            print '<label><input type="checkbox" name="'
                . $name
                . '_searchOption" value="1"'
                . (
                (   defined $this->{'searchOption'} && $this->{'searchOption'}
                ) ? ' checked="checked"' : ''
                ) . ' /> より詳しい検索</label>';
            print '</fieldset>';
        }

        #文字設定
        $this->print_font_setting_form($name);
    }

    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = $this->is_valid_font_setting;

    #タグの除去
    $main::data{ $this->{'id'} . '_default' } =~ s/[\x0A\x0D]//sg;
    $this->detag( \$main::data{ $this->{'id'} . '_default' } )
        if defined $main::data{ $this->{'id'} . '_default' }
        && $main::data{ $this->{'id'} . '_default' };
    if (   $main::data{ $this->{'id'} . '_default' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_default' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'デフォルト設定を確認してください。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_default' };
        $is_valid = 0;
    }
    elsif ($main::data{ $this->{'id'} . '_int' }
        && $main::data{ $this->{'id'} . '_default' }
        && $main::data{ $this->{'id'} . '_default' } =~ /\./ )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'デフォルト設定を確認してください。小数点以下を四捨五入しました。'
        ) if ref $cgi::action;
        $main::data{ $this->{'id'} . '_default' }
            = int( $main::data{ $this->{'id'} . '_default' } + 0.5 );
    }

    $this->tag_fix( \$main::data{ $this->{'id'} . '_unit' }, 2 )
        if defined $main::data{ $this->{'id'} . '_unit' }
        && $main::data{ $this->{'id'} . '_unit' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_searchOption' } = ''
        if !defined $main::data{ $this->{'id'} . '_searchOption' }
        || $main::data{ $this->{'id'} . '_searchOption' } eq '';
    $main::data{ $this->{'id'} . '_comma' } = ''
        if !defined $main::data{ $this->{'id'} . '_comma' }
        || $main::data{ $this->{'id'} . '_comma' } eq '';
    $main::data{ $this->{'id'} . '_br' } = ''
        if !defined $main::data{ $this->{'id'} . '_br' }
        || $main::data{ $this->{'id'} . '_br' } eq '';

    return $is_valid;
}

######################################################################
#sub import {
BEGIN {
    if ( !$setting::field_for_mail ) {
        Field::class_register( 'num_sum', 'Sum', '数[合計]' );
    }
}

1;
