package TMUserGeneratedField;
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（TableMaker ユーザー作成フィールド）
# TMUserGeneratedField.pm 1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-06-23
######################################################################
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

sub get_query_for_user_generated_field_editor ($;$$$) {
    my ( $this, $for_post, $c, $n ) = @_;
    $c
        = ( defined $c && $c ne '' ) ? $c
        : ( defined $main::c && $main::c ne '' ) ? $main::c
        :                                          '';
    $n = ( defined $n && $n ne '' ) ? $n : $main::n;
    if ($for_post) {
        return $this->add_query(
            'post',
            {   'm'  => 'UserGeneratedFieldEditor',
                'k'  => 'ugfieldeditor',
                'id' => $this->{'id'},
                'c'  => $c,
                'n'  => $n,
                (   (          $main::m
                            && $main::m !~ /[^0-9a-zA-Z_]/
                            && $main::m ne 'UserGeneratedFieldEditor'
                    ) ? ( 'mod' => $main::m )
                    : (        $main::mod
                            && $main::mod !~ /[^0-9a-zA-Z_]/
                            && $main::mod ne 'UserGeneratedFieldEditor' )
                    ? ( 'mod' => $main::mod )
                    : ()
                ),
            }
        );
    }
    else {
        return
              '?m=UserGeneratedFieldEditor&k=ugfieldeditor&id='
            . $this->{'id'} . '&c='
            . $c . '&n='
            . $n
            . (
            (          $main::m
                    && $main::m !~ /[^0-9a-zA-Z_]/
                    && $main::m ne 'UserGeneratedFieldEditor'
            ) ? '&mod=' . $main::m
            : (        $main::mod
                    && $main::mod !~ /[^0-9a-zA-Z_]/
                    && $main::mod ne 'UserGeneratedFieldEditor' )
            ? '&mod=' . $main::mod
            : ''
            );
    }
}

sub _mk_user_generated_field_id ($;$$) {
    my ( $this, $c, $n ) = @_;
    return
          ( ( defined $c && $c ne '' ) ? '-' . $c : '' )
        . ( ( defined $n && $n ne '' ) ? '-' . $n : '' ) . '-'
        . $this->{'id'};
}

sub get_query_keys ($) {
    my $this = shift;
    if ( $this->{'externalFileDisabled'} && $main::m ne 'Teaser' ) {
        return [ grep( $_ ne 'c' && $_ ne 'n', @setting::form ) ];
    }
    else {
        return [];
    }
}

sub add_query_for_form ($;$$) {
    my ( $this, $c, $n ) = @_;
    return ( $main::m eq 'Teaser' )
        ? $this->add_query( 'post',
        { 'm' => 'UserGeneratedFieldUpdater', 'c' => $c, 'n' => $n } )
        : ( $this->{'externalFileDisabled'} )
        ? $this->add_query( 'post', { 'c' => $c, 'n' => $n } )
        : $this->add_query( 'post',
        { 'm' => 'DetailViewer', 'c' => $c, 'n' => $n } );
}

sub get_output_path ($) {
    my $this = shift;
    return '';
}

sub is_short_parameters ($) {
    return (   !$default::db
            || !$default::file
            || !defined $main::c
            || $main::c eq ''
            || !defined $main::n
            || $main::n eq '' ) ? 1 : 0;
}

sub get_field_data ($) {
    my $this = shift;
    my ( %db, $data );
    tie( %db, $env::dbm_file, $default::db . '/' . $main::c . '/' . $this->db,
        O_RDONLY, $env::dbm_mode );
    if ( ref tied %db ) {
        $data = $this->decode_utf8( $db{ $this->encode_utf8($main::n) } );
    }
    untie %db;
    return ($data) ? { $this->elements($data) } : {};
}

sub get_file_directory ($) {
    my $this = shift;
    return $default::file . '/' . $main::c . '/' . $main::n;
}

sub get_db_directory ($) {
    my $this = shift;
    return $default::db . '/' . $main::c;
}

sub get_mail_field_data ($$) {
    my ( $this, $mailto ) = @_;
    return ''
        if !$mailto
        || !ref $this->{'field_obj'}{$mailto}
        || $this->{'field_obj'}{$mailto}->{'class'} !~ /email/;
    my (%mail);
    my $addr = '';
    tie(%mail,
        $env::dbm_file,
        $default::db . '/'
            . $main::c . '/'
            . $this->{'field_obj'}{$mailto}->db,
        O_RDONLY,
        $env::dbm_mode
    );
    if ( ref tied %mail ) {
        $addr = $this->decode_utf8( $mail{ $this->encode_utf8($main::n) } )
            if $mail{ $this->encode_utf8($main::n) };
    }
    untie %mail;
    return
          (wantarray)
        ? ($addr)
            ? $this->get_address($addr)
            : ()
        : ($addr) ? join( ',', $this->get_address($addr) )
        :           '';
}

sub get_title_field_data ($) {
    my $this = shift;
    my ( %title, $title, $title_field );
    $title_field
        = ( $this->{'field_for'}{'title'} ) ? $this->{'field_for'}{'title'}
        : ( $this->{'field_for'}{'key'} ) ? $this->{'field_for'}{'key'}
        :                                   '';
    return '' if !$title_field || !ref $this->{'field_obj'}{$title_field};
    $title = '';
    tie(%title,
        $env::dbm_file,
        $default::db . '/'
            . $main::c . '/'
            . $this->{'field_obj'}{$title_field}->db,
        O_RDONLY,
        $env::dbm_mode
    );
    if ( ref tied %title ) {
        $title = $this->decode_utf8( $title{ $this->encode_utf8($main::n) } )
            if $title{ $this->encode_utf8($main::n) };
    }
    untie %title;
    $this->text_color( \$title );
    return $title;
}

sub get_viewer_url ($;$$) {
    my ( $this, $c, $n ) = @_;
    my $url = $this->permalink_of_detailview( $c, $n );
    return $url;
}

sub post_update ($;$) {
    my ( $this, $unadditional ) = @_;
    return 1 if $unadditional || !$this->{'mTime'};
    my ( %mtime, %general, $time );
    $time = time;
    tie( %mtime, $env::dbm_file, "$default::db/$main::c/mtime",
        O_RDWR | O_CREAT,
        $env::dbm_mode );
    if ( ref tied %mtime ) {
        $mtime{ $this->encode_utf8($main::n) } = $time;
    }
    untie %mtime;
    tie(%general, $env::dbm_file,
        $default::preference_dir . '/general',
        O_RDWR | O_CREAT,
        $env::dbm_mode
    );
    if ( ref tied %general ) {
        $general{'mtime'} = $time;
    }
    untie %general;
    $setting::general{'mtime'} = $time;
    return 1;
}

sub is_secure_user_for_update ($) {
    my $this = shift;
    return 0 if $this->is_short_parameters;
    $this->read_security_settings;
    return (
        (   $this->is_secure( 'browse', 1 ) || $this->is_secure( 'detail', 1 )
        )
            && (
            !$this->{'generatableUser'}
            || $this->is_as_secure_as(
                $this->{'generatableUser'},
                (   (   $setting::security{'detail'}{'passwordCheck'} eq
                            'member'
                    ) ? [ $this->get_all_mail_field_data_list ] : ()
                )
            )
            )
            && !$this->{'Hidden'}
            && ( $this->{'Open'} || $this->is_secure( 'secret', 1 ) )
    ) ? 1 : 0;
}

sub get_rss_path ($) {
    my $this   = shift;
    my $my_url = $this->my_url;
    return ( $default::file . '/' . $main::c, $my_url, $default::file,
        $my_url );
}

sub has_detail_view ($) {
    my $this = shift;
    return 1;
}

sub has_permanent_id ($$$) {
    my ( $this, $c, $n ) = @_;
    return 0 if !defined $c || $c eq '' || !defined $n || $n eq '';
    my $has_permanent_id = 0;
    $n = $this->encode_utf8($n);
    if ( ref $cgi::action && ref $cgi::action->{'DB'} ) {
        unless ( ref tied %{ $cgi::action->{'DB'}{'pref'}{'record_id'} } ) {
            tie( %{ $cgi::action->{'DB'}{'pref'}{'record_id'} },
                $env::dbm_file, "$default::db/record_id", O_RDONLY,
                $env::dbm_mode );
        }
        if (   ref tied %{ $cgi::action->{'DB'}{'pref'}{'record_id'} }
            && defined $cgi::action->{'DB'}{'pref'}{'record_id'}{$n}
            && $cgi::action->{'DB'}{'pref'}{'record_id'}{$n} eq $c )
        {
            $has_permanent_id = 1;
        }
    }
    else {
        my %record_id;
        tie( %record_id, $env::dbm_file, $default::db . '/record_id',
            O_RDONLY, $env::dbm_mode );
        if (   ref tied %record_id
            && defined $record_id{$n}
            && $record_id{$n} eq $c )
        {
            $has_permanent_id = 1;
        }
        untie %record_id;
    }
    return $has_permanent_id;
}

sub permanent_id ($$$) {
    my ( $this, $c, $n ) = @_;
    return '' if !defined $c || $c eq '' || !defined $n || $n eq '';
    return ( $this->has_permanent_id( $c, $n ) ) ? $n : $c * 1000000 + $n;
}

sub permalink_of_detailview ($$$) {
    my ( $this, $c, $n ) = @_;
    return (wantarray) ? ( $this->my_url, '' ) : $this->my_url
        if !defined $c || $c eq '' || !defined $n || $n eq '';
    my $has_permanent_id = $this->has_permanent_id( $c, $n );
    my $url
        = $this->my_url
        . '?m=DetailViewer'
        . (
        ($has_permanent_id) ? '&record_id=' . $n : '&c=' . $c . '&n=' . $n );
    if (wantarray) {
        return ( $url, ( ($has_permanent_id) ? $n : $c * 1000000 + $n ) );
    }
    else {
        return $url;
    }
}

1;
