package Gate;
require CMONOS::TableMaker::TableViewer;
@ISA = qw(TableViewer);
use strict;
use utf8;
######################################################################
# データ修正レコード選択モジュール
# Gate.pm ver1.0.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-01-21
######################################################################
# 変数調整
sub set_viewer ($) {
    my $this = shift;

    #emailのない場合パスワードチェック画面へ
    $this->print_password_check_form($setting::key)
        if $this->is_invalid_email_address($main::email);

    #不要なデータを消去
    while ( my ( $k, $v ) = each %main::search ) {
        undef %{$v} if ref $v;
    }
    undef %main::search;
    undef $main::n;
    undef $main::q;

    #ゲート設定
    @main::f = @{ $this->{'required_fields'} }
        = @{ $setting::page{$setting::key}{'selectedField'} }
        if ref $setting::page{$setting::key}{'selectedField'}
        && @{ $setting::page{$setting::key}{'selectedField'} };
    $main::s = $setting::page{$setting::key}{'s'}
        if !defined $main::s || !$main::s;
    $main::w = $setting::page{$setting::key}{'w'}
        if !defined $main::w || !$main::w;
    $main::u = $setting::page{$setting::key}{'u'}
        if !defined $main::u || !$main::u;

    if ( !ref $this->{'required_fields'} ) {
        $this->{'required_fields'} = [];
        foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
            my $id = $field::ORDER{$i};
            push( @{ $this->{'required_fields'} }, $id )
                if ref $field::obj{$id}
                && !$field::obj{$id}->{'Hidden'}
                && $field::obj{$id}->{'Default'}
                && ( $field::obj{$id}->{'Open'}
                || $this->is_secure('secret') )
                && !grep( $_ eq $id, @{ $this->{'required_fields'} } );
        }
        @main::f = @{ $this->{'required_fields'} };
    }

    if ( $setting::general{'oneEmailToOneRecord'} && $field::for{'mail'} ) {
        ( $main::c, $main::n )
            = $this->get_category_and_number_from_permanent_id(
            $this->email_to_id($main::email) );
        @main::c = ($main::c);
        undef $main::c;
        $main::pickup = 1;

    }
    else {

        #カテゴリー設定読み込み
        $this->import_db( $default::preference_dir . '/category',
            \%setting::category, 1 );
        @main::c = values %{ $setting::category{'ORDER'} } if !@main::c;
        push( @main::c, 1 ) if !@main::c;

        #メールアドレスを検索
        if ( ref $field::for{'mail_address'}
            && @{ $field::for{'mail_address'} } )
        {
            foreach my $id ( @{ $field::for{'mail_address'} } ) {
                $main::search{$id}{'str'} = $main::email;
            }
        }

        $this->{'search_enabled'} = 1;
    }
    $setting::pending_check = 0
        if $setting::security{'revise'}{'passwordCheck'} ne 'nocheck'
        && $this->is_secure('revise');
}

######################################################################
# 表示フィールド取得
sub get_required_fields ($) {
    my $this = shift;
    $this->{'revForm'} = 1;
    foreach my $i ( @{ $this->{'required_fields'} } ) {
        $this->set_field_setting($i);
    }
}

######################################################################
# コンテンツヘッダ
sub print_viewer_header ($) {
    my $this = shift;
    $this->set_category_name;
    $this->print_page_header($setting::key);
    $this->{'match'} = {};
}

sub print_toolbox_top ($) {
    my $this = shift;
    return;
}

######################################################################
# コンテンツフッタ
sub print_contents_footer ($) {
    my $this = shift;

    #テーブル終了
    print $this->{'Table'}->_table;
    print '</div>';

    #前後ページへのジャンプ
    $this->print_page_jump_form;

    #再検索ボタン
    $this->print_mini_toolbox( 'bottom', 1 );
}

sub print_toolbox_bottom ($) {
    my $this = shift;
    return;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ( defined $main::m && $main::m eq 'Gate' ) {
        no warnings qw(once);

        #設定種キー設定
        $setting::security_key = 'revise';
        $setting::key          = 'gate';

        #デフォルトキー
        $main::k = 'gate' if !defined $main::k || $main::k eq '';
        $main::mod = $main::m;

        #クラス登録
        Common::class_register( 'gate', 'Gate' );

        #必須フォーム
        @setting::form = ( 'm', 'c', 's', 'w', 'f', 'u', 'mod' );
    }
}

1;
