package HandyCart;
require CMONOS::CGI_Lib::AjaxSetUp;
@ISA = qw(AjaxSetUp);
use strict;
use utf8;
######################################################################
# 非同期型カート内容変更モジュール
# HandyCart.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-10-31
######################################################################
# メイン
sub run ($) {
    my $this = shift;
    require CMONOS::CGI_Lib::CartController;
    $cgi::CartController = CartController->new;
    binmode STDOUT;
    if ( $main::item && defined $main::quantity && $main::quantity eq '0' ) {
        $main::cancel = $main::item;
        undef $main::item;
        undef $main::quantity;
    }
    if ($main::cancel) {
        $cgi::CartController->cancel($main::cancel);
        $this->print_response( { 'status' => 'success' } );
    }
    elsif ( $main::item && !$this->is_nan($main::quantity) ) {
        $cgi::CartController->change( { $main::item => $main::quantity } );
        my @message = $this->dialog;
        if (@message) {
            map {
                $_ =~ s/\\n//g;
                $_ =~ s/;//g;
            } @message;
            $this->print_response(
                { 'status' => 'error', 'message' => join( ';', @message ) } );
        }
        else {
            $this->print_response( { 'status' => 'success' } );
        }
    }
    else {
        $this->print_response( { 'status' => 'error' } );
    }
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ( $default::type && $default::type eq 'order' ) {
        no warnings qw(once);

        #設定DB読み込み設定
        $setting::general  = 1;    #一般設定読み込み
        $setting::deco     = 0;    #テキスト装飾設定読み込み
        $setting::security = 1;    #アクセス権設定読み込み
        $setting::table    = 0;    #テーブル設定読み込み
        $setting::page     = 0;    #ページ設定読み込み

        $setting::field_db_name = '';    #フィールド設定DB
        $setting::field         = 0
            ; #フィールド設定読み込み（2=オリジナルも読み込む）

        #設定種キー設定
        $setting::security_key = 'checkout'
            if !defined $setting::security_key
            || !$setting::security_key
            ;    #デフォルトセキュリティキー

        #クッキー
        $cookie::id_enabled = 1;    #ID情報クッキー読み込み

        #必須フォーム
        @setting::form = ();

        #設定種キー設定
        $setting::key = 'handycart';    #ページ設定キー

        #デフォルトキー
        $main::k = 'handycart' if !defined $main::k || !$main::k;

        #クラス登録
        Common::class_register( 'handycart', 'HandyCart' );
    }
}

1;
