package CartViewerPage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# チェックアウトページ設定モジュール
# CartViewerPage.pm ver1.0.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2012-03-15
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    my $this = shift;
    push( @check::checkbox, 'ajaxdisabled' );    #チェックボックス
    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'cartviewer';              # データキー
    $preference::name
        = 'カートを見る ページレイアウト';  # 設定パネル名
    $preference::title
        = 'カートを見る ページのレイアウトについて設定します。';
    $setting::image_css = 'order-image.css';
}

######################################################################
# 設定チェック
sub is_valid_setting ($) {
    my $this = shift;

    #ナビメーカーに CGI の名前を登録する
    my $navi_db = $default::preference_dir;
    if ( $navi_db =~ s![0-9a-zA-Z_]+$!navimaker/navi_db! ) {
        my ( %navi, $update );
        use Fcntl qw(:DEFAULT);
        eval 'use ' . $env::dbm_file . ';';
        tie( %navi, $env::dbm_file, $navi_db, O_RDWR, $env::dbm_mode );
        if ( ref tied %navi ) {
            my $k = 'orderCartViewer_title';
            utf8::encode($k) if utf8::is_utf8($k);
            if ( defined $navi{$k} ) {
                my $title
                    = $main::data{'cartviewer_title'}
                    || $setting::general{'cginame'}
                    || 'カートを見る';
                if ( $this->decode_utf8( $navi{$k} ) ne $title ) {
                    $navi{$k} = $this->encode_utf8($title);
                    $update = 1;
                }
            }
        }
        untie %navi;
        if ($update) {
            require CMONOS::CGI_Lib::NavUpdate;
            NavUpdate->new->update;
        }
    }

}

######################################################################
# 設定パネル
sub use_checkout_icon ($) {
    my $this = shift;
    require CMONOS::CGI_Lib::Deco;
    my $icon_obj
        = Deco->new( $env::image_dir . '/order', $env::image_lib . '/order' );
    return $icon_obj;
}

sub print_sub_preference_panel ($$$) {
    my ( $this, $id, $key ) = @_;
    my $icon_obj = $this->use_checkout_icon;
    print '<fieldset><legend>アイコン設定</legend>';
    $this->print_button_menu( $cgi::Deco, '閉じる ボタン',
        $id, 'closeButton', 'close' );
    $this->print_button_menu( $cgi::Deco, '戻る ボタン',
        $id, 'backButton', 'return' );
    $this->print_button_menu( $icon_obj, 'ゴミ箱 ボタン',
        $id, 'trashButton', 'trash' );
    $this->print_button_menu( $icon_obj, '再計算 ボタン',
        $id, 'sumButton', 'sum' );
    $this->print_button_menu( $icon_obj, '空にする ボタン',
        $id, 'emptyButton', 'empty', 1 );
    $this->print_button_menu( $icon_obj, 'レジに進む ボタン',
        $id, 'checkoutButton', 'checkout', 1 );
    print '</fieldset>';
    print '<fieldset><legend>Ajax 通信設定</legend>';
    print '<label><input type="checkbox" name="data:'
        . $id
        . 'ajaxdisabled" value="1"'
        . (
        ( $main::data{ $key . 'ajaxdisabled' } ) ? ' checked="checked"' : '' )
        . ' /> カート内容の変更を非同期で送信しない。</label>';
    print '</fieldset>';
}

sub print_button_menu ($$$$$$;$$) {
    my ( $this, $icon_obj, $title, $key, $name, $image_type, $alt_required,
        $togglable )
        = @_;
    print '<fieldset><legend>';
    print '<input type="checkbox" name="data:'
        . $key
        . $name
        . 'Enabled" id="data:'
        . $key
        . $name
        . 'Enabled"  value="1"'
        . ( ( $main::data{ $key . $name . 'Enabled' } )
        ? ' checked="checked"'
        : '' )
        . ' title="表示する" /> '
        if $togglable;
    print $title . '</legend>';
    print $icon_obj->button_menu( 'data:' . $key . $name,
        $image_type, 120, $main::data{ $key . $name } );
    print '<div class="additional-field"><label for="data:'
        . $key
        . $name
        . 'Name">ボタンの名前</label><input type="text" size="50" maxlength="100" name="data:'
        . $key
        . $name
        . 'Name" id="data:'
        . $key
        . $name
        . 'Name" value="'
        . $this->escape( $main::data{ $key . $name . 'Name' } )
        . '" /></div>'
        if $alt_required;
    print '</fieldset>';
}

sub print_sub_sub_preference_panel ($$$) {
    my ( $this, $id, $key ) = @_;
}

######################################################################
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( 'c000', 'CartViewerPage' );

    #ツール登録
    $setting::sub_jump_menu{'page'}{'c000'} = 'カートを見る ページ';
    $setting::selected_jump_menu{'c000'} = 't000'
        ; #サブメニューがあるときメインメニューのデフォルトキー

    $preference::page{'c000'} = 'cartviewer';
}

1;
