package TMCommon;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
use strict;
use utf8;
######################################################################
# テーブルメーカー共通モジュール
# TMCommon.pm ver1.2.8
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2017-07-30
######################################################################
# Eメール→ID
sub email_to_id ($$) {
    my ( $this, $email ) = @_;
    my $id = '';
    if ($email) {
        my %email_to_id;
        tie( %email_to_id, $env::dbm_file, $default::db . '/email_to_id',
            O_RDONLY, $env::dbm_mode );
        if ( ref tied %email_to_id ) {
            $id = $email_to_id{ $this->encode_utf8($email) } || '';
        }
        untie %email_to_id;
    }
    return $id;
}

######################################################################
# ヘッダ
sub print_viewer_header ($) {
    my $this = shift;
    $this->use_deco;
    $this->set_category_name;
    $this->push_title( $this->{'favorites_field_name'}, 1 )
        if $this->{'has_favorites'};
    $this->push_title(
        ( ($default::english) ? 'Search Results' : '検索結果' ), 1 )
        if $this->{'is_searched'};
    $this->push_title( $this->{'record_title'} ) if $this->{'record_title'};
    my $url
        = ( $default::type && $default::type eq 'order' )
        ? $this->my_url . '?m=Gate'
        : $this->view_url;
    $this->set_canonical($url);
    $this->set_og_url($url);
    $this->set_og_cgi_summary;
    $this->set_favorites_control_js;
    $this->set_delete_this_js if $this->{'revForm'};
    $this->set_style_sheet_link("$env::css/tablemaker-common.css");
    $this->print_page_header($setting::key);
}

sub set_category_name ($) {
    my $this = shift;
    if ( defined $setting::page{'categoryname'}
        && $setting::page{'categoryname'} )
    {
        my $sub_title  = '';
        my @categories = sort {
            $setting::category{$a}{'ORDER'}
                <=> $setting::category{$b}{'ORDER'}
                || $a <=> $b
        } grep( defined $_ && $_ !~ /[^0-9]/, keys %setting::category );
        my $category_count = @categories;
        if ( $category_count && $category_count > 1 ) {
            my $count = 0;
            my %done;
            foreach my $catlist (@main::c) {
                foreach my $cat ( split( /,/, $catlist ) ) {
                    if (   !$done{$cat}++
                        && defined $setting::category{$cat}{'name'}
                        && $setting::category{$cat}{'name'} ne '' )
                    {
                        $count++;
                    }
                }
            }
            if ( $count == $category_count ) {
                $this->push_title(
                    ($default::english) ? 'All' : '全データ' );
            }
            else {
                $this->push_title(
                    $this->_set_category_name(
                        \%setting::category, \@categories, '', \%done
                    )
                );
            }
        }
    }
}

sub _set_category_name ($$$$$) {
    my ( $this, $category, $categories, $key, $done ) = @_;
    $key = '' if !defined $key;
    my ( $sub_key, @sub_list, $list );
    $done = {} if !ref $done;
    $sub_key = $list = '';
    foreach my $c (@$categories) {
        next if !defined $c;
        $sub_key = $1
            if $sub_key eq ''
            && $category->{$c}->{'name'}
            && $category->{$c}->{'name'} =~ m!^($key[^/]+/?)!;
        if (   $sub_key ne ''
            && $sub_key ne $key
            && $category->{$c}->{'name'} =~ /^$sub_key/
            && ( $sub_key =~ m!/$! || $category->{$c}->{'name'} eq $sub_key )
            )
        {
            push( @sub_list, $c );
        }
        else {
            if ( @sub_list && $sub_key ne '' && $sub_key ne $key ) {
                my $category_name = '';
                if ( !grep( !$done->{$_}, @sub_list ) ) {
                    $category_name = $sub_key;
                    $category_name =~ s!/$!!s;
                }
                else {
                    $category_name
                        = $this->_set_category_name( $category, \@sub_list,
                        $sub_key, $done );
                }
                $list .= ( ( $list ne '' ) ? ', ' : '' ) . $category_name
                    if $category_name ne '';
            }
            $sub_key = $1
                if $category->{$c}->{'name'}
                && $category->{$c}->{'name'} =~ m!^($key[^/]+/?)!;
            undef @sub_list;
            push( @sub_list, $c );
        }
    }
    if ( @sub_list && $sub_key ne '' && $sub_key ne $key ) {
        my $category_name = '';
        if ( !grep( !$done->{$_}, @sub_list ) ) {
            $category_name = $sub_key;
            $category_name =~ s!/$!!s;
        }
        else {
            $category_name
                = $this->_set_category_name( $category, \@sub_list, $sub_key,
                $done );
        }
        $list .= ( ( $list ne '' ) ? ', ' : '' ) . $category_name
            if $category_name ne '';
    }
    return $list;
}

sub push_title ($$;$) {
    my ( $this, $title, $search_flag ) = @_;
    return if !defined $title || $title eq '';
    $this->push_window_title($title);
    if ( defined $setting::page{$setting::key}{'titleText'}
        && $setting::page{$setting::key}{'titleText'} ne '' )
    {
        my $tag = ( $setting::page{$setting::key}{'titleText'}
                =~ s/((<\/[^>]+>)+)$// ) ? $1 : '';
        if ( defined $search_flag && $search_flag ) {
            $setting::page{$setting::key}{'titleText'}
                .= ' (' . $title . ')' . $tag;
        }
        else {
            $setting::page{$setting::key}{'titleText'}
                .= ' &gt; ' . $title . $tag;
        }
    }
}

sub set_favorites_control_js ($) {
    my $this = shift;
    return if !$this->favorites_enabled;
    my $js = <<'JAVASCRIPT';
cmonos.tool.favorites = {
	list : cmonos.value.deleteFromArray(cmonos.document.getCookie('favorites').split(/,/),""),

	set : function (this_record,add_record) {
		if (!this.list) this.list = new Array();
		var updated = false;
		if (add_record) {
			if (!cmonos.value.isIncluded(this.list,this_record)) {
				this.list.push(this_record);
				updated = true;
			}
		} else {
			if (cmonos.value.isIncluded(this.list,this_record)) {
				this.list = cmonos.value.deleteFromArray(this.list,this_record);
				updated = true;
			}
		}
		if (updated) {
			if (this.list.length > 0) {
				cmonos.document.setCookie('favorites',this.list.join(","));
			} else {
				cmonos.document.deleteCookie('favorites');
			}
			this.toggle();
		}
	},

	toggle : function () {
		var display = (this.list && this.list.length > 0) ? "" : "none";
		if (document.getElementById('show-favorites-top')) document.getElementById('show-favorites-top').style.display = display;
		if (document.getElementById('show-favorites-bottom')) document.getElementById('show-favorites-bottom').style.display = display;
	},

	checkbox : function (this_id,title) {
		document.write('<form action="#"><input type="checkbox" onclick="cmonos.tool.favorites.set(\''+this_id+'\',this.checked);" title="'+title+'"'+((cmonos.value.isIncluded(this.list,this_id)) ? ' checked="checked"' : '')+' /></form>');
	},

	reset : function () {
		this.list = new Array();
		cmonos.document.deleteCookie('favorites');
	}
}
JAVASCRIPT
    $this->set_javascript($js);
    $this->set_onload(
        (   ( $this->{'reset_favorites'} )
            ? 'cmonos.tool.favorites.reset();'
            : ''
        )
        . 'cmonos.tool.favorites.toggle();'
    );
    return;
}

sub set_delete_this_js ($) {
    my $this = shift;
    return;
}

sub favorites_enabled ($) {
    my $this = shift;
    return $this->{'favorites_enabled'}
        if defined $this->{'favorites_enabled'};
    $this->{'favorites_enabled'} = 0;
    foreach my $field ( values %field::obj ) {
        if (   $field->{'class'} eq 'xtm_favorites'
            && !$field->{'Hidden'}
            && ( $field->{'Open'} || $this->is_secure('secret') ) )
        {
            $this->{'favorites_enabled'}    = 1;
            $this->{'favorites_field_name'} = $field->name;
            last;
        }
    }
    return $this->{'favorites_enabled'};
}

######################################################################
# フッタ
sub print_viewer_footer ($) {
    my $this = shift;
    $this->print_page_footer($setting::key);
}

######################################################################
# 検索
sub has_to_satisfy_queries ($) {
    my $this = shift;
    if ( $field::for{'coordinates'}
        && ref $main::search{ $field::for{'coordinates'} } )
    {
        delete $main::search{ $field::for{'coordinates'} }{'sw'};
        delete $main::search{ $field::for{'coordinates'} }{'ne'};
    }
    return ();
}

sub sort_and_search ($;$@) {
    my ( $this, $target_no, @target_c ) = @_;

    #ソート
    my $sort_db = 'mtime';
    $main::s
        = ( $field::for{'sort'} ) ? $field::for{'sort'}
        : ( $field::for{'key'} )   ? $field::for{'key'}
        : ( $field::for{'title'} ) ? $field::for{'title'}
        : ''
        if !defined $main::s || $main::s eq '';
    if (   ref $field::obj{$main::s}
        && $field::obj{$main::s}->sort_enabled
        && $field::obj{$main::s}->{'sortEnabled'}
        && !$field::obj{$main::s}->{'Hidden'}
        && ( $field::obj{$main::s}->{'Open'} || $this->is_secure('secret') ) )
    {
        $sort_db = $field::obj{$main::s}->db;
        if ( !$sort_db ) {
            $sort_db = 'mtime';
            $main::s = '';
        }
    }
    else {
        $main::s = '';
    }
    $main::w = $field::SORTORDER || 'ascend'
        if !defined $main::w || $main::w eq '';
    $this->{'sort'} = {};

    #検索無し+番号指定
    if (   @main::c == 1
        && defined $main::n
        && $main::n ne ''
        && $main::pickup )
    {
        my $c = $main::c[0];
        my $kdb
            = ( $field::for{'name'} ) ? $field::for{'name'}
            : ( $field::for{'key'} ) ? $field::for{'key'}
            :                          $sort_db;
        unless ( ref tied %{ $this->{'DB'}{$c}{$kdb} } ) {
            tie( %{ $this->{'DB'}{$c}{$kdb} },
                $env::dbm_file, "$default::db/$c/$kdb", O_RDONLY,
                $env::dbm_mode );
        }
        if ( defined $this->{'DB'}{$c}{$kdb}{ $this->encode_utf8($main::n) } )
        {
            if ( !$this->is_pending_record( $c, $main::n, $target_no ) ) {
                $this->{'record_title'}
                    = $this->{'sort'}{ $main::n . '@' . $c }
                    = $this->decode_utf8(
                    $this->{'DB'}{$c}{$kdb}{ $this->encode_utf8($main::n) } );
                $this->{'mcount'} = 1;
            }
        }
        $this->{'match'} = {};
        return;
    }

    $this->{'match'}  = {};
    $this->{'mcount'} = 0;
    @target_c
        = (@main::c) ? @main::c
        : ( defined $main::c && $main::c ne '' ) ? ($main::c)
        : ()
        if !@target_c;

    #お気に入り抽出
    undef $main::fv
        if !grep( $main::m eq $_,
        'TableViewer', 'TileViewer', 'KMLViewer',
        'GMapViewer',  'DetailViewer' );
    my %favorites;
    if ( $main::fv && $this->favorites_enabled ) {
        my @favorites;
        if ($main::fav) {
            @favorites = grep( $_ ne '' && $_ !~ /[^0-9]/,
                split( /,/, $main::fav ) );
            push( @setting::form, 'fav' );
        }
        else {
            @favorites = grep( $_ ne '' && $_ !~ /[^0-9]/,
                split( /,/, $this->read_cookie_direct('favorites') ) );
        }
        if (@favorites) {
            my $order = 1;
            foreach my $no (@favorites) {
                my ( $c, $n )
                    = $this->get_category_and_number_from_permanent_id($no);
                $favorites{$c}{$n} = $order++;
            }
            @target_c = keys %favorites;
            $this->{'has_favorites'} = 1;
        }
    }

    #キーワード検索
    my ( @q, @num );
    @q = $this->make_patterns( \$main::q, 1 );
    @num = grep( $_ =~ /^\\?=[0-9]+(?:\@[0-9]+|)$/, @q );
    map( $_ =~ s/^\\?=//, @num ) if @num;
    undef $main::order_item
        if !$default::type
        || $default::type ne 'order'
        || !$field::for{'order_info'}
        || !ref $field::obj{ $field::for{'order_info'} }
        || $field::obj{ $field::for{'order_info'} }->db ne 'order';

    #検索
    my @required = $this->has_to_satisfy_queries;
    my @fields   = keys %field::obj;
    my $count    = 0;
    my %done;
MCATEGORY:
    foreach my $ct (@target_c) {
    CATEGORY:
        foreach my $c ( split( /,/, $ct ) ) {
            next CATEGORY if $done{$c}++ || $c =~ /[^0-9]/;
            my ( $dir, $records_ref );
            $dir = "$default::db/$c/";
            unless ( ref tied %{ $this->{'DB'}{$c}{'mtime'} } ) {
                tie(%{ $this->{'DB'}{$c}{'mtime'} },
                    $env::dbm_file, "$dir/mtime",
                    O_RDONLY,       $env::dbm_mode
                );
            }
            if (%favorites) {
                $records_ref = $favorites{$c};
            }
            elsif ( ref tied %{ $this->{'DB'}{$c}{'mtime'} } ) {
                $records_ref = $this->{'DB'}{$c}{'mtime'};
            }
            if ( ref $records_ref ) {
            RECORD:
                while ( my ($n) = each %$records_ref ) {
                    next RECORD
                        if ( %favorites
                        && !
                        defined $this->{'DB'}{$c}{'mtime'}
                        { $this->encode_utf8($n) } )
                        || $this->is_pending_record( $c, $n, $target_no );
                    $count++;
                    my $matched   = 0;
                    my $q_matched = 0;
                    my $satisfied = 1;
                    my $text      = '';
                SEARCH:
                    foreach my $id (@fields) {
                        next SEARCH
                            if !ref $field::obj{$id}
                            || (
                            !$field::obj{$id}->match_enabled
                            && ( ( !@q && !@num )
                                || !$field::obj{$id}
                                ->format_for_text_enabled )
                            )
                            || (
                            !$this->{'search_enabled'}
                            && (  !$field::obj{$id}->{'searchEnabled'}
                                || $field::obj{$id}->{'Hidden'}
                                || (   !$field::obj{$id}->{'Open'}
                                    && !$this->is_secure('secret') )
                            )
                            );
                        my $db = $field::obj{$id}->db;
                        next SEARCH if !defined $db || $db eq '';
                        $this->{'is_searched'} = 1;
                        unless ( ref tied %{ $this->{'DB'}{$c}{$db} } ) {
                            tie( %{ $this->{'DB'}{$c}{$db} },
                                $env::dbm_file, "$dir/$db", O_RDONLY,
                                $env::dbm_mode );
                        }
                        my $dat
                            = $this->decode_utf8(
                            $this->{'DB'}{$c}{$db}{ $this->encode_utf8($n) } )
                            || '';
                        if ( $field::obj{$id}->match_enabled ) {
                            my $required;
                            if ( @required && grep( $_ eq $id, @required ) ) {
                                $required = 1;
                            }
                            else {
                                $this->{'is_searched_full'} = 1;
                            }
                            if ( $field::obj{$id}->match( \$dat, $c, $n ) ) {
                                $matched++ if !$required;
                            }
                            elsif ( $main::and || $required ) {
                                $matched = $satisfied = 0;
                                last SEARCH;
                            }
                        }
                        if (   defined $dat
                            && @q
                            && $field::obj{$id}->format_for_text_enabled )
                        {
                            $text .= ( ($text) ? "\x0A" : '' )
                                . $field::obj{$id}->format_for_text($dat);
                        }
                    }
                    if ( $text && @q ) {
                        $q_matched
                            = $this->pattern_matched( \$text, \@q, 1, 'and',
                            1 );
                    }
                    if (@num) {
                        foreach my $tr (@num) {
                            my ( $tc, $tn )
                                = $this
                                ->get_category_and_number_from_permanent_id(
                                $tr);
                            $q_matched++ if $tc eq $c && $tn eq $n;
                        }
                    }
                    if ($main::order_item) {
                        my $id = $field::for{'order_info'};
                        local $main::search{$id}{'str'}  = $main::order_item;
                        local $main::search{$id}{'mode'} = 'and';
                        local $main::search{$id}{'i'}    = '';
                        unless ( ref tied %{ $this->{'DB'}{$c}{'order'} } ) {
                            tie(%{ $this->{'DB'}{$c}{'order'} },
                                $env::dbm_file, "$dir/order",
                                O_RDONLY,       $env::dbm_mode
                            );
                        }
                        my $dat
                            = $this->decode_utf8( $this->{'DB'}{$c}{'order'}
                                { $this->encode_utf8($n) } )
                            || '';
                        $this->{'is_searched'} = 1;
                        $satisfied = 0
                            if !$field::obj{$id}->match( \$dat, $c, $n );
                    }
                    if (   $satisfied
                        && ( !$this->{'is_searched_full'} || $matched )
                        && ( ( !@q && !@num ) || $q_matched ) )
                    {
                        my $no = $n . '@' . $c;
                        $this->{'match'}{$no} += $matched + $q_matched
                            if $this->{'is_searched'};
                        if (%favorites) {
                            $this->{'sort'}{$no} = $favorites{$c}{$n};
                        }
                        else {
                            unless (
                                ref tied %{ $this->{'DB'}{$c}{$sort_db} } )
                            {
                                tie(%{ $this->{'DB'}{$c}{$sort_db} },
                                    $env::dbm_file, "$dir/$sort_db",
                                    O_RDONLY,       $env::dbm_mode
                                );
                            }
                            $this->{'sort'}{$no}
                                = ( $main::s && ref $field::obj{$main::s} )
                                ? $field::obj{$main::s}->sample(
                                $this->decode_utf8(
                                    $this->{'DB'}{$c}{$sort_db}
                                        { $this->encode_utf8($n) }
                                ),
                                $c, $n
                                )
                                : $this->decode_utf8(
                                $this->{'DB'}{$c}{$sort_db}
                                    { $this->encode_utf8($n) } );
                        }
                        $this->{'mcount'}++;
                    }
                }
            }
        }
    }
    if ( %favorites && !$count ) {
        $this->{'reset_favorites'} = 1;
    }

}

sub query_optimize ($) {
    my $this = shift;
    if (@main::f) {
        my @f              = @main::f;
        my $is_not_default = 0;
        while ( my ( $id, $field ) = each %field::obj ) {
            if (   ref $field
                && !$field->{'Hidden'}
                && $field->{'Default'}
                && ( $field->{'Open'} || $this->is_secure('secret') ) )
            {
                if ( !grep( $_ eq $id, @f ) ) {
                    $is_not_default = 1;
                    last;
                }
                else {
                    @f = grep( $_ ne $id, @f );
                }
            }
        }
        @f             = grep( $_ ne 'r', @f );
        @setting::form = grep( $_ ne 'f', @setting::form )
            if !$is_not_default && !@f;
    }
    @setting::form = grep( $_ ne 'u', @setting::form )
        if !$main::u || ( $main::u eq ( $setting::page{'u'} || '20' ) );
    @setting::form = grep( $_ ne 'uni', @setting::form )
        if !$main::uni
        || ( $main::uni eq ( $main::u || $setting::page{'u'} || '20' ) );
    @setting::form = grep( $_ ne 'w', @setting::form )
        if !$main::w || ( $main::w eq ( $field::SORTORDER || 'ascend' ) );
    my $default_s
        = ( $field::for{'sort'} ) ? $field::for{'sort'}
        : ( $field::for{'key'} )   ? $field::for{'key'}
        : ( $field::for{'title'} ) ? $field::for{'title'}
        :                            '';
    @setting::form = grep( $_ ne 's', @setting::form )
        if !$main::s || $main::s eq $default_s;
    @setting::form = grep( $_ ne 'q', @setting::form )
        if !$main::q || $main::q eq '';
    @setting::form = grep( $_ ne 'ct', @setting::form )
        if $main::ct
        && ( ( $main::c && $main::ct eq $main::c )
        || ( @main::c && @main::c == 1 && $main::ct eq $main::c[0] ) );

    if (%main::search) {
        my %delete;
        my @delete_ids;
        while ( my ( $id, $hash ) = each %main::search ) {
            my $count = 0;
            while ( my ( $k, $v ) = each %$hash ) {
                if ( defined $v
                    && ( ( ref $v && @$v ) || ( !ref $v && $v ne '' ) ) )
                {
                    $count++;
                }
                else {
                    $delete{$id} = $k;
                }
            }
            if ( $count && $count == 1 && $main::search{$id}{'mode'} ) {
                $delete{$id} = 'mode';
                $count = 0;
            }
            push( @delete_ids, $id ) if !$count;
        }
        while ( my ( $id, $name ) = each %delete ) {
            delete $main::search{$id}{$name};
        }
        foreach my $id (@delete_ids) {
            delete $main::search{$id};
        }
        undef %main::search if !%main::search;
    }
    @setting::form = grep( $_ ne 'search' && $_ ne 'and', @setting::form )
        if !%main::search;
}

sub referer_url ($) {
    my $this = shift;
    return $this->view_url(1);
}

sub view_url ($;$) {
    my ( $this, $for_referer ) = @_;
    my $m = ($for_referer) ? $main::mod : $main::m;
    if ( !defined $cgi::path || $cgi::path eq '' ) {
        $cgi::path = $ENV{'SCRIPT_NAME'};
        $cgi::path = $env::cgi_server . $cgi::path
            if defined $env::cgi_server && $env::cgi_server;
    }
    my $view_url
        = ( ($for_referer) ? $cgi::path : $this->my_url ) . '?'
        . ( ($m) ? 'm=' . ( ( $m eq 'KMLViewer' ) ? 'GMapViewer' : $m )
        : ( $default::m && $default::m eq 'Index' ) ? 'm=Gate'
        :                                             '' );
    if (@main::ct) {
        no warnings qw(numeric);
        foreach my $cat ( sort { $a <=> $b || $a cmp $b } @main::ct ) {
            $view_url .= '&c=' . $cat;
        }
    }
    elsif ( defined $main::ct && $main::ct ne '' ) {
        $view_url .= '&c=' . $main::ct;
    }
    elsif (@main::c) {
        no warnings qw(numeric);
        foreach my $cat ( sort { $a <=> $b || $a cmp $b } @main::c ) {
            $view_url .= '&c=' . $cat;
        }
    }
    elsif ( defined $main::c && $main::c ne '' ) {
        $view_url .= '&c=' . $main::c;
    }
    $view_url
        .= ( ( defined $main::n && $main::n ne '' ) ? '&n=' . $main::n : '' )
        . $this->set_query(
        'url+',
        [   grep( $_ ne 'm'
                    && $_ ne 'k'
                    && $_ ne 'c'
                    && $_ ne 'n'
                    && $_ ne 'mod'
                    && $_ ne 'ct'
                    && $_ ne 'dn'
                    && $_ ne 'mf'
                    && $_ ne 'type'
                    && $_ ne 'ss'
                    && $_ ne 'sw',
                @setting::form )
        ]
        );
    return $view_url;
}

sub is_pending_record ($$$$) {
    my ( $this, $c, $n, $target_no ) = @_;
    return 0 if !$field::for{'pending'};
    my ( $is_pending, $is_expired );
    if (   !ref $this->{'DB'}{$c}{'pending'}
        || !ref tied %{ $this->{'DB'}{$c}{'pending'} } )
    {
        tie(%{ $this->{'DB'}{$c}{'pending'} },
            $env::dbm_file, "$default::db/$c/pending", O_RDWR | O_CREAT,
            $env::dbm_mode
        );
    }
    if ( ref tied %{ $this->{'DB'}{$c}{'pending'} } ) {
        my ( $was_pending, $start, $end )
            = (
            defined $this->{'DB'}{$c}{'pending'}{ $this->encode_utf8($n) } )
            ? split(
            /-/,
            $this->decode_utf8(
                $this->{'DB'}{$c}{'pending'}{ $this->encode_utf8($n) }
            )
            )
            : ( 0, '', '' );
        if ( !$start && !$end ) {
            $is_pending = $was_pending;
        }
        else {
            $was_pending = 0 if !$was_pending;
            my $time = time;
            $is_pending = ( ( !$start || $start < $time )
                    && ( !$end || $time < $end ) ) ? 0 : 1;
            if ( $was_pending ne $is_pending ) {
                unless ( ref tied %{ $this->{'DB'}{'pref'}{'category'} } ) {
                    tie(%{ $this->{'DB'}{'pref'}{'category'} },
                        $env::dbm_file,
                        $default::preference_dir . '/category',
                        O_RDWR | O_CREAT,
                        $env::dbm_mode
                    );
                }
                if (   $end
                    && $field::obj{ $field::for{'pending'} }->{'margin'}
                    && $time > $end )
                {
                    if ( $field::obj{ $field::for{'pending'} }->{'margin'}
                        == 1 )
                    {
                        $this->{'expired_record'} = {}
                            if !ref $this->{'expired_record'};
                        $this->{'expired_record'}{$c} = []
                            if !ref $this->{'expired_record'}{$c};
                        push( @{ $this->{'expired_record'}{$c} }, $n );
                        $is_expired = 1;
                    }
                    else {
                        unless ( ref tied %{ $this->{'DB'}{$c}{'expire'} } ) {
                            tie(%{ $this->{'DB'}{$c}{'expire'} },
                                $env::dbm_file,
                                "$default::db/$c/expire",
                                O_RDWR | O_CREAT,
                                $env::dbm_mode
                            );
                        }
                        if ( ref tied %{ $this->{'DB'}{$c}{'expire'} } ) {
                            $this->{'DB'}{$c}{'expire'}
                                { $this->encode_utf8($n) }
                                = $this->encode_utf8(
                                $time + $field::obj{ $field::for{'pending'} }
                                    ->{'margin'} );
                            $this->{'DB'}{$c}{'pending'}
                                { $this->encode_utf8($n) }
                                = $this->encode_utf8(
                                      $is_pending . '-'
                                    . $start . '-'
                                    . $end . '-'
                                    . $this->decode_utf8(
                                    $this->{'DB'}{$c}{'expire'}
                                        { $this->encode_utf8($n) }
                                    )
                                );
                        }
                    }
                }
                else {
                    $this->{'DB'}{$c}{'pending'}{ $this->encode_utf8($n) }
                        = $this->encode_utf8(
                        $is_pending . '-' . $start . '-' . $end );
                }
                if ( ref tied %{ $this->{'DB'}{'pref'}{'category'} } ) {
                    if ($is_pending) {
                        $this->{'DB'}{'pref'}{'category'}{ $c . '_count' }--;
                        $this->{'DB'}{'pref'}{'category'}{ $c . '_total' }--
                            if $is_expired;
                    }
                    else {
                        $this->{'DB'}{'pref'}{'category'}{ $c . '_count' }++;
                    }
                }
                if (!$is_expired
                    && (   $is_pending
                        || $field::obj{ $field::for{'pending'} }->{'mTime'} )
                    )
                {
                    $this->{'modified_record'} = {}
                        if !ref $this->{'modified_record'};
                    $this->{'modified_record'}{$c} = {}
                        if !ref $this->{'modified_record'}{$c};
                    $this->{'modified_record'}{$c}{$n} = $is_pending;
                }
                $field::obj{ $field::for{'pending'} }->pending_notice(
                    $field::obj{ $field::for{'pending'} }->_pending_status(
                        $is_pending, $start, $end, 0, 1, 1
                    ),
                    $c, $n
                );
            }
        }
    }
    return (
        $is_expired || ( $is_pending
            && $setting::pending_check
            && !$this->is_secure('pending')
            && ( !defined $target_no || $target_no ne ( $n . '@' . $c ) ) )
    ) ? 1 : 0;
}

sub is_pending_record_detail ($$$;$) {
    my ( $this, $c, $n, $ver ) = @_;
    if ( $field::for{'pending'} ) {
        my ( %pending, %mtime, %general, $is_pending, $is_expired );
        tie( %pending, $env::dbm_file, "$default::db/$c/pending",
            O_RDWR | O_CREAT,
            $env::dbm_mode );
        if ( ref tied %pending ) {
            my ( $was_pending, $start, $end )
                = ( defined $pending{ $this->encode_utf8($n) } )
                ? split( /-/,
                $this->decode_utf8( $pending{ $this->encode_utf8($n) } ) )
                : ( 0, 0, 0 );
            if ( !$start && !$end ) {
                $is_pending = $was_pending;
            }
            else {
                $was_pending = 0 if !$was_pending;
                my $time = time;
                $is_pending = ( ( !$start || $start < $time )
                        && ( !$end || $time < $end ) ) ? 0 : 1;
                if ( $was_pending ne $is_pending ) {
                    my ( %category, %expire );
                    if (   $end
                        && $field::obj{ $field::for{'pending'} }->{'margin'}
                        && $time > $end )
                    {
                        if ( $field::obj{ $field::for{'pending'} }->{'margin'}
                            == 1 )
                        {
                            $is_expired = 1;
                        }
                        else {
                            tie( %expire, $env::dbm_file,
                                "$default::db/$c/expire", O_RDWR | O_CREAT,
                                $env::dbm_mode );
                            if ( ref tied %expire ) {
                                $expire{ $this->encode_utf8($n) }
                                    = $this->encode_utf8( $time
                                        + $field::obj{ $field::for{'pending'}
                                        }->{'margin'} );
                                $pending{ $this->encode_utf8($n) }
                                    = $this->encode_utf8(
                                          $is_pending . '-'
                                        . $start . '-'
                                        . $end . '-'
                                        . $this->decode_utf8(
                                        $expire{ $this->encode_utf8($n) }
                                        )
                                    );
                            }
                            untie %expire;
                        }
                    }
                    else {
                        $pending{ $this->encode_utf8($n) }
                            = $this->encode_utf8(
                            $is_pending . '-' . $start . '-' . $end );
                    }
                    tie(%category, $env::dbm_file,
                        $default::preference_dir . '/category',
                        O_RDWR | O_CREAT,
                        $env::dbm_mode
                    );
                    if ( ref tied %category ) {
                        if ($is_pending) {
                            $category{ $this->encode_utf8( $c . '_count' ) }
                                --;
                            $category{ $this->encode_utf8( $c . '_total' ) }--
                                if $is_expired;
                        }
                        else {
                            $category{ $this->encode_utf8( $c . '_count' )
                            }++;
                        }
                    }
                    untie %category;
                    if (!$is_expired
                        && (   $is_pending
                            || $field::obj{ $field::for{'pending'} }
                            ->{'mTime'} )
                        )
                    {
                        $this->rss_refresh( $c, $n, $is_pending );
                        if ($field::obj{ $field::for{'pending'} }->{'mTime'} )
                        {
                            tie( %mtime, $env::dbm_file,
                                "$default::db/$c/mtime", O_RDWR | O_CREAT,
                                $env::dbm_mode );
                            if ( ref tied %mtime ) {
                                $mtime{ $this->encode_utf8($n) } = $time;
                            }
                            untie %mtime;
                            tie(%general,
                                $env::dbm_file,
                                $default::preference_dir . '/general',
                                O_RDWR | O_CREAT,
                                $env::dbm_mode
                            );
                            if ( ref tied %general ) {
                                $general{'mtime'} = $time;
                            }
                            untie %general;
                        }
                        $setting::general{'mtime'} = $time;
                    }
                    $field::obj{ $field::for{'pending'} }->pending_notice(
                        $field::obj{ $field::for{'pending'} }
                            ->_pending_status(
                            $is_pending, $start, $end, 0, 1, 1
                            ),
                        $c, $n
                    );
                }
            }
        }
        untie %pending;
        undef %pending;
        if ($is_expired) {
            $this->delete_record( $c, $n );
            $this->print_dialog( $setting::key,
                '<p>指定されたレコードは存在しません。</p>'
            );
            return 1;
        }
        elsif ( !$ver && $is_pending && !$this->is_secure('pending') ) {
            $this->print_password_check_form($setting::key);
            return 1;
        }
    }
    return 0;
}

sub rss_refresh ($$$$) {
    my ( $this, $c, $n, $is_pending ) = @_;
    if ($is_pending) {
        $this->index_sweeper( $c, $n );
    }
    else {
        my %data = ();
        foreach my $type ( 'title', 'key', 'content', 'media' ) {
            if ( $field::for{$type} ) {
                my $id = $field::for{$type};
                if ( ref $field::obj{$id} && $field::obj{$id}->db ) {
                    my $db = $field::obj{$id}->db;
                    my %db;
                    tie( %db, $env::dbm_file, "$default::db/$c/$db",
                        O_RDONLY, $env::dbm_mode );
                    $data{$id}{'str'}
                        = $this->decode_utf8( $db{ $this->encode_utf8($n) } )
                        if ref tied %db
                        && defined $db{ $this->encode_utf8($n) };
                    untie(%db);
                }
            }
        }
        $this->feed_db_rss( $c, $n, \%data );
    }
}

sub untie_all_dbm ($) {
    my $this = shift;
    if ( ref $this->{'modified_record'} ) {
        while ( my ( $c, $modified_records )
            = each %{ $this->{'modified_record'} } )
        {
            while ( my ( $n, $is_pending ) = each %$modified_records ) {
                if ($is_pending) {
                    $this->index_sweeper( $c, $n );
                }
                else {
                    my %data = ();
                    foreach my $type ( 'title', 'key', 'content', 'media' ) {
                        if ( $field::for{$type} ) {
                            my $id = $field::for{$type};
                            if ( ref $field::obj{$id}
                                && $field::obj{$id}->db )
                            {
                                my $db = $field::obj{$id}->db;
                                unless (
                                    ref tied %{ $this->{'DB'}{$c}{$db} } )
                                {
                                    tie(%{ $this->{'DB'}{$c}{$db} },
                                        $env::dbm_file,
                                        "$default::db/$c/$db",
                                        O_RDONLY,
                                        $env::dbm_mode
                                    );
                                }
                                $data{$id}{'str'}
                                    = $this->decode_utf8(
                                    $this->{'DB'}{$c}{$db}
                                        { $this->encode_utf8($n) } )
                                    if ref tied %{ $this->{'DB'}{$c}{$db} }
                                    && defined $this->{'DB'}{$c}{$db}
                                    { $this->encode_utf8($n) };
                            }
                        }
                    }
                    $this->feed_db_rss( $c, $n, \%data );
                }
            }
        }
    }
    while ( my ($c) = each %{ $this->{'DB'} } ) {
        while ( my ($db_id) = each %{ $this->{'DB'}{$c} } ) {
            untie( %{ $this->{'DB'}{$c}{$db_id} } );
            delete $this->{'DB'}{$c}{$db_id};
        }
        delete $this->{'DB'}{$c};
    }
    delete $this->{'DB'};
    if ( ref $this->{'modified_record'} ) {
        if ( $field::obj{ $field::for{'pending'} }->{'mTime'} ) {
            my $time = time;
            while ( my ( $c, $modified_records )
                = each %{ $this->{'modified_record'} } )
            {
                my (%mtime);
                tie( %mtime, $env::dbm_file, "$default::db/$c/mtime",
                    O_RDWR | O_CREAT,
                    $env::dbm_mode );
                if ( ref tied %mtime ) {
                    while ( my ( $n, $is_pending ) = each %$modified_records )
                    {
                        $mtime{$n} = $time;
                    }
                }
                untie %mtime;
            }
            my %general;
            tie(%general, $env::dbm_file,
                $default::preference_dir . '/general',
                O_RDWR | O_CREAT,
                $env::dbm_mode
            );
            if ( ref tied %general ) {
                $general{'mtime'} = $time;
            }
            untie %general;
            $setting::general{'mtime'} = $time;
        }
        delete $this->{'modified_record'};
    }
    if ( ref $this->{'expired_record'} ) {
        while ( my ( $c, $expired_records )
            = each %{ $this->{'expired_record'} } )
        {
            foreach my $n (@$expired_records) {
                $this->delete_record( $c, $n );
            }
        }
        delete $this->{'expired_record'};
    }
}

######################################################################
# ツールボタン
sub tm_tool_button ($$;$$$$$$$$) {
    my ($this,     $view,    $title,  $url,         $query,
        $li_class, $onclick, $target, $is_selected, $li_id
    ) = @_;
    if ( !ref $this->{'icon_obj'} ) {
        require CMONOS::CGI_Lib::Deco;
        $this->{'icon_obj'} = Deco->new(
            $env::image_dir . '/tablemaker',
            $env::image_lib . '/tablemaker'
        );
    }
    my $button
        = '<li'
        . ( ( defined $li_class && $li_class ne '' )
        ? ' class="' . $li_class . '"'
        : '' )
        . ( ( defined $li_id && $li_id ne '' ) ? ' id="' . $li_id . '"' : '' )
        . '>';
    if ( defined $url && $url ne '' ) {
        $url .= $this->amp_escape( $this->add_query( 'url', $query ) )
            if ref $query;
        $button .= $this->{'icon_obj'}->button(
            $view,
            ( ( $setting::page{$view} ) ? $setting::page{$view} : '' )
                . (
                  ( $is_selected && $is_selected == 2 ) ? '-active'
                : ($is_selected) ? '-selected'
                :                  ''
                ),
            $url, $title, $target,
            ( ($onclick) ? { 'onclick' => $onclick } : '' )
        );
    }
    else {
        if ($target) {
            if ( $onclick =~ /^return/ ) {
                $onclick =~ s/;$/ \&\& /;
                $onclick .= '(this.form.target=\'' . $target . '\');';
            }
            else {
                $onclick .= ';' if $onclick;
                $onclick .= 'this.form.target=\'' . $target . '\';';
            }
        }
        $button .= $this->{'icon_obj'}->submit_button(
            $view,
            ( ( $setting::page{$view} ) ? $setting::page{$view} : '' )
                . (
                  ( $is_selected && $is_selected == 2 ) ? '-active'
                : ($is_selected) ? '-selected'
                :                  ''
                ),
            $title,
            ( ($onclick) ? { 'onclick' => $onclick } : '' ),
            $query
        );
    }
    $button .= '</li>';
    return $button;
}

sub amp_escape ($$) {
    my ( $this, $url ) = @_;
    return '' if !defined $url;
    $url =~ s/\&/\&amp;/g;
    return $url;
}

sub gmap_view_enabled ($) {
    my $this = shift;
    return (
        ( !$ENV{'HTTP_USER_AGENT'} || $ENV{'HTTP_USER_AGENT'} !~ /MCONV/ )
            && defined $field::for{'coordinates'}
            && ref $field::obj{ $field::for{'coordinates'} }
            && $field::obj{ $field::for{'coordinates'} }->{'class'}
            && $field::obj{ $field::for{'coordinates'} }->{'class'} eq
            'webapi_gmap' ) ? 1 : 0;
}

sub add_field_footer ($$) {
    my ( $this, $data, $addition ) = @_;
    my $escaped_addition = $this->escape($addition);
    my $added            = 0;
    $added = 1 if $data =~ s/foot="(.*?)"/foot="$escaped_addition$1"/s;
    $added = 1
        if $data
        =~ s/(<!--foot(?!\w)[^>]*-->)(.*?)(<!--\/foot(?!\w)[^>]*-->)/$1$addition$2$3/s;
    if ( !$added ) {
        $data
            =~ s/(<!--\/field(?!\w)[^>]*-->)/<!--foot-->$addition<!--\/foot-->$1/s;
    }
    return $data;
}

######################################################################
# ツールボックス
sub print_toolbox ($$) {
    my ( $this, $suffix ) = @_;
    my $gmap_view_enabled = $this->gmap_view_enabled;
    my @form = grep( $_ ne 'm' && $_ ne 'k' && $_ ne 'fv', @setting::form );
    @form = grep( $_ ne 'c', @form )
        if defined $setting::page{'categoryselector'}
        && $setting::page{'categoryselector'};
    @form = grep( $_ ne 'q', @form )
        if defined $setting::page{'searchbox'} && $setting::page{'searchbox'};
    @form = grep( $_ ne 'w' && $_ ne 's', @form )
        if defined $setting::page{'sortmenu'} && $setting::page{'sortmenu'};

    print $this->form_start(
        'key'      => $setting::security_key,
        'name'     => 'tm-toolbox-' . $suffix,
        'id'       => 'tm-toolbox-' . $suffix,
        'class'    => 'panel',
        'required' => \@form
    );
    if (@main::c) {
        print '<input type="hidden" name="rc" value="'
            . $this->escape( join( ',', @main::c ) ) . '" />';
    }
    elsif ($main::c) {
        print '<input type="hidden" name="rc" value="'
            . $this->escape($main::c) . '" />';
    }
    if ($gmap_view_enabled) {
        print '<input type="hidden" name="gz" id="gz-'
            . $suffix
            . '" value="'
            . $this->escape($main::gz) . '" />';
        print '<input type="hidden" name="gt" id="gt-'
            . $suffix
            . '" value="'
            . $this->escape($main::gt) . '" />';
        print '<input type="hidden" name="gc" id="gc-'
            . $suffix
            . '" value="'
            . $this->escape($main::gc) . '" />';
    }
    print '<ul class="tools">';

    if ( defined $setting::page{'categoryselector'}
        && $setting::page{'categoryselector'} )
    {
        my @categories = sort {
            $setting::category{$a}{'ORDER'}
                <=> $setting::category{$b}{'ORDER'}
                || $a <=> $b
        } grep( defined $_ && $_ !~ /[^0-9]/, keys %setting::category );
        if ( @categories > 1 ) {
            push( @main::c, $main::c )
                if !@main::c && defined $main::c && $main::c;
            push(
                @main::c,
                (   ( ref $setting::category{'DEFAULT'} )
                    ? @{ $setting::category{'DEFAULT'} }
                    : $setting::category{'DEFAULT'}
                )
            ) if !@main::c && defined $setting::category{'DEFAULT'};
            my $size     = 0;
            my $selector = $this->mk_category_selector( \%setting::category,
                \@categories, \@main::c, \$size );
            print '<li><select name="c"';
            if ( defined $setting::category{'MULTIPLE'}
                && $setting::category{'MULTIPLE'} )
            {
                $size = 5 if $size > 5;
                $size = 1 if $size < 1;
                print ' size="' . $size . '" multiple="multiple"';
            }
            else {
                print ' onchange="this.name=\'m='
                    . $main::m
                    . ( ( $this->{'has_favorites'} ) ? '&amp;fv=1' : '' )
                    . '&amp;c=\'+this.value;';
                if ( $setting::page{'searchbox'} ) {
                    print
                        'var q=self.cmonos.element.form(this.form).fieldname(\'q\').shift();if(self.cmonos.element.item(q).hasClassName(\'placeholder\')){q.value=\'\';}';
                }
                print 'submit();"';
            }
            print '>';
            print $selector;
            print '</select></li>';
        }
    }
    if ( defined $setting::page{'searchbox'} && $setting::page{'searchbox'} )
    {
        print '<li><input type="search" placeholder="'
            . ( ( $this->{'is_searched_full'} )
            ? ($default::english)
                    ? 'Further Search'
                    : '絞り込み検索'
            : ($default::english) ? 'Search'
            :                       '検索' )
            . '" results="5" autosave="'
            . ( ($default::id) ? $default::id : 'tablemaker' )
            . '" name="q" size="16" value="'
            . $this->escape($main::q)
            . '" title="'
            . ( ( $this->{'is_searched_full'} )
            ? ($default::english)
                    ? 'Search'
                    : '検索キーワードでさらに絞り込みます。'
            : ($default::english) ? 'Search'
            :                       '検索キーワード' )
            . '" onkeypress="if((event.keyCode || event.charCode)==13){this.name=\'m='
            . $main::m
            . ( ( $this->{'has_favorites'} ) ? '&amp;fv=1' : '' )
            . '&amp;q=%03\';submit();return false}" /></li>';
    }
    if ( defined $setting::page{'sortmenu'} && $setting::page{'sortmenu'} ) {
        print '<li><select name="s" title="'
            . ( ($default::english)
            ? 'Sort field'
            : 'ソート(並べ替え)項目' )
            . '">';
        $main::s
            = ( $field::for{'sort'} ) ? $field::for{'sort'}
            : ( $field::for{'key'} )   ? $field::for{'key'}
            : ( $field::for{'title'} ) ? $field::for{'title'}
            : ''
            if !defined $main::s || $main::s eq '';
        foreach ( sort { $a <=> $b } keys %field::ORDER ) {
            my $id = $field::ORDER{$_};
            next
                unless ref $field::obj{$id}
                && !$field::obj{$id}->{'Hidden'}
                && ( $field::obj{$id}->{'Open'}
                || $this->is_secure('secret') )
                && $field::obj{$id}->sort_enabled
                && $field::obj{$id}->{'sortEnabled'};
            print '<option value="'
                . $id . '"'
                . ( ( $main::s eq $id ) ? ' selected="selected"' : '' ) . '>'
                . $this->jfold( $field::obj{$id}->name, 32, 'I', 1 )
                . '</option>';
        }
        print '</select></li>';
        $main::w = $field::SORTORDER
            if ( !defined $main::w || $main::w eq '' ) && $field::SORTORDER;
        $main::w = 'ascend' if !defined $main::w || $main::w eq '';
        print '<li><select name="w" title="'
            . (
            ($default::english) ? 'Sort' : 'ソート(並べ替え)方法' )
            . '">';
        print '<option value="ascend"'
            . ( ( defined $main::w && $main::w eq 'ascend' )
            ? ' selected="selected"'
            : '' )
            . '>'
            . ( ($default::english) ? 'Ascending' : '昇順' )
            . '</option>';
        print '<option value="descend"'
            . ( ( defined $main::w && $main::w eq 'descend' )
            ? ' selected="selected"'
            : '' )
            . '>'
            . ( ($default::english) ? 'Descending' : '降順' )
            . '</option>';
        print '</select></li>';
    }

    # 表示
    print $this->tm_tool_button(
        'tableview',
        ( ($default::english) ? 'Table' : 'テーブル表示' ),
        '',
        {   'm' => 'TableViewer',
            ( ( $this->{'has_favorites'} ) ? ( 'fv' => 1 ) : () )
        },
        '', '', '',
        ( ( $main::m && $main::m eq 'TableViewer' ) ? 1 : 0 )
    );
    if ($gmap_view_enabled) {
        print $this->tm_tool_button(
            'gmapview',
            ( ($default::english) ? 'GoogleMaps' : 'Googleマップ表示' ),
            '',
            {   'm' => 'GMapViewer',
                ( ( $this->{'has_favorites'} ) ? ( 'fv' => 1 ) : () )
            },
            '', '', '',
            ( ( $main::m && $main::m eq 'GMapViewer' ) ? 1 : 0 )
        );
    }
    print $this->tm_tool_button(
        'tileview',
        ( ($default::english) ? 'Tile' : 'タイル表示' ),
        '',
        {   'm' => 'TileViewer',
            ( ( $this->{'has_favorites'} ) ? ( 'fv' => 1 ) : () )
        },
        '', '', '',
        ( ( $main::m && $main::m eq 'TileViewer' ) ? 1 : 0 )
    );

    # お気に入りを表示
    if ( $this->favorites_enabled ) {
        print $this->tm_tool_button(
            'tmfavorites',
            (   ( $this->{'has_favorites'} )
                ? ( ($default::english)
                    ? 'Back.'
                    : '通常の表示に戻す' )
                : ( ($default::english)
                    ? 'Show ' . $this->{'favorites_field_name'} . '.'
                    : $this->{'favorites_field_name'} . ' を表示する' )
            ),
            '',
            {   'm' => $main::m,
                ( ( $this->{'has_favorites'} ) ? () : ( 'fv' => 1 ) )
            },
            'group-start',
            '', '',
            ( ( $this->{'has_favorites'} ) ? 2 : 0 ),
            'show-favorites-' . $suffix
        );
    }

    # メール配信フォームへの接続
    if (   $this->{'mcount'}
        && $this->is_secure('mail')
        && $this->email_field_enabled )
    {
        print $this->tm_tool_button(
            'tmmailer',
            (   ($default::english)
                ? 'Send mail by this list.'
                : 'メール配信フォームを開く'
            ),
            '',
            {   'm' => 'Mailer',
                ( ( $this->{'has_favorites'} ) ? ( 'fv' => 1 ) : () )
            },
            'group-start',
        );
    }

    # リフレッシュ
    if ( $this->{'is_searched'} ) {
        print $this->tm_tool_button(
            'tmreset',
            (   ($default::english)
                ? 'Refresh.'
                : '検索条件をリセット'
            ),
            $cgi::path
                . $this->set_query(
                'url',
                [   grep( $_ ne 'q'
                            && $_ ne 'search'
                            && $_ ne 'and'
                            && $_ ne 'order_item',
                        @setting::form )
                ]
                ),
            '',
            'group-start'
        );
    }

    # 検索ページ
    if ( !$setting::page{'searchIconDisabled'} ) {
        print $this->tm_tool_button(
            'tmsearch', ( ($default::english) ? 'Search.' : '検索' ),
            '', { 'm' => 'Index' },
            'group-start',
        );
    }

    # データ修正フォームへの接続
    if ( $this->email_field_enabled && $this->is_secure('revise') ) {
        $setting::page{'reviseButton'}
            = ($default::english) ? 'Revise Data' : 'データ修正'
            if !defined $setting::page{'reviseButton'}
            || $setting::page{'reviseButton'} eq '';
        print $this->tm_tool_button(
            'tmlist', $setting::page{'reviseButton'},
            '', { 'm' => 'Gate' },
            'group-start',
        );
    }
    if ( $this->is_secure('input') ) {
        $setting::page{'newDataButton'}
            = ($default::english) ? 'New Data' : '新規データ入力'
            if !defined $setting::page{'newDataButton'}
            || $setting::page{'newDataButton'} eq '';
        print $this->tm_tool_button(
            'tminput',
            $setting::page{'newDataButton'},
            $cgi::path
                . '?_=%EF%BC%BF&m=Input'
                . $this->set_query(
                'url',
                [   grep( $_ ne 'm' && $_ ne 'k' && $_ ne 'fv',
                        @setting::form )
                ],
                1
                ),
            '',
            'group-start',
            (     ( $setting::page{'sameWindowNewDataButton'} )
                ? ()
                : ( 'cmonos.window.open(\'detailViewer\','
                        . ( $setting::page{'inputWindowWidth'} || '640' )
                        . ','
                        . ( $setting::page{'inputWindowHeight'} || '480' )
                        . ')',
                    'detailViewer',
                )
            )
        );
    }

    if ( $this->is_secure('tools') ) {
        print $this->tm_tool_button(
            'tmtool',
            (   ($default::english)
                ? 'Control Panel.'
                : '環境設定を開く'
            ),
            $cgi::path . '?m=Tools',
            '',
            'group-start'
        );
    }

    # パスワード操作
    if ( $setting::page{'pswdIcon'} ) {
        print $this->tm_tool_button(
            'tmlogin',
            ( ($default::english) ? 'Log in.' : 'ログイン' ),
            $env::register_cgi . '?k=pswd&amp;m=Password',
            '',
            'group-start',
            (     ($env::register_in_same_window)
                ? ()
                : ( "cmonos.window.open('LoginWindow',450,300)",
                    'LoginWindow',
                )
            ),
        );
    }

    print '</ul>';
    print '</form>';
}

sub print_mini_toolbox ($$;$) {
    my ( $this, $suffix, $another_gate ) = @_;
    return
        if ( !$this->email_field_enabled
        || ( !$another_gate && !$this->is_secure('revise') ) )
        && !$this->is_secure('input')
        && !$this->is_secure('tools')
        && !$setting::page{'pswdIcon'};

    print $this->form_start(
        'key'      => $setting::security_key,
        'name'     => 'tm-toolbox-' . $suffix,
        'id'       => 'tm-toolbox-' . $suffix,
        'required' => ['mod']
    );
    print '<ul class="tools panel">';

    if ($main::order_item) {
        print $this->tm_tool_button(
            'tmreset',
            (   ($default::english)
                ? 'Refresh.'
                : '検索条件をリセット'
            ),
            $cgi::path
                . $this->set_query(
                'url',
                [   grep( $_ ne 'q'
                            && $_ ne 'search'
                            && $_ ne 'and'
                            && $_ ne 'order_item',
                        @setting::form )
                ]
                ),
        );
    }

    # 修正
    if ( $this->email_field_enabled
        && ( $another_gate || $this->is_secure('revise') ) )
    {
        $setting::page{'reviseButton'}
            = ($default::english) ? 'Revise Data' : 'データ修正'
            if !defined $setting::page{'reviseButton'}
            || $setting::page{'reviseButton'} eq '';
        print $this->tm_tool_button(
            'tmlist',
            (     ($another_gate)
                ? ($default::english)
                        ? 'Another e-mail address'
                        : '別のアドレスで検索する'
                : $setting::page{'reviseButton'}
                ),
                '',
                {
                'm' => 'Gate',
                ( ($another_gate) ? ( 'id_disabled' => '1' ) : () )
                },
                'group-start'
        );
    }

    # 新規データ入力
    if ( $this->is_secure('input') ) {
        $setting::page{'newDataButton'}
            = ($default::english) ? 'New Data' : '新規データ入力'
            if !defined $setting::page{'newDataButton'}
            || $setting::page{'newDataButton'} eq '';
        print $this->tm_tool_button(
            'tminput',
            $setting::page{'newDataButton'},
            '',
            { 'm' => 'Input' },
            'group-start',
            (     ( $setting::page{'sameWindowNewDataButton'} )
                ? ()
                : ( 'cmonos.window.open(\'detailViewer\','
                        . ( $setting::page{'inputWindowWidth'} || '640' )
                        . ','
                        . ( $setting::page{'inputWindowHeight'} || '480' )
                        . ')',
                    'detailViewer',
                )
            )
        );
    }

    # 環境設定を開く
    if ( $this->is_secure('tools') ) {
        print $this->tm_tool_button(
            'tmtool',
            (   ($default::english)
                ? 'Control Panel.'
                : '環境設定を開く'
            ),
            $cgi::path . '?m=Tools',
            '',
            'group-start'
        );
    }

    # パスワード操作
    if ( defined $setting::page{'pswdIcon'} && $setting::page{'pswdIcon'} ) {
        print $this->tm_tool_button(
            'tmlogin',
            ( ($default::english) ? 'Log in.' : 'ログイン' ),
            $env::register_cgi . '?k=pswd&amp;m=Password',
            '',
            'group-start',
            (     ($env::register_in_same_window)
                ? ()
                : ( "cmonos.window.open('LoginWindow',450,300)",
                    'LoginWindow',
                )
            ),
        );
    }

    print '</ul>';
    print '</form>';
}

sub print_toolbox_top ($) {
    my $this = shift;
    $setting::page{$setting::key}{'toolboxTop'} = 1
        if !defined $setting::page{$setting::key}{'toolboxTop'}
        && !defined $setting::page{$setting::key}{'toolboxBottom'};
    $this->print_toolbox('top')
        if defined $setting::page{$setting::key}{'toolboxTop'}
        && $setting::page{$setting::key}{'toolboxTop'};
}

sub print_toolbox_bottom ($) {
    my $this = shift;
    $this->print_toolbox('bottom')
        if defined $setting::page{$setting::key}{'toolboxBottom'}
        && $setting::page{$setting::key}{'toolboxBottom'};
}

######################################################################
sub email_field_enabled ($) {
    my $this = shift;
    return ( ref $field::for{'mail_address'}
            && @{ $field::for{'mail_address'} } ) ? 1 : 0;
}

######################################################################
sub get_rev_buttons ($$$$$;$) {
    my ( $this, $c, $n, $edit_button, $delete_button, $setting_key ) = @_;
    my $delete_disabled = (
        !$this->is_secure( 'delete', 0, 'revise' )
            || ( $default::type
            && $default::type eq 'order'
            && !$this->is_secure('tools') )
    ) ? 1 : 0;
    my $is_detail
        = ( $setting_key && $setting_key =~ /^detail[0-9]*$/ ) ? 1 : 0;
    if ( !ref $this->{'icon_obj'} ) {
        require CMONOS::CGI_Lib::Deco;
        $this->{'icon_obj'} = Deco->new(
            $env::image_dir . '/tablemaker',
            $env::image_lib . '/tablemaker'
        );
    }
    my $button = $this->form_start(
        'key' => 'editor',
        (     ( $setting::page{'sameWindowNewDataButton'} )
            ? ()
            : ( 'target' => 'detailViewer' )
        ),
        'method' => 'post',
        'id'     => 'record-editor'
            . ( ($is_detail) ? '' : '-n' . $c . '-' . $n ),
        'required' => [
            grep( $_ ne 'm'
                    && $_ ne 'k'
                    && $_ ne 'c'
                    && $_ ne 'ct'
                    && $_ ne 'n',
                @setting::form )
        ]
    );
    $button .= '<input type="hidden" name="m" value="Input" />';
    $button .= '<input type="hidden" name="k" value="input" />';
    $button .= '<input type="hidden" name="c" value="' . $c . '" />';
    if (@main::ct) {
        foreach my $ct (@main::ct) {
            $button
                .= '<input type="hidden" name="ct" value="' . $ct . '" />';
        }
    }
    elsif (@main::c) {
        foreach my $ct (@main::c) {
            $button
                .= '<input type="hidden" name="ct" value="' . $ct . '" />';
        }
    }
    $button .= '<input type="hidden" name="n" value="' . $n . '" />';
    if (   !$env::session_enabled
        && defined $main::pswd
        && !ref $main::pswd
        && $main::pswd ne ''
        && !$cookie::read{ $this->login_cookie_name } )
    {
        $button
            .= '<input type="hidden" name="email" value="'
            . $this->escape($main::email) . '" />'
            if defined $main::email && $main::email;
        $button
            .= '<input type="hidden" name="pswd" value="'
            . $this->escape($main::pswd) . '" />'
            if defined $main::pswd && $main::pswd;
    }
    if ( !$delete_disabled ) {
        $button .= '<ul class="tools">';
        $button .= '<li>';
    }
    $button .= $this->{'icon_obj'}->submit_button(
        $edit_button,
        (   ($setting_key) ? $setting::page{$setting_key}{$edit_button}
            : $setting::page{$edit_button}
        ),
        ( ($default::english) ? 'Edit.' : '修正' ),
        (   ( $setting::page{'sameWindowNewDataButton'} ) ? ()
            : { 'onclick' =>
                    'return window.opener || cmonos.window.open(\'detailViewer\','
                    . ( $setting::page{'inputWindowWidth'}  || '640' ) . ','
                    . ( $setting::page{'inputWindowHeight'} || '480' ) . ')'
            }
        )
    );
    if ( !$delete_disabled ) {
        $button .= '</li>';
        $button .= '<li>';
        $button .= $this->{'icon_obj'}->submit_button(
            $delete_button,
            (   ($setting_key)
                ? $setting::page{$setting_key}{$delete_button}
                : $setting::page{$delete_button}
            ),
            ( ($default::english) ? 'Delete.' : '削除' ),
            (   ($is_detail)
                ? { 'onclick' =>
                        'return confirm(\'この操作は取り消せません。本当に削除しますか？\')'
                        . (
                        ( $setting::page{'sameWindowNewDataButton'} )
                        ? ''
                        : ' && (window.opener || cmonos.window.open(\'detailViewer\','
                            . ( $setting::page{'inputWindowWidth'} || '640' )
                            . ','
                            . ( $setting::page{'inputWindowHeight'} || '480' )
                            . '))'
                        )
                    }
                : { 'onclick' =>
                        'return confirm(\'この操作は取り消せません。本当に削除しますか？\') && cmonos.form.item(this.form).field(this).deleteRecord(\''
                        . $c . '\',\''
                        . $n . '\')'
                }
            ),
            { 'delete' => '1' }
        );
        $button .= '</li>';
        $button .= '</ul>';
    }
    $button .= '</form>';
    return $button;
}

######################################################################
sub category_selector ($$$$;$$$) {
    my ( $this, $tableheader, $header, $footer, $multiple, $checkbox,
        $static )
        = @_;
    my $selector = '';

    #カテゴリー設定読み込み
    $this->import_db( $default::preference_dir . '/category',
        \%setting::category, 1 )
        if !%setting::category;
    $multiple = 1 if $setting::category{'MULTIPLE'};

    my @categories = sort {
        $setting::category{$a}{'ORDER'} <=> $setting::category{$b}{'ORDER'}
            || $a <=> $b
    } grep( defined $_ && $_ !~ /[^0-9]/, keys %setting::category );
    if ( @categories && @categories > 1 ) {
        push( @main::c, $main::c )
            if !@main::c && defined $main::c && $main::c;
        push(
            @main::c,
            (   ( ref $setting::category{'DEFAULT'} )
                ? @{ $setting::category{'DEFAULT'} }
                : $setting::category{'DEFAULT'}
            )
        ) if !@main::c && defined $setting::category{'DEFAULT'};
        my $size = 0;
        my $options
            = $this->mk_category_selector( \%setting::category, \@categories,
            \@main::c, \$size, $multiple, $checkbox, $static );
        $selector .= $tableheader if $tableheader;
        $selector .= $header      if $header;
        $selector
            .= ($checkbox)
            ? '<ol class="checkbox">'
            : '<select name="c" id="c"'
            . ( ($multiple)
            ? ' size="' . ( ($size) ? $size : '1' ) . '" multiple="multiple"'
            : '' )
            . '>';
        $selector .= $options;
        $selector .= ($checkbox) ? '</ol>' : '</select>';
        $selector .= $footer if $footer;
    }
    elsif (@categories) {
        $selector .= '<input type="hidden" name="c" value="'
            . $categories[0] . '" />';
        $selector .= $tableheader if $tableheader;
    }
    else {
        $selector .= '<input type="hidden" name="c" value="1" />';
        $selector .= $tableheader if $tableheader;
    }
    return $selector;
}

sub mk_category_selector ($$$;$$$$$$$$) {
    my ($this,     $category, $list, $selected, $size, $multiple,
        $checkbox, $static,   $key,  $indent,   $done
    ) = @_;
    return '' if !ref $list;
    $key    = '' if !defined $key;
    $indent = '' if !defined $indent;
    my ( $sub_key, @sub_list, $selector, $c );
    $done = {} if !ref $done;
    $sub_key = $selector = '';
    foreach $c (@$list) {
        next if !defined $c;
        $sub_key = $1
            if $sub_key eq ''
            && $category->{$c}->{'name'}
            && $category->{$c}->{'name'} =~ m!^($key[^/]+/?)!;
        if (   $sub_key ne ''
            && $sub_key ne $key
            && $category->{$c}->{'name'} =~ /^$sub_key/
            && ( $sub_key =~ m!/$! || $category->{$c}->{'name'} eq $sub_key )
            )
        {
            push( @sub_list, $c );
        }
        else {
            if ( $sub_key ne '' && $sub_key ne $key ) {
                my $my_indent = $indent;
                my $indent2   = '';
                if ( $key ne '' ) {
                    $my_indent .= '├';
                    $indent2 = '│';
                }
                $selector .= $this->_mk_category_selector(
                    $category,  \@sub_list, $selected, $size,
                    $multiple,  $checkbox,  $static,   $sub_key,
                    $my_indent, $done
                );
                $selector .= $this->mk_category_selector(
                    $category, \@sub_list, $selected,
                    $size,     $multiple,  $checkbox,
                    $static,   $sub_key,   $indent . $indent2,
                    $done
                ) if @sub_list && $key ne $sub_key;
            }
            $sub_key = $1
                if $category->{$c}->{'name'}
                && $category->{$c}->{'name'} =~ m!^($key[^/]+/?)!;
            undef @sub_list;
            push( @sub_list, $c );
        }
    }
    if ( $sub_key ne '' && $sub_key ne $key ) {
        my $my_indent = $indent;
        my $indent2   = '';
        if ( $key ne '' ) {
            $my_indent .= '└';
            $indent2 = '　';
        }
        $selector .= $this->_mk_category_selector(
            $category, \@sub_list, $selected, $size,      $multiple,
            $checkbox, $static,    $sub_key,  $my_indent, $done
        );
        $selector .= $this->mk_category_selector(
            $category,          \@sub_list, $selected, $size,
            $multiple,          $checkbox,  $static,   $sub_key,
            $indent . $indent2, $done
        ) if @sub_list && $key ne $sub_key;
    }
    return $selector;
}

sub _mk_category_selector ($$$$$$$$$$$) {
    my ($this,     $category, $sub_list, $selected,  $size, $multiple,
        $checkbox, $static,   $sub_key,  $my_indent, $done
    ) = @_;
    my $record_count = 0;
    my $record_total = 0;
    foreach my $c (@$sub_list) {
        if ( ref $category->{$c} ) {
            $record_count += $category->{$c}->{'count'}
                if ref $category->{$c} && $category->{$c}->{'count'};
            $record_total += $category->{$c}->{'total'}
                if !$static
                && $this->is_secure('pending')
                && ref $category->{$c}
                && $category->{$c}->{'total'};
        }
    }
    no warnings qw(numeric);
    my $value = join( ',', sort { $a <=> $b || $a cmp $b } @$sub_list );
    my $is_selected
        = ( !$done->{$value}++ && grep( $_ eq $value, @$selected ) ) ? 1 : 0;
    my $selector = '';
    $selector
        .= ($checkbox)
        ? '<li>'
        : '<option value="'
        . $value . '"'
        . ( ($is_selected) ? ' selected="selected"' : '' ) . '>';
    $selector .= $my_indent;
    $selector
        .= '<label><input type="'
        . ( ($multiple) ? 'checkbox' : 'radio' )
        . '" name="c" value="'
        . $value . '"'
        . ( ($is_selected) ? ' checked="checked"' : '' ) . ' />'
        if $checkbox;
    $selector .= $1 if $sub_key =~ m!([^/]+)/?$!;
    $selector
        .= ' ('
        . $record_count
        . ( ( !$static && $this->is_secure('pending') )
        ? '/' . $record_total
        : '' )
        . ')';
    $selector .= ($checkbox) ? '</label></li>' : '</option>';
    $$size++ if ref $size;
    return $selector;
}

#ヘッダ・フッタ埋め込みツール変換
sub _page_item_replace ($$;$$$$) {
    my ( $this, $str, $file_flag, $output ) = @_;
    if ( $$str
        =~ /<\!--categorylist(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/categorylist(?![0-9a-zA-Z_])[^>]*-->/is
        )
    {
        $this->import_db( $default::preference_dir . '/category',
            \%setting::category, 1 )
            if !%setting::category;
        my @categories = sort {
            $setting::category{$a}{'ORDER'}
                <=> $setting::category{$b}{'ORDER'}
                || $a <=> $b
        } grep( defined $_ && $_ !~ /[^0-9]/, keys %setting::category );
        my $categorylist = '';
        if ( @categories > 1 ) {
            my @cat = (@main::c) ? @main::c : ();
            push( @cat, $main::c ) if !@cat && defined $main::c && $main::c;
            push(
                @cat,
                (   ( ref $setting::category{'DEFAULT'} )
                    ? @{ $setting::category{'DEFAULT'} }
                    : $setting::category{'DEFAULT'}
                )
            ) if !@cat && defined $setting::category{'DEFAULT'};
            my @required
                = grep( $_ ne 'm'
                    && $_ ne 'k'
                    && $_ ne 'c'
                    && $_ ne 'n'
                    && $_ ne 'mod'
                    && $_ ne 'ct'
                    && $_ ne 'dn'
                    && $_ ne 'mf'
                    && $_ ne 'type'
                    && $_ ne 'ss'
                    && $_ ne 'sw',
                @setting::form );
            my $query = $this->set_query( 'url', \@required, 1 );
            $categorylist
                = $this->mk_category_list( $query, \%setting::category,
                \@categories, \@cat, '', {}, 'tm-categories', '',
                ( ($output) ? 1 : 0 ) );
        }
        $$str
            =~ s/<\!--(categorylist)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/categorylist(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace($1,$2,$3,$categorylist,$file_flag)/iges;
    }
    if ( $$str
        =~ /<\!--search(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/search(?![0-9a-zA-Z_])[^>]*-->/is
        )
    {
        my $search = $this->aside_search_form( ($output) ? 1 : 0 );
        $$str
            =~ s/<\!--(search)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/search(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace($1,$2,$3,$search,$file_flag)/iges;
    }
    $$str
        =~ s/<\!--(results)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/results(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace($1,$2,$3,$this->{'mcount'},$file_flag)/iges;
}

sub aside_search_form ($;$) {
    my ( $this, $static ) = @_;
    my $search = $this->form_start(
        'name'  => 'tmsearch',
        'class' => 'tm-aside-search',
        (     ($static)
            ? ( 'required' => [], )
            : ( 'key'      => $setting::key,
                'required' => [ 's', 'w', 'f', 'u', 'fv', 'q', 'mod', 'uni' ],
                'onsubmit' =>
                    'if (window.opener) { if (!window.opener.name) window.opener.name = \'window\'+(new Date()).getTime(); this.target = window.opener.name; } return true;'
            )
        )
    );
    $search
        .= '<input type="hidden" name="order_item" value="'
        . $this->escape($main::order_item) . '" />'
        if !$static
        && $default::type
        && $default::type eq 'order'
        && $main::order_item;
    $search .= '<input type="hidden" name="m" value="'
        . $this->escape(
          ($static)
        ? ( $setting::page{'defaultView'} )
                ? $setting::page{'defaultView'}
                : 'TableViewer'
        : ( $main::m
                && ( $main::m eq 'TableViewer'
                || $main::m eq 'TileViewer'
                || $main::m eq 'GMapViewer' )
            )
        ? $main::m
        : ( $main::mod
                && ( $main::mod eq 'TableViewer'
                || $main::mod eq 'TileViewer'
                || $main::mod eq 'GMapViewer' )
            ) ? $main::mod
        : ( $setting::page{'defaultView'} ) ? $setting::page{'defaultView'}
        :                                     'TableViewer'
        ) . '" />';
    my ( $search_form, $count );
    foreach my $n ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$n} }
            && !$field::obj{ $field::ORDER{$n} }->{'Hidden'}
            && ( $field::obj{ $field::ORDER{$n} }->{'Open'}
            || $this->is_secure('secret') )
            && $field::obj{ $field::ORDER{$n} }->{'searchEnabled'}
            && $field::obj{ $field::ORDER{$n} }->search_form_enabled;
        $search_form .= $field::obj{ $field::ORDER{$n} }->search_form;
        $count++;
    }
    $search .= $this->category_selector(
        '<table class="field-table"><tbody>',
        '<tr><td class="field-name"><label for="c">カテゴリー</label></td><td class="field">',
        '</td></tr>',
        0,
        $setting::page{'checkboxForCatList'},
        $static
    );
    $search .= $search_form;
    $search .= '</tbody>';
    $search .= '<tbody>';
    $search .= '<tr class="tbody-start">';
    $search
        .= '<td class="reset-box"><input type="button" value="'
        . ( ($default::english) ? 'Reset' : 'リセット' )
        . '" onclick="cmonos.form.item(this.form).resetAll(\'search:\')" /></td>';
    $search .= '<td class="submit-box">';
    $search
        .= '<input type="search" placeholder="'
        . ( ( $this->{'is_searched_full'} )
        ? ($default::english)
                ? 'Further Search'
                : '絞り込み検索'
        : ($default::english) ? 'Search'
        :                       '検索' )
        . '" results="5" autosave="'
        . ( ($default::id) ? $default::id : 'tablemaker' )
        . '" name="q" size="16" value="'
        . $this->escape($main::q)
        . '" title="'
        . ( ( $this->{'is_searched_full'} )
        ? ($default::english)
                ? 'Search'
                : '検索キーワードでさらに絞り込みます。'
        : ($default::english) ? 'Search'
        :                       '検索キーワード' )
        . '" /> '
        if defined $main::q && $main::q ne '';

    if ( $count > 1 ) {
        if (   $setting::page{'defaultSearchOparator'}
            && $setting::page{'defaultSearchOparatorFixed'} )
        {
            $search
                .= '<input type="hidden" name="and" value="'
                . ( ( $setting::page{'defaultSearchOparator'} eq 'OR' )
                ? '0'
                : '1' )
                . '" />';
        }
        else {
            $search .= '<select name="and">';
            $search
                .= '<option value="1">'
                . ( ($default::english)
                ? 'Matches on all requirements'
                : '全ての条件に一致' )
                . '</option>';
            $search .= '<option value="0"'
                . (
                (   (          !defined $main::and
                            && $setting::page{'defaultSearchOparator'}
                            && $setting::page{'defaultSearchOparator'} eq 'OR'
                    )
                        || (
                        (   defined $main::and
                            || !$setting::page{'defaultSearchOparator'}
                        )
                        && !$main::and
                        )
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . ( ($default::english)
                ? 'Matches on any requirements'
                : 'いずれかの条件に一致' )
                . '</option>';
            $search .= '</select>';
        }
    }
    $search .= '<input type="submit" value="'
        . ( ($default::english) ? 'Search' : '検索' ) . '" />';
    $search .= '</td></tr></tbody></table></form>';
    return $search;
}

sub mk_category_list ($$$$;$$$$$$) {
    my ($this,     $query, $category, $category_list,
        $selected, $key,   $done,     $class,
        $m,        $static
    ) = @_;
    $key = '' if !defined $key;
    my ( $sub_key, @sub_list, $list, $c );
    $done = {} if !ref $done;
    $sub_key = $list = '';
    foreach $c (@$category_list) {
        next if !defined $c;
        $sub_key = $1
            if $sub_key eq ''
            && $category->{$c}->{'name'}
            && $category->{$c}->{'name'} =~ m!^($key[^/]+/?)!;
        if (   $sub_key ne ''
            && $sub_key ne $key
            && $category->{$c}->{'name'} =~ /^$sub_key/
            && ( $sub_key =~ m!/$! || $category->{$c}->{'name'} eq $sub_key )
            )
        {
            push( @sub_list, $c );
        }
        else {
            if ( $sub_key ne '' && $sub_key ne $key ) {
                $list .= '<li>'
                    . $this->_mk_category_list( $query, $category,
                    \@sub_list, $selected, $sub_key, $done, $m, $static );
                $list .= $this->mk_category_list(
                    $query,    $category, \@sub_list,
                    $selected, $sub_key,  $done,
                    '',        $m,        $static
                ) if @sub_list && $key ne $sub_key;
                $list .= '</li>';
            }
            $sub_key = $1
                if $category->{$c}->{'name'}
                && $category->{$c}->{'name'} =~ m!^($key[^/]+/?)!;
            undef @sub_list;
            push( @sub_list, $c );
        }
    }
    if ( $sub_key ne '' && $sub_key ne $key ) {
        $list .= '<li>'
            . $this->_mk_category_list( $query, $category, \@sub_list,
            $selected, $sub_key, $done, $m, $static );
        $list .= $this->mk_category_list(
            $query, $category, \@sub_list, $selected, $sub_key,
            $done,  '',        $m,         $static
        ) if @sub_list && $key ne $sub_key;
        $list .= '</li>';
    }
    return ($list)
        ? '<ul'
        . ( ($class) ? ' class="' . $class . '"' : '' ) . '>'
        . $list . '</ul>'
        : '';
}

sub _mk_category_list ($$$$$$$;$$) {
    my ($this,    $query, $category, $sub_list, $selected,
        $sub_key, $done,  $m,        $static
    ) = @_;
    my $record_count = 0;
    my $record_total = 0;
    foreach my $c (@$sub_list) {
        $record_count += $category->{$c}->{'count'}
            if ref $category->{$c} && $category->{$c}->{'count'};
        $record_total += $category->{$c}->{'total'}
            if ref $category->{$c} && $category->{$c}->{'total'};
    }
    no warnings qw(numeric);
    my $value = join( ',', sort { $a <=> $b || $a cmp $b } @$sub_list );
    my $is_here
        = (    !$done->{$value}++
            && ref $selected
            && @$selected
            && grep( $_ eq $value, @$selected ) ) ? 1 : 0;
    my $info = '';
    if ( defined $category->{'INFOFORMAT'}
        && $category->{'INFOFORMAT'} ne '' )
    {
        $info = $category->{'INFOFORMAT'};
        $info =~ s/\%p/$record_count/sgi;
        $info =~ s/\%t/$record_total/sgi;
        my $secret_count = $record_total - $record_count;
        $info =~ s/\%s/$secret_count/sgi;
    }
    else {
        $info
            = ' <span>('
            . $record_count
            . ( ( !$static && $this->is_secure('pending') )
            ? '/' . $record_total
            : '' )
            . ')</span>';
    }
    return
          ( ($is_here) ? '<strong>' : '' )
        . '<a href="'
        . $cgi::path . '?m='
        . (
        ($m) ? $m
        : ( $main::m
                && ( $main::m eq 'TableViewer'
                || $main::m eq 'TileViewer'
                || $main::m eq 'GMapViewer' )
            ) ? $main::m
        : ( $main::mod
                && ( $main::mod eq 'TableViewer'
                || $main::mod eq 'TileViewer'
                || $main::mod eq 'GMapViewer' )
            ) ? $main::mod
        : ( $setting::page{'defaultView'} ) ? $setting::page{'defaultView'}
        :                                     'TileViewer'
        )
        . '&amp;c='
        . $value
        . $this->escape($query) . '"'
        . ( ( $this->has_opener )
        ? ' onclick="cmonos.window.openerLocation(this.href);return false;"'
        : '' )
        . '>'
        . ( ( $sub_key =~ m!([^/]+)/?$! ) ? $1 : '' ) . '</a>'
        . ( ($is_here) ? '</strong>' : '' )
        . $info;
}

sub has_opener ($) {
    my $this = shift;
    return 0;
}

sub write_category_list ($) {
    my $this = shift;
    return 1 if $default::type && $default::type eq 'order';
    $this->import_db( $default::preference_dir . '/page',
        \%setting::page, 1, $setting::key )
        if !%setting::page || !$setting::page{'defaultView'};
    $this->import_db( $default::preference_dir . '/category',
        \%setting::category, 1 )
        if !%setting::category;
    my @categories = sort {
        $setting::category{$a}{'ORDER'} <=> $setting::category{$b}{'ORDER'}
            || $a <=> $b
    } grep( defined $_ && $_ !~ /[^0-9]/, keys %setting::category );
    $this->write_file(
        $default::file . '/category_list.ssi',
        $this->mk_category_list(
            '', \%setting::category, \@categories, [], '', {},
            'tm-categories',
            ( $setting::page{'defaultView'} || 'TileViewer' ), 1
        ),
        1
    );
    $this->mk_external_javascript( $default::file . '/category_list.ssi' );
    return 1;
}

sub gc_download_directory ($) {
    my $this   = shift;
    my $gc_dat = $default::file . '/download/gc.dat';
    return 1 if -f $gc_dat && ( -M $gc_dat ) < 3;
    local (*DIR);
    if ( opendir( DIR, $default::file . '/download' ) ) {
        my @expired = ();
        while ( my $key = readdir(DIR) ) {
            if ( $key !~ /^\./ && -d $default::file . '/download/' . $key ) {
                my $dat
                    = $default::file . '/download/' . $key . '/checkout.dat';
                if ((   !-s $dat && ( -M $dat ) > (
                            ( $setting::general{'dcPendingTimeout'} )
                            ? $setting::general{'dcPendingTimeout'}
                            : 30
                        )
                    )
                    || (-s $dat
                        && ( -M $dat ) > (
                            ( $setting::general{'dcLifetime'} )
                            ? $setting::general{'dcLifetime'}
                            : 30
                        )
                    )
                    )
                {
                    push( @expired, $default::file . '/download/' . $key );
                }
            }
        }
        closedir(DIR);
        if (@expired) {
            use File::Path;
            foreach my $dir (@expired) {
                rmtree $dir;
            }
        }
        $this->write_file(
            $default::file . '/download/index.html',
            "<html><head><title>404 Not Found</title></head><body><h1>Not Found</h1> The requested object does not exist on this server.</body></html>\x0A",
            1
        );
        $this->write_file( $gc_dat, time, 1 );
        return 1;
    }
    return 0;
}

######################################################################
#RSS更新
sub feed_db_rss ($$$$) {
    my ( $this, $c, $n, $data ) = @_;
    local $main::c = $c;
    if (   ( !$default::type || $default::type ne 'order' )
        && defined $c
        && $c ne ''
        && defined $n
        && $n ne ''
        && (   $setting::general{'RSSEnabled'}
            || $setting::general{'masterRSSEnabled'}
            || $setting::general{'siteRSSEnabled'} )
        )
    {
        $this->import_db( $default::preference_dir . '/category',
            \%setting::category, 1 )
            if !%setting::category;
        my $my_url = $this->my_url;
        my $guid   = $my_url . '?m=DetailViewer&c=' . $c . '&n=' . $n;
        if (   $setting::security{'browse'}{'passwordCheck'} eq 'nocheck'
            && $setting::security{'detail'}{'passwordCheck'} eq 'nocheck' )
        {
            $this->feed_rss(
                {   'title' => (
                        (          $field::for{'title'}
                                && ref $field::obj{ $field::for{'title'} }
                                && $field::obj{ $field::for{'title'} }
                                ->{'Open'}
                                && !$field::obj{ $field::for{'title'} }
                                ->{'Hidden'}
                                && $data->{ $field::for{'title'} }{'str'}
                        )
                        ? $field::obj{ $field::for{'title'} }->usual_format(
                            $data->{ $field::for{'title'} }{'str'},
                            $default::file . '/' . $c . '/' . $n,
                            $c, $n
                            )
                        : (        $field::for{'key'}
                                && ref $field::obj{ $field::for{'key'} }
                                && $field::obj{ $field::for{'key'} }->{'Open'}
                                && !$field::obj{ $field::for{'key'} }
                                ->{'Hidden'}
                                && $data->{ $field::for{'key'} }{'str'} )
                        ? $field::obj{ $field::for{'key'} }->usual_format(
                            $data->{ $field::for{'key'} }{'str'},
                            $default::file . '/' . $c . '/' . $n,
                            $c, $n
                            )
                        : '新しいレコードが入力されました。'
                    ),
                    'link'            => $guid,
                    'content:encoded' => (
                        (          $field::for{'content'}
                                && ref $field::obj{ $field::for{'content'} }
                                && $field::obj{ $field::for{'content'} }
                                ->{'Open'}
                                && !$field::obj{ $field::for{'content'} }
                                ->{'Hidden'}
                                && $data->{ $field::for{'content'} }{'str'}
                        )
                        ? $field::obj{ $field::for{'content'} }
                            ->format_for_detail(
                            $data->{ $field::for{'content'} }{'str'},
                            $default::file . '/' . $c . '/' . $n,
                            $c, $n
                            )
                        : '新しいレコードが入力されました。'
                    ),
                    'dc:creator' => (
                        (          $field::for{'name'}
                                && ref $field::obj{ $field::for{'name'} }
                                && $field::obj{ $field::for{'name'} }
                                ->{'Open'}
                                && !$field::obj{ $field::for{'name'} }
                                ->{'Hidden'}
                                && $data->{ $field::for{'name'} }{'str'}
                        ) ? $field::obj{ $field::for{'name'} }->usual_format(
                            $data->{ $field::for{'name'} }{'str'},
                            $default::file . '/' . $c . '/' . $n,
                            $c, $n
                            )
                        : ( !$field::for{'name'}
                                && defined $setting::general{'mastername'} )
                        ? $setting::general{'mastername'}
                        : ''
                    ),
                    'category' => (
                        (   ref $setting::category{$c}
                                && defined $setting::category{$c}{'name'}
                        ) ? $setting::category{$c}{'name'} : ''
                    ),
                    'enclosure' => $this->article_enclosure( $c, $n, $data ),
                    'guid'      => $guid,
                    (   (          $env::checkout
                                && $field::for{'showcase'}
                                && ref $field::obj{ $field::for{'showcase'} }
                                && $field::obj{ $field::for{'showcase'} }
                                ->{'Open'}
                                && !$field::obj{ $field::for{'media'} }
                                ->{'Hidden'}
                        )
                        ? $field::obj{ $field::for{'showcase'} }
                            ->get_gdata( $guid,
                            $data->{ $field::for{'showcase'} } )
                        : ()
                    )
                },
                $default::file . '/' . $c,
                $my_url,
                $default::file,
                $my_url
            );
        }
        else {
            $this->feed_rss(
                {   'title' =>
                        '新しいレコードが入力されました。',
                    'link' => $guid,
                    'content:encoded' =>
                        '新しいレコードが入力されました。',
                    'guid' => $guid
                },
                $default::file . '/' . $c,
                $my_url,
                $default::file,
                $my_url
            );
        }
    }
}

sub article_enclosure ($$$$) {
    my ( $this, $c, $n, $data ) = @_;
    my $hash
        = (    $field::for{'media'}
            && ref $field::obj{ $field::for{'media'} }
            && $field::obj{ $field::for{'media'} }->{'Open'}
            && !$field::obj{ $field::for{'media'} }->{'Hidden'}
            && $data->{ $field::for{'media'} }{'str'} )
        ? {
        $field::obj{ $field::for{'media'} }->get_enclosure_attributes(
            $data->{ $field::for{'media'} }{'str'},
            $default::file . '/' . $c . '/' . $n,
            $c, $n
        )
        }
        : '';
    $hash
        = (    $field::for{'media2'}
            && ref $field::obj{ $field::for{'media2'} }
            && $field::obj{ $field::for{'media2'} }->{'Open'}
            && !$field::obj{ $field::for{'media2'} }->{'Hidden'}
            && $data->{ $field::for{'media2'} }{'str'} )
        ? {
        $field::obj{ $field::for{'media2'} }->get_enclosure_attributes(
            $data->{ $field::for{'media2'} }{'str'},
            $default::file . '/' . $c . '/' . $n,
            $c, $n
        )
        }
        : ''
        if !ref $hash || !%$hash;
    $hash
        = (    $field::for{'media3'}
            && ref $field::obj{ $field::for{'media3'} }
            && $field::obj{ $field::for{'media3'} }->{'Open'}
            && !$field::obj{ $field::for{'media3'} }->{'Hidden'}
            && $data->{ $field::for{'media3'} }{'str'} )
        ? {
        $field::obj{ $field::for{'media3'} }->get_enclosure_attributes(
            $data->{ $field::for{'media3'} }{'str'},
            $default::file . '/' . $c . '/' . $n,
            $c, $n
        )
        }
        : ''
        if !ref $hash || !%$hash;
    return $hash;
}

sub index_sweeper ($$$) {
    my ( $this, $c, $n ) = @_;
    require CMONOS::CGI_Lib::IndexSweeper;
    IndexSweeper->new(
        'index_files' => [
            $env::externalfiles . '/recentcomments.ssi',
            $env::externalfiles . '/recenttrackbacks.ssi',
            $default::file . '/recentcomments.ssi',
            $default::file . '/recenttrackbacks.ssi',
            $default::file . '/' . $c . '/recentcomments.ssi',
            $default::file . '/' . $c . '/recenttrackbacks.ssi',
        ],
        'rss_files' => [
            '../../index.xml',
            '../../comment.xml',
            '../../trackback.xml',
            '../../podcast.xml',
            $default::file . '/index.xml',
            $default::file . '/comment.xml',
            $default::file . '/trackback.xml',
            $default::file . '/podcast.xml',
            $default::file . '/' . $c . '/index.xml',
            $default::file . '/' . $c . '/comment.xml',
            $default::file . '/' . $c . '/trackback.xml',
            $default::file . '/' . $c . '/podcast.xml',
        ]
        )->sweep( [ $this->my_url . '?m=DetailViewer&c=' . $c . '&n=' . $n ],
        { $default::id => [ $c . '-' . $n ] } );
}

sub delete_record ($$$;$) {
    my ( $this, $c, $n, $count_fix ) = @_;
    return 0 if !defined $c || $c eq '' || !defined $n || $n eq '';
    if ($count_fix) {
        my ( %category, %pending, $nocount );
        tie( %pending, $env::dbm_file, "$default::db/$c/pending", O_RDONLY,
            $env::dbm_mode );
        if ( ref tied %pending ) {
            $nocount = 1
                if ref tied %pending
                && $pending{ $this->encode_utf8($n) }
                && $this->decode_utf8( $pending{ $this->encode_utf8($n) } )
                =~ /^1/;
        }
        untie %pending;

        #レコード数減数
        tie(%category, $env::dbm_file,
            $default::preference_dir . '/category',
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %category ) {
            $category{ $this->encode_utf8( $c . '_count' ) }--
                if !$nocount
                && $category{ $this->encode_utf8( $c . '_count' ) };
            $category{ $this->encode_utf8( $c . '_total' ) }--
                if $category{ $this->encode_utf8( $c . '_total' ) };
            $setting::category{$c}{'total'}
                = $this->decode_utf8(
                $category{ $this->encode_utf8( $c . '_total' ) } )
                || 0;
            $setting::category{$c}{'count'}
                = $this->decode_utf8(
                $category{ $this->encode_utf8( $c . '_count' ) } )
                || 0;
        }
        untie %category;
        $this->write_category_list
            if !defined $default::type || $default::type ne 'order';
    }

    if ( $setting::general{'oneEmailToOneRecord'} ) {
        $this->use_field(
            'field',
            $default::field_pref_dir . '/inputfield',
            $setting::field,
            $setting::field_style_disabled,
            $setting::field_tag_enabled,
            $setting::field_tag_name
        ) if !%field::obj;
        if ( $field::for{'mail'} ) {
            my ( %email, $email, %email_to_id );
            tie(%email,
                $env::dbm_file,
                $default::db . '/'
                    . $c . '/'
                    . $field::obj{ $field::for{'mail'} }->db,
                O_RDONLY,
                $env::dbm_mode
            );
            $email = $email{ $this->encode_utf8($n) } if ref tied %email;
            untie(%email);
            if ($email) {
                tie(%email_to_id, $env::dbm_file,
                    $default::db . '/email_to_id',
                    O_RDWR | O_CREAT,
                    $env::dbm_mode
                );
                if ( ref tied %email_to_id ) {
                    delete $email_to_id{$email};
                }
                untie %email_to_id;
                if (   $setting::general{'syncRegister'}
                    && $this->use_register
                    && $cgi::Register->remove( '', $email, 1 ) )
                {
                    $cgi::Register->success_dialog;
                }
            }
        }
    }

    #データ削除
    $this->delete_all_data( "$default::db/$c", $n );

    #添付ファイル削除
    use File::Path;
    rmtree "$default::file/$c/$n";

    #インデックスから削除
    $this->delete_permanent_id( $c, $n );
    $this->index_sweeper( $c, $n );
}

sub delete_permanent_id ($;$$) {
    my ( $this, $c, $n ) = @_;
    my %record_id;
    my $has_permanent_id = 0;
    $n = $this->encode_utf8($n);
    tie( %record_id, $env::dbm_file, $default::db . '/record_id',
        O_RDWR, $env::dbm_mode );
    if (   ref tied %record_id
        && defined $record_id{$n}
        && $record_id{$n} eq $c )
    {
        delete $record_id{$n};
        $has_permanent_id = 1;
    }
    untie %record_id;
    return $has_permanent_id;
}

sub get_category_and_number_from_permanent_id ($;$) {
    my ( $this, $n ) = @_;
    return ( '', '' ) if !defined $n || $n eq '';
    my $c = '';
    $c = $1 if $n =~ s/\@([0-9]+)$//;
    $n = $this->encode_utf8($n);
    if ( ref $this->{'DB'} ) {
        unless ( ref tied %{ $this->{'DB'}{'pref'}{'record_id'} } ) {
            tie( %{ $this->{'DB'}{'pref'}{'record_id'} },
                $env::dbm_file, "$default::db/record_id", O_RDONLY,
                $env::dbm_mode );
        }
        if ( ref tied %{ $this->{'DB'}{'pref'}{'record_id'} }
            && defined $this->{'DB'}{'pref'}{'record_id'}{$n} )
        {
            $c = $this->{'DB'}{'pref'}{'record_id'}{$n};
        }
    }
    else {
        my %record_id;
        tie( %record_id, $env::dbm_file, $default::db . '/record_id',
            O_RDONLY, $env::dbm_mode );
        if ( ref tied %record_id && defined $record_id{$n} ) {
            $c = $record_id{$n};
        }
        untie %record_id;
    }
    if ( !$c && $n !~ /[^0-9]/ && $n >= 1000000 ) {
        $c = int( $n / 1000000 );
        $n = $n - ( $c * 1000000 );
    }
    return ( $c, $n );
}

sub has_permanent_id ($$$) {
    my ( $this, $c, $n ) = @_;
    return 0 if !defined $c || $c eq '' || !defined $n || $n eq '';
    my $has_permanent_id = 0;
    $n = $this->encode_utf8($n);
    if ( ref $this->{'DB'} ) {
        unless ( ref tied %{ $this->{'DB'}{'pref'}{'record_id'} } ) {
            tie( %{ $this->{'DB'}{'pref'}{'record_id'} },
                $env::dbm_file, "$default::db/record_id", O_RDONLY,
                $env::dbm_mode );
        }
        if (   ref tied %{ $this->{'DB'}{'pref'}{'record_id'} }
            && defined $this->{'DB'}{'pref'}{'record_id'}{$n}
            && $this->{'DB'}{'pref'}{'record_id'}{$n} eq $c )
        {
            $has_permanent_id = 1;
        }
    }
    else {
        my %record_id;
        tie( %record_id, $env::dbm_file, $default::db . '/record_id',
            O_RDONLY, $env::dbm_mode );
        if (   ref tied %record_id
            && defined $record_id{$n}
            && $record_id{$n} eq $c )
        {
            $has_permanent_id = 1;
        }
        untie %record_id;
    }
    return $has_permanent_id;
}

sub permanent_id ($$$) {
    my ( $this, $c, $n ) = @_;
    return '' if !defined $c || $c eq '' || !defined $n || $n eq '';
    return ( $this->has_permanent_id( $c, $n ) ) ? $n : $c * 1000000 + $n;
}

sub permalink_of_detailview ($$$) {
    my ( $this, $c, $n ) = @_;
    return (wantarray) ? ( $this->my_url, '' ) : $this->my_url
        if !defined $c || $c eq '' || !defined $n || $n eq '';
    my $has_permanent_id = $this->has_permanent_id( $c, $n );
    my $url
        = $this->my_url
        . '?m=DetailViewer'
        . (
        ($has_permanent_id) ? '&record_id=' . $n : '&c=' . $c . '&n=' . $n );
    if (wantarray) {
        return ( $url, ( ($has_permanent_id) ? $n : $c * 1000000 + $n ) );
    }
    else {
        return $url;
    }
}

sub reset_access_counter ($$) {
    my ( $this, $latest_reset_date ) = @_;
    my ($reset_total, $reset_monthly, $reset_weekly, $reset_daily,
        $reset_date,  $w_start,       $m_start
    );

    my ( $sec, $min, $hour, $mday, $mon, $year, $wday ) = localtime(time);
    $year += 1900;
    $mon++;
    $reset_date = $year . sprintf( "%.2d", $mon ) . sprintf( "%.2d", $mday );

    ( $sec, $min, $hour, $mday, $mon, $year, $wday )
        = localtime( time - 86400 * $wday );
    $year += 1900;
    $mon++;
    $w_start = $year . sprintf( "%.2d", $mon ) . sprintf( "%.2d", $mday );
    $m_start = $year . sprintf( "%.2d", $mon ) . '01';

    $reset_total = ( !$latest_reset_date ) ? 1 : 0;
    $reset_monthly
        = ( !$latest_reset_date || $latest_reset_date < $m_start ) ? 1 : 0;
    $reset_weekly
        = ( !$latest_reset_date || $latest_reset_date < $w_start ) ? 1 : 0;
    $reset_daily
        = ( !$latest_reset_date || $latest_reset_date != $reset_date )
        ? 1
        : 0;
    return 1
        if !$reset_total
        && !$reset_monthly
        && !$reset_weekly
        && !$reset_daily;

    local (*CATEGORY);
    opendir( CATEGORY, $default::db );
    foreach my $c ( readdir(CATEGORY) ) {
        next if $c =~ /^\./ || !-d "$default::db/$c";
        my ( %mtime, %total, %monthly, %weekly, %daily );
        tie( %mtime, $env::dbm_file, "$default::db/$c/mtime", O_RDONLY,
            $env::dbm_mode );
        tie(%total, $env::dbm_file,
            "$default::db/$c/access_total",
            O_RDWR | O_CREAT,
            $env::dbm_mode
        ) if $reset_total;
        tie(%monthly, $env::dbm_file,
            "$default::db/$c/access_monthly",
            O_RDWR | O_CREAT,
            $env::dbm_mode
        ) if $reset_monthly;
        tie(%weekly, $env::dbm_file,
            "$default::db/$c/access_weekly",
            O_RDWR | O_CREAT,
            $env::dbm_mode
        ) if $reset_weekly;
        tie(%daily, $env::dbm_file,
            "$default::db/$c/access_daily",
            O_RDWR | O_CREAT,
            $env::dbm_mode
        ) if $reset_daily;
        while ( my ($n) = each %mtime ) {
            $total{$n}   = '0' if $reset_total   && ref tied %total;
            $monthly{$n} = '0' if $reset_monthly && ref tied %monthly;
            $weekly{$n}  = '0' if $reset_weekly  && ref tied %weekly;
            $daily{$n}   = '0' if $reset_daily   && ref tied %daily;
        }
        untie %daily   if $reset_daily;
        untie %weekly  if $reset_weekly;
        untie %monthly if $reset_monthly;
        untie %total   if $reset_total;
        untie %mtime;
        if ($reset_total) {
            my (%ip);
            tie( %ip, $env::dbm_file, "$default::db/$c/access_ip",
                O_RDWR | O_CREAT,
                $env::dbm_mode );
            if ( ref tied %ip ) {
                %ip = ();
            }
            untie %ip;
        }
    }
    closedir(CATEGORY);
    my (%general);
    tie(%general, $env::dbm_file,
        $default::preference_dir . '/general',
        O_RDWR | O_CREAT,
        $env::dbm_mode
    );
    if ( ref tied %general ) {
        $general{'counterReset'} = $this->encode_utf8($reset_date);
    }
    untie %general;
    $setting::general{'counterReset'} = $reset_date;

}

######################################################################
# 前後記事取得
sub get_neighbor_record ($) {
    no warnings qw(numeric);
    my $this = shift;
    my ( $next_record, $prev_record, $this_no, $is_checked );
    $this_no = $main::n . '@' . $main::c;

    #---------------------------------------------------------------------
    #検索
    if ( $main::mod
        && ( $main::mod eq 'Gate' || $main::mod eq 'DetailGate' ) )
    {
        if ( ref $field::for{'mail_address'}
            && @{ $field::for{'mail_address'} } )
        {
            foreach my $id ( @{ $field::for{'mail_address'} } ) {
                $main::search{$id}{'str'} = $main::email;
            }
        }
    }
    $this->sort_and_search( $this_no, @main::ct );

    #---------------------------------------------------------------------
    #前後記事判定
    $main::w = $field::SORTORDER if !$main::w && $field::SORTORDER;
    $main::w = 'ascend' if !$main::w;

    foreach my $no (
        sort {
            $this->sort_by( \$this->{'match'}{$b}, \$this->{'match'}{$a} )
                || $this->sort_by( \$this->{'sort'}{$a},
                \$this->{'sort'}{$b}, $main::w )
                || $a <=> $b
                || $a cmp $b
        } keys %{ $this->{'sort'} }
        )
    {
        if ( defined $is_checked && $is_checked ) {
            $next_record = $no;
            last;
        }
        elsif ( $this_no == $no ) {
            $is_checked = 1;
        }
        else {
            $prev_record = $no;
        }
    }

    #DBM接続解除
    $this->untie_all_dbm;

    return ( $prev_record, $next_record );
}

sub get_neighbor_link ($$$;$) {
    my ( $this, $prev, $next, $referer_url ) = @_;
    my ( $page_navi, $form_enabled );
    if ( $setting::general{'postMethod'} ) {
        $page_navi = $this->form_start(
            'key'  => $setting::security_key,
            'name' => 'jump' . ( ( defined $referer_url ) ? '2' : '1' ),
            'required' => [ grep( $_ ne 'c' && $_ ne 'n', @setting::form ) ]
        );
        $form_enabled = 1;
    }
    else {
        $form_enabled = 0;
        $this->use_deco;
    }
    $page_navi .= '<ul class="pager" id="'
        . ( ($referer_url) ? 'bottom-pager' : 'top-pager' ) . '">';
    $page_navi
        .= '<li class="prev">'
        . $this->get_link_button( 'prev', $prev ) . '</li>'
        if $prev;
    $page_navi
        .= $this->back_button( $referer_url, '<li class="button">', '</li>' );
    $page_navi
        .= '<li class="next">'
        . $this->get_link_button( 'next', $next ) . '</li>'
        if $next;
    $page_navi .= '</ul>';
    $page_navi .= '</form>' if $form_enabled;
    return $page_navi;
}

sub back_button ($$$$) {
    my ( $this, $referer_url, $header, $footer ) = @_;
    if ( defined $referer_url ) {
        if (   $setting::page{$setting::key}{'closeButtonDisabled'}
            && $referer_url )
        {
            return $header
                . $cgi::Deco->button( 'return', $setting::page{'backButton'},
                $referer_url, ( ($default::english) ? 'Return.' : '戻る' ) )
                . $footer;
        }
        elsif ( !$setting::page{$setting::key}{'closeButtonDisabled'} ) {
            return $header
                . $this->close_button(
                $referer_url,
                $setting::page{'closeButton'},
                $setting::page{'backButton'}
                ) . $footer;
        }
    }
    return '';
}

sub get_link_button($$$) {
    my ( $this, $type, $record_no ) = @_;
    return '' if !$record_no;
    my ( $button, $name, $button_type, $c, $n );
    ( $n, $c ) = split( /\@/, $record_no );
    if ( $type eq 'prev' ) {
        $name = ( ($default::english) ? 'Prev' : '前のページ' );
        $button_type = 'prevButton';
    }
    else {
        $name = ( ($default::english) ? $type : '次のページ' );
        $button_type = 'nextButton';
    }
    if ( $setting::general{'postMethod'} ) {
        return $cgi::Deco->submit_button( $type, $setting::page{$button_type},
            $name, '', { 'c' => $c, 'n' => $n } );
    }
    else {
        my $href
            = $cgi::path . '?m='
            . $main::m . '&c='
            . $c . '&n='
            . $n
            . $this->set_query(
            'url+',
            [   grep( $_ ne 'm' && $_ ne 'k' && $_ ne 'c' && $_ ne 'n',
                    @setting::form )
            ]
            );
        $this->set_link_rel(
            { $type => { 'href' => $this->escape($href) } } );
        return $cgi::Deco->button( $type, $setting::page{$button_type},
            $href, $name );
    }
}

1;
