package Teaser;
require CMONOS::CGI_Lib::Base;
@ISA = qw(Base);

#require CMONOS::TableMaker::TMCommon;
#@ISA = qw(TMCommon);
use strict;
use utf8;
######################################################################
# 埋め込み用リスト作成モジュール
# Teaser.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-05-14
######################################################################
# メイン
sub run ($) {
    my $this = shift;
    if ($main::js) {
        print "Content-type: text/javascript\x0A\x0A";
    }
    else {
        print 'Content-type: image/gif', "\x0A";
        print 'Content-length: 43',      "\x0A";
        print 'Cache-Control: no-cache', "\x0A";
        print 'Pragma: no-cache',        "\x0A";
        print "\x0A";
        print
            "GIF89a\x01\x00\x01\x00\x80\x00\x00\xFF\xFF\xFF\x00\x00\x00\x21\xF9\x04\x05\x14\x00\x00\x00\x2C\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02\x02D\x01\x00\x3B";
    }

    #---------------------------------------------------------------------
    #既存ファイルチェック
    my $target_file
        = $default::file
        . '/teaser'
        . ( ( $main::tn > 1 ) ? $main::tn : '' ) . '.ssi';
    if (   !ref $setting::page{$setting::key}
        || !%{ $setting::page{$setting::key} }
        || !$setting::page{$setting::key}{'interval'}
        || (   $setting::security{'browse'}{'passwordCheck'}
            && $setting::security{'browse'}{'passwordCheck'} ne 'nocheck' )
        )
    {
        $this->write_file( $target_file, '', 1 );
    }
    else {
        my $refresh = 0;
        if ( !$main::refresh && -s $target_file ) {
            my $ltime = time - $setting::page{$setting::key}{'interval'};
            my $mtime = ( stat($target_file) )[9];
            $refresh = 1
                if !$mtime
                || ( $ltime && $mtime < $ltime )
                || ( !$setting::page{$setting::key}{'keepInterval'}
                && $setting::general{'mtime'}
                && $mtime < $setting::general{'mtime'} );
            $this->write_file( $target_file . '.txt', $mtime .'<'. $setting::general{'mtime'}, 1 );
        }
        else {
            $refresh = 1;
        }
        if ($refresh) {
            local (
                *TEASER,   @setting::form, $cgi::action, $main::m,
                $main::k,  $main::c,       $main::n,     $main::mod,
                $main::ct, $main::s,       $main::w,     $main::f,
                $main::u,  $main::uni,     $main::and,   $main::search,
                $main::q,  $main::fv,      $main::id,    $main::p
            );
            if ( $setting::page{$setting::key}{'query'} ) {
                my %in = ();
                $this->url_decode( $setting::page{$setting::key}{'query'},
                    \%in, 1 );
                $this->variable( \%in, 0, 'main' );
            }
            $main::u = 4 if !$main::u;
            $cgi::action = {};
            if (   $setting::page{$setting::key}{'mode'}
                && $setting::page{$setting::key}{'mode'} eq 'tile' )
            {
                require CMONOS::TableMaker::TeaserTile;
                bless $cgi::action, 'TeaserTile';
                $setting::page{$setting::key}{'table'}
                    = $setting::page{$setting::key}{'tileTable'};
                $main::m = 'TileViewer';
                $main::k = 'tile';
            }
            else {
                require CMONOS::TableMaker::TeaserTable;
                bless $cgi::action, 'TeaserTable';
                $main::m = 'TableViewer';
                $main::k = 'viewer';
            }
            @setting::form = grep( $_ ne 'u', @setting::form );
            $cgi::action->run;
        }
    }
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ( $default::teaser_variation
        && ( $default::type || $default::type ne 'order' ) )
    {
        no warnings qw(once);

        #設定DB読み込み設定
        $setting::general  = 1;    #一般設定読み込み
        $setting::deco     = 1;    #テキスト装飾設定読み込み
        $setting::security = 1;    #アクセス権設定読み込み
        $setting::table    = 1;    #テーブル設定読み込み
        $setting::page     = 1;    #ページ設定読み込み

        $setting::field_db_name = 'inputfield';    #フィールド設定DB
        $setting::field         = 2
            ; #フィールド設定読み込み（2=オリジナルも読み込む）
        $setting::field_style_disabled = 0
            ; #2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
        $setting::field_tag_enabled = 'no'
            ;   #tag=タグのみ/all=全ての設定/no=タグをつけない

        $setting::pending_check = 1;    #非公開レコードチェック

        #設定種キー設定
        $setting::security_key
            = 'browse';    #デフォルトセキュリティキー
        $setting::key = 'teaser';    #ページ設定キー
        if (   $main::tn
            && $main::tn >= 2
            && $main::tn <= $default::teaser_variation )
        {
            $main::tn = int($main::tn);
            $setting::key .= $main::tn;
        }
        else {
            $main::tn = 1;
        }

        #クッキー
        $cookie::id_enabled = 1;    #ID情報クッキー読み込み

        #デフォルトキー
        $main::k = 'teaser' if !defined $main::k || !$main::k;

        #必須フォーム
        @setting::form = (
            'm',   'c',   'n',  'dn', 's',   'w',
            'f',   'u',   'fv', 'q',  'and', 'search',
            'mod', 'uni', 'ct'
        );

        #クラス登録
        Common::class_register( 'teaser', 'Teaser' );
    }
}

1;
