package DetailGatePage;
require CMONOS::TableMaker::Tools::GatePage;
@ISA = qw(GatePage);
use strict;
use utf8;
no warnings qw(once);
######################################################################
# データ修正レコード選択ページ設定モジュール
# GatePage.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'detailgate';    # データキー
    $preference::name
        = '詳細表示選択ページレイアウト';   # 設定パネル名
    $preference::title
        = '詳細表示選択ページのレイアウトについて設定します。';
}

######################################################################
# 設定チェック
sub is_valid_setting ($) {
    my $this = shift;
    if ( $default::type && $default::type eq 'order' ) {

        #ナビメーカーに CGI の名前を登録する
        my $navi_db = $default::preference_dir;
        if ( $navi_db =~ s![0-9a-zA-Z_]+$!navimaker/navi_db! ) {
            my ( %navi, $update );
            use Fcntl qw(:DEFAULT);
            eval 'use ' . $env::dbm_file . ';';
            tie( %navi, $env::dbm_file, $navi_db, O_RDWR, $env::dbm_mode );
            if ( ref tied %navi ) {
                my $k = 'order_pagetitle';
                utf8::encode($k) if utf8::is_utf8($k);
                if ( defined $navi{$k} ) {
                    my $title
                        = $main::data{'detailgate_title'}
                        || $setting::general{'cginame'}
                        || '注文履歴';
                    if ( $this->decode_utf8( $navi{$k} ) ne $title ) {
                        $navi{$k} = $this->encode_utf8($title);
                        $update = 1;
                    }
                }
            }
            untie %navi;
            if ($update) {
                require CMONOS::CGI_Lib::NavUpdate;
                NavUpdate->new->update;
            }
        }
    }
}

######################################################################
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( 't012', 'DetailGatePage' );

    #ツール登録
    $setting::sub_jump_menu{'page'}{'t012'} = '詳細表示選択ページ';
    $setting::selected_jump_menu{'t012'} = 't000'
        ; #サブメニューがあるときメインメニューのデフォルトキー

    $preference::page{'t012'} = 'detailgate';
}

1;
