package IconEditor;
require CMONOS::CGI_Lib::Tools::ImageEditor;
@ISA = qw(ImageEditor);
use strict;
use utf8;
######################################################################
# TableMakerアイコンライブラリ編集モジュール
# IconEditor.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 画像情報
sub get_image_info ($) {
    my $this = shift;
    undef %setting::deco_type;
    undef %setting::deco_dir;

    #イメージCSS
    $setting::image_css = 'tablemaker-image.css';

    %setting::deco_type = (
        'tableview'   => 'button',
        'gmapview'    => 'button',
        'tileview'    => 'button',
        'tmrefresh'   => 'button',
        'tmfavorites' => 'button',

        'tmmailer' => 'button',
        'tmsearch' => 'button',

        'tmlist'  => 'button',
        'tminput' => 'button',

        'tmtool'  => 'button',
        'tmlogin' => 'button',

        'tmedit'   => 'button',
        'tmdelete' => 'button',

        'detailedit'   => 'button',
        'detaildelete' => 'button',

        'toomuch' => 'image',
        'nomatch' => 'image',
    );
    %setting::deco_dir = (
        'tableview' => '001:テーブル表示ボタン',
        'gmapview'  => '002:Googleマップ表示ボタン',
        'tileview'  => '003:タイル表示ボタン',

        'tmreset'     => '101:検索条件リセットボタン',
        'tmfavorites' => '102:お気に入り表示ボタン',

        'tmmailer' => '201:メール配信フォームボタン',
        'tmsearch' => '202:検索ボタン',

        'tmlist'  => '301:修正ボタン',
        'tminput' => '302:新規入力ボタン',

        'tmtool'  => '401:環境設定を開く ボタン',
        'tmlogin' => '402:ログインボタン',

        'tmedit'   => '501:修正ボタン(テーブル表示)',
        'tmdelete' => '502:削除ボタン(テーブル表示)',

        'detailedit'   => '601:修正ボタン(詳細表示)',
        'detaildelete' => '602:削除ボタン(詳細表示)',

        'nomatch' => '601:ヒットなしの警告',
        'toomuch' => '602:ヒット件数過多の警告',
    );
    %setting::deco_option = (
        'toomuch' => 'nosave',
        'nomatch' => 'nosave',
    );
    $main::dir = 'tableview' if !defined $main::dir || $main::dir eq '';
    return (
        $env::image_dir . '/tablemaker',
        $env::image_lib . '/tablemaker',
        '', '', $env::css . '/' . $setting::image_css
    );
}

######################################################################
# クラス登録
#sub import {
BEGIN {

    #クラス登録
    Common::class_register( '0102', 'IconEditor' );

    #メニュー登録
    $setting::jump_menu{'0102'}
        = 'アイコンライブラリ編集(TableMaker共通)';
    $setting::master_check_option{'0102'} = 1;

}

1;
