package InquiryField;
require CMONOS::CGI_Lib::Tools::FieldEditor;
@ISA = qw(FieldEditor);
use strict;
use utf8;
######################################################################
# 問い合わせフィールド編集モジュール
# InquiryField.pm ver1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# フィールド読み込み設定
sub set_field ($) {
    no warnings qw(once);
    my $this = shift;
    $setting::field_db_name  = 'inquiryfield';
    $setting::field          = 2;
    $setting::field_for_mail = 1;
}

######################################################################
#サブ設定
sub print_sub_setting_items ($) {
    my $this = shift;
    return if !%field::obj;

    print
        '<fieldset><legend>特殊フィールド</legend><table class="field-table"><tbody>';

    print
        '<tr><td class="field-name"><label for="data:for_from">差出人メールアドレスフィールド</label></td>';
    print
        '<td class="field"><select name="data:for_from" id="data:for_from">';
    print '<option value=""></option>';
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$_} }
            && defined $field::obj{ $field::ORDER{$_} }->{'e-mail'}
            && $field::obj{ $field::ORDER{$_} }->{'e-mail'};
        print '<option value="'
            . $field::ORDER{$_} . '"'
            . (
            (   defined $field::for{'from'}
                    && $field::for{'from'} eq $field::ORDER{$_}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$_} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_name">差出人名フィールド</label></td>';
    print
        '<td class="field"><select name="data:for_name" id="data:for_name">';
    print '<option value=""></option>';
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$_} }
            && $field::obj{ $field::ORDER{$_} }->{'class'} eq 'text'
            && $field::obj{ $field::ORDER{$_} }->sort_enabled;
        print '<option value="'
            . $field::ORDER{$_} . '"'
            . (
            (   defined $field::for{'name'}
                    && $field::for{'name'} eq $field::ORDER{$_}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$_} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print
        ' <span class="note">入力欄高さが1文字以下の文字列フィールド</span>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_subject">メール表題フィールド</label></td>';
    print
        '<td class="field"><select name="data:for_subject" id="data:for_subject">';
    print '<option value=""></option>';
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$_} }
            && (
            (      $field::obj{ $field::ORDER{$_} }->{'class'} eq 'text'
                && $field::obj{ $field::ORDER{$_} }->sort_enabled
            )
            || $field::obj{ $field::ORDER{$_} }->{'class'} =~ /^select_/
            || $field::obj{ $field::ORDER{$_} }->{'class'} eq 'addr_pref'
            );
        print '<option value="'
            . $field::ORDER{$_} . '"'
            . (
            (   defined $field::for{'subject'}
                    && $field::for{'subject'} eq $field::ORDER{$_}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$_} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print
        ' <span class="note">入力欄高さが1文字以下の文字列フィールド</span>';
    print '</td></tr>';

    print '</tbody></table>';
    print '</fieldset>';
    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>';
}

######################################################################
#DBフィールド
sub is_not_html ($) {
    my $this = shift;
    return 1;
}

######################################################################
#入力Tips
sub tips ($) {
    my $this = shift;
    return
        '<div class="hints">&lt;name&gt;は名前フィールド（入力フィールド）の値に変換されます。</div><div class="hints">&lt;key&gt;はキーフィールド（入力フィールド）の値に変換されます。</div>';
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( 't101', 'InquiryField' );

    #ツール登録
    $setting::jump_menu{'t101'} = '問い合わせフィールド設定';
}

1;
