package InquiryPage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# 問い合わせページ設定モジュール
# InquiryPage.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2008-11-30
######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'inq';    # データキー
    $preference::name
        = '問い合わせページレイアウト';    # 設定パネル名
    $preference::title
        = '問い合わせページのレイアウトについて設定します。';
}

######################################################################
# 設定パネル
sub print_sub_preference_panel ($$$) {
    my ( $this, $id, $key ) = @_;
    print
        '<fieldset><legend><label for="data:inq_template">問い合わせ情報テンプレート</label></legend>';
    print
        '<textarea name="data:inq_template" id="data:inq_template" cols="72" rows="15" wrap="soft" class="content-editor-area">'
        . $this->escape( $main::data{'inq_template'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:inq_template\').quotationByMenu(this)" title="これらのタグは問い合わせページ表示時に対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print '<option value="&lt;name&gt;">&lt;name&gt;[名前フィールド'
        . ( ( $field::for{'name'} && ref $field::obj{ $field::for{'name'} } )
        ? '（' . $field::obj{ $field::for{'name'} }->name . '）'
        : '' )
        . 'の値]</option>';
    print '<option value="&lt;key&gt;">&lt;key&gt;[キーフィールド'
        . ( ( $field::for{'key'} && ref $field::obj{ $field::for{'key'} } )
        ? '（' . $field::obj{ $field::for{'key'} }->name . '）'
        : '' )
        . 'の値]</option>';
    print
        '<option value="&lt;title&gt;">&lt;title&gt;[タイトルフィールド'
        . (
        ( $field::for{'title'} && ref $field::obj{ $field::for{'title'} } )
        ? '（' . $field::obj{ $field::for{'title'} }->name . '）'
        : '' )
        . 'の値]</option>';
    print '</select></div>';
    print '</fieldset>';
}

######################################################################
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( 't011', 'InquiryPage' );

    #ツール登録
    $setting::sub_jump_menu{'page'}{'t011'} = '問い合わせページ';
    $setting::selected_jump_menu{'t011'} = 't000'
        ; #サブメニューがあるときメインメニューのデフォルトキー

    $preference::page{'t011'} = 'inq';
}

1;
