package TilePage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# タイルページ設定モジュール
# TilePage.pm ver1.1.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-05-11
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    no warnings qw(once);
    my $this = shift;

    #数字チェック
    $check::num{'tableWidth'} = 'テーブル幅';
    $check::num{'tileWidth'}  = 'タイル横幅';
    $check::num{'tileHeight'} = 'タイル高さ';
    $check::num{'tableCols'}  = 'テーブル列数';
    $check::num{'tableRows'}  = 'テーブル行数';

    #チェックボックス
    push( @check::checkbox,
        'toolboxTop', 'toolboxBottom', 'tileTableEnabled' );

    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    no warnings qw(once);
    my $this = shift;
    $preference::id = 'tile';    # データキー
    $preference::name
        = 'タイル表示ページレイアウト';    # 設定パネル名
    $preference::title
        = 'タイル表示ページのレイアウトについて設定します。';
}

######################################################################
# 設定パネル
sub _print_header_tool ($) {
    my $this = shift;
    return
        '<option value="&lt;!--categorylist--&gt;&lt;!--/categorylist--&gt;">カテゴリーリスト(&lt;!--categorylist--&gt;)</option><option value="&lt;!--search--&gt;&lt;!--/search--&gt;">検索フォーム (&lt;!--search--&gt;)</option><option value="&lt;!--results--&gt;&lt;!--/results--&gt;">条件にマッチしたレコードの数 (&lt;!--results--&gt;)</option>';
}

sub print_sub_preference_panel ($$$) {
    my ( $this, $id, $key ) = @_;
    print '<fieldset><legend>ツールボックス</legend>';
    print '<ol class="checkbox">';
    print
        '<li><label><input type="checkbox" name="data:tile_toolboxTop" id="data:tile_toolboxTop" value="1"'
        . (
        (   defined $main::data{ $key . 'toolboxTop' }
                && $main::data{ $key . 'toolboxTop' }
        ) ? ' checked="checked"' : ''
        )
        . ' /> ツールボックスをページ上部に表示する</label></li>';
    print
        '<li><label><input type="checkbox" name="data:tile_toolboxBottom" id="data:tile_toolboxBottom" value="1"'
        . (
        (   defined $main::data{ $key . 'toolboxBottom' }
                && $main::data{ $key . 'toolboxBottom' }
        ) ? ' checked="checked"' : ''
        )
        . ' /> ツールボックスをページ下部に表示する</label></li>';
    print '</ol>';
    print '</fieldset>';
    print '<fieldset><legend>タイル表示設定</legend>';
    print '<table class="field-table"><tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:tile_tileWidth">タイル横幅</label></td>';
    print
        '<td class="field"><input type="text" name="data:tile_tileWidth" id="data:tile_tileWidth" value="'
        . $this->escape( $main::data{'tile_tileWidth'} )
        . '" size="7" maxlength="7" /> <span class="">ピクセル</span></td>';
    print
        '<td class="field-name"><label for="data:tile_tileHeight">タイル高さ</label></td>';
    print
        '<td class="field"><input type="text" name="data:tile_tileHeight" id="data:tile_tileHeight" value="'
        . $this->escape( $main::data{'tile_tileHeight'} )
        . '" size="7" maxlength="7" /> <span class="">ピクセル</span></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:tile_tileAlign">行揃え</label></td>';
    print '<td class="q-field">';
    print $this->mk_select_menu(
        'data:tile_tileAlign', '', '', $main::data{'tile_tileAlign'},
        ''       => '',
        'left'   => '左寄せ',
        'center' => '中央揃え',
        'right'  => '右寄せ'
    );
    print '</td>';
    print
        '<td class="field-name"><label for="data:tile_tileValign">垂直位置揃え</label></td>';
    print '<td class="q-field">';
    print $this->mk_select_menu(
        'data:tile_tileValign', '', '', $main::data{'tile_tileValign'},
        ''       => '',
        'top'    => '上寄せ',
        'middle' => '中央揃え',
        'bottom' => '下寄せ'
    );
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '<fieldset><legend><label><input type="checkbox" name="data:'
        . $id
        . 'tileTableEnabled" value="1"'
        . (
        (   !defined $main::data{ $key . 'tileTableEnabled' }
                || $main::data{ $key . 'tileTableEnabled' }
        ) ? ' checked="checked"' : ''
        )
        . ' onclick="cmonos.element.item(\'tile-table-settings\').disappear(!this.checked);" />テーブルでタイル状に表示する</label></legend>';
    print '<div id="tile-table-settings"><table class="field-table"><tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:tile_table">タイルテーブルタイプ</label></td>';
    print '<td class="q-field">';
    print $this->table_menu( 'data:tile_table', $main::data{'tile_table'} );
    print '</td>';
    print
        '<td class="field-name"><label for="data:tile_tableCols">タイル列数</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:tile_tableCols" id="data:tile_tableCols" value="'
        . $this->escape( $main::data{'tile_tableCols'} )
        . '" size="7" maxlength="7" /></td>';
    print '</tr>';
    print '</tbody></table></div>';
    print '</fieldset>';
    print '<fieldset><legend>タイルフレーム</legend>';
    print $cgi::Deco->frame_menu( 'data:tile_tileFrame', 'frame',
        $main::data{'tile_tileFrame'} );
    print '</fieldset>';
    print '</fieldset>';
    print $this->javascript(
        "cmonos.element.item('tile-table-settings').disappear(true);")
        if defined $main::data{ $key . 'tileTableEnabled' }
        && !$main::data{ $key . 'tileTableEnabled' };

    $this->use_field( 'field', $default::field_pref_dir . '/inputfield', 2 );
    require CMONOS::CGI_Lib::Template;
    my $this_template = Template->new( \%field::obj );
    $this_template->print_template_form(
        'data:tile_template',
        'タイルテンプレート（上記タイル表示設定よりテンプレートが優先されます）',
        \$main::data{'tile_template'}
    );

}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 't002', 'TilePage' );

    #ツール登録
    $setting::sub_jump_menu{'page'}{'t002'} = 'タイル表示ページ';
    $setting::selected_jump_menu{'t002'} = 't000'
        ; #サブメニューがあるときメインメニューのデフォルトキー

    $preference::page{'t002'} = 'tile';
}

1;
