package MkZipCodeDB;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# 郵便番号データベース更新モジュール
# MkZipCodeDB.pm ver1.0.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-08-17
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    my $mtime;
    push( @main::target, $main::target ) if defined $main::target;

    use Fcntl qw(:flock :DEFAULT);
    eval 'use ' . $env::dbm_file . ';';
    $this->jump_menu('tools');

    #CSVファイル登録
    if ( defined $main::csv && $main::csv ne '' ) {
        my $new_csv
            = ( $main::csv =~ /([^\/\\:]*)(\.[^\.]+)$/ )
            ? $1 . ( lc $2 )
            : $main::csv;
        if ( $new_csv !~ /^[0-9a-zA-Z_]+\.csv$/ ) {
            push(
                @{ $this->{'dialog'} },
                '郵便番号 CSV を追加できませんでした。ファイル名を英数字列にしてください。'
            );
        }
        else {
            $cgi::input->save_file( 'csv', '<client>', '', '',
                $env::zipcode );
        }
    }

    if ( @main::target && defined $main::a && $main::a ) {
        if ( $main::a eq 'delete' ) {
            foreach (@main::target) {
                next if $_ !~ /^[0-9a-zA-Z_]+\.csv$/i;
                unlink $env::zipcode . '/' . $_;
            }
        }
        else {
            my ( $jiscode_start, $jiscode_total );
            @main::target = sort @main::target;
            $jiscode_start
                = ( $main::target[0] =~ /^([0-9]{2})/ ) ? int($1) * 1000 : 0;
            if ($jiscode_start) {
                my $jiscode_end
                    = ( $main::target[$#main::target] =~ /^([0-9]{2})/ )
                    ? ( int($1) + 1 ) * 1000
                    : 0;
                if ( $jiscode_end && $jiscode_end <= 48000 ) {
                    $jiscode_total = $jiscode_end - $jiscode_start;
                }
                else {
                    $jiscode_total = 48000;
                    $jiscode_start = 0;
                }
            }
            else {
                $jiscode_total = 48000;
            }
            require CMONOS::CGI_Lib::ProgressBar;
            my $progress_bar = ProgressBar->new;
            $progress_bar->set_sig;
            $this->set_javascript(
                <<JAVASCRIPT
cmonos.tool.zipcodeUpdater = {
	action_start : (new Date()).getTime(),
	jiscode_start : $jiscode_start,
	jiscode_total : $jiscode_total,

	updateProgressBar : function (jiscode,zip3) {
		jiscode = parseInt(jiscode);
		if (typeof document.body.style.maxHeight == "undefined") {
			document.getElementById('progress-bar-box-bg').style.height = (cmonos.window.getPageYOffset() + cmonos.window.getInnerHeight()) + 'px';
			document.getElementById('progress-bar-box-bg').style.width = (cmonos.window.getPageXOffset() + cmonos.window.getInnerWidth()) + 'px';
		}
		var max_width = 480;
		if (cmonos.window.getInnerWidth() <= 500) max_width = cmonos.window.getInnerWidth() - 20;
		if (cmonos.window.getInnerHeight() < 300) document.getElementById('progress-bar-dialog').style.paddingTop = (parseInt(cmonos.window.getInnerHeight() / 2) - 20) + 'px';
		document.getElementById('progress-bar-dialog').style.width = (max_width + 2) + 'px';
		document.getElementById('progress-bar-bg').style.width = max_width + 'px';
		if (jiscode == 48000) {
			document.getElementById('progress-bar').style.width = max_width + 'px';
			document.getElementById('progress-bar-box-bg').style.display = 'none';
			document.getElementById('progress-bar-box').style.display = 'none';
		} else {
			var done = jiscode - this.jiscode_start;
			var w = Math.floor(done / this.jiscode_total * max_width);
			document.getElementById('progress-bar').style.width = ((w > 0) ? w : 1) + 'px';
			document.getElementById('action-target').innerHTML = zip3 + '-**** ';
			if (done > 0) {
				var rmin = Math.ceil(((new Date()).getTime() - this.action_start) / done * this.jiscode_total / 60000);
				document.getElementById('time-remain').innerHTML = '(あと' + rmin + '分)';
			}
		}
	}
};
JAVASCRIPT
            );
        }
    }
    elsif ( defined $main::a && $main::a ) {
        push(
            @{ $this->{'dialog'} },
            '郵便番号 CSV を指定してください。'
        );
    }
    elsif (@main::target) {
        push( @{ $this->{'dialog'} },
            '処理を指定してください。' );
    }

    my (%zipcode);
    tie( %zipcode, $env::dbm_file, $env::zipcode . '/zipcode',
        O_RDONLY, $env::dbm_mode );
    $mtime = $this->decode_utf8( $zipcode{'mtime'} ) if ref tied %zipcode;
    untie(%zipcode);

    #ページヘッダ
    if (   @main::target
        && defined $main::a
        && $main::a
        && $main::a ne 'delete' )
    {
        $setting::page{'tools'}{'header'}
            = '<div id="progress-bar-box-bg"></div><div id="progress-bar-box"><div id="progress-bar-dialog"><span id="action-target">郵便番号CSV</span> を読み込み中...<span id="time-remain">(このまましばらくお待ち下さい)</span></div><div id="progress-bar-bg"><div id="progress-bar"></div></div></div>';
    }
    $this->print_page_header('tools');

    print
        '<h1 title="郵便番号データベースを更新します">郵便番号データベース更新 [前回更新時:<span id="zipcode-mtime">'
        . ( ($mtime) ? $this->date( $mtime, 3, 'gmtc' ) : '-' )
        . '</span>]</h1>';

    #フォーム開始
    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'multi'    => 1,
        'required' => \@setting::form
    );
    print '<fieldset>';
    print '<table class="field-table"><tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="csv">郵便番号 CSV 登録</label></td>';
    print
        '<td class="field"><input type="file" name="csv" id="csv" /> <a href="http://www.post.japanpost.jp/zipcode/download.html" title="日本郵便ホームページ" target="_blank" class="tool">郵便番号 CSV のダウンロード</a></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="target">郵便番号 CSV</label></td>';
    print '<td class="field">';

    my ( $file_name, @zipcsv );
    no warnings qw(numeric);
    local (*ZIP);
    opendir( ZIP, $env::zipcode );
    @zipcsv
        = sort { $a <=> $b || $a cmp $b }
        grep( $_ =~ /^[0-9a-zA-Z_]+\.csv$/i && -f $env::zipcode . '/' . $_,
        readdir(ZIP) );
    closedir(ZIP);

    if (@zipcsv) {
        print '<select name="target" id="target" multiple="multiple" size="'
            . scalar(@zipcsv) . '">';
        foreach (@zipcsv) {
            print '<option value="' . $_ . '">' . $_ . '</option>';
        }
        print '</select>';
    }
    else {
        print
            '<div class="hints">郵便番号 CSV がみつかりません。</div>';
    }
    print '</td>';
    print '</tr>';

    if (@zipcsv) {
        print '<tr>';
        print '<td class="field-name"><label for="a">処理</label></td>';
        print '<td class="field">';
        print '<select name="a" id="a">';
        print '<option value=""></option>';
        print '<option value="delete">削除</option>';
        print '<option value=""></option>';
        print
            '<option value="modify">郵便番号 DB に追加する</option>';
        print
            '<option value="refresh">郵便番号 DB を作り直す</option>';
        print '</select>';
        print '</td>';
        print '</tr>';
    }
    print '</tbody></table>';
    print '</fieldset>';

    print
        '<fieldset class="submit"><input type="submit" value="実行する" onclick="return confirm(\'この操作は取り消せません。本当に更新しますか？\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();" /></fieldset>';

    print '</form>';

    #ページフッタ
    $this->print_page_footer('tools');

    #データベース処理
    if (   @main::target
        && defined $main::a
        && $main::a
        && $main::a ne 'delete' )
    {
        binmode STDOUT, ":utf8";
        $mtime = $this->mod_zipcode_db( $main::a, @main::target );
        print $this->javascript(
                  'document.getElementById(\'zipcode-mtime\').innerHTML = \''
                . $this->date( $mtime, 3, 'gmtc' )
                . '\'' );
        print
            '<style type="text/css">div#progress-bar-box-bg, div#progress-bar-box { display: none; }</style>';
        binmode STDOUT;
    }
}

######################################################################
#ＤＢ作成
sub mod_zipcode_db ($$@) {
    my ( $this, $action, @target ) = @_;
    my ( %zipcode, $mtime );
    local (*CSV);
    tie(%zipcode, $env::dbm_file,
        $env::zipcode . '/zipcode',
        O_RDWR | O_CREAT,
        $env::dbm_mode
    );
    if ( ref tied %zipcode ) {
        %zipcode = () if $action eq 'refresh';
        my ( $csv, $prev, $prev_street, $prev_jis, $dialog );
        $dialog = '';
        foreach $csv (@target) {
            next if $csv !~ /^[0-9a-zA-Z_]+\.csv$/i;
            if ( open( CSV, $env::zipcode . '/' . $csv ) ) {
                binmode CSV;
                flock( CSV, LOCK_SH );
                my $line;
                while ( $line = <CSV> ) {
                    my ( $zip, $addr, @zip_data );
                    $line = $this->jcode_convert( $line, 'utf8', 'sjis' );
                    $zip = $addr = '';
                    @zip_data = split( /,/, $line );
                    map {
                        $_ =~ s/^"//;
                        $_ =~ s/"$//;
                    } @zip_data;

                    #事業所 CSV の場合
                    if ( $csv =~ /^J/ ) {
                        $zip  = $zip_data[7];
                        $addr = join( ' ',
                            $zip_data[3],
                            $zip_data[4],
                            $this->z_to_h( $zip_data[5], 'utf8' ),
                            $this->z_to_h( $zip_data[6], 'utf8' ),
                            $zip_data[2] )

                            #郵便番号 CSV の場合
                    }
                    else {
                        $zip = $zip_data[2];
                        $zip_data[8] =~ s/以下に掲載がない場合//g;
                        $zip_data[8] =~ s/の次に番地がくる場合//g;
                        $zip_data[8] =~ s/地階・階層不明//g;
                        $zip_data[8] =~ s/次のビルを除く//g;
                        $zip_data[8] =~ s/「.*?を除く」//g;
                        $zip_data[8] =~ s/（.*?を除く）//g;
                        $zip_data[8] =~ s/（/(/g;
                        $zip_data[8] =~ s/）/)/g;
                        $zip_data[8] =~ s/、/|/g;
                        $zip_data[8] =~ s/その他//g;
                        $zip_data[8] = $this->z_to_h( $zip_data[8], 'utf8' );

                        $zip_data[8]
                            =~ s/^([^\(\)]+\|[^\(\)]+)\(([^\|\(\)]+)\)$/\($1\)$2/;
                        $zip_data[8] =~ s/\(([^\|\)\(]*)\)/$1/;
                        $zip_data[8] =~ s/^(.+\([^\)]+)$/$1\)/;
                        $zip_data[8] =~ s/^([^\(]+)\)$/$1/;
                        $zip_data[8] = '(' . $zip_data[8] . ')'
                            if $zip_data[8] !~ /[\(\)]/
                            && $zip_data[8] =~ /\|/;

                        $zip_data[8]
                            =~ s/([0-9]+)[~∼～〜]([0-9]+)/[$1-$2]/g;
                        $zip_data[8] =~ s/(\([0-9\|]+)([^0-9]+)\)/$1\)$2/g;

                        if ( $prev && $zip eq $prev ) {
                            $prev_street =~ s/^\((.*)\)$/$1/;
                            $zip_data[8] =~ s/^\((.*)\)$/$1/;
                            $zip_data[8]
                                = '('
                                . $prev_street . '|'
                                . $zip_data[8] . ')';
                        }

                        $addr = join( ' ',
                            $zip_data[6], $zip_data[7], $zip_data[8] );
                        $prev        = $zip;
                        $prev_street = $zip_data[8];
                    }
                    if ( $zip ne '' && $addr ne '' ) {
                        $zipcode{ $this->encode_utf8($zip) }
                            = $this->encode_utf8($addr);
                        my $zip3 = substr( $zip, 0, 3 );
                        my $jis = int( $zip_data[0] / 10 ) * 10;
                        print $this->javascript(
                            "cmonos.tool.zipcodeUpdater.updateProgressBar($zip_data[0],'$zip3');"
                        ) if $prev_jis && $jis ne $prev_jis;
                        $prev_jis = $jis;
                    }
                }
                close(CSV);
                $zipcode{ $this->encode_utf8('mtime') } = $mtime = time;
                $dialog
                    .= '郵便番号データベースの更新に成功しました。('
                    . $this->escape($csv) . ')\\n';
            }
            else {
                $dialog
                    .= '郵便番号データベースの更新に失敗しました。\\n'
                    . $this->escape($csv)
                    . 'を開けませんでした。\\n';
            }
        }
        print $this->javascript(
            "cmonos.tool.zipcodeUpdater.updateProgressBar(48000);");
        print $this->javascript( $this->mk_alert($dialog) );
    }
    else {
        print $this->javascript(
            "cmonos.tool.zipcodeUpdater.updateProgressBar(48000);");
        print $this->javascript(
            $this->mk_alert(
                '郵便番号データベースの更新に失敗しました。\\nデータベースを作成できませんでした。'
            )
        );
    }
    untie(%zipcode);
    return $mtime;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ( !$env::subdirectory_disabled && !$env::user_site_template_dir ) {
        no warnings qw(once);

        #クラス登録
        Common::class_register( 'xxba', 'MkZipCodeDB' );

        #メニュー登録
        $setting::jump_menu{'xxba'} = '郵便番号データベース更新';

    }
}

1;
