#!/usr/bin/perl
# サーバのパスに合わせる
#use KCatch qw( mode=html );

######################################################################
# 旧型携帯向けコンテンツ変換スクリプト m.cgi ver1.0
# Copyright (C) 2011-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
######################################################################
require "<cgi-data-path-from-top>/lib/env.pl";

{
	package default;

	# Cookie 格納ディレクトリ
	$cookie_store = $env::session_store;
	$cookie_store =~ s!^\.\./\.\./!!;

	# Cookie 保存日数
	$cookie_lifetime = 14;

	# 携帯固有ID(かんたんログイン)を使わず携帯URL にセッションIDを埋め込む
	$use_trans_sid = 0;

	# 対象ドメイン(空=下位階層のみ/all=全てのドメイン)
	@target_domain = ();

	# 対象外URL(携帯用に表示を変換しないURL)
	@ignorable_url = ();

	# 無視する要素(id|tagName?.className)
	@skippable_elements = ('.user-generated-content-input-form','.auto-fit','.toggle-html-editor','td.time-scale');

	# 後回しにする要素(id|tagName?.className)
	@postponable_elements = ('header','site-navi','info-bar');

	# セルごとにヘッダを付記して表示する table 要素(id|.className)
	@parsable_tables = ('daytable','timetable-grid','daytable');

	# ページ分割時 前のページ
	$prev_text = ' &lt;&lt;PREV ';

	# ページ分割時 次のページ
	$next_text = ' NEXT&gt;&gt; ';

}

# CGI共通ライブラリ読み込み
use lib "<shared-cgi-data-root-from-top>/lib";
use CMONOS::OutdatedMobile::MConv;
MConv->new(
	$default::cookie_store,
	\@default::skippable_elements,
	\@default::postponable_elements,
	\@default::parsable_tables,
	\@default::target_domain,
	\@default::ignorable_url,
	$default::cookie_lifetime,
	$default::use_trans_sid,
	$default::prev_text,
	$default::next_text,
)->run;

