#!/usr/local/bin/perl
#サーバ環境チェック

use Config;

print <<HTML;
Content-type: text/html

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html;charset=UTF-8" />
<meta http-equiv="Content-Style-Type" content="text/css" />
<title lang="ja">このサーバの環境</title>
<style type="text/css">
<!--
body {
  background-color: #FFF;
  margin: 3em 10%;
}
table {
  border-collapse: collapse;
  empty-cells: show;
  border: 1px solid #CCC;
  font-size: 0.9em
}
td, th {
  margin: 0;
  padding: 0.7em 1em;
  border: 1px solid #CCC;
  background-color: #F3F3F3;
}
th {
  background-color: #EEE;
  text-align: right;
  white-space: nowrap;
}
tr:hover td, tr:hover th {
  background-color: #FFF;
}
-->
</style>
</head>
<body>
<h1>このサーバの環境</h1>
HTML
print '<table><tr><th>OS</th><td>',         "\n";
print `uname`,                              '</td></tr>', "\n";
print '<tr><th>OSバージョン</th><td>', "\n";
print $Config{'osvers'}, '</td></tr>', "\n";
print '<tr><th>サーバソフトウェア</th><td>', "\n";
print $ENV{'SERVER_SOFTWARE'}, '</td></tr>', "\n";
print '<tr><th>Perlバージョン</th><td>', "\n";
print $], '</td></tr>', "\n";

my $uid = ( stat('./servercheck.cgi') )[4];
print '<tr><th>CGIの動作</th><td>';
print( ( $uid ne $> && $uid ne $< )
    ? 'ユーザー以外の権限'
    : 'ユーザー権限' );
print '(' . $uid . '/' . $> . ',' . $< . ')';
print '</td></tr>';
print '<tr><th>Jcode.pm</th><td>';
print( ( eval 'use Jcode;1;' )
    ? 'インストール済み'
    : '追加アップロードが必要' );
print '</td></tr>';
print '<tr><th>Image::Magick</th><td>';
print( ( eval 'use Image::Magick;1;' )
    ? '利用可能'
    : 'みつかりません' );
print '</td></tr>';
print '<tr><th>LWP::UserAgent</th><td>';
print( ( eval 'use LWP::UserAgent;1;' )
    ? '利用可能'
    : 'みつかりません' );
print '</td></tr>';
print '<tr><th>Crypt::SSLeay</th><td>';
print( ( eval 'use Crypt::SSLeay;1;' )
    ? '利用可能'
    : 'みつかりません' );
print '</td></tr>';
print '<tr><th>Digest::SHA</th><td>';
print( ( eval 'use Digest;use Digest::SHA;1;' )
    ? '利用可能'
    : 'みつかりません' );
print '</td></tr>';

print '<tr><th>DBM</th><td><dl>', "\n";

$ex = $Config{'extensions'};
while ( $ex =~ s/(\w+_File)// ) {
    print '<dt>';
    print $1;
    print '</dt><dd>';
    if ( $1 eq 'NDBM_File' ) {
        print
            'UNIXに標準装備されていることが多いndbmデータベースにアクセスします。1レコードあたり最大 4,096 byte です。';
    }
    elsif ( $1 eq 'DB_File' ) {
        print
            'BSD系UNIXに標準装備されているdbデータベースパッケージを利用します。';
    }
    elsif ( $1 eq 'GDBM_File' ) {
        print
            'gdbmデータベースにアクセスします。キーと値の容量に制限がありません。';
    }
    elsif ( $1 eq 'SDBM_File' ) {
        print
            'Perlに付属しているsdbmデータベースにアクセスします。1レコードあたり最大 1,024 byte または 4,096 byte です。';
    }
    elsif ( $1 eq 'ODBM_File' ) {
        print
            '古くからUNIXで標準だったdbmデータベースにアクセスします。1レコードあたり最大 1,024 byte です。';
    }
    print '</dd>';
}

print '</dl></td></tr>',               "\n";
print '<tr><th>機能拡張</th><td>', "\n";
$ex =~ s/\//::/g;
$ex =~ s/\s+/<\/li><li>/g;
print '<ul><li>';
print $ex;
print '</li></ul>';
print '</td></tr></table>', "\n";
print '</body></html>',     "\n";

exit(0);
