package Editor;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# 記事編集モジュール
# Editor.pm ver1.1.6
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新：2016-07-05
######################################################################
# メイン
sub run ($) {
    my $this = shift;
    $this->{'tool_master'} = $this->is_secure('tools');

    #---------------------------------------------------------------------
    #承認待ち項目警告
    if ( $default::subdivided && !defined $main::c ) {
        $this->set_pending_item_alert if $this->{'tool_master'};
    }
    elsif (!defined $main::a
        && !defined $main::n
        && !defined $main::year
        && $this->is_secure('edit') )
    {
        $this->set_pending_item_alert;
    }

    #---------------------------------------------------------------------

    my $get_last_chapter
        = ( !$main::w && !$setting::general{'getNewChapter'} ) ? 1 : 0;
    my $get_last_section
        = ( !$main::w && !$setting::general{'getNewSection'} ) ? 1 : 0;
    if ( $main::chap && $main::chap eq 'new' ) {
        $main::chap       = '';
        $get_last_chapter = 0;
    }
    if ( $main::sect && $main::sect eq 'new' ) {
        $main::sect       = '';
        $get_last_section = 0;
    }

    $main::a = '' if !defined $main::a;
    undef $main::keep_mtime if !$setting::general{'keepMtimeEnabled'};

    $setting::page{'edit'}{'infoLabel'} = 'ページ情報'
        if !$setting::page{'edit'}{'infoLabel'};

    #---------------------------------------------------------------------
    #必要なモジュール
    use Fcntl qw(:DEFAULT :flock);
    eval 'use ' . $env::dbm_file . ';';
    use File::Path;
    require CMONOS::CGI_Lib::Template;
    require CMONOS::CGI_Lib::Taketori;

    #サブグループがある場合のホームディレクトリ
    $master::home = $default::home;
    if ( defined $default::subdivided && $default::subdivided ) {
        $default::home = '.'
            if !defined $default::home || $default::home eq '';
        if ( !defined $main::c || $main::c eq '' ) {
            $this->print_folder_selector;
        }
        elsif (defined $main::c
            && $main::c ne ''
            && -d $default::preference_dir )
        {
            $default::home .= '/' . $main::c;
            $this->set_dir($default::home) if !-d $default::home;
            if ( !$main::a && !$main::n ) {
                $this->write_file( $master::home . '/navi.ssi', '', 1 )
                    if !-f $master::home . '/navi.ssi';
            }
        }
        else {
            push(
                @{ $this->{'dialog'} },
                '指定されたフォルダがみつかりませんでした。'
            );
            $this->print_folder_selector;
        }
    }
    else {
        undef $main::c;
    }
    $this->write_file( $default::home . '/navi.ssi', '', 1 )
        if !$main::a && !$main::n && !-f $default::home . '/navi.ssi';

    #記事ファイル拡張子
    $default::ext = ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html';

    #フォルダの移動
    my ($old_n);
    if ((      $default::date
            && $main::new_year
            && $main::new_mon
            && $main::new_mday
        )
        || ( !$default::date && defined $main::new_n && $main::new_n ne '' )
        )
    {
        if ($main::n !~ /[^0-9a-zA-Z_]/
            && (   -d $default::home . '/' . $main::n
                || -d $default::home . '/' . $main::n . '.pending' )
            )
        {
            my $is_same = 0;
            if ($default::date) {
                my $renamed_date
                    = sprintf( "%.4d", $main::new_year )
                    . sprintf( "%.2d", $main::new_mon )
                    . sprintf( "%.2d", $main::new_mday );
                if ( $main::n =~ /^$renamed_date/ && !$main::copy ) {
                    push(
                        @{ $this->{'dialog'} },
                        '変更前と変更後の日付が同じです。'
                    );
                    $is_same = 1;
                }
            }
            elsif ( $main::n eq $main::new_n ) {
                push(
                    @{ $this->{'dialog'} },
                    '変更前と変更後のフォルダ名が同じです。'
                );
                $is_same = 1;
            }
            if ( !$is_same ) {
                $old_n   = $main::n;
                $main::a = 'c';
                if ($default::date) {
                    undef $main::n;
                    ( $main::year, $main::mon, $main::mday )
                        = ( $main::new_year, $main::new_mon,
                        $main::new_mday );
                }
                else {
                    $main::n = $main::new_n;
                }
            }
        }
    }

    #日付管理モード設定値調整
    if ( defined $default::date && $default::date ) {
        @setting::dateform = ( 'year', 'mon', 'mday' );

        #カレンダーディレクトリ
        $calendar::path = $default::home . '/calendar';
        $this->set_dir($calendar::path);

        #履歴ディレクトリ
        $history::path = $default::home . '/history';
        $this->set_dir($history::path);

        #日付調整
        my (@localtime);
        @localtime = localtime(time);
        $localtime[5] += 1900;
        if ( !defined $main::year || !$main::year ) {
            if (   $main::n
                && $main::n =~ /^([0-9]{4})([0-9]{2})([0-9]{2})[0-9]{2}$/ )
            {
                ( $main::year, $main::mon, $main::mday )
                    = ( $1 + 0, $2 + 0, $3 + 0 );
            }
            else {
                ( $main::year, $main::mon, $main::mday )
                    = ( $localtime[5], $localtime[4] + 1, $localtime[3] );
            }
        }

        #年初期値調整
        $setting::general{'yearStart'} = $localtime[5] - 1
            if !$setting::general{'yearStart'}
            || $setting::general{'yearStart'} >= $localtime[5];
        $setting::general{'yearEnd'} = $localtime[5] + 1
            if !$setting::general{'yearEnd'}
            || $setting::general{'yearEnd'} < $localtime[5];
        ( $setting::general{'yearStart'}, $setting::general{'yearEnd'} )
            = ( $setting::general{'yearEnd'}, $setting::general{'yearStart'} )
            if $setting::general{'yearEnd'} < $setting::general{'yearStart'};

        #カレンダーオブジェクト作成
        $this->mk_calendar_obj;
    }

    #総合インデックス情報読み込み
    if (   defined $default::subdivided
        && defined $main::c
        && $default::subdivided
        && $main::c ne '' )
    {
        $this->import_db( $default::master_preference_dir . '/page',
            \%setting::indexpage, 1, 'masterindex', 'metanavi' );
    }

#-----------------------------------------------------------------------------
#記事フォルダ全削除
    if (   defined $main::delete
        && defined $main::n
        && $main::delete eq 'n'
        && $main::n ne ''
        && $main::n !~ /[^0-9a-zA-Z_]/
        && $this->is_secure( 'delete', 0, 'edit' ) )
    {
        my $is_deleted = 0;
        if ( -d "$default::home/$main::n"
            && rmtree "$default::home/$main::n" )
        {
            $this->article_delete_from_index($main::delete);
            $this->index_sweeper($main::n);
            $is_deleted = 1;
        }
        elsif ( -d "$default::home/$main::n.pending"
            && rmtree "$default::home/$main::n.pending" )
        {
            $is_deleted = 1;
        }
        if ($is_deleted) {
            push(
                @{ $this->{'dialog'} },
                '指定された記事を削除しました。'
            );
            if ( defined $default::date && $default::date ) {
                $this->d_article_scan( $main::year, $main::mon, $main::mday );
            }
            else {
                $this->article_scan();
            }
            undef $main::n;
            $main::a = 'r';

            #記事選択ダイアログ=終了
            $this->print_article_selector;
        }
        else {
            push( @{ $this->{'dialog'} }, '削除に失敗しました。' );
            undef $main::delete;
        }

    }
    elsif ( defined $main::delete && $main::delete eq 'n' ) {
        push( @{ $this->{'dialog'} }, '削除に失敗しました。' );
        undef $main::delete;
    }
    @page::list = ();

#-----------------------------------------------------------------------------
#全記事テンプレート一括更新
#作業済み記事をファイルに記録→途中でエラーとなった場合、エラー表示→やり直し時続きから開始。
    my $template_has_recommendedindex = $this->template_has_recommendedindex;
    if (   $setting::general{'rebuildenabled'}
        && $this->{'tool_master'}
        && ( $main::a eq 'refresh' || $main::refresh_key ) )
    {
        $main::a = 'refresh';
        my (@article,           $total,         $no,
            $prev_history_name, $refresh_log,   $refresh_key,
            $last_article,      $rebuild_count, $done_count
        );
        $this->{'keep_mtime'} = $this->{'rebuild'} = 1;
        $rebuild_count = $done_count = 0;
        $setting::general{'rebuildinterval'} = 10
            if !$setting::general{'rebuildinterval'};
        $prev_history_name = '';
        $refresh_log       = $default::home . '/refresh_log.dat';
        if ( defined $default::date && $default::date ) {
            @article = $this->d_article_scan( $main::year, $main::mon,
                $main::mday );
        }
        else {
            @article = $this->article_scan($main::n);
        }
        $total = @article;
        if ( -f $refresh_log ) {
            $refresh_key = $this->get_refresh_key;
            if (   $refresh_key
                && $main::refresh_key
                && $refresh_key eq $main::refresh_key )
            {
                $last_article = $this->get_refresh_dat($refresh_log);
            }
            else {
                my @stat = stat($refresh_log);
                my $t = time - ( ( $stat[9] ) ? $stat[9] : 0 );
                if ( $t < 180 ) {
                    push(
                        @{ $this->{'dialog'} },
                        '既に実行されています。どうしてもやり直す場合は'
                            . ( int( ( 180 - $t ) / 60 ) + 1 )
                            . '分以上待って再度実行してください。'
                    );
                    undef $main::n;
                    $main::a = 'r';
                    if ($main::ajax) {
                        $this->ajax_print_response(
                            {   'status'  => 'error',
                                'message' => join( ';', $this->dialog ),
                            }
                        );
                    }
                    else {
                        $this->print_article_selector;
                        $this->set_refresh_dat( $refresh_log, $article[0] );
                    }
                }
                elsif ( $stat[9] && $t > 3600 ) {
                    $this->clear_refresh_log;
                }
                else {
                    $last_article = $this->get_refresh_dat($refresh_log);
                }
            }
        }
        else {
            $this->set_refresh_dat( $refresh_log, $article[0] );
        }
        $refresh_key = $this->set_refresh_key;
        $this->use_field( 'info', $default::field_pref_dir . '/infofield',
            2, 0, $setting::field_tag_enabled, 'info' );
        if ( !$last_article ) {
            if ($default::date) {
                $main::refresh_calendar = 1
                    if defined $main::refresh_history
                    && $main::refresh_history;
                local (*DIR);
                if (   defined $main::refresh_calendar
                    && $main::refresh_calendar
                    && opendir( DIR, $calendar::path ) )
                {
                    my @cals
                        = grep( -f "$calendar::path/$_"
                            && $_ =~ /^[0-9]{6}\.(ssi|js)$/,
                        readdir(DIR) );
                    closedir(DIR);
                    foreach my $cal (@cals) {
                        unlink "$calendar::path/$cal";
                        $this->write_file( "$calendar::path/$cal", '', 1 );
                    }
                }
                if ((   $main::refresh_recommendedindex
                        || !$template_has_recommendedindex
                    )
                    && $main::refresh_history
                    && opendir( DIR, $history::path )
                    )
                {
                    my @history
                        = grep( -f "$history::path/$_"
                            && $_ =~ /^[0-9]{8}\.[0-9a-zA-Z_]+$/,
                        readdir(DIR) );
                    closedir(DIR);
                    foreach my $arc (@history) {
                        unlink "$history::path/$arc";
                    }
                }
            }
            if ($main::refresh_history) {
                $this->write_file( $default::home . '/index.' . $default::ext,
                    '', 1 )
                    if $main::refresh_recommendedindex
                    || !$template_has_recommendedindex;
                $this->write_file( $default::home . '/index.kml', '', 1 );
                $this->write_file( $default::home . '/navi.ssi',  '', 1 )
                    if $main::refresh_recommendedindex
                    || !$template_has_recommendedindex;
            }
        }
    ARTICLE:
        foreach $no (@article) {
            $rebuild_count++;
            if ( defined $last_article && $last_article ) {
                undef $last_article if $last_article eq $no;
                next ARTICLE;
            }
            local $main::pending;
            local (*DIR);
            $main::pending
                = ( -d $default::home . '/' . $no . '.pending' ) ? 1 : 0;
            my $dir = ($main::pending) ? $no . '.pending' : $no;
            if ( opendir( DIR, $default::home . '/' . $dir ) ) {
                no warnings qw(numeric);
                my (%counter);
                @page::list
                    = sort { $a <=> $b || $a cmp $b }
                    grep( -f "$default::home/$dir/$_"
                        && $_ =~ s/^([0-9]+)\.(?:shtml|html|htm|shtm)$/$1/i
                        && !$counter{$_}++,
                    readdir(DIR) );
                closedir(DIR);
            }
            else {
                next ARTICLE;
            }
            $main::n = $no;
            if ( defined $default::date && $default::date ) {
                $this->d_article_scan($main::n);
                $this->get_history_info;
            }
            else {
                $this->article_scan($main::n);
            }
            $this->write_file(
                $default::home . '/' . $dir . '/i/waypoints.kml',
                '<?xml version="1.0"?><kml></kml>', 1 )
                if $main::refresh_history;
        PAGE:
            foreach my $p (@page::list) {
                my ( $output, $article, $new_template, $mtime );
                local ( $cgi::output, $cgi::output_option, $main::p );
                $output
                    = $default::home . '/'
                    . $dir . '/'
                    . $p . '.'
                    . $default::ext;
                $article = $this->read_html_file($output);
                next PAGE
                    if $article !~ /<!--chapter(?![0-9a-zA-Z_])[^>]*-->/s;
                $mtime = $this->get_last_modified( \$article, $output )
                    if $setting::general{'lastModifiedHeaderEnabled'};
                $article::title = $this->get_article_title( \$article );
                $article::description
                    = $this->get_article_description( \$article );
                $article::title
                    = ($default::date)
                    ? $this->date( substr( $main::n, 0, 8 ),
                    0, $setting::general{'datetype'} )
                    : $main::n
                    if !defined $article::title || $article::title eq '';
                $main::p = 'i';
                $this->mk_template_obj;
                $this->save_og_data_from_article( \$article,
                    $default::home . '/' . $dir . '/i' )
                    if !ref $this->{'og'};
                $new_template = $this->{'template'}->refresh(
                    \$article,
                    '',
                    $default::home . '/' . $dir . '/i',
                    'detail', $output, '', $this,
                    (   ( !$main::pending && $main::refresh_history )
                        ? \&index_refresh
                        : ''
                    ),
                    $main::c, $main::n
                );
                $article::title
                    = ($default::date)
                    ? $this->date( substr( $main::n, 0, 8 ),
                    0, $setting::general{'datetype'} )
                    : $main::n
                    if !defined $article::title || $article::title eq '';
                $main::p = $p + 0;
                $this->mk_template_obj;
                $article = $this->{'template'}->refresh(
                    \$article,
                    \$new_template,
                    $default::home . '/' . $dir . '/' . $main::p,
                    'detail', $output, '', $this,
                    (   ( !$main::pending && $main::refresh_history )
                        ? \&index_refresh
                        : \&waypoints_refresh
                    ),
                    $main::c, $main::n
                );
                $cgi::output = $output;
                undef $cgi::output_option;
                $this->set_last_modified($mtime)
                    if $setting::general{'lastModifiedHeaderEnabled'};
                $this->set_og_data;
                $this->write_html_file(
                    $output,
                    $this->tag_replace(
                        $article,               \$article::title,
                        \$article::description, $main::p,
                        $output,                '',
                        $main::pending
                    ),
                    1,
                    'article',
                    0,
                    $article::title,
                    $article::description,
                    (   ( @page::list > 1 )
                        ? ' ('
                            . $main::p . '/'
                            . ( scalar @page::list ) . ')'
                        : ''
                    ),
                    $this->article_id($main::n)
                );
                undef $main::p;
                undef $cgi::output;
                undef $cgi::output_option;
            }
            $this->clear_og_data;
            $this->mk_calendar($main::n)
                if $default::date
                && !$main::pending
                && $main::refresh_calendar;
            undef $main::n;
            if ( $main::pending || !$main::refresh_history ) {
                $this->mk_template_obj;
                if ($default::date) {
                    $this->index_replace_multi(1)
                        if $prev_history_name ne $history::name;
                    $prev_history_name = $history::name;
                }
                delete $this->{'template'};
            }
            $done_count++;
            $this->set_refresh_dat( $refresh_log, $no );
            if ( $done_count >= $setting::general{'rebuildinterval'} ) {
                $this->print_toss_page( $total, $rebuild_count,
                    $refresh_key );
            }
        }
        undef %info::obj;
        undef $cgi::output;
        undef $cgi::output_option;
        undef $main::n;
        undef $main::p;
        if ( defined $default::date && $default::date ) {
            $this->mk_template_obj;
            $this->index_replace_multi(2);
            delete $this->{'template'};
        }
        delete $this->{'rebuild'};
        delete $this->{'keep_mtime'};
        undef $main::n;
        $main::a = 'r';
        $this->clear_refresh_log;

        #終了
        push(
            @{ $this->{'dialog'} },
            'すべての記事('
                . $rebuild_count
                . ')を、最新のテンプレートを使って書き換えました。'
        );
        if ($main::ajax) {
            $this->ajax_print_response(
                {   'status'  => 'success',
                    'total'   => $rebuild_count,
                    'message' => join( ';', $this->dialog ),
                }
            );
        }
        else {
            if ( defined $default::date && $default::date ) {
                $this->d_article_scan( $main::year, $main::mon, $main::mday );
            }
            else {
                $this->article_scan;
            }
            $this->print_article_selector;
        }
        exit;

    }
    elsif ( $main::a eq 'refresh' ) {
        push(
            @{ $this->{'dialog'} },
            'この処理を実行する権限がありません。'
        );
        $main::a         = 'r';
        $main::return    = 1;
        $main::referer_n = $main::n if $main::n;
    }

#-----------------------------------------------------------------------------
#記事特定

    #日付管理版
    if ( defined $default::date && $default::date ) {
        if ( !$main::year && !$main::mon && !$main::mday ) {
            undef $main::n;
        }
        elsif ( !$main::year || !$main::mon || !$main::mday ) {
            push(
                @{ $this->{'dialog'} },
                '日付指定を確認してください。'
            );
            undef $main::n;
        }
        elsif ($main::year
            && $main::mon
            && $main::mday
            && $this->is_impossible_mday( $main::year, $main::mon,
                $main::mday ) )
        {
            push(
                @{ $this->{'dialog'} },
                '日付指定を確認してください。存在しない日付です。'
            );
            $main::mday = '';
            undef $main::n;
        }
        elsif ( $main::a ne 'c' && defined $main::n && $main::n ne '' ) {
            $this->d_article_scan($main::n);
        }
        else {
            $main::a = 'r' if !defined $main::a || $main::a eq '';
            undef $main::n;
            $this->d_article_scan( $main::year, $main::mon, $main::mday );
        }

        #名前管理版
    }
    else {
        if ( defined $main::n && $main::n ne '' ) {
            $main::n = $this->z_to_h( $main::n, 'utf8' )
                if defined $main::n && $main::n ne '';
            if ( $main::n =~ /[^0-9a-zA-Z_]/ ) {
                push(
                    @{ $this->{'dialog'} },
                    'フォルダ名は半角英数字にしてください。'
                );
                undef $main::n;
            }
            elsif (
                   $main::n eq 'new'
                || $main::n eq 'first'
                || $main::n eq 'media'
                || ($main::n ne ''
                    && (   -d "$default::home/$main::n"
                        || -d "$default::home/$main::n.pending" )
                )
                )
            {
                if ( $main::a eq 'c' ) {
                    push(
                        @{ $this->{'dialog'} },
                        'この名前のフォルダは既に存在します。別の名前にしてください。'
                    );
                    undef $main::n;
                }
            }
            else {
                $article::new++;
            }
        }
        $this->article_scan($main::n);
    }

    #記事移動の場合
    if ( defined $old_n && $old_n ne '' ) {
        undef $article::new;
        if ( !defined $main::n || $main::n eq '' ) {
            $main::n = $old_n;
            $main::a = 'r';
            undef $old_n;
            $main::pending = 1
                if -d $default::home . '/' . $main::n . '.pending';
            if ($default::date) {
                ( $main::year, $main::mon, $main::mday )
                    = ( $1 + 0, $2 + 0, $3 + 0 )
                    if $main::n =~ /^([0-9]{4})([0-9]{2})([0-9]{2})[0-9]{2}$/;
                $this->d_article_scan($main::n);
            }
            else {
                $this->article_scan($main::n);
            }
        }
    }

    #記事選択ダイアログ=終了
    $this->print_article_selector
        if !defined $main::n
        || $main::n eq ''
        || $main::return
        || $main::pending_list;

#-----------------------------------------------------------------------------
#ページ指定調整/ページ指定なし→文書情報入力　cookie 取得
    my $cookie_read = 0;
    if (   !$main::p
        && !$main::w
        && !$setting::general{'skip'}
        && !$main::get_last
        && !$main::get_new )
    {
        $main::p = 'i';
    }
    elsif ( !defined $main::p || $main::p ne 'i' ) {
        $main::p = 1 if !$main::p || $main::p =~ /[^0-9]/;
        $main::p += 0;
    }
    $cookie::default_enabled
        = 1;    #ユーザー設定情報クッキー読み込み
    $cookie::name = ( $main::p eq 'i' ) ? 'INFO' : 'EDITOR';
    $cookie::name .= '_' . ( uc $main::c )
        if $default::subdivided && defined $main::c && $main::c ne '';
    $cookie::path = $ENV{'SCRIPT_NAME'};
    if ( !%main::data ) {
        $this->read_cookie($cookie::name);
        $cookie_read = 1;
    }

#-----------------------------------------------------------------------------
#フォルダ名変更
    if ( defined $old_n && $old_n ne '' ) {
        my $old_is_pending
            = ( -d $default::home . '/' . $old_n . '.pending' ) ? 1 : 0;
        my $dir = $main::n . ( ($main::pending) ? '.pending' : '' );
        if ($main::copy) {
            $main::pending = 1;
            $dir           = $main::n . '.pending';
            $this->directory_copy(
                $default::home . '/'
                    . $old_n
                    . ( ($old_is_pending) ? '.pending' : '' ),
                $default::home . '/' . $dir,
                1
            );
            push(
                @{ $this->{'dialog'} },
                '記事をコピーしました。この記事は現在 非公開 です。前後リンクなどは、公開時に更新されます。'
            );
        }
        else {
            $this->{'keep_mtime'} = 1 if $main::keep_mtime;
            rename(
                $default::home . '/'
                    . $old_n
                    . ( ($old_is_pending) ? '.pending' : '' ),
                $default::home . '/' . $dir
            );
            if ($old_is_pending) {
                unlink "$default::home/$main::n/.htaccess" if !$main::pending;
            }
            else {
                if ($main::pending) {
                    $this->index_sweeper($old_n);
                }
                else {
                    $this->index_link_replace( $old_n, $main::n );
                }
                {
                    local $main::n = $old_n;
                    $this->article_delete_from_index('n');
                }
            }
        }
        if ($default::date) {
            $this->d_article_scan($main::n);
            $this->get_history_info;
        }
        else {
            $this->article_scan($main::n);
        }
        my $old_permalink
            = $this->full_path( $default::home . '/' . $old_n . '/' );
        my $new_permalink
            = $this->full_path( $default::home . '/' . $main::n . '/' );
        my $old_url = $this->full_path( "$default::home/$old_n"
                . ( ($old_is_pending) ? '.pending' : '' ) );
        my $new_url = $this->full_path( "$default::home/$main::n"
                . ( ($main::pending) ? '.pending' : '' ) );
        $this->article_path_replace(
            $default::home . '/' . $dir,
            $this->path_change(
                "$default::home/$old_n"
                    . ( ($old_is_pending) ? '.pending' : '' ),
                $ENV{'SCRIPT_NAME'},
                'abs'
            ),
            $this->path_change(
                "$default::home/$main::n"
                    . ( ($main::pending) ? '.pending' : '' ),
                $ENV{'SCRIPT_NAME'},
                'abs'
            ),
            [   $old_url                    => $new_url,
                $this->url_encode($old_url) => $this->url_encode($new_url),
                $this->url_encode(
                    $this->base_change(
                        "$default::home/$old_n"
                            . ( ($old_is_pending) ? '.pending' : '' ),
                        $env::javascript . '/player'
                    )
                    ) => $this->url_encode(
                    $this->base_change(
                        "$default::home/$main::n"
                            . ( ($main::pending) ? '.pending' : '' ),
                        $env::javascript . '/player'
                    )
                    ),
                $old_permalink => $new_permalink,
                $this->url_encode($old_permalink) =>
                    $this->url_encode($new_permalink),
            ]
        );
        local (*DIR);
        if ( opendir( DIR, $default::home . '/' . $dir ) ) {
            no warnings qw(numeric);
            my (%counter);
            $this->use_field( 'info', $default::field_pref_dir . '/infofield',
                2, 0, $setting::field_tag_enabled, 'info' );
            @page::list
                = sort { $a <=> $b || $a cmp $b }
                grep( -f "$default::home/$dir/$_"
                    && $_ =~ s/^([0-9]+)\.(?:shtml|html|htm|shtm)$/$1/i
                    && !$counter{$_}++,
                readdir(DIR) );
            closedir(DIR);
            foreach my $p (@page::list) {
                my ( $output, $article, $new_template, %link, $mtime );
                local ( %main::data, $main::p, $main::chap, $main::sect,
                    $cgi::output, $cgi::output_option );
                $output
                    = $default::home . '/'
                    . $dir . '/'
                    . $p . '.'
                    . $default::ext;
                $article = $this->read_html_file($output);
                next if $article !~ /<!--chapter(?![0-9a-zA-Z_])[^>]*-->/s;
                $mtime = $this->get_last_modified( \$article, $output )
                    if $setting::general{'lastModifiedHeaderEnabled'};
                $article::title = $this->get_article_title( \$article );
                $article::description
                    = $this->get_article_description( \$article );
                $article::title
                    = ($default::date)
                    ? $this->date( substr( $main::n, 0, 8 ),
                    0, $setting::general{'datetype'} )
                    : $main::n
                    if !defined $article::title || $article::title eq '';
                $main::p = 'i';
                $this->mk_template_obj;
                $new_template = $this->{'template'}->refresh(
                    \$article,
                    \$article,
                    $default::home . '/' . $dir . '/i',
                    'detail',
                    $output,
                    '',
                    $this,
                    ( ( !$main::pending ) ? \&index_refresh : '' ),
                    $main::c,
                    $main::n
                );
                $article::title
                    = ($default::date)
                    ? $this->date( substr( $main::n, 0, 8 ),
                    0, $setting::general{'datetype'} )
                    : $main::n
                    if !defined $article::title || $article::title eq '';
                $main::p = $p;
                $this->mk_template_obj;
                $article = $this->{'template'}->refresh(
                    \$article,
                    \$new_template,
                    $default::home . '/' . $dir . '/' . $main::p,
                    'detail', $output, '', $this,
                    (   ( !$main::pending )
                        ? \&index_refresh
                        : \&waypoints_refresh
                    ),
                    $main::c, $main::n
                );
                $this->set_last_modified($mtime)
                    if $setting::general{'lastModifiedHeaderEnabled'};
                $cgi::output        = $output;
                $cgi::output_option = '';
                $this->write_html_file(
                    $output,
                    $this->tag_replace(
                        $article,               \$article::title,
                        \$article::description, $main::p,
                        $output,                '',
                        $main::pending
                    ),
                    1,
                    'article',
                    0,
                    $article::title,
                    $article::description,
                    (   ( @page::list > 1 )
                        ? ' ('
                            . $main::p . '/'
                            . ( scalar @page::list ) . ')'
                        : ''
                    ),
                    $this->article_id($main::n)
                );
            }
            $this->mk_calendar($main::n) if $default::date && !$main::pending;
        }

        #履歴保存情報
    }
    elsif ($default::date) {
        $this->get_history_info;
    }

#-----------------------------------------------------------------------------
#公開予約
    if ( $setting::general{'autoPublishingEnabled'} ) {
        if ( $main::pending && %main::publish ) {
            if (   !$main::publish{'year'}
                && !$main::publish{'mon'}
                && !$main::publish{'mday'} )
            {
                undef %main::publish;
                push(
                    @{ $this->{'dialog'} },
                    '公開日指定を解除しました。'
                    )
                    if ( -d "$default::home/$main::n.pending"
                    && unlink("$default::home/$main::n.pending/publish.dat") )
                    || ( -d "$default::home/$main::n"
                    && unlink("$default::home/$main::n/publish.dat") );
            }
            elsif (!$main::publish{'year'}
                || !$main::publish{'mon'}
                || !$main::publish{'mday'} )
            {
                push(
                    @{ $this->{'dialog'} },
                    '公開日を設定できませんでした。日付に不足があります。'
                );
                undef %main::publish;
            }
            elsif (
                   $main::publish{'year'}
                && $main::publish{'mon'}
                && $main::publish{'mday'}
                && $this->is_impossible_mday(
                    $main::publish{'year'}, $main::publish{'mon'},
                    $main::publish{'mday'}
                )
                )
            {
                push(
                    @{ $this->{'dialog'} },
                    '公開日を設定できませんでした。存在しない日付です。'
                );
                undef %main::publish;
            }
            else {
                my $pub_date = sprintf( "%.4d%.2d%.2d",
                    $main::publish{'year'}, $main::publish{'mon'},
                    $main::publish{'mday'} );
                if ( $pub_date <= $this->date_id ) {
                    push(
                        @{ $this->{'dialog'} },
                        '今日と今日より前の日付を公開日に指定することはできません。'
                    );
                    undef %main::publish;
                }
                elsif ( -d "$default::home/$main::n.pending" ) {
                    $this->write_file(
                        "$default::home/$main::n.pending/publish.dat",
                        $pub_date, 1 );
                }
                elsif ( -d "$default::home/$main::n" ) {
                    $this->write_file( "$default::home/$main::n/publish.dat",
                        $pub_date, 1 );
                }
            }
        }
    }
    else {
        undef %main::publish;
        unlink "$default::home/$main::n.pending/publish.dat"
            if -d "$default::home/$main::n.pending";
    }

#-----------------------------------------------------------------------------
#非公開|公開　切り替え
    my $dir = $main::n;
    if ($article::new) {
        $dir .= '.pending' if $main::pending;
    }
    else {
        $this->{'keep_mtime'} = 1 if $main::keep_mtime;
        if ($main::w) {
            my $public_path = $this->path_change( "$default::home/$main::n",
                $ENV{'SCRIPT_NAME'}, 'abs' );
            my $pending_path = $public_path . '.pending/';
            my $public_url   = $this->full_path($public_path);
            my $pending_url  = $public_url . '.pending/';
            $public_path .= '/';
            $public_url  .= '/';
            my $public_url_encoded  = $this->url_encode($public_url);
            my $pending_url_encoded = $this->url_encode($pending_url);

            if ($main::pending) {
                $dir .= '.pending';
                if ( -d "$default::home/$main::n" ) {
                    no warnings qw(numeric);
                    rename(
                        "$default::home/$main::n",
                        "$default::home/$main::n.pending"
                    );
                    $this->article_delete_from_index('n');
                    $this->index_sweeper($main::n);
                    push( @article::pending, $main::n ) if $default::date;
                    local (*DIR);
                    if ( opendir( DIR, $default::home . '/' . $dir ) ) {
                        no warnings qw(numeric);
                        my (%counter);
                        @page::list
                            = sort { $a <=> $b || $a cmp $b }
                            grep( -f "$default::home/$dir/$_"
                                && $_ =~ /^[0-9]+\.(shtml|html|htm|shtm)$/i,
                            readdir(DIR) );
                        @page::list
                            = sort { $a <=> $b || $a cmp $b }
                            grep( $_ =~ s/^([0-9]+)\..*$/$1/
                                && !$counter{$_}++,
                            @page::list );
                        closedir(DIR);
                        my $public_fla_encoded = $this->url_encode(
                            $this->base_change(
                                "$default::home/$main::n",
                                $env::javascript . '/player'
                            )
                        );
                        my $pending_fla_encoded = $this->url_encode(
                            $this->base_change(
                                "$default::home/$main::n.pending",
                                $env::javascript . '/player'
                            )
                        );
                        $this->article_path_replace(
                            "$default::home/$main::n.pending",
                            $public_path,
                            $pending_path,
                            [   $public_url         => $pending_url,
                                $public_url_encoded => $pending_url_encoded,
                                $public_fla_encoded => $pending_fla_encoded,
                            ]
                        );
                    }
                }
            }
            else {
                if ( $main::recommend
                    || -d "$default::home/$main::n.pending" )
                {
                    if ( -d "$default::home/$main::n.pending" ) {
                        unlink "$default::home/$main::n.pending/.htaccess";
                        unlink "$default::home/$main::n.pending/publish.dat";
                        unlink
                            "$default::home/$main::n.pending/i/waypoints.kml";
                        rename(
                            "$default::home/$main::n.pending",
                            "$default::home/$main::n"
                        );
                        my $public_fla_encoded = $this->url_encode(
                            $this->base_change(
                                "$default::home/$main::n",
                                $env::javascript . '/player'
                            )
                        );
                        my $pending_fla_encoded = $this->url_encode(
                            $this->base_change(
                                "$default::home/$main::n.pending",
                                $env::javascript . '/player'
                            )
                        );
                        $this->article_path_replace(
                            "$default::home/$main::n",
                            $pending_path,
                            $public_path,
                            [   $pending_url         => $public_url,
                                $pending_url_encoded => $public_url_encoded,
                                $pending_fla_encoded => $public_fla_encoded,
                            ]
                        );
                        @article::pending
                            = grep( $_ ne $main::n, @article::pending )
                            if $default::date && @article::pending;
                        $article::count++;
                    }
                    local (*DIR);
                    if ( opendir( DIR, $default::home . '/' . $dir ) ) {
                        no warnings qw(numeric);
                        my ( %counter, $title, $info_rss_feeded );
                        $this->use_field( 'info',
                            $default::field_pref_dir . '/infofield',
                            2, 0, $setting::field_tag_enabled, 'info' )
                            if !%info::obj;
                        @page::list
                            = sort { $a <=> $b || $a cmp $b }
                            grep( -f "$default::home/$dir/$_"
                                && $_
                                =~ s/^([0-9]+)\.(?:shtml|html|htm|shtm)$/$1/i
                                && !$counter{$_}++,
                            readdir(DIR) );
                        closedir(DIR);
                        $title = '';
                        foreach my $p (@page::list) {
                            my ( $output, $article, $new_template, %link,
                                $mtime );
                            local ( %main::data, $main::p, $main::chap,
                                $main::sect, $cgi::output,
                                $cgi::output_option );
                            $output
                                = $default::home . '/'
                                . $dir . '/'
                                . $p . '.'
                                . $default::ext;
                            $article = $this->read_html_file($output);
                            next
                                if $article
                                !~ /<!--chapter(?![0-9a-zA-Z_])[^>]*-->/s;
                            $mtime
                                = $this->get_last_modified( \$article,
                                $output )
                                if $setting::general{
                                'lastModifiedHeaderEnabled'};
                            $article =~ s/\Q$pending_url\E/$public_url/gs;
                            $article
                                =~ s/\Q$pending_url_encoded\E/$public_url_encoded/gs;
                            $article
                                =~ s/<!--#include virtual="\Q$pending_path\E([^">]*)"-->/<!--#include virtual="$public_path$1"-->/sg
                                if $env::ssi;
                            $title = $this->get_article_title( \$article )
                                if $title eq '';
                            $main::p = 'i';
                            $this->mk_template_obj;
                            $new_template = $this->{'template'}->refresh(
                                \$article,
                                \$article,
                                $default::home . '/' . $dir . '/i',
                                'detail',
                                $output,
                                '',
                                $this,
                                \&index_and_rss_refresh,
                                $main::c,
                                $main::n
                            );
                            $main::p = $p;
                            $this->mk_template_obj;
                            $article = $this->{'template'}->refresh(
                                \$article,
                                \$new_template,
                                $default::home . '/' . $dir . '/' . $main::p,
                                'detail',
                                $output,
                                '',
                                $this,
                                \&index_and_rss_refresh,
                                $main::c,
                                $main::n
                            );
                            ( $article::prev_title, $article::next_title )
                                = $this->a_neighbor_link_replace(
                                \$article,
                                (   ($article::prev)
                                    ? "$default::home/$article::prev"
                                    : ''
                                ),
                                (   ($article::next)
                                    ? "$default::home/$article::next"
                                    : ''
                                ),
                                $output, '', $title,
                                \%link,
                                $article::prev_title,
                                $article::next_title
                                );

                            if ( $p eq $page::list[0] ) {
                                $this->replace_link_rel( \$article,
                                    { 'prev' => $link{'prev'} } )
                                    if ref $link{'prev'};
                            }
                            elsif ( $p eq $page::list[$#page::list] ) {
                                $this->replace_link_rel( \$article,
                                    { 'next' => $link{'next'} } )
                                    if ref $link{'next'};
                            }
                            $this->set_last_modified($mtime)
                                if $setting::general{
                                'lastModifiedHeaderEnabled'};
                            $this->write_html_file( $output, $article, 1,
                                'article', );
                        }
                        $this->mk_calendar($main::n) if $default::date;
                    }
                }
            }
        }
        elsif ( -d "$default::home/$main::n.pending" ) {
            $main::pending = 1;
            $dir .= '.pending';
        }
    }

    #---------------------------------------------------------------------
    #ロールバック
    if ($main::rewind) {
        $main::rewind =~ s/[^0-9]//g;
        undef $main::rewind
            if $main::a
            || !$main::rewind
            || !$main::n
            || !-d "$default::home/$dir/archives.pending/$main::rewind"
            || !$this->is_secure('rewind');
    }
    if ($main::rewind) {
        if ( !$main::pending ) {
            $this->article_delete_from_index('n');
            $this->index_sweeper($main::n);
        }
        my $article_dir = $default::home . '/' . $dir;
        my $current_dir = $article_dir . '/archives.pending/' . $main::rewind;
        $this->article_directory_copy( $current_dir, $article_dir, 1 );
        if ($default::date) {
            $this->d_article_scan($main::n);
            $this->get_history_info;
        }
        else {
            $this->article_scan($main::n);
        }
        local (*DIR);
        if ( opendir( DIR, $article_dir ) ) {
            no warnings qw(numeric);
            my (%counter);
            $this->use_field( 'info', $default::field_pref_dir . '/infofield',
                2, 0, $setting::field_tag_enabled, 'info' );
            @page::list
                = sort { $a <=> $b || $a cmp $b }
                grep( -f "$default::home/$dir/$_"
                    && $_ =~ s/^([0-9]+)\.(?:shtml|html|htm|shtm)$/$1/i
                    && !$counter{$_}++,
                readdir(DIR) );
            closedir(DIR);
            foreach my $p (@page::list) {
                my ( $output, $article, $new_template, %link );
                local ( %main::data, $main::p, $main::chap, $main::sect,
                    $cgi::output, $cgi::output_option,
                    $this->{'keep_mtime'} );
                $this->{'keep_mtime'} = 1;
                $output  = $article_dir . '/' . $p . '.' . $default::ext;
                $article = $this->read_html_file($output);
                next if $article !~ /<!--chapter(?![0-9a-zA-Z_])[^>]*-->/s;
                $article::title = $this->get_article_title( \$article );
                $article::description
                    = $this->get_article_description( \$article );
                $article::title
                    = ($default::date)
                    ? $this->date( substr( $main::n, 0, 8 ),
                    0, $setting::general{'datetype'} )
                    : $main::n
                    if !defined $article::title || $article::title eq '';
                $main::p = 'i';
                $this->mk_template_obj;
                $new_template = $this->{'template'}->refresh(
                    \$article,
                    \$article,
                    $default::home . '/' . $dir . '/i',
                    'detail',
                    $output,
                    '',
                    $this,
                    ( ( !$main::pending ) ? \&index_refresh : '' ),
                    $main::c,
                    $main::n
                );
                $article::title
                    = ($default::date)
                    ? $this->date( substr( $main::n, 0, 8 ),
                    0, $setting::general{'datetype'} )
                    : $main::n
                    if !defined $article::title || $article::title eq '';
                $main::p = $p;
                $this->mk_template_obj;
                $article = $this->{'template'}->refresh(
                    \$article,
                    \$new_template,
                    $default::home . '/' . $dir . '/' . $main::p,
                    'detail', $output, '', $this,
                    (   ( !$main::pending )
                        ? \&index_refresh
                        : \&waypoints_refresh
                    ),
                    $main::c, $main::n
                );
                $cgi::output        = $output;
                $cgi::output_option = '';
                $this->write_html_file(
                    $output,
                    $this->tag_replace(
                        $article,               \$article::title,
                        \$article::description, $main::p,
                        $output,                '',
                        $main::pending
                    ),
                    1,
                    'article',
                    0,
                    $article::title,
                    $article::description,
                    (   ( @page::list > 1 )
                        ? ' ('
                            . $main::p . '/'
                            . ( scalar @page::list ) . ')'
                        : ''
                    ),
                    $this->article_id($main::n)
                );
            }
        }
        $this->save_this_version;
    }

#-----------------------------------------------------------------------------
#全ページリスト
    local (*DIR);
    if ( !@page::list && opendir( DIR, "$default::home/$dir" ) ) {
        no warnings qw(numeric);
        my (%counter);
        @page::list
            = sort { $a <=> $b || $a cmp $b }
            grep( -f "$default::home/$dir/$_"
                && $_ =~ s/^([0-9]+)\..*$/$1/
                && !$counter{$_}++,
            readdir(DIR) );
        closedir(DIR);
    }
    if ($main::get_last) {
        $main::delete = $main::a = $main::w = $main::chap = $main::sect = '';
        $get_last_chapter = $get_last_section = 1;
        $main::p = $page::list[$#page::list];
    }
    elsif ($main::get_new) {
        $main::delete = $main::a = $main::w = $main::chap = $main::sect = '';
        $get_last_chapter = $get_last_section = 0;
        $main::p = $page::list[$#page::list];
    }

    if ( $main::p ne 'i' && $main::p > @page::list ) {
        $main::p = @page::list + 1;
        if ( $main::p > 99 ) {
            $main::p = 99;
            push(
                @{ $this->{'dialog'} },
                '作成できるページ数は 99 ページまでです。'
            );
        }
        unless ( grep( $_ == $main::p, @page::list ) ) {
            push( @page::list, $main::p );
            $page::new = 1;
        }

    }
    elsif ( !@page::list ) {
        $page::new = 1;
    }
    $main::chap = ''
        if !defined $main::chap || !$main::chap || $main::chap =~ /[^0-9]/;
    $main::sect = ''
        if !defined $main::sect || !$main::sect || $main::sect =~ /[^0-9]/;
    if ( $main::chap && $main::chap > 99 ) {
        $main::chap = 99;
        push(
            @{ $this->{'dialog'} },
            '作成できる chapter は 99 までです。'
        );
    }
    if ( $main::sect && $main::sect > 99 ) {
        $main::sect = 99;
        push(
            @{ $this->{'dialog'} },
            '作成できる section は 99 までです。'
        );
    }

#-----------------------------------------------------------------------------
#ページ削除
    if (   defined $main::delete
        && $main::delete eq 'rmpage'
        && $main::p > 1
        && $main::p eq $page::list[$#page::list]
        && unlink $this->fileglob(
            "$default::home/$dir",
            '^' . $main::p . '\.(html|htm|shtml|stml|shtm|stm)$', 'f'
        )
        )
    {
        $this->{'keep_mtime'} = 1 if $main::keep_mtime;

        #添付ファイルディレクトリ削除
        rmtree "$default::home/$dir/$main::p";

        $main::chap = $main::sect = '';
        push(
            @{ $this->{'dialog'} },
            '指定されたページを削除しました。'
        );

        #次ページタイトル取得
        my $next_path  = '';
        my $next_title = '';
        if ($article::next) {
            $next_path = $this->fileglob(
                "$default::home/$article::next",
                '^1\.(html|htm|shtml|stml|shtm|stm)$',
                'f'
            );
            my $temp = $this->read_html_file($next_path);
            $next_title = $this->get_article_title( \$temp );
        }
        my $last_page = $this->fileglob(
            "$default::home/$dir",
            '^'
                . ( $page::list[$#page::list] - 1 )
                . '\.(html|htm|shtml|stml|shtm|stm)$',
            'f'
        );
        $last_page = './' . $1
            if $last_page =~ /\/([0-9]+\.(html|htm|shtml|stml|shtm|stm))$/;

        #前ページのリンク更新
        pop(@page::list);
        foreach my $p (@page::list) {
            my $path = $this->fileglob( "$default::home/$dir",
                '^' . $p . '\.(html|htm|shtml|stml|shtm|stm)$', 'f' );
            my $temp = $this->read_html_file($path);
            $this->page_navi_replace( \$temp, $p,
                $this->get_article_title( \$temp ), $path );
            if ( $p == $page::list[$#page::list] ) {
                $this->replace_link_rel(
                    \$temp,
                    {   'last' => '',
                        'next' => (
                            ($next_path)
                            ? { 'href' =>
                                    $this->base_change( $next_path, $path ),
                                'title' => (
                                    (   defined $next_title
                                            && $next_title ne ''
                                    )                     ? $next_title
                                    : ($default::english) ? 'Next Article'
                                    :                       '次の記事'
                                )
                                }
                            : ''
                        ),
                        ( ( $p == 1 ) ? ( 'first' => '' ) : () ),
                    }
                );
                $temp
                    =~ s/<\!--nextpage(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/nextpage-->/$this->item_tag_replace('nextpage',$1,$2,'',1)/seg;
            }
            else {
                $this->replace_link_rel(
                    \$temp,
                    {   'last' => {
                            'href'  => $last_page,
                            'title' => (
                                ($default::english)
                                ? 'Last Page'
                                : '最後のページ'
                            )
                        }
                    }
                );
            }
            $this->write_html_file( $path, $temp, 1, 'article' );
        }
        push( @page::list, $main::p );
        $page::new = 1;

        #RSS更新
        $this->index_sweeper( $main::n, $main::p );

        #更新保存
        $this->save_this_version;

    }
    elsif ( defined $main::delete && $main::delete eq 'rmpage' ) {
        push(
            @{ $this->{'dialog'} },
            '削除に失敗しました。ページ指定を確認してください。'
        );
        undef $main::delete;

    }

#-----------------------------------------------------------------------------
#ページ情報フィールド設定読み込み/テンプレートオブジェクト作成
    $this->mk_template_obj;

#-----------------------------------------------------------------------------
#chapter/section ID調整
    $main::chap = ''
        if !defined $main::chap || !$main::chap || $main::chap =~ /[^0-9]/;
    $main::sect = ''
        if !defined $main::sect || !$main::sect || $main::sect =~ /[^0-9]/;

    #記事ファイル読み込み
    my ( $article, %temp_data );
    %temp_data = ();
    $article   = $this->read_html_file( "$default::home/$dir",
        ( ( $main::p eq 'i' ) ? 1 : $main::p ) );

    #移動
    if (   $main::moveto
        && $main::p ne 'i'
        && $main::chap
        && ( $main::target eq 'chapter' || $main::sect ) )
    {
        $this->{'keep_mtime'} = 1;
        $this->{'template'}->subdivision_move_to(
            \$article,   $main::target, $main::chap,
            $main::sect, $main::moveto,
        );
        $this->write_html_file( "$default::home/$dir/$main::p.$default::ext",
            $article, 1 );
        $this->save_this_version;
    }
    else {
        undef $main::moveto;
    }

    #記事補完
    if ( $article eq '' && $main::p ne 'i' && $main::p > 1 ) {
        $article = $this->read_html_file( "$default::home/$dir", '1' );

        #データの消去→テンプレート化
        $article = $this->{'template'}->default_template($article);

        # 読み取り先のクリア
    }
    elsif ( $cookie_read && %main::data ) {
        %temp_data = %main::data;
        undef %main::data;
    }

    #テンプレートから使用フィールドを取り出す
    $cgi::output = "$default::home/$dir/$main::p.$default::ext";
    $this->{'template'}
        ->scan( \$article, \$main::chap, \$main::sect, 'main', 'data',
        $get_last_chapter, $get_last_section );
    if ( $cookie_read && %temp_data ) {
        my ( $k, $v );
        my $is_empty = 1;
        while ( ( $k, $v ) = each %main::data ) {
            if ( ref $v && %{$v} ) {
                $is_empty = 0;
                last;
            }
        }
        %main::data = %temp_data if $is_empty;
    }
    undef %temp_data;

    $this->set_last_modified(
        $this->get_last_modified( \$article, $cgi::output ) || time )
        if $setting::general{'lastModifiedHeaderEnabled'};

#-----------------------------------------------------------------------------
#アップロードファイル保存先
    my ( $filedir, $input_is_valid );
    if ( $main::p eq 'i' ) {
        $filedir = $default::home . '/' . $dir . '/i';
    }
    else {
        $filedir
            = $default::home . '/'
            . $dir . '/'
            . $main::p . '/'
            . $main::chap . '/'
            . $main::sect;
    }

#-----------------------------------------------------------------------------
#データユニット削除
    my ( $chapter, $section );
    if (defined $main::delete
        && ((   $main::delete eq 'rmchapter'
                && @{ $this->{'template'}->{'stat'}{'chapter_order'} }
            )
            || (   $main::delete eq 'rmsection'
                && $main::sect
                && @{ $this->{'template'}->{'stat'}{'section_order'} } > 1 )
        )
        && $main::n ne ''
        && $main::p ne 'i'
        && $main::p > 0
        && $main::chap
        )
    {
        $this->{'keep_mtime'} = 1 if $main::keep_mtime;

        #添付ファイルディレクトリ削除
        if ( $main::delete eq 'rmsection' ) {
            rmtree "$default::home/$dir/$main::p/$main::chap/$main::sect";
        }
        else {
            rmtree "$default::home/$dir/$main::p/$main::chap";
        }

        $article::title       = $this->get_article_title( \$article );
        $article::description = $this->get_article_description( \$article );
        $article              = $this->tag_replace(
            $this->{'template'}->replace(
                $main::chap,   $main::sect, $article, \%main::data,
                $main::delete, $filedir,    $main::c, $main::n
            ),
            \$article::title,
            \$article::description,
            $main::p,
            $cgi::output,
            $cgi::output_option,
            $main::pending
        );
        $this->write_html_file( $cgi::output, $article, 1, 'article' );

        if ( $main::delete eq 'rmsection' ) {

            #インデックスから削除
            $this->index_sweeper( $main::n, $main::p, $main::chap,
                $main::sect );
            $chapter = $main::chap;
            $section = '';
        }
        else {

            #インデックスから削除
            $this->index_sweeper( $main::n, $main::p, $main::chap );
            $chapter = $section = '';
        }
        undef %main::data;
        $this->{'template'}->scan( \$article, \$chapter, \$section );

        #更新自動保存
        $this->save_this_version;

    }
    elsif ( defined $main::delete
        && ( $main::delete eq 'rmsection' || $main::delete eq 'rmchapter' ) )
    {
        push(
            @{ $this->{'dialog'} },
            '削除に失敗しました。指定を確認してください。'
        );
        undef $main::delete;

#-----------------------------------------------------------------------------
#入力のチェック
    }
    elsif ( defined $main::w && $main::w ) {
        $input_is_valid = 1;
        if ( @{ $this->{'template'}->{'stat'}{'field'} } ) {
            no warnings qw(numeric);
            foreach my $fid (
                sort {
                    $this->{'field_obj'}{$a}->{'ORDER'}
                        <=> $this->{'field_obj'}{$b}->{'ORDER'}
                } @{ $this->{'template'}->{'stat'}{'field'} }
                )
            {
                $input_is_valid = 0
                    unless ref $this->{'field_obj'}{$fid}
                    && $this->{'field_obj'}{$fid}->is_valid_data($filedir);
            }
        }

#-----------------------------------------------------------------------------
#書き込み
        if ( defined $input_is_valid && $input_is_valid ) {
            $article::first = $main::n
                if !$main::pending
                && ( ( $default::date && $main::n < $article::first )
                || ( !$default::date && $main::n lt $article::first ) );
            $article::latest = $main::n
                if !$main::pending
                && ( ( $default::date && $main::n > $article::latest )
                || ( !$default::date && $main::n gt $article::latest ) );

            #ファイル保存
            $cgi::input->fix_all_files($filedir);

            if ( ref $cgi::input->{'dialog'}
                && @{ $cgi::input->{'dialog'} } > 0 )
            {
                push( @{ $this->{'dialog'} }, @{ $cgi::input->{'dialog'} } );
            }

            #後処理
            $this->field_settle_up($filedir);

            #更新時の保持
            $this->{'keep_mtime'} = 1 if !$article::new && $main::keep_mtime;

            #文書情報の更新
            if ( $main::p eq 'i' ) {
                $this->page_info_update( $dir, $filedir );

                #ページの更新
            }
            else {
                $this->section_update( $cgi::output, $article, $dir,
                    $filedir );
            }
            undef $main::refresh;
            undef $article::new;
            undef $page::new;

            #更新自動保存
            $this->save_this_version;

        }
        else {
            push(
                @{ $this->{'dialog'} },
                '書き込みに失敗しました。'
            );
        }
    }
    undef $cgi::output;
    undef $cgi::output_option;

    #インデックス＆履歴の更新
    if ( $input_is_valid || $main::delete || $main::moveto ) {
        if ($main::pending) {
            $this->waypoints_replace;
        }
        else {
            $this->index_replace_multi;
        }
    }
    undef $cgi::output;
    undef $cgi::output_option;

    #新規作成時の文書情報記録->自動的に記事入力画面
    if ( $main::new && $input_is_valid && $main::p eq 'i' ) {
        $main::p = $main::chap = $main::sect = 1;
        $filedir
            = $default::home . '/'
            . $dir . '/'
            . $main::p . '/'
            . $main::chap . '/'
            . $main::sect;
        undef %main::data;
        $cookie::default_enabled
            = 1;    #ユーザー設定情報クッキー読み込み
        $cookie::name = 'EDITOR';
        $cookie::name .= '_' . ( uc $main::c )
            if $default::subdivided && defined $main::c && $main::c ne '';
        $cookie::path = $ENV{'SCRIPT_NAME'};
        $this->read_cookie($cookie::name);
        $this->mk_template_obj;
        $this->{'template'}->scan( \$article, \$main::chap, \$main::sect );
    }
    $main::a = 'r' if defined $input_is_valid && $input_is_valid;

    if ( !defined $main::delete || $main::delete eq '' ) {

        #何もしない
    }
    elsif ( defined $main::delete && $main::delete eq 'rmchapter' ) {
        $main::chap = $chapter;
        $main::sect = $section;
    }
    elsif ( defined $main::delete && $main::delete eq 'rmsection' ) {
        $main::sect = $section;
    }

    #非公開設定
    $this->set_htaccess("$default::home/$main::n.pending")
        if $main::pending && -d "$default::home/$main::n.pending";

#-----------------------------------------------------------------------------
#入力画面

    #ページヘッダ
    $this->print_page_header('edit');

    $this->print_article_selector(1);

    #戻る/オリジナルページ
    print '<div id="target-selector"><ul>';
    print '<li><a href="'
        . $this->fileglob( $default::home . '/' . $dir,
        '^' . ( ( $main::p eq 'i' ) ? '1' : $main::p ) . '\.' )
        . '" target="_blank">実際のページ</a></li>'
        if !$article::new && !$page::new;

    #ページ選択/新規作成
    push( @setting::form, 'n' );
    if ( $main::p ne 'i' ) {
        print '<li>';
        print $this->form_start(
            'key'      => 'edit',
            'name'     => 'prevpage',
            'required' => [ @setting::form, @setting::dateform ]
        );
        if ( $main::p > 1 ) {
            print '<input type="submit" name="p='
                . ( $main::p - 1 )
                . '" value="&lsaquo; 前のページ" />';
        }
        else {
            print '<input type="submit" name="p=i" value="&lsaquo; '
                . $setting::page{'edit'}{'infoLabel'} . '" />';
        }
        print '</form></li>';
    }
    if ( $main::p eq 'i' || ( $main::p <= @page::list && !$page::new ) ) {
        print '<li>';
        print $this->form_start(
            'key'      => 'edit',
            'name'     => 'nextpage',
            'required' => [ @setting::form, @setting::dateform ]
        );
        if ( $main::p eq 'i' ) {
            print '<input type="submit" name="p=1" value="'
                . ( ( $setting::page{'edit'}{'mainLabel'} )
                ? $setting::page{'edit'}{'mainLabel'} . ' '
                : '' )
                . '1ページ目 &rsaquo;" />';
        }
        elsif ( $main::p < 99 ) {
            print '<input type="submit" name="p='
                . ( $main::p + 1 )
                . '" value="次のページ &rsaquo;" />';
        }
        print '</form></li>';
    }
    print '<li>';
    print $this->form_start(
        'key'      => 'edit',
        'name'     => 'pageselector',
        'required' => [ @setting::form, @setting::dateform ]
    );
    print '<select name="p" onchange="submit()"><option value="i"'
        . ( ( $main::p eq 'i' ) ? ' selected="selected"' : '' ) . '>'
        . $setting::page{'edit'}{'infoLabel'}
        . '</option>';
    foreach my $p (@page::list) {
        print '<option value="'
            . $p . '"'
            . ( ( $main::p && $main::p ne 'i' && $main::p == $p )
            ? ' selected="selected"'
            : '' )
            . '>'
            . ( ( $setting::page{'edit'}{'mainLabel'} )
            ? $setting::page{'edit'}{'mainLabel'} . ' '
            : '' )
            . $p
            . 'ページ</option>';
    }
    print '<option value="'
        . ( @page::list + 1 ) . '">'
        . ( ( $setting::page{'edit'}{'mainLabel'} )
        ? $setting::page{'edit'}{'mainLabel'} . ' '
        : '' )
        . '新規ページ</option>'
        if !$page::new && @page::list < 99;
    print '</select><input type="submit" value="選択" /></form></li></ul>';
    push( @setting::form, 'p' );

    #情報書き込み以外の場合
    if ( $main::p ne 'i' ) {

        #ボディ選択/新規作成
        if (   !defined $this->{'template'}->{'chapter_limit'}
            || $this->{'template'}->{'chapter_limit'} eq ''
            || $this->{'template'}->{'chapter_limit'} > 1 )
        {
            my $chap_dir
                = ( defined $this->{'template'}->{'chapter_dir'}
                    && $this->{'template'}->{'chapter_dir'} eq 'above' )
                ? '[↑]'
                : '[↓]';

            print '<ul>';
            if (   $this->{'template'}->{'stat'}{'prev_chapter'}
                && $this->{'template'}->{'stat'}{'prev_chapter'} ne '<new>' )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'prevchapter',
                    'required' => [ @setting::form, @setting::dateform ]
                );
                print '<input type="submit" name="chap='
                    . $this->{'template'}->{'stat'}{'prev_chapter'}
                    . '" value="前の chapter" /></form></li>';
            }
            elsif (
                   $this->{'template'}->{'chapter_dir'}
                && $this->{'template'}->{'chapter_dir'} eq 'above'
                && !$this->{'template'}->{'stat'}{'new_chapter'}
                && (   !defined $this->{'template'}->{'chapter_limit'}
                    || $this->{'template'}->{'chapter_limit'} eq ''
                    || @{ $this->{'template'}->{'stat'}{'chapter_order'} }
                    < $this->{'template'}->{'chapter_limit'} )
                && @{ $this->{'template'}->{'stat'}{'chapter_order'} } < 99
                )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'nextchapter',
                    'required' => [ @setting::form, @setting::dateform ]
                );
                print
                    '<input type="submit" name="chap=new" value="新規 chapter 作成'
                    . $chap_dir
                    . '" /></form></li>';
            }

            if (   $this->{'template'}->{'stat'}{'next_chapter'}
                && $this->{'template'}->{'stat'}{'next_chapter'} ne '<new>' )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'nextchapter',
                    'required' => [ @setting::form, @setting::dateform ]
                );
                print '<input type="submit" name="chap='
                    . $this->{'template'}->{'stat'}{'next_chapter'}
                    . '" value="次の chapter" /></form></li>';
            }
            elsif (
                (     !$this->{'template'}->{'chapter_dir'}
                    || $this->{'template'}->{'chapter_dir'} ne 'above'
                )
                && !$this->{'template'}->{'stat'}{'new_chapter'}
                && (   !defined $this->{'template'}->{'chapter_limit'}
                    || $this->{'template'}->{'chapter_limit'} eq ''
                    || @{ $this->{'template'}->{'stat'}{'chapter_order'} }
                    < $this->{'template'}->{'chapter_limit'} )
                && @{ $this->{'template'}->{'stat'}{'chapter_order'} } < 99
                )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'nextchapter',
                    'required' => [ @setting::form, @setting::dateform ]
                );
                print
                    '<input type="submit" name="chap=new" value="新規 chapter 作成'
                    . $chap_dir
                    . '" /></form></li>';
            }

            print '<li>';
            print $this->form_start(
                'key'      => 'edit',
                'name'     => 'chapterselector',
                'required' => [ @setting::form, @setting::dateform ]
            );
            print '<select name="chap" onchange="submit()">';
            print '<option value="new">新規 chapter 作成'
                . $chap_dir
                . '</option>'
                if $this->{'template'}->{'chapter_dir'}
                && $this->{'template'}->{'chapter_dir'} eq 'above'
                && !$this->{'template'}->{'stat'}{'new_chapter'}
                && ( !defined $this->{'template'}->{'chapter_limit'}
                || $this->{'template'}->{'chapter_limit'} eq ''
                || @{ $this->{'template'}->{'stat'}{'chapter_order'} }
                < $this->{'template'}->{'chapter_limit'} );
            foreach my $chp (
                @{ $this->{'template'}->{'stat'}{'chapter_order'} } )
            {
                next if $chp eq '';
                print '<option value="'
                    . $chp . '"'
                    . (
                    ( $main::chap eq $chp ) ? ' selected="selected"' : '' )
                    . '>'
                    . $this->jfold(
                    $this->{'template'}->{'stat'}{'chapter_title'}{$chp},
                    24, 'I', 1 )
                    . '</option>';
            }
            print '<option value="new">新規 chapter 作成'
                . $chap_dir
                . '</option>'
                if ( !$this->{'template'}->{'chapter_dir'}
                || $this->{'template'}->{'chapter_dir'} ne 'above' )
                && !$this->{'template'}->{'stat'}{'new_chapter'}
                && ( !defined $this->{'template'}->{'chapter_limit'}
                || $this->{'template'}->{'chapter_limit'} eq ''
                || @{ $this->{'template'}->{'stat'}{'chapter_order'} }
                < $this->{'template'}->{'chapter_limit'} );
            print
                '</select><input type="submit" value="選択" /></form></li>';
            print '</ul>';

        }
        push( @setting::form, 'chap' );

        #ユニット選択/新規作成
        if (   !defined $this->{'template'}->{'section_limit'}
            || $this->{'template'}->{'section_limit'} eq ''
            || $this->{'template'}->{'section_limit'} > 1 )
        {
            my $sect_dir
                = ( defined $this->{'template'}->{'section_dir'}
                    && $this->{'template'}->{'section_dir'} eq 'above' )
                ? '[↑]'
                : '[↓]';

            print '<ul>';
            if (   $this->{'template'}->{'stat'}{'prev_section'}
                && $this->{'template'}->{'stat'}{'prev_section'} ne '<new>' )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'prevsection',
                    'required' => [ @setting::form, @setting::dateform ]
                );
                print '<input type="submit" name="sect='
                    . $this->{'template'}->{'stat'}{'prev_section'}
                    . '" value="前の section" /></form></li>';
            }
            elsif (
                   $this->{'template'}->{'section_dir'}
                && $this->{'template'}->{'section_dir'} eq 'above'
                && !$this->{'template'}->{'stat'}{'new_section'}
                && (   !defined $this->{'template'}->{'section_limit'}
                    || $this->{'template'}->{'section_limit'} eq ''
                    || @{ $this->{'template'}->{'stat'}{'section_order'} }
                    < $this->{'template'}->{'section_limit'} )
                && @{ $this->{'template'}->{'stat'}{'section_order'} } < 99
                )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'nextsection',
                    'required' => [ @setting::form, @setting::dateform ]
                );
                print
                    '<input type="submit" name="sect=new" value="新規 section 作成'
                    . $sect_dir
                    . '" /></form></li>';
            }

            if (   $this->{'template'}->{'stat'}{'next_section'}
                && $this->{'template'}->{'stat'}{'next_section'} ne '<new>' )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'nextsection',
                    'required' => [ @setting::form, @setting::dateform ]
                );
                print '<input type="submit" name="sect='
                    . $this->{'template'}->{'stat'}{'next_section'}
                    . '" value="次の section" /></form></li>';
            }
            elsif (
                (     !$this->{'template'}->{'section_dir'}
                    || $this->{'template'}->{'section_dir'} ne 'above'
                )
                && !$this->{'template'}->{'stat'}{'new_section'}
                && (   !defined $this->{'template'}->{'section_limit'}
                    || $this->{'template'}->{'section_limit'} eq ''
                    || @{ $this->{'template'}->{'stat'}{'section_order'} }
                    < $this->{'template'}->{'section_limit'} )
                && @{ $this->{'template'}->{'stat'}{'section_order'} } < 99
                )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'nextsection',
                    'required' => [ @setting::form, @setting::dateform ]
                );
                print
                    '<input type="submit" name="sect=new" value="新規 section 作成'
                    . $sect_dir
                    . '" /></form></li>';
            }

            print '<li>';
            print $this->form_start(
                'key'      => 'edit',
                'name'     => 'sectionselector',
                'required' => [ @setting::form, @setting::dateform ]
            );
            print '<select name="sect" onchange="submit()">';
            print '<option value="new">新規 section 作成'
                . $sect_dir
                . '</option>'
                if $this->{'template'}->{'section_dir'}
                && $this->{'template'}->{'section_dir'} eq 'above'
                && !$this->{'template'}->{'stat'}{'new_section'}
                && ( !defined $this->{'template'}->{'section_limit'}
                || $this->{'template'}->{'section_limit'} eq ''
                || @{ $this->{'template'}->{'stat'}{'section_order'} }
                < $this->{'template'}->{'section_limit'} );
            foreach my $sec (
                @{ $this->{'template'}->{'stat'}{'section_order'} } )
            {
                next if $sec eq '';
                print '<option value="'
                    . $sec . '"'
                    . (
                    ( $main::sect eq $sec ) ? ' selected="selected"' : '' )
                    . '>'
                    . $this->jfold(
                    $this->{'template'}->{'stat'}{'section_title'}{$sec},
                    24, 'I', 1 )
                    . '</option>';
            }
            print '<option value="new">新規 section 作成'
                . $sect_dir
                . '</option>'
                if ( !$this->{'template'}->{'section_dir'}
                || $this->{'template'}->{'section_dir'} ne 'above' )
                && !$this->{'template'}->{'stat'}{'new_section'}
                && ( !defined $this->{'template'}->{'section_limit'}
                || $this->{'template'}->{'section_limit'} eq ''
                || @{ $this->{'template'}->{'stat'}{'section_order'} }
                < $this->{'template'}->{'section_limit'} );
            print
                '</select><input type="submit" value="選択" /></form></li>';
            print '</ul>';
        }

    }
    else {
        push( @setting::form, 'chap' );
    }
    push( @setting::form, 'sect' );
    print '</div>';

    #移動フォーム
    if ( !$article::new ) {
        $this->{'template'}->print_subdivision_arrangement_form(
            $this->form_start(
                'key'    => 'edit',
                'name'   => 'subdivision_arrangement',
                'method' => 'post',
                'onsubmit' =>
                    'return cmonos.form.item(this).isNotSubmitted()',
                'required' => [ @setting::form, @setting::dateform ]
            )
        );
    }

    #記事タイトル
    print '<h1 id="editor-article-title">';
    print
        '<span style="color: #FFF; background-color: #f66">非公開</span> '
        if $main::pending;
    $article::title = $this->get_article_title( \$article )
        if !defined $article::title || $article::title eq '';
    if ( !defined $article::title || $article::title eq '' ) {
        if ( defined $default::date && $default::date ) {
            print $this->date( substr( $main::n, 0, 8 ),
                0, $setting::general{'datetype'} );
        }
        else {
            print $main::n;
        }
    }
    else {
        print $this->escape_except_html_entity($article::title);
    }
    if ( $main::p eq 'i' ) {
        print ' - ' . $setting::page{'edit'}{'infoLabel'};
    }
    elsif ( $setting::page{'edit'}{'mainLabel'} ) {
        print ' - '
            . ( ( $setting::page{'edit'}{'mainLabel'} )
            ? $setting::page{'edit'}{'mainLabel'} . ' '
            : '' )
            . $main::p
            . 'ページ目';
    }
    print '</h1>';

    #フォーム
    print $this->form_start(
        'key'    => 'edit',
        'name'   => 'input',
        'method' => 'post',
        'multi'  => (
            ( defined $cgi::enctype_multipart && $cgi::enctype_multipart )
            ? $cgi::enctype_multipart
            : 0
        ),
        'onsubmit' => 'return cmonos.form.item(this).isNotSubmitted()',
        'required' => [ @setting::form, @setting::dateform ]
    );
    print '<input type="hidden" name="a" value="r" />';
    print '<input type="hidden" name="w" value="1" />';
    print '<input type="hidden" name="new" value="1" />'
        if $article::new && $main::p eq 'i';

    print '<table class="field-table"><tbody>';
    if ( defined $this->{'template'}->{'stat'}{'chapter_title_enabled'}
        && $this->{'template'}->{'stat'}{'chapter_title_enabled'} )
    {
        print
            '<tr class="tbody-end"><td class="field-name"><label for="data:title">chapter タイトル</label></td>';
        print
            '<td class="field"><input type="text" size="50" name="data:title" id="data:title" value="'
            . $this->escape( $main::data{'title'} ) . '" />';
        print '</td></tr>';
        print '</tbody><tbody>';
    }
    my $cookie_enabled = 0;
    if ( @{ $this->{'template'}->{'stat'}{'field'} } ) {
        no warnings qw(numeric);
        foreach my $fid (
            sort {
                $this->{'field_obj'}{$a}->{'ORDER'}
                    <=> $this->{'field_obj'}{$b}->{'ORDER'}
                    || $a <=> $b
            } @{ $this->{'template'}->{'stat'}{'field'} }
            )
        {
            next unless ref $this->{'field_obj'}{$fid};
            $cookie_enabled = 1
                if $this->{'field_obj'}{$fid}->cookie_enabled
                && $this->{'field_obj'}{$fid}->{'cookie'};
            print $this->{'field_obj'}{$fid}->form(
                (   (   (   $main::p eq 'i'
                                && ( !ref $main::data{$fid}
                                || !%{ $main::data{$fid} } )
                        )
                            || $this->{'template'}->{'stat'}{'new_section'}
                    ) ? '' : 1
                ),
                '', $filedir
            );
        }
    }
    print '</tbody><tbody>';
    print '<tr class="tbody-start"><td class="submit-box" colspan="2">';

    print
        '<label title="おすすめインデックスにこの記事を追加します。"><input type="checkbox" name="recommend" value="1" />おすすめに追加</label> '
        if $template_has_recommendedindex;
    print
        '<label title="前回の更新時を保持します。"><input type="checkbox" id="keep_mtime_1" name="keep_mtime" value="1"'
        . ( ( $main::keep_mtime || $setting::general{'keepMtimeChecked'} )
        ? ' checked="checked"'
        : '' )
        . ' onclick="cmonos.form.checkboxSyncById(\'keep_mtime_2\',this.checked);" />前回更新時を保持</label> '
        if !$article::new
        && $setting::general{'keepMtimeEnabled'}
        && $this->{'template'}->{'stat'}{'mtime'}
        && !$this->{'template'}->{'stat'}{'new_section'};
    print
        '<label title="設定時IPからのみアクセス可能です。"><input type="checkbox" name="pending" value="1"'
        . (
        (   $main::pending
                || ( $article::new && $setting::general{'pendingChecked'} )
        ) ? ' checked="checked"' : ''
        )
        . ( ( $setting::general{'autoPublishingEnabled'} )
        ? ' onclick="cmonos.element.item(\'publishing-date\').disappear(!this.checked);"'
        : '' )
        . ' />非公開</label> ';
    print
        '<label title="同じ内容を入力することが多いいくつかの項目を記憶します。"><input type="checkbox" name="set_cookie" value="1"'
        . ( ( $cookie::read{$cookie::name} || $main::set_cookie )
        ? ' checked="checked"'
        : '' )
        . ' />情報を記憶する</label> '
        if defined $cookie_enabled && $cookie_enabled;
    print '<label><input type="checkbox" name="refresh" value="1"'
        . ( ($main::refresh) ? ' checked="checked"' : '' )
        . ' onclick="cmonos.form.field(this).checkboxConfirm(\'最新のテンプレートと旧テンプレートの間に互換性がない場合、データが失われたり表示が崩れることがあります。\\nそれでも最新のテンプレートを使いますか？\')" />最新のテンプレートを使う</label> '
        if $this->{'tool_master'} && !$article::new;
    print
        '<label title="RSSを更新します。"><input type="checkbox" name="feed_rss" value="1"'
        . ( ( $setting::general{'rssChecked'} ) ? ' checked="checked"' : '' )
        . ' />RSS更新</label> '
        if ( $setting::general{'RSSEnabled'}
        || $setting::general{'masterRSSEnabled'}
        || $setting::general{'siteRSSEnabled'} )
        && ( ( $main::p eq 'i' && $setting::general{'feedArticleRSS'} )
        || ( $main::p ne 'i' && $setting::general{'feedSectionRSS'} ) );
    print
        '<input type="submit" value="保存" class="save" /></td></tr></tbody></table>';

    #フォルダの移動
    if ( $setting::general{'autoPublishingEnabled'} ) {
        print '<fieldset id="publishing-date" class="risky">この記事を';

        if ( !%main::publish ) {
            if ($main::pending) {
                my $date = $this->read_file(
                    "$default::home/$main::n.pending/publish.dat", 1 );
                if ( $date && $date =~ /^([0-9]{4})([0-9]{2})([0-9]{2})/ ) {
                    (   $main::publish{'year'}, $main::publish{'mon'},
                        $main::publish{'mday'}
                    ) = ( $1 + 0, $2 + 0, $3 + 0 );
                }
            }
            elsif (
                $default::date
                && sprintf( "%.4d%.2d%.2d",
                    $main::year, $main::mon, $main::mday ) > $this->date_id
                )
            {
                (   $main::publish{'year'}, $main::publish{'mon'},
                    $main::publish{'mday'}
                ) = ( $main::year, $main::mon, $main::mday );
            }
        }

        #年
        print
            '<span class="date-selector"><label><select name="publish:year" id="publish:year">';
        print '<option value=""></option>';
        my $year = ( localtime(time) )[5] + 1900;
        foreach my $y ( $year .. ( $year + 5 ) ) {
            print '<option value="'
                . $y . '"'
                . ( ( $main::publish{'year'} && $main::publish{'year'} == $y )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $y
                . '</option>';
        }
        print '</select>年</label>';

        #月
        print '<label><select name="publish:mon" id="publish:mon">';
        print '<option value=""></option>';
        foreach my $mon ( 1 .. 12 ) {
            print '<option value="'
                . $mon . '"'
                . ( ( $main::publish{'mon'} && $main::publish{'mon'} == $mon )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $mon
                . '</option>';
        }
        print '</select>月</label>';

        #日
        print '<label><select name="publish:mday" id="publish:mday">';
        print '<option value=""></option>';
        foreach my $mday ( 1 .. 31 ) {
            print '<option value="'
                . $mday . '"'
                . (
                ( $main::publish{'mday'} && $main::publish{'mday'} == $mday )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $mday
                . '</option>';
        }
        print '</select>日</label>';
        print
            '<a href="javascript:void(0)" onclick="cmonos.tool.calendarPalette.open(\'publish:year\',\'publish:mon\',\'publish:mday\')" title="クリックするとカレンダーから日付を設定できます。"><img src="'
            . $env::image_dir
            . '/tool/calendar.gif" width="15" height="15" border="0" alt="カレンダーパネル" /></a>';

        print '</span> に公開する';
        print
            ' <input type="button" value="&laquo;リセット" onclick="cmonos.form.item(this.form).setDateFromDay(\'\',\'publish:year\',\'publish:mon\',\'publish:mday\');" />';
        print '</fieldset>';
        print $this->javascript(
            'cmonos.element.item(\'publishing-date\').disappear(true)')
            if !$main::pending
            && ( !$article::new || !$setting::general{'pendingChecked'} );
    }

    #フォルダの移動
    if ( !$article::new ) {
        print '<fieldset id="renamer" class="risky">この記事を';
        if ($default::date) {
            print
                '<span class="date-selector"><label><select name="new_year" id="new_year">';
            print '<option value=""></option>';
            my $ys
                = ( $setting::general{'yearStart'} > $main::year )
                ? $main::year
                : $setting::general{'yearStart'};
            foreach my $y ( $ys .. $setting::general{'yearEnd'} ) {
                print '<option value="' . $y . '">' . $y . '</option>';
            }
            print '</select>年</label>';

            #月
            print '<label><select name="new_mon" id="new_mon">';
            print '<option value=""></option>';
            foreach my $mon ( 1 .. 12 ) {
                print '<option value="' . $mon . '">' . $mon . '</option>';
            }
            print '</select>月</label>';

            #日
            print '<label><select name="new_mday" id="new_mday">';
            print '<option value=""></option>';
            foreach my $mday ( 1 .. 31 ) {
                print '<option value="' . $mday . '">' . $mday . '</option>';
            }
            print '</select>日</label>';
            print
                '<a href="javascript:void(0)" onclick="cmonos.tool.calendarPalette.open(\'new_year\',\'new_mon\',\'new_mday\')" title="クリックするとカレンダーから日付を設定できます。"><img src="'
                . $env::image_dir
                . '/tool/calendar.gif" width="15" height="15" border="0" alt="カレンダーパネル" /></a> に</span>';

            #名前管理
        }
        else {
            print
                '<input type="text" name="new_n" size="16" title="新しいフォルダ名を入力します。" onchange="cmonos.validate.field(this).asWord()" placeholder="フォルダ名" />に';
        }
        print '<select name="copy" id="copy">';
        print '<option value="1">コピー</option>';
        print '<option value="0">変更</option>';
        print '</select><input type="submit" value="する" />';
        print
            ' <input type="button" value="&laquo;リセット" onclick="cmonos.form.item(this.form).setDateFromDay(\'\',\'new_year\',\'new_mon\',\'new_mday\');" />'
            if $default::date;
        print '</fieldset>';
    }

    print '</form>';

    if ( !$article::new ) {
        my $archives_dir
            = $default::home . '/'
            . $main::n
            . ( ($main::pending) ? '.pending' : '' )
            . '/archives.pending';
        if ( !$setting::general{'rewindable'} ) {
            if ( -d $archives_dir ) {
                use File::Path;
                rmtree $archives_dir;
            }
        }
        elsif ( $this->is_secure('rewind') ) {
            if ( opendir( DIR, $archives_dir ) ) {
                my @dir
                    = sort { $this->sort_by( \$a, \$b, 'descend' ) }
                    grep( $_ !~ /[^0-9]/ && -d $archives_dir . '/' . $_,
                    readdir(DIR) );
                shift @dir;
                my $ip = $ENV{'REMOTE_HOST'}
                    || $this->to_host( $ENV{'REMOTE_ADDR'} );
                $this->write_file(
                    $archives_dir . '/.htaccess',
                    'Satisfy all' . "\x0A"
                        . 'order deny,allow' . "\x0A"
                        . 'deny from all' . "\x0A"
                        . 'allow from '
                        . $ip . "\x0A",
                    1
                );
                if (@dir) {
                    my $js = <<JAVASCRIPT;
cmonos.tool.openPreviewWindow = function () {
	var preview_enabled = document.getElementById('preview-enabled');
	if (preview_enabled && preview_enabled.checked) {
		var d = cmonos.form.field('rewind').getValue();
		if (d != '') window.open('$archives_dir/'+d+'/1.$default::ext');
	}
};
cmonos.tool.isRewindable = function () {
	if (cmonos.form.field('rewind').getValue() != "") {
		return confirm('この操作は取り消せません。本当に以前の状態に戻しますか？') && cmonos.form.item(this).isNotSubmitted();
	} else {
		alert('以前の記事を選択してください。');
		return false;
	}
};
JAVASCRIPT
                    print $this->javascript($js);
                    print $this->form_start(
                        'key'      => 'edit',
                        'id'       => 'rewind-form',
                        'name'     => 'rewind-form',
                        'method'   => 'post',
                        'onsubmit' => 'return cmonos.tool.isRewindable()',
                        'required' => [ @setting::form, @setting::dateform ]
                    );
                    print '<fieldset class="risky">';
                    print
                        '<select name="rewind" id="rewind" onchange="cmonos.tool.openPreviewWindow()">';
                    print '<option value="">▼以前の記事'
                        . ( ( $main::email || $this->is_secure('tools') )
                        ? ' [編集者]'
                        : '' )
                        . '</option>';
                    foreach my $d (@dir) {
                        my $user = '';
                        if ( $main::email || $this->is_secure('tools') ) {
                            my ( $ip, $ua, $email ) = split(
                                /\x0A/,
                                $this->read_file(
                                    $archives_dir . '/' . $d . '/data/author',
                                    1
                                )
                            );
                            if ($email
                                && ((      $main::email
                                        && $email eq $main::email
                                    )
                                    || $this->is_secure('tools')
                                )
                                )
                            {
                                $user = $cgi::Register->get_name_from_email(
                                    $email);
                                $user
                                    .= ($user) ? '<' . $email . '>' : $email;
                            }
                        }
                        print '<option value="'
                            . $d . '">'
                            . $this->date( $d, 3,
                            $setting::general{'datetype'} )
                            . (
                            ($user) ? ' [' . $this->escape($user) . ']' : '' )
                            . '</option>';
                    }
                    print '</select>';
                    print 'に<input type="submit" value="戻す" />';
                    print
                        ' <label><input type="checkbox" id="preview-enabled" onclick="cmonos.tool.openPreviewWindow()" />プレビュー</label>';
                    print '</fieldset>';
                    print '</form>';
                }
            }
        }

        my $rmoption = '';
        $rmoption .= '<option value="rmsection">この section を</option>'
            if ref $this->{'template'}->{'stat'}{'section_order'}
            && @{ $this->{'template'}->{'stat'}{'section_order'} } > 1
            && !$this->{'template'}->{'stat'}{'new_section'};
        $rmoption .= '<option value="rmchapter">この'
            . (
            (          ref $this->{'template'}->{'stat'}{'chapter_order'}
                    && @{ $this->{'template'}->{'stat'}{'chapter_order'} } > 1
                    && !$this->{'template'}->{'stat'}{'new_chapter'}
            ) ? ' chapter '
            : ( $setting::page{'edit'}{'mainLabel'} )
            ? $setting::page{'edit'}{'mainLabel'}
            : '本文'
            )
            . 'を</option>'
            if ref $this->{'template'}->{'stat'}{'chapter_order'}
            && @{ $this->{'template'}->{'stat'}{'chapter_order'} }
            && !$this->{'template'}->{'stat'}{'new_chapter'};
        $rmoption .= '<option value="rmpage">このページを</option>'
            if @page::list > 1
            && $main::p
            && $main::p ne 'i'
            && $main::p >= @page::list
            && !$page::new;
        if ( $this->is_secure( 'delete', 0, 'edit' ) ) {
            $rmoption .= '<option value=""></option>';
            $rmoption .= '<option value="n">この記事を</option>';
        }
        if ($rmoption) {
            print $this->form_start(
                'key'      => 'edit',
                'name'     => 'delete',
                'method'   => 'post',
                'required' => [ @setting::form, @setting::dateform ]
            );
            print '<input type="hidden" name="a" value="r" />';
            print '<fieldset id="delete-menu" class="risky">';
            print
                '<label title="前回の更新時を保持します。"><input type="checkbox" id="keep_mtime_2" name="keep_mtime" value="1"'
                . (
                (   $main::keep_mtime || $setting::general{'keepMtimeChecked'}
                ) ? ' checked="checked"' : ''
                )
                . ' onclick="cmonos.form.checkboxSyncById(\'keep_mtime_1\',this.checked)" />前回更新時を保持</label> '
                if !$article::new
                && $setting::general{'keepMtimeEnabled'}
                && $this->{'template'}->{'stat'}{'mtime'}
                && !$this->{'template'}->{'stat'}{'new_section'};
            print ' <select name="delete">';
            print '<option value=""></option>';
            print $rmoption;
            print
                '</select><input type="submit" value="削除する" onclick="return confirm(\'この操作は取り消せません。本当に削除しますか？\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();" /></fieldset></form>';
        }
    }

    #ページフッタ
    $this->print_page_footer('edit');
}

sub article_path_replace ($$$$$) {
    my ( $this, $dir, $from, $to, $table ) = @_;
    my ( @files, @directories );
    local (*DIR);
    return unless opendir( DIR, $dir );
    while ( my $entry = readdir(DIR) ) {
        next if $entry =~ /^\./;
        my $path = $dir . '/' . $entry;
        if ( -f $path ) {
            push( @files, $path )
                if $entry =~ /^[0-9]+\.s?html$/ || $entry eq 'waypoints.kml';
        }
        elsif ( -d $path ) {
            push( @directories, $path );
        }
    }
    closedir(DIR);
    if (@files) {
        foreach my $path (@files) {
            my $article = $this->read_file( $path, 1 );
            my $is_changed = 0;
            $is_changed = 1
                if $article
                =~ s/<!--#include virtual="\Q$from\E([^">]*)"-->/<!--#include virtual="$to$1"-->/sg;
            if ( ref $table ) {
                for ( my $i = 0; $i < @$table; $i += 2 ) {
                    $is_changed = 1
                        if $article =~ s/\Q$table->[$i]\E/$table->[$i+1]/gs;
                }
            }
            $this->write_file( $path, \$article, 1 ) if $is_changed;
        }
    }
    if (@directories) {
        foreach my $path (@directories) {
            $this->article_path_replace( $path, $from, $to, $table );
        }
    }
}

sub template_has_recommendedindex ($) {
    my $this = shift;
    return (
        (          $setting::page{'index'}{'template'}
                && $setting::page{'index'}{'template'}
                =~ /<!--recommendedindex[^>]*-->/is
        )
            || ( $setting::page{'template'}
            && $setting::page{'template'}
            =~ /<!--recommendedindex[^>]*-->/is )
            || ( $setting::page{'history'}{'template'}
            && $setting::page{'history'}{'template'}
            =~ /<!--recommendedindex[^>]*-->/is )
            || ( $setting::indexpage{'masterindex'}{'template'}
            && $setting::indexpage{'masterindex'}{'template'}
            =~ /<!--recommendedindex[^>]*-->/is )
            || ( $setting::indexpage{'metanavi'}{'template'}
            && $setting::indexpage{'metanavi'}{'template'}
            =~ /<!--recommendedindex[^>]*-->/is )
            || ( $default::external_index
            && !$setting::general{'externalIndexDisabled'}
            && -f $default::external_index
            && $this->read_file( $default::external_index, 1 )
            =~ /<!--recommendedindex[^>]*-->/is )
            || ( $default::external_navi
            && !$setting::general{'externalNaviDisabled'}
            && -f $default::external_navi
            && $this->read_file( $default::external_navi, 1 )
            =~ /<!--recommendedindex[^>]*-->/is )
            || ( $default::external_navi2
            && !$setting::general{'externalNavi2Disabled'}
            && -f $default::external_navi2
            && $this->read_file( $default::external_navi2, 1 )
            =~ /<!--recommendedindex[^>]*-->/is )
    ) ? 1 : 0;
}

sub field_settle_up ($$) {
    my ( $this, $filedir ) = @_;
    if ( @{ $this->{'template'}->{'stat'}{'field'} } ) {
        no warnings qw(numeric);
        foreach my $fid (
            sort {
                $this->{'field_obj'}{$a}->{'ORDER'}
                    <=> $this->{'field_obj'}{$b}->{'ORDER'}
            } @{ $this->{'template'}->{'stat'}{'field'} }
            )
        {
            $this->{'field_obj'}{$fid}->settle_up($filedir)
                if ref $this->{'field_obj'}{$fid};
        }
    }
}

sub page_info_update ($$$;$) {
    my ( $this, $dir, $filedir, $article_template ) = @_;
    unshift( @page::list, '1' ) if !@page::list;
    $article::title = $this->detag_text(
        $this->{'field_obj'}{ $this->{'field_for'}{'title'} }
            ->data_only->usual_format(
            $main::data{ $this->{'field_for'}{'title'} }{'str'}
            )
        )
        if defined $this->{'field_for'}{'title'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'title'} }
        && defined $main::data{ $this->{'field_for'}{'title'} }{'str'}
        && $main::data{ $this->{'field_for'}{'title'} }{'str'} ne '';
    $article::title
        = ($default::date)
        ? $this->date( substr( $main::n, 0, 8 ),
        0, $setting::general{'datetype'} )
        : $main::n
        if !defined $article::title || $article::title eq '';
    $article::description = $this->detag_text(
        $this->{'field_obj'}{ $this->{'field_for'}{'description'} }
            ->data_only->usual_format(
            $main::data{ $this->{'field_for'}{'description'} }{'str'}
            )
        )
        if defined $this->{'field_for'}{'description'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'description'} }
        && defined $main::data{ $this->{'field_for'}{'description'} }{'str'}
        && $main::data{ $this->{'field_for'}{'description'} }{'str'} ne '';
    $article_template = $this->mk_article_template_obj
        if !ref $article_template
        && ( ( $article::new && !$setting::general{'skip'} )
        || ( $this->{'tool_master'} && $main::refresh ) );
    $this->save_og_data_from_field($filedir);
    foreach my $p (@page::list) {
        local $cgi::output
            = $default::home . '/' . $dir . '/' . $p . '.' . $default::ext;
        local $cgi::output_option = '';
        $this->set_og_cgi_summary;
        my $article = $this->read_html_file( "$default::home/$dir", $p );
        if ( ref $article_template ) {
            my ($new_template);
            {
                local $main::p = $p;
                $article_template->{'link_id'}
                    = 'a'
                    . ( ( !defined $main::p || $main::p eq '' )
                    ? '01'
                    : sprintf( "%.2d", $main::p ) );
                $new_template
                    = $article_template->refresh( \$article, '',
                    $default::home . '/' . $dir . '/' . $main::p,
                    'detail', '', '', '', '', $main::c, $main::n );
            }
            if ($article::new) {
                $article = $new_template;
            }
            else {
                $article = $this->{'template'}->refresh(
                    \$article, \$new_template, $filedir, 'detail',
                    '',        '',             '',       '',
                    $main::c,  $main::n
                );
                $this->{'template'}->scan( \$article );
            }
        }
        $this->set_og_data;
        $this->write_html_file(
            $cgi::output,
            $this->tag_replace(
                $this->{'template'}->replace(
                    $article, \%main::data, 'detail', $filedir,
                    ( ( defined $main::c ) ? $main::c : '' ), $main::n
                ),
                \$article::title,
                \$article::description,
                $p,
                $cgi::output,
                $cgi::output_option,
                $main::pending
            ),
            1,
            'article',
            0,
            $article::title,
            $article::description,
            (   ( @page::list > 1 )
                ? ' (' . $p . '/' . ( scalar @page::list ) . ')'
                : ''
            ),
            $this->article_id($main::n)
        );
    }
    $this->clear_og_data;

    #RSS更新
    if (  !$main::pending
        && $main::feed_rss
        && $setting::general{'feedArticleRSS'}
        && (   $setting::general{'RSSEnabled'}
            || $setting::general{'masterRSSEnabled'}
            || $setting::general{'siteRSSEnabled'} )
        )
    {
        $this->feed_article_rss(
            $this->full_path($default::home) . '/'
                . $main::n . '/1.'
                . $default::ext,
            $filedir,
            (   (   $this->is_available_field(
                        $this->{'field_for'}{'author'}
                    )
                )
                ? $this->{'field_obj'}{ $this->{'field_for'}{'author'} }
                    ->restore->format_for_text(
                    $main::data{ $this->{'field_for'}{'author'} }{'str'},
                    $filedir, $main::c, $main::n )
                : ( !$this->{'field_for'}{'author'}
                        && defined $setting::general{'mastername'} )
                ? $setting::general{'mastername'}
                : ''
            )
        );
    }
}

sub section_update ($$$$$;$$) {
    my ( $this, $path, $article, $dir, $filedir, $info_template, $keep_title )
        = @_;
    local $cgi::output        = $path;
    local $cgi::output_option = '';
    if ( !$keep_title ) {
        $article::title       = $this->get_article_title( \$article );
        $article::description = $this->get_article_description( \$article );
    }
    if (   ref $info_template
        || ( $article::new && $setting::general{'skip'} )
        || ( $this->{'tool_master'} && $main::refresh ) )
    {
        my ($new_template);
        {
            local $main::p = 'i';
            if ( !ref $info_template ) {
                $this->use_field( 'info',
                    $default::field_pref_dir . '/infofield',
                    2, 0, $setting::field_tag_enabled, 'info' )
                    if !%info::obj;
                $info_template = $this->mk_info_template_obj;
                $this->save_og_data_from_article( \$article,
                    $default::home . '/' . $dir . '/i',
                    $info_template, \%info::obj, \%info::for );
            }
            $new_template
                = $info_template->refresh( \$article, '',
                $default::home . '/' . $dir . '/i',
                'detail', '', '', '', '', $main::c, $main::n );
        }
        if ( !defined $article || $article eq '' || $article::new ) {
            $article = $new_template;
        }
        else {
            $article
                = $this->{'template'}->refresh( \$article, \$new_template,
                $default::home . '/' . $dir . '/' . $main::p,
                'detail', '', '', '', '', $main::c, $main::n );
            $this->{'template'}
                ->scan( \$article, \$main::chap, \$main::sect );
        }
    }
    else {
        $this->save_og_data_from_article( \$article );
    }
    my $creator = $this->article_creator( \$article );
    $this->set_og_data;
    $this->write_html_file(
        $cgi::output,
        $this->tag_replace(
            $this->{'template'}->replace(
                $main::chap, $main::sect, $article, \%main::data,
                'detail',    $filedir,    $main::c, $main::n
            ),
            \$article::title,
            \$article::description,
            $main::p,
            $cgi::output,
            $cgi::output_option,
            $main::pending
        ),
        1,
        'article',
        0,
        $article::title,
        $article::description,
        (   ( @page::list > 1 )
            ? ' (' . $main::p . '/' . ( scalar @page::list ) . ')'
            : ''
        ),
        $this->article_id($main::n)
    );
    $this->clear_og_data;

    #link情報の更新
    if ($page::new) {
        my $last_page = './' . $main::p . '.' . $default::ext;
        foreach my $p (@page::list) {
            last if $p == $main::p;
            my $path = $this->fileglob( "$default::home/$dir",
                '^' . $p . '\.(html|htm|shtml|stml|shtm|stm)$', 'f' );
            my $temp = $this->read_html_file($path);
            $this->page_navi_replace( \$temp, $p,
                $this->get_article_title( \$temp ), $path );
            $this->replace_link_rel(
                \$temp,
                {   'last' => {
                        'href'  => $last_page,
                        'title' => (
                            ($default::english)
                            ? 'Last Page'
                            : '最後のページ'
                        )
                    }
                }
            );
            $this->write_html_file( $path, $temp, 1, 'article' );
        }
    }

    push( @{ $this->{'template'}->{'stat'}{'chapter_order'} }, $main::chap )
        unless grep( $_ eq $main::chap,
        @{ $this->{'template'}->{'stat'}{'chapter_order'} } );
    push( @{ $this->{'template'}->{'stat'}{'section_order'} }, $main::sect )
        unless grep( $_ eq $main::sect,
        @{ $this->{'template'}->{'stat'}{'section_order'} } );
    $this->{'template'}->{'stat'}{'new_chapter'}
        = $this->{'template'}->{'stat'}{'new_section'} = 0;

    #RSS更新
    if (  !$main::pending
        && $main::feed_rss
        && $setting::general{'feedSectionRSS'}
        && (   $setting::general{'RSSEnabled'}
            || $setting::general{'masterRSSEnabled'}
            || $setting::general{'siteRSSEnabled'} )
        )
    {
        if ((   !$setting::general{'sectionRSStitleRequired'}
                || ( $this->{'field_for'}{'title'}
                    && ref $this->{'field_obj'}
                    { $this->{'field_for'}{'title'} }
                    && $main::data{ $this->{'field_for'}{'title'} }{'str'} )
            )
            )
        {
            $this->feed_article_rss(
                $this->full_path($default::home) . '/'
                    . $main::n . '/'
                    . $main::p . '.'
                    . $default::ext . '#a'
                    . sprintf( "%.2d", $main::p )
                    . sprintf( "%.2d", $main::chap )
                    . sprintf( "%.2d", $main::sect ),
                $filedir, $creator
            );
        }
        else {
            $this->delete_article_rss( $this->full_path($default::home) . '/'
                    . $main::n . '/'
                    . $main::p . '.'
                    . $default::ext . '#a'
                    . sprintf( "%.2d", $main::p )
                    . sprintf( "%.2d", $main::chap )
                    . sprintf( "%.2d", $main::sect ) );
        }
    }
}

sub article_creator ($$) {
    my ( $this, $article_ref ) = @_;
    $this->use_field( 'info', $default::field_pref_dir . '/infofield',
        2, 0, $setting::field_tag_enabled, 'info' )
        if !%info::obj;
    if ( $info::for{'author'} ) {
        my $id = $info::for{'author'};
        if ( $$article_ref
            =~ /<!--info(?!\w)[^<>]*\s+id="$id"[^<>]*-->(.*?)<!--\/info-->/s )
        {
            my $data = $1;
            if ( $data
                =~ /<!--data(?!\w)[^<>]*\s+name="str"([^<>]*)-->(.*?)<!--\/data-->/s
                )
            {
                my $value   = $1;
                my $content = $2;
                return ( $value =~ /\svalue="(.*?)"/s )
                    ? $this->unescape($1)
                    : $content;
            }
        }
    }
    return '';
}

sub save_og_data_from_article ($$;$$$$) {
    my ( $this, $article_ref, $filedir, $template, $field, $field_for ) = @_;
    $this->{'og'} = {};
    $this->{'og'}{'title'}
        = $this->get_metadata_by_name( $article_ref, 'og:title' )
        || $this->get_metadata_by_name( $article_ref, 'title' )
        || $article::title;
    $this->{'og'}{'description'}
        = $this->get_metadata_by_name( $article_ref, 'og:description' )
        || $this->get_metadata_by_name( $article_ref, 'description' )
        || $article::description;
    $this->{'og'}{'image'}
        = $this->get_metadata_by_name( $article_ref, 'og:image' );
    if (  !ref $template
        && ref $this->{'template'}
        && $this->{'template'}->{'field_tag_name'} eq 'info' )
    {
        $template  = $this->{'template'};
        $field     = $this->{'field_obj'};
        $field_for = $this->{'field_for'};
    }
    if ( !$this->{'og'}{'image'} && $filedir && ref $template ) {
        if (  !$this->{'og'}{'image'}
            && $field_for->{'media'}
            && ref $field->{ $field_for->{'media'} }
            && $$article_ref
            =~ /<!--info(?![a-z])[^>]*id="$field_for->{'media'}"[^>]*-->(.*?)<!--\/info-->/s
            )
        {
            my $field_data = $1;
            $this->{'og'}{'image'}
                = $field->{ $field_for->{'media'} }->image_file_url(
                {   $template->tag_to_data(
                        \$field_data, $field->{ $field_for->{'media'} }
                    )
                },
                $filedir
                );
        }
        if (  !$this->{'og'}{'image'}
            && $field_for->{'media2'}
            && ref $field->{ $field_for->{'media2'} }
            && $$article_ref
            =~ /<!--info(?![a-z])[^>]*id="$field_for->{'media2'}"[^>]*-->(.*?)<!--\/info-->/s
            )
        {
            my $field_data = $1;
            $this->{'og'}{'image'}
                = $field->{ $field_for->{'media2'} }->image_file_url(
                {   $template->tag_to_data(
                        \$field_data, $field->{ $field_for->{'media2'} }
                    )
                },
                $filedir
                );
        }
        if (  !$this->{'og'}{'image'}
            && $field_for->{'media3'}
            && ref $field->{ $field_for->{'media3'} }
            && $$article_ref
            =~ /<!--info(?![a-z])[^>]*id="$field_for->{'media3'}"[^>]*-->(.*?)<!--\/info-->/s
            )
        {
            my $field_data = $1;
            $this->{'og'}{'image'}
                = $field->{ $field_for->{'media3'} }->image_file_url(
                {   $template->tag_to_data(
                        \$field_data, $field->{ $field_for->{'media3'} }
                    )
                },
                $filedir
                );
        }
    }
    $this->{'og'}{'latlng'} = [ $this->get_og_latlng($article_ref) ];
    if (  !$this->{'og'}{'latlng'}[0]
        && $filedir
        && ref $field_for
        && $field_for->{'coordinates'}
        && ref $field->{ $field_for->{'coordinates'} } )
    {
        if ( $$article_ref
            =~ /<!--info(?![a-z])[^>]*id="$field_for->{'coordinates'}"[^>]*-->(.*?)<!--\/info-->/s
            )
        {
            my $data = $1;
            if ( $data =~ /<!--data name="enabled" value="1"--><!--\/data-->/s
                && $data
                =~ /<!--data name="c" value="(\-?[0-9\.]+),(\-?[0-9\.]+)"--><!--\/data-->/s
                )
            {
                $this->{'og'}{'latlng'} = [ $1, $2 ];
            }
        }
    }
}

sub save_og_data_from_field ($) {
    my ( $this, $filedir ) = @_;
    $this->{'og'}                = {};
    $this->{'og'}{'title'}       = $article::title;
    $this->{'og'}{'description'} = $article::description;
    if (   $this->{'field_for'}{'media'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'media'} }
        && ref $main::data{ $this->{'field_for'}{'media'} }
        && $main::data{ $this->{'field_for'}{'media'} }{'str'} )
    {
        $this->{'og'}{'image'}
            = $this->{'field_obj'}{ $this->{'field_for'}{'media'} }
            ->image_file_url(
            $main::data{ $this->{'field_for'}{'media'} }{'str'}, $filedir );
    }
    if (  !$this->{'og'}{'image'}
        && $this->{'field_for'}{'media2'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'media2'} }
        && ref $main::data{ $this->{'field_for'}{'media2'} }
        && $main::data{ $this->{'field_for'}{'media2'} }{'str'} )
    {
        $this->{'og'}{'image'}
            = $this->{'field_obj'}{ $this->{'field_for'}{'media2'} }
            ->image_file_url(
            $main::data{ $this->{'field_for'}{'media2'} }{'str'}, $filedir );
    }
    if (  !$this->{'og'}{'image'}
        && $this->{'field_for'}{'media3'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'media3'} }
        && ref $main::data{ $this->{'field_for'}{'media3'} }
        && $main::data{ $this->{'field_for'}{'media3'} }{'str'} )
    {
        $this->{'og'}{'image'}
            = $this->{'field_obj'}{ $this->{'field_for'}{'media3'} }
            ->image_file_url(
            $main::data{ $this->{'field_for'}{'media3'} }{'str'}, $filedir );
    }
    $this->{'og'}{'latlng'}
        = (    $this->{'field_for'}{'coordinates'}
            && ref $this->{'field_obj'}{ $this->{'field_for'}{'coordinates'} }
            && ref $main::data{ $this->{'field_for'}{'coordinates'} }
            && $main::data{ $this->{'field_for'}{'coordinates'} }{'str'} )
        ? [
        $this->{'field_obj'}{ $this->{'field_for'}{'coordinates'} }
            ->get_latlng(
            $main::data{ $this->{'field_for'}{'coordinates'} }{'str'},
            $filedir
            )
        ]
        : [ '', '' ];
}

sub set_og_data ($$) {
    my ( $this, $article_ref ) = @_;
    $this->set_og_cgi_summary(1);
    $this->set_og_title( $this->{'og'}{'title'} ) if $this->{'og'}{'title'};
    $this->set_description( $this->{'og'}{'description'} )
        if $this->{'og'}{'description'};
    $this->set_og_image( $this->{'og'}{'image'} ) if $this->{'og'}{'image'};
    $this->set_og_latlng( @{ $this->{'og'}{'latlng'} } );
}

sub clear_og_data ($$) {
    my ( $this, $article_ref ) = @_;
    delete $this->{'og'};
}

######################################################################
# インデックスリフレッシュ
sub index_refresh ($$$;$$) {
    my ( $this, $template_obj, $data, $chapter_id, $section_id ) = @_;
    local ( %main::data, $main::chap, $main::sect, $this->{'template'} );
    $this->{'template'} = $template_obj;
    %main::data         = %$data;
    $main::chap         = $chapter_id;
    $main::sect         = $section_id;
    $this->index_replace_multi;
}

sub waypoints_refresh ($$$;$$) {
    my ( $this, $template_obj, $data, $chapter_id, $section_id ) = @_;
    local ( %main::data, $main::chap, $main::sect, $this->{'template'} );
    $this->{'template'} = $template_obj;
    %main::data         = %$data;
    $main::chap         = $chapter_id;
    $main::sect         = $section_id;
    $this->waypoints_replace;
}

sub index_and_rss_refresh ($$$;$$$) {
    my ( $this, $template_obj, $data, $chapter_id, $section_id, $file_dir )
        = @_;
    local ( %main::data, $main::chap, $main::sect, $this->{'template'} );
    $this->{'template'} = $template_obj;
    %main::data         = %$data;
    $main::chap         = $chapter_id;
    $main::sect         = $section_id;
    $this->index_replace_multi;
    if ($setting::general{'rssChecked'}
        && (   $setting::general{'RSSEnabled'}
            || $setting::general{'masterRSSEnabled'}
            || $setting::general{'siteRSSEnabled'} )
        )
    {

        if ( $this->{'template'}->{'field_tag_name'} eq 'info' ) {
            $article::creator = (
                (   $this->is_available_field(
                        $this->{'field_for'}{'author'}
                    )
                )
                ? $this->{'field_obj'}{ $this->{'field_for'}{'author'} }
                    ->restore->format_for_text(
                    $main::data{ $this->{'field_for'}{'author'} }{'str'},
                    $file_dir, $main::c, $main::n )
                : ( !$this->{'field_for'}{'author'}
                        && defined $setting::general{'mastername'} )
                ? $setting::general{'mastername'}
                : ''
            );
            if ( $setting::general{'feedArticleRSS'} ) {
                $this->feed_article_rss(
                    $this->full_path($default::home) . '/'
                        . $main::n . '/1.'
                        . $default::ext,
                    $file_dir, $article::creator
                );
            }
        }
        else {
            if ( $setting::general{'feedSectionRSS'} ) {
                if ((   !$setting::general{'sectionRSStitleRequired'}
                        || ( $this->{'field_for'}{'title'}
                            && ref $this->{'field_obj'}
                            { $this->{'field_for'}{'title'} }
                            && $main::data{ $this->{'field_for'}{'title'} }
                            {'str'} )
                    )
                    )
                {
                    $this->feed_article_rss(
                        $this->full_path($default::home) . '/'
                            . $main::n . '/'
                            . $main::p . '.'
                            . $default::ext . '#a'
                            . sprintf( "%.2d", $main::p )
                            . sprintf( "%.2d", $main::chap )
                            . sprintf( "%.2d", $main::sect ),
                        $file_dir, $article::creator
                    );
                }
                else {
                    $this->delete_article_rss(
                              $this->full_path($default::home) . '/'
                            . $main::n . '/'
                            . $main::p . '.'
                            . $default::ext . '#a'
                            . sprintf( "%.2d", $main::p )
                            . sprintf( "%.2d", $main::chap )
                            . sprintf( "%.2d", $main::sect ) );
                }
            }
        }
    }
}

######################################################################
#更新を保存
sub save_this_version ($) {
    my $this = shift;
    if ( $setting::general{'rewindable'} ) {
        my $article_dir
            = $default::home . '/'
            . $main::n
            . ( ($main::pending) ? '.pending' : '' );
        my $archives_dir = $article_dir . '/archives.pending';
        if ( $this->set_dir($archives_dir) ) {
            my $ver         = $this->time_id;
            my $current_dir = $archives_dir . '/' . $ver;
            $this->write_file(
                $archives_dir . '/.htaccess',
                'Satisfy all' . "\x0A"
                    . 'order deny,allow' . "\x0A"
                    . 'deny from all' . "\x0A",
                1
            );
            rmtree $current_dir if -d $current_dir;
            if ( $this->set_dir($current_dir) ) {
                $this->article_directory_copy( $article_dir, $current_dir, 1,
                    $ver );
                if ( $this->set_dir( $current_dir . '/data' ) ) {
                    $this->write_file(
                        $current_dir . '/data/.htaccess',
                        'Satisfy all' . "\x0A"
                            . 'order deny,allow' . "\x0A"
                            . 'deny from all' . "\x0A",
                        1
                    );
                    $this->write_file(
                        $current_dir . '/data/author',
                        (          $ENV{'REMOTE_HOST'}
                                || $this->to_host( $ENV{'REMOTE_ADDR'} )
                            )
                            . "\x0A"
                            . $ENV{'HTTP_USER_AGENT'} . "\x0A"
                            . ( ($main::email) ? $main::email : '' ),
                        1
                    );
                }
            }
            if ( opendir( DIR, $archives_dir ) ) {
                my @dir
                    = sort { $this->sort_by( \$a, \$b, 'descend' ) }
                    grep( $_ !~ /^\./ && -d $archives_dir . '/' . $_,
                    readdir(DIR) );
                closedir(DIR);
                if ( ( $setting::general{'rewindable'} + 1 ) < @dir ) {
                    foreach my $n ( ( $setting::general{'rewindable'} + 1 )
                        .. ( @dir - 1 ) )
                    {
                        rmtree $archives_dir . '/' . $dir[$n];
                    }
                }
            }
        }
    }
}

# ディレクトリをコピー
sub article_directory_copy ($$$;$$) {
    my ( $this, $dir, $clone, $top, $info ) = @_;
    my ( @files, @directories );
    local (*DIR);
    return unless $this->set_dir($clone) && opendir( DIR, $dir );
    while ( my $entry = readdir(DIR) ) {
        my $path = $dir . '/' . $entry;
        next
            if $entry =~ /^\./
            || $entry eq 'archives.pending'
            || $entry eq 'author'
            || $entry eq 'data';
        if ( -f $path ) {
            push( @files, $entry );
        }
        elsif ( -d $path ) {
            push( @directories, $entry );
        }
    }
    closedir(DIR);
    if (@files) {
        my @clone_files;
        if ( opendir( DIR, $clone ) ) {
            @clone_files
                = grep( $_ !~ /^\./ && $_ ne 'author' && -f $clone . '/' . $_,
                readdir(DIR) );
            closedir(DIR);
        }
        foreach my $f (@files) {
            if ( $top && $f =~ /\.s?html?$/i ) {
                $this->article_copy( $dir, $clone, $f, $info );
            }
            elsif ( $f eq 'waypoints.kml' ) {
                $this->waypoints_copy( $dir, $clone, $f );
            }
            elsif ($f !~ /\.(?:ssi|js|dat)$/
                || $f =~ /^[0-9]+\.[0-9a-zA-Z_]+\.[0-9a-zA-Z_]+\.dat$/
                || !-f $clone . '/' . $f )
            {
                $this->file_copy( $dir . '/' . $f, $clone . '/' . $f );
            }
            @clone_files = grep( $_ ne $f, @clone_files );
        }
        if (@clone_files) {
            foreach my $f (@clone_files) {
                unlink $clone . '/' . $f;
            }
        }
    }
    if (@directories) {
        my @clone_directories;
        if ( opendir( DIR, $clone ) ) {
            @clone_directories
                = grep( $_ !~ /^\./
                    && $_ ne 'archives.pending'
                    && $_ ne 'data'
                    && -d $clone . '/' . $_,
                readdir(DIR) );
            closedir(DIR);
        }
        foreach my $d (@directories) {
            $this->article_directory_copy( $dir . '/' . $d,
                $clone . '/' . $d );
            @clone_directories = grep( $_ ne $d, @clone_directories );
        }
        if (@clone_directories) {
            foreach my $d (@clone_directories) {
                rmtree $clone . '/' . $d;
            }
        }
    }
}

sub article_copy ($$$$;$) {
    my ( $this, $source, $copy, $name, $info ) = @_;
    my $data = $this->read_file( $source . '/' . $name, 1 );
    $data = Taketori->new( { 'css' => 1 } )->tategaki_to_text($data) if $data;

    my $here        = $ENV{'SCRIPT_NAME'};
    my $source_path = $this->path_change( $source, $here, 'abs' );
    my $copy_path   = $this->path_change( $copy, $here, 'abs' );

    $data
        =~ s/(<[^<>]*[\x09\x0A\x0C\x0D\x20]+(?:href|src|background|action)=["']?)$source_path([^<>]*>)/$1$copy_path$2/sig;
    $data
        =~ s/(<param[\x09\x0A\x0C\x0D\x20]+name=["']?(?:src|movie)["']?[\x09\x0A\x0C\x0D\x20]+value=["']?)$source_path([^<>]*>)/$1$copy_path$2/sig;
    $data
        =~ s/(<video(?![0-9a-zA-Z_])[^<>]*[\x09\x0A\x0C\x0D\x20]+preview=["']?)$source_path([^<>]*>)/$1$copy_path$2/sig;
    $data
        =~ s/<!--#include virtual="\Q$source_path\E\/([^">]*)\.ssi"-->/<script type="text\/javascript" language="JavaScript" src=".\/$1.js"><\/script>/sg;

#$data =~ s/<!--#include virtual="\Q$source_path\E\/([^">]*)"-->/<!--#include virtual="$copy_path\/$1"-->/sg;
    if ( $copy =~ /^\Q$source\E/ ) {
        $data
            =~ s/(<[^<>]*[\x09\x0A\x0C\x0D\x20]+(?:href|src|background|action)=["']?)(\.\.\/[^<>]*>)/$1..\/..\/$2/sig;
        $data
            =~ s/(<param[\x09\x0A\x0C\x0D\x20]+name=["']?(?:src|movie)["']?[\x09\x0A\x0C\x0D\x20]+value=["']?)(\.\.\/[^<>]*>)/$1..\/..\/$2/sig;
        $data
            =~ s/(<video(?![0-9a-zA-Z_])[^<>]*[\x09\x0A\x0C\x0D\x20]+preview=["']?)(\.\.\/[^<>]*>)/$1..\/..\/$2/sig;
    }
    else {
        $data
            =~ s/(<[^<>]*[\x09\x0A\x0C\x0D\x20]+(?:href|src|background|action)=["']?)\.\.\/\.\.\/([^<>]*>)/$1$2/sig;
        $data
            =~ s/(<param[\x09\x0A\x0C\x0D\x20]+name=["']?(?:src|movie)["']?[\x09\x0A\x0C\x0D\x20]+value=["']?)\.\.\/\.\.\/([^<>]*>)/$1$2/sig;
        $data
            =~ s/(<video(?![0-9a-zA-Z_])[^<>]*[\x09\x0A\x0C\x0D\x20]+preview=["']?)\.\.\/\.\.\/([^<>]*>)/$1$2/sig;
    }

    my $source_url         = $this->full_path($source_path);
    my $copy_url           = $this->full_path($copy_path);
    my $source_url_encoded = $this->url_encode($source_url);
    my $copy_url_encoded   = $this->url_encode($copy_url);
    $data =~ s/\Q$source_url\E/$copy_url/g;
    $data =~ s/\Q$source_url_encoded\E/$copy_url_encoded/g;

    my $source_fla_encoded = $this->url_encode(
        $this->base_change( $source, $env::javascript . '/player' ) );
    my $copy_fla_encoded = $this->url_encode(
        $this->base_change( $copy, $env::javascript . '/player' ) );
    $data =~ s/\Q$source_fla_encoded\E/$copy_fla_encoded/sg;

    if ($info) {
        $info
            = '<div id="cms-rollback-information"><strong>【'
            . $this->date( $info, 3, $setting::general{'datetype'} )
            . '版】</strong></div>';
        $data =~ s/(<body(?![0-9a-zA-Z_])[^>]*>)/$1$info/si;
    }
    else {
        $data =~ s/<div id="cms-rollback-information">.*?<\/div>//si;
    }

    $data = Taketori->new( { 'css' => 1 } )->text_to_tategaki( $data, 1 )
        if $data;
    return $this->write_file( $copy . '/' . $name, \$data, 1 );
}

sub waypoints_copy ($$$$) {
    my ( $this, $source, $copy, $name ) = @_;
    my $data = $this->read_file( $source . '/' . $name, 1 );

    my $here        = $ENV{'SCRIPT_NAME'};
    my $source_path = $this->path_change( $source, $here, 'abs' );
    my $copy_path   = $this->path_change( $copy, $here, 'abs' );
    $source_path =~ s!/i$!!;
    $copy_path =~ s!/i$!!;

    $data
        =~ s/(<[^<>]*[\x09\x0A\x0C\x0D\x20]+(?:href|src|background|action)=["']?)$source_path([^<>]*>)/$1$copy_path$2/sig;

    my $source_url         = $this->full_path($source_path);
    my $copy_url           = $this->full_path($copy_path);
    my $source_url_encoded = $this->url_encode($source_url);
    my $copy_url_encoded   = $this->url_encode($copy_url);
    $data =~ s/\Q$source_url\E/$copy_url/g;
    $data =~ s/\Q$source_url_encoded\E/$copy_url_encoded/g;

    my $source_fla_encoded = $this->url_encode(
        $this->base_change( $source, $env::javascript . '/player' ) );
    my $copy_fla_encoded = $this->url_encode(
        $this->base_change( $copy, $env::javascript . '/player' ) );
    $data =~ s/\Q$source_fla_encoded\E/$copy_fla_encoded/sg;

    return $this->write_file( $copy . '/' . $name, \$data, 1 );
}

######################################################################
# 非公開.htaccess
sub set_htaccess ($$) {
    my ( $this, $path ) = @_;
    $this->write_file(
        $path . '/.htaccess',
        "order deny,allow\x0Adeny from all\x0A"
            . (
            ( $ENV{'REMOTE_ADDR'} )
            ? "allow from " . $ENV{'REMOTE_ADDR'} . "\x0A"
            : ''
            ),
        1
    );
}

sub date_id ($) {
    my $this = shift;
    my ( $sec, $min, $hour, $mday, $mon, $year ) = localtime(
        time - (
            ( $setting::general{'autoPublishingStartTime'} )
            ? $setting::general{'autoPublishingStartTime'} * 3600
            : 0
        )
    );
    $year += 1900;
    $mon++;
    return $year . sprintf( "%.2d", $mon ) . sprintf( "%.2d", $mday );
}

######################################################################
# 再構築
sub get_refresh_key ($) {
    my $this = shift;
    if ($default::date) {
        my $env
            = $this->get_refresh_dat( $default::home . '/refresh_env.dat' );
        ( $main::refresh_history, $main::refresh_calendar )
            = split( /,/, $env )
            if $env;
    }
    return $this->get_refresh_dat( $default::home . '/refresh_key.dat' );
}

sub set_refresh_key ($) {
    my $this = shift;
    $this->set_refresh_dat(
        $default::home . '/refresh_env.dat',
        ( ($main::refresh_history) ? '1' : '0' ) . ','
            . ( ($main::refresh_calendar) ? '1' : '0' )
    ) if $default::date;
    my $key
        = ( $ENV{'UNIQUE_ID'} )
        ? $ENV{'UNIQUE_ID'}
        : time . $$ . $ENV{'REMOTE_ADDR'} . $this->rand_char;
    $this->set_refresh_dat( $default::home . '/refresh_key.dat', $key );
    return $key;
}

sub get_refresh_dat ($$) {
    my ( $this, $path ) = @_;
    local (*DAT);
    my $dat = '';
    if ( open( DAT, $path ) ) {
        binmode DAT, ":utf8";
        flock( DAT, LOCK_SH );
        $dat = <DAT>;
        close(DAT);
    }
    return $dat;
}

sub set_refresh_dat ($$;$) {
    my ( $this, $path, $dat ) = @_;
    $dat = '' if !defined $dat;
    local (*DAT);
    if ( open( DAT, ">>$path" ) ) {
        binmode DAT, ":utf8";
        flock( DAT, LOCK_EX );
        truncate( DAT, 0 );
        seek( DAT, 0, 0 );
        print DAT $dat;
        close(DAT);
    }
}

sub clear_refresh_log ($) {
    my $this = shift;
    unlink $default::home . '/refresh_log.dat';
    unlink $default::home . '/refresh_env.dat' if $default::date;
    unlink $default::home . '/refresh_key.dat';
}

sub print_toss_page ($$$$) {
    my ( $this, $total, $count, $refresh_key ) = @_;
    if ($main::ajax) {
        $this->ajax_print_response(
            {   'status'      => 'toss',
                'total'       => $total,
                'count'       => $count,
                'refresh_key' => $refresh_key,
            }
        );
    }
    else {
        my $url = $cgi::path
            . $this->set_query(
            'url',
            (     ($default::date)
                ? [ @setting::form, @setting::dateform ]
                : \@setting::form
            )
            )
            . $this->add_query(
            'url',
            {   'a'           => 'refresh',
                'refresh_key' => $refresh_key,
            }
            );
        binmode STDOUT, ":utf8";
        $this->print_http_header;
        print '<html><head><meta http-equiv="Refresh" content="0; URL='
            . $this->escape($url) . '" />';
        print
            '<meta http-equiv="Content-Type" content="text/html;charset=UTF-8" />';
        print '<style type="text/css">' . "\x0A";
        require CMONOS::CGI_Lib::ProgressBar;
        print ProgressBar->new->css( int( $count / $total * 480 ), 1 );
        print '</style>';
        print '</head>';
        print '<body>';
        print
            '<div id="progress-bar-dialog">再構築中... <span id="action-counter">('
            . $count . '/'
            . $total
            . ')</span></div><div id="progress-bar-bg"><div id="progress-bar"></div></div>';
        print '</body></html>';
        binmode STDOUT;
    }
    exit;
}

######################################################################
# 記事リンク削除
sub article_delete_from_index ($$) {
    my ( $this, $delete ) = @_;
    local $main::delete = $delete;
    if ( defined $default::date && $default::date ) {
        $this->get_history_info;
        undef @article::folder;
        my @articles = $this->d_article_scan($main::n);
        my $mon = substr( $main::n, 0, 6 );
        if ( !grep( $_ =~ /^$mon/ && -d $default::home . '/' . $_, @articles )
            )
        {
            my $calpath = $calendar::path . '/' . $mon . '.ssi';
            unlink $calpath;
            $this->write_file( $calpath, '', 1 );
            $calpath = $calendar::path . '/' . $mon . '.js';
            unlink $calpath;
            $this->write_file( $calpath, '', 1 );
        }
        else {
            $this->mk_calendar($main::n);
        }
    }
    else {
        $this->article_scan($main::n);
    }

    #前後記事ののリンク更新
    my $prev_title;
    ($prev_title)
        = $this->a_neighbor_link_replace( '', "$default::home/$article::prev",
        '', ( ($article::next) ? "$default::home/$article::next" : '' ) )
        if defined $article::prev && $article::prev;
    $this->a_neighbor_link_replace(
        '', '',
        "$default::home/$article::next",
        ( ($article::prev) ? "$default::home/$article::prev" : '' ),
        '', $prev_title
    ) if defined $article::next && $article::next;

    #テンプレートオブジェクト作成
    $this->mk_template_obj(1);

    #インデックス＆履歴更新
    $this->index_replace_multi;
}

######################################################################
# 履歴ファイル
sub get_history_info ($) {
    my $this = shift;
    local (*DIR);

    #履歴ディレクトリ
    if ( opendir( DIR, $history::path ) ) {
        no warnings qw(numeric);
        my (@history);
        @history
            = grep( -f $history::path . '/' . $_
                && $_ =~ /^[0-9]+\.(?:html|htm|shtml|stml|shtm|stm)$/,
            readdir(DIR) );
        closedir(DIR);

        #履歴の名前（日月年の順で試す）
        if ($this->fileglob(
                $history::path,
                '^'
                    . substr( $main::n, 0, 8 )
                    . '\.(?:html|htm|shtml|stml|shtm|stm)$'
            )
            )
        {
            $history::name = substr( $main::n, 0, 8 );
            $setting::general{'historyType'} = 'd';
        }
        elsif (
            $this->fileglob(
                $history::path,
                '^'
                    . substr( $main::n, 0, 6 )
                    . '00\.(?:html|htm|shtml|stml|shtm|stm)$'
            )
            )
        {
            $history::name = substr( $main::n, 0, 6 ) . '00';
            $setting::general{'historyType'} = 'm';
        }
        elsif (
            $this->fileglob(
                $history::path,
                '^'
                    . substr( $main::n, 0, 4 )
                    . '0000\.(?:html|htm|shtml|stml|shtm|stm)$'
            )
            )
        {
            $history::name = substr( $main::n, 0, 4 ) . '0000';
            $setting::general{'historyType'} = 'y';
        }
        elsif ( defined $setting::general{'historyType'}
            && $setting::general{'historyType'} eq 'd' )
        {
            $history::name = substr( $main::n, 0, 8 );
        }
        elsif ( defined $setting::general{'historyType'}
            && $setting::general{'historyType'} eq 'y' )
        {
            $history::name = substr( $main::n, 0, 4 ) . '0000';
        }
        else {
            $history::name = substr( $main::n, 0, 6 ) . '00';
        }

        #前後の記事を判定
        push( @history, $history::name . '.' . $default::ext )
            unless grep( $_ =~ /^$history::name\./, @history );
        @history = sort { $a <=> $b || $a cmp $b } @history;
        $history::latest = $history[$#history];

        ( $history::prev, $history::next )
            = $this->get_neighbor( $history::name, \@history );
        $history::home
            = $history::path . '/'
            . $history::name . '.'
            . $default::ext . '#a'
            . substr( $main::n, 0, 8 )
            . $default::id
            . ( ($main::c) ? '_' . $main::c : '' );
    }
}

######################################################################
# フォルダメニュー
sub print_folder_selector ($;$) {
    my ( $this, $is_embedded ) = @_;
    my (@folder);
    local (*DIR);
    if ( opendir( DIR, $default::master_preference_dir ) ) {
        no warnings qw(numeric);
        @folder
            = sort { $a <=> $b || $a cmp $b }
            grep( $_ =~ /^[0-9a-zA-Z_]+$/
                && -d "$default::master_preference_dir/$_",
            readdir(DIR) );
        closedir(DIR);
    }
    elsif ( !$is_embedded ) {
        push(
            @{ $this->{'dialog'} },
            'ホームディレクトリの設定を確認してください。'
        );
    }
    my $index_path
        = $master::home
        . '/index.'
        . ( ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html' );
    if ( -f $index_path ) {
        my $index_html = $this->read_file( $index_path, 1 );
        my $my_index_id
            = ( defined $default::id && $default::id ne '' )
            ? $default::id
            : 'homepage';
        if ( $index_html
            =~ /(<!--index(?![0-9a-zA-Z_])[^>]*? id="$my_index_id"[^>]*-->.*?<!--\/index-->)/s
            )
        {
            my $my_index_html  = $1;
            my %subindex_order = ();
            my $no             = 0;
            while ( $my_index_html
                =~ /<!--subindex(?![0-9a-zA-Z_])([^>]*)-->.*?<!--\/subindex-->/gs
                )
            {
                my $subindex_setting = $1;
                my $subindex_id
                    = ( $subindex_setting
                        =~ /[\x09\x0A\x0C\x0D\x20]*id[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)"/s
                    ) ? $1 : '';
                $subindex_order{$subindex_id} = ++$no;
            }
            if (%subindex_order) {
                @folder = sort {
                    (          defined $subindex_order{$a}
                            && defined $subindex_order{$b}
                            && $subindex_order{$a} <=> $subindex_order{$b} )
                        || $a <=> $b
                        || $a cmp $b
                } @folder;
            }
        }
    }

    #ページヘッダ
    $this->print_page_header('tools') if !$is_embedded;

    if (@folder) {

        #フォーム
        print $this->form_start(
            'key'      => 'edit',
            'name'     => 'categoryselector',
            'id'       => 'categoryselector',
            'required' => [ 'm', 'k' ]
        );
        print '<select name="c" onchange="submit()">';

        foreach my $f (@folder) {
            my (%setting);
            tie( %setting, $env::dbm_file,
                $default::master_preference_dir . '/' . $f . '/general',
                O_RDONLY, $env::dbm_mode );
            print '<option value="', $f, '"',
                ( ( defined $main::c && $main::c ne '' && $f eq $main::c )
                ? ' selected="selected"'
                : '' ), '>';
            print(
                (          ref tied %setting
                        && defined $setting{'cginame'}
                        && $setting{'cginame'} ne ''
                )
                ? $this->escape(
                    $this->decode_utf8( $setting{'cginame'} )
                    )
                : $f
            );
            print '</option>';
            untie %setting;
        }

        print '</select>';
        print '<input type="submit" value="選択" />';
        print '</form>';

    }
    elsif ( !$is_embedded ) {
        print 'フォルダが見つかりません。';

    }
    return 1 if $is_embedded;

    #ページフッタ
    $this->print_page_footer('tools');
    exit;
}

######################################################################
# 記事番号解析
sub d_article_scan ($$;$$) {
    no warnings qw(numeric);
    my ( $this, $n, $mon, $mday ) = @_;
    my (@folder, @article,      $date,         $prev,
        $next,   $prev_article, $next_article, $exist,
        $search, $done
    );

    #全記事リスト
    if ( !@article::folder ) {
        unless ( opendir( DIR, $default::home ) ) {
            push(
                @{ $this->{'dialog'} },
                'ホームディレクトリの設定を確認してください。'
            );
            return;
        }
        @article::folder
            = sort { $a <=> $b || $a cmp $b }
            grep( -d "$default::home/$_" && $_ =~ /^[0-9]{10}/,
            readdir(DIR) );
        closedir(DIR);
    }
    undef @article::list;
    undef $article::prev_date;
    undef $article::next_date;
    undef $article::prev;
    undef $article::next;
    undef $article::prev_article;
    undef $article::next_article;
    undef $article::prev_title;
    undef $article::next_title;
    undef $article::first;
    undef $article::latest;
    undef @article::pending;
    $article::count = 0;

    #日付検索
    if ( defined $mon && $mon ) {
        $date = sprintf( "%.4d", $n ) . sprintf( "%.2d", $mon );
        if ( defined $mday && $mday ) {
            $date .= sprintf( "%.2d", $mday );
            $n = $date . '00';
        }
        else {
            $date .= '01';
            $main::a = 'r';
            $n       = '';
        }
        $search = 1;
    }
    elsif ($n) {
        $date = substr( $n, 0, 8 );
    }
    else {
        $n = '';
    }

    #前後の記事を判定
    foreach my $ar (@article::folder) {
        my $is_pending = ( $ar =~ s/\.pending$// ) ? 1 : 0;
        if ( $ar =~ /^[0-9]{10}$/ ) {
            if ($is_pending) {
                push( @article::pending, $ar );
            }
            else {
                $article::first = $ar
                    if !defined $article::first || $article::first eq '';
                $article::latest = $ar;
                $article::count++;
            }
            push( @article, $ar );
            if ( !$done ) {
                if ( $n && $ar < $n ) {
                    $prev = $ar if !$is_pending;
                    $prev_article = $ar;
                }
                if ( defined $date && $date ) {
                    my $article_date = substr( $ar, 0, 8 );
                    $article::prev_date = $article_date
                        if $article_date < $date;
                    if ( $article_date eq $date ) {
                        if ( $search && $ar == $n ) {
                            $prev = $ar;
                            $n++;
                        }
                        push( @article::list, $ar );
                    }
                    elsif ( !$article::next_date && $article_date > $date ) {
                        $article::next_date = $article_date;
                        $done = 1 if $next;
                    }
                }
                if ($n) {
                    if ( $ar == $n ) {
                        $exist++;
                    }
                    elsif ( $ar > $n ) {
                        if ( !$is_pending ) {
                            $next = $ar if !$next;
                            $done = 1   if $article::next_date;
                        }
                        $next_article = $ar if !$next_article;
                    }
                }
            }
        }
    }
    undef @article::folder if !$this->{'rebuild'};

    if ($n) {
        $article::prev = $prev if defined $prev && $prev;
        $article::next = $next if defined $next && $next;
        $article::prev_article = $prev_article
            if defined $prev_article && $prev_article;
        $article::next_article = $next_article
            if defined $next_article && $next_article;
    }
    if ($exist) {
        undef $article::new;
    }
    elsif ( !$main::delete || $main::delete ne 'n' ) {
        $article::new++;
        $article::count++ if !$main::pending;
    }
    $article::first = $n
        if $n && ( !defined $article::first || $article::first eq '' );
    $article::latest = $n
        if $n && ( !defined $article::latest || $article::latest eq '' );
    $setting::general{'yearStart'} = $1 - 1
        if $article::first
        && $article::first =~ /^([0-9]{4})/
        && $1 <= $setting::general{'yearStart'};
    $setting::general{'yearEnd'} = $1 + 1
        if $article::latest
        && $article::latest =~ /^([0-9]{4})/
        && $1 >= $setting::general{'yearEnd'};

    #日付検索の場合→調整
    if ( $search && ( $main::a eq 'c' || @article::list == 0 ) ) {
        $main::a = 'c';
        $main::n = $n;
    }
    return (wantarray) ? @article : 1;
}

######################################################################
# 記事番号解析
sub article_scan ($$) {
    no warnings qw(numeric);
    my ( $this, $n ) = @_;
    my (@article);
    undef $article::prev;
    undef $article::next;
    undef $article::prev_article;
    undef $article::next_article;
    undef $article::prev_title;
    undef $article::next_title;
    undef $article::first;
    undef $article::latest;

    #全記事リスト
    unless ( opendir( DIR, $default::home ) ) {
        push(
            @{ $this->{'dialog'} },
            'ホームディレクトリの設定を確認してください。'
        );
        return;
    }
    @article::list
        = sort { $a <=> $b || $a cmp $b }
        grep( -d "$default::home/$_"
            && $_ !~ /^[\.\-_]/
            && $_ ne 'new'
            && $_ ne 'first'
            && $_ ne 'media'
            && $this->fileglob( $default::home . '/' . $_, '^1\.' ),
        readdir(DIR) );
    closedir(DIR);
    @article = grep( $_ !~ /\.pending$/, @article::list );
    $article::first  = (@article) ? $article[0]         : '';
    $article::latest = (@article) ? $article[$#article] : '';
    $article::count  = @article;
    map( $_ =~ s/\.pending$//, @article::list );
    $article::count++
        if defined $article::new && $article::new && !$main::pending;
    return (wantarray) ? @article::list : 1 if !defined $n || $n eq '';

    #前後の記事を判定
    ( $article::prev, $article::next ) = $this->get_neighbor( $n, \@article );
    ( $article::prev_article, $article::next_article )
        = ( @article == @article::list )
        ? ( $article::prev, $article::next )
        : $this->get_neighbor( $n, \@article::list );
    return (wantarray) ? @article::list : 1;
}

#前後のNoを判定
sub get_neighbor ($$$) {
    no warnings qw(numeric);
    my ( $this, $n, $array ) = @_;
    my ( $num, $prev, $next );
    foreach my $i (@$array) {
        $num = $1 if $i =~ /^([^\.]+)/;
        if ( $num < $n || ( $num == $n && $num lt $n ) ) {
            $prev = $i;
        }
        elsif ( $num > $n || ( $num == $n && $num gt $n ) ) {
            $next = $i if !defined $next || !$next;
            last;
        }
    }
    return ( $prev, $next );
}

######################################################################
# 記事選択ダイアログ
sub print_article_selector ($;$) {
    my ( $this, $is_embedded ) = @_;
    if ( !$is_embedded ) {
        undef $cgi::output;
        undef $cgi::output_option;
        if ( $main::pending_list && !@article::pending ) {
            push(
                @{ $this->{'dialog'} },
                '非公開記事は存在しません。'
            );
            undef $main::pending_list;
        }

        if (   $setting::general{'rebuildenabled'}
            && defined $this->{'tool_master'}
            && $this->{'tool_master'} )
        {
            require CMONOS::CGI_Lib::ProgressBar;
            $this->set_javascript(
                <<JAVASCRIPT
cmonos.articles = {
	form : function(element) {
		if (typeof element == 'object') {
			this.currentForm = element;
		} else if (typeof element == "string") {
			this.currentForm = document.getElementById(element);
		} else {
			this.currentForm = null;
		}
		return this;
	},

	rebuildAll : function () {
		if (this.currentForm) {
			this.current_form = new cmonos.persistent.form;
			this.current_form.item(this.currentForm).enabled(false).makeProgressBar('再構築中...');
			this.parameters = this.current_form.toHash();
			this.parameters["ajax"] = "1";
			this.rebuild();
			return false;
		} else {
			return true;
		}
	},

	rebuild : function () {
		var this_articles = this;
		cmonos.xml.request(
			this.currentForm.action,
			{
				method: 'post',
				parameters: this.parameters,
				onFailure: function(){
					alert("error!");
					this_articles.current_form.removeProgressBar();
				},
				onSuccess: function(transport){
					var response_hash = cmonos.value.urlDecode(transport.responseText);
					if (response_hash["status"] == "success" || response_hash["status"] == "error") {
						if (response_hash["status"] == "success") {
							var total = parseInt(response_hash["total"]);
							this_articles.current_form.progressbar.bar.style.width = this_articles.current_form.progressbar.max_width + 'px';
							this_articles.current_form.progressbar.action_counter.innerHTML = '(' + total + '/' + total + ')';
							this_articles.current_form.progressbar.time_remain.innerHTML = ' [完了]';
						}
						if (response_hash["message"] != null) {
							var success_message = response_hash["message"].split(";");
							for (var i=0; i < success_message.length; i++) {
								if (success_message[i] != "") alert(success_message[i]);
							}
						}
						this_articles.current_form.removeProgressBar();
					} else if (response_hash["status"] == "toss") {
						var total = parseInt(response_hash["total"]);
						var count = parseInt(response_hash["count"]);
						var w = Math.floor(count / total * this_articles.current_form.progressbar.max_width);
						this_articles.current_form.progressbar.bar_size = (w > 0) ? w : 1;
						this_articles.current_form.progressbar.bar.style.width = ((w > 0) ? w : 1) + 'px';
						this_articles.current_form.progressbar.action_counter.innerHTML = '(' + count + '/' + total + ')';
						if (count > 0) {
							var rmin = Math.ceil(((new Date()).getTime() - this_articles.current_form.progressbar.start) * (total - count) / count / 60000);
							this_articles.current_form.progressbar.time_remain.innerHTML = ' [あと' + rmin + '分]';
						}
						this_articles.parameters["refresh_key"] = response_hash["refresh_key"];
						this_articles.rebuild();
					}
				}
			}
		);
	}
}
JAVASCRIPT
            );
        }

        #ページヘッダ
        $this->print_page_header('edit');

        $this->print_folder_selector(1) if $default::subdivided;
    }

    #記事選択フォーム
    #日付管理
    if ( defined $default::date && $default::date ) {
        print '<div id="article-finder">';
        if (   $article::prev_date
            || $article::next_date
            || ( $is_embedded
                && ( @article::list > 1
                    || ( @article::list && $article::new ) ) )
            || @article::pending
            )
        {
            print $this->form_start(
                'key'      => 'edit',
                'name'     => 'articlenavi',
                'id'       => 'articlenavi',
                'class'    => 'toolbox',
                'required' => \@setting::form
            );
            if ( $is_embedded && $article::prev_article ) {
                print '<input type="submit" name="a=r&amp;n='
                    . $article::prev_article
                    . '" value="&lsaquo; 前の記事" />';
            }
            elsif ($article::prev_date
                && $article::prev_date =~ /^([0-9]{4})([0-9]{2})([0-9]{2})/ )
            {
                print '<input type="submit" name="a=r&amp;year='
                    . $1
                    . '&amp;mon='
                    . ( $2 + 0 )
                    . '&amp;mday='
                    . ( $3 + 0 )
                    . '" value="&laquo; 前の日付" />';
            }
            my $v
                = ( ($main::n) ? '&amp;referer_n=' . $main::n : '' )
                . ( ($main::year) ? '&amp;year=' . $main::year : '' )
                . ( ($main::mon)  ? '&amp;mon=' . $main::mon   : '' )
                . ( ($main::mday) ? '&amp;mday=' . $main::mday : '' );
            print '<input type="submit" name="return=1'
                . $v
                . '" value="同日" title="同じ日付の記事の一覧を表示します。" />'
                if $is_embedded
                && ( @article::list > 1
                || ( @article::list && $article::new ) );
            print '<input type="submit" name="pending_list=1'
                . $v
                . '" value="非公開" title="非公開記事の一覧を表示します。" />'
                if @article::pending;
            if ( $is_embedded && $article::next_article ) {
                print '<input type="submit" name="a=r&amp;n='
                    . $article::next_article
                    . '" value="次の記事 &rsaquo;" />';
            }
            elsif ($article::next_date
                && $article::next_date =~ /^([0-9]{4})([0-9]{2})([0-9]{2})/ )
            {
                print '<input type="submit" name="a=r&amp;year='
                    . $1
                    . '&amp;mon='
                    . ( $2 + 0 )
                    . '&amp;mday='
                    . ( $3 + 0 )
                    . '" value="次の日付 &raquo;" />';
            }
            print '</form>';
        }
        my ($y);
        print $this->form_start(
            'key'      => 'edit',
            'name'     => 'selector',
            'class'    => 'toolbox',
            'method'   => 'post',
            'required' => \@setting::form
        );

        #年
        print
            '<span class="date-selector"><label><select name="year" id="year">';
        my $ys
            = ( $setting::general{'yearStart'} > $main::year )
            ? $main::year
            : $setting::general{'yearStart'};
        foreach my $y ( $ys .. $setting::general{'yearEnd'} ) {
            print '<option value="' . $y . '"';
            print ' selected="selected"' if $main::year && $y == $main::year;
            print '>' . $y . '</option>';
        }
        print '</select>年</label>';

        #月
        print '<label><select name="mon" id="mon">';
        foreach my $mon ( 1 .. 12 ) {
            print '<option value="' . $mon . '"';
            print ' selected="selected"' if $main::mon && $mon == $main::mon;
            print '>' . $mon . '</option>';
        }
        print '</select>月</label>';

        #日
        print '<label><select name="mday" id="mday">';
        foreach my $mday ( 1 .. 31 ) {
            print '<option value="' . $mday . '"';
            print ' selected="selected"'
                if $main::mday && $mday == $main::mday;
            print '>' . $mday . '</option>';
        }
        print '</select>日</label>';
        print
            '<a href="javascript:void(0)" onclick="cmonos.tool.calendarPalette.open(\'year\',\'mon\',\'mday\')" title="クリックするとカレンダーから日付を設定できます。"><img src="'
            . $env::image_dir
            . '/tool/calendar.gif" width="15" height="15" border="0" alt="カレンダーパネル" /></a>';

        print ' の記事を</span>';
        print '<select name="a">';
        print '<option value="c"';
        print ' selected="selected"' if $main::a eq 'c';
        print '>新規作成</option>';
        print '<option value="r"';
        print ' selected="selected"' if $main::a eq 'r';
        print '>修正</option>';
        print '</select>';
        print '<input type="submit" value="する" />';
        print '</form></div>';

        #名前管理
    }
    else {
        print '<div class="toolbox" id="article-finder">';
        if ($is_embedded) {
            print $this->form_start(
                'key'      => 'edit',
                'name'     => 'articlenavi',
                'id'       => 'articlenavi',
                'class'    => 'toolbox',
                'required' => \@setting::form
            );
            print '<input type="submit" name="a=r&amp;n='
                . $article::prev_article
                . '" value="&lsaquo; 前の記事" />'
                if $article::prev_article;
            print '<input type="submit" name="return=1&amp;referer_n='
                . $main::n
                . '" value="一覧" />';
            print '<input type="submit" name="a=r&amp;n='
                . $article::next_article
                . '" value="次の記事 &rsaquo;" />'
                if $article::next_article;
            print '</form>';
        }
        print $this->form_start(
            'key'      => 'edit',
            'name'     => 'selector',
            'method'   => 'post',
            'required' => \@setting::form
        );
        print '名前が <input type="text" name="n" size="16" value="',
            ( ( !$is_embedded && $main::n ) ? $main::n : '' ),
            '" onchange="cmonos.validate.field(this).asWord()" /> のフォルダに記事を';
        print '<input type="hidden" name="a" value="c" />';
        print '<input type="submit" value="新規作成する" />';
        print '</form></div>';
    }
    return 1 if $is_embedded;

    #記事選択フォーム
    @article::list = @article::pending
        if $main::pending_list && @article::pending;
    if (@article::list) {
        print $this->form_start(
            'key'      => 'edit',
            'name'     => 'articles',
            'method'   => 'post',
            'required' => [ @setting::form, @setting::dateform ]
        );
        print '<input type="hidden" name="a" value="r" />';
        print '<fieldset id="article-selector">';

        #日付管理
        if ( defined $default::date && $default::date ) {
            print '<legend>';
            print(
                ( $main::pending_list && @article::pending )
                ? '非公開記事一覧'
                : $this->date(
                    [ $main::year, $main::mon, $main::mday ], 0,
                    $setting::general{'datetype'}
                )
            );
            print '</legend>'

                #名前管理
        }
        else {
            print '<legend>記事一覧</legend>';
        }
        print '<ol class="checkbox">';
        my $count = 0;
        foreach my $ar (@article::list) {
            my $is_pending = ( -d $default::home . '/' . $ar ) ? 0 : 1;
            my $url = $this->fileglob(
                $default::home . '/'
                    . $ar
                    . ( ($is_pending) ? '.pending' : '' ),
                '^1\.'
            );
            next if !defined $url || $url eq '';
            my $data = $this->read_html_file($url);
            print '<li><label><input type="radio" name="n" value="'
                . $ar . '"'
                . (
                (          ( $main::referer_n && $main::referer_n eq $ar )
                        || ( !$main::referer_n && !$count++ )
                ) ? ' checked="checked"' : ''
                ) . ' /> ';
            print '<a href="', $url, '" target="_blank">';
            print $ar, ' : ' if !$default::date;
            print $this->get_article_title( \$data );
            print '</a>';
            print
                ' <span style="color: #FFF; background-color: #f66">非公開</span>'
                if $is_pending;
            print '</label></li>';
        }
        print '</ol>';
        print '<div class="submit-box">';

#print '<input type="submit" class="delete" name="delete=n" value="削除する" onclick="return confirm(\'この操作は取り消せません。本当に削除しますか？\');" />' if $this->is_secure('delete',0,'edit');
        print '<input name="get_new=1" type="submit" value="追記する" />'
            if !defined $this->{'template'}->{'chapter_limit'}
            || $this->{'template'}->{'chapter_limit'} eq ''
            || $this->{'template'}->{'chapter_limit'} > 1
            || !defined $this->{'template'}->{'section_limit'}
            || $this->{'template'}->{'section_limit'} eq ''
            || $this->{'template'}->{'section_limit'} > 1;
        print
            '<input name="get_last=1" type="submit" value="修正する" />';
        print '</div></fieldset></form>';
    }
    if (   $setting::general{'rebuildenabled'}
        && defined $this->{'tool_master'}
        && $this->{'tool_master'} )
    {
        print $this->form_start(
            'key'    => 'edit',
            'name'   => 'rebuild',
            'method' => 'post',
            'onsubmit' =>
                'return confirm(\'最新のテンプレートと旧テンプレートの間に互換性がない場合、データが失われたり表示が崩れることがあります。\\nこの処理はサーバに過大な負荷をかける場合があります。\\nそれでも最新のテンプレートを使ってすべての記事を書き換えますか？\') &amp;&amp; cmonos.form.item(this).isNotSubmitted() &amp;&amp; cmonos.articles.form(this).rebuildAll();',
            'required' => [ @setting::form, @setting::dateform ]
        );
        print '<fieldset id="refresh" class="risky">';
        print '<legend>記事の再構築</legend>';
        my $refresh_log = $default::home . '/refresh.log';
        if ( -f $refresh_log ) {
            my @stat = stat($refresh_log);
            if ( $stat[9] ) {
                my $t = time - $stat[9];
                if ( $t < 180 ) {
                    print
                        '<div id="rebuild-warning" class="warning">既に実行されています。やり直す場合は'
                        . ( int( ( 180 - $t ) / 60 ) + 1 )
                        . '分以上待って再度実行してください。</div>';
                }
                elsif ( $t <= 3600 ) {
                    print
                        '<div id="rebuild-warning" class="warning">前回、処理が中断されたようです。続きから実行します。</div>';
                }
            }
        }
        print '<ol class="checkbox">';
        print
            '<li><label><input type="checkbox" name="refresh_calendar" value="1"'
            . ( ($main::refresh_calendar) ? 'checked="checked"' : '' )
            . ' />カレンダーも書き換える</label></li>'
            if $default::date;
        print
            '<li><label><input type="checkbox" name="refresh_history" value="1"'
            . ( ($main::refresh_history) ? 'checked="checked"' : '' ) . ' />'
            . ( ($default::date) ? '履歴' : 'インデックス' )
            . 'も書き換える</label>';
        print
            '(<label><input type="checkbox" name="refresh_recommendedindex" value="1"'
            . ( ($main::refresh_recommendedindex) ? 'checked="checked"' : '' )
            . ' />おすすめをリセット</label>)'
            if $this->template_has_recommendedindex;
        print '</li></ol>';
        print '<input type="hidden" name="a" value="refresh" />';
        print
            '<input type="submit" value="すべての記事を最新のテンプレートを使って書き換える" />';
        print '</fieldset></form>';
    }

    print '<div class="toolbox"><a href="./start.cgi?m=Tools'
        . (
        ( defined $main::c && $main::c ne '' ) ? '&amp;c=' . $main::c : '' )
        . '" title="環境設定を開く">';
    print '<img src="' . $env::image_dir . '/tool/tools.gif"';
    print
        ' width="20" height="20" border="0" alt="環境設定を開く" /></a></div>';

    #ページフッタ
    $this->print_page_footer('edit');
    exit;
}

######################################################################
# 記事タイトル取得
sub get_article_title ($$) {
    my ( $this, $data ) = @_;
    my ( $title, $ok );
    return '' unless ref $data && defined $$data && $$data ne '';
    return $1 if $$data =~ m/<meta name="title" content="([^">]+)" \/>/is;
    $title
        = ( $$data
            =~ m/<title(?![0-9a-zA-Z_])[^>]*>(.*?)<\/title(?![0-9a-zA-Z_])[^>]*>/is
        ) ? $1 : '';
    $ok = 1 if $env::title ne '' && $title =~ s/^\Q$env::title\E(:|$)//s;
    $ok = 1
        if defined $master::general{'cginame'}
        && $master::general{'cginame'} ne ''
        && $title =~ s/^\Q$master::general{'cginame'}\E(:|$)//s;
    $ok = 1
        if $setting::general{'cginame'} ne ''
        && $title =~ s/^\Q$setting::general{'cginame'}\E(:|$)//s;
    $ok = 1
        if $setting::page{'article'}{'title'} ne ''
        && $title =~ s/^\Q$setting::page{'article'}{'title'}\E(:|$)//s;
    $title = $1 if !$ok && $title =~ /:([^:]+)$/;
    return $title;
}

# 記事要約取得
sub get_article_description ($$) {
    my ( $this, $data ) = @_;
    return (   ref $data
            && defined $$data
            && $$data ne ''
            && $$data
            =~ m/<meta name="description" content="([^">]+?)" \/>/i )
        ? $1
        : '';
}

######################################################################
# 記事基本情報更新
sub tag_replace ($$;$$$$$$$) {
    my ( $this, $article, $title, $description, $p, $output, $option,
        $is_pending )
        = @_;
    my ( $articletitle, $date, $mtime );
    $mtime = $this->time_id;
    if ( defined $default::date && $default::date ) {
        $date = substr( $main::n, 0, 8 );
        $$title = $this->date( $date, 0, $setting::general{'datetype'} )
            if !defined $$title || $$title eq '';
    }
    else {
        $date = substr( $mtime, 0, 8 );
        $$title = $main::n if !defined $$title || $$title eq '';
    }

    #タイトル更新
    $article
        =~ s/<meta name="title" content="[^">]*?" \/>/'<meta name="title" content="' . $this->escape_except_html_entity($$title) . '" \/>'/segi;

    #カテゴリータイトル・アイコン・説明
    $article
        =~ s/<\!--title(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/title(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('title',$1,$2,$setting::general{'cginame'},1)/ges;
    $article
        =~ s/<\!--(mastertitle(?![0-9a-zA-Z_]))([^>]*)-->(.*?)<\!--\/\1(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace($1,$2,$3,$master::general{'cginame'},1)/gies;
    my $subindex_icon = $this->get_icon_tag(
        $default::home,                 $setting::general{'icon'},
        $setting::general{'iconwidth'}, $setting::general{'iconheight'},
        $setting::general{'cginame'}
    );
    $article
        =~ s/<\!--(icon(?![0-9a-zA-Z_]))([^>]*)-->(.*?)<\!--\/\1(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace($1,$2,$3,$subindex_icon,1)/gies;
    my $subindex_description = $this->autolink(
        $this->tag_fix(
            $this->autolist( $setting::general{'description'} ), 2
        ),
        0,
        $setting::general{'addressProtector'}
    );
    $article
        =~ s/<\!--(description(?![0-9a-zA-Z_]))([^>]*)-->(.*?)<\!--\/\1(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace($1,$2,$3,$subindex_description,1)/gies;
    if ( defined $default::subdivided && $default::subdivided ) {
        my $index_icon = $this->get_icon_tag(
            $default::home,                $master::general{'icon'},
            $master::general{'iconwidth'}, $master::general{'iconheight'},
            $master::general{'cginame'}
        );
        $article
            =~ s/<\!--(mastericon(?![0-9a-zA-Z_]))([^>]*)-->(.*?)<\!--\/\1(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace($1,$2,$3,$index_icon,1)/gies;
        my $index_description = $this->autolink(
            $this->tag_fix(
                $this->autolist( $master::general{'description'} ), 2
            ),
            0,
            $master::general{'addressProtector'}
        );
        $article
            =~ s/<\!--(masterdescription(?![0-9a-zA-Z_]))([^>]*)-->(.*?)<\!--\/\1(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace($1,$2,$3,$index_description,1)/gies;
    }

    if ( defined $$description && $$description ne '' ) {
        my $page_description
            = '<meta name="description" content="'
            . $this->escape_except_html_entity(
            $this->cut_string( $$description, 201, 'i' ) )
            . '" />';
        $article
            =~ s/<meta name="description" content="[^">]*" \/>/$page_description/sig
            || $article
            =~ s/(<meta name="title" content="[^">]*" \/>)/$1\x0A$page_description/sig
            || $article
            =~ s/[\x09\x0A\x0C\x0D\x20]*<\/head>/\x0A$page_description<\/head>/sig;
    }
    else {
        $article
            =~ s/<meta name="description" content="[^">]*" \/>[\x09\x0A\x0C\x0D\x20]*//sig;
    }

    #更新時更新
    $article
        =~ s/<\!--(mtime)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/mtime-->/$this->date_replace($1,$2,$3,$mtime,$this->{'keep_mtime'})/sge;

    #日付更新
    $article
        =~ s/<\!--(date)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/date-->/$this->date_replace($1,$2,$3,$date)/sge;

    $this->page_navi_replace( \$article, $p, $$title, $output );

    my $written_flag = ( $article =~ /<body(?![0-9a-zA-Z_])[^>]*>/i ) ? 1 : 0;
    if ( defined $output && $output ) {
        my %link = (
            'home' => {
                'href' => $this->base_change(
                    $this->home_directory, $output, $option
                ),
                'title' => ( ($env::title) ? $env::title : 'Home' )
            },
            (   ( $default::subdivided || $default::date )
                ? ( 'index' => (
                        ($default::subdivided)
                        ? { 'href'  => '../../index.' . $default::ext,
                            'title' => (
                                (   $setting::indexpage{'masterindex'}
                                        {'title'}
                                )
                                ? $setting::indexpage{'masterindex'}{'title'}
                                : '総合インデックス'
                            )
                            }
                        : { 'href'  => '../index.' . $default::ext,
                            'title' => (
                                ( $setting::page{'index'}{'title'} )
                                ? $setting::page{'index'}{'title'}
                                : 'インデックス'
                            )
                        }
                    )
                    )
                : ()
            ),
            'contents' => (
                ($default::date)
                ? { 'href' => '../history/'
                        . $history::name . '.'
                        . $default::ext,
                    'title' => (
                        ( $setting::page{'history'}{'title'} )
                        ? $setting::page{'history'}{'title'}
                        : 'バックナンバー'
                    )
                    }
                : { 'href'  => '../index.' . $default::ext,
                    'title' => (
                        ( $setting::page{'index'}{'title'} )
                        ? $setting::page{'index'}{'title'}
                        : 'インデックス'
                    )
                }
            ),
            'next'  => '',
            'prev'  => '',
            'first' => '',
            'last'  => '',
        );

        #前後記事リンク
        ( $article::prev_title, $article::next_title )
            = $this->a_neighbor_link_replace(
            \$article,
            ( ($article::prev) ? "$default::home/$article::prev" : '' ),
            ( ($article::next) ? "$default::home/$article::next" : '' ),
            $output,
            $option,
            $$title,
            \%link,
            $article::prev_title,
            $article::next_title
            ) if !$is_pending;

        #前後ページリンク
        if ( defined $p && $p ) {
            my ( $lastpage, $prevpage, $nextpage );
            $lastpage = @page::list;
            $nextpage = $p + 1 if $p < $lastpage;
            $prevpage = $p - 1 if $p > 1;
            $this->p_neighbor_link_replace(
                \$article,
                $default::home . '/'
                    . $main::n
                    . ( ($is_pending) ? '.pending' : '' ),
                $prevpage,
                $nextpage,
                $output,
                $option,
                0,
                '',
                \%link,
                1,
                ( ( $page::new && $prevpage && $prevpage == 1 ) ? 1 : '' )
            );
            if ( $lastpage > 1 ) {
                $link{'first'} = {
                    'href'  => './1.' . $default::ext,
                    'title' => (
                        ($default::english)
                        ? 'First Page'
                        : '最初のページ'
                    )
                    }
                    if $p > 1;
                $link{'last'} = {
                    'href'  => './' . $lastpage . '.' . $default::ext,
                    'title' => (
                        ($default::english)
                        ? 'Last Page'
                        : '最後のページ'
                    )
                    }
                    if $p < $lastpage;
            }
        }
        $this->set_link_rel( \%link ) if !$written_flag;
        $this->replace_link_rel( \$article, \%link );

        #インデックスリンク/画像
        $this->link_tag_replace( \$article, $output, $option, 'article' );
    }

    #カレンダーSSI
    $this->calendar_tag_replace( \$article, $main::n )
        if defined $default::date && $default::date;

    #パーマリンク
    $article
        =~ s/<EntryPermalink(?![0-9a-zA-Z_])([^>]*)>/$this->get_entry_permalink($output,$1)/gies;

    return $article;
}

sub page_navi_replace ($$$;$$) {
    my ( $this, $article, $p, $title, $output ) = @_;
    my ( $pagenavi, $here, $articletitle );
    $title = $this->get_article_title($article)
        if !defined $title || $title eq '';

    #ページ位置
    $here = ( @page::list > 1 ) ? $p . '/' . scalar(@page::list) : '';
    $$article
        =~ s/<\!--here(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/here(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('here',$1,$2,$here,1)/ges;

    $here = ($here) ? ' (' . $here . ')' : '';
    $articletitle = $this->window_title(
        $env::window_title_format,          $env::title,
        $master::general{'cginame'},        $setting::general{'cginame'},
        $setting::page{'article'}{'title'}, $title . $here
    );
    $$article
        =~ s/(<title(?![0-9a-zA-Z_])[^>]*>).*?(<\/title(?![0-9a-zA-Z_])[^>]*>)/$1$articletitle$2/sgi;
    $$article
        = $this->page_item_replace( $$article, 1, $output, $title, $here );
    undef $here;

    #ページナビ
    $$article
        =~ s/<\!--pagenavi(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/pagenavi(?![0-9a-zA-Z_])[^>]*-->/$this->_page_navi_replace($p,$1,$2)/ges;
}

sub _page_navi_replace ($$$) {
    my ( $this, $p, $setting, $content ) = @_;
    my $prevpage =
      ( $content =~
          s/<!--prevpage(?![0-9a-zA-Z_])[^>]*-->(.*?)<!--\/prevpage-->//s )
      ? $1
      : '';
    $prevpage =~ s/<!--head(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/head-->//sg;
    $prevpage =~ s/<!--foot(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/foot-->//sg;
    $prevpage = $1
      if $prevpage =~ /<!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<!--\/data-->/s;
    my $nextpage =
      ( $content =~
          s/<!--nextpage(?![0-9a-zA-Z_])[^>]*-->(.*?)<!--\/nextpage-->//s )
      ? $1
      : '';
    $nextpage =~ s/<!--head(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/head-->//sg;
    $nextpage =~ s/<!--foot(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/foot-->//sg;
    $nextpage = $1
      if $nextpage =~ /<!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<!--\/data-->/s;
    $content =~ s/<!--prevpage(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/prevpage-->//sg;
    $content =~ s/<!--nextpage(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/nextpage-->//sg;
    my ( $header, $footer ) =
      $this->get_header_and_footer( $setting, $content );
    $setting =~ s/[\x09\x0A\x0C\x0D\x20]+head="([^"]+)"//sg;
    $setting =~ s/[\x09\x0A\x0C\x0D\x20]+foot="([^"]+)"//sg;
    $setting = '' if $setting eq '' || $setting !~ /[^\x09\x0A\x0C\x0D\x20]/;

    if ( scalar @page::list > 1 ) {
        my $is_list = ( $setting =~ / type="list"/i )    ? 1  : 0;
        my $max     = ( $setting =~ / max="([0-9]+)"/i ) ? $1 : 0;
        my $class = ( $setting =~ / class="([0-9a-zA-Z_\-\x20]+)"/i ) ? $1 : '';
        my $id    = ( $setting =~ / id="([0-9a-zA-Z_\-]+)"/i )        ? $1 : '';
        my $prevtitle   = ( $setting =~ / prevtitle="([^"]+)"/i )     ? $1 : '';
        my $prevtext    = ( $setting =~ / prevtext="([^"]+)"/i )      ? $1 : '';
        my $prevclass   = ( $setting =~ / prevclass="([^"]+)"/i )     ? $1 : '';
        my $nexttitle   = ( $setting =~ / nexttitle="([^"]+)"/i )     ? $1 : '';
        my $nexttext    = ( $setting =~ / nexttext="([^"]+)"/i )      ? $1 : '';
        my $nextclass   = ( $setting =~ / nextclass="([^"]+)"/i )     ? $1 : '';
        my $itemclass   = ( $setting =~ / itemclass="([^"]+)"/i )     ? $1 : '';
        my $linkclass   = ( $setting =~ / linkclass="([^"]+)"/i )     ? $1 : '';
        my $activeclass = ( $setting =~ / activeclass="([^"]+)"/i )   ? $1 : '';
        my $reverse     = ( $setting =~ / reverse="[0-9a-zA-Z_]+"/i ) ? 1  : 0;
        my $turner      = ( $setting =~ / turner="([^"]+)"/i )        ? $1 : '';
        $turner =
          ( $turner || $prevtitle || $prevtext || $nexttitle || $nexttext )
          ? 1
          : 0;
        my $margin = ( $setting =~ / margin="([0-9]+)"/i ) ? $1 : 2;
        $max = 7 if $max && $max < 7;
        $margin = int( ( $max - 5 ) / 2 ) if $max - $margin * 2 - 5 < 0;
        $margin = 1 if $margin < 1;
        my $prevnavi =
          ($turner)
          ? $this->item_tag_replace(
            'prevpage',
            ( ($linkclass) ? ' class="' . $linkclass . '"' : '' )
              . ( ($prevtitle) ? ' title="' . $prevtitle . '"' : '' )
              . ( ($prevtext)  ? ' text="' . $prevtext . '"'   : '' ),
            (
                ($is_list)
                ? '<!--head--><li class="'
                  . ( ($itemclass) ? $itemclass : '' )
                  . ( ($prevclass) ? $prevclass : 'prev' )
                  . '"><!--/head--><!--foot--></li><!--/foot-->'
                : ''
            ),
            $prevpage,
            1
          )
          : '';
        my $nextnavi =
          ($turner)
          ? $this->item_tag_replace(
            'nextpage',
            ( ($linkclass) ? ' class="' . $linkclass . '"' : '' )
              . ( ($nexttitle) ? ' title="' . $nexttitle . '"' : '' )
              . ( ($nexttext)  ? ' text="' . $nexttext . '"'   : '' ),
            (
                ($is_list)
                ? '<!--head--><li class="'
                  . ( ($itemclass) ? $itemclass : '' )
                  . ( ($nextclass) ? $nextclass : 'next' )
                  . '"><!--/head--><!--foot--></li><!--/foot-->'
                : ''
            ),
            $nextpage,
            1
          )
          : '';
        my $pagenavi = '';
        $pagenavi =
            ( ($is_list) ? '<ul'                     : '<div' )
          . ( ($class)   ? ' class="' . $class . '"' : '' )
          . ( ($id)      ? ' id="' . $id . '"'       : '' ) . '>'
          if $is_list || $class || $id;
        $pagenavi .= ($reverse) ? $nextnavi : $prevnavi;
        my $start_page =
          ( $p - $margin <=
              $page::list[$#page::list] - $max + 3 )
          ? ( $p - $margin > 3 )
              ? $p - $margin
              : 3
          : $page::list[$#page::list] - $max + 3;
        my $end_page = $start_page + $max - 5;
        my $omission = 0;
        my @list     = ();

        foreach my $page ( sort { $a <=> $b }
            @page::list )
        {
            if (
                (
                       $max
                    && $max < @page::list
                    && $page > 1
                    && $page <
                    $page::list[$#page::list]
                )
                && (
                    ( $p > $margin + 3 && $page < $start_page )
                    || (   $end_page < $page
                        && $end_page <
                        $page::list[$#page::list] -
                        2 )
                )
              )
            {
                $omission = 1;
                next;
            }
            if ($omission) {
                push(
                    @list,
                    (
                        ($is_list)
                        ? '<li class="omission'
                          . ( ($itemclass) ? ' ' . $itemclass : '' )
                          . '"><span'
                          . (
                            ($linkclass)
                            ? ' class="' . $linkclass . '"'
                            : ''
                          )
                          . '>...</span></li>'
                        : ' <span class="omission'
                          . ( ($itemclass) ? ' ' . $itemclass : '' )
                          . '"><span'
                          . (
                            ($linkclass)
                            ? ' class="' . $linkclass . '"'
                            : ''
                          )
                          . '>...</span></span>'
                    )
                );
                $omission = 0;
            }
            if ( $page == $p ) {
                push(
                    @list,
                    (
                        ($is_list)
                        ? '<li class="here'
                          . (
                            ($itemclass)
                            ? ' ' . $itemclass
                            : ''
                          )
                          . ( ($activeclass) ? ' ' . $activeclass : '' )
                          . '"><span'
                          . (
                            ($linkclass)
                            ? ' class="' . $linkclass . '"'
                            : ''
                          )
                          . '>'
                          . $page
                          . '</span></li>'
                        : ' <span class="here'
                          . ( ($itemclass)   ? ' ' . $itemclass   : '' )
                          . ( ($activeclass) ? ' ' . $activeclass : '' )
                          . '"><strong'
                          . (
                            ($linkclass)
                            ? ' class="' . $linkclass . '"'
                            : ''
                          )
                          . '>'
                          . $page
                          . '</strong></span>'
                    )
                );
            }
            else {
                push(
                    @list,
                    (
                        ($is_list)
                        ? '<li'
                          . (
                            ($itemclass)
                            ? ' class="' . $itemclass . '"'
                            : ''
                          )
                          . '><a href="./'
                          . $page . '.'
                          . $cgi::ext . '"'
                          . (
                            ($linkclass)
                            ? ' class="' . $linkclass . '"'
                            : ''
                          )
                          . '>'
                          . $page
                          . '</a></li>'
                        : ' <span'
                          . (
                            ($itemclass)
                            ? ' class="' . $itemclass . '"'
                            : ''
                          )
                          . '><a href="./'
                          . $page . '.'
                          . $cgi::ext . '"'
                          . (
                            ($linkclass)
                            ? ' class="' . $linkclass . '"'
                            : ''
                          )
                          . '>'
                          . $page
                          . '</a></span>'
                    )
                );
            }
        }
        $pagenavi .= join( '', ( ($reverse) ? reverse @list : @list ) );
        $pagenavi .= ($reverse) ? $prevnavi : $nextnavi;
        $pagenavi .= ($is_list) ? '</ul>'   : '</div>'
          if $is_list || $class || $id;
        return
            '<!--pagenavi'
          . $setting . '-->'
          . (
            ( $header ne '' ) ? '<!--head-->' . $header . '<!--/head-->'
            : ''
          )
          . '<!--data-->'
          . $pagenavi
          . '<!--/data-->'
          . (
            ( $footer ne '' ) ? '<!--foot-->' . $footer . '<!--/foot-->'
            : ''
          ) . '<!--/pagenavi-->';
    }
    else {
        return
            '<!--pagenavi'
          . $setting
          . (
            ( $header ne '' )
            ? ' head="' . $this->lf_to_entity( $this->escape($header) ) . '"'
            : ''
          )
          . (
            ( $footer ne '' )
            ? ' foot="' . $this->lf_to_entity( $this->escape($footer) ) . '"'
            : ''
          ) . '--><!--/pagenavi-->';
    }
}

sub get_entry_permalink ($$$) {
    my ( $this, $output, $setting ) = @_;
    my $permalink
        = $this->full_path( $default::home . '/'
            . $main::n . '/1.'
            . ( ( $output =~ /\.([0-9a-zA-Z_]+)$/ ) ? $1 : $default::ext ) );
    return ( $setting =~ / encode_url="1"/i )
        ? $this->url_encode($permalink)
        : $permalink;
}

sub link_replace ($$$$$$$$$;$$$) {
    my ($this, $tag,   $setting, $content, $dir,    $name,
        $type, $image, $alt,     $title,   $output, $option
    ) = @_;
    my ( $header, $footer )
        = $this->get_header_and_footer( $setting, $content );
    $setting =~ s/[\x09\x0A\x0C\x0D\x20]+head="([^"]+)"//sg;
    $setting =~ s/[\x09\x0A\x0C\x0D\x20]+foot="([^"]+)"//sg;
    $setting = '' if $setting eq '' || $setting !~ /[^\x09\x0A\x0C\x0D\x20]/;
    my $location = '';
    $name = '' if !defined $name;
    $dir  = '' if !defined $dir;

    if ( $name =~ /\.(html|htm|shtml|stml|shtm|stm)(#.*|)$/ ) {
        $location = $dir . '/' . $name;
    }
    elsif ( $name eq '' && $dir =~ /\.(html|htm|shtml|stml|shtm|stm)(#.*|)$/ )
    {
        $location = $dir;
    }
    elsif ( $dir ne '' && $name ne '' ) {
        $location = $this->fileglob( $dir,
            '^' . $name . '\.(html|htm|shtml|stml|shtm|stm)$', 'f' );
    }
    if ($location) {
        if ( defined $title && $title ne '' ) {
            $alt = $title;
        }
        elsif ( $setting =~ / title="([^"]+)"/i ) {
            $alt = $this->unescape($1);
        }
        if ( $setting =~ / text="([^"]+)"/i ) {
            my $text = $1;
            $content
                = '<a href="'
                . $this->escape_except_html_entity( ( $output || $option )
                ? $this->base_change( $location, $output, $option )
                : $location )
                . '"'
                . ( ( $setting =~ / class="([^"]+)"/i )
                ? ' class="' . $this->escape_except_html_entity($1) . '"'
                : '' )
                . ' title="'
                . $this->escape_except_html_entity($alt) . '">'
                . $this->escape_except_html_entity($text) . '</a>';
        }
        else {
            $this->use_deco($output) if defined $output && $output;
            $content = $cgi::Deco->button(
                $type,
                (   ( $setting =~ / image="([0-9]+)"/i )
                    ? $1
                    : $setting::page{$image}
                ),
                $location,
                $alt, '', '', $option
            );
        }
        return
              '<!--'
            . $tag
            . $setting . '-->'
            . ( ( $header ne '' ) ? '<!--head-->' . $header . '<!--/head-->'
            : '' )
            . '<!--data-->'
            . $content
            . '<!--/data-->'
            . ( ( $footer ne '' ) ? '<!--foot-->' . $footer . '<!--/foot-->'
            : '' )
            . '<!--/'
            . $tag . '-->';
    }
    else {
        return
              '<!--'
            . $tag
            . $setting
            . ( ( $header ne '' )
            ? ' head="' . $this->lf_to_entity( $this->escape($header) ) . '"'
            : '' )
            . ( ( $footer ne '' )
            ? ' foot="' . $this->lf_to_entity( $this->escape($footer) ) . '"'
            : '' )
            . '--><!--/'
            . $tag . '-->';
    }
}

sub tools_replace ($$$$$$$) {
    my ( $this, $tag, $setting, $content, $output, $option, $key ) = @_;
    my ( $header, $footer )
        = $this->get_header_and_footer( $setting, $content );
    $setting =~ s/[\x09\x0A\x0C\x0D\x20]+head="([^"]+)"//sg;
    $setting =~ s/[\x09\x0A\x0C\x0D\x20]+foot="([^"]+)"//sg;
    $setting = '' if $setting eq '' || $setting !~ /[^\x09\x0A\x0C\x0D\x20]/;
    my $alt
        = ( $setting =~ / title="([^"]+)"/i ) ? $this->unescape($1)
        : ( $tag eq 'edit' ) ? '編集'
        :                      '環境設定';
    my ( $image_type, $image_id )
        = ( $tag eq 'edit' )
        ? ( 'edit', $setting::page{'editButton'} )
        : ( 'tools', $setting::page{'toolButton'} );
    my $url
        = $ENV{'SCRIPT_NAME'} . '?'
        . ( ( $tag eq 'tool' ) ? 'm=Tools&amp;' : '' )
        . ( ( defined $main::c && $main::c ne '' && $key ne 'masterindex' )
        ? 'c=' . $main::c . '&amp;'
        : '' )
        . (
        (          $tag eq 'edit'
                && $key eq 'article'
                && defined $main::n
                && $main::n ne ''
        ) ? 'n=' . $main::n : ''
        );
    $url =~ s/\&amp;$//;

    if ( $setting =~ / text="([^"]+)"/i ) {
        my $text = $1;
        $content
            = '<a href="'
            . $url . '"'
            . ( ( $setting =~ / class="([^"]+)"/i )
            ? ' class="' . $this->escape_except_html_entity($1) . '"'
            : '' )
            . ' title="'
            . $this->escape_except_html_entity($alt) . '">'
            . $this->escape_except_html_entity($text) . '</a>';
    }
    else {
        $this->use_deco($output) if defined $output && $output;
        $content
            = $cgi::Deco->button( $image_type,
            ( ( $setting =~ / image="([0-9]+)"/i ) ? $1 : $image_id ),
            $url, $alt, '_blank', '', $option );
    }
    return
          '<!--'
        . $tag
        . $setting . '-->'
        . (
        ( $header ne '' ) ? '<!--head-->' . $header . '<!--/head-->' : '' )
        . '<!--data-->'
        . $content
        . '<!--/data-->'
        . (
        ( $footer ne '' ) ? '<!--foot-->' . $footer . '<!--/foot-->' : '' )
        . '<!--/'
        . $tag . '-->';
}

sub link_tag_replace ($$;$$$) {
    my ( $this, $template, $output, $option, $key ) = @_;

    if ( $key =~ /index/ && $key ne 'historyindex' ) {

        #インデックスリンク
        if ( defined $default::subdivided && $default::subdivided ) {
            $$template
                =~ s/<\!--indexpage(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/indexpage-->/$this->link_replace('indexpage',$1,$2,$master::home,'index.' . $default::ext,'index','indexButton',(($default::english) ? 'Index' : 'インデックス'),'',$output,$option)/sge;
        }
        else {
            $$template
                =~ s/<\!--indexpage(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/indexpage-->/$this->item_tag_replace('indexpage',$1,$2,'',1)/sge;
        }

        #履歴リンク
        $$template
            =~ s/<\!--history(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/history-->/$this->link_replace('history',$1,$2,$history::path,'index.' . $default::ext,'index','historyButton',(($default::english) ? 'History' : '履歴'),'',$output,$option)/sge
            if $key ne 'masterindex' && $history::path;

    }
    else {
        #インデックスリンク
        $$template
            =~ s/<\!--indexpage(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/indexpage-->/$this->link_replace('indexpage',$1,$2,$default::home,'index.' . $default::ext,'index','indexButton',(($default::english) ? 'Index' : 'インデックス'),'',$output,$option)/sge;

        #履歴リンク
        if ( defined $history::path && $history::path ) {
            if ( $key eq 'article' ) {
                $$template
                    =~ s/<\!--history(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/history-->/$this->link_replace('history',$1,$2,$history::home,'','index','historyButton',(($default::english) ? 'History' : '履歴'),'',$output,$option)/sge;
            }
            else {
                $$template
                    =~ s/<\!--history(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/history-->/$this->link_replace('history',$1,$2,$history::path,'index.' . $default::ext,'index','historyButton',(($default::english) ? 'History' : '履歴'),'',$output,$option)/sge;
            }
        }
    }

    #一番新しい履歴リンク
    $$template
        =~ s/<\!--latesthistory(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/latesthistory-->/$this->link_replace('history',$1,$2,$history::path,'latest.' . $default::ext,'index','latestHistoryButton',(($default::english) ? 'History' : '履歴'),'',$output,$option)/sge
        if $key ne 'masterindex' && $history::path;

    #ツールアイコン
    $$template
        =~ s/<\!--(edit|tool)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/\1-->/$this->tools_replace($1,$2,$3,$output,$option,$key)/iges;

    #最新記事情報
    if ( $key eq 'masterindex' ) {
        $$template
            =~ s/<\!--(navi)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/navi-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($master::home . '\/navi.ssi',1,$output,((defined $option && $option eq 'abs') ? 1 : 0)),1)/iges;
        $$template
            =~ s/<\!--(recentcomments)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/recentcomments-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($master::home . '\/recentcomments.ssi',1,$output,((defined $option && $option eq 'abs') ? 1 : 0)),1)/iges;
        $$template
            =~ s/<\!--(recenttrackbacks)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/recenttrackbacks-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($master::home . '\/recenttrackbacks.ssi',1,$output,((defined $option && $option eq 'abs') ? 1 : 0)),1)/iges;
    }
    else {
        $$template
            =~ s/<\!--(navi)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/navi-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($default::home . '\/navi.ssi',1,$output,((defined $option && $option eq 'abs') ? 1 : 0)),1)/iges;
        $$template
            =~ s/<\!--(recentcomments)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/recentcomments-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($default::home . '\/recentcomments.ssi',1,$output,((defined $option && $option eq 'abs') ? 1 : 0)),1)/iges;
        $$template
            =~ s/<\!--(recenttrackbacks)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/recenttrackbacks-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($default::home . '\/recenttrackbacks.ssi',1,$output,((defined $option && $option eq 'abs') ? 1 : 0)),1)/iges;
    }
    if ($default::subdivided) {
        $$template
            =~ s/<\!--(metanavi)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/metanavi-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($master::home . '\/navi.ssi',1,$output,((defined $option && $option eq 'abs') ? 1 : 0)),1)/iges;
        $$template
            =~ s/<\!--(metarecentcomments)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/metarecentcomments-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($master::home . '\/recentcomments.ssi',1,$output,((defined $option && $option eq 'abs') ? 1 : 0)),1)/iges;
        $$template
            =~ s/<\!--(metarecenttrackbacks)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/metarecenttrackbacks-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($master::home . '\/recenttrackbacks.ssi',1,$output,((defined $option && $option eq 'abs') ? 1 : 0)),1)/iges;
    }
    $$template
        =~ s/<\!--(masternavi)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/masternavi-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($env::externalfiles . '\/metaindex.ssi',1,$output,((defined $option && $option eq 'abs') ? 1 : 0)),1)/iges;
    $$template
        =~ s/<\!--(masterrecentcomments)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/masterrecentcomments-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($env::externalfiles . '\/recentcomments.ssi',1,$output,((defined $option && $option eq 'abs') ? 1 : 0)),1)/iges;
    $$template
        =~ s/<\!--(masterrecenttrackbacks)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/masterrecenttrackbacks-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($env::externalfiles . '\/recenttrackbacks.ssi',1,$output,((defined $option && $option eq 'abs') ? 1 : 0)),1)/iges;

    #画像付きリンク
    $$template
        =~ s/<\!--(link)(?![0-9a-zA-Z_])([^>]*)-->.*?<\!--\/link-->/$this->image_replace($2,$output,$option)/sge;

    #RSS
    if ( $key eq 'masterindex' ) {
        $$template
            =~ s/<\!--(rss)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/rss-->/$this->rss_link_replace($1,$2,$3,$master::home . '\/index.xml',1,$output,$option)/iges;
        $$template
            =~ s/<\!--(trackbackrss)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/trackbackrss-->/$this->rss_link_replace($1,$2,$3,$master::home . '\/trackback.xml',1,$output,$option)/iges;
        $$template
            =~ s/<\!--(commentrss)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/commentrss-->/$this->rss_link_replace($1,$2,$3,$master::home . '\/comment.xml',1,$output,$option)/iges;
        $$template
            =~ s/<\!--(podcast)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/podcast-->/$this->rss_link_replace($1,$2,$3,$master::home . '\/podcast.xml',1,$output,$option)/iges;
    }
    else {
        $$template
            =~ s/<\!--(rss)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/rss-->/$this->rss_link_replace($1,$2,$3,$default::home . '\/index.xml',1,$output,$option)/iges;
        $$template
            =~ s/<\!--(trackbackrss)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/trackbackrss-->/$this->rss_link_replace($1,$2,$3,$default::home . '\/trackback.xml',1,$output,$option)/iges;
        $$template
            =~ s/<\!--(commentrss)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/commentrss-->/$this->rss_link_replace($1,$2,$3,$default::home . '\/comment.xml',1,$output,$option)/iges;
        $$template
            =~ s/<\!--(podcast)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/podcast-->/$this->rss_link_replace($1,$2,$3,$default::home . '\/podcast.xml',1,$output,$option)/iges;
    }
    if ($default::subdivided) {
        $$template
            =~ s/<\!--(metarss)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/metarss-->/$this->rss_link_replace($1,$2,$3,$master::home . '\/index.xml',1,$output,$option)/iges
            if $master::home;
        $$template
            =~ s/<\!--(metacommentrss)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/metacommentrss-->/$this->rss_link_replace($1,$2,$3,$master::home . '\/comment.xml',1,$output,$option)/iges
            if $master::home;
        $$template
            =~ s/<\!--(metatrackbackrss)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/metatrackbackrss-->/$this->rss_link_replace($1,$2,$3,$master::home . '\/trackback.xml',1,$output,$option)/iges
            if $master::home;
        $$template
            =~ s/<\!--(metapodcast)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/metapodcast-->/$this->rss_link_replace($1,$2,$3,$master::home . '\/podcast.xml',1,$output,$option)/iges;
    }
}

sub image_replace ($$$;$) {
    my ( $this, $attributes, $output, $option ) = @_;
    my ( $link_attributes, $type, $image, $alt, $location, $target );
    $attributes = ''
        if $attributes eq '' || $attributes !~ /[^\x09\x0A\x0C\x0D\x20]/;
    $link_attributes = $attributes;
    $this->use_deco($output) if defined $output && $output;
    $alt = $this->unescape($1) if $attributes =~ s/ title="([^"]+)"//i;
    $image = lc $1 if $attributes =~ s/ image="([^"]+)"//i;
    $type
        = (    $image =~ s/^([0-9a-z_]+)button$/${1}Button/
            || $image =~ s/^([0-9a-z_]+)article$/${1}Article/
            || $image =~ s/^([0-9a-z_]+)history$/${1}History/ ) ? $1 : '';

    if ( $type eq 'top' ) {
        $type   = 'index';
        $target = '_top';
    }
    $location
        = $this->path_change( $1,
        $this->path_change( $output, $ENV{'SCRIPT_NAME'}, 'abs' ), 'abs' )
        if $attributes =~ s/ location="([^"]+)"//gi;
    $target = $1 if $attributes =~ s/ target="([^"]+)"//gi;
    return
          '<!--link'
        . $link_attributes . '-->'
        . $cgi::Deco->button( $type, $setting::page{$image}, $location, $alt,
        $target, $attributes, $option )
        . '<!--/link-->';
}

sub date_tag_replace ($$$;$$$$$) {
    my ( $this, $article, $template, $target, $date, $mtime, $link, $title )
        = @_;
    return unless ref $template;
    if ( !$mtime ) {
        if (   ( !$target || $this->{'keep_mtime'} )
            && ref $article
            && $$article
            =~ /<\!--mtime(?![0-9a-zA-Z_])([^>]*)-->.*?<\!--\/mtime-->/s
            && $1 =~ /[\x09\x0A\x0C\x0D\x20]+value="([0-9a-zA-Z_]+)"/ )
        {
            $mtime = $1;
        }
        else {
            $mtime = $this->time_id(
                ($cgi::output) ? ( stat $cgi::output )[9] : time );
        }
    }
    $date = $1
        if ( !$target || $this->{'keep_mtime'} )
        && ref $article
        && $$article
        =~ /<\!--date(?![0-9a-zA-Z_])([^>]*)-->.*?<\!--\/date-->/s
        && $1 =~ /[\x09\x0A\x0C\x0D\x20]+value="([0-9]+)"/;
    if ( $date && $date =~ /^[0-9]{4}/ ) {
        $date = substr( $date, 0, 8 );
        $date =~ s/00$//;
        $date =~ s/00$//;
        $date = $date * 100 if $date < 100;
    }
    else {
        $date
            = ( $target && $default::date && $main::n )
            ? substr( $main::n,       0, 8 )
            : substr( $this->time_id, 0, 8 );
    }

    #更新時更新
    $$template
        =~ s/<\!--(mtime)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/mtime-->/$this->date_replace($1,$2,$3,$mtime,0,$link,$title)/sge;

    #日付更新
    $$template
        =~ s/<\!--(date)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/date-->/$this->date_replace($1,$2,$3,$date,0,$link,$title)/sge;
}

sub date_replace ($$;$$$$$) {
    my ( $this, $tag, $attributes, $content, $time, $keep_mtime, $link,
        $title )
        = @_;
    my ( $type, $format, $date_only, $class, $id );
    if ( $content
        =~ s/[\x09\x0A\x0C\x0D\x20]*<\!--format(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/format(?![0-9a-zA-Z_])[^>]*-->//si
        )
    {
        $format = $1;
        $attributes
            .= ' format="'
            . $this->lf_to_entity( $this->escape($format) ) . '"'
            unless $attributes
            =~ s/([\x09\x0A\x0C\x0D\x20]+format[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*")[^"]*(")/$1 . $this->lf_to_entity($this->escape($format)) . $2/gesi;
    }
    elsif ( $attributes
        =~ /[\x09\x0A\x0C\x0D\x20]+format[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)"/si
        )
    {
        $format = $this->unescape( $this->entity_to_lf($1) );
    }
    my ( $header, $footer )
        = $this->get_header_and_footer( $attributes, $content );
    $attributes =~ s/[\x09\x0A\x0C\x0D\x20]+head="([^"]+)"//sgi;
    $attributes =~ s/[\x09\x0A\x0C\x0D\x20]+foot="([^"]+)"//sgi;
    $attributes = ''
        if $attributes eq '' || $attributes !~ /[^\x09\x0A\x0C\x0D\x20]/;
    $date_only = $1
        if $attributes
        && $attributes =~ /[\x09\x0A\x0C\x0D\x20]+dateonly="([12])"/si;
    if (   $attributes
        && $attributes =~ /[\x09\x0A\x0C\x0D\x20]+linked(?:="linked"|)/si )
    {
        $id = $1 if $attributes =~ /[\x09\x0A\x0C\x0D\x20]+id="(.*?)"/si;
        $class = $1
            if $attributes =~ /[\x09\x0A\x0C\x0D\x20]+class="(.*?)"/si;
    }
    else {
        undef $link;
    }
    if (   $keep_mtime
        && $attributes
        && $attributes =~ /[\x09\x0A\x0C\x0D\x20]+value="([^"]+)"/si )
    {
        $time = $1;
    }
    elsif ( $keep_mtime && $cgi::output && $tag eq 'mtime' ) {
        $time = $this->time_id( ( stat $cgi::output )[9] );
    }
    elsif ( !defined $time || !$time ) {
        $time = $this->time_id;
    }
    $type
        = (    $attributes
            && $attributes =~ /[\x09\x0A\x0C\x0D\x20]+type="([^"]+)"/s )
        ? $1
        : $setting::general{'datetype'};
    $attributes .= ' value="' . $time . '"'
        unless $attributes
        =~ s/[\x09\x0A\x0C\x0D\x20]+value="([^"]+)"/ value="$time"/gs;
    $type .= ( $date_only == 2 ) ? '>dnw' : '>d' if $date_only;
    return
          '<!--'
        . $tag
        . $attributes . '-->'
        . (
        ( $header ne '' ) ? '<!--head-->' . $header . '<!--/head-->' : '' )
        . ( ($link)
        ? '<a href="'
            . $link . '"'
            . ( ($id)    ? ' class="' . $id . '"'    : '' )
            . ( ($class) ? ' class="' . $class . '"' : '' )
            . ( ($title) ? ' title="' . $title . '"' : '' ) . '>'
        : '' )
        . $this->date( $time, 0, $type, $format )
        . ( ($link) ? '</a>' : '' )
        . (
        ( $footer ne '' ) ? '<!--foot-->' . $footer . '<!--/foot-->' : '' )
        . '<!--/'
        . $tag . '-->';
}

######################################################################
# 記事取得
sub mk_template_obj ($;$) {
    my ( $this, $infofield ) = @_;
    delete $this->{'template'}  if ref $this->{'template'};
    delete $this->{'field_obj'} if ref $this->{'field_obj'};
    if ( $infofield || ( $main::p && $main::p eq 'i' ) ) {
        $this->use_field( 'info', $default::field_pref_dir . '/infofield',
            2, 0, $setting::field_tag_enabled, 'info' )
            if !%info::obj;
        $this->{'template'}  = $this->mk_info_template_obj;
        $this->{'field_obj'} = \%info::obj;
        $this->{'field_for'} = \%info::for;
    }
    else {
        $this->{'template'}  = $this->mk_article_template_obj;
        $this->{'field_obj'} = \%field::obj;
        $this->{'field_for'} = \%field::for;
    }
}

sub mk_info_template_obj ($) {
    my $this = shift;
    my $obj = Template->new( \%info::obj, \%info::for, $frame::obj{'frame'} );
    $obj->set(
        'field_style_disabled' => 0
        , # 1=フォント設定を無視する/2=スタイル設定も無視する
        'field_tag_enabled' => $setting::field_tag_enabled
        ,   # tag=タグのみ/all=全設定を付記/no=タグをつけない
        'field_tag_name' =>
            'info',    # フィールドタグ デフォルトは<!--field-->
        'default'           => \$setting::page{'article'}{'template'},
        'link_id'           => 'i',
        'tategaki_disabled' => 1,
    );
    return $obj;
}

sub mk_article_template_obj ($) {
    my $this = shift;
    my $obj
        = Template->new( \%field::obj, \%field::for, $frame::obj{'frame'} );
    $obj->set(
        'field_style_disabled' => 0
        , # 1=フォント設定を無視する/2=スタイル設定も無視する
        'field_tag_enabled' => $setting::field_tag_enabled
        ,   # tag=タグのみ/all=全設定を付記/no=タグをつけない
        'field_tag_name' =>
            'field',    # フィールドタグ デフォルトは<!--field-->
        'chapter' => 'chapter',                               # chapter タグ
        'section' => 'section',                               # section タグ
        'default' => \$setting::page{'article'}{'template'},
        'chapter_limit' => $setting::page{'article'}{'ChapterLimit'},
        'section_limit' => $setting::page{'article'}{'SectionLimit'},
        'chapter_dir'   => $setting::page{'article'}{'ChapterDir'},
        'section_dir'   => $setting::page{'article'}{'SectionDir'},
        'link_id'       => 'a'
            . (
            ( !defined $main::p || $main::p eq '' || $main::p eq 'i' )
            ? '01'
            : sprintf( "%.2d", $main::p )
            ),
        'tategaki_disabled' => 1,
    );
    return $obj;
}

######################################################################
# 関連ページ更新
sub index_replace_multi ($;$) {
    my ( $this, $refresh_flag ) = @_;
    my ( $index_ext, $latest, $first, $kml, $url, $placemark_data_ref );
    $refresh_flag = 0 if !defined $refresh_flag;

    #KMLツール
    if (   defined $main::n
        && $main::n ne ''
        && defined $this->{'field_for'}{'coordinates'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'coordinates'} }
        && $this->{'field_obj'}{ $this->{'field_for'}{'coordinates'} }
        ->{'class'}
        && $this->{'field_obj'}{ $this->{'field_for'}{'coordinates'} }
        ->{'class'} eq 'webapi_gmap' )
    {
        require CMONOS::HomePageMaker::KMLTool;
        $kml = KMLTool->new( $this->{'template'} );
        if ( $main::delete
            || !$main::data{ $this->{'field_for'}{'coordinates'} }{'enabled'}
            )
        {
            $url = $this->full_path($default::home) . '/' . $main::n . '/';
            if ( ( !$main::delete || $main::delete ne 'n' ) && $main::p ) {
                $url .= ( ( $main::p eq 'i' ) ? '1' : $main::p ) . '.'
                    . $default::ext;
                if (   ( !$main::delete || $main::delete ne 'rmpage' )
                    && $main::p
                    && $main::p =~ /^[0-9]+$/
                    && $main::chap
                    && $main::chap =~ /^[0-9]+$/ )
                {
                    $url .= '#a' . sprintf( "%.2d", $main::p );
                    $url .= sprintf( "%.2d", $main::chap );
                    if (   $main::delete ne ''
                        && $main::sect
                        && $main::sect =~ /^[0-9]+$/ )
                    {
                        $url .= sprintf( "%.2d", $main::sect );
                    }
                }
            }
            $placemark_data_ref = {
                'link'   => $url,
                'delete' => 1,
            };
        }
        else {
            my $title
                = ($default::date)
                ? $this->date( substr( $main::n, 0, 8 ),
                0, $setting::general{'datetype'} )
                : $main::n;
            if ( !$main::p || $main::p eq 'i' ) {
                $url = $this->full_path(
                    $default::home . '/' . $main::n . '/1.' . $default::ext );
            }
            else {
                $url
                    = $this->full_path( $default::home . '/'
                        . $main::n . '/'
                        . $main::p . '.'
                        . $default::ext );
                $url
                    .= '#a'
                    . sprintf( "%.2d", $main::p )
                    . sprintf( "%.2d", $main::chap )
                    . sprintf( "%.2d", $main::sect )
                    if $main::chap
                    && $main::chap =~ /^[0-9]+$/
                    && $main::sect
                    && $main::sect =~ /^[0-9]+$/;
            }
            $placemark_data_ref = {
                'link'  => $url,
                'mtime' => (
                    (   ref $this->{'template'}{'stat'}
                            && $this->{'template'}{'stat'}{'mtime'}
                    ) ? $this->{'template'}{'stat'}{'mtime'} : time
                ),
                'coordinates' =>
                    $kml->mk_coordinates_from_template( \%main::data ),
                'name' => $kml->mk_name_from_template( \%main::data, $title ),
                'description' => $kml->mk_description_from_template(
                    $url,
                    \%main::data,
                    (   ( $main::p && $main::p eq 'i' )
                        ? $setting::page{'kmlDescriptionTemplateForInfo'}
                        : $setting::page{'kmlDescriptionTemplate'}
                    ),
                    $title
                ),
                'icon' => $kml->mk_icon_from_template( \%main::data ),
                'url'  => $kml->mk_kmlurl_from_template( \%main::data ),
            };
        }
    }

    #最新記事の更新
    if ( $refresh_flag != 1 ) {
        $latest = $this->make_alies_page( $article::latest, 'new' );
        $first  = $this->make_alies_page( $article::first,  'first' );
        if ( defined $article::latest && $article::latest ne '' && $latest ) {
            $latest =~ s/^.*\/(?=$article::latest)/\.\//;
            $this->write_html_file(
                $default::home . '/new.html',
                '<html><head><meta http-equiv="Refresh" content="0 ;URL='
                    . $latest
                    . '" /></head><body></body></html>',
                1
            );
        }
        if ( defined $article::first && $article::first ne '' && $first ) {
            $first =~ s/^.*\/(?=$article::first)/\.\//;
            $this->write_html_file(
                $default::home . '/first.html',
                '<html><head><meta http-equiv="Refresh" content="0 ;URL='
                    . $first
                    . '" /></head><body></body></html>',
                1
            );
        }

        #最新記事の更新
        $this->index_replace(
            $default::home,             'navi',
            'ssi',                      '',
            $setting::page{'template'}, '',
            $setting::page{'sort'},     $setting::page{'limit'},
            '',                         '',
            '',                         0,
            0,                          'abs',
            1
        );

        #インデックスの更新
        $this->index_replace(
            $default::home,
            'index',
            $default::ext,
            'index',
            $setting::page{'index'}{'template'},
            '',
            $setting::page{'index'}{'sort'},
            ( ($default::date) ? $setting::page{'index'}{'limit'} : '' )
        );

        #KMLの更新
        $kml->update(
            $default::home . '/index.kml',
            {   'name'        => $setting::general{'cginame'},
                'description' => $setting::general{'description'},
            },
            $placemark_data_ref,
            (   ($default::date)
                ? ( $setting::page{'index'}{'sort'},
                    $setting::page{'index'}{'limit'}
                    )
                : ()
            )
        ) if ref $kml;
    }

    #日付管理
    if ( $refresh_flag != 2 ) {
        if ( defined $default::date && $default::date ) {

            if ( defined $history::name && $history::name ) {

                #履歴ページタイトル
                my $title = $this->date(
                    substr(
                        $history::name,
                        0,
                        (   (   defined $setting::general{'historyType'}
                                    && $setting::general{'historyType'} eq 'd'
                            )
                            ? 8
                            : ( (   defined $setting::general{'historyType'}
                                        && $setting::general{'historyType'}
                                        eq 'y'
                                ) ? 4 : 6
                            )
                        )
                    ),
                    0,
                    $setting::general{'datetype'}
                );

                #履歴を更新
                $this->index_replace(
                    $history::path,                        $history::name,
                    $default::ext,                         'history',
                    $setting::page{'history'}{'template'}, $title,
                    $setting::page{'history'}{'sort'},     ''
                );

                #カレンダーの更新
                $this->mk_calendar($main::n)
                    if !$refresh_flag && !$main::delete;

                #履歴デフォルトの更新
                if ( defined $history::latest && $history::latest ) {
                    if ( ref $setting::page{'historyindex'}
                        && $this->historyindex_replace )
                    {
                        unlink(
                            $this->fileglob(
                                $history::path,
                                '^latest\.(html|htm|shtml|stml|shtm|stm)$'
                            )
                        );
                        $this->file_copy(
                            $history::path . '/' . $history::latest,
                            $history::path . '/latest.' . $default::ext
                        );
                    }
                    else {
                        $this->write_html_file(
                            $history::path . '/index.' . $default::ext,
                            '<html><head><meta http-equiv="Refresh" content="0 ;URL=./'
                                . $history::latest
                                . '" /></head><body></body></html>',
                            1
                        );
                    }
                }

                #KMLの更新
                $kml->update(
                    $history::path . '/' . $history::name . '.kml',
                    {   'name' => $setting::general{'cginame'} . ' ' . $title,
                        'description' => $setting::general{'description'},
                    },
                    $placemark_data_ref
                ) if ref $kml;
            }

        }
        else {
            $setting::page{'index'}{'limit'} = '';
        }
    }
    return if $refresh_flag;

    #マスターインデックスの更新
    if ( defined $default::subdivided && $default::subdivided ) {
        local %setting::page = %setting::indexpage;
        $this->index_replace(
            $master::home,
            'index',
            $default::ext,
            'masterindex',
            $setting::indexpage{'masterindex'}{'template'},
            '',
            $setting::indexpage{'masterindex'}{'sort'},
            $setting::indexpage{'masterindex'}{'limit'},
            $setting::indexpage{'masterindex'}{'reverse'},
            $setting::indexpage{'masterindex'}{'metasort'},
            $setting::indexpage{'masterindex'}{'metalimit'}
        );

        #最新記事の更新
        $this->index_replace(
            $master::home,
            'navi',
            'ssi',
            '',
            $setting::indexpage{'metanavi'}{'template'},
            '',
            $setting::indexpage{'metanavi'}{'sort'},
            $setting::indexpage{'metanavi'}{'limit'},
            $setting::indexpage{'metanavi'}{'reverse'},
            $setting::indexpage{'metanavi'}{'metasort'},
            $setting::indexpage{'metanavi'}{'metalimit'},
            0,
            0,
            'abs',
            1
        );

        #KMLの更新
        $kml->update(
            $master::home . '/index.kml',
            {   'name'        => $master::general{'cginame'},
                'description' => $master::general{'description'},
            },
            $placemark_data_ref,
            $setting::indexpage{'masterindex'}{'metasort'},
            $setting::indexpage{'masterindex'}{'metalimit'}
        ) if ref $kml;
    }

    #外部インデックスの更新
    $this->index_replace(
        $default::external_index,
        '',
        '',
        '',
        '',
        '',
        $setting::page{'index'}{'sort'},
        $setting::page{'index'}{'limit'},
        $setting::indexpage{'masterindex'}{'reverse'},
        $setting::indexpage{'masterindex'}{'metasort'},
        $setting::indexpage{'masterindex'}{'metalimit'},
        1,
        1
        )
        if $default::external_index
        && !$setting::general{'externalIndexDisabled'}
        && -f $default::external_index;

    #外部ナビの更新
    $this->index_replace( $default::external_navi, '', '', '', '', '', '',
        '', '', '', '', 1, 1, 'abs', 1 )
        if $default::external_navi
        && !$setting::general{'externalNaviDisabled'}
        && -f $default::external_navi;
    $this->index_replace( $default::external_navi2, '', '', '', '', '', '',
        '', '', '', '', 1, 1, 'abs', 1 )
        if $default::external_navi2
        && !$setting::general{'externalNavi2Disabled'}
        && -f $default::external_navi2;

    #waypoints.kml
    $this->waypoints_replace;

}

sub waypoints_replace ($) {
    my $this = shift;
    if (   defined $main::n
        && $main::n ne ''
        && $main::p
        && $main::p =~ /^[0-9]+$/
        && $main::chap
        && $main::chap =~ /^[0-9]+$/
        && $main::sect
        && $main::sect =~ /^[0-9]+$/ )
    {
        my $dir = ($main::pending) ? $main::n . '.pending' : $main::n;
        if ( -d $default::home . '/' . $dir ) {
            $this->set_dir( $default::home . '/' . $dir . '/i' );
            require CMONOS::CGI_Lib::WayPointsKML;
            WayPointsKML->new(
                $default::home . '/' . $dir . '/i/waypoints.kml',
                $this->{'field_obj'},
                $this->{'field_for'},
                $this->full_path(
                    $default::home . '/' . $dir . '/1.' . $default::ext
                ),
                )->update(
                $this->full_path(
                          $default::home . '/'
                        . $dir . '/'
                        . $main::p . '.'
                        . $default::ext
                    )
                    . '#a'
                    . sprintf( "%.2d", $main::p )
                    . sprintf( "%.2d", $main::chap )
                    . sprintf( "%.2d", $main::sect ),
                ( ($main::delete) ? {} : \%main::data ),
                $this->full_path(
                          $default::home . '/'
                        . $dir . '/'
                        . $main::p . '/'
                        . $main::chap . '/'
                        . $main::sect
                )
                );
        }
    }
}

sub make_alies_page ($$$) {
    my ( $this, $id, $name ) = @_;
    my $path = '';
    if ( $this->set_dir( $default::home . '/' . $name ) ) {
        my $alies = $default::home . '/' . $name . '/index.' . $default::ext;
        if ( !defined $id || $id eq '' || !-d $default::home . '/' . $id ) {
            $path = './index.' . $default::ext;
            $this->write_html_file(
                $alies,
                '<html><head><meta http-equiv="Refresh" content="0 ;URL=../index.'
                    . $default::ext
                    . '" /></head><body></body></html>',
                1
            );
        }
        else {
            $path = $this->fileglob( $default::home . '/' . $id, '^1\.' );
            my $base_url = $this->full_path($path);
            local ( *FILE, *COPY );
            if ( $path && open( FILE, $path ) ) {
                binmode FILE, ":utf8";
                flock( FILE, LOCK_SH );
                if ( open( COPY, ">>$alies" ) ) {
                    my $check = 0;
                    binmode COPY, ":utf8";
                    flock( COPY, LOCK_EX );
                    truncate( COPY, 0 );
                    seek( COPY, 0, 0 );
                    while (<FILE>) {
                        $check = 1
                            if !$check
                            && $_
                            =~ s/(<head(?![0-9a-zA-Z_])[^>]*>)/$1\x0A<base href="$base_url" \/>/i;
                        print COPY;
                    }
                    close(COPY);
                }
                close(FILE);
                chmod( $env::file_mode, $alies );
            }
        }
    }
    return $path;
}

######################################################################
# 履歴インデックスページ更新
sub historyindex_replace ($) {
    my $this = shift;
    return 0 if !$setting::page{'historyindex'}{'template'};
    my $template = $setting::page{'historyindex'}{'template'};
    my $path     = $history::path . '/index.' . $default::ext;
    $template = $this->{'template'}->deco( $template, $path );

    #履歴リスト
    my $history = {};
    local (*DIR);
    if ( opendir( DIR, $history::path ) ) {
        my @history_files = grep( $_ =~ /^[0-9]+\.s?html?$/i, readdir(DIR) );
        closedir(DIR);
        my $f;
        foreach $f (@history_files) {
            if ( $f =~ /^([0-9]{4})([0-9]{2})([0-9]{2})/ ) {
                $history->{$1}->{ ( $2 + 0 ) }->{ ( $3 + 0 ) } = $f;
            }
        }
    }
    else {
        push(
            @{ $this->{'dialog'} },
            '履歴ディレクトリを開けません。'
        );
        return 0;
    }
    $template
        =~ s/<!--historylist(?![0-9a-zA-Z_])([^<>]*?)-->(.*?)<!--\/historylist-->/$this->history_list($1,$2,$history)/esg;

    #履歴カレンダー
    my $cal = {};
    if ( opendir( DIR, $calendar::path ) ) {
        my @cal_files = grep( $_ =~ /^[0-9]{6}\.ssi$/, readdir(DIR) );
        closedir(DIR);
        my $f;
        foreach $f (@cal_files) {
            if ( $f =~ /^([0-9]{4})([0-9]{2})/ ) {
                $cal->{$1}->{ ( $2 + 0 ) } = $f;
            }
        }
    }
    else {
        push(
            @{ $this->{'dialog'} },
            'カレンダーディレクトリを開けません。'
        );
        return 0;
    }
    $template
        =~ s/<!--yhistory(?![0-9a-zA-Z_])([^<>]*?)-->(.*?)<!--\/yhistory-->/$this->yearly_history($1,$2,$cal,$history)/esg;
    undef $history;
    undef $cal;

    #日時/タイトル
    $this->date_tag_replace( '', \$template, 1 );
    $this->master_index_info_replace( \$template, 'historyindex' );
    $template
        =~ s/<\!--mastertitle(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/mastertitle(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('mastertitle',$1,$2,$master::general{'cginame'},1)/ges
        if defined $master::general{'cginame'}
        && $master::general{'cginame'} ne '';
    $template = $this->page_item_replace(
        $template,
        1, $path,
        (   ( $setting::page{'historyindex'}{'title'} )
            ? $setting::page{'historyindex'}{'title'}
            : 'Calendar'
        )
    );

    #インデックスリンク
    $this->link_tag_replace( \$template, $path, '', 'historyindex' );

    #カレンダーSSI
    $this->calendar_tag_replace( \$template, 'latest' );

    #インデックス更新
    $this->set_link_rel(
        {   'home' => {
                'href' => $this->base_change( $this->home_directory, $path ),
                'title' => ( ($env::title) ? $env::title : 'Home' )
            },
            'index' => (
                ($default::subdivided)
                ? { 'href'  => '../../index.' . $default::ext,
                    'title' => (
                        ( $setting::indexpage{'masterindex'}{'title'} )
                        ? $setting::indexpage{'masterindex'}{'title'}
                        : '総合インデックス'
                    )
                    }
                : { 'href'  => '../index.' . $default::ext,
                    'title' => (
                        ( $setting::page{'index'}{'title'} )
                        ? $setting::page{'index'}{'title'}
                        : 'インデックス'
                    )
                }
            )
        }
    );
    return $this->write_html_file( $path, $template, 1, 'historyindex' );
}

sub history_list ($$$$) {
    my ( $this, $setting, $contents, $history ) = @_;
    return '' if !%$history;
    my ( $header, $footer )
        = $this->get_header_and_footer( $setting, $contents );
    my ( $yearsort, $monthsort, $datetype )
        = $this->get_history_list_setting($setting);
    $datetype = $setting::general{'datetype'} if !$datetype;
    no warnings qw(numeric);
    my $list = '';
    my $y;

    foreach $y ( sort { $this->sort_by( \$a, \$b, $yearsort ) }
        keys %$history )
    {
        my $mon_list    = '';
        my $yearly_list = '';
        my $m;
        foreach $m ( sort { $this->sort_by( \$a, \$b, $monthsort ) }
            keys %{ $history->{$y} } )
        {
            if ( !$m ) {
                $yearly_list = $history->{$y}->{0}->{0};
            }
            else {
                my $day_list     = '';
                my $monthly_list = '';
                my $d;
                foreach $d ( sort { $a <=> $b || $a cmp $b }
                    keys %{ $history->{$y}->{$m} } )
                {
                    if ( !$d ) {
                        $monthly_list = $history->{$y}->{$m}->{0};
                    }
                    else {
                        $day_list
                            .= '<option value="./'
                            . $history->{$y}->{$m}->{$d} . '">'
                            . $this->get_mday_name( $d, $datetype )
                            . '</option>';
                    }
                }
                if ($day_list) {
                    $mon_list
                        .= '<form action="#"><select onchange="location.href=this.options[this.selectedIndex].value">';
                    my $month_name = $this->get_month_name( $m, $datetype );
                    $mon_list
                        .= '<option value="'
                        . ( ($monthly_list) ? './' . $monthly_list : '#' )
                        . '">'
                        . $month_name
                        . '</option>';
                    $mon_list
                        .= '<option value="./'
                        . $monthly_list . '">'
                        . $month_name
                        . '</option>'
                        if $monthly_list;
                    $mon_list .= $day_list;
                    $mon_list .= '</select></form>';
                }
                elsif ($monthly_list) {
                    $mon_list
                        .= '<li><a href="./'
                        . $monthly_list . '">'
                        . $this->get_month_name( $m, $datetype )
                        . '</a></li>';
                }
            }
        }
        $list
            .= '<li>'
            . ( ($yearly_list) ? '<a href="./' . $yearly_list . '">' : '' )
            . $this->get_year_name( $y, 6, 1, $datetype )
            . ( ($yearly_list) ? '</a>' : '' );
        $list .= '<ul class="mlist">' . $mon_list . '</ul>' if $mon_list;
        $list .= '</li>';
    }
    return ($list)
        ? $header
        . '<ul id="historylist" class="ylist">'
        . $list . '</ul>'
        . $footer
        : '';
}

sub yearly_history ($$$$$) {
    my ( $this, $setting, $template, $cal, $history ) = @_;
    return '' if !%$cal;
    my ( $yearsort, $monthsort, $datetype )
        = $this->get_history_list_setting($setting);
    $datetype = $setting::general{'datetype'} if !$datetype;
    my ( $separator, $separator_interval, $cal_header, $cal_footer );
    if ( $template
        =~ /<\!--separator(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/separator(?![0-9a-zA-Z_])[^>]*-->/s
        )
    {
        my $separator_option;
        ( $separator_option, $separator ) = ( $1, $2 );
        $separator_interval = ( $separator_option
                =~ /[\x09\x0A\x0C\x0D\x20]+interval="([0-9]+)"/si ) ? $1 : 1;
        $separator = $this->unescape($1)
            if $separator_option
            =~ /[\x09\x0A\x0C\x0D\x20]+value="([^"]+)"/si;
        $template
            =~ s/<\!--separator(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/separator(?![0-9a-zA-Z_])[^>]*-->//gs;
    }
    else {
        $separator_interval = 1;
        $separator          = '';
    }
    ( $cal_header, $cal_footer ) = $this->get_header_and_footer( $1, $2 )
        if $template
        =~ /<\!--ycal(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/ycal(?![0-9a-zA-Z_])[^>]*-->/s;
    no warnings qw(numeric);
    my $yhistory = '';
    my $y;
    foreach $y ( sort { $this->sort_by( \$a, \$b, $yearsort ) } keys %$cal ) {
        my $list = $template;
        my $ytitle
            = ( ( $history->{$y}->{0}->{0} )
            ? '<a href="./' . $history->{$y}->{0}->{0} . '">'
            : '' )
            . $this->get_year_name( $y, 6, 1, $datetype )
            . ( ( $history->{$y}->{0}->{0} ) ? '</a>' : '' );
        $list
            =~ s/<\!--ytitle(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/ytitle(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('ytitle',$1,$2,$ytitle)/ges;
        my $calendar = '';
        my $n        = 0;
        my $m;
        foreach $m ( sort { $this->sort_by( \$a, \$b, $monthsort ) }
            keys %{ $cal->{$y} } )
        {
            my $cal_table = $this->read_html_file(
                $calendar::path . '/' . $cal->{$y}->{$m} );
            next if !$cal_table || $cal_table !~ /[^\x09\x0A\x0C\x0D\x20]/;
            $calendar .= $separator
                if defined $separator
                && $separator ne ''
                && $separator_interval
                && $n++ % $separator_interval == 0
                && $n > 1;
            $calendar .= $cal_header . $cal_table . $cal_footer;
        }
        if ($calendar) {
            $list
                =~ s/<\!--ycal(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/ycal(?![0-9a-zA-Z_])[^>]*-->/$calendar/gs;
            $yhistory .= $list;
        }
    }
    return $yhistory;
}

sub get_history_list_setting ($$) {
    my ( $this, $setting ) = @_;
    my $yearsort
        = ( $setting =~ /[\x09\x0A\x0C\x0D\x20]*yearsort="([0-9a-zA-Z_]*)"/ )
        ? $1
        : '';
    my $monthsort
        = ( $setting =~ /[\x09\x0A\x0C\x0D\x20]*monthsort="([0-9a-zA-Z_]*)"/ )
        ? $1
        : '';
    my $datetype
        = ( $setting =~ /[\x09\x0A\x0C\x0D\x20]*datetype="([0-9a-zA-Z_]*)"/ )
        ? $1
        : '';
    return ( $yearsort, $monthsort, $datetype );
}

######################################################################
# カレンダーオブジェクト
sub mk_calendar_obj ($) {
    my $this = shift;
    require CMONOS::CGI_Lib::Calendar;
    $this->{'calendar'} = Calendar->new(
        'jcode' => 'utf8',                               # utf8/euc/jis/sjis
        'css'   => $setting::page{'calendar'}{'css'},    # 1=css
        'bg'    => $setting::page{'calendar'}{'bg'}
        ,    # 1=テーブルの背面を反映させる
        'cellpadding' => $setting::page{'calendar'}{'cellpadding'}
        ,    # cellpadding
        'cellspacing' => $setting::page{'calendar'}{'cellspacing'}
        ,    # cellspacing
        'border'      => $setting::page{'calendar'}{'border'},       # border
        'bordercolor' => $setting::page{'calendar'}{'bordercolor'}
        ,    # bordercolor
        'cellwidth'  => $setting::page{'calendar'}{'cellwidth'},   # セル幅
        'cellheight' => $setting::page{'calendar'}{'cellheight'}
        ,    # セル高さ
        'cellalign'  => $setting::page{'calendar'}{'cellalign'}, # セルalign
        'cellvalign' => $setting::page{'calendar'}{'cellvalign'}
        ,    # セルvalign
        'bgcolor'   => $setting::page{'calendar'}{'bgcolor'},  # 標準bgcolor
        'fontcolor' => $setting::page{'calendar'}{'fontcolor'}
        ,    # 標準文字色
        'fontsize' => $setting::page{'calendar'}{'fontsize'}
        ,    # 標準文字サイズ
        'style' => $setting::page{'calendar'}{'style'}
        ,    # 標準文字スタイル
        'bold' => $setting::page{'calendar'}{'bold'},    # 標準文字太字
        'headerfontcolor' => $setting::page{'calendar'}{'headerfontcolor'}
        ,                                                # 月名文字色
        'headerfontsize' => $setting::page{'calendar'}{'headerfontsize'}
        ,    # 月名文字サイズ
        'headerstyle' => $setting::page{'calendar'}{'headerstyle'}
        ,    # 月名文字スタイル
        'headerbold' => $setting::page{'calendar'}{'headerbold'}
        ,    # 月名文字太字
        'thbgcolor' => $setting::page{'calendar'}{'thbgcolor'}
        ,    # 曜日bgcolor
        'thfontcolor' => $setting::page{'calendar'}{'thfontcolor'}
        ,    # 曜日文字色
        'thfontsize' => $setting::page{'calendar'}{'thfontsize'}
        ,    # 曜日文字サイズ
        'thstyle' => $setting::page{'calendar'}{'thstyle'}
        ,    # 曜日文字スタイル
        'thbold' => $setting::page{'calendar'}{'thbold'}, # 曜日文字太字
        'linkstyle' => $setting::page{'calendar'}{'linkstyle'}
        ,    # リンク文字スタイル
        'linkbold' => $setting::page{'calendar'}{'linkbold'}
        ,    # リンク文字太字
        'weekformat' => $setting::page{'calendar'}{'weekformat'},    # 曜日
          #（j=日本語/e=英語/f=フル/u=ucfirst/U=大文字/l=小文字）
        'monthformat' => $setting::page{'calendar'}{'monthformat'},    # 月
          #（j=日本語/J=陰暦月名/e=英語/f=フル/u=ucfirst/U=大文字/l=小文字）
        'yearformat' => $setting::page{'calendar'}{'yearformat'},    # 年
             #（J=年号/w=西暦/j=西暦日本語表記/k=漢字表記）
        'saturdaybgcolor' => $setting::page{'calendar'}{'saturdaybgcolor'}
        ,    # 土曜日bgcolor
        'sundaybgcolor' => $setting::page{'calendar'}{'sundaybgcolor'}
        ,    # 日曜日bgcolor
        'holidaybgcolor' => $setting::page{'calendar'}{'holidaybgcolor'}
        ,    # 休日bgcolor
        'specialdaybgcolor' => $setting::page{'calendar'}{'specialdaybgcolor'}
        ,    # 特別な日bgcolor
        'specialwdaybgcolor' =>
            $setting::page{'calendar'}{'specialwdaybgcolor'}
        ,    # 特別な曜日bgcolor
        'specialwday' => $setting::page{'calendar'}{'specialwday'}
        ,    # 特別な曜日
        'specialwdayexception' =>
            $setting::page{'calendar'}{'specialwdayexception'}
        ,    # 特別な曜日例外
        'specialwdayextra' => $setting::page{'calendar'}
            {'specialwdayextra'}    # 特別な曜日追加
    );
    $this->{'calendar_css'} = $this->{'calendar'}->mk_css
        if !$setting::page{'calendar'}{'calcssunembedded'};
}

# カレンダー作成〜リンク
sub mk_calendar ($$) {
    my ( $this, $id ) = @_;
    my ($calendar, $mon_id,     $year,        $mon,     $mday,
        $url,      $cap_link,   $history_url, $date_id, $alt,
        $count,    %specialday, %cell
    );
    if ( $id =~ /^([0-9]{4})([0-9]{2})/ ) {
        $year    = $1;
        $mon     = $2 + 0;
        $date_id = substr( $id, 0, 8 );
        $mon_id  = substr( $id, 0, 6 );
    }
    else {
        return;
    }
    $calendar
        = $this->read_html_file( $calendar::path . '/' . $mon_id . '.ssi' );
    $history_url
        = $this->path_change(
        $history::path . '/' . $history::name . '.' . $default::ext,
        $ENV{'SCRIPT_NAME'}, 'abs' );
    if ( -f $history::path . '/' . $mon_id . '00.' . $default::ext ) {
        $cap_link
            = $this->path_change(
            $history::path . '/' . $mon_id . '00.' . $default::ext,
            $ENV{'SCRIPT_NAME'}, 'abs' );
    }
    if ( defined $setting::page{'calendar'}{'specialday'}
        && $setting::page{'calendar'}{'specialday'} )
    {
        while ( $setting::page{'calendar'}{'specialday'}
            =~ /^([0-9]{1,2})[\x20]*\/[\x20]*([0-9]{1,2})[\x20]*=[\x20]*(.*?)$/mg
            )
        {
            $specialday{ $1 + 0 }{ $2 + 0 } = $3;
        }
    }
    if ( defined $setting::page{'calendar'}{'addition'}
        && $setting::page{'calendar'}{'addition'} )
    {
        while ( $setting::page{'calendar'}{'addition'}
            =~ /^([0-9]{1,2})[\x20]*\/[\x20]*([0-9]{1,2})[\x20]*=[\x20]*(.*?)$/mg
            )
        {
            $cell{ $1 + 0 }{ $2 + 0 } = $3;
        }
    }
    if ( !defined $calendar || $calendar eq '' ) {
        $calendar = $this->{'calendar'}
            ->calendar( $year, $mon, \%specialday, \%cell, $cap_link );
    }
    else {
        $this->{'calendar'}->set_caption( \$calendar, $mon_id, $cap_link );
    }
    $count = 0;
    foreach my $n ( 0 .. 99 ) {
        my $dir = $date_id . sprintf( "%.2d", $n );
        if ( -d $default::home . '/' . $dir ) {
            $alt = $dir;
            $count++;
        }
        last if $count > 1;
    }
    if ($count) {
        if ( $count == 1 ) {
            $url
                = $this->path_change(
                $default::home . '/' . $alt . '/1.' . $default::ext,
                $ENV{'SCRIPT_NAME'}, 'abs' );
        }
        else {
            $url
                = $history_url . '#a'
                . substr( $id, 0, 8 )
                . $default::id
                . ( ($main::c) ? '_' . $main::c : '' );
        }
    }
    $this->{'calendar'}->set_link( \$calendar, $id, $url );
    $this->write_html_file( $calendar::path . '/' . $mon_id . '.ssi',
        $calendar, 1 );
    $this->mk_external_javascript( $calendar::path . '/' . $mon_id . '.ssi',
        $calendar::path . '/' . $mon_id . '.js', $calendar );

    #最近のカレンダー
    my ( @localtime, $fyear, $tyear, $fmon, $tmon, $span, $recent_calendars );
    $span
        = ( defined $setting::page{'calendar'}{'calSpan'} )
        ? $setting::page{'calendar'}{'calSpan'}
        : 1;

    @localtime = localtime(time);
    $tyear     = $fyear = $localtime[5] + 1900;
    $tmon      = $fmon = $localtime[4];
    if ($span) {
        if (  !$setting::page{'calendar'}{'calDirection'}
            || $setting::page{'calendar'}{'calDirection'} ne 'future' )
        {
            $fmon -= $span;
            $fyear
                += ( $fmon >= 0 )
                ? int( $fmon / 12 )
                : int( ( $fmon / 12 ) - 1 );
            $fmon = ( ( $fmon >= 0 ) ? $fmon : 12 + $fmon ) % 12;
        }
        if (  !$setting::page{'calendar'}{'calDirection'}
            || $setting::page{'calendar'}{'calDirection'} ne 'past' )
        {
            $tmon  += $span;
            $tyear += int( $tmon / 12 );
            $tmon = $tmon % 12;
        }
    }
    $fmon++;
    $tmon++;
    $recent_calendars = '';
YEAR:
    foreach my $year ( $fyear .. $tyear ) {
    MON:
        foreach my $mon ( 1 .. 12 ) {
            next MON if $year == $fyear && $mon < $fmon;
            next MON if $year == $tyear && $mon > $tmon;
            my ( $mon_id, $path, $cap_link );
            $mon_id = sprintf( "%.4d", $year ) . sprintf( "%.2d", $mon );
            $path = $calendar::path . '/' . $mon_id . '.ssi';
            $cap_link
                = $this->path_change(
                $history::path . '/' . $mon_id . '00.' . $default::ext,
                $ENV{'SCRIPT_NAME'}, 'abs' )
                if -f $history::path . '/' . $mon_id . '00.' . $default::ext;
            $recent_calendars
                .= ( -s $path )
                ? $this->read_file( $path, 1 )
                : $this->{'calendar'}
                ->calendar( $year, $mon, \%specialday, \%cell, $cap_link );
        }
    }
    $this->write_html_file( $calendar::path . '/recent_calendars.ssi',
        $recent_calendars, 1 );
    $this->mk_external_javascript(
        $calendar::path . '/recent_calendars.ssi',
        $calendar::path . '/recent_calendars.js',
        $recent_calendars
    );
}

######################################################################
# 関連ページ更新
sub index_replace ($$$$$;$$$$$$$$$$$) {
    my ($this,                  $path,          $name,
        $ext,                   $key,           $template,
        $title,                 $sort,          $limit,
        $subindex_reverse_flag, $metanavi_sort, $metanavi_limit,
        $notemplate,            $nocreate,      $option,
        $mk_javascript_flag
    ) = @_;
    my ($original,                    $index_template,
        $subindex_template,           $list_template,
        $master_limit,                $master_sort,
        $index_separator,             $index_separator_interval,
        $article_limit,               $article_sort,
        $subindex_separator,          $subindex_reverse_flag_old,
        $subindex_separator_interval, $article_separator,
        $article_separator_interval,  $c,
        $id,                          $metaindex,
        $recommendedindex,            $temp_index,
        $done,                        $kml_path,
        @subindex_info
    );
    local ( $cgi::output, $cgi::output_option );
    $done = 0;

    #インデックス名/カテゴリー名
    $id
        = ( defined $default::id && $default::id ne '' )
        ? $default::id
        : 'homepage';
    $c = ($default::subdivided) ? $main::c : 'main';

    #KML URL
    if ( $key && $name && $ext ) {
        $kml_path = $this->full_path( $path . '/' . $name . '.kml' );
    }

    #ページ読み込み
    if ( $ext && $name && $ext eq 'ssi' ) {
        $original = $this->read_html_file( $path . '/' . $name . '.ssi' );
    }
    else {
        $original = $this->read_html_file( $path, $name );
    }
    $path .= ( ($name) ? '/' . $name : '' ) . ( ($ext) ? '.' . $ext : '' );
    $cgi::output        = $path;
    $cgi::output_option = $option;

    if ( $original && $notemplate ) {
        $template = $original;
    }
    else {
        $template = $this->{'template'}->deco( $template, $path, $option );
    }

    return if !$original && $nocreate;
    $this->set_last_modified( $this->get_last_modified( \$original, $path )
            || time )
        if ( $key
        && $key eq 'masterindex'
        && $master::general{'lastModifiedHeaderEnabled'} )
        || ( ( !$key || $key ne 'masterindex' )
        && $setting::general{'lastModifiedHeaderEnabled'} );

    #メタインデックス更新
    $metanavi_sort  = $sort  if !defined $metanavi_sort  || !$metanavi_sort;
    $metanavi_limit = $limit if !defined $metanavi_limit || !$metanavi_limit;
    $metaindex
        = $this->metaindex_replace( \$template, \$original, $metanavi_sort,
        $metanavi_limit, $path, $option, $notemplate );
    $recommendedindex
        = $this->recommendedindex_replace( \$template, \$original,
        $metanavi_sort, $metanavi_limit, $path, $option, $notemplate );

#テンプレート解析〜セパレータの処理〜変更の必要がなければ中止
    (   $index_template, $index_separator, $index_separator_interval,
        $master_limit, $master_sort, $subindex_reverse_flag_old
    ) = $this->get_settings_of_template( \$template, 'index' );
    (   $subindex_template, $subindex_separator,
        $subindex_separator_interval, $article_limit, $article_sort
    ) = $this->get_settings_of_template( \$index_template, 'subindex' );
    ( $list_template, $article_separator, $article_separator_interval )
        = $this->get_settings_of_template( \$subindex_template, 'article' );

#return if !$metaindex && !$recommendedindex && !$this->index_is_replaceable($main::delete,$main::n,$main::p,\$list_template);

    $this->{'anchor_id'} = {};

    #デフォルトのインデックスアイコン
    my $default_index_icon = '';
    if ( defined $default::subdivided && $default::subdivided ) {
        my $index_title
            = ( $master::general{'cginame'} ne '' )
            ? $master::general{'cginame'}
            : $default::id;
        my $index_url
            = $this->base_change( $master::home . '/index.' . $default::ext,
            $path, $option );
        my $index_icon = $this->get_icon_tag(
            $master::home,
            $master::general{'icon'},
            $master::general{'iconwidth'},
            $master::general{'iconheight'}, $index_title
        );
        $default_index_icon
            = '<a href="' . $index_url . '">' . $index_icon . '</a>'
            if defined $index_icon && $index_icon;
    }

    $this->set_list_item_template( \$list_template );

    #インデックススキャン
    $subindex_reverse_flag = $subindex_reverse_flag_old
        if !defined $subindex_reverse_flag || $subindex_reverse_flag eq '';
    $temp_index = '';
INDEX:
    while ( $original
        =~ /<!--index(?![0-9a-zA-Z_])([^>]*)-->(.*?)<!--\/index-->/sg )
    {
        my ( $index_setting, $index_id, $index, $this_index_is_target,
            $temp_subindex, $index_title, $index_icon, $index_description );
        ( $index_setting, $index ) = ( $1, $2 );
        $index_id
            = ( $index_setting =~ /[\x09\x0A\x0C\x0D\x20]*id="([^"]+)"/s )
            ? $1
            : ( ($done) ? '' : $id );
        $this_index_is_target = 0;
        $temp_subindex        = '';
        next INDEX if $index_id eq '';

        if ( $index_id eq $id ) {
            $this_index_is_target = 1;
            $master_limit
                = ($limit) ? $limit
                : (
                $index_setting =~ /[\x09\x0A\x0C\x0D\x20]*limit="([0-9]*)"/s )
                ? $1
                : ($master_limit) ? $master_limit
                :                   '';
            $master_sort
                = ($sort) ? $sort
                : (
                $index_setting =~ /[\x09\x0A\x0C\x0D\x20]*sort="([^"]*)"/s )
                ? $1
                : ($master_sort) ? $master_sort
                :                  '';
            $subindex_reverse_flag
                = ( $subindex_reverse_flag ne '' )
                ? $subindex_reverse_flag
                : ( $index_setting
                       =~ /[\x09\x0A\x0C\x0D\x20]*reverse="([0-9a-zA-Z_]*)"/s
                    && $1 ne ''
                    && $1 ne 'no' ) ? 1
                : 0;
        }
        else {
            $master_limit
                = (
                $index_setting =~ /[\x09\x0A\x0C\x0D\x20]*limit="([0-9]*)"/s )
                ? $1
                : ($master_limit) ? $master_limit
                :                   $limit;
            $master_sort
                = (
                $index_setting =~ /[\x09\x0A\x0C\x0D\x20]*sort="([^"]*)"/s )
                ? $1
                : ($master_sort) ? $master_sort
                :                  $sort;
            $subindex_reverse_flag
                = ( $index_setting
                       =~ /[\x09\x0A\x0C\x0D\x20]*reverse="([0-9a-zA-Z_]*)"/s
                    && $1 ne ''
                    && $1 ne 'no' ) ? 1
                : ( $subindex_reverse_flag ne '' ) ? $subindex_reverse_flag
                :                                    0;

            #スキップ
            if ( $notemplate && !$master_limit ) {
                $temp_index .= '<!--index'
                    . $this->index_setting( $index_id, $master_sort,
                    $master_limit, $subindex_reverse_flag )
                    . '-->'
                    . $index
                    . '<!--/index-->';
                next INDEX;
            }
        }

        #サブインデックススキャン
    SUBINDEX:
        while ( $index
            =~ s/<!--subindex(?![0-9a-zA-Z_])([^>]*)-->(.*?)<!--\/subindex-->//s
            )
        {
            my ($subindex_setting,     $subindex_id,
                $subindex,             $this_subindex_is_target,
                $temp_article,         $this_limit,
                $this_sort,            $subindex_title,
                $subindex_description, $subindex_icon,
                $subindex_count
            );
            ( $subindex_setting, $subindex ) = ( $1, $2 );
            $subindex_id
                = (
                $subindex_setting =~ /[\x09\x0A\x0C\x0D\x20]*id="([^"]+)"/s )
                ? $1
                : ($done) ? ''
                :           $c;
            $this_subindex_is_target = 0;
            next SUBINDEX if $subindex_id eq '';

            if ( $this_index_is_target && $subindex_id eq $c ) {
                $this_subindex_is_target = 1;
                if ($this_subindex_is_target
                    && (   ( defined $main::delete && $main::delete eq 'c' )
                        || ( !$notemplate && !$article::count ) )
                    )
                {
                    $done++;
                    next SUBINDEX;
                }
                $this_limit
                    = ($article_limit) ? $article_limit
                    : ($limit)        ? $limit
                    : ($master_limit) ? $master_limit
                    : ( $subindex_setting
                        =~ /[\x09\x0A\x0C\x0D\x20]*limit="([0-9]*)"/s ) ? $1
                    : '';
                $this_sort
                    = ($article_sort) ? $article_sort
                    : ($sort)        ? $sort
                    : ($master_sort) ? $master_sort
                    : ( $subindex_setting
                        =~ /[\x09\x0A\x0C\x0D\x20]*sort="([^"]*)"/s ) ? $1
                    : '';
            }
            else {
                $this_limit
                    = ( $subindex_setting
                        =~ /[\x09\x0A\x0C\x0D\x20]*limit="([0-9]*)"/s ) ? $1
                    : ( ($done) ? ''
                    : ($article_limit) ? $article_limit
                    : ($limit)         ? $limit
                    :                    $master_limit );
                $this_sort
                    = ( $subindex_setting
                        =~ /[\x09\x0A\x0C\x0D\x20]*sort="([^"]*)"/s ) ? $1
                    : ($article_sort) ? $article_sort
                    : ($sort)         ? $sort
                    :                   $master_sort;

                #スキップ
                if ( $notemplate && !$this_limit ) {
                    $temp_subindex .= '<!--subindex'
                        . $this->index_setting( $subindex_id, $this_sort,
                        $this_limit )
                        . '-->'
                        . $subindex
                        . '<!--/subindex-->';
                    next SUBINDEX;
                }
            }

            $temp_article = $this->article_list_replace(
                \$subindex,               \$list_template,
                $this_subindex_is_target, \$done,
                \$article_separator,      $article_separator_interval,
                $this_sort,               $this_limit,
                $path,                    $option,
                $notemplate
            );

            #サブインデックス名
            if ($this_subindex_is_target) {
                $subindex_title       = $setting::general{'cginame'};
                $subindex_description = $this->autolink(
                    $this->tag_fix(
                        $this->autolist( $setting::general{'description'} ),
                        2
                    ),
                    0,
                    $setting::general{'addressProtector'}
                );
                $subindex_icon = $this->get_icon_tag(
                    $default::home,
                    $setting::general{'icon'},
                    $setting::general{'iconwidth'},
                    $setting::general{'iconheight'},
                    $subindex_title
                );
                $subindex_count = $article::count;
            }
            else {
                (   $subindex_title, $subindex_description,
                    $subindex_icon,  $subindex_count
                ) = $this->get_index_title( \$subindex );
            }
            my $subindex_url = $this->base_change(
                (   ($default::subdivided)
                    ? $master::home . '/' . $subindex_id
                    : $default::home
                )
                . '/index.'
                    . $default::ext,
                $path, $option
            );
            $subindex_title
                = '<a href="'
                . $subindex_url . '">'
                . $subindex_title . '</a>'
                if defined $subindex_title && $subindex_title;
            $subindex_icon
                = '<a href="'
                . $subindex_url . '">'
                . $subindex_icon . '</a>'
                if defined $subindex_icon && $subindex_icon;

            #タグ追加
            my $subindex_template2 = $subindex_template;
            $this->index_info_replace(
                \$subindex_template2,  $subindex_title,
                $subindex_description, $subindex_icon,
                $subindex_count,       $default_index_icon
            );

            my $readmore_url
                = ( $key eq 'index' && $default::date )
                ? $this->subindex_history_link( \$temp_article, $subindex_id,
                $subindex_url, $path, $option )
                : ( $key eq 'history' && $default::date )
                ? $this->base_change(
                $history::path . '/index.' . $default::ext,
                $path, $option )
                : $subindex_url;
            $subindex_template2
                =~ s/<\!--readmore(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/readmore-->/$this->readmore_replace($1,$2,$readmore_url,'もっと見る...')/seg;

            push(
                @subindex_info,
                [   $subindex_title, $subindex_description,
                    $subindex_icon,  $subindex_count,
                    $default_index_icon
                ]
            ) if $this_index_is_target;
            $this->date_tag_replace( \$subindex, \$subindex_template2,
                $this_subindex_is_target, $name, '', $subindex_url );
            $subindex_template2
                =~ s/<\!--article--><\!--\/article-->/$temp_article/s;
            $temp_subindex
                .= '<!--subindex'
                . $this->index_setting( $subindex_id, $this_sort,
                $this_limit )
                . '-->'
                . $subindex_template2
                . '<!--/subindex-->';
        }

        #リストに追加
        if (   $this_index_is_target
            && !$done
            && defined $main::n
            && $main::n ne '' )
        {
            if ( !$main::delete || $main::delete ne 'n' ) {
                my ( $subindex_template2, $subindex_url, $subindex_title,
                    $subindex_description, $subindex_icon, $readmore_url );
                $subindex_template2 = $subindex_template;

                $subindex_url
                    = $this->base_change(
                    $default::home . '/index.' . $default::ext,
                    $path, $option );
                $subindex_icon = $this->get_icon_tag(
                    $default::home,
                    $setting::general{'icon'},
                    $setting::general{'iconwidth'},
                    $setting::general{'iconheight'},
                    $setting::general{'cginame'}
                );
                $subindex_title
                    = '<a href="'
                    . $subindex_url . '">'
                    . $setting::general{'cginame'} . '</a>'
                    if defined $setting::general{'cginame'}
                    && $setting::general{'cginame'};
                $subindex_icon
                    = '<a href="'
                    . $subindex_url . '">'
                    . $subindex_icon . '</a>'
                    if defined $subindex_icon && $subindex_icon;
                $subindex_description = $this->autolink(
                    $this->tag_fix(
                        $this->autolist( $setting::general{'description'} ),
                        2
                    ),
                    0,
                    $setting::general{'addressProtector'}
                );

                $this->index_info_replace(
                    \$subindex_template2,  $subindex_title,
                    $subindex_description, $subindex_icon,
                    $article::count,       $default_index_icon
                );
                $readmore_url
                    = ( $key eq 'index' && $default::date )
                    ? $this->subindex_history_link( $main::n, $c,
                    $subindex_url, $path, $option )
                    : ( $key eq 'history' && $default::date )
                    ? $this->base_change(
                    $history::path . '/index.' . $default::ext,
                    $path, $option )
                    : $subindex_url;
                $subindex_template2
                    =~ s/<\!--readmore(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/readmore-->/$this->readmore_replace($1,$2,$readmore_url,'もっと見る...')/seg;

                push(
                    @subindex_info,
                    [   $subindex_title, $subindex_description,
                        $subindex_icon,  $article::count,
                        $default_index_icon
                    ]
                );
                $this->date_tag_replace( '', \$subindex_template2, 1, $name,
                    '', $subindex_url );
                $subindex_template2
                    =~ s/<\!--article--><\!--\/article-->/'<!--article id="' . $main::n . '"-->' . $this->list_replace('',$list_template,$main::n,1,$path,$option,$notemplate) . '<!--\/article-->'/se;
                $subindex_template2
                    .= '<!--separator interval="'
                    . $article_separator_interval
                    . '" value="'
                    . $this->escape($article_separator)
                    . '"--><!--/separator-->'
                    if defined $article_separator && $article_separator ne '';

                $temp_subindex = $this->add_subindex(
                    $temp_subindex,
                    '<!--subindex'
                        . $this->index_setting( $c, $master_sort,
                        $master_limit )
                        . '-->'
                        . $subindex_template2
                        . '<!--/subindex-->',
                    $subindex_reverse_flag,
                    ( ( $key eq 'tag' ) ? $c : '' )
                );
            }
            $done = 1;
        }

        #サブインデックスセパレータ
        if ($subindex_separator) {
            my ( $separator, $subindex_separator_check, $subindex_count );
            $separator
                = '<!--separator interval="'
                . $subindex_separator_interval . '"-->'
                . $subindex_separator
                . '<!--/separator-->';
            $temp_subindex
                =~ s/(<!--subindex(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/subindex-->)/($subindex_count++ > 1 && $subindex_separator_interval && ($subindex_count - 1) % $subindex_separator_interval == 0 && ++$subindex_separator_check) ? $separator . $1 : $1/egs;
            $temp_subindex
                .= '<!--separator interval="'
                . $subindex_separator_interval
                . '" value="'
                . $this->escape($subindex_separator)
                . '"--><!--/separator-->'
                if !defined $subindex_separator_check
                || !$subindex_separator_check;
        }

        #インデックス名
        if ( defined $default::subdivided && $default::subdivided ) {
            if ( defined $this_index_is_target && $this_index_is_target ) {
                $index_title
                    = ( defined $master::general{'cginame'}
                        && $master::general{'cginame'} ne '' )
                    ? $master::general{'cginame'}
                    : $default::id;
                $index_description = $this->autolink(
                    $this->tag_fix(
                        $this->autolist( $master::general{'description'} ), 2
                    ),
                    0,
                    $master::general{'addressProtector'}
                );
                $index_icon = $this->get_icon_tag(
                    $master::home,
                    $master::general{'icon'},
                    $master::general{'iconwidth'},
                    $master::general{'iconheight'},
                    $index_title
                );
            }
            else {
                ( $index_title, $index_description, $index_icon )
                    = $this->get_index_title( \$index );
            }
            my $index_url
                = $this->base_change(
                $master::home . '/index.' . $default::ext,
                $path, $option );
            $index_title
                = '<a href="' . $index_url . '">' . $index_title . '</a>'
                if $index_title;
            $index_icon
                = '<a href="' . $index_url . '">' . $index_icon . '</a>'
                if $index_icon;
        }

        #タグ追加
        my $index_template2 = $index_template;
        $this->index_info_replace(
            \$index_template2,  $index_title,
            $index_description, $index_icon
        );
        $this->date_tag_replace( \$index, \$index_template2,
            $this_index_is_target, $name );
        $index_template2
            =~ s/<!--subindex--><!--\/subindex-->/$temp_subindex/s;
        $temp_index
            .= '<!--index'
            . $this->index_setting( $index_id, $master_sort, $master_limit )
            . '-->'
            . $index_template2
            . '<!--/index-->';
    }

    #リストに追加
    if ( !$done && defined $main::n && $main::n ne '' ) {
        if ( !$main::delete || $main::delete ne 'n' ) {
            $limit = $master_limit if !$limit && $master_limit;
            $sort  = $master_sort  if !$sort  && $master_sort;
            my ( $subindex_template2, $subindex_url, $subindex_title,
                $subindex_description, $subindex_icon, $readmore_url );
            $subindex_template2 = $subindex_template;

            $subindex_url
                = $this->base_change(
                $default::home . '/index.' . $default::ext,
                $path, $option );
            $subindex_icon = $this->get_icon_tag(
                $default::home,
                $setting::general{'icon'},
                $setting::general{'iconwidth'},
                $setting::general{'iconheight'},
                $setting::general{'cginame'}
            );
            $subindex_title
                = '<a href="'
                . $subindex_url . '">'
                . $setting::general{'cginame'} . '</a>'
                if defined $setting::general{'cginame'}
                && $setting::general{'cginame'} ne '';
            $subindex_icon
                = '<a href="'
                . $subindex_url . '">'
                . $subindex_icon . '</a>'
                if defined $subindex_icon && $subindex_icon;
            $subindex_description = $this->autolink(
                $this->tag_fix(
                    $this->autolist( $setting::general{'description'} ), 2
                ),
                0,
                $setting::general{'addressProtector'}
            );

            $this->index_info_replace( \$subindex_template2, $subindex_title,
                $subindex_description, $subindex_icon, '',
                $default_index_icon );
            $readmore_url
                = ( $key eq 'index' && $default::date )
                ? $this->subindex_history_link( $main::n, $c, $subindex_url,
                $path, $option )
                : ( $key eq 'history' && $default::date )
                ? $this->base_change(
                $history::path . '/index.' . $default::ext,
                $path, $option )
                : $subindex_url;
            $subindex_template2
                =~ s/<\!--readmore(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/readmore-->/$this->readmore_replace($1,$2,$readmore_url,'もっと見る...')/seg;

            push(
                @subindex_info,
                [   $subindex_title, $subindex_description,
                    $subindex_icon,  '',
                    $default_index_icon
                ]
            );
            $this->date_tag_replace( '', \$subindex_template2, 1, $name, '',
                $subindex_url );
            $subindex_template2
                =~ s/<\!--article--><\!--\/article-->/'<!--article id="' . $main::n . '"-->' . $this->list_replace('',$list_template,$main::n,1,$path,$option,$notemplate) . '<!--\/article-->'/se;

            my $index_template2 = $index_template;
            if ( defined $default::subdivided && $default::subdivided ) {
                my $index_title
                    = ( defined $master::general{'cginame'}
                        && $master::general{'cginame'} ne '' )
                    ? $master::general{'cginame'}
                    : $default::id;
                my $index_url
                    = $this->base_change(
                    $master::home . '/index.' . $default::ext,
                    $path, $option );
                my $index_icon = $this->get_icon_tag(
                    $master::home,
                    $master::general{'icon'},
                    $master::general{'iconwidth'},
                    $master::general{'iconheight'},
                    $index_title
                );
                $index_title
                    = '<a href="' . $index_url . '">' . $index_title . '</a>';
                $index_icon
                    = '<a href="' . $index_url . '">' . $index_icon . '</a>'
                    if defined $index_icon && $index_icon;
                $this->index_info_replace(
                    \$index_template2,
                    $index_title,
                    $this->autolink(
                        $this->tag_fix(
                            $this->autolist(
                                $master::general{'description'}
                            ),
                            2
                        ),
                        0,
                        $master::general{'addressProtector'}
                    ),
                    $index_icon
                );
            }
            $this->date_tag_replace( '', \$index_template2, 1, $name );
            $index_template2
                =~ s/<!--subindex--><!--\/subindex-->/'<!--subindex' . $this->index_setting($c,$sort,$limit) . '-->' . $subindex_template2 . '<!--\/subindex-->'/se;

            $temp_index
                .= '<!--index'
                . $this->index_setting( $id, $sort, $limit ) . '-->'
                . $index_template2
                . '<!--/index-->';
        }
        $done = 1;
    }

    #日時/タイトル
    $this->date_tag_replace( '', \$template, 1, $name );
    $this->master_index_info_replace( \$template, $key );

    #インデックス完成
    $template =~ s/<\!--index--><\!--\/index-->/$temp_index/s
        if defined $temp_index && $temp_index;
    $template
        =~ s/<\!--mastertitle(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/mastertitle(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('mastertitle',$1,$2,$master::general{'cginame'},1)/ges
        if defined $master::general{'cginame'}
        && $master::general{'cginame'} ne '';
    $template =~ s/<\!--metaindex--><\!--\/metaindex-->/$metaindex/sig;
    $template
        =~ s/<\!--recommendedindex--><\!--\/recommendedindex-->/$recommendedindex/sig;

    $template
        =~ s/(<\!--categories-->.*?<\!--\/categories-->)/$this->replace_category_list($1,\@subindex_info)/sige;

    my ($written_flag);
    $written_flag = 1 if $template =~ /<body(?![0-9a-zA-Z_])[^>]*>/i;

    #インデックスリンク
    $this->link_tag_replace( \$template, $path, $option, $key );

    #GoogleMapインデックス
    $template
        =~ s/<\!--gmap(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/gmap(?![0-9a-zA-Z_])[^>]*-->/$this->gmap_iframe($1,$2,$kml_path,(($key && $key eq 'masterindex') ? $setting::indexpage{'masterindex'} : \%setting::page),$path,$option)/ges;

    if ($key) {
        $template = $this->page_item_replace(
            $template,
            1, $path,
            (     ($title) ? $title
                : ( $setting::page{$key}{'title'} )
                ? $setting::page{$key}{'title'}
                : $key
            )
        );
        my %link = ();

        $link{'home'} = {
            'href' =>
                $this->base_change( $this->home_directory, $path, $option ),
            'title' => ( ($env::title) ? $env::title : 'Home' )
        };
        if ( $key eq 'index' ) {
            $link{'index'} = {
                'href'  => '../index.' . $default::ext,
                'title' => (
                    ( $setting::indexpage{'masterindex'}{'title'} )
                    ? $setting::indexpage{'masterindex'}{'title'}
                    : '総合インデックス'
                )
                }
                if $default::subdivided;
            $link{'contents'} = {
                'href'  => './history/index.' . $default::ext,
                'title' => (
                    ( $setting::page{'historyindex'}{'title'} )
                    ? $setting::page{'historyindex'}{'title'}
                    : 'バックナンバーインデックス'
                )
                }
                if $default::date;

            #履歴の場合、前後ページリンク
        }
        elsif ( $key eq 'history' ) {
            $link{'index'} = ($default::subdivided)
                ? {
                'href'  => '../../index.' . $default::ext,
                'title' => (
                    ( $setting::indexpage{'masterindex'}{'title'} )
                    ? $setting::indexpage{'masterindex'}{'title'}
                    : '総合インデックス'
                )
                }
                : {
                'href'  => '../index.' . $default::ext,
                'title' => (
                    ( $setting::page{'index'}{'title'} )
                    ? $setting::page{'index'}{'title'}
                    : 'インデックス'
                )
                };
            $link{'contents'} = {
                'href'  => './index.' . $default::ext,
                'title' => (
                    ( $setting::page{'historyindex'}{'title'} )
                    ? $setting::page{'historyindex'}{'title'}
                    : 'バックナンバーインデックス'
                )
            };
            $link{'next'} = '';
            $link{'prev'} = '';
            $this->p_neighbor_link_replace(
                \$template,     $history::path,
                $history::prev, $history::next,
                $path,          $option,
                1,              $title,
                \%link
            );
        }

        if ($written_flag) {
            $this->replace_link_rel( \$template, \%link );
        }
        else {
            $this->set_link_rel( \%link );
        }
    }

    #カレンダーSSI
    if ( defined $default::date && $default::date ) {
        if ( $key eq 'history' ) {
            $this->calendar_tag_replace( \$template, $name );
        }
        else {
            $this->calendar_tag_replace( \$template, 'latest' );
        }
    }

    delete $this->{'anchor_id'};

    #インデックス更新
    $this->set_og_cgi_summary if $key;
    return $this->write_html_file( $path, $template,
        ( ( $name ne '' ) ? 1 : 0 ),
        $key, $mk_javascript_flag, $title );
}

sub subindex_history_link ($$$$$$) {
    my ( $this, $temp_article, $subindex_id, $subindex_url, $path, $option )
        = @_;
    my ( $start_id, $end_id, $history_path );
    if ( ref $temp_article ) {
        $end_id = $1
            if $$temp_article
            =~ /^.*?<!--article\s[^>]*id="([0-9]+)"[^>]*-->/s;
        $start_id = $1
            if $$temp_article
            =~ /<!--article\s[^>]*id="([0-9]+)"[^>]*-->((?:.(?!<\!--article\s[^>]*-->))*?)$/s;
        $start_id = $end_id if $end_id && $start_id && $start_id > $end_id;
    }
    else {
        $start_id = $temp_article;
    }
    return $subindex_url if !$start_id;
    $history_path
        = (   -f $history::path . '/'
            . substr( $start_id, 0, 8 ) . '.'
            . $default::ext )
        ? $history::path . '/'
        . substr( $start_id, 0, 8 ) . '.'
        . $default::ext
        : (   -f $history::path . '/'
            . substr( $start_id, 0, 6 ) . '00.'
            . $default::ext )
        ? $history::path . '/'
        . substr( $start_id, 0, 6 ) . '00.'
        . $default::ext
        : (   -f $history::path . '/'
            . substr( $start_id, 0, 4 ) . '0000.'
            . $default::ext )
        ? $history::path . '/'
        . substr( $start_id, 0, 4 ) . '0000.'
        . $default::ext
        : (    $setting::general{'historyType'}
            && $setting::general{'historyType'} eq 'd' )
        ? $history::path . '/'
        . substr( $start_id, 0, 8 ) . '.'
        . $default::ext
        : (    $setting::general{'historyType'}
            && $setting::general{'historyType'} eq 'y' )
        ? $history::path . '/'
        . substr( $start_id, 0, 4 ) . '0000.'
        . $default::ext
        : $history::path . '/'
        . substr( $start_id, 0, 6 ) . '00.'
        . $default::ext;
    return ($history_path)
        ? $this->base_change( $history_path, $path, $option ) . '#' . 'a'
        . substr( $start_id, 0, 8 )
        . $default::id
        . (
        ( $default::subdivided && $subindex_id ) ? '_' . $subindex_id : '' )
        : $subindex_url;
}

sub replace_category_list ($$$) {
    my ( $this, $template, $subindex_info ) = @_;
    $template
        =~ s/(<\!--category-->.*?<\!--\/category-->)(?:.*<\!--\/category-->)?/$this->_replace_category_list($1,$subindex_info)/sie;
    return $template;
}

sub _replace_category_list ($$$$) {
    my ( $this, $template, $subindex_info ) = @_;
    my ( @info, $list );
    if ( ref $subindex_info && @$subindex_info ) {
        @info = @$subindex_info;
    }
    else {
        @info = ( [ '', '', '', '', '' ] );
    }
    foreach my $i (@info) {
        my $temp = $template;
        $this->index_info_replace( \$temp, @$i );
        $list .= $temp;
    }
    return $list;
}

sub master_index_info_replace ($;$) {
    my ( $this, $template, $key ) = @_;
    my ( $title, $description, $icon );
    if ( $default::subdivided && ( !$key || $key eq 'masterindex' ) ) {
        $title
            = ( defined $master::general{'cginame'}
                && $master::general{'cginame'} ne '' )
            ? $master::general{'cginame'}
            : $default::id;
        $description = $this->autolink(
            $this->tag_fix(
                $this->autolist( $master::general{'description'} ), 2
            ),
            0,
            $master::general{'addressProtector'}
        );
        $icon = $this->get_icon_tag(
            $master::home,
            $master::general{'icon'},
            $master::general{'iconwidth'},
            $master::general{'iconheight'}, $title
        );
    }
    else {
        $title
            = ( $setting::general{'cginame'} ne '' )
            ? $setting::general{'cginame'}
            : $default::id;
        $description = $this->autolink(
            $this->tag_fix(
                $this->autolist( $setting::general{'description'} ), 2
            ),
            0,
            $setting::general{'addressProtector'}
        );
        $icon = $this->get_icon_tag(
            $default::home,
            $setting::general{'icon'},
            $setting::general{'iconwidth'},
            $setting::general{'iconheight'}, $title
        );
    }
    $this->index_info_replace( $template, $title, $description, $icon );
    return 1;
}

#メタナビ
sub metaindex_replace ($$$$$$;$) {
    my ( $this, $template, $original, $article_sort, $article_limit, $path,
        $option, $notemplate )
        = @_;
    my ( $metaindex_template, $article_separator,
        $article_separator_interval, $list_template, $attributes, $index,
        $done, $temp_article );
    if (   ref $template
        && defined $$template
        && $$template
        =~ s/<\!--metaindex(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/metaindex(?![0-9a-zA-Z_])[^>]*-->/<\!--metaindex--><\!--\/metaindex-->/si
        )
    {
        $attributes         = $1;
        $metaindex_template = $2;
        $article_limit      = $1
            if $attributes =~ /[\x09\x0A\x0C\x0D\x20]*limit="([0-9]*)"/;
        $article_sort = $1
            if $attributes =~ /[\x09\x0A\x0C\x0D\x20]*sort="([^"]*)"/;
        $metaindex_template = $this->include_header_and_footer( $attributes,
            $metaindex_template );
    }
    else {
        return '';
    }
    ( $list_template, $article_separator, $article_separator_interval )
        = $this->get_settings_of_template( \$metaindex_template, 'article' );
    $this->master_index_info_replace( \$metaindex_template );
    return ''
        if !$this->index_is_replaceable( $main::delete, $main::n, $main::p,
        \$list_template );
    $this->set_list_item_template( \$list_template );
    if ( $$original
        =~ s/<!--metaindex(?![0-9a-zA-Z_])([^>]*)-->(.*?)<!--\/metaindex-->/<\!--metaindex--><\!--\/metaindex-->/si
        )
    {
        ( $attributes, $index ) = ( $1, $2 );
        $article_limit = $1
            if !$article_limit
            && $attributes =~ /[\x09\x0A\x0C\x0D\x20]*limit="([0-9]*)"/;
        $article_sort = $1
            if !$article_sort
            && $attributes =~ /[\x09\x0A\x0C\x0D\x20]*sort="([^"]*)"/;
    }
    else {
        $index = '';
    }
    $done          = 0;
    $article_limit = 10 if !defined $article_limit || !$article_limit;
    $article_sort  = 'descend' if !defined $article_sort || !$article_sort;
    $temp_article  = $this->article_list_replace(
        \$index,             \$list_template,
        1,                   \$done,
        \$article_separator, $article_separator_interval,
        $article_sort,       $article_limit,
        $path,               $option,
        $notemplate,         1
    );
    $this->date_tag_replace( '', \$metaindex_template, 1 );
    $metaindex_template =~ s/<\!--article--><\!--\/article-->/$temp_article/s;
    return
          '<!--metaindex'
        . $this->index_setting( '', $article_sort, $article_limit ) . '-->'
        . $metaindex_template
        . '<!--/metaindex-->';
}

sub recommendedindex_replace ($$$$$$;$) {
    my ( $this, $template, $original, $article_sort, $article_limit, $path,
        $option, $notemplate )
        = @_;
    my ( $recommendedindex_template, $article_separator,
        $article_separator_interval, $list_template, $attributes, $index,
        $done, $temp_article );
    if (   ref $template
        && defined $$template
        && $$template
        =~ s/<\!--recommendedindex(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/recommendedindex(?![0-9a-zA-Z_])[^>]*-->/<\!--recommendedindex--><\!--\/recommendedindex-->/si
        )
    {
        my $attributes = $1;
        $recommendedindex_template = $2;
        $article_limit             = $1
            if $attributes =~ /[\x09\x0A\x0C\x0D\x20]*limit="([0-9]*)"/;
        $article_sort = $1
            if $attributes =~ /[\x09\x0A\x0C\x0D\x20]*sort="([^"]*)"/;
        $recommendedindex_template
            = $this->include_header_and_footer( $attributes,
            $recommendedindex_template );
    }
    else {
        return '';
    }
    ( $list_template, $article_separator, $article_separator_interval )
        = $this->get_settings_of_template( \$recommendedindex_template,
        'article' );
    $this->master_index_info_replace( \$recommendedindex_template );
    return ''
        if !$this->index_is_replaceable( $main::delete, $main::n, $main::p,
        \$list_template );
    $this->set_list_item_template( \$list_template );
    if ( $$original
        =~ s/<!--recommendedindex(?![0-9a-zA-Z_])([^>]*)-->(.*?)<!--\/recommendedindex-->/<\!--recommendedindex--><\!--\/recommendedindex-->/si
        )
    {
        ( $attributes, $index ) = ( $1, $2 );
        $article_limit = $1
            if !$article_limit
            && $attributes =~ /[\x09\x0A\x0C\x0D\x20]*limit="([0-9]*)"/;
        $article_sort = $1
            if !$article_sort
            && $attributes =~ /[\x09\x0A\x0C\x0D\x20]*sort="([^"]*)"/;
    }
    else {
        $index = '';
    }
    $done          = 0;
    $article_limit = 10 if !defined $article_limit || !$article_limit;
    $article_sort  = 'descend' if !defined $article_sort || !$article_sort;
    $temp_article  = $this->article_list_replace(
        \$index,             \$list_template,
        1,                   \$done,
        \$article_separator, $article_separator_interval,
        $article_sort,       $article_limit,
        $path,               $option,
        $notemplate,         1,
        ( ($main::recommend) ? 0 : 1 ),
    );
    $this->date_tag_replace( '', \$recommendedindex_template, 1 );
    $recommendedindex_template
        =~ s/<\!--article--><\!--\/article-->/$temp_article/s;
    return
          '<!--recommendedindex'
        . $this->index_setting( '', $article_sort, $article_limit ) . '-->'
        . $recommendedindex_template
        . '<!--/recommendedindex-->';
}

sub article_global_id ($$) {
    my ( $this, $id ) = @_;
}

sub article_id ($$) {
    my ( $this, $id ) = @_;
    return
          $default::name
        . ( ( defined $main::c && $main::c ne '' ) ? '-' . $main::c : '' )
        . ( ( defined $id      && $id ne '' )      ? '-' . $id      : '' );
}

#記事リスト更新
sub article_list_replace ($$$$$$$$$$$$;$) {
    my ($this,                       $subindex,
        $list_template,              $this_subindex_is_target,
        $done,                       $article_separator,
        $article_separator_interval, $article_sort,
        $article_limit,              $path,
        $option,                     $notemplate,
        $is_metaindex,               $is_recommendedindex,
    ) = @_;
    my ( $article_separator_check, $count, $temp_article, %article,
        $target_id, $sort_by_mtime, $sort_by_date );
    $temp_article = '';
    $target_id = ( defined $main::n ) ? $main::n : '';
    if ( $is_metaindex && $target_id ne '' ) {
        my $prefix = $default::id;
        $prefix =~ s/^_+//;
        $prefix =~ s/_/-/g;
        $target_id
            = $prefix
            . ( ( defined $main::c && $main::c ne '' ) ? '-' . $main::c : '' )
            . ( ( defined $target_id && $target_id ne '' )
            ? '-' . $target_id
            : '' );
    }
    if ($article_sort) {
        $article_sort = lc $article_sort;
        if ( $article_sort =~ s/date// ) {
            $sort_by_date = 1;
        }
        elsif ( $article_sort =~ s/mtime// ) {
            $sort_by_mtime = 1;
        }
        $article_sort = $1 if $article_sort =~ /(descend|ascend)/;
    }

    #リストスキャン
LIST:
    while ( $$subindex
        =~ s/<!--article(?![0-9a-zA-Z_])([^>]*)-->(.*?)<!--\/article-->//s )
    {
        my ( $article_id, $article_mtime, $article_setting, $article,
            $this_article_is_target );
        $this_article_is_target = 0;
        ( $article_setting, $article ) = ( $1, $2 );
        $article_id
            = ( $article_setting =~ /[\x09\x0A\x0C\x0D\x20]+id="([^"]+)"/s )
            ? $1
            : '';
        next LIST if !defined $article_id || $article_id eq '';
        $$done = $this_article_is_target = 1
            if $this_subindex_is_target && $article_id eq $target_id;

        #ターゲット記事削除
        next LIST
            if $this_article_is_target
            && $main::delete
            && $main::delete eq 'n';

#ターゲット記事書き換え/新しいテンプレートに従って書き換える
        $article_mtime
            = (    $this_article_is_target
                && $this->{'keep_mtime'}
                && $this->{'template'}->{'stat'}{'mtime'} )
            ? $this->{'template'}->{'stat'}{'mtime'}
            : ( $this_article_is_target && !$this->{'keep_mtime'} )
            ? $this->time_id
            : (
            $article_setting =~ /[\x09\x0A\x0C\x0D\x20]*mtime="([0-9]+)"/s )
            ? $1
            : $this->get_article_mtime($article_id);
        $article_mtime = $this->time_id($article_mtime)
            if $article_mtime < 19000000000000;
        $article{
            $this->article_key(
                \%article,      $article_id,   $article_mtime,
                $sort_by_mtime, $sort_by_date, $is_metaindex
            )
            }
            = '<!--article id="'
            . $article_id
            . '" mtime="'
            . $article_mtime . '"-->'
            . $this->list_replace(
            $article,    $$list_template,
            $article_id, $this_article_is_target,
            $path,       $option,
            $notemplate, $is_metaindex,
            $article_mtime
            ) . '<!--/article-->';
    }

    #リストに追加
    if (   $this_subindex_is_target
        && !$$done
        && !$is_recommendedindex
        && defined $main::n
        && $main::n ne '' )
    {
        if (( !$main::delete || $main::delete ne 'n' )
            && (   !$article_limit
                || ( !$sort_by_date && !$sort_by_mtime )
                || !$this->{'keep_mtime'}
                || (   $this->{'keep_mtime'}
                    && defined $this->{'template'}->{'stat'}
                    && $this->{'template'}->{'stat'}{'mtime'} )
            )
            )
        {
            my $article_mtime
                = (    $this->{'keep_mtime'}
                    && defined $this->{'template'}->{'stat'}
                    && $this->{'template'}->{'stat'}{'mtime'} )
                ? $this->{'template'}->{'stat'}{'mtime'}
                : $this->time_id;
            $article_mtime = $this->time_id($article_mtime)
                if $article_mtime < 19000000000000;
            $article{
                $this->article_key(
                    \%article,      $target_id,    $article_mtime,
                    $sort_by_mtime, $sort_by_date, $is_metaindex
                )
                }
                = '<!--article id="'
                . $target_id
                . '" mtime="'
                . $article_mtime . '"-->'
                . $this->list_replace( '', $$list_template, $main::n, 1,
                $path, $option, $notemplate, $is_metaindex )
                . '<!--/article-->';
        }
        $$done = 1;
    }

    #リスト整列
    foreach
        my $article_key ( sort { $this->sort_by( \$a, \$b, $article_sort ) }
        keys %article )
    {

        #セパレータ
        if (   $$article_separator ne ''
            && $count
            && $article_separator_interval
            && $count % $article_separator_interval == 0 )
        {
            $temp_article
                .= '<!--separator interval="'
                . $article_separator_interval . '"-->'
                . $$article_separator
                . '<!--/separator-->';
            $article_separator_check++;
        }
        $count++;
        last if $article_limit && $article_limit < $count;
        $temp_article .= $article{$article_key};
    }
    if ( $$article_separator ne '' && !$article_separator_check ) {
        $temp_article
            .= '<!--separator interval="'
            . $article_separator_interval
            . '" value="'
            . $this->escape($$article_separator)
            . '"--><!--/separator-->';
    }
    return ( $temp_article ne '' )
        ? $temp_article
        : $this->shrink_article_template($$list_template);
}

sub article_key ($$$$$) {
    my ($this,          $article_hash, $article_id, $article_mtime,
        $sort_by_mtime, $sort_by_date, $is_metaindex
    ) = @_;
    my $article_key = '';
    if ($sort_by_mtime) {
        $article_key = $article_mtime;
        $article_key++ while defined $article_hash->{$article_key};
    }
    else {
        $article_key = $article_id;
        $article_key = $1
            if $is_metaindex && $article_key =~ /-([0-9a-zA-Z_]+)$/;
        if ($sort_by_date) {
            if ( $article_key =~ /^[0-9]{10}$/ ) {
                $article_key *= 10000;
            }
            else {
                $article_key = $article_mtime;
            }
            $article_key++ while defined $article_hash->{$article_key};
        }
    }
    return $article_key;
}

sub get_article_mtime ($$) {
    my ( $this, $article_id ) = @_;
    if ( $article_id =~ /^([0-9]{4}[0-9]{2}[0-9]{2})[0-9]+/ ) {
        return $1 . '000000';
    }
    else {
        return $this->time_id;
    }
}

sub set_list_item_template ($$) {
    my ( $this, $template ) = @_;
    $$template
        =~ s/<\!--\/subtitle(?![0-9a-zA-Z_])[^>]*-->[\x09\x0A\x0C\x0D\x20]*<\!--subtitle(?![0-9a-zA-Z_])[^>]*-->.*<\!--\/subtitle(?![0-9a-zA-Z_])[^>]*-->/<\!--\/subtitle\-->/gs;
    $$template
        =~ s/<\!--\/chaptertitle(?![0-9a-zA-Z_])[^>]*-->[\x09\x0A\x0C\x0D\x20]*<\!--chaptertitle(?![0-9a-zA-Z_])[^>]*-->.*<\!--\/chaptertitle(?![0-9a-zA-Z_])[^>]*-->/<\!--\/chaptertitle\-->/gs;
    $$template
        =~ s/<\!--\/sectiontitle(?![0-9a-zA-Z_])[^>]*-->[\x09\x0A\x0C\x0D\x20]*<\!--sectiontitle(?![0-9a-zA-Z_])[^>]*-->.*<\!--\/sectiontitle(?![0-9a-zA-Z_])[^>]*-->/<\!--\/sectiontitle\-->/gs;
}

sub index_is_replaceable ($$$$$) {
    my ( $this, $delete, $n, $p, $list_template ) = @_;
    if (   ( defined $delete && $delete eq 'n' )
        || !$n
        || (   $p ne ''
            && $$list_template
            =~ /<\!--title(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/title(?![0-9a-zA-Z_])[^>]*-->/s
        )
        || (   $p eq 'i'
            && $$list_template
            =~ /<\!--icon(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/icon(?![0-9a-zA-Z_])[^>]*-->/s
        )
        || (   $p =~ /^[0-9]+$/
            && $$list_template
            =~ /<\!--(subtitle|chaptertitle|sectiontitle)(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/\1(?![0-9a-zA-Z_])[^>]*-->/s
        )
        )
    {
        return 1;
    }
    else {
        return 0;
    }
}

sub add_subindex ($$$;$$) {
    my ( $this, $item, $additional_item, $reverse_flag, $id ) = @_;
    if ( $id && $default::subdivided ) {
        if ( !ref $this->{'categories'} ) {
            $this->{'categories'} = [];
            my $index
                = $this->read_file( $master::home . '/index.' . $default::ext,
                1 );
            $index = $1
                if $index =~ /<!--index\s[^>]*-->(.*?)<!--\/index-->/s;
            while ( $index =~ /<!--subindex[^>]*id="([^"]+)"[^>]*-->/sg ) {
                push( @{ $this->{'categories'} }, $1 );
            }
        }
        my @followers;
        my $following = 0;
        foreach my $i ( @{ $this->{'categories'} } ) {
            if ($following) {
                push( @followers, $i );
            }
            elsif ( $i eq $id ) {
                $following = 1;
            }
        }
        if (@followers) {
            foreach my $i (@followers) {
                if ( $item
                    =~ s/(<!--subindex[^>]*id="$i"[^>]*-->)/$additional_item$1/s
                    )
                {
                    return $item;
                }
            }
        }
        $reverse_flag = 0 if $following;
    }
    if ( defined $reverse_flag && $reverse_flag ) {
        return $additional_item . $item;
    }
    else {
        return $item . $additional_item;
    }
}

sub get_settings_of_template ($$$) {
    my ( $this, $template, $tag ) = @_;
    my ( $attributes, $sub_template, $separator, $separator_interval, $limit,
        $sort, $reverse_flag );
    $attributes = $sub_template = '';
    $$template = '' if !defined $$template;
    ( $attributes, $sub_template ) = ( $1, $2 )
        if $$template
        =~ s/<\!--$tag(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/$tag(?![0-9a-zA-Z_])[^>]*-->/<\!--$tag--><\!--\/$tag-->/s;
    $limit
        = (    $attributes
            && $attributes =~ /[\x09\x0A\x0C\x0D\x20]*limit="([0-9]*)"/ )
        ? $1
        : '';
    $sort
        = (    $attributes
            && $attributes =~ /[\x09\x0A\x0C\x0D\x20]*sort="([^"]*)"/ )
        ? $1
        : '';
    $reverse_flag
        = (    $attributes
            && $attributes
            =~ /[\x09\x0A\x0C\x0D\x20]*reverse="([0-9a-zA-Z_]*)"/
            && $1 ne ''
            && $1 ne 'no' ) ? 1 : 0;
    $sub_template
        = $this->include_header_and_footer( $attributes, $sub_template );
    $$template
        =~ s/<\!--$tag(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/$tag(?![0-9a-zA-Z_])[^>]*-->/<\!--$tag--><\!--\/$tag\-->/gs;

    if ( $$template
        =~ /<\!--separator(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/separator(?![0-9a-zA-Z_])[^>]*-->/s
        )
    {
        my $separator_option;
        ( $separator_option, $separator ) = ( $1, $2 );
        $separator_interval = ( $separator_option
                =~ /[\x09\x0A\x0C\x0D\x20]+interval="([0-9]+)"/si ) ? $1 : 1;
        $separator = $this->unescape($1)
            if $separator_option
            =~ /[\x09\x0A\x0C\x0D\x20]+value="([^"]+)"/si;
        $$template
            =~ s/<\!--separator(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/separator(?![0-9a-zA-Z_])[^>]*-->//gs;
    }
    else {
        $separator_interval = 1;
        $separator          = '';
    }
    1 while $$template
        =~ s/<\!--$tag--><\!--\/$tag-->[\x09\x0A\x0C\x0D\x20]*<\!--$tag--><\!--\/$tag-->/<\!--$tag--><\!--\/$tag\-->/gs;
    if ( $tag eq 'article' ) {
        $sub_template
            =~ s/^[\x09\x0A\x0C\x0D\x20]*(<tr(?![0-9a-zA-Z_])[^>]*>|<!--head-->.*?<!--\/head-->|<li(?![0-9a-zA-Z_])[^>]*>|)[\x09\x0A\x0C\x0D\x20]*(<td(?![0-9a-zA-Z_])[^>]*>|)[\x09\x0A\x0C\x0D\x20]*(<a name="[^"]+" id="[^"]+"  ><\/a>|)/$1$2/is;
    }
    return ( $sub_template, $separator, $separator_interval, $limit, $sort,
        $reverse_flag );
}

sub index_setting ($;$$$$) {
    my ( $this, $id, $sort, $limit, $reverse_flag ) = @_;
    my $attributes = '';
    $attributes .= ' id="' . $id . '"'     if defined $id   && $id ne '';
    $attributes .= ' sort="' . $sort . '"' if defined $sort && $sort ne '';
    $attributes .= ' limit="' . $limit . '"'
        if defined $limit && $limit ne '';
    $attributes .= ' reverse="reverse"'
        if defined $reverse_flag && $reverse_flag;
    return $attributes;
}

######################################################################
# インデックスタイトル差し替え
sub get_index_title ($$) {
    my ( $this, $index ) = @_;
    return (
        (   (   $$index
                    =~ /<\!--title(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/title(?![0-9a-zA-Z_])[^>]*-->/s
            ) ? $this->get_title_data($1) : ''
        ),
        (   (   $$index
                    =~ /<\!--description(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/description(?![0-9a-zA-Z_])[^>]*-->/s
            ) ? $this->get_title_data($1) : ''
        ),
        (   (   $$index
                    =~ /<\!--icon(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/icon(?![0-9a-zA-Z_])[^>]*-->/s
            ) ? $this->get_title_data($1) : ''
        ),
        (   (   $$index
                    =~ /<\!--count(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/count(?![0-9a-zA-Z_])[^>]*-->/s
            ) ? $this->get_title_data($1) : ''
        )
    );
}

sub get_title_data ($$) {
    my ( $this, $data ) = @_;
    $data
        =~ s/<\!--head(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/head(?![0-9a-zA-Z_])[^>]*-->//sg;
    $data
        =~ s/<\!--foot(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/foot(?![0-9a-zA-Z_])[^>]*-->//sg;
    $data = $1
        if $data
        =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;
    $data =~ s/<[\/]?a(?![0-9a-zA-Z_])[^>]*>//sg;
    return $data;
}

sub index_info_replace ($$$$$;$$) {
    my ( $this, $template, $title, $description, $icon, $count, $topicon )
        = @_;
    $topicon = $icon if !$topicon && $icon;
    $$template
        =~ s/<\!--title(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/title(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('title',$1,$2,$title,1)/ges;
    $$template
        =~ s/<\!--icon(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/icon(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('icon',$1,$2,$icon,1)/ges;
    $$template
        =~ s/<\!--mainicon(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/mainicon(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('mainicon',$1,$2,$icon,1)/ges;
    $$template
        =~ s/<\!--topicon(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/topicon(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('topicon',$1,$2,$topicon,1)/ges;
    $$template
        =~ s/<\!--description(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/description(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('description',$1,$2,$description,1)/ges;
    $$template
        =~ s/<\!--count(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/count(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('count',$1,$2,$count,1)/ges;
}

sub get_icon_tag ($$$$$$) {
    my ( $this, $dir, $icon, $width, $height, $title ) = @_;
    return $title
        if !defined $icon || !defined $dir || $icon eq '' || $dir eq '';
    return '<img src="'
        . $this->base_change( $dir . '/' . $icon,
        $cgi::output, $cgi::output_option )
        . '" width="'
        . $width
        . '" height="'
        . $height
        . '" alt="'
        . $this->escape($title)
        . '" border="0" />';
}

######################################################################
sub p_neighbor_link_replace ($$$$$;$$$$$$$) {
    my ($this,      $template, $path,        $prev_name,
        $next_name, $output,   $option,      $history_flag,
        $title,     $link,     $use_default, $prev_num
    ) = @_;
    my ($data,             $prev,         $next,
        $next_button,      $prev_button,  $prev_title,
        $next_title,       $first_anchor, $last_anchor,
        $first_section_id, $last_section_id
    );
    $first_anchor
        = (    ref $template
            && $$template
            && $$template
            =~ /\A.*?<[0-9a-zA-Z_]+[^>]* id="(a[0-9]{6})"[^>]*>/s ) ? $1 : '';
    $last_anchor
        = (    ref $template
            && $$template
            && $$template
            =~ /<[0-9a-zA-Z_]+[^>]* id="(a[0-9]{6})"[^>]*>.*?\Z/s ) ? $1 : '';
    $prev_title = $next_title = '';
    ( $next_button, $prev_button )
        = ($history_flag)
        ? ( 'nextHistory', 'prevHistory' )
        : ( 'nextButton', 'prevButton' );
    if ( defined $prev_name
        && $prev_name =~ /\.(html|htm|shtml|stml|shtm|stm)$/ )
    {
        $prev = $path . '/' . $prev_name;
    }
    elsif ( defined $prev_name && $prev_name ne '' ) {
        $prev = $this->fileglob( $path,
            '^' . $prev_name . '\.(html|htm|shtml|stml|shtm|stm)$', 'f' );
    }
    if ( defined $prev && $prev ) {
        ( $prev_title, $first_section_id, $last_section_id )
            = $this->w_neighbor_link_replace(
            'nextpage', $prev, 'next', $next_button,
            ( ($default::english) ? 'Next Page' : '次のページ' ),
            ( ($use_default) ? '' : $title ), $output, $option, 'next',
            $first_anchor, $prev_num
            );
        $$template
            =~ s/<\!--prevpage(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/prevpage-->/$this->link_replace('prevpage',$1,$2,$prev,'','prev',$prev_button,(($default::english) ? 'Previous Page' : '前のページ'),(($use_default) ? '' : $prev_title),$output,$option)/sge;
        $link->{'prev'} = {
            'href'  => $this->base_change( $prev, $output, $option ),
            'title' => (
                  ($use_default)
                ? ($default::english)
                        ? 'Previous Page'
                        : '前のページ'
                : $prev_title
                ),
                'anchor' => $last_section_id
            }
            if ref $link;
    }
    else {
        $$template
            =~ s/<\!--prevpage(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/prevpage-->/$this->item_tag_replace('prevpage',$1,$2,'',1)/seg;
    }
    if ( defined $next_name
        && $next_name =~ /\.(html|htm|shtml|stml|shtm|stm)$/ )
    {
        $next = $path . '/' . $next_name;
    }
    elsif ( defined $next_name && $next_name ne '' ) {
        $next = $this->fileglob( $path,
            '^' . $next_name . '\.(html|htm|shtml|stml|shtm|stm)$', 'f' );
    }
    if ( defined $next && $next ) {
        ( $next_title, $first_section_id, $last_section_id )
            = $this->w_neighbor_link_replace(
            'prevpage', $next, 'prev', $prev_button,
            ( ($default::english) ? 'Previous Page' : '前のページ' ),
            ( ($use_default) ? '' : $title ),
            $output, $option, 'prev', $last_anchor
            );
        $$template
            =~ s/<\!--nextpage(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/nextpage-->/$this->link_replace('nextpage',$1,$2,$next,'','next',$next_button,(($default::english) ? 'Next Page' : '次のページ'),(($use_default) ? '' : $next_title),$output,$option)/sge;
        $link->{'next'} = {
            'href'  => $this->base_change( $next, $output, $option ),
            'title' => (
                  ($use_default)
                ? ($default::english)
                        ? 'Next Page'
                        : '次のページ'
                : $next_title
                ),
                'anchor' => $first_section_id
            }
            if ref $link;
    }
    else {
        $$template
            =~ s/<\!--nextpage(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/nextpage-->/$this->item_tag_replace('nextpage',$1,$2,'',1)/seg;
    }
    return ( $prev_title, $next_title );
}

sub a_neighbor_link_replace ($$$$;$$$$$$) {
    my ($this,   $template, $prev_path, $next_path,  $output,
        $option, $title,    $link,      $prev_title, $next_title
    ) = @_;
    my ( $data, $prev, $next, $first_anchor, $last_anchor, $first_section_id,
        $last_section_id );
    $first_anchor
        = (    ref $template
            && $$template
            && $$template
            =~ /\A.*?<[0-9a-zA-Z_]+[^>]* id="(a[0-9]{6})"[^>]*>/s ) ? $1 : '';
    $last_anchor
        = (    ref $template
            && $$template
            && $$template
            =~ /<[0-9a-zA-Z_]+[^>]* id="(a[0-9]{6})"[^>]*>.*?\Z/s ) ? $1 : '';
    $prev_title = '' if !defined $prev_title;
    $next_title = '' if !defined $next_title;
    $output
        = $this->fileglob( $output, '^1\.(html|htm|shtml|stml|shtm|stm)$',
        'f' )
        unless $output =~ s/[0-9]+(\.(html|htm|shtml|shtm|stml|stm))$/1$1/;
    if ( $output && !defined $title ) {
        my $article = $this->read_html_file($output);
        $title = $this->get_article_title( \$article );
    }
    if ( defined $prev_path && $prev_path ) {
        $prev = $this->fileglob( $prev_path,
            '^1\.(html|htm|shtml|stml|shtm|stm)$', 'f' );
        if ( $prev_title eq '' && opendir( DIR, $prev_path ) ) {
            my ( @page, %counter );
            @page
                = grep( -f "$prev_path/$_"
                    && $_ =~ /^[0-9]+\.(html|htm|shtml|shtm|stml|stm)$/
                    && !$counter{$_}++,
                readdir(DIR) );
            closedir(DIR);
            foreach my $p (@page) {
                ( $prev_title, $first_section_id, $last_section_id )
                    = $this->w_neighbor_link_replace(
                    'next',
                    "$prev_path/$p",
                    'next',
                    'nextArticle',
                    ( ($default::english) ? 'Next Article' : '次の記事' ),
                    $title, $output, $option,
                    (     ( $p eq $page[$#page] )
                        ? ( 'next', $first_anchor )
                        : ()
                    )
                    );
            }
        }
        if ( ref $template ) {
            $$template
                =~ s/<\!--prev(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/prev-->/$this->link_replace('prev',$1,$2,$prev,'','prev','prevArticle',(($default::english) ? 'Previous Article' : '前の記事'),$prev_title,$output,$option)/sge;
            $link->{'prev'} = {
                'href'   => $this->base_change( $prev, $output, $option ),
                'title'  => $prev_title,
                'anchor' => $last_section_id
                }
                if ref $link;
        }
    }
    elsif ( ref $template ) {
        $$template
            =~ s/<\!--prev(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/prev-->/$this->item_tag_replace('prev',$1,$2,'',1)/seg;
        $link->{'prev'} = '' if ref $link;
    }
    if ( defined $next_path && $next_path ) {
        $next = $this->fileglob( $next_path,
            '^1\.(html|htm|shtml|stml|shtm|stm)$', 'f' );
        if ( $next_title eq '' && opendir( DIR, $next_path ) ) {
            my ( @page, %counter );
            @page
                = grep( -f "$next_path/$_"
                    && $_ =~ /^[0-9]+\.(html|htm|shtml|shtm|stml|stm)$/
                    && !$counter{$_}++,
                readdir(DIR) );
            closedir(DIR);
            foreach my $p (@page) {
                ( $next_title, $first_section_id, $last_section_id )
                    = $this->w_neighbor_link_replace(
                    'prev',
                    "$next_path/$p",
                    'prev',
                    'prevArticle',
                    (   ($default::english)
                        ? 'Previous Article'
                        : '前の記事'
                    ),
                    $title, $output, $option,
                    ( ( $p eq $page[0] ) ? ( 'prev', $last_anchor ) : () )
                    );
            }
        }
        if ( ref $template ) {
            $$template
                =~ s/<\!--next(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/next-->/$this->link_replace('next',$1,$2,$next,'','next','nextArticle',(($default::english) ? 'Next Article' : '次の記事'),$next_title,$output,$option)/sge;
            $link->{'next'} = {
                'href'   => $this->base_change( $next, $output, $option ),
                'title'  => $next_title,
                'anchor' => $first_section_id
                }
                if ref $link;
        }
    }
    elsif ( ref $template ) {
        $$template
            =~ s/<\!--next(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/next-->/$this->item_tag_replace('next',$1,$2,'',1)/seg;
        $link->{'next'} = '' if ref $link;
    }
    return ( $prev_title, $next_title );
}

sub w_neighbor_link_replace ($$$$$$;$$$$$) {
    my ($this,  $tag,    $path,   $type, $image,  $alt,
        $title, $output, $option, $rel,  $anchor, $p
    ) = @_;
    my ( $data, $article_title, $first_section_id, $last_section_id,
        $is_changed );
    local (*FILE);
    local (*OUT);
    if ( open( FILE, $path ) ) {
        binmode FILE, ":utf8";
        flock( FILE, LOCK_SH );
        $data = join( '', <FILE> );
        close(FILE);
    }
    else {
        return '';
    }
    $article_title = $this->get_article_title( \$data );
    $first_section_id
        = ( $data =~ /\A.*?<[0-9a-zA-Z_]+[^>]* id="(a[0-9]{6})"[^>]*>/s )
        ? $1
        : '';
    $last_section_id
        = ( $data =~ /<[0-9a-zA-Z_]+[^>]* id="(a[0-9]{6})"[^>]*>.*?\Z/s )
        ? $1
        : '';
    if ($p) {
        $this->page_navi_replace( \$data, $p, $article_title, $output );
        $is_changed = 1;
    }
    $is_changed = 1
        if $data
        =~ s/<\!--$tag(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/$tag-->/$this->link_replace($tag,$1,$2,$output,'',$type,$image,$alt,$title,$path,$option)/sge;
    if ($rel) {
        $this->replace_link_rel(
            \$data,
            {   $rel => (
                    ($output)
                    ? { 'href' =>
                            $this->base_change( $output, $path, $option ),
                        'title' => (
                            ( defined $title && $title ne '' )
                            ? $title
                            : $alt
                        ),
                        ( ($anchor) ? ( 'anchor' => $anchor ) : () )
                        }
                    : ''
                )
            }
        );
        $is_changed = 1;
    }
    if ( $is_changed && open( OUT, ">>$path" ) ) {
        binmode OUT, ":utf8";
        flock( OUT, LOCK_EX );
        truncate( OUT, 0 );
        seek( OUT, 0, 0 );
        print OUT $data;
        close(OUT);
    }
    return ( $article_title, $first_section_id, $last_section_id );
}

######################################################################
sub list_replace ($$$$$;$$$$$) {
    my ($this,         $article, $template,   $article_id,
        $target,       $output,  $abs_option, $notemplate,
        $is_metaindex, $mtime
    ) = @_;
    my ($url,                  $article_title,  $title,
        $description,          $teaser,         $label,
        $mark,                 $price,          $score,
        $icon,                 $icon_image,     $mainicon,
        $topicon,              $author,         $author_email,
        $target_page,          $target_chapter, $target_section,
        %page_num,             %subtitle,       %subtitle_id_order,
        %target_page_id_order, $cgi_title
    );
    if ( defined $target && $target ) {
        $target_page = sprintf( "%.2d", $main::p ) if $main::p =~ /^[0-9]+$/;
        $target_chapter = $target_page . sprintf( "%.2d", $main::chap )
            if $target_page && $main::chap =~ /^[0-9]+$/;
        $target_section = $target_chapter . sprintf( "%.2d", $main::sect )
            if $target_chapter && $main::sect =~ /^[0-9]+$/;
    }
    if ( defined $is_metaindex && $is_metaindex ) {
        $cgi_title
            = ' title="'
            . ( ( $env::title ne '' )
            ? $this->escape($env::title) . ' &gt; '
            : '' )
            . (
            (          $default::subdivided
                    && defined $main::c
                    && $main::c ne ''
                    && $master::general{'cginame'} ne ''
            ) ? $this->escape( $master::general{'cginame'} ) . ' &gt; ' : ''
            ) . $this->escape( $setting::general{'cginame'} ) . '"';
    }
    $article_id = $1 if $article_id =~ /-([0-9a-zA-Z_]+)$/;

    #既存データ抽出
    if ( defined $article && $article ) {
        my $order  = 0;
        my $order2 = 0;
        $title = $1
            if $article
            =~ /<\!--title(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/title(?![0-9a-zA-Z_])[^>]*-->/s
            && $1
            =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;
        $description = $1
            if $article
            =~ /<\!--description(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/description(?![0-9a-zA-Z_])[^>]*-->/s
            && $1
            =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;
        $teaser = $1
            if $article
            =~ /<\!--teaser(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/teaser(?![0-9a-zA-Z_])[^>]*-->/s
            && $1
            =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;
        $icon_image = $1
            if $article
            =~ /<\!--icon(?![0-9a-zA-Z_])[^>]*thumbnail="(?:no|false|off|0)"[^>]*-->(.*?)<\!--\/icon(?![0-9a-zA-Z_])[^>]*-->/s
            && $1
            =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;
        $icon = $1
            if $article
            =~ /<\!--icon(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/icon(?![0-9a-zA-Z_])[^>]*-->/s
            && $1
            =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;
        $mainicon = $1
            if $article
            =~ /<\!--mainicon(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/mainicon(?![0-9a-zA-Z_])[^>]*-->/s
            && $1
            =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;
        $topicon = $1
            if $article
            =~ /<\!--topicon(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/topicon(?![0-9a-zA-Z_])[^>]*-->/s
            && $1
            =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;
        $author = $1
            if $article
            =~ /<\!--author(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/author(?![0-9a-zA-Z_])[^>]*-->/s
            && $1
            =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;
        $author_email = $1 if $this->get_email_from_html($author);
        $label = $1
            if $article
            =~ /<\!--label(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/label(?![0-9a-zA-Z_])[^>]*-->/s
            && $1
            =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;
        $mark = $1
            if $article
            =~ /<\!--mark(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/mark(?![0-9a-zA-Z_])[^>]*-->/s
            && $1
            =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;
        $price = $1
            if $article
            =~ /<\!--price(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/price(?![0-9a-zA-Z_])[^>]*-->/s
            && $1
            =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;
        $score = $1
            if $article
            =~ /<\!--score(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/score(?![0-9a-zA-Z_])[^>]*-->/s
            && $1
            =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;
        my $readmore = $1
            if $article
            =~ /<\!--readmore(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/readmore(?![0-9a-zA-Z_])[^>]*-->/s
            && $1
            =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;

        while ( $article
            =~ /<\!--(subtitle|chaptertitle|sectiontitle)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/\1(?![0-9a-zA-Z_])[^>]*-->/gs
            )
        {
            my ( $id, $subtitle );
            $subtitle = $3;
            $id = $1 if $2 =~ /[\x09\x0A\x0C\x0D\x20]+id="([^"]+)"/s;
            next if !defined $id || $id == 0 || $id =~ /[^0-9]/;
            if ( defined $target && $target && $main::delete ) {
                next
                    if $main::delete eq 'rmsection'
                    && $target_section
                    && $id eq $target_section;
                next
                    if $main::delete eq 'rmchapter'
                    && $target_chapter
                    && $id =~ /^$target_chapter/;
                next
                    if $main::delete eq 'rmpage'
                    && $target_page
                    && $id =~ /^$target_page/;
            }
            if ( $target_section && $id =~ /^$target_page/ ) {
                $subtitle_id_order{$id} = $subtitle_id_order{$target_chapter}
                    = $subtitle_id_order{$target_section} = $order;
                $target_page_id_order{$id} = $order2++;
            }
            else {
                $order++;
                $subtitle_id_order{$id} = $order++;
            }
            $page_num{$id} = $1 + 0 if $id =~ /^([0-9]{2})/;
            $subtitle = $1
                if $subtitle
                =~ /<\!--data(?![0-9a-zA-Z_])[^>]*-->(.*)<\!--\/data(?![0-9a-zA-Z_])[^>]*-->/s;
            $subtitle{$id} = $subtitle;
        }
        if (   ( $title && $title =~ /<a\s+href="(.*?)"[^>]*>/si )
            || ( $icon && $icon =~ /<a\s+href="(.*?)"[^>]*>/si )
            || ( $readmore && $readmore =~ /<a\s+href="(.*?)"[^>]*>/si ) )
        {
            $url = $1;
        }
        if ( $title && $title =~ /<a\s+[^>]*>(.*?)<\/a>/si ) {
            $article_title = $this->escape($1);
        }
        elsif ( $icon && $icon =~ /<a\s+[^>]*?title="(.*?)"[^>]*?>/si ) {
            $article_title = $1;
        }
    }

    #新規データ
    if ($target) {
        if ( %main::data && !$main::delete ) {
            $url
                = $this->base_change(
                $default::home . '/' . $main::n . '/1.' . $default::ext,
                $output, $abs_option );
            if ( $main::p eq 'i' ) {
                $icon = $icon_image = $author = $author_email = $label
                    = $mark = $price = $score = '';
                if ( defined $this->{'field_for'}{'title'}
                    && ref $this->{'field_obj'}
                    { $this->{'field_for'}{'title'} }
                    && defined $main::data{ $this->{'field_for'}{'title'} }
                    {'str'}
                    && $main::data{ $this->{'field_for'}{'title'} }{'str'} ne
                    '' )
                {
                    $article::title = $this->detag_text(
                        $this->{'field_obj'}{ $this->{'field_for'}{'title'} }
                            ->data_only->usual_format(
                            $main::data{ $this->{'field_for'}{'title'} }
                                {'str'}
                            )
                    );
                }
                else {
                    $article::title
                        = ($default::date)
                        ? $this->date( substr( $main::n, 0, 8 ),
                        0, $setting::general{'datetype'} )
                        : $main::n;
                }
                $article_title = $article::title;
                if (   ref $this->{'field_for'}
                    && $this->{'field_for'}{'icon'}
                    && ref $this->{'field_obj'}
                    { $this->{'field_for'}{'icon'} }
                    && ref $main::data{ $this->{'field_for'}{'icon'} }
                    && %{ $main::data{ $this->{'field_for'}{'icon'} } } )
                {
                    $icon
                        = $this->get_article_icon( $url,
                        $this->{'field_for'}{'icon'},
                        'preview', $article::title );
                    $icon_image
                        = $this->get_article_icon( $url,
                        $this->{'field_for'}{'icon'},
                        'image', $article::title );
                }
                if (   !$icon
                    && !$icon_image
                    && ref $this->{'field_for'}
                    && $this->{'field_for'}{'icon2'}
                    && ref $this->{'field_obj'}
                    { $this->{'field_for'}{'icon2'} }
                    && ref $main::data{ $this->{'field_for'}{'icon2'} }
                    && %{ $main::data{ $this->{'field_for'}{'icon2'} } } )
                {
                    $icon
                        = $this->get_article_icon( $url,
                        $this->{'field_for'}{'icon2'},
                        'preview', $article::title );
                    $icon_image
                        = $this->get_article_icon( $url,
                        $this->{'field_for'}{'icon2'},
                        'image', $article::title );
                }
                if (   !$icon
                    && !$icon_image
                    && ref $this->{'field_for'}
                    && $this->{'field_for'}{'icon3'}
                    && ref $this->{'field_obj'}
                    { $this->{'field_for'}{'icon3'} }
                    && ref $main::data{ $this->{'field_for'}{'icon3'} }
                    && %{ $main::data{ $this->{'field_for'}{'icon3'} } } )
                {
                    $icon
                        = $this->get_article_icon( $url,
                        $this->{'field_for'}{'icon3'},
                        'preview', $article::title );
                    $icon_image
                        = $this->get_article_icon( $url,
                        $this->{'field_for'}{'icon3'},
                        'image', $article::title );
                }
                if (   ref $this->{'field_for'}
                    && $this->{'field_for'}{'description'}
                    && $this->{'field_obj'}
                    { $this->{'field_for'}{'description'} }
                    && defined
                    $main::data{ $this->{'field_for'}{'description'} }{'str'}
                    )
                {
                    $description
                        = $this->{'field_obj'}
                        { $this->{'field_for'}{'description'} }
                        ->data_only->usual_format(
                        $main::data{ $this->{'field_for'}{'description'} }
                            {'str'},
                        $default::home . '/' . $main::n . '/i',
                        $main::c,
                        $main::n
                        );
                }
                if (   ref $this->{'field_for'}
                    && $this->{'field_for'}{'author'}
                    && $this->{'field_obj'}{ $this->{'field_for'}{'author'} }
                    && defined $main::data{ $this->{'field_for'}{'author'} }
                    {'str'} )
                {
                    $author
                        = $this->{'field_obj'}
                        { $this->{'field_for'}{'author'} }
                        ->data_only->usual_format(
                        $main::data{ $this->{'field_for'}{'author'} }{'str'},
                        $default::home . '/' . $main::n . '/i',
                        $main::c,
                        $main::n
                        );
                }
                elsif ( defined $setting::general{'mastername'}
                    && $setting::general{'mastername'} ne '' )
                {
                    $author = $setting::general{'mastername'};
                    $author_email
                        = ( defined $setting::general{'master'} )
                        ? $setting::general{'master'}
                        : '';
                }
                elsif ( defined $master::general{'mastername'}
                    && $master::general{'mastername'} ne '' )
                {
                    $author = $master::general{'mastername'};
                    $author_email
                        = ( defined $master::general{'master'} )
                        ? $master::general{'master'}
                        : '';
                }
                if (   ref $this->{'field_for'}
                    && $this->{'field_for'}{'label'}
                    && $this->{'field_obj'}{ $this->{'field_for'}{'label'} }
                    && defined $main::data{ $this->{'field_for'}{'label'} }
                    && %{ $main::data{ $this->{'field_for'}{'label'} } } )
                {
                    $label
                        = $this->{'field_obj'}
                        { $this->{'field_for'}{'label'} }
                        ->data_only->usual_format(
                        $main::data{ $this->{'field_for'}{'label'} },
                        $default::home . '/' . $main::n . '/i',
                        $main::c,
                        $main::n
                        );
                }
                if (   ref $this->{'field_for'}
                    && $this->{'field_for'}{'mark'}
                    && $this->{'field_obj'}{ $this->{'field_for'}{'mark'} }
                    && defined $main::data{ $this->{'field_for'}{'mark'} }
                    && %{ $main::data{ $this->{'field_for'}{'mark'} } } )
                {
                    $mark
                        = $this->{'field_obj'}{ $this->{'field_for'}{'mark'} }
                        ->data_only->usual_format(
                        $main::data{ $this->{'field_for'}{'mark'} },
                        $default::home . '/' . $main::n . '/i',
                        $main::c,
                        $main::n
                        );
                }
                if (   ref $this->{'field_for'}
                    && $this->{'field_for'}{'price'}
                    && $this->{'field_obj'}{ $this->{'field_for'}{'price'} }
                    && defined $main::data{ $this->{'field_for'}{'price'} }
                    && %{ $main::data{ $this->{'field_for'}{'price'} } } )
                {
                    $price
                        = $this->{'field_obj'}
                        { $this->{'field_for'}{'price'} }
                        ->data_only->usual_format(
                        $main::data{ $this->{'field_for'}{'price'} },
                        $default::home . '/' . $main::n . '/i',
                        $main::c,
                        $main::n
                        );
                }
                if (   ref $this->{'field_for'}
                    && $this->{'field_for'}{'score'}
                    && $this->{'field_obj'}{ $this->{'field_for'}{'score'} }
                    && defined $main::data{ $this->{'field_for'}{'score'} }
                    && %{ $main::data{ $this->{'field_for'}{'score'} } } )
                {
                    $score
                        = $this->{'field_obj'}
                        { $this->{'field_for'}{'score'} }
                        ->data_only->usual_format(
                        $main::data{ $this->{'field_for'}{'score'} },
                        $default::home . '/' . $main::n . '/i',
                        $main::c,
                        $main::n
                        );
                }
            }
            else {
                if (   ref $this->{'field_for'}
                    && $this->{'field_for'}{'title'}
                    && $this->{'field_obj'}{ $this->{'field_for'}{'title'} }
                    && defined $main::data{ $this->{'field_for'}{'title'} }
                    {'str'}
                    && $main::data{ $this->{'field_for'}{'title'} }{'str'} ne
                    '' )
                {
                    $subtitle{$target_section} = $this->detag_text(
                        $this->{'field_obj'}{ $this->{'field_for'}{'title'} }
                            ->data_only->usual_format(
                            $main::data{ $this->{'field_for'}{'title'} }
                                {'str'},
                            $default::home . '/' . $main::n . '/i',
                            $main::c,
                            $main::n
                            )
                    );
                    $subtitle{$target_section} = '<a href="'
                        . $this->base_change(
                        $default::home . '/'
                            . $main::n . '/'
                            . $main::p . '.'
                            . $default::ext,
                        $output,
                        $abs_option
                        )
                        . '#a'
                        . $target_section . '">'
                        . $subtitle{$target_section} . '</a>'
                        if defined $subtitle{$target_section}
                        && $subtitle{$target_section} ne '';
                }
                else {
                    delete $subtitle{$target_section};
                }
                if ( $main::p && $main::p == 1 ) {
                    if ( $main::chap eq
                           $this->{'template'}->{'stat'}{'chapter_order'}[0]
                        && $main::sect eq
                        $this->{'template'}->{'stat'}{'section_order'}[0]
                        && ref $this->{'field_for'}
                        && $this->{'field_for'}{'description'}
                        && $this->{'field_obj'}
                        { $this->{'field_for'}{'description'} }
                        && defined
                        $main::data{ $this->{'field_for'}{'description'} }
                        {'str'} )
                    {
                        $teaser
                            = $this->{'field_obj'}
                            { $this->{'field_for'}{'description'} }
                            ->data_only->usual_format(
                            $main::data{ $this->{'field_for'}{'description'} }
                                {'str'},
                            $default::home . '/' . $main::n . '/i',
                            $main::c,
                            $main::n
                            );
                    }
                    elsif ( defined $this->{'template'}{'stat'}{'teaser'}
                        && $this->{'template'}{'stat'}{'teaser'} ne '' )
                    {
                        $teaser = $this->{'template'}{'stat'}{'teaser'};
                    }
                }
            }
            $title
                = '<a href="'
                . $url . '"'
                . ( ($cgi_title) ? $cgi_title : '' ) . '>'
                . $this->detag_text($article::title) . '</a>'
                if defined $article::title && $article::title;
            if ($default::subdivided) {
                $topicon = '<a href="'
                    . $this->get_index_path( $master::home, $output,
                    $abs_option )
                    . '" title="'
                    . ( ( $env::title ne '' )
                    ? $this->escape($env::title) . ' &gt; '
                    : '' )
                    . (
                    (          $default::subdivided
                            && defined $main::c
                            && $main::c ne ''
                            && $master::general{'cginame'} ne ''
                    ) ? $this->escape( $master::general{'cginame'} )
                    : $this->escape( $setting::general{'cginame'} )
                    )
                    . '">'
                    . $this->get_icon_tag(
                    $master::home,
                    $master::general{'icon'},
                    $master::general{'iconwidth'},
                    $master::general{'iconheight'},
                    $master::general{'cginame'}
                    ) . '</a>';
                $mainicon = '<a href="'
                    . $this->get_index_path( $default::home, $output,
                    $abs_option )
                    . '"'
                    . ( ($cgi_title) ? $cgi_title : '' ) . '>'
                    . $this->get_icon_tag(
                    $default::home,
                    $setting::general{'icon'},
                    $setting::general{'iconwidth'},
                    $setting::general{'iconheight'},
                    $setting::general{'cginame'}
                    ) . '</a>';
            }
            else {
                $mainicon = $topicon = '<a href="'
                    . $this->get_index_path( $default::home, $output,
                    $abs_option )
                    . '"'
                    . ( ($cgi_title) ? $cgi_title : '' ) . '>'
                    . $this->get_icon_tag(
                    $default::home,
                    $setting::general{'icon'},
                    $setting::general{'iconwidth'},
                    $setting::general{'iconheight'},
                    $setting::general{'cginame'}
                    ) . '</a>';
            }
            if ( defined $main::data{'title'} && $main::data{'title'} ne '' )
            {
                $subtitle{$target_chapter} = '<a href="'
                    . $this->base_change(
                    $default::home . '/'
                        . $main::n . '/'
                        . $main::p . '.'
                        . $default::ext,
                    $output,
                    $abs_option
                    )
                    . '#a'
                    . $target_chapter
                    . '" class="chapter-title">'
                    . $this->detag_text( $main::data{'title'} ) . '</a>';
            }
        }
        elsif ( defined $this->{'template'}{'stat'}{'teaser'}
            && $this->{'template'}{'stat'}{'teaser'} ne '' )
        {
            $teaser = $this->{'template'}{'stat'}{'teaser'};
        }

        #サブタイトル順序
        if ( $target_chapter && $target_section ) {
            my ( $order, @target_page_sections, @target_page_sections_order );
            @target_page_sections = keys %target_page_id_order;
            foreach my $chap (
                @{ $this->{'template'}->{'stat'}{'chapter_order'} } )
            {
                if ( $main::chap =~ /^[0-9]+$/ && $chap == $main::chap ) {
                    push( @target_page_sections_order, $target_chapter );
                    foreach my $sect (
                        @{ $this->{'template'}->{'stat'}{'section_order'} } )
                    {
                        push( @target_page_sections_order,
                            $target_chapter . sprintf( "%.2d", $sect ) );
                    }
                }
                else {
                    my $chapter = $target_page . sprintf( "%.2d", $chap );
                    my @order
                        = grep( $_ =~ /^$chapter/, @target_page_sections );
                    push(
                        @target_page_sections_order,
                        (   sort {
                                $target_page_id_order{$a}
                                    <=> $target_page_id_order{$b}
                            } @order
                        )
                    );
                }
            }
            $order = 0;
            foreach my $sid (@target_page_sections_order) {
                $target_page_id_order{$sid} = $order++;
            }
            if ( $subtitle{$target_chapter} ) {
                $target_page_id_order{$target_chapter}
                    = (    $this->{'template'}->{'chapter_dir'}
                        && $this->{'template'}->{'chapter_dir'} eq 'above' )
                    ? -2
                    : 10000
                    if !defined $target_page_id_order{$target_chapter};
                $page_num{$target_chapter} = $1 + 0
                    if !$page_num{$target_chapter}
                    && $target_chapter =~ /^([0-9]{2})/;
            }
            if ( $subtitle{$target_section} ) {
                $target_page_id_order{$target_section}
                    = (    $this->{'template'}->{'section_dir'}
                        && $this->{'template'}->{'section_dir'} eq 'above' )
                    ? -1
                    : 10001
                    if !defined $target_page_id_order{$target_section};
                $page_num{$target_section} = $1 + 0
                    if !$page_num{$target_section}
                    && $target_section =~ /^([0-9]{2})/;
            }
        }
    }

    #更新時変換
    $this->date_tag_replace( \$article, \$template, $target,
        ( ($default::date) ? $article_id : '' ),
        $mtime, $url, $article_title );

    #新しいテンプレートで書き直し
    $template
        =~ s/<\!--title(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/title-->/$this->item_tag_replace('title',$1,$2,$title,1)/seg;
    $template
        =~ s/<\!--description(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/description-->/$this->item_tag_replace('description',$1,$2,$description,1)/seg;
    $template
        =~ s/<\!--teaser(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/teaser-->/$this->item_tag_replace('teaser',$1,$2,$teaser,1)/seg;
    $template
        =~ s/<\!--mainicon(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/mainicon-->/$this->item_tag_replace('mainicon',$1,$2,$mainicon,1)/seg;
    $template
        =~ s/<\!--topicon(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/topicon-->/$this->item_tag_replace('topicon',$1,$2,$topicon,1)/seg;
    $template
        =~ s/<\!--mastericon(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/mastericon-->/$this->item_tag_replace('topicon',$1,$2,$topicon,1)/seg;
    $template
        =~ s/<\!--label(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/label-->/$this->item_tag_replace('label',$1,$2,$label,1)/seg;
    $template
        =~ s/<\!--mark(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/mark-->/$this->item_tag_replace('mark',$1,$2,$mark,1)/seg;
    $template
        =~ s/<\!--price(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/price-->/$this->item_tag_replace('price',$1,$2,$price,1)/seg;
    $template
        =~ s/<\!--score(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/score-->/$this->item_tag_replace('score',$1,$2,$score,1)/seg;
    $template
        =~ s/<\!--icon(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/icon-->/$this->article_icon_tag_replace($1,$2,$icon,$icon_image)/seg;
    $template
        =~ s/<\!--author(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/author-->/$this->article_author_tag_replace($1,$2,$author,$author_email,$setting::general{'addressProtector'})/seg;

    $template
        =~ s/<\!--readmore(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/readmore-->/$this->readmore_replace($1,$2,$url)/seg;

    no warnings qw(numeric);
    my @subtitle_order = (%subtitle)
        ? sort {
        (          defined $page_num{$a}
                && defined $page_num{$b}
                && $page_num{$a} <=> $page_num{$b} )
            || ( defined $subtitle_id_order{$a}
            && defined $subtitle_id_order{$b}
            && $subtitle_id_order{$a} <=> $subtitle_id_order{$b} )
            || ( defined $target_page_id_order{$a}
            && defined $target_page_id_order{$b}
            && $target_page_id_order{$a} <=> $target_page_id_order{$b} )
            || $a <=> $b
            || $a cmp $b
        } keys %subtitle
        : ();
    $template
        =~ s/<\!--(subtitle|chaptertitle|sectiontitle)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/\1-->/$this->article_subtitle_tag_replace($1,$2,$3,\%subtitle,\@subtitle_order)/seg;
    $template
        =~ s/<\!--subtitlelist(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/subtitlelist-->/$this->article_subtitlelist_tag_replace($1,$2,\@subtitle_order)/seg;

    if ( $default::date && $output !~ /\.ssi$/ ) {
        my $anchor_id
            = 'a'
            . substr( $article_id, 0, 8 )
            . $default::id
            . ( ( $default::subdivided && $main::c ) ? '_' . $main::c : '' );
        $template
            =~ s/(<h[1-6](?![0-9a-zA-Z_])[^>]*>)/$this->_anchor_replace($1,$anchor_id)/iges;
        $template
            =~ s/(<(?:table|caption|thead|tbody|tfoot|tr|th|td|ol|ul|li|dl|dt|dd|div|address|p|blockquote|fieldset|form|pre)(?![0-9a-zA-Z_])[^>]*>)/$this->_anchor_replace($1,$anchor_id)/iges;
        $template
            =~ s/(<a(?![0-9a-zA-Z_])[^>]*>)/$this->_anchor_replace($1,$anchor_id,1)/iges;
    }
    if ( $article_id && !$notemplate ) {
        my $aid          = $this->article_id($article_id);
        my $aid_replaced = 0;
        $template
            =~ s/<(table|caption|thead|tbody|tfoot|tr|th|td|ol|ul|li|dl|dt|dd|div|address|p|blockquote|fieldset|form|pre|h[1-6])(?![0-9a-zA-Z_])([^>]*)>/$this->_articleid_replace($1,$2,$aid,\$aid_replaced)/iges;
    }
    return $template;
}

sub readmore_replace ($$$$;$) {
    my ( $this, $setting, $content, $url, $text ) = @_;
    my ( $header, $footer )
        = $this->get_header_and_footer( $setting, $content );
    $setting =~ s/[\x09\x0A\x0C\x0D\x20]+head="([^"]+)"//sg;
    $setting =~ s/[\x09\x0A\x0C\x0D\x20]+foot="([^"]+)"//sg;
    $setting = '' if $setting eq '' || $setting !~ /[^\x09\x0A\x0C\x0D\x20]/;
    if ($url) {
        $text = $this->unescape($1) if $setting =~ /\stext="([^"]+)"/i;
        return
              '<!--readmore'
            . $setting . '-->'
            . ( ( $header ne '' ) ? '<!--head-->' . $header . '<!--/head-->'
            : '' )
            . '<!--data--><a href="'
            . $url . '"'
            . ( ( $setting =~ / class="([^"]+)"/i )
            ? ' class="' . $this->escape_except_html_entity($1) . '"'
            : '' )
            . '>'
            . $this->escape_except_html_entity( $text
                || '続きを読む...' )
            . '</a><!--/data-->'
            . ( ( $footer ne '' ) ? '<!--foot-->' . $footer . '<!--/foot-->'
            : '' )
            . '<!--/readmore-->';
    }
    else {
        return
              '<!--readmore'
            . $setting
            . ( ( $header ne '' )
            ? ' head="' . $this->lf_to_entity( $this->escape($header) ) . '"'
            : '' )
            . ( ( $footer ne '' )
            ? ' foot="' . $this->lf_to_entity( $this->escape($footer) ) . '"'
            : '' )
            . '--><!--/readmore-->';
    }
}

sub shrink_article_template ($$) {
    my ( $this, $template ) = @_;
    my ( $header, $footer ) = ( '', '' );
    if ( $template
        =~ s/^[\x09\x0A\x0C\x0D\x20]*<\!--head(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/head(?![0-9a-zA-Z_])[^>]*-->//s
        )
    {
        $header = $1;
    }
    if ( $template
        =~ s/<\!--foot(?![0-9a-zA-Z_])[^>]*-->((?:.(?!<\!--foot-->))*?)<\!--\/foot(?![0-9a-zA-Z_])[^>]*-->[\x09\x0A\x0C\x0D\x20]*\Z//s
        )
    {
        $footer = $1;
    }
    $template
        =~ s/<\!--readmore(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/readmore-->/$this->item_tag_replace('readmore',$1,$2,'',1)/seg;
    $template
        =~ s/<\!--title(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/title-->/$this->item_tag_replace('title',$1,$2,'',1)/seg;
    $template
        =~ s/<\!--description(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/description-->/$this->item_tag_replace('description',$1,$2,'',1)/seg;
    $template
        =~ s/<\!--teaser(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/teaser-->/$this->item_tag_replace('teaser',$1,$2,'',1)/seg;
    $template
        =~ s/<\!--mainicon(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/mainicon-->/$this->item_tag_replace('mainicon',$1,$2,'',1)/seg;
    $template
        =~ s/<\!--topicon(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/topicon-->/$this->item_tag_replace('topicon',$1,$2,'',1)/seg;
    $template
        =~ s/<\!--mastericon(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/mastericon-->/$this->item_tag_replace('topicon',$1,$2,'',1)/seg;
    $template
        =~ s/<\!--label(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/label-->/$this->item_tag_replace('label',$1,$2,'',1)/seg;
    $template
        =~ s/<\!--mark(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/mark-->/$this->item_tag_replace('mark',$1,$2,'',1)/seg;
    $template
        =~ s/<\!--price(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/price-->/$this->item_tag_replace('price',$1,$2,'',1)/seg;
    $template
        =~ s/<\!--score(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/score-->/$this->item_tag_replace('score',$1,$2,'',1)/seg;
    $template
        =~ s/<\!--icon(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/icon-->/$this->article_icon_tag_replace($1,$2,'','')/seg;
    $template
        =~ s/<\!--author(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/author-->/$this->article_author_tag_replace($1,$2,'','','')/seg;
    $template
        =~ s/<\!--(subtitle|chaptertitle|sectiontitle)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/\1-->/$this->article_subtitle_tag_replace($1,$2,$3,{},[])/seg;
    $template
        =~ s/<\!--subtitlelist(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/subtitlelist-->/$this->article_subtitlelist_tag_replace($1,$2,[])/seg;
    return '<!--article'
        . ( ( $header ne '' )
        ? ' head="' . $this->lf_to_entity( $this->escape($header) ) . '"'
        : '' )
        . ( ( $footer ne '' )
        ? ' foot="' . $this->lf_to_entity( $this->escape($footer) ) . '"'
        : '' )
        . '-->'
        . $template
        . '<!--/article-->';
    return $template;
}

sub article_subtitlelist_tag_replace ($$$$) {
    my ( $this, $attributes, $content, $subtitle_order ) = @_;
    my ( $header, $footer ) = ( '', '' );
    if ( $attributes
        =~ s/[\x09\x0A\x0C\x0D\x20]+head[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)"//s
        )
    {
        $header = $this->unescape( $this->entity_to_lf($1) );
    }
    if ( $content
        =~ s/^[\x09\x0A\x0C\x0D\x20]*<\!--head(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/head(?![0-9a-zA-Z_])[^>]*-->//s
        )
    {
        $header = $1;
    }
    if ( $attributes
        =~ s/[\x09\x0A\x0C\x0D\x20]+foot[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)"//s
        )
    {
        $footer = $this->unescape( $this->entity_to_lf($1) );
    }
    if ( $content
        =~ s/<\!--foot(?![0-9a-zA-Z_])[^>]*-->((?:.(?!<\!--foot-->))*?)<\!--\/foot(?![0-9a-zA-Z_])[^>]*-->[\x09\x0A\x0C\x0D\x20]*\Z//s
        )
    {
        $footer = $1;
    }
    if (@$subtitle_order) {
        return
              '<!--subtitlelist'
            . $attributes . '-->'
            . ( ( $header ne '' ) ? '<!--head-->' . $header . '<!--/head-->'
            : '' )
            . $content
            . ( ( $footer ne '' ) ? '<!--foot-->' . $footer . '<!--/foot-->'
            : '' )
            . '<!--/subtitlelist-->';
    }
    else {
        return
              '<!--subtitlelist'
            . $attributes
            . ( ( $header ne '' )
            ? ' head="' . $this->lf_to_entity( $this->escape($header) ) . '"'
            : '' )
            . ( ( $footer ne '' )
            ? ' foot="' . $this->lf_to_entity( $this->escape($footer) ) . '"'
            : '' )
            . '-->'
            . $content
            . '<!--/subtitlelist-->';
    }
}

sub article_subtitle_tag_replace ($$$$$) {
    my ( $this, $tag, $attributes, $content, $subtitle, $subtitle_order )
        = @_;
    $tag = lc $tag;
    my ( $header, $footer );
    ( $header, $footer, $attributes )
        = $this->get_header_and_footer( $attributes, $content );
    $attributes
        =~ s/[\x09\x0A\x0C\x0D\x20]+id[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)"//sg;
    my $branchheader
        = ( $attributes =~ / branchhead="(.*?)"/i )
        ? $this->unescape($1)
        : '';
    my $branchfooter
        = ( $attributes =~ / branchfoot="(.*?)"/i )
        ? $this->unescape($1)
        : '';
    my $branched
        = ( $tag ne 'sectiontitle'
            && ( $branchheader
            || $branchfooter
            || $attributes =~ /branched/i ) ) ? 1 : 0;
    $attributes = '' if $attributes !~ /[^\x09\x0A\x0C\x0D\x20]/;
    my $temp         = '';
    my $prev_is_chap = 0;

    if (@$subtitle_order) {
        my $max_length
            = ( $attributes
                =~ /[\x09\x0A\x0C\x0D\x20]+maxlength=['"]?([0-9]+)['"]?/si )
            ? $1
            : '';
        for ( my $i = 0; $i < @$subtitle_order; $i++ ) {
            my $sid = $subtitle_order->[$i];
            if (   $tag eq 'subtitle'
                || ( $tag eq 'sectiontitle' && $sid =~ /^[0-9]{6}$/ )
                || ( $tag eq 'chaptertitle'
                    && ( $branched || ( !$branched && $sid =~ /^[0-9]{4}$/ ) )
                )
                )
            {
                my $chap = ( $branched && $sid =~ /^[0-9]{4}$/ ) ? 1 : 0;
                my $chap_start
                    = (    $branched
                        && $chap
                        && $subtitle_order->[ $i + 1 ]
                        && $subtitle_order->[ $i + 1 ] =~ /^[0-9]{6}$/ )
                    ? 1
                    : 0;
                $temp
                    .= '<!--'
                    . $tag . ' id="'
                    . $sid . '"'
                    . $attributes
                    . ( ($chap_start)
                    ? ' foot="'
                        . $this->lf_to_entity( $this->escape($footer) ) . '"'
                    : '' )
                    . '-->'
                    . ( ( $branched && !$i && $sid =~ /^[0-9]{6}$/ )
                    ? $header . $branchheader
                    : ( $chap && $i && !$prev_is_chap )
                    ? $branchfooter . $footer
                    : '' )
                    . ( ( $header ne '' )
                    ? '<!--head-->' . $header . '<!--/head-->'
                    : '' )
                    . '<!--data-->'
                    . (
                    ($max_length)
                    ? $this->cut_string(
                        $this->detag_except_anchor( $subtitle->{$sid} ),
                        $max_length, 'i' )
                    : $subtitle->{$sid}
                    )
                    . '<!--/data-->'
                    . ( ($chap_start) ? $branchheader
                    : ( $footer ne '' )
                    ? '<!--foot-->' . $footer . '<!--/foot-->'
                    : '' )
                    . (
                    (          $branched
                            && $i == $#{$subtitle_order}
                            && $sid =~ /^[0-9]{6}$/
                    ) ? $branchfooter . $footer : ''
                    )
                    . '<!--/'
                    . $tag . '-->';
                $prev_is_chap = $chap;
            }
        }
    }
    if ($temp) {
        return $temp;
    }
    else {
        return
              '<!--'
            . $tag
            . $attributes
            . ( ( $header ne '' )
            ? ' head="' . $this->lf_to_entity( $this->escape($header) ) . '"'
            : '' )
            . ( ( $footer ne '' )
            ? ' foot="' . $this->lf_to_entity( $this->escape($footer) ) . '"'
            : '' )
            . '--><!--/'
            . $tag . '-->';
    }
}

sub _anchor_replace ($$$;$) {
    my ( $this, $template, $anchor_id, $is_anchor ) = @_;
    if ( $this->{'anchor_id'}{$anchor_id} ) {
        $template
            =~ s/[\x09\x0A\x0C\x0D\x20](id|name)="a[0-9]{8}[0-9a-zA-Z_]+"//gs;
    }
    elsif ( $template =~ / id="$anchor_id"/ ) {
        $this->{'anchor_id'}{$anchor_id} = 1;
    }
    elsif ($is_anchor) {
        if ( $template
            =~ s/ name="a[0-9]{8}[0-9a-zA-Z_]+" id="a[0-9]{8}[0-9a-zA-Z_]+"/ name="$anchor_id" id="$anchor_id"/s
            )
        {
            $this->{'anchor_id'}{$anchor_id} = 1;
        }
        elsif ($template !~ /[\x09\x0A\x0C\x0D\x20](id|name)=/is
            && $template =~ s/>$/ name="$anchor_id" id="$anchor_id">/s )
        {
            $this->{'anchor_id'}{$anchor_id} = 1;
        }
    }
    elsif ( $template
        =~ s/[\x09\x0A\x0C\x0D\x20](id|name)="a[0-9]{8}[0-9a-zA-Z_]+"/ id="$anchor_id"/s
        )
    {
        $this->{'anchor_id'}{$anchor_id} = 1;
    }
    elsif ($template !~ /[\x09\x0A\x0C\x0D\x20](id|name)=/is
        && $template =~ s/>$/ id="$anchor_id">/s )
    {
        $this->{'anchor_id'}{$anchor_id} = 1;
    }
    return $template;
}

sub _articleid_replace ($$$$) {
    my ( $this, $tag, $attributes, $id, $id_replaced ) = @_;
    my $class
        = ( $attributes =~ s/[\x09\x0A\x0C\x0D\x20]*class=["'](.*?)['"]//si )
        ? $1
        : '';
    if ($$id_replaced) {
        $class =~ s/(?:^|[\x09\x0A\x0C\x0D\x20])$id//is;
    }
    elsif ( $class =~ /(?:^|[\x09\x0A\x0C\x0D\x20])$id/ ) {
        $$id_replaced = 1;
    }
    else {
        $class = $id . ( ($class) ? ' ' . $class : '' );
        $$id_replaced = 1;
    }
    return
          '<'
        . $tag
        . ( ($class) ? ' class="' . $class . '"' : '' )
        . $attributes . '>';
}

sub get_index_path ($$;$$) {
    my ( $this, $path, $output, $abs_option ) = @_;
    $path = $this->base_change( $path, $output, $abs_option );
    return ( $path =~ m!/$! ) ? $path : $path . '/';
}

sub article_author_tag_replace ($$$$$$) {
    my ( $this, $attributes, $content, $author, $author_email,
        $address_protector )
        = @_;
    my ( $header, $footer );
    ( $header, $footer, $attributes )
        = $this->get_header_and_footer( $attributes, $content );
    if ($author) {
        if ( $attributes
            =~ m![\x09\x0A\x0C\x0D\x20]email="(?:yes|1|on|true)"!si )
        {
            return
                  '<!--author'
                . $attributes . '-->'
                . (
                ( $header ne '' ) ? '<!--head-->' . $header . '<!--/head-->'
                : '' )
                . '<!--data-->'
                . (
                ($author_email) ? '<a href="'
                    . $this->address_protector( $author_email,
                    $address_protector )
                    . '">'
                    . $author
                    . '</a>' : $author
                )
                . '<!--/data-->'
                . (
                ( $footer ne '' ) ? '<!--foot-->' . $footer . '<!--/foot-->'
                : '' )
                . '<!--/author-->';
        }
        else {
            return
                  '<!--author'
                . $attributes . '-->'
                . (
                ( $header ne '' ) ? '<!--head-->' . $header . '<!--/head-->'
                : '' )
                . '<!--data-->'
                . $author
                . '<!--/data-->'
                . (
                ( $footer ne '' ) ? '<!--foot-->' . $footer . '<!--/foot-->'
                : '' )
                . '<!--/author-->';
        }
    }
    else {
        return
              '<!--author'
            . $attributes
            . ( ( $header ne '' )
            ? ' head="' . $this->lf_to_entity( $this->escape($header) ) . '"'
            : '' )
            . ( ( $footer ne '' )
            ? ' foot="' . $this->lf_to_entity( $this->escape($footer) ) . '"'
            : '' )
            . '--><!--/author-->';
    }
}

sub get_article_icon ($$$;$) {
    my ( $this, $url, $icon_field, $icon_type, $title ) = @_;
    my $icon = '';
    local $this->{'field_obj'}{$icon_field}->{'icon_type'} = $icon_type;
    my $temp_icon = $this->{'field_obj'}{$icon_field}->usual_format(
        $main::data{$icon_field},
        $default::home . '/' . $main::n . '/i',
        $main::c, $main::n
    );
    if ( defined $temp_icon && $temp_icon ) {
        $title = $this->escape_except_html_entity( ($title) ? $title : $url );
        while ( $temp_icon =~ /(<img [^>]+>)/gs ) {
            my $img = $1;
            $img =~ s/ (title|alt)=".*?"/ $1="$title"/sgi;
            $icon .= $img;
        }
        $icon
            = '<a href="'
            . $url
            . '" title="'
            . $title . '">'
            . $icon . '</a>'
            if $icon;
    }
    return $icon;
}

sub article_icon_tag_replace ($$$$$) {
    my ( $this, $attributes, $content, $icon, $icon_image ) = @_;
    my ( $header, $footer, $maxwidth, $maxheight );
    ( $header, $footer, $attributes )
        = $this->get_header_and_footer( $attributes, $content );
    $maxwidth = $1
        if $attributes =~ m![\x09\x0A\x0C\x0D\x20]maxwidth="([0-9]+)"!si;
    $maxheight = $1
        if $attributes =~ m![\x09\x0A\x0C\x0D\x20]maxheight="([0-9]+)"!si;
    if ( $attributes
        =~ m![\x09\x0A\x0C\x0D\x20]thumbnail="(?:no|false|off|0)"!si )
    {
        return
              '<!--icon'
            . $attributes . '-->'
            . ( ( $header ne '' ) ? '<!--head-->' . $header . '<!--/head-->'
            : '' )
            . '<!--data-->'
            . $this->article_icon_fit( ( $icon_image || $icon ),
            $maxwidth, $maxheight )
            . '<!--/data-->'
            . ( ( $footer ne '' ) ? '<!--foot-->' . $footer . '<!--/foot-->'
            : '' )
            . '<!--/icon-->'
            if $icon || $icon_image;
    }
    elsif ($icon) {
        return
              '<!--icon'
            . $attributes . '-->'
            . ( ( $header ne '' ) ? '<!--head-->' . $header . '<!--/head-->'
            : '' )
            . '<!--data-->'
            . $this->article_icon_fit( $icon, $maxwidth, $maxheight )
            . '<!--/data-->'
            . ( ( $footer ne '' ) ? '<!--foot-->' . $footer . '<!--/foot-->'
            : '' )
            . '<!--/icon-->';
    }
    return
          '<!--icon'
        . $attributes
        . ( ( $header ne '' )
        ? ' head="' . $this->lf_to_entity( $this->escape($header) ) . '"'
        : '' )
        . ( ( $footer ne '' )
        ? ' foot="' . $this->lf_to_entity( $this->escape($footer) ) . '"'
        : '' )
        . '--><!--/icon-->';
}

sub article_icon_fit ($$$$$) {
    my ( $this, $icon, $maxwidth, $maxheight ) = @_;
    $icon
        =~ s/(<img [^>]+>)/$this->_article_icon_fit($1,$maxwidth,$maxheight)/gies
        if $maxwidth || $maxheight;
    return $icon;
}

sub _article_icon_fit ($$$$$) {
    my ( $this, $icon, $maxwidth, $maxheight ) = @_;
    my ( $width, $height );
    $width  = $1 if $icon =~ m![\x09\x0A\x0C\x0D\x20]width="([0-9]+)"!si;
    $height = $1 if $icon =~ m![\x09\x0A\x0C\x0D\x20]height="([0-9]+)"!si;
    if ( $width > $maxwidth || $height > $maxheight ) {
        ( $width, $height )
            = $cgi::Image->image_fit( $width, $height, $maxwidth,
            $maxheight );
        $icon =~ s!([\x09\x0A\x0C\x0D\x20]width=")[0-9]+(")!$1$width$2!si;
        $icon =~ s!([\x09\x0A\x0C\x0D\x20]height=")[0-9]+(")!$1$height$2!si;
    }
    return $icon;
}

######################################################################
# カレンダーSSI 更新
sub calendar_tag_replace ($$;$) {
    my ( $this, $template, $id ) = @_;
    $$template
        =~ s/(<!--cal(?![0-9a-zA-Z_])([^>]*)-->).*?(<!--\/cal-->)/$1 . $this->_calendar_tag_replace($id,$2) . $3/ges;
    my $recent_calendars
        = $this->include_external_file(
        $calendar::path . '/recent_calendars.ssi',
        1, $cgi::output,
        ( ( $cgi::output_option && $cgi::output_option eq 'abs' ) ? 1 : 0 ) );
    $$template
        =~ s/(<!--recentcalendars(?![0-9a-zA-Z_])[^>]*-->).*?(<!--\/recentcalendars-->)/$1$recent_calendars$2/gis;
}

sub _calendar_tag_replace ($$;$) {
    my ( $this, $id, $setting ) = @_;
    my ( $fyear, $tyear, $fmon, $tmon, $reverse, $span, @tag );
    $span    = 0;
    $span    = $1 if $setting =~ /[\x09\x0A\x0C\x0D\x20]+span="([0-9]+)"/;
    $reverse = $1 if $setting =~ /[\x09\x0A\x0C\x0D\x20]+reverse="([^"]*)"/;

    #年単位履歴
    if ( $id =~ /^([0-9]{4})[0]{4}/ ) {
        $fyear = $tyear = $1 + 0;
        $fmon  = 0;
        $tmon  = 11;

        #月日単位履歴
    }
    elsif ( $id =~ /^([0-9]{4})([0-9]{2})[0-9]{0,2}/ ) {
        $tyear = $fyear = $1 + 0;
        $tmon  = $fmon  = $2 - 1;

        #最新
    }
    elsif ($default::date
        && $article::latest =~ /^([0-9]{4})([0-9]{2})[0-9]{0,2}/ )
    {
        $tyear = $fyear = $1 + 0;
        $tmon  = $fmon  = $2 - 1;

        #最新
    }
    else {
        my @localtime = localtime(time);
        $tyear = $fyear = $localtime[5] + 1900;
        $tmon  = $fmon  = $localtime[4];

    }

    $fmon -= $span;
    $fyear += ( $fmon >= 0 ) ? int( $fmon / 12 ) : int( ( $fmon / 12 ) - 1 );
    $fmon = ( ( ( $fmon >= 0 ) ? $fmon : 12 + $fmon ) % 12 ) + 1;

    $tmon  += $span;
    $tyear += int( $tmon / 12 );
    $tmon = ( $tmon % 12 ) + 1;

YEAR:
    foreach my $year ( $fyear .. $tyear ) {
    MON:
        foreach my $mon ( 1 .. 12 ) {
            next MON if $year == $fyear && $mon < $fmon;
            next MON if $year == $tyear && $mon > $tmon;
            my $name = sprintf( "%.4d", $year ) . sprintf( "%.2d", $mon );
            $this->write_file( "$calendar::path/${name}.ssi", '', 1 )
                unless -f "$calendar::path/${name}.ssi";
            $this->write_file( "$calendar::path/${name}.js", '', 1 )
                unless -f "$calendar::path/${name}.js";
            push(
                @tag,
                $this->include_external_file(
                    $calendar::path . '/' . $name . '.ssi',
                    1,
                    $cgi::output,
                    (   (          $cgi::output_option
                                && $cgi::output_option eq 'abs'
                        ) ? 1 : 0
                    )
                )
            );
        }
    }
    @tag = reverse(@tag) if defined $reverse && $reverse;
    return join( '', @tag );
}

######################################################################
# 記事取得
sub read_html_file ($$;$) {
    my ( $this, $path, $name ) = @_;
    return '' if !$path;
    my ($data);
    if ( defined $name && $name ne '' ) {
        my $dir = $path;
        $path .= '/' . $name . '.' . $default::ext;
        if ( !-f $path ) {
            my $old_path = $this->fileglob( $dir,
                '^' . $name . '\.(?:html|htm|shtml|stml|shtm|stm)$' );
            rename( $old_path, $path ) if $old_path;
        }
    }
    elsif ( -f $path ) {
        if ( $path !~ /\.(?:ssi|$default::ext)$/ ) {
            my $old_path = $path;
            $path =~ s/\.\w+$/\.$default::ext/;
            rename( $old_path, $path );
        }
    }
    elsif ( $path =~ /\.$default::ext$/ ) {
        my $old_path = $path;
        $old_path =~ s/\.$default::ext$//;
        $old_path
            = ( -f $old_path . '.html' ) ? $old_path . '.html'
            : ( -f $old_path . '.htm' )   ? $old_path . '.htm'
            : ( -f $old_path . '.shtml' ) ? $old_path . '.shtml'
            : ( -f $old_path . '.stml' )  ? $old_path . '.stml'
            : ( -f $old_path . '.shtm' )  ? $old_path . '.shtm'
            : ( -f $old_path . '.stm' )   ? $old_path . '.stm'
            :                               '';
        rename( $old_path, $path ) if $old_path;
    }
    local (*FILE);
    if ( $path && open( FILE, $path ) ) {
        binmode FILE, ":utf8";
        flock( FILE, LOCK_SH );
        $data = join( '', <FILE> );
        close(FILE);
        $data = Taketori->new( { 'css' => 1 } )->tategaki_to_text($data)
            if $data;
    }
    else {
        $data = '';
    }
    return $data;
}

######################################################################
# 記事書き込み
sub write_html_file ($$$;$$$$$$$) {
    my ($this, $path,               $data,  $unlink,
        $key,  $mk_javascript_flag, $title, $description,
        $info, $class
    ) = @_;
    my ( $dir, $file ) = ( $1, $2 ) if $path =~ m!^(.*)/([^/]+)\.[^/]+$!;
    if ( !$this->set_dir($dir) ) {
        push(
            @{ $this->{'dialog'} },
            'ファイルの書き込みに失敗しました。ディレクトリ指定を確認してください。'
        );
        return 0;
    }
    unlink(
        $this->fileglob(
            $dir, '^' . $file . '\.(html|htm|shtml|stml|shtm|stm)$'
        )
    ) if $unlink || $default::unlink;
    local (*OUT);
    $data = '' if !defined $data;
    if ($key) {
        if ( $key eq 'article' && $main::pending ) {
            my $canonical = $path;
            $canonical
                =~ s!(/[0-9a-zA-Z_]+)\.pending(/[0-9]+\.[0-9a-zA-Z_]+)$!$1$2!;
            $this->set_canonical( $this->full_path($canonical) );
        }
        else {
            $this->set_canonical( $this->full_path($path) );
        }
    }
    $this->set_last_modified(time)
        if $setting::general{'lastModifiedHeaderEnabled'}
        && $this->{'Last_Modified'}
        && !$this->{'keep_mtime'};
    if (   $data =~ /<body(?![0-9a-zA-Z_])[^>]*>/is
        && $data =~ /<html(?![0-9a-zA-Z_])[^>]*>/is )
    {
        $key = '';
        if (   $setting::general{'lastModifiedHeaderEnabled'}
            && $this->{'Last_Modified'} )
        {
            my $last_modified = $this->meta_last_modified;
            unless ( $data
                =~ s/<meta(?!\w)[^>]*?\s+http-equiv=['"]?Last-Modified["']?[^>]*>/$last_modified/gis
                )
            {
                $data =~ s/(<\/title>)/$1\x0A$last_modified/gis;
            }
        }
        elsif ( !$setting::general{'lastModifiedHeaderEnabled'} ) {
            $data
                =~ s/<meta(?!\w)[^>]*?\s+http-equiv=['"]?Last-Modified["']?[^>]*>[\x09\x20]*\x0A?//gis;
        }
        $this->replace_meta_data(
            \$data,
            $this->{'meta_data'},
            (   ( $setting::page{$key}{'htmlHeader'} )
                ? \$setting::page{$key}{'htmlHeader'}
                : ''
            )
        ) if ref $this->{'og'} && ref $this->{'meta_data'};
        if ( $class && $class =~ /^(.*-)[0-9a-zA-Z_]+$/ ) {
            my $old_class = $1;
            $data
                =~ s/(<body(?![0-9a-zA-Z_])[^>]*[\x09\x0A\x0C\x0D\x20]class="(?:[^"]+[\x09\x0A\x0C\x0D\x20]+|))$old_class(?:[0-9a-zA-Z_]+)("[^>]*>)/$1$class$2/is;
        }
    }
    $data = Taketori->new( { 'css' => 1 } )->text_to_tategaki( $data, 1 )
        if $data;
    if ( open( OUT, ">>$path" ) ) {
        binmode OUT, ":utf8";
        flock( OUT, LOCK_EX );
        truncate( OUT, 0 );
        seek( OUT, 0, 0 );
        if ($key) {
            $this->set_css( $this->{'calendar_css'} )
                if $this->{'calendar_css'} && $data =~ /<!--\/cal-->/;
            $this->print_page_header(
                $key,
                \*OUT,
                $path, 0,
                (   ( $key eq 'masterindex' )
                    ? ( (   defined $master::general{'cginame'}
                                && $master::general{'cginame'} ne ''
                        ) ? $master::general{'cginame'} : ' '
                        )
                    : ''
                ),
                $title,
                $description,
                $info, $class
            );
        }
        else {
            $this->reset_html_header;
        }
        print OUT $data;
        $this->print_page_footer( $key, \*OUT, $path )
            if defined $key && $key;
        close(OUT);
        $this->mk_external_javascript( $path, '', $data )
            if defined $mk_javascript_flag && $mk_javascript_flag;
        return 1;
    }
    else {
        push(
            @{ $this->{'dialog'} },
            'ファイルの書き込みに失敗しました。'
        );
        return 0;
    }
}

######################################################################
sub feed_article_rss ($$$;$) {
    my ( $this, $url, $filedir, $creator ) = @_;
    $this->feed_rss(
        {   'title' => (
                (   $this->is_available_field(
                        $this->{'field_for'}{'title'}
                    )
                )
                ? $this->{'field_obj'}{ $this->{'field_for'}{'title'} }
                    ->restore->format_for_text(
                    $main::data{ $this->{'field_for'}{'title'} }{'str'},
                    $filedir, $main::c, $main::n )
                : ( ($default::date) ? $this->date(
                        substr( $main::n, 0, 8 ), 0,
                        $setting::general{'datetype'}
                    ) : ''
                )
            ),
            'link'            => $url,
            'content:encoded' => (
                (   $this->is_available_field(
                        $this->{'field_for'}{'description'}
                    )
                )
                ? $this->{'field_obj'}{ $this->{'field_for'}{'description'} }
                    ->restore->format_for_detail(
                    $main::data{ $this->{'field_for'}{'description'} }{'str'},
                    $filedir, $main::c, $main::n )
                : ''
            ),
            'category' => (
                (          $default::subdivided
                        && defined $main::c
                        && $main::c ne ''
                        && $setting::general{'cginame'}
                ) ? $setting::general{'cginame'} : ''
            ),
            'enclosure' => $this->article_enclosure($filedir),
            ( ( defined $creator ) ? ( 'dc:creator' => $creator ) : () ),
            (   (          $env::checkout
                        && $this->{'field_for'}{'showcase'}
                        && ref $this->{'field_obj'}
                        { $this->{'field_for'}{'showcase'} }
                )
                ? $this->{'field_obj'}{ $this->{'field_for'}{'showcase'} }
                    ->get_gdata( $url,
                    $main::data{ $this->{'field_for'}{'showcase'} } )
                : ()
            ),
            ( ( $this->{'keep_mtime'} ) ? ( 'pubDate' => 'KEEP' ) : () )
        },
        $default::home,
        $this->full_path($default::home) . '/index.' . $default::ext,
        ( ($default::subdivided) ? $master::home : '' ),
        (   ($default::subdivided)
            ? $this->full_path($master::home) . '/index.' . $default::ext
            : ''
        )
    );
}

sub article_enclosure ($$) {
    my ( $this, $filedir ) = @_;
    my $hash = ( $this->is_available_field( $this->{'field_for'}{'media'} ) )
        ? {
        $this->{'field_obj'}{ $this->{'field_for'}{'media'} }
            ->get_enclosure_attributes(
            $main::data{ $this->{'field_for'}{'media'} }{'str'},
            $filedir, $main::c, $main::n
            )
        }
        : '';
    $hash = ( $this->is_available_field( $this->{'field_for'}{'media2'} ) )
        ? {
        $this->{'field_obj'}{ $this->{'field_for'}{'media2'} }
            ->get_enclosure_attributes(
            $main::data{ $this->{'field_for'}{'media2'} }{'str'},
            $filedir, $main::c, $main::n
            )
        }
        : ''
        if !ref $hash || !%$hash;
    $hash = ( $this->is_available_field( $this->{'field_for'}{'media3'} ) )
        ? {
        $this->{'field_obj'}{ $this->{'field_for'}{'media3'} }
            ->get_enclosure_attributes(
            $main::data{ $this->{'field_for'}{'media3'} }{'str'},
            $filedir, $main::c, $main::n
            )
        }
        : ''
        if !ref $hash || !%$hash;
    return $hash;
}

sub delete_article_rss ($$) {
    my ( $this, $url ) = @_;
    $this->delete_rss_item(
        $url,
        $default::home,
        $this->full_path($default::home) . '/index.' . $default::ext,
        ( ($default::subdivided) ? $master::home : '' ),
        (   ($default::subdivided)
            ? $this->full_path($master::home) . '/index.' . $default::ext
            : ''
        ),
        1
    );
}

sub is_available_field ($$) {
    my ( $this, $id ) = @_;
    if ( $id && ref $this->{'field_obj'}{$id} ) {
        $this->{'field_obj'}{$id}->data
            if !$main::data{$id}{'str'} && %{ $main::data{$id} };
        return 1 if $main::data{$id}{'str'};
    }
    return 0;
}

sub index_sweeper ($$;$$$) {
    my ( $this, $n, $p, $chap, $sect ) = @_;
    my ( $target_url, $target_id );
    $target_id = $main::c . '-'
        if $default::subdivided && defined $main::c && $main::c ne '';
    $target_id .= $n;
    $target_url = $this->full_path($default::home) . '/' . $n . '/';
    if ( $p && $p ne 'i' ) {
        $target_url .= $p . '.' . $default::ext;
        $target_id  .= '-' . $p;
        if ($chap) {
            $target_url
                .= '#a' . sprintf( "%.2d", $p ) . sprintf( "%.2d", $chap );
            $target_id .= '-' . $chap;
            if ($sect) {
                $target_url .= sprintf( "%.2d", $sect );
                $target_id .= '-' . $sect;
            }
        }
    }
    require CMONOS::CGI_Lib::IndexSweeper;
    IndexSweeper->new(
        'index_files' => [ $this->index_files ],
        'rss_files'   => [ $this->rss_files ],
        'kml_files'   => [ $this->kml_files( ($p) ? 0 : 1 ) ],
    )->sweep( [$target_url], { $default::id => [$target_id] } );
}

sub index_link_replace ($$$) {
    my ( $this, $old, $new ) = @_;
    my ($home_id,  @index_files, @xml_files, $home_path,
        $old_path, $new_path,    $home_url,  $old_url,
        $new_url,  $old_id,      $new_id
    );
    $home_id = $this->article_id;
    $home_path
        = $this->path_change( $default::home, $ENV{'SCRIPT_NAME'}, 'abs' );
    $old_path    = $home_path . '/' . $old . '/';
    $new_path    = $home_path . '/' . $new . '/';
    $home_url    = $this->http_my_domain . $home_path;
    $old_url     = $home_url . '/' . $old . '/';
    $new_url     = $home_url . '/' . $new . '/';
    $old_id      = $home_id . '-' . $old;
    $new_id      = $home_id . '-' . $new;
    @index_files = $this->index_files;

    foreach my $path (@index_files) {
        my $data = $this->read_file( $path, 1 );
        my $replaced = 0;
        $replaced = 1
            if $data
            =~ s/(<!--article(?![0-9a-zA-Z_])[^>]*[\x09\x0A\x0C\x0D\x20]+id=")$old_id(-|")/$1$new_id$2/sg;
        $replaced = 1 if $data =~ s/$old_url/$new_url/sg;
        $replaced = 1 if $data =~ s/<a href="$old_path/<a href="$new_path/sg;
        $this->write_file( $path, \$data, 1 ) if $replaced;
    }
    @xml_files = ( $this->rss_files, $this->kml_files );
    foreach my $path (@xml_files) {
        my $data = $this->read_file( $path, 1 );
        if ( $data =~ s/$old_url/$new_url/sg ) {
            $this->write_file( $path, \$data, 1 );
        }
    }
}

sub index_files ($) {
    my $this        = shift;
    my @index_files = (
        $env::externalfiles . '/recentcomments.ssi',
        $env::externalfiles . '/recenttrackbacks.ssi',
        $default::home . '/recentcomments.ssi',
        $default::home . '/recenttrackbacks.ssi',
    );
    if (   $default::subdivided
        && $master::home
        && $master::home ne $default::home )
    {
        push( @index_files,
            $master::home . '/recentcomments.ssi',
            $master::home . '/recenttrackbacks.ssi' );
    }
    push( @index_files, $default::external_index )
        if $default::external_index
        && !grep( $_ eq $default::external_index, @index_files )
        && -f $default::external_index;
    push( @index_files, $default::external_navi )
        if $default::external_navi
        && !grep( $_ eq $default::external_navi, @index_files )
        && -f $default::external_navi;
    push( @index_files, $default::external_navi2 )
        if $default::external_navi2
        && !grep( $_ eq $default::external_navi2, @index_files )
        && -f $default::external_navi2;
    return @index_files;
}

sub rss_files ($) {
    my $this      = shift;
    my @rss_files = (
        '../../index.xml',                 '../../comment.xml',
        '../../trackback.xml',             '../../podcast.xml',
        $default::home . '/index.xml',     $default::home . '/comment.xml',
        $default::home . '/trackback.xml', $default::home . '/podcast.xml',
    );
    if (   $default::subdivided
        && $master::home
        && $master::home ne $default::home )
    {
        push( @rss_files,
            $master::home . '/index.xml',
            $master::home . '/comment.xml',
            $master::home . '/trackback.xml',
            $master::home . '/podcast.xml' );
    }
    return @rss_files;
}

sub kml_files ($;$) {
    my ( $this, $ignore_waypoints ) = @_;
    my @kml_files = ( $default::home . '/index.kml' );
    push( @kml_files, $default::home . '/' . $main::n . '/i/waypoints.kml' )
        if !$ignore_waypoints
        && defined $main::n
        && $main::n ne ''
        && -f $default::home . '/' . $main::n . '/i/waypoints.kml';
    if (   $default::subdivided
        && $master::home
        && $master::home ne $default::home )
    {
        push( @kml_files, $master::home . '/index.kml' );
    }
    return @kml_files;
}

sub gmap_iframe ($$$$$;$$) {
    my ( $this, $setting, $contents, $kml_path, $page_setting, $output,
        $output_option )
        = @_;
    my ( $header, $footer )
        = $this->get_header_and_footer( $setting, $contents );
    $setting
        =~ s/[\x09\x0A\x0C\x0D\x20]+head[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)"//sg;
    $setting
        =~ s/[\x09\x0A\x0C\x0D\x20]+foot[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)"//sg;
    $setting = '' if $setting !~ /[^\x09\x0A\x0C\x0D\x20]/;
    if ($kml_path) {
        my $width
            = ( $setting =~ /[\x09\x0A\x0C\x0D\x20]+width="([0-9]+)"/i ) ? $1
            : ( $page_setting->{'gmapWidth'} ) ? $page_setting->{'gmapWidth'}
            :                                    400;
        my $height
            = ( $setting =~ /[\x09\x0A\x0C\x0D\x20]+height="([0-9]+)"/i )
            ? $1
            : ( $page_setting->{'gmapHeight'} )
            ? $page_setting->{'gmapHeight'}
            : 300;
        my $url = $this->escape(
            (   ( $output || $output_option )
                ? $this->base_change( $env::javascript, $output,
                    $output_option )
                : $env::javascript
            )
            . '/gmap.html?'
                . $this->url_encoded_query(
                {   (     ($env::google_api_key)
                        ? ( 'key' => $env::google_api_key )
                        : ()
                    ),
                    'url' => $kml_path,
                    'fit' => 1,
                    'i'   => 1,
                    (   (   $setting =~ /[\x09\x0A\x0C\x0D\x20]+om="1"/i
                                || $page_setting->{'gmapOverView'}
                        ) ? ( 'om' => 1 ) : ()
                    ),
                    (   (   $setting
                                =~ /[\x09\x0A\x0C\x0D\x20]+(sv|streetview)="1"/i
                                || $page_setting->{'gmapStreetView'}
                        ) ? ( 'sv' => 1 ) : ()
                    ),
                    (   (   $setting
                                =~ /[\x09\x0A\x0C\x0D\x20]+(s|g?search)="1"/i
                                || $page_setting->{'gmapSearch'}
                        ) ? ( 's' => 1 ) : ()
                    ),
                    (   (   $setting
                                =~ /[\x09\x0A\x0C\x0D\x20]+(target|tr|linktarget)="_?([btpsd])[0-9a-zA-Z_]+"/i
                        ) ? ( 'tr' => lc $2 )
                        : ( $page_setting->{'gmapLinkTarget'} )
                        ? ( 'tr' => $page_setting->{'gmapLinkTarget'} )
                        : ( 'tr' => 'p' )
                    ),
                    (   (   $setting
                                =~ /[\x09\x0A\x0C\x0D\x20]+(mw|maxwidth)="([0-9]+)"/i
                        ) ? ( 'mw' => $2 )
                        : ( $page_setting->{'gmapMaxWidth'} )
                        ? ( 'mw' => $page_setting->{'gmapMaxWidth'} )
                        : ()
                    ),
                }
                )
        );
        my $iframe
            = '<iframe'
            . (
            ( $setting =~ /[\x09\x0A\x0C\x0D\x20]+id="([0-9a-zA-Z_\-]+)"/i )
            ? ' id="' . $1 . '"'
            : '' )
            . ' class="'
            . (
            (   $setting
                    =~ /[\x09\x0A\x0C\x0D\x20]+class="([0-9a-zA-Z_\x20\-]+)"/i
            ) ? $1 : 'gmap-index'
            )
            . '" src="'
            . $url
            . '" width="'
            . $width
            . '" height="'
            . $height
            . '" scrolling="no" marginwidth="0" marginheight="0" frameborder="0">';
        my $link
            = '<a href="'
            . $url
            . '" target="_blank">新しいウィンドウで地図を開く</a>';
        $iframe .= $link;
        $iframe .= '</iframe>';
        return
              '<!--gmap'
            . $setting . '-->'
            . ( ( $header ne '' ) ? '<!--head-->' . $header . '<!--/head-->'
            : '' )
            . '<!--data-->'
            . $iframe
            . '<!--/data-->'
            . ( ( $footer ne '' ) ? '<!--foot-->' . $footer . '<!--/foot-->'
            : '' )
            . '<!--/gmap-->';
    }
    else {
        return
              '<!--gmap'
            . $setting
            . ( ( $header ne '' )
            ? ' head="' . $this->lf_to_entity( $this->escape($header) ) . '"'
            : '' )
            . ( ( $footer ne '' )
            ? ' foot="' . $this->lf_to_entity( $this->escape($footer) ) . '"'
            : '' )
            . '--><!--/gmap-->';
    }
}

######################################################################
sub use_tag_manager ($) {
    my $this = shift;
    if ( !ref $this->{'tag'} ) {
        require CMONOS::HomePageMaker::TagManager;
        $this->{'tag_manager'} = TagManager->new(
            (   (          $default::subdivided
                        && $master::home
                        && $master::home ne $default::home
                ) ? $master::home : $default::home
            )
            . '/tags'
        );
    }
}

######################################################################
sub ajax_print_response ($$) {
    my ( $this, $hash ) = @_;
    binmode STDOUT, ":utf8";
    $this->print_http_header(
        'application/x-www-form-urlencoded; charset=utf-8');
    print $this->url_encoded_query($hash);
    exit;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ( !ref $cgi::action && !$setting::security_key ) {
        no warnings qw(once);

        #設定DB読み込み設定
        $setting::general  = 1;    #一般設定読み込み
        $setting::deco     = 1;    #テキスト装飾設定読み込み
        $setting::security = 1;    #アクセス権設定読み込み
        $setting::table    = 1;    #テーブル設定読み込み
        $setting::page     = 1;    #ページ設定読み込み

        if ( !$default::subdivided || $main::c ) {
            $setting::field_db_name = 'inputfield';   #フィールド設定DB
            $setting::field         = 2
                ; #フィールド設定読み込み（2=オリジナルも読み込む）
            $setting::field_style_disabled = 0
                ; #2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
            $setting::field_tag_enabled = 'tag'
                ; #tag=タグのみ/all=全ての設定/no=タグをつけない
        }

        #設定種キー設定
        $setting::security_key
            = 'edit';    #デフォルトセキュリティキー

        #デフォルトキー
        $main::k = 'edit';

        #クッキー
        $cookie::id_enabled = 1;    #ID情報クッキー読み込み

        #必須フォーム
        @setting::form = ( 'm', 'k' );
        push( @setting::form, 'c' )
            if defined $default::subdivided && $default::subdivided;
        if ($ENV{'QUERY_STRING'}
            || (   $ENV{'REQUEST_METHOD'}
                && $ENV{'REQUEST_METHOD'} eq 'POST'
                && !$cgi::input->referer_is_me )
            )
        {
            undef $main::a;
            undef $main::w;
            undef $main::moveto;
            undef $main::delete;
        }

        #クラス登録
        Common::class_register( 'edit', 'Editor' );

        $setting::page{'edit'}{'title'} = '記事編集';
    }
}

1;
